<?php // -*- coding:utf-8 -*-
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then TikiWiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tikiwiki.org/tiki-index.php?page=UnusedWords for further info
"-1d" => "-1d",
"+1d" => "+1d",
"-1m" => "-1m",
"+1m" => "+1m",
"-7d" => "-7d",
"+7d" => "+7d",
"a" => "a",
"Access HTML dump" => "Access HTML dump",
"Activs" => "Activitats",
"act status" => "Estat d'act.",
"Add all your site users to this newsletter (broadcast)" => "Afegeix tots els usuaris del teu lloc web a aquest butlletí (publicació)",
"Add Calendar Item" => "Afegeix un ítem al Calendari",
"Added users" => "Usuaris afegits",
"Add New Group" => "Afegeix un Nou Grup",
"Add or edit a category" => "Add or edit a category",
"Add or edit a task" => "Afegeix o edita una tasca",
"Add scaled images size X x Y" => "Afegeix imatges a escala tamany X x Y",
"Add users" => "Afegeix usuaris",
"admin charts tpl" => "administrar plantilla per a llistes ",
"Admin chat" => "Admin xat",
"Admin content" => "Administrar blocs de contingut",
"Admin content templates" => "Admin content templates",
"admin content templates tpl" => "administrar plantilla per als continguts de les plantilles",
"Admin Cookies" => "adminsitrar galetes",
"Admin Dirertory Sites" => "Admin Dirertory Sites",
"admin Drawings" => "administració de Dibuixos",
"AdminDSN" => "AdministrarDSN",
"admin DynamicContent" => "administrar Contigut dinàmic",
"admin ExternalWiki" => "administrar WikiExtern",
"admin featured links tpl" => "administra plantilla per a enllaços destacats",
"admin forums tpl" => "administra plantilla per a fòrums",
"admin groups tpl" => "administra plantilla per a grups",
"admin hotwords tpl" => "administra plantilla per a paraules clau ",
"Admin HTML page dynamic zones" => "Administra seccions dinàmiques",
"admin HtmlPages" => "administra les PàginesHtml",
"admin HtmlPages tpl" => "administra la plantilla per a pàginesHtml ",
"admin mailin tpl" => "admin mailin tpl",
"Admin->Modules" => "Administrar->mòduls",
"admin modules tpl" => "admin mòduls tpl",
"admin newsletters tpl" => "administrar plantilla per a butlletins",
"admin notifications tpl" => "xxx",
"admin polls tpl" => "administrar plantilla per a votacions",
"admin RSSmodules tpl" => "administrar plantilla per a mòdulsRSS ",
"Admin structures" => "Administrar estructures",
"admin structures tpl" => "administrar plantilla per a estructures",
"admin surveys tpl" => "administrar plantilla per a enquestes",
"admin topics tpl" => "administrar plantilla per a temes",
"admin users tpl" => "administrar plantilla per a usuaris",
"Allowed HTML:" => "HTML permès:",
"Allow smileys" => "Empra emoticons",
"Allow viewing HTML mails" => "Allow viewing HTML mails",
"Allow viwing HTML mails?" => "Permetre visualitzar correus HTML?",
"Allow wiki markup" => "Allow wiki markup",
"All pages" => "Totes les pàgines",
"All tasks" => "Totes les tasques",
"A new password has been sent " => "Una nova contrasenya ha estat enviada ",
"Anonymous users can edit pages" => "Usuaris anònims poden editar pàgines",
"Anonymous users cannot edit pages" => "Cal estar registrat per a accedir a aquesta pàgina",
"A password reminder email has been sent " => "Un correu-e recordatori de contrasenya ha estat enviat ",
"Append CSS file to feed urls" => "Adjunta arxiu CSS per a capturar url's",
"Archived page:" => "Archived page:",
"Are you sure you want to delete this attachment?" => "Segur que vols eliminar aquest arxiu adjunt?",
"Are you sure you want to delete this calendar?" => "Are you sure you want to delete this calendar?",
"Are you sure you want to delete this category?" => "Are you sure you want to delete this category?",
"Are you sure you want to delete this channel?" => "Are you sure you want to delete this channel?",
"Are you sure you want to delete this comment?" => "Segur que vols eliminar aquest comentari?",
"Are you sure you want to delete this contact?" => "Segur que vols eliminar aquest contacte?",
"Are you sure you want to delete this cookie?" => "Are you sure you want to delete this cookie?",
"Are you sure you want to delete this copyright?" => "Are you sure you want to delete this copyright?",
"Are you sure you want to delete this directory?" => "Are you sure you want to delete this directory?",
"Are you sure you want to delete this drawing?" => "Are you sure you want to delete this drawing?",
"Are you sure you want to delete this dsn?" => "Are you sure you want to delete this dsn?",
"Are you sure you want to delete this external wiki?" => "Are you sure you want to delete this external wiki?",
"Are you sure you want to delete this file?" => "Are you sure you want to delete this file?",
"Are you sure you want to delete this forum?" => "Are you sure you want to delete this forum?",
"Are you sure you want to delete this group?" => "Are you sure you want to delete this group?",
"Are you sure you want to delete this hotword?" => "Are you sure you want to delete this hotword?",
"Are you sure you want to delete this HTML page?" => "Are you sure you want to delete this HTML page?",
"Are you sure you want to delete this menu?" => "Are you sure you want to delete this menu?",
"Are you sure you want to delete this repository?" => "Segur que vols esborrar aquest dipòsit?",
"Are you sure you want to delete this rule?" => "Are you sure you want to delete this rule?",
"Are you sure you want to delete this template?" => "Are you sure you want to delete this template?",
"Are you sure you want to delete this tracker?" => "Are you sure you want to delete this tracker?",
"Articles listing configuration" => "Articles listing configuration",
"assgn" => "assignació",
"assigned" => "assignat",
"Assign Group (Active)" => "Assignar Grup(Actiu)",
"assign group" => "assigna grup",
"Assign permissions to thispage" => "Assigna permisos a aquesta pàgina",
"Assign permissions to this page" => "Assignar permisos a aquesta pàgina",
"assign_perms" => "assign_perms",
" at " => " un ",
"Automatic Page Breaks" => "Canvi de Pàgina Automàtic",
"Availible scales" => "Availible scales",
"Average posts pero weblog" => "Mitjana de publicacions per bitàcola web",
">Block description: " => ">Descripció del bloc:",
"Blog settings" => "Configuració de les bitàcoles",
"b" => "n",
"Bookmakrs" => "Adreces d'interès",
"browse by" => "browse by",
"Bye bye from " => "Adéu de part de ",
"by %s" => "by %s",
"Cache wiki pages" => "Cache wiki pages",
"Calendars Panel" => "Panell de Calendaris",
"Cannot get file from URL" => "No es pot obtenir l'arxiu a partir de la URL",
"categorize" => "categoritza",
"Category: wiki, tracker, etc." => "Category: wiki, tracker, etc.",
"center" => "centra",
"change email" => "canvia el correu-e",
"Change your email" => "Canvia el teu correu-e",
"chars" => "cars",
"ChatAdmin" => "Administració del Xat",
"ChatAdmin tpl" => "plantilla per a Administració del Xat",
"checked" => "marcat",
"choose" => "choose",
"Click here to configure this menu" => "Fes clic aquí per configurar aquest menú",
"Click here to create a new backup" => "Punxa aquí per crear una còpia de seguretat nova",
"Click here to delete this attachment" => "Clica aquí per eliminar aquest arxiu adjunt",
"Click here to delete this channel" => "Fes clic aquí per esborrar aquest canal",
"Click here to delete this comment" => "Clica aquí per editar aquest comentari",
"Click here to delete this contact" => "Clica aquí per eliminar aquest contacte",
"Click here to delete this cookie" => "Fes clic aquí per esborrar aquesta galeta (cookie)",
"Click here to delete this copyright" => "Fes clic aquí per esborrar aquest copyright",
"Click here to delete this drawing" => "Fes clic aquí per esborrar aquest dibuix",
"Click here to delete this menu" => "Fes clic aquí per esborrar aquest menú",
"Click here to delete this repository" => "Punxa aquí per esborrar aquest dipòsit",
"Click here to delete this rule" => "Fes clic aquí per esborrar aquesta norma",
"Click here to delete this template" => "Fes clic aquí per esborrar aquesta plantilla",
"Click here to delete this tracker" => "Fes clic aquí per esborrar aquest formulari",
"Click here to edit this comment" => "Clica aquí per editar aquest comentari",
"Click here to edit this menu" => "Clica aquí per editar aquest menú",
"Click here to unassign this module" => "Clica aquí per desassignar aquest mòdul",
"Click the :: option on the menu for more options." => "Fes clic a l'opció :: del menú per a més opcions.",
"Click to enlarge" => "Click to enlarge",
"cms" => "cms",
"CMS settings" => "Configuració dels CMS",
"Cms" => "Sgc (Cms)",
"column" => "columna",
"Comm" => "Comm",
"compose message tpl" => "plantilla per a escriu un missatge",
"Configure modules" => "Configura mòduls",
"Configure this page" => "Configura aquesta pàgina",
"content templates" => "plantilles de contingut",
"Control by category" => "Control per categoria",
"Control by Object" => "Control per Objecte",
"Crea page:" => "Crea la pàgina:",
"Create a tag for the current wiki" => "Crear una marca per al wiki actual",
"Create/edit extwiki" => "Create/edit extwiki",
"Create/edit Faq" => "Crear/editar Puf",
"Create/edit Forums" => "Crea o edita fòrums",
"Create/edit HTML pages" => "Crea/edita pàgines  HTML",
"Create/edit Menus" => "Crear o editar menús",
"Create/edit RSS module" => "Crea o edita mòdul RSS",
"Create/edit surveys" => "Crea/edita enquestes",
"Create/edit templates" => "Crea/edita plantilles",
"Create HTML dump" => "Create HTML dump",
"create new empty structure" => "create new empty structure",
"Create New Survey:" => "Crear nova Enquesta:",
"Create or edit a file gallery using this form" => "Crea o edita una galeria emprant aquest formulari",
"Create or edit a gallery using this form" => "Creeu o editeu una galeria fent servir aquest formulari",
"creates an editable drawing named foo" => "crea un dibuix editable anomenat foo",
"Create structure from tree" => "Create structure from tree",
"create tag" => "crear marca",
"Create TAR dump" => "Create TAR dump",
"Creating backups may take a long time. If the process is not completed you will" => "Creating backups may take a long time. If the process is not completed you will",
"Creating backups may take a long time. If the process is not completed you willsee a blank screen. If so you " => "Creating backups may take a long time. If the process is not completed you willsee a blank screen. If so you ",
"creation date" => "creation date",
"Current page:" => "Current page:",
"Current version" => "Versió actual",
"current_version" => "versió actual",
"days (0=all)" => "dies (0=tots)",
"dcs" => "dcs",
"deep" => "profund",
"Delete item from category?" => "esborrar item des de categoria?",
"Describe topics in listing" => "Describe topics in listing",
"Diff:" => "Diff:",
"Diff of %s." => "Diff of %s.",
"Directory (include trailing slash)" => "Directory (include trailing slash)",
"dispay" => "mostra",
"Displays a snippet of code.\nSet optional paramater -+ln+- to 1 if you need line numbering feature." => "Displays a snippet of code.\nSet optional paramater -+ln+- to 1 if you need line numbering feature.",
"Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done)." => "Mostra text/codi preformatat; no es dóna processat Wiki dins d'aquestes seccions (igual que amb np), i l'espaiat és fixe (no s'inserten salts de línia automàtics entre les paraules).",
"Download last TAR dump" => "Download last TAR dump",
"drawings" => "dibuixos",
"(Dropdown options : list of items separated with commas)" => "(Llista d'opcions : llista d'ítems separats amb comes)",
"dynamic colapsed" => "dinàmic colapsat",
"Edit desc" => "Editar desc",
"Edit drawings &amp; pictures" => "Edit drawings &amp; pictures",
"Editing tracker item" => "Editant punt del formulari",
"Edit or add category" => "Editar o afegir categories",
"Edit Submissions" => "edita Submissions",
"Edit succesful!" => "Edició satisfactòria!",
"Edit this group:" => "Edita aquest grup:",
"Edit this HTML page" => "Edita aquesta pàgina en format HTML",
"Edit tpl" => "plantilla per a editar ",
"Email Encoding" => "Codificació correu-e",
"Enable watch by default for author" => "Habilita avís per defecte per a l'autor",
"Enable watches when I am the editor" => "Habilita avisos quan sóc l'editor",
"Enlarge area width" => "fes més gran l'amplada",
"Entire site" => "Lloc complet",
"Events Panel" => "Panell d'Esdeveniments",
"ExtWikis" => "ExtWikis",
"FAQ Answers" => "Respostes de les PUFs",
"FAQ comments" => "Comentaris en les PUFs",
"FAQ Questions" => "Preguntes d'Ús Freqüent (PUFs)",
"FAQs settings" => "Funcionalitats de les Preguntes d'Ús Freqüent (PUFs)",
"feat" => "caract",
"features" => "característiques",
"file galleries" => "galeries d'arxius",
"file galleries tpl" => "plantilla per a galeria d'arxius",
"File gals" => "Gals d'arxius",
"file gls" => "gals de fitxers",
"For more information, please see <a href=\"{\$helpurl}WikiSyntax\">WikiSyntax</a>" => "Per a més informació, si us plau vegi les normes de <a href=\"{\$helpurl}WikiSyntax\">Sintaxi Wiki</a>.",
"For more information, please see <a\nhref=\"http://www.tikiwiki.org/tiki-index.php?page=WikiSyntax\">WikiSyntax</a>\non <a href=\"http://www.tikiwiki.org\">Tikiwiki.org</a>." => "Per a més informació, si us plau veure  <a\nhref=\"http://www.tikiwiki.org/tiki-index.php?page=WikiSyntax\">WikiSyntax</a>\non <a href=\"http://www.tikiwiki.org\">Tikiwiki.org</a>.",
"Forum settings" => "Forum settings",
"forum topic" => "tema del fòrum",
"Forward messages to this forum to this email" => "Forward messages to this forum to this email",
"frms" => "fòrums",
"from the list" => "from the list",
"general" => "general",
"Go to your <a href=\"tiki-friends.php\">friendship network</a> to accept or refuse this request" => "Go to your <a href=\"tiki-friends.php\">friendship network</a> to accept or refuse this request",
"gral" => "gral",
"h1" => "t1",
"h2" => "t2",
"h3" => "t3",
"half a second" => "mig segon",
"HasImg" => "TeImatge",
"heading2" => "titular2",
"heading3" => "titular3",
"heading" => "heading",
"Height of inner Heading" => "Alçada de l'encapçalament",
"Height of mid Heading" => "Alçada del mig de l'encapçalament",
"Height of top Heading" => "Alçada de la part superior de l'encapçalament",
"Hide comments" => "Ocultar comentaris",
"hide from display" => "hide from display",
"Hide Panels" => "Hide Panels",
"Hide Post Form" => "Ocultar formulari",
"Hide suggested questions" => "Oculta",
"History of" => "Historial de",
"horizontal ruler" => "horizontal ruler",
"Hotwords in new window" => "Paraules calentes en una nova finestra",
"hotwords" => "paraules calentes",
"i" => "c",
"idle" => "autista",
">I forgot my password" => ">He oblidat la meva contrasenya",
"If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose)." => "If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose).",
"image galleries" => "galeries d'imatges",
"Image gals" => "Gals d'imatges",
"(Image options : xSize,ySize indicated in pixels)" => "(Opcions d'Imatge  : xTamany,yTamany indicats en píxels)",
"img gls" => "gals d'imtg",
"img" => "img",
"img nc" => "img nc",
"In blog listing show user as" => "Al diari, l'usuari llistat és",
"Index page" => "Pàgina índex",
"Information:" => "Informació:",
"In parent page" => "In parent page",
"Insert articles into a wikipage" => "Inserta articles a una pàgina wiki",
"Ins" => "Ins",
"Invalid password.  You current password is required to change your email address." => "Contrasenya incorrecte.  La teva Contrasenya és necessària per canviar la teva adreça de correu.",
"JoinCapitalizedWords" => "AjuntarParaulesEnMajuscules",
"Klick to enlarge" => "Klick to enlarge",
"last_login" => "darrera connexió",
"last modification time" => "last modification time",
"last modified on %s" => "last modified on %s",
"Layout options" => "Opcions de format",
"LDAP Group Atribute" => "LDAP Group Atribute",
"Like pages" => "Pàgines similars",
"link_description" => "descripció de l'enllaç",
"Links/Commands" => "Enllaços/Comandaments",
"links" => "enllaços",
"List Calendars" => "Llista calendaris",
"list_pages" => "llistar pàgines",
"{literal}{CODE()}some code{CODE} {/literal} will render \"some code\" as program code. This plugin has other options; see <a href=\"{\$helpurl}PluginCode\">PluginCode</a>." => "{literal}{CODE()}tros de codi{CODE} {/literal} inerpretarà el \"tros de codi\" com a codi de programa. Aquest plugin té altres opcions; mira <a href=\"{\$helpurl}PluginCode\">PluginCode</a>.",
"Mailin accounts" => "Mailin accounts",
"Maked as deleted" => "Marcada com esborrada",
"mark as done" => "marca com a feta",
"Mark as Flagged" => "Marca com Senyalat",
"messages tpl" => "missatges tpl",
"Moderator" => "Moderador",
" modified" => "modificada",
"modules" => "mòduls",
"More info about" => "Més informació sobre",
"mot" => "mot",
"Mus enter a name to add a site" => "Mus enter a name to add a site",
"my galleries" => "les meves galeries",
"MyTikiDoc" => "El meu TikiDoc",
"name of wiki page" => "nom de la pàgina wiki",
"Navigation Panel" => "Navigation Panel",
"New article submitted at " => "Article nou enviat a ",
"New message arrived from " => "Ha arribat un missatge de ",
"Newss from" => "Newss from",
" new topic:" => " nou tema:",
"Next version" => "Propera versió",
"\n for rows" => "\n for rows",
"No file" => "Cap arxiu",
"No image uploaded" => "No s'ha pujat la imatge",
"No indivual permissions global permissions apply" => "No hi ha permisos individuals - manen els globals",
"No indivual permissions global permissions to all pages apply" => " No hi ha permisos individuals. Manen els permisos globlals",
"No scales availible" => "No scales availible",
"No such forum" => "No such forum",
"note: those parameters are exclusive" => "avis: aquells paràmetres són exclusius",
"Not rated yet" => "Not rated yet",
"objs" => "objs",
"Old versions" => "Versions anteriors",
"Only an admin can remove a thread." => "Només un administrador pot esborrar un enviament permament.",
"open tasks" => "obre les tasques",
"op" => "op",
"Options (separated by commas used in dropdowns only)" => "Options (separated by commas used in dropdowns only)",
"Options (sepparated by commas used in dropdowns only)" => "Opcions (separades per comes emprades només en menús desplegables)",
"or use square brackets for an" => "o emprar corxets per a",
"pageviews" => "vista de pàgina",
"parent" => "pare",
"password for this account is" => "la contrasenya per a aquest compte és",
"Path to where the dumped files are (relative to tiki basedir with trailing slahs ex: dump/)" => "Path to where the dumped files are (relative to tiki basedir with trailing slahs ex: dump/)",
"Path to where the dumped files are" => "Ruta a on es troben els fitxers del buidat",
"Permission denied you cannot browse this gallery" => "No tens autorització per accedir a la galeria",
"Permission denied you cant view this section" => "Permís denegat per veure aquesta secció",
"perm" => "perm",
"Perm" => "Permís",
"Php error reporting level for non-admin:" => "Nivell d'informació sobre errors per a no administradors:",
"PHPOpenTracker" => "PHPOpenTracker",
"Please also see" => "Si us plau, veieu també",
"Please follow the steps below to have your password properly reset:\n\n1. Click the following link to confirm you wish to reset your password:\n{\$mail_machine}?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\n2. Click the following link to go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\nhttp://{\$mail_machine}/tiki-change_password.php?user={\$mail_user}&oldpass={\$mail_pass}\n\nAlternatively, go to {\$mail_site} and login using your username and temporary password:\n Username:   {\$mail_user}\n Temporary password:  {\$mail_pass}\n\n3. Done! You should be logged in." => "Segueix, si us plau, els passos de sota per fer que la teva contrasenya es canvii adequadament:\n\n1. Punxa sobre el següent enllaç per confirmar que vols que es posi una nova contrasenya:\n{\$mail_machine}?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\n2. Punxa en el següent enllaç per anar a la finestra on hauràs d'introduir una nova contrasenya \"permanent\". Si su plau, escull una contrasenya que nonomés tu sàpigues, i no la comparteixis amb ningú més.\nhttp://{\$mail_machine}/tiki-change_password.php?user={\$mail_user}&oldpass={\$mail_pass}\n\nAlternativament, ves a {\$mail_site} i connecta't emprant el teu nom com a persona usuària i la contrasenya temporal:\n Nom de persona usuària:   {\$mail_user}\n Contrasenya temporal:  {\$mail_pass}\n\n3. Fet! Hauries d'estar connectat.",
"polls" => "votacions",
"Poll settings" => "Configuració de la Votació",
"Posted comments" => "Comentaris publicats",
"Prevents parsing data" => "Evita analitar dades",
"Prevent users from voting same item more than one time" => "Prevent users from voting same item more than one time",
"printable" => "imprimible",
"Programmed versions" => "Versions programades",
"Publisher" => "Publicat per",
"Publish/Event Date" => "Publish/Event Date",
"Quiz time limit excedeed quiz cannot be computed" => "Has excedit el temps màxim",
"Ranking" => "Rànquing",
"ranking" => "rànquing",
"Reduce area width" => "Reduir l'amplada de l'àrea",
"References" => "Referències",
"Remind passwords by email" => "Recorda mots de pas per correu-e",
"remove bookmark" => "elimina adreça d'interès",
">Remove Zones (you lose entered info for the banner)" => ">Eliminar zones (perds la informació en el banner)",
"Renders a graph" => "Renders a graph",
"Reply to parent comment" => "Respondre al comentari pare",
"reply to this" => "respondre",
"report this post" => "reportar aquesta publicació",
"requested a reminder of the password for the" => "s'ha solicitat un recordatori de la paraula clau per el",
"Restore the wiki" => "Recuperar el wiki",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the " => "La recuperació d'una còpia de seguretat  destrueix totes les dades en la ",
"Restoring a backup destoys all the data in your Tiki database." => "Restoring a backup destoys all the data in your Tiki database.",
"Return to messages" => "Tornar als missatges",
"Reuse question" => "Empra de nou la pregunta",
"Rollback_page" => "Restableix pàgina",
"rotate left" => "rotate left",
"rss" => "rss",
"running" => "engegat",
"save a custom copy" => "guardar una còpia personalitzada",
"search category" => "categoria de cerca",
"Search : " => "Cerca : ",
"Send Objects" => "Enviar Objectes",
"Server time zone" => "Zona horària del servidor",
"Set feeds" => "Especifica alimentacions",
"Set home forum" => "Especifica fòrum inicial",
"Set prefs" => "Especif prefs",
"shoutbox" => "quadre d'avisos",
"ShoutBox" => "QuadredAvisos",
"Show chart for the last " => "Mostra gràfica per als darrers... ",
"Show comments" => "Mostrar comentaris",
"Show Post Form" => "Mostrar formulari per publicar",
"Show status when listing tracker items?" => "Mostra l'estatus quan es llistin els punts del formulari?",
"Show suggested questions/suggest a question" => "Mostra preguntes suggerides/suggerir pregunta",
"since this is your registered email address we inform that the" => "ja que aquesta es la seva adreça email registrada, li informem que ",
"smileys" => "emoticons",
"someone from" => "algú des de",
"stat" => "estadística",
"strict" => "estricte",
"sub categories" => "subcategories",
"subs" => "subs",
"suggested" => "suggerides",
"system gallery" => "galeria del sistema",
"tbheight" => "alçada taula",
"tbl" => "tbl",
"TextFormattingRules" => "Regles de formateig de text",
"Textheight" => "Alçada del text",
"Thanks for your subscription. You will receive an email soon to confirm your subscription." => "Thanks for your subscription. You will receive an email soon to confirm your subscription.",
"Thankyou for installing Tikiwiki" => "Thankyou for installing Tikiwiki",
"The cord" => "El fil",
"The following file was succesfully uploaded" => "El següent arxiu ha estat pujat satisfactòriament",
"The following image was succesfully edited" => "La següent imatge ja ha estat editada satisfactòriament",
"The following image was succesfully uploaded" => "La següent imatge s'ha rebut satisfactòriament",
"The new page content is:" => "El nou contingut de la pàgina és:",
"The passwords didn't match" => "Els mots de pas no coincideixen",
"The passwords dont match" => "Els mots de pas no coincideixen",
"There are inddividual permissions set for this blog" => "Aquesta bitàcola té especificats permisos individuals",
"There are inddividual permissions set for this file gallery" => "Hi ha permisos individuals especificats per a aquesta galeria",
"There are inddividual permissions set for this forum" => "Hi ha permisos personalitzats per aquest fòrum",
"There are inddividual permissions set for this gallery" => "Hi ha permisos individuals per aquesta galeria",
"There are inddividual permissions set for this tracker" => "Hi ha permisos individuals fixats per a aquest formulari",
"There is an error in the plugin data" => "There is an error in the plugin data",
"The SandBox is a page where you can practice your editing skills, use the preview feature" => "The SandBox is a page where you can practice your editing skills, use the preview feature",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appeareance of the page, no versions are stored for this page." => "El LLocdeProves és una pàgina on pots practicar les teves habilitats d'edició, empra l'opció de previsualització per previsualitzar l'aspecte de la pàgina, no es desa cap versió per aquesta pàgina.",
"the space beetween nodes\n" => "the space beetween nodes\n",
"The user has choosen to make his information private" => "The user has choosen to make his information private",
"this post was reported" => "aquesta publicació ha estat notificada",
"Threads can be voted" => "Els fils poden ser votats",
"tiki admin external wikis tpl" => "plantilla de wikis externs per l'admin del tiki",
"tiki admin quicktags tpl" => "plantilla de marques ràpides (quicktags) per l'admin del tiki",
"Tiki Calendars" => "Tiki Calendars",
"Tiki forums" => "Tiki forums",
"Tiki RSS Feed Error Message" => "Missatge d'error d'alimentació RSS del Tiki",
"Tiki ShoutBox" => "Quadre d'avisos del Tiki",
"time" => "temps",
"Time Zone Map" => "Mapa de Zona Horària",
"Time Zone" => "Zona Horària",
"Title_bar" => "Barra de títol",
"today" => "avui",
"to insert a random tagline" => "per insertar una línea de marcador a l'atzar",
"Top Files" => "Arxius principals",
"topics in this forum" => "tòpics en aquest fòrum",
"topic:" => "tòpic:",
"trckrs" => "trckrs",
"ul" => "sl",
"unchecked" => "no marcat",
"Unexistant gallery" => "Galeria inexistent",
"Unexistant link" => "Enllaç inexistent",
"Unexistant user" => "Usuari inexistent",
"Unexistant version" => "Versió inexistent",
"Unflagg" => "Deixa de marcar amb la bandera",
"Upload succesful!" => "Pujada satisfactòria!",
"Upload was not successful (maybe a duplicate file)" => "La pujada no s'ha realitzat amb èxit (potser és un fitxer duplicat)",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory" => "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory",
"Use dbl click to edit pages" => "Empra doble click per editar planes",
"use filename" => "empra nom de fitxer",
"UseImg" => "UsaImatge",
"Use (:name:) for smileys" => "Empra (:nom:) per a emoticons",
"user bookmarks" => "Enllaços d'interès de l'usuari",
"userfiles" => "fitxersdusuari",
"user preferences" => "preferències de l'usuari",
"User preferences screen" => "Preferències de l'usuari",
"Users can save pages to notepad" => "Users can save pages to notepad",
"Users can subscribe any email addresss" => "Els usuaris poden subscriure qualsevol adreça de correu-e",
"Users can vote only one item from this chart per period" => "Users can vote only one item from this chart per period",
"User versions" => "Versions de l'usuari",
"use square brackets for an" => "empra corxets per a un/a",
"version %s" => "version %s",
"versions" => "versions",
"view info" => "veure info",
"Warn on edit" => "Avisa en ser editat",
"WebMail accounts" => "WebMail accounts",
"webmail" => "correuweb",
"Webmail Doc tpl" => "Plantilla de document Webmail",
"Welcome to " => "Benvingut/da a ",
"Wiki comments settings" => "Especificacions de comentaris del Wiki",
"Wiki Import dump" => "Importa buidat del Wiki",
"wiki link" => "enllaç del wiki",
"Wiki page list configuration" => "Configuració de llista de planes Wiki",
"Wiki Page Names" => "Noms de les Pàgines del Wiki",
"Wiki page" => "Plana Wiki",
"with role" => "with role",
"xx" => "xx",
"xxx" => "xxx",
"You are not permitted to edit someone else\\'s post!" => "No tens permís per editar la publicació d'algú altre!",
"You can edit the page following this link:" => "Pots editar la pàgina seguint aquest enllaç:",
"You can include the image in an HTML or Tiki page using" => "Pots incloure aquesta imatge en una pàgina HTML o Tiki emprant",
"You can include the image in an HTML/Tiki page using" => "Pots incloure aquesta imatge en una pàgina HTML/Tiki emprant",
"You cant download files" => "No pots baixar arxius",
"You cant use the same password again" => "Pots emprar la mateixa contrasenya un altre cop",
"You can view the page following this link:" => "Pots veure la pàgina seguint aquest enllaç:",
"You do not have permission to use this feature." => "No tens permís per emprar aquesta característica.",
"You dont have permissions to edit banners" => "No té permís per editar banners",
"You dont have permission to delete the mapfile" => "No tens permís per esborrar fitxer del mapa",
"You dont have permission to edit messages" => "No tens autorització per editar imatges",
"You dont have permission to edit this banner" => "No té permís per editar aquest banner",
"You dont have permission to read the mapfile" => "No tens permís per llegir el fitxer del mapa",
"You dont have permission to read the template" => "No té permís per llegir la plantilla",
"You dont have permission to use this feature" => "No tens permís per emprar aquesta característica",
"You dont have permission to view other users data" => "No té permís per veure dades d'altres usuaris",
"You dont have permission to write the style sheet" => "No tens permís per escriure al full d'estil",
"You dont have permission to write the template" => "No té permís per escriure la plantilla",
"You dont have permission to write to the mapfile" => "No tens permís per escriure al fitxer del mapa",
"You have to provide a name to the file" => "Has de posar un nom al fitxer",
"You have to provide a name to the image" => "Has de proporcionar un nom a la imatge",
"You have to type a searchword" => "Has de teclejar una paraula de cerca",
"You need to supply information for : " => "You need to supply information for : ",
"You reivied this task, please read and execute it" => "HAs rebut aquesta tasca, si us plau llegeix-la i executa-la",
"Your Tiki account information for" => "La teva informació de compte de Tiki per a",
"You should first ask that a calendar is created, so you can create events attached to it." => "You should first ask that a calendar is created, so you can create events attached to it.",
"TikiTabs" => "TikiTabs",
"Please" => "Si us plau",
"log in" => "entrar",
"to access full functionalities" => "per accedir a totes les funcionalitats",
"Use Quote plugin for quoting" => "Empra el plugin de Cita (QUOTE) per citar",
"Use {literal}{{/literal}ed id=name} or {literal}{{/literal}ted id=name} to insert dynamic zones" => "Utilitzeu {literal}{{/literal}ed id=name} o {literal}{{/literal}ted id=name} per inserir zones dinàmiques",
"Emphasis" => "Èmfasi",
"italics" => "cursives",
"both" => "ambdós",
"make_headings" => "fa títols",
"underlines text" => "subratlla text",
"Simple box" => "Requadre simple",
"Will display using the indicated HTML color" => "Es mostrarà usant el color HTML indicat",
"Will display the text centered" => "Mostra el text centrat",
"Insert Module Output" => "Inserta la sortida del Mòdul",
"{literal}{MODULE(module=>some_module)}text{MODULE}{/literal}  can be used to insert the output of module \"some_module\" into your Wiki page. See <a href=\"{\$helpurl}PluginModule\">PluginModule</a> for more information. " => "{literal}{MODULE(module=>algun mòdul)}text{MODULE}{/literal}  pot ser emprat per insertar la sortida del mòdul \"algun mòdul\" a la teva pàgina Wiki. Mira <a href=\"{\$helpurl}PluginModule\">PluginModule</a> per més informació. ",
"Rendering Program Code" => "Interpreta Codi de Programa",
"New blog post: {\$mail_title}: {\$title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nova entrada a la bitàcola: {\$mail_title}: {\$title} per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"Jukebox" => "Jukebox",
"Jukebox preference" => "Jukebox preference",
"Admin sections" => "Administra seccions",
"Paste" => "Enganxa",
"Remove Category" => "Elimina categoria",
"New group" => "Nou grup",
"Add group" => "Afegeix el grup",
"Remove group" => "Elimina el grup",
"Add user" => "Afegeix l'usuari/a",
"Borrar" => "Esborrar",
"Workspace Types" => "Tipus d'Espais de Treball",
"Admin Workspaces" => "Admin Espais de Treball",
"Assign aulawiki_myworkspaces" => "Assigna aulawiki_myworkspaces",
"to AulaWiki.css" => "a AulaWiki.css",
"Define the <a class='link' href=\"./aulawiki-roles.php\">workspace roles</a> and permission levels." => "Defineix els <a class='link' href=\"./aulawiki-roles.php\">rols dels espais de treball</a> i els nivells de permisos.",
"Define the <a class='link' href=\"./aulawiki-workspace_types.php\">workspace types</a> , use MenuID 100 or <a class='link' href=\"./tiki-admin_menus.php\">define your own menu</a>. Assign <img src='img/icons/change.gif' border='0' alt='Workspace type resources' title='Workspace type resources' /> default resources and <img src='img/icons/mo.png' border='0' alt='Assigned modules' title='Assigned modules' /> desktop modules." => "Defineix els <a class='link' href=\"./aulawiki-workspace_types.php\">Tipus d'Espais de Treball</a> , empra el MenuID 100 o <a class='link' href=\"./tiki-admin_menus.php\">defineix el teu propi menú</a>. Assigna els <img src='img/icons/change.gif' border='0' alt='recursos del Tipus d\\'Espai de Treball' title='recursos del Tipus d\\'Espai de Treball' /> recursos per defecte i els <img src='img/icons/mo.png' border='0' alt='Mòduls assignats' title='Mòduls assignats' /> mòduls de l'escriptori.",
" line " => " línia ",
"permission." => "permís.",
"Error: Invalid" => "Error: Invàlid",
"Error: Call to hw_page_fetch_by_id failed!" => "Error: ha fallat la crida a la recuperació de la pàgina per id!",
"no description" => "sense descripció",
"Updated" => "Actualitzat",
"Renders a graph, with linked pages navigation visually figured.\n" => "Produeix un gràfic, amb navegació de mode visual per les planes enllaçades.\n",
"the number of hops the graph follows\n" => "segueix el nombre de salts de la pàgina\n",
"the title of the map\n" => "el títol del mapa\n",
"the space between nodes\n" => "l'espai entre nodes\n",
"Left to Right, the direction of graph\n" => "D'esquerra a dreta, la direcció del graph\n",
"the background color, use #rrvvbb color types.\n" => "el color de fons, fer servir els tipus #rrvvbb.\n",
"nothing there, unlimited size. use 5,3 type sizes in inches\n" => "aquí no hi ha res, tamany il·limitat. Feu servir tamanys de font 5,3 pulgades\n",
"the font size in pts presumably\n" => "la mida de la font en pts presumiblement\n",
"the name of the font used for labels\n" => "el nom de la font emprada per les etiquetes\n",
"the shape of a node. can be " => "la forma d'un node. pot ser ",
"plaintext ellipse circle egg triangle box diamond trapezium parallelogram house hexagon octagon\n" => "texsenzill el·lipse cercle ou triangle rectangle rombe trapezi  paral·lelogram casa hexàgon octàgon\n",
"style for drawing nodes.\n" => "estil per dibuixar nodes.\n",
"color of the border\n" => "color de la vora\n",
"background color of the node\n" => "color de fons del node\n",
"sortof relative width ??\n" => "un tipus d'amplada relatiu ??\n",
"same mystery as above\n" => "el mateix misteri que a dalt\n",
"color for links (called edges here)\n" => "color per a enllaços (anomenats vores aquí)\n",
"shape of the arrow that come with the link\n" => "forma de la fletxa que ve amb l'enllaç\n",
"Assignments Administration" => "Administració de deures",
"Period" => "Període",
"Grade Weight" => "Ponderacions de les avaluacions",
"Exam" => "Examen",
"Exercise" => "Exercici",
"New Assignment" => "Deures nous",
"Weight" => "Pes",
"Permission levels" => "Nivells de permisos",
"Studies" => "Estudis",
"Gradebook" => "Quadern d'avaluacions",
"Select period" => "Selecciona període",
"Save grades" => "Desa avaluacions",
"Allow Anonymous" => "Permet als Anònims",
"Allow Registered" => "Permet als registrats",
"Workspace resources" => "Estructures de l'Espai de Treball",
"User workspace" => "Espais de treball dels Usuaris",
"Remove all" => "Esborra tot/s",
"User Workspaces" => "Espais de treball dels usuaris",
"Assignment details" => "Detalls dels deures",
"Grade" => "Avalua",
"Save Grades" => "Desa Avaluacions",
"Grade for" => "Avalua a",
"Personal Learning Folder" => "ePortfolio Personal de l'usuari/a",
"The page {\$mail_page} was changed by {\$mail_user} at\n{\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} va ser canviada per {\$mail_user} el\n{\$mail_date|tiki_short_datetime}",
"You can view the page by following this link:\n    {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}" => "Pots veure la pàgina si segueixes aquest enllaç:\n    {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}",
"You can edit the page by following this link:\n    {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}" => "Pots editar la pàgina seguint aquest enllaç:\n    {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}",
"You can view a diff back to the previous version by following\nthis link:\n    {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}" => "Pots veure un diff a la versió prèvia seguint\naquest enllaç:\n    {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}",
"Confirmation required" => "Confirmació requerida",
"Wiki quick help" => "Ajuda ràpida Wiki",
"Quicklinks" => "Enllaços ràpids",
"Go \n                    back" => "Tornar \n                    Enrera",
"Return to home \n                    page" => "Tornar a la pàgina d'inici \n                    pàgina",
"MyTiki (click!)" => "El meu Tiki (fes clic!)",
"Admin (click!)" => "Admin (fes clic!)",
"Grade Paper" => "Avalua treball escrit",
"Comparing versions" => "Comparant versions",
"Actual_version" => "Versió actual",
"Diff to version" => "Diferent de la versió",
"Grading Queue " => "Cua d'Avaluacions ",
"Edit Assignment" => "Edit deures",
"list assignments" => "llista els deures",
"create assignment" => "crea deures",
"Import pages from a PHPWiki Dump" => "Importa pàgines des d'un buidat de PHPWiki",
"Path to where the dumped files are (relative to tiki basedir with trailing slash ex: dump/)" => "Ruta dels arxius a resumir (relatiu al directori tiki, amb barra ex: dump/)",
"ver" => "versió",
"sort order" => "criteri d'ordenació",
"Edit selection" => "Edita la selecció",
"Error: This page is being edited by another user." => "Error: aquesta pàgina està essent editada per un altra persona usuària.",
"updated by the phpwiki import process" => "actualitzat pel procés d'importació de phpwiki",
"created from phpwiki import" => "creada des de phpwiki import",
"Security check failed!" => "Verificació de seguretat fallida!",
"MenuID" => "MenuID",
"missing tracker ID for plugin TRACKER" => "manca l'ID del formulari per al connector TRACKER",
"Workspace not selected" => "No s'ha seleccionat cap Espai de Treball",
"Resource type not selected" => "Tipus de recurs no seleccionat",
"Permission denied you cannot create new resources" => "Permís denegat, no podeu crear recursos nous",
"Name requiered" => "Es requereix el nom",
"Permission denied, you cannot admin the workspace" => "Permís denegat, no podeu administrar l'Espai de Treball",
"Tip: hold down CTRL to select multiple categories" => "Pista: manteniu apretat CTRL per selecciar multiples categories",
"Tip: uncheck the above checkbox to uncategorize this page/object" => "Pista: desselecciona el quadre de verificació de sobre per descategoritzar aquesta pàgina/objecte",
"usernames separated with ;" => "noms d'usuaris separats per ;",
"reply to" => "respon a",
"AulaWiki Assistant" => "Assitent de l'AulaWiki",
"Welcome to AulaWiki" => "Benvinguts/des a AulaWiki!",
"First configuration steps" => "Primers passos de configuració",
"module" => "mòdul",
"to the users that you want to use AulaWiki workspaces" => "a les persones usuàries que vols que emprin els espais de treball d'AulaWiki",
"Change theme" => "Canvia l'estil de tema",
"to workspaces.css" => "a workspaces.css",
"Define the <a class='link' href=\"./tiki-workspaces_roles.php\">workspace roles</a> and permission levels." => "Defineix els <a class='link' href=\"./tiki-workspaces_roles.php\">rols de l'espai de treball</a> i els nivells de permisos.",
"Define the <a class='link' href=\"./tiki-workspaces_types.php\">workspace types</a> , use MenuID 100 or <a class='link' href=\"./tiki-admin_menus.php\">define your own menu</a>. Assign <img src='img/icons/change.gif' border='0' alt='Workspace type resources' title='Workspace type resources' /> default resources and <img src='img/icons/mo.png' border='0' alt='Assigned modules' title='Assigned modules' /> desktop modules." => "Defineix els <a class='link' href=\"./tiki-workspaces_types.php\">tipus d'espais de treball</a> , empra el MenuID 100 o <a class='link' href=\"./tiki-admin_menus.php\">defineix el teu propi menú</a>. Assigna <img src='img/icons/change.gif' border='0' alt='Workspace type resources' title='Workspace type resources' /> els recursos per defecte i <img src='img/icons/mo.png' border='0' alt='Assigned modules' title='Assigned modules' /> els mòduls visibles al seu escriptori.",
"Create a workspace" => "Crea un espai de treball",
"of the previosly defined type" => "del Tipus definit prèviament",
"Assign workspace users and groups" => "Assigna usuaris i grups als Espais de Treball",
"Admin the workspace resources" => "Administra els recursos dels Espais de Treball",
"View the workspace desktop" => "Visualitza l'escriptori de l'Espai de Treball",
"Break module" => "Mòdul de fi de columnes",
"Workspace Calendar" => "Calendari de l'Espai de Treball",
"List events" => "Llista esdeveniments",
"Child Workspaces" => "Espais de treball fills",
"Inactive workspace" => "Espai de treball inactiu",
"Clipboard" => "Portaretalls",
"Empty clipboard" => "Buida el portaretalls",
"Workspace History" => "Història de l'Espai de Treball",
"prev posts" => "publicacions prèvies",
"next posts" => "publicacions següents",
"prev files" => "arxius previs",
"next files" => "arxius següents",
"prev images" => "imatges prèvies",
"next images" => "imatges següents",
"My Workspaces" => "Els meus Espais de Treball",
"Current workspace:" => "Espai de treball actual:",
"Active workspace" => "Espai de treball actiu",
"My workspaces:" => "Els meus espais de treball:",
"Resources" => "Recursos",
"Object type:" => "Tipus d'objecte:",
"are you sure to remove object " => "segur que vols eliminar l'objecte ",
"UserGroups" => "Grups d'Usuaris",
"Group Name:" => "Nom de Grup:",
"are you sure to remove group " => "segur que vols eliminar el grup ",
"are you sure to remove user from group " => "segur que vols eliminar a l'usuari del grup ",
"View Structure" => "Visualitza estructura",
"Workspace Members" => "Membres de l'Espai de Treball",
"offline users" => "usuaris no-connectats",
"Site Calendar" => "Calendari del Lloc",
"Please see the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://doc.tikiwiki.org/tiki-index.php?page=Features\">evaluation of each feature</a> on Tiki's developer site." => "Consulta l'<a class=\"rbox-link\" target=\"tikihelp\" href=\"http://doc.tikiwiki.org/tiki-index.php?page=Features\">avaluació de cada funcionalitat</a> al lloc Tiki sobre desenvolupament.",
"Create a group for each user <br />(with the same\nname as the user)" => "Crear un grup per a cada usuari/a <br />(amb the mateix\nnom que l'usuari/a)",
"Field is public? (for use thru trackerlist plugin)" => "El camp és públic? (per ser emprat a través del connector trackerlist)",
"Batch upload (CSV file<a {popup text='login,password,email,groups<br />user1,password1,email1,&quot;group1,group2&quot;<br />user2, password2,email2'}><img src=\"img/icons/help.gif\" border=\"0\" height=\"16\" width=\"16\" alt='{tr}help" => "Càrrega en bloc (arxiu CSV<a {popup text='login,password,email,groups<br />user1,password1,email1,&quot;group1,group2&quot;<br />user2, password2,email2'}><img src=\"img/icons/help.gif\" border=\"0\" height=\"16\" width=\"16\" alt='{tr}ajuda",
"Note: if you want to use images please save the post first and you\nwill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\nor use the image URL to include images using the WYSIWYG editor" => "Nota: si vols fer servir imatges guarda el post primer\ni a les hores edita/envia les imatges. Fes servir el &lt;img&gt; snippet per incloure les imatges al area de texte\no s'ha de fer servir l'URL de la imatge amb l'editor WYSIWYG",
"use ...page... to separate pages" => "utilitzeu...pàgina...per separar les pàgines",
"Welcome to the installation & upgrade script!" => "Benvinguts/des al procés d'instal·lació & actualitació!",
"Your database has been configured and Tiki is ready to run, if\n    \t\tthis is your first install your admin password is 'admin'. You can\n    \t\tnow log in into Tiki as 'admin' - 'admin' and start configuring\n    \t\tthe application" => "La teva base de dades ha estat configurada i Tiki està llest per fer-se servir; si \n    \t\taquesta és la teva primera instal·lació, la teva contrasenya d'usuari administrador (admin) és 'admin'. Pots \n    \t\tara ja connectar-te a Tiki com 'admin' - 'admin' i començar a configurar \n    \t\tla aplicació",
"Workspaces Administration" => "Administració de l'Espai de Treball",
"Closed" => "Tancat",
"Hide workspace" => "Oculta l'espai de treball",
"Assigned modules" => "Mòduls Assignats",
"Users/Groups" => "Usuaris/Grups",
"Desktop" => "Escriptori",
"Workspace path:" => "Ruta a l'Espai de Treball:",
"Admin resource" => "Administra recurs",
"Roles Administration" => "Administració de Rols",
"Workspace Types Administration" => "Administració del Tipus d'Espai de Treball",
"Allow private user zone" => "Permet zona privada de persona usuària",
"Workspace Types Resources" => "Recursos del Tipus d'Espai de Treball",
"Workspace type name" => "Nom del tipus de l'Espai de Treball",
"Resource name" => "Nom de recurs",
"Resource description" => "Descripció del recurs",
"Resource type" => "Tipus de recurs",
"Invalid variable value : " => "Invàlid valor de variable: ",
"Code in use, please select a different code" => "Aquest codi ja s'utilitza, si us plau seleccioneu-ne un altre diferent",
"Code not selected" => "Codi no seleccionat",
"Workspace not found" => "No s'ha trobat l'Espai de Treball",
"Closed Workspace" => "Espai de treball tancat",
"Resource name not selected" => "No s'ha seleccionat el nom del recurs",
"Resource not found" => "No s'ha trobat el recurs",
"Role name not selected" => "No s'ha seleccionat cap nom de rol",
"Role name in use, please select a different name" => "Aquest nom de rol ja és emprat, selecciona un nom diferent, si us plau",
"Workspace type not found" => "No s'ha trobat l'Espai de Treball",
"Workspace type not selected" => "No s'ha seleccionat cap tipus d'espai de treball",
"Module not set" => "No s'ha especificat el mòdul",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"perms" => "perms",
"similar" => "similar",
"loc" => "loc",
"cat" => "cat",
"prio" => "prio",
"coms" => "coms",
"ppd" => "ppd",
"url" => "url",
"admin groups template" => "administra plantilla de grups",
"articles" => "articles",
"uploaded by" => "pujat/da per",
"not specified" => "no especificat",
"There was a problem with your upload." => "Hi ha hagut un problema amb la teva pujada.",
"The file you are trying to upload is too big." => "El fitxer que s'està intentant pujar es massa gran.",
"The file you are trying to upload was only partially uploaded." => "El fitxer que s'està pujant nomès s'ha transferit parcialment.",
"You must select a file for upload." => "Has de seleccionar un fitxer per pujar.",
"%s is an empty archive file" => "%s és un arxiu buit",
"Invalid remote file on url %s" => "Arxiu remot invàlid a la url %s",
"Project Group for " => "Grup del projecte per ",
"Project Admin Group for " => "Grup d'admins del projecte per ",
"%A %d of %B, %Y" => "%A %d de %B, %Y",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A %d de %B, %Y[%H:%M:%S %Z]",
"%a %d of %b, %Y" => "%a %d de %b, %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a %d de %b, %Y[%H:%M %Z]",
"delete" => "elimina",
"post" => "publicar",
"stop monitoring this blog" => "desubscriu-te a aquesta bitàcola",
"posts" => "publicacions",
"visits" => "visites",
"show categories" => "mostra categories",
"author" => "autor",
"user level" => "nivell d'usuari/a",
"send email to user" => "enviar email a usuari",
"score" => "puntuació",
"delete selected" => "esborrar seleccionats",
"move" => "moure",
"Posted messages" => "Missatges publicats",
"set" => "especifica",
"replies" => "respostes",
"new reply" => "resposta nova",
"cancel" => "cancel·la",
"up" => "amunt",
"down" => "avall",
"stop monitoring this map" => "deixa de seguir aquest  mapa",
"create" => "crear",
"save" => "guardar",
"send" => "envia",
"Hide module contents" => "Amaga contingut del mòdul",
"signed" => "signat",
"Last visitors" => "Últims visitants",
"register" => "registra't",
"standard" => "estàndar",
"secure" => "segur",
"stay in ssl mode" => "roman en mode segur (ssl)",
"new messages" => "nous missatges",
"new message" => "nou missatge",
"go" => "ves-hi",
"use" => "empra",
"cached" => "captat en memòria cau",
"refresh" => "refresc",
"print" => "imprimir",
"create pdf" => "crea un pdf",
"monitor this page" => "vigila aquesta pàgina",
"stop monitoring this page" => "deixa de vigilar aquesta pàgina",
"backlinks" => "retroenllaços",
"last modification:" => "última modificació:",
"click here" => "cliqueu aquí",
"rename" => "reanomenar",
"unlock" => "desbloquejar",
"lock" => "bloquejar",
"history" => "historial",
"undo" => "desfès",
"slides" => "diapos",
"export" => "exporta",
"discuss" => "debat",
"add comment" => "afegeix un comentari",
"attach file" => "adjuntar arxiu",
"translation" => "traducció",
"last modification" => "Última modificació",
"attachments" => "arxius adjunts",
"stats" => "estadistiques",
"last changes" => "darreres modificacions",
"list pages" => "llista pàgines",
"back to homepage" => "tornar a inici",
"logout" => "desconnecta't",
"cancel edit" => "cancel·la edició",
"No attachments for this page" => "No hi ha adjuncions per a aquesta pàgina",
"Skip to navigation" => "Saltar a navegació",
"switch" => "canvi",
"view blog" => "visualitza bitàcola",
"list blogs" => "llista bitàcoles",
"save and exit" => "guardar i sortir",
"reads" => "lectures",
"view comments" => "visualitza comentaris",
"Click here to create it" => "Cliqueu aquí per crear-ho",
"wiki help" => "ajuda wiki",
"Personal portfolio" => "ePortfolio Personal de l'usuari/a",
"General preferences" => "Preferències generals",
"Other preferences" => "Altres preferències",
"flag" => "bandera",
"HomePage" => "Inici",
"Edit information" => "Edita la informació",
"Change information" => "Canvia la informació",
"ok" => "d'acord",
"Best language" => "Millor idioma",
"Workspaces" => "Espais de treball",
"System Features" => "Característiques del sistema",
"Signal System" => "Sistema de senyal",
"Enable cache images to all galleries" => "Habilita posar les imatges en memòria cau per a totes les galeries",
"Images cache directory" => "Directori per la memòria cau de les imatges",
"images" => "imatges",
"PHP error reporting level for non-admin:" => "Nivell d'informació sobre errors per a no administradors:",
"Server name (for absolute URIs)" => "Nom del servidor (per URIs absolutes)",
"HTTPS Server" => "Servidor HTTPS (segur)",
"Wiki_Tiki_Title" => "Títol del Wiki",
"path" => "ruta",
"groups" => "grups",
"Admin->Features" => "Admin->Funcionalitats",
"must be turned on and notification is sent to the admin's" => "han de ser activats/des i la notificació és enviada a la bústia de missatges Tiki de l'administrador",
"inter-user message inbox" => "bústia d'entrada de missatges inter-usuaris",
"Validate email address (may not work)" => "Valida adreces de correu-e (pot no funcionar)",
"Require HTTP Basic authentication" => "Requereix autenticació bàsica HTTP",
"HTTP server name" => "Nom del servidor HTTP",
"HTTP URL prefix" => "Prefix de les URL d'HTTP",
"HTTPS server name" => "Nom del servidor HTTPS",
"HTTPS URL prefix" => "Prefix de les URL d'HTTPS",
"Only for users" => "Només per a usuaris/es",
"Users and admins" => "Usuaris i admins",
"Full Text Search" => "Cerca a text complet",
"Don't forget: to use feature you will need to enable it on" => "No t'oblidis: per emprar la funcionalitat necessitaràs habilitar-la a",
"Custom Code" => "Codi Adaptat",
"Site breadcrumbs" => "Rastres en el lloc",
"Site search bar" => "Barra de cerca del lloc",
"Site logo" => "Logo del lloc",
"Site logo source" => "Font del logo del lloc",
"Site ads and banners" => "Anuncis i pancartes del lloc",
"Site Menu" => "Menú del lloc",
"Note: This feature also requires phplayers to be turned on in Admin->Features" => "Nota: Aquesta funcionalitat també requereix que els menús per capes phplayers siguin activats a Admin->Funcionalitats",
"change" => "canviar",
"Manage attachment preferences" => "Gestiona les preferències dels adjunts",
"HTML in Wiki Pages" => "HTML en Planes Wiki",
"Wiki syntax used when a page contains HTML" => "Sintaxi Wiki emprada quan una pàgina contè HTML",
"full" => "sencer",
"partial" => "parcial",
"Search and replace" => "Cerca i reemplaça",
"Enable Feature" => "Activa la Característica",
"Wiki attachments preferences" => "Preferències dels adjunts al Wiki",
"Admin Action Log" => "Administra el Registre d'Accions",
"admin banning tpl" => "administrar plantilla per a prohibició",
"lang" => "idm",
"permissions" => "permisos",
"admin categories" => "administrar categories",
"admin categories tpl" => "administrar plantilla per a categories",
"create new" => "crear nou",
"edit chart" => "edita chart",
"update" => "actualitza",
"admin content templates" => "administrar contingut de les plantilles",
"use in cms" => "fes servir en el cms",
"use in wiki" => "fes servir en el wiki",
"use in newsletters" => "empra en butlletins",
"use in HTML pages" => "fes servir en pàgines HTML",
"last modif" => "darrera modificació",
"sections" => "seccions",
"admin FortuneCookie" => "administrar Galeta de la Sort",
"admin FortuneCookie tpl" => "administrar plantilla per a la Galeta de la Sort",
"upload" => "puja",
"admin Drawings tpl" => "administrar plantilla per a Dibuixos",
"admin External Wikis" => "admin Wikis Externs",
"extwiki" => "wikiext",
"Edit existing forums" => "Edita fòrums existents",
"topics" => "temes",
"age" => "edat",
"last post" => "darrer missatge",
"Assign Permissions (Active)" => "Assignar permisos (Actiu)",
"Click here to delete this forum" => "Fes clic aquí per esborrar aquest fòrum",
"admin hotwords" => "administrar paraules calentes",
"admin hotwords template" => "administra la plantilla de paraules calentes",
"admin HTML page dynamic zones" => "administrar zones dinàmiques de la pàgina HTML",
"list repositories" => "llista dipòsits",
"new repository" => "nou dipòsit",
"view repository" => "visualitza dipòsit",
"view this repository" => "veure aquest dipòsit",
"new rule" => "nova regla",
"admin featured links" => "administra d'enllaços destacats",
"position" => "posició",
"admin Webmail" => "administrar Correu-Web",
"admin mailin template" => "administrar plantilla per a butlletins",
"section" => "secció",
"sorted section" => "secció ordenada",
"admin menu builder" => "Constructor de menús d'administració",
"options" => "opcions",
"admin modules" => "administració de mòduls",
"assign module" => "assigna mòdul",
"left modules" => "mòduls a l'esquerra",
"right modules" => "mòduls ala dreta",
"edit/create" => "editar/crear",
"clear cache" => "esborra memòria cau",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\n<b>Nota 1</b>: si permeteu als usuaris configurar els mòduls,  els mòduls\nassignats no es veurena a la pantalla fins que no els configureu\ndes de ElMeuTiki->mòdulss.<br />\n<b>Nota 2</b>: Si assigneu mòduls a grups, assegureu-vos de tenir\ndesconnectada l'opció 'mostra sempre els mòduls a tots els grups'\nde Admin->General\n",
"assign" => "assignar",
"left" => "esquerra",
"right" => "dreta",
"order" => "ordre",
"parameters" => "paràmetres",
"create/edit" => "crea/edita",
"use poll" => "usar votacions",
"use gallery" => "empra galeria",
"use dynamic  content" => "usa contingut dinàmic",
"use rss module" => "empra mòdul RSS",
"use menu" => "empra menú",
"use phplayermenu" => "empra phplayermenu",
"use banner zone" => "usa zones de banners",
"structure" => "estructura",
"list newsletters" => "llista butlletins",
"admin newsletters" => "administra butlletins",
"send newsletters" => "envia butlletins",
"editions" => "edicions",
"drafts" => "esborranys",
"last sent" => "últims enviats",
"admin Email Notifications" => "administra les notificacions de correu electrònic",
"use admin email" => "fes servir el correu-e de l'admin",
"event" => "aconteixement",
"admin polls" => "administrar votacions",
"admin QuickTags" => "administrar Marques ràpides",
"label" => "etiqueta",
"admin RSS Modules" => "administrar mòduls RSS",
"export pages" => "exportar pàgines",
"dump tree" => "baixa't l'arbre",
"create webhelp" => "crear ajudaweb",
"view webhelp" => "visualitza ajutweb",
"tree" => "arbre",
"create new structure" => "crear nova estructura",
"survey stats" => "estadístiques d'enquestes",
"edit this survey" => "edita aquesta enquesta",
"admin surveys" => "administra enquestes",
"list surveys" => "llista enquestes",
"questions" => "preguntes",
"If your Tiki is acting weird, 1st thing to try it to clear your cache below. Also very important to clear your cache after an upgrade (by FTP/SSH if need be)." => "Si el teu Tiki està actuant de forma rara, la primera cosa a provar és netejar la memòria cau de sota. També és molt important netejar la teva memòria cau després d'una actualització (per FTP/SSH si és necessari).",
"files" => "arxius",
"advanced feature" => "funcionalitat avançada",
"admin Trackers tpl" => "admin plantilles de formularis",
"Edit fields for tracker" => "Edita els camps del formulari",
"items" => "punts",
"The tracker needs a text field named Subject" => "El formulari necessita un camp de text anomenat Tema",
"version" => "versió",
"tracker_{\$trackerId}.csv" => "formulari {\$trackerId}.csv",
"Import file" => "Importa arxiu",
"admin groups" => "administarció de grups",
"assign permissions" => "assigna permisos",
"admin" => "administrar",
"remove from group" => "elimina del grup",
"admin users" => "administrar usuaris",
"edit account settings" => "edita els paràmetres del compte",
"edit included group" => "edita el grup inclòs",
"remove users and their userpages" => "elimina els usuaris i les seves planes d'usuari",
"assign to groups" => "assigna a grups",
"edit article tpl" => "edita plantilla per a article",
"all" => "tots",
"Assign user" => "Assignar usuari",
"Available groups" => "Grups disponibles",
"assign perms to this group" => "assigna permisos a aquest grup",
"admin backups" => "administra les còpies de seguretat",
"admin admin tpl" => "admin plantilla admin",
"Use of this feature is NOT recommended. Please use phpMyAdmin or mysqldump instead." => "Es recomana NO EMPRAR aquesta funcionalitat. Si us plau, empreu phpMyAdmin o mysqldump en el seu lloc.",
"List of available backups" => "Llista de còpies de seguretat disponibles",
"Restoring a backup" => "Recupera una còpia de seguretat",
"Warning!" => "Atenció!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "La restitució d'una còpia de seguretat destruirà totes les dades de la teva base de dades del Tiki. Totes les teves taules seran reemplaçades amb la informació de la còpia de seguretat.",
"Click here to confirm restoring" => "Punxa aquí per confirmar la recuperació de la còpia de seguretat",
"Create new backup" => "Crea una còpia de seguretat nova",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "La creació de còpies de seguretat pot durar molt temps. Si el procés no es pot completar veuràs una pantalla blanca. Si passa això necessitaràs incrementar el temps màxim d'execució de macro al teu fitxer php.ini",
"Your image gallery storage is set to \"{\$gal_use_dir}\", you will need to backup this using FTP or SCP." => "El magatzem de la teva galeria d'imatges està fixat a \"{\$gal_use_dir}\", necessitaràs fer-ne còpies de seguretat emprant FTP o SCP.",
"Your file gallery storage is set to \"{\$fgal_use_dir}\", you will need to backup this using FTP or SCP." => "El magatzem de la teva galeria de fitxers està fixat a \"{\$gal_use_dir}\", necessitaràs fer-ne còpies de seguretat emprant FTP o SCP.",
"If any of your forums have attachments stored in the directory you will need to backup these using FTP or SCP." => "Si qualsevol dels teus fòrums porta adjunts al seu directori necessitaràs fer-ne còpia de seguretat a través d' FTP o SCP.",
"Upload a backup" => "Puja una còpia de seguretat",
"Upload backup" => "Puja còpia de seguretat",
"edit gallery" => "edita la Galeria",
"rebuild thumbnails" => "reconstrueix miniatures",
"upload image" => "Pujar imatge",
"list gallery" => "llista la galeria",
"original size" => "tamany original",
"return to gallery" => "torna a la galeria",
"edit image" => "edita dibuix",
"smaller" => "més petit",
"bigger" => "més gran",
"prev image" => "imatge prèvia",
"popup window" => "finestra emergent",
"next image" => "propera imatge",
"stop" => "atura",
"imagescale" => "escala de la imatge",
"or create a new category" => "o crear una nova categoria",
"or create a new location" => "o crear una nova localització",
"comma separated usernames" => "nom d'usuari separat per comes",
"comma separated username:role" => "separat per comes nom d'usuari:funció",
"with roles" => "amb els rols",
"Chair" => "Cadira",
"Optional" => "Opcional",
"permission" => "permís",
"remove from this category &amp; all its children" => "elimina d'aquesta categoria &amp; i totes les seves filles",
"remove from this category only" => "elimina només aquesta categoria",
"remove page" => "eliminar pàgina",
"admin directory tpl" => "administrar plantilla per a directori de categories",
"browse" => "examina",
"related" => "relacionat",
"validate" => "valida",
"add a site" => "afegiu un lloc",
"add a category" => "afegeix una categoria",
"search" => "cerca",
"edit template" => "edita plantilla",
"list articles" => "llista d'articles",
"view articles" => "visualitza articles",
"create zone" => "crear zona",
"save the banner" => "desar el banner",
"edit blog tpl" => "edita plantilla per a bitàcola",
"Allow trackback pings" => "Permet trackback pings",
"try" => "prova",
"display" => "pantalla",
"admin quicktags" => "admin marques ràpides",
"create new block" => "crear un nou bloc",
"list quizzes" => "fes llista de qüestionaris",
"quiz stats" => "estadístiques de tests",
"edit this quiz" => "edita aquest test",
"admin quizzes" => "administrar qüestionaris",
"admin quizzes tpl" => "administrar plantilla per a qüestionaris",
"results" => "resultats",
"create page" => "crear pàgina",
"edit submissions tpl" => "edita plantilla per a submissions",
"list submissions" => "llista de submissions",
"add to the set" => "afegeix al conjunt",
"Search " => "Cerca ",
"replace" => "reemplaça",
"Admin ephemerides" => "Administrar efemèrides",
"admin Ephemerides tpl" => "administrar plantilla per a Efemèrides ",
"All ephemerides" => "Totes les efemèrides",
"list sheets" => "llista fulls",
"new question" => "pregunta nova",
"approve" => "aprova",
"configure listing" => "configura llistat",
"topic" => "tòpic",
"save and approve" => "desa i aprova",
"new topic" => "nou tema",
"reject" => "rebutja",
"accept" => " accepta",
"refuse" => "rebutja",
"add new" => "afegeix nou/va",
"add role" => "afegeix funció",
"new minor" => "nou menor",
"new major" => "nou major",
"admin processes" => "administració de processos",
"admin activities" => "administarció d'activitats",
"admin roles" => "administració de rols",
"edit this process" => "edita aquest procés",
"monitor" => "vigilància",
"send instance" => "enviar instància",
"create new gallery" => "crear una nova galeria",
"result" => "resultat",
"reload" => "recarrega",
"Note: This install script may be potentially harmful so we strongly\n    \t\trecommend you to disable the script and then proceed into Tiki. If\n    \t\tyou decide to reuse later, just follow the instructions in\n\t\ttiki-install.php to restore" => "Nota: Aquesta seqüència (script) d'instal·lació pot ser potencial perillós si es deixa accesible a tothom, així que recomanem encoratjadament \n    \t\t que la desactivis abans de pasar a connectar-te a Tiki. Si\n    \t\tdecideixes tornar-la a fer servir més endavant, només cal que segueixis les instruccions a\n\t\ttiki-install.php per restaurar-la",
"Tiki has detected your PHP memory limit at only 8 Megs" => "Tiki ha detectat que el teu limit de memòria per a PHP es troba en només  8 MB",
"edit repository" => "edita dipòsit",
"source" => "font",
"list articles tpl" => "plantilla per a llista d'articles",
"edit new article" => "edita nou article",
"admin Banners" => "administració de Banners",
"admin Banners tpl" => "administrar plantilla per a Pancartes",
"create new blog" => "crear una nova bitàcola",
"admin cache" => "administrar caxé",
"admin cache tpl" => "administrar plantilla per a caxé ",
"admin DynamicContent tpl" => "administrar plantilla de Contigut dinàmic ",
"list faqs tpl" => "llistat de preguntes més freqüents",
"upload file" => "puja arxiu",
"Edit a file using this form" => "Edita un arxiu utilitzant aquest formulari",
"delete selected files" => "esborra els arxius seleccionats",
"browse gallery" => "fulleja galeria",
"Flash binary (.sqf or .dcr)" => "Arxiu Flash (.sqf or .dcr)",
"list posts tpl" => "plantilla per a llista d'enviaments",
"edit blog" => "Edita bitàcola",
"edit new submission" => "edita la nova petición",
"admin live support tpl" => "xxx",
"set as operator" => "definit com a operador",
"add topic" => "afegiu-hi un tema",
"install" => "instal·la'l",
"wiki create" => "crea wiki",
"wiki overwrite" => "sobrescriu wiki",
"back" => "enrera",
"Assign permissions to page" => "Assignar permisos a la pàgina",
"Current permissions for this page" => "permisos actuals per a aquesta pàgina",
"remove from this page" => "Esborrar d'aquesta  pàgina",
"remove from this structure" => "Esborrar d'aquesta estructura",
"No individual permissions; category or global permissions apply" => "Cap permís local (individual); s'aplicaran els permisos de la categoria o els globals",
"this page" => "aquesta pàgina",
"this structure" => "aquesta estructura",
"Current permissions for categories that this page belongs to" => "Permisos actuals per categories a les quals pertany aquesta pàgina",
"Send email notifications when this page changes to" => "Envia notificacions email quan aquesta pàgina canvii a",
"add email" => "afegeix una adreça de correu-e",
"Notifications" => "Notificacions",
"clear stats" => "esborrar estadístiques",
"Edit received page" => "Edita pàgina rebuda",
"admin Referer stats" => "administrar estadístiques dels Referents",
"admin Referer stats tpl" => "administrar plantilla per a estadístiques dels Referents",
"last" => "darrer/a",
"send me my password" => "envia'm la meva contrasenya",
"searched" => "cercat",
"galleries" => "galeries",
"blog posts" => "publicacions a bitàcoles",
"wiki pages" => "pàgines wiki",
"admin send objects tpl" => "administrar plantilla per a enviar objectes",
"site" => "lloc",
"clear" => "neteja",
"add article" => "afegeix article",
"create new sheet" => "crea un nou full",
"admin Tiki Shoutbox" => "admin quadre d'avisos del Tiki",
"admin Tiki Shoutbox tpl" => "administrar plantilla per a Tiki Shoutbox",
"send answers" => "envia respostes",
"move to right column" => "moure ala columna dreta",
"unassign" => "desassigna",
"move to left column" => "moure a la columna esquerra",
"remove folder" => "elimina carpeta",
"refresh cache" => "refresca memòria cau",
"use google map locator" => "empra el localitzador dels mapes de google",
"admin mode" => "mode administrador",
"trash" => "paperera",
"empty trash" => "buida paperea",
"remove from trash" => "elimina de la paperera",
"edit user files" => "edita els arxius de l'usuari",
"no comments" => "sense comentaris",
"edit items" => "edita items",
"list charts" => "llista de gràfiques",
"last chart" => "Darrera llista",
"item" => "ítem",
"view faq" => "visualitza puf",
"view faq tpl" => "visualitza plantilla de puf",
"admin menus tpl" => "administrar plantilla per a menús",
"add suggestion" => "afegeix un suggeriment",
"monitor this forum" => "Segueix aquest fòrum",
"stop monitoring this forum" => "deixa de seguir aquest fòrum",
"delete selected topics" => "esborrar temes seleccionats",
"stop monitoring this topic" => "deixa de seguir aquest tòpic",
"Comments below your current threshold" => "Comentaris sota mínim llindar actual",
"list attachments" => "llista adjunts",
"remove image" => "elimina imatge",
"add contacts" => "afegeix contactes",
"DATE-of" => "de",
"You cannot edit this page because it is a user personal page" => "No pots editar aquesta pàgina, ja que és una pàgina personal d'un usuari",
"Permission denied you cannot assign permissions for this page" => "No tens autorització per assignar permisos en aquesta pàgina",
"Cannot read file" => "No es pot llegir l'arxiu",
"Permission denied you cannot upload files" => "Permís denegat, no podeu pujar fitxers",
"cannot process upload" => "no s'ha pogut processar la pujada",
"Your email address has been removed from the list of addresses monitoring this tracker" => "La teva adreça de correu-e ha estat eliminada de la llista d'adreces subscrites a aquest formulari",
"Your email address has been added to the list of addresses monitoring this tracker" => "La teva adreça de correu-e ha estat afegida a la llista d'adreces subscrites a aquest formulari",
"Cancel monitoring" => "Deixa de vigilar-ho",
"Your email address has been removed from the list of addresses monitoring this item" => "La teva adreça de correu-e ha estat eliminada de la llista d'adreces subscrites a aquest item",
"Your email address has been added to the list of addresses monitoring this item" => "La teva adreça de correu-e ha estat afegida a la llista d'adreces subscrites a aquest item",
"pdf" => "pdf",
"categories" => "categories",
"UTC" => "UTC",
"Local" => "Local",
"Ratio" => "Ratio",
"proc" => "proc",
"pos" => "pos",
"emot" => "emot",
"pop" => "pop",
"new image uploaded by" => "nova imatge pujada per",
"new subscriptions" => "subscripcions noves",
"new item in tracker" => "nova entrada al formulari",
"tikiwiki logo" => "logo tikiwiki",
"show" => "mostrar",
"hide" => "oculta",
"Table Of Contents" => "Taula de continguts",
"field is not numeric" => "el camp no és numèric",
"message" => "missatge",
"Include an article" => "Inclou un article",
"select all" => "selecciona-ho tot",
"All fields must be from the same tracker" => "Tots els camps han de ser del mateix formulari",
"filter" => "filtra",
"missing fields list" => "manca llista de camps",
"no such file" => "Aquest fitxer no hi és",
"downloads" => "descàrregues",
"download" => "descarregar",
"hide categories" => "oculta categories",
"Admin categories" => "Administra categories",
"reply" => "respon",
"monitor this topic" => "Segueix aquest tema",
"active perms" => "activar permisos",
"Dls" => "Descàrr..",
"move selected files" => "mou els arxius seleccionats",
"Thank you for you registration. You may log in now." => "Gràcies pel seu registre. Ara pot connectar-se",
"from\nthe mapfile:" => "des del\n mapfile:",
"compare" => "comparar",
"diff" => "dif",
"older version" => "versió més vella",
"Click the :: options in the Menu for more options." => "Clica les opcions :: en el Menú per a més opcions.",
"Please, also see" => "Si us plau, mira també",
"for more setup details." => "per a més opcions.",
"Note 1:" => "Nota 1:",
"You can remove this module in" => "Pots eliminar aquest mòdul a",
"Note 2:" => "Nota 2:",
"Create pdf" => "Crea un pdf",
"List pages where I am a creator" => "Llista pàgines on en sóc creador",
"by creator" => "pel creador/a",
"List pages where I am a modificator" => "Llista pàgines on en sóc modificador",
"by modificator" => "pel modificador/a",
"at tracker" => "al formulari",
"check / uncheck all" => "marcar / desmarcar tot",
"Tiki sections and features" => "Seccions del Tiki i Funcionalitats",
"tikiwiki.org help" => "ajuda en tikiwiki.org",
"Site Logo and Identity" => "Logo del lloc i Identitat",
"Storing files in a directory" => "Guarda arxius en un directori",
"please read" => "Si us plau, llegiu-ho",
"yes" => "si",
"Click here for more details." => "Fes clic aquí per a més detalls.",
"Best Language" => "Millor idioma",
"Tiki preferences value field in db is set to be max. 250 characters long by default until now. That applies for the custom code content too. Check this field if you want to update your preferences database table to support more than 250 chars (although it was tested and works fine with mysql, it's recommended to backup your data manually before any database update)" => "El valor del camp de les preferències Tiki a la base de dades està fixat en com a màxim 250 caracters de llarg (per defecte fins ara). Això té validesa també sobre sobre el contingut del codi adaptat. Marca aquesta casella si vols actualitzar la taula de preferències de la teva base dades per permetre més de 250 caracters (malgrat ha estat provat i funciona bé amb mysql, és recomanable fer una còpia de seguretat de la base de dades manualment abans de qualsevol actualització de la base de dades)",
"Users &amp; groups" => "Usuaris &amp; grups",
"private" => "privat",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS Modules\" on the application menu, or" => "Aquesta pàgina és per configurar els paràmetres de les alimentacions RSS generades/exportades per Tiki. Per llegir/importar alimenacions RSS, cerca \"Mòduls RSS\"  en el menú principal de l'aplicació, o",
"<b>Feed</b>" => "<b>Alimentació</b>",
"<b>enable/disable</b>" => "<b>habilita/deshabilita</b>",
"<b>Max number of items</b>" => "<b>Quantitat màxima d'ítems</b>",
"Feed for Articles" => "Alimentació per als articles",
"Feed for Weblogs" => "Alimentació per a les bitàcoles web",
"Feed for Image Galleries" => "Alimentació per a les galeries d'imatges",
"Feed for File Galleries" => "Alimentació per a les galeries d'arxius",
"Feed for the Wiki" => "Alimentació per al Wiki",
"Feed for individual Image Galleries" => "Alimentacío per a galeries d'imatges individuals",
"Feed for individual File Galleries" => "Alimentació de galeria d'arxius individuals",
"Feed for individual weblogs" => "Alimentació per a bitàcoles web individuals",
"Feed for individual forums" => "Alimentació per fòrums individuals",
"Feed for mapfiles" => "Contigut per als mapfiles",
"Feed for directories" => "Contingut per als directoris",
"Feed for individual tracker items" => "Alimentació RSS per ítems individuals de formularis",
"Feed for tracker items" => "Alimentació RSS per a ítems de formularis",
"Feed for upcoming calendar events" => "Alimentació RSS per propers esdeveniments del calendari",
"Prefix breadcrumbs with 'Location:' label?" => "Posa un prefix al Rastre amb l'etiqueta 'Lloc:'?",
"Site Search" => "Cerca del lloc",
"Change style only" => "Canvia només l'estil de tema (estètica)",
"WARNING : Old and New trackers cannot coexist. Trackers created with new library\nwill not work with old library and conversely" => "AVÍS : Formularis vells i nous no poden coexistir. Els Formularis creats amb la nova llibreria\nno funcionaran amb la vella llibreria i viceversa",
"PDF generation" => "generació de PDF",
"Statistic" => "Estadístiques",
"Edit Existing Forums" => "Edita Fòrums existents",
"configure repositories" => "configura dipòsits",
"configure this repository" => "configurar aquest dipòsit",
"copy rules" => "copiar regles",
"subscriptions" => "subscripcions",
"Tip: hold down CTRL to select multiple" => "Pista: menté apretada la tecla CTRL per a seleccions múltiples",
"activate" => "activa",
"fields" => "camps",
"active permissions" => "permisos actius",
"filename" => "nom de l'arxiu",
"filesize" => "mida de l'arxiu",
"filetype" => "tipus d'arxiu",
"longdesc" => "descripció llarga",
"Import/Export CSV Data" => "Importa/Exporta dades en format CSV",
"Add a new group" => "Afegir un grup nou",
"List all members" => "Llista tots els membres",
"Add a new user" => "Afegeix un nou usuari",
"manage group assignments" => "gestiona les assignacions a grups",
"set default groups" => "especifica els grups per defecte",
"Popup Window" => "Finestra emergent",
"details" => "detalls",
"Welcome to the Tiki Chat Rooms" => "Benvinguts/des a les sales de Xat del Tiki",
"Please select a chat channel" => "Si us plau, seleccioneu un canal de xat",
"enter chat room" => "entrar a la sala de xat",
"There are no channels setup, please contact a site admin" => "No existeix cap canal configurat, si us plau, contacte a l'admin del lloc",
"Chatroom" => "Sala de xat",
"Active Channels" => "Canals actius",
"Users in this channel" => "Usuaris en aquest canal",
"Channel Information" => "Informació del canal",
"Channel" => "Canal",
"Use :nickname:message for private messages" => "Empra :sobrenom:missatge per missatges privats",
"Use [URL|description] or [URL] for links" => "Empra [URL|descripció] ó [URL] per a enllaços",
"Use (:smileyname:) for smileys" => "Empra (:nom_d_emotico:) per emoticons",
"Create PDF" => "Crear PDF",
"PDF Settings" => "Configuració de PDF",
"Select Wiki Pages" => "Seleccionar les Pàgines Wiki",
"Remove Page" => "Eliminar pàgina",
"Use ...page... to separate pages in a multi-page article" => "Empra ...page... per separar planes en un article multi-pàgina",
"answer" => "resposta",
"Use this section to set the language of the version you are currently working on." => "Empra aquesta secció per especificar l'idioma de la versió en la qual estàs treballant actualment.",
"Set of Translations" => "Conjunt de Tranduccions",
"Translation of:" => "Traducció de:",
"Enter the name of the page for which the current page is the translation." => "Introdueix el nom de la pàgina per a la cual aquesta és la traducció.",
"Add to the Set" => "Afegeix al conjunt",
"graph" => "gràfica",
"icon" => "icona",
"Available File Galleries" => "Galeries d'arxius disponibles",
"configure forum" => "configura el fòrum",
"start" => "començar",
"end" => "fi",
"roles" => "rols",
"Add role" => "Afegeix funció",
"active process" => "procés actiu",
"invalid" => "invàlida",
"invalid process" => "procés no vàlid",
"valid process" => "procés vàlid",
"activities" => "activitats",
"aborted" => "abortat/da",
"value" => "valor",
"exceptions" => "excepcions",
"Please enter your database connection info" => "Si us plau, introdueix la informació de connexió a la base de dades",
"The type of database you intend to use" => "El tipus de base de dades que tens intenció d'emprar",
"Hostname or IP for your MySQL database, example: localhost if running in the same machine as tiki" => "Nom d'allotjament (Hostname) o adreça IP de la teva base de dades MySQL; exemple: localhost si s'executa en la mateixa màquina que Tiki",
"If you use SQLite, insert the path and filename to your database file" => "Si empres SQLite, introdueix la ruta i nom d'arxiu de l'arxiu de la teva base de dades",
"Database password" => "Contrasenya de la base de dades",
"The name of the database where tiki will create tables. You can create the database using mysqladmin, or PHPMyAdmin or ask your\nhosting service to create a MySQL database.  Normally Tiki tables won't conflict with other product names" => "El nom de la base de dades on Tiki crearà les taules. Pots crear la base de dades emprant mysqladmin, o PHPMyAdmin o demanant-ho al teu \nservei d'allotjament web per que et creïn la base de dades MySQL.  Normalment, les taules de Tiki no entren en conflicte amb els noms de les taules d'altres aplicacions",
"If you use Oracle, you can put your TNS Name here and leave hostname empty\nor you override tnsnames.ora and put your SID here and fill your hostname:port above" => "Si empres Oracle, pots posar el teu Nom TNS aquí i deixar el hostname buit\no sobreescriure  tnsnames.ora i posar el teu SID aquí i omplir el teu hostname:port més amunt",
"Create database (clean install) with profile" => "Crea la base de dades (instal·lació neta) amb perfil",
"Descriptions of the available profiles" => "Descripcions dels perfils disponibles",
"backup your database" => "fes una còpia de seguretat de la teva base de dades",
"with mysqldump or phpmyadmin before you proceed" => "amb mysqldump o phpmyadmin abans de continuar",
"For database update from 1.8 or later" => "Per a actualitzacions de la base de dades des de 1.8 o posterior",
"If you upgrade from 1.8.x you <b>MUST</b> run tiki_1.8to1.9 and don't need an additional script" => "Si actualitzes des de 1.8.x, <b>NECESSITES</b> executar tiki_1.8to1.9 i no necessites cap seqüència (script) addicional",
"If you upgrade from a previous 1.9.x version, use tiki_1.8to1.9, too. (ex.: 1.9.2 to 1.9.5)" => "Si actualitzes des d'una versió prèvia 1.9.x, empra tiki_1.8to1.9, també. (ex.: 1.9.2 a 1.9.5)",
"For database update from 1.7.x, please visit <a target=\"help\" href=\"http://tikiwiki.org/UpgradeTo18\">Tiki database 1.7.x to 1.8x instructions" => "Per actualitzacions de la base de dades des de 1.7.x, si us plau consulta les <a target=\"help\" href=\"http://tikiwiki.org/UpgradeTo18\">instruccions per passar de la base dades de Tiki 1.7.x a 1.8.x",
"For information about tiki-secdb_*.sql files, please see <a target=\"help\" href=\"http://tikiwiki.org/AdminSecurity\">http://tikiwiki.org/AdminSecurity" => "Per informació sobre els arxius tiki-secdb_*.sql , pots consultar <a target=\"help\" href=\"http://tikiwiki.org/AdminSecurity\">http://tikiwiki.org/AdminSecurity",
"Please enter your admin password to continue" => "Si us plau, introdueix la teva contrasenya d'usuari administrador (admin) per continuar",
"Print operations executed successfully" => "Llistat d'operacions executades amb èxit",
"Print operations failed" => "Llistat d'operacions que han tingut algun problema",
"READ THE FOLLOWING NOTES BEFORE ENTERING TIKI USING THE LINKS BELOW!" => "LLEGEIX LES NOTES SEGÜENTS ABANS D'ENTRAR A TIKI AMB ELS ENLLAÇOS DE SOTA!",
"Make sure tiki gets more than 8 MB of memory for script execution. \nSee file php.ini, the relevant key is memory_limit. Use something like memory_limit = 16M and restart your \nwebserver. Too little memory will cause blank pages!" => "Assegura't que tiki disposa de més de 8 MB de memòria per a l'execució de seqüències (scripts). \nMira a l'arxiu php.ini, la clau rellevant és memory_limit. Empra quelcom de l'estil memory_limit = 16M i re-inicia el teu \nservidor web. Massa poca memòria provocarà planes en blanc!",
"If this is a first time installation, go to tiki-admin.php after login to start configuring your new Tiki installation" => "Si aquesta és una instal·lació inicial, ves a tiki-admin.php després de connectar-te i comença a configurar la teva nova instal·lació Tiki",
"If you did a Tiki upgrade, make sure to clean the caches (templates_c/) manually or by using the feature on admin / system" => "Si has fet una actualització de Tiki, assegura't de netejar les memòries cau (templates_c/) manualment o a través d'emprar la funcionalitat a Admin > Administrador de sistema",
"Now you may proceed by clicking one of these links" => "Ara ja pots continuar punxant en algun d'aquests enllaços",
"Click here to disable the install script and proceed into tiki" => "Punxa aquí per desactivar la seqüència (script) d'instal·lació i procedir a entrar a Tiki",
"Click here to proceed into tiki without disabling the script" => "Punxa aquí per procedir a entrar a Tiki sense deshabilitar la seqüència (script)",
"do not use your Back button in your browser!" => "no empris el botó Enrera del teu navegador!",
"rollback" => "restableix",
"Listing Gallery" => "Contingut de la galeria",
"Gallery Files" => "Galeries de fitxers",
"rollback to this version" => "restableix aquesta versió",
"Print Wiki Pages" => "Imprimir pàgines del Wiki",
"add page" => "afegeix pàgina",
"add structure" => "afegeix estructura",
"click to navigate" => "fes clic per navegar",
"Total threads" => "Quantitat de missatges",
"Average threads per topic" => "Mitjana de missatges per tema",
"You can include the file in an HTML/Tiki page using" => "Podeu incloure l'arxiu en una pàgina Tiki/html emprant",
"Now enter the file URL" => "Introdueix ara la URL de l'arxiu",
" or upload a local file from your disk" => "o puja l'arxiu des del teu disc",
"received" => "rebut/da",
"submitted" => "enviat/da",
"shared" => "compartit/da",
"accepted by task user and creator" => "acceptada per l'usuari de la tasca i creador",
"accepted user and creator" => "ususari i creador acceptat",
"not accepted by one user" => "no acceptada per un/a usuari/a",
"not accepted user" => "usuari no acceptat",
"waiting for me" => "esperant-me a mi",
"waiting for other user" => "esperant a un altre/a usuari/a",
"move into trash" => "mou a la paperera",
"waiting / not started" => "en espera / no iniciada",
"waiting" => "esperant",
"shared for group" => "compartida per al group",
"accepted by user" => "acceptada per l'usuari/a",
"no / rejected" => "no / rebutjada",
"accepted by creator" => "acceptada pel creador",
"priority" => "prioritat",
"select one" => "selecciona un/a",
"undo trash" => "desfés paperera",
"show:" => "mostra:",
"all shared tasks" => "totes les tasques compartides",
"previous chart" => "chart anterior",
"next chart" => "diagrama següent",
"avg" => "mtj",
"post new comment" => "publicar missatge nou",
"Post New Comment" => "Publicar missatge nou",
"HTML tags are not allowed inside comments" => "No s'admeten etiquetes html als comentaris",
"moderator actions" => "accions del moderador",
"move selected topics" => "moure temes seleccionats",
"unlock selected topics" => "desbloqueja tòpics seleccionats",
"lock selected topics" => "bloqueja temes escollits",
"merge" => "escapçar",
"merge selected topics" => "Escapçar els temes escollits",
"reported messages:" => "missatges reportats:",
"queued messages:" => "missatges a la cua:",
"account" => "compte",
"Projects" => "Projectes",
"Projects configuration" => "Configuració dels projectes",
"Site Identity features" => "Paràmetres de la Identitat del Lloc",
"Click here to delete this category" => "Fes clic aquí per esborrar aquesta categoria",
"Group doesnt exist" => "Aquest grup no existeix",
"User doesnt exist" => "Aquest usuari no existeix",
"Event without Name" => "Event sense nom",
"No channel indicated" => "No s'ha indicat cap canal",
"No nickname indicated" => "No s'ha indicat cap sobrenom",
"Please create a directory named \$map_path to hold your map files." => "Si us plau, creeu un directori anomenat \$map_path per incloure els vostres fitxers map.",
"Permision denied" => "Permís denegat",
"Selected category" => "Categoria seleccionada",
"Active group" => "Grup actiu",
"Create object" => "Crea l'objecte",
"sql queries" => "crides sql",
"Request failed for %s" => "La petició per %s ha fallat",
"Insert a Mediawiki/Wikipedia-type contents link box on a wiki page, using maketoc." => "Inserta un requadre amb enllaços de taula de continguts del tipus Mediawiki/Wikipedia en una pàgina Wiki, emprant maketoc.",
"Inserts a Mediawiki/Wikipedia-look thumbnail with caption that links to a full-size image." => "Inserta un contacte estil Mediawiki/Wikipedia amb un peu de figura que enllaça a la imatge sencera.",
"Insert a Tikipedia-look box on wiki page" => "Inserta una caixa estil Tikipedia en una pàgina Wiki",
"group not found" => "No s'ha trobat el grup",
"group already exist" => "El grup ja existeix",
"user not found" => "usuari no trobat",
"the main workspace group cant be removed" => "el grup principal de l'espai de treball no pot ser eliminat",
"Not a portfolio workspace" => "No és un espai de treball de tipus portfolio",
"Assignment not found" => "No s'ha trobat l'assignació de deures",
"Page not found\".\" \".\$page));\r\n\t}\r\n}else{\r\n\t\$smarty->assign('error_msg', tra(\"Param name not found" => "Plana no trobada\".\" \".\$page));\r\n\t}\r\n}else{\r\n\t\$smarty->assign('error_msg', tra(\"Param name not found",
"Owner not set" => "No s'ha especificat el propietari",
"Anonymous and Registered group can't be added" => "No es poden afegir els grups Anonymous i Registered",
"Page not found\".\" \".\$page));\n\t}\n}elseif (!\$exit_module){\n\t\$smarty->assign('error_msg', tra(\"Param name not found" => "Plana no trobada\".\" \".\$page));\n\t}\n}elseif (!\$exit_module){\n\t\$smarty->assign('error_msg', tra(\"Param name not found",
"Param name not found" => "No s'ha trobat nom de parametre",
"are you sure to remove the assigment" => "Segur que vols eliminar aquesta assignació de deures?",
"Cuaderno de Problemas de" => "Quadern de problemes de",
"Subject Administration" => "Administració d'assignatures",
"Workspace type" => "Tipus d'espai de treball",
"Hide workspace on the list of user assigned workspaces" => "Amaga espai de treball de la llista d'espais de treball assignats a un usuari",
"Personal workspace" => "És un espai de treball personal?",
"Save Zone" => "Guarda Zona",
"Title Style" => "Estil de Títol (si no saps què és, deixa-ho en blanc)",
"Data Style" => "Estil de dades (si no saps què és, deixa-ho en blanc)",
"Module params" => "Paràmetres del mòdul (si no saps què és, deixa-ho en blanc)",
"Remove zone" => "Elimina zona",
"Create zone" => "Crea zona",
"No zones defined, please create a first zone to start" => "No s'han definit zones, si us plau, crea primer una zonaper començar",
"No modules assigned to the zone, please assign a first module" => "No s'han assignat mòduls a la zona, si us plau, assigna un primer mòdul",
"Permission group" => "Grup de permisos",
"Premissions" => "Permisos",
"Delete from structure" => "Esborra de l'estructura",
"Workspace type roles" => "rols per a un tipus d'espai de treball",
"Workspace type resources" => "Recursos per a un Tipus d'espai de treball",
"Workspace Type Roles" => "Rols per a un Tipus d'espai de treball",
"Role name" => "Nom de Rol",
"Role description" => "Descripció de Rol",
"Permission Group" => "Grup de permisos",
"Contact email" => "Mail de contacte",
"Population" => "Població",
"Transaction" => "Transacció",
"Examine" => "Examina",
"Unregister" => "No registrat",
"as well as assign or edit many others." => "així com assignar o editar molts/es altres/as.",
"The menu module installed by default is named" => "El mòdul de menú instal·lat per defecte s'anomena",
"it is a \"custom module\" which includes menu ID " => "és un \"mòdul customitzat\" que inclou el menú per té per ID ",
"That menu is stored in database and it can be edited from " => "Aquell menú es guarda a la base de dades i pot ser editat des de ",
"Do not mix this with the original <em>application_menu</em> module" => "No barregeu això amb el mòdul original <em>application_menu</em>",
"created by" => "creat per",
"toolbox" => "caixa d'eines",
"slideshow backward" => "endavant passi de diapositives",
"by the " => "per el/la ",
"phpLayers Menus" => "Menús en capes de php (phpLayers)",
"Back links" => "Retroenllaços",
"You have to \ncreate a gallery first!" => "Primer cal \ncrear una galeria!",
"Amount of transactions" => "Quantitat de transaccions",
"Approval?" => "Aprovació?",
"Approved?" => "Aprovat/da?",
"Balance" => "Balanç",
"balance" => "balanç",
"Blogroll" => "Llista de blocs",
"Create a new Currency" => "Crea una nova moneda",
"Currencies Admin" => "Administrador de monedes",
"Currency Provider Unique Name" => "Nom únic del proveïdor de moneda",
"DNS check failed for %s" => "La comprovació de DNS ha fallat per %s",
"Domain for list of CC service providers" => "Domini per la llista de proveïdors de serveis CC",
"Edit currency" => "Edita moneda",
"Examine Currency" => "Examina la moneda",
"last transaction date" => "última data de transacció",
"Last transaction" => "Última transacció",
"List Currencies" => "Llista les monedes",
"Listed?" => "Llistat?",
"Listed publicly" => "Llistat públicament",
"Logs" => "Registres",
"Modify a Currency" => "Modifica una moneda",
"My Currencies" => "Les meves monedes",
"New Transaction with" => "Nova transacció amb",
"Number of transactions" => "Nombre de transaccions",
"out" => "fora",
"Page not found\".\" \".\$page));\n\t}\n}else{\n\t\$smarty->assign('error_msg', tra(\"Param name not found" => "Pàgina no trobada\".\" \".\$page));\n\t}\n}o{\n\t\$smarty->assign('error_msg', tra(\"Nom de paràmetre no trobat",
"Pending Registration" => "Registre pendent",
"Permission denied you cannot create assignments" => "Permís denegat, no pots crear assignacions",
"Permission denied you cannot edit assignments" => "Permís denegat, no pots editar assignacions",
"Permission denied you cannot remove assignments" => "Permís denegat, no pots eliminar assignacions",
"record" => "registre",
"Register Owner" => "Propietari del registre",
"Requires approval" => "Necessita aprovació",
"Reregister" => "Reregistre",
"revert" => "inverteix",
"Revert Transaction" => "Inverteix la transacció",
"Sorry, the currency \$currency is not available." => "Disculpa, la moneda \$currency no es troba disponible.",
"Sorry, you are not registered into currency \$currency." => "Disculpa, no t'has enregistrat encara per a la moneda \$currency. Enregistra't-hi primer'",
"That one can be heavily customized to match style used but it can be currently done only by editing mod-application_menu.tpl file \"manually\"" => "Aquesta pot ser molt adaptada per encaixar amb l'estil emprat però això només es pot fer a través d'editar manualment l'arxiu 'mod-application_menu.tpl''",
"{\$thelist[i].age|duration} ago" => "fa {\$thelist[i].age|duration}",
"total volume" => "volum total",
"transactions" => "transaccions",
"Your message has been queued for approval, the message will be posted after\r\na moderator approves it." => "El teu missatge està pendent d'aprovació, s'enviarà quan el moderador l'aprovi.",
"IMAP/POP3 BaseDSN" => "IMAP/POP3 BaseDSN",
"participants" => "participants",
"perso" => "perso",
"dsn" => "dsn",
"vertical" => "vertical",
"Tikiwiki CMS/Groupware" => "Tikiwiki CMS/Groupware",
"zoom" => "zoom",
"adm" => "adm",
"P" => "P",
"F" => "F",
"pre" => "pre",
"Another post with the same title and content already exists" => "Ja hi ha una altra publicació amb el mateix títol i contingut",
"Textarea options: quicktags,width,height,max,listmax - Use Quicktags is 1 or 0, widthis indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax isthe maximum number of characters that are displayed in list mode." => "Opcions d'Àrea de Text: marques_ràpides,amplada,alçada,max,llist_max - Utilització: marques_ràpides pot ser 1 (mostrar-les) o 0 (no mostrar-les), l'amplada s'indica en caracters, l'alçada s'indica en línies, max és el número màxim de caracters que poden ser guardats, llist_max és el número màxim de caracters que són mostrats en el mode de llista.",
"User Selector: use options for automatic field feeding : you can use 1 for author login or 2 for modificator login." => "Selector d'usuari: empra opcions per a alimentació automàtica del camp: pots emprar 1 per al nom d'usuari/a de l'autor/a o 2 per al nom d'usuari/a de la persona modificadora.",
"Category options: parentId" => "Opcions de categories options: parentId (Id del pare dels ítems de la categoria a incloure)",
"Item Link options: trackerId,fieldId,linkToItem links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing" => "Opcions d'enllaç de l'ítem: IdFormulari,IdCamp,enllaç_a_Item enllaça a l'ítem de l'IdFormulari en el qual l'IdCamp coincideix amb el contingut d'aquell camp. enllaç_a_Item pot ser 1 ó 0 per crear, o no, l'enllaç a l'ítem en el mode de visualització i llistat",
"~np~{~/np~ARTICLES(max=>3,topic=>topicName,type=>type,categId=>Category parent ID)}{ARTICLES} Insert articles into a wikipage" => "~np~{~/np~ARTICLES(max=>3,topic=>NomdelTopic,type=>tipus,categId=>ID de categoria pare/mare)}{ARTICLES} Inserta els articles a una pàgina Wiki",
"no such attachment on this page" => "no hi ha aquest adjunt en aquesta pàgina",
"num is optional and is the order number of the attachment in the list. If not provided, a list of all attachments is displayed.  Inline makes the comment be the text of the link." => "num és opcional i és el número d'ordre de l'adjunt a la llista. Si no s'especifica, es mostra una llista de tots els adjunts.  Enlinia fa que el comentari sigui el text de l'enllaç.",
"~np~{~/np~EVENTS(calendarid=>id1+id2,maxdays=>365,max=>-1,datetime=>0|1,desc=>0|1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=>id1+id2,maxdays=>365,max=>-1,datetime=>0|1,desc=>0|1)}{EVENTS} Inserta el resultat de l'alimentació rss en una pàgina Wiki",
"~np~{~/np~RSS(id=>feedId+feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId+feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Inserta el resultat d'una o vàries alimentacions rss en una pàgina Wiki",
"move %s in %s" => "mou %s a %s",
"Please notify the admin that the \"sender email\" option in the General configuration section has not been set.  An internal Tiki message has been sent to the admin to validate your registration request.  An email should arrive shortly after you have been validated, with information on how to login for the first time into this site" => "Si us plau, notifica a l'administrador que la opció del \"correu-e de l'enviador\" a la secció de configuració General no ha estat especificada.  S'ha enviat un missatge intern Tiki a l'administrador per validar la teva petició de registre.  T'hauria d'arribar un correu-e just després de que s'hagi validat la teva petició, amb informació sobre com connectar-te per primera vegada en aquest lloc",
"TikiWiki Assistant" => "Assitent de TikiWiki",
"Thank you for installing TikiWiki CMS/Groupware" => "Gràcies per instal·lar TikiWiki CMS/Groupware",
"Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"TikiWiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Llegeix la <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Documentació de TikiWiki\" target=\"_blank\">documentació de la configuració</a>",
"To learn more, visit: <a href=\"http://www.tikiwiki.org\" title=\"The TikiWiki Community\" target=\"_blank\">http://www.tikiwiki.org</a>" => "Per aprendre més, visita: <a href=\"http://www.tikiwiki.org\" title=\"La Comunitat TikiWiki\" target=\"_blank\">http://www.tikiwiki.org</a>",
"TikiWiki Documentation" => "Documentació de TikiWiki",
"For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"TikiWiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "Per ajuda, visita <a href=\"http://doc.tikiwiki.org\" title=\"Documentació de TikiWiki\" target=\"_blank\">http://doc.tikiwiki.org</a>",
"Confirm your action" => "Confirma la teva acció",
"Please, confirm your action" => "Si us plau, confirma la teva acció",
"Use categories to regroup various Tiki objects." => "Utilitza les categories per agrupar diversos objectes tiki.",
"Report PHP errors only for admin" => "Informe dels errors de PHP tan sols per l'administrador",
"Automatic (uses HTTPS variable)" => "Automàtic (utilitza una variable HTTPS)",
"Help system" => "Sistema d'Ajuda",
"Auth Type" => "Tipus d'autenticació",
"IMAP/POP3/LDAP Host" => "Servidor IMAP/POP3/LDAP",
"IMAP/POP3/LDAP Port" => "Port IMAP/POP3/LDAP",
"Configure InterTiki here" => "Configura l'InterTiki aquí",
"<b>Item</b>" => "<b>Ítem</b>",
"<b>Value</b>" => "<b>Valor</b>",
"Hint: If you remove your login module, use tiki-login_scr.php to be able to login!" => "Consell: si treus el teu mòdul de registre, utilitza tiki-login_scr.php per poder iniciar la sessió!",
"Caching time :" => "Temps de memòria cau :",
"Only enable caching if all syndicated content is public (visible to everyone) or private documents might leak out. Cache ignores existing permissions." => "Només permet carregar-ho a la memòria cau si tot el contingut sindicat és públic (visible per a tothom) o si els documents privats s'han filtrat. La memòria cau ignora els permisos existents.",
"This text can be used as a variable" => "Es pot emprar aquest text com a variable",
"Here you can (as an admin) place a piece of custom XHTML and/or Smarty code. Be careful and properly close all the tags before you choose to publish ! (Javascript, applets and object tags are stripped out.)" => "Aquí pots (com admin) posar un tros de codi adaptat XHTML i/o Smarty. Sigués curos i tanca adequadament totes les etiquetes abans que no escullis publicar-ho! (Les etiquetes de Javascript, applets i d'objectes són estripades.)",
"Please also see:" => "Si us plau, mira també:",
"While classic trackers are mature, mirror table trackers are an experimental feature. Many bugs have been reported when using plugins, etc.  <b>Do NOT use mirror trackers unless you know what you are doing</b> and are ready to participate to development and debugging. Mirror trackers could even eventually be discontinued from Tiki." => "Així com els formularis clàssics are madurs, els formularis amb taules mirall són una funcionalitat experimental. S'ha descrit molts errors en emprar connectors de formularis amb ells, etc. <b>NO empris taules mirall a no ser que sàpigues què estàs fent</b> i estiguis preparat a participar en el seu desenvolupament i depuració d'errors. Formularis amb taules mirall podrien ser descontinuats de Tiki.",
"Moved to:" => "Mogut/s a:",
"A new version of TikiWiki, <b>{\$tiki_release}</b>, is available.  You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>." => "Hi ha disponible una nova versió de Tikiwiki: <b>{\$tiki_release}</b>. Estàs funcionanat actualment amb la versió <b>{\$tiki_version}</b>. Si us plau, visita <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>.",
"Click and scroll up to the top of the page" => "Clica i puja la barra de desplaçament fins a dalt de la pàgina",
"subscription" => "subscripció",
"admin charts template" => "administra plantilla de sondejos (charts)",
"Managing content templates" => "Gestiona les plantilles de continguts",
"admin content templates template" => "administra plantilla de plantilles de contingut",
"use in events" => "empra en els esdeveniment",
"Manage FortuneCookie" => "Gestiona la FortuneCookie",
"admin forums template" => "administra la plantilla dels fòrums",
"online" => "en línia",
"admin Html Pages" => "administra pàgines Html",
"admin Html Pages template" => "administra plantilla de les pàgines Html",
"Use {literal}{/literal}ed id=name} or {literal}{/literal}ted id=name} to insert dynamic zones" => "Utilitza {literal}{/literal}ed id=name} o {literal}{/literal}ted id=name} per inserir zones dinàmiques",
"admin featured links template" => "administra plantilla d'enllaços destacats",
"Help with Mail-in accounts" => "Ajuda amb els comptes correu-dins",
"admin menus template" => "administra plantilla dels menus",
"admin modules template" => "administra plantilla de mòduls",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom <a href=\"tiki-admin.php?page=module\">Admin->Modules</a>\n" => "\n<b>Nota 1</b>: si permets als teus usuaris de configurar mòduls llavors els mòduls\nassignats no es veuran a la pantalla fins que els configuris des de\nElMeuTiki->mòduls.<br />\n<b>Nota 2</b>: Si assignes mòduls a grups, assegura't que hagis desactivat\nla opció 'mostra els mòduls sempre a tots els grups'\ndes de <a href=\"tiki-admin.php?page=module\">Admin->Mòduls</a>\n",
"Hint: For the vertical menu to work properly with all browsers, make sure to add <b>overflow=y</b> to the module parameters when you assign it." => "Consell: per tal que el menú vertical funcioni correctament amb tots els navegadors, assegura't d'afegir <b>overflow=y</b> als paràmetres de mòdul quan els assignis.",
"Admin calendar" => "Administra calendari",
"Newsletters Help" => "Ajuda per a butlletins",
"admin newsletters template" => "administra la plantilla dels butlletins",
"send newsletter" => "envia el butlletí",
"archives" => "arxius",
"admin notifications template" => "administra la plantilla de les notificacions",
"admin polls template" => "administra la plantilla de les votacions",
"configure polls" => "configura les votacions",
"admin RSSmodules template" => "administra la plantilla dels moduls RSS",
"To aggregate several RSS feeds, use {literal}{rss id=x+y+z}{/literal}. <b>\"show publish date\" must be checked.<b/>" => "Per agregar diverses alimentacions RSS, empra {literal}{rss id=x+y+z}{/literal}. Ha d'estar seleccionar <b>\"mostra la data de publicació\".<b/>",
"edit tpl" => "edita tpl",
"Manage Banned Words in Shoutbox" => "Gestiona les Paraules Prohibides en el Requadre d'Avisos",
"admin shoutbox words template" => "administra plantilla de paraules del quadre d'avisos",
"admin structures template" => "adminstra la plantilla de les estructures",
"Help with Surveys" => "Ajuda amb les Enquestes",
"admin topics template" => "administra la plantilla dels temes",
"Show tracker ID" => "Mostra ID del formulari",
"with leading zeroes?" => "amb zeros per davant?",
"hyphenated?" => "amb guions?",
"admin users template" => "administra la plantilla d'ususaris",
"Warning: Are you sure you want to rename the \"admin\" user? It's better to add a new user and to assign this new user to the \"Admins\" group" => "Avís: estàs segur que vols canviar el nom de l'usuari \"admin\"? És millor afegir un nou usuari i assignar-lo al grup \"Admins\"",
"Batch upload (CSV file<a {popup text='login,password,email,groups<br />user1,password1,email1,&quot;group1,group2&quot;<br />user2,password2,email2'}><img src=\"img/icons/help.gif\" border=\"0\" height=\"16\" width=\"16\" alt='{tr}help" => "Càrrega de lots (CSV file<a {popup text='login,password,email,groups<br />usuari1,contrasenya1,correu-e1,&quot;grup1,grup2&quot;<br />usuari2,contrasenya2,correu-e2'}><img src=\"img/icons/help.gif\" border=\"0\" height=\"16\" width=\"16\" alt='{tr}help",
"Help for Backups" => "Ajuda per fer còpies de seguretat",
"remove file extension from image name" => "elimina l'extensió de l'arxiu del nom de la imatge",
"convert sub directories to sub galleries" => "converteix els subdirectoris en subgaleries",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named screenshots will be created" => "ex. per \"misc/screenshots/digicam0001.jpg\" es crearà una galeria anomenada screenshots",
"use sub directory names as description" => "utilitza el nom del subdirectori com a descripció",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description misc/screenshots will be created" => "ex. per \"misc/screenshots/digicam0001.jpg\" es posarà com a descripció misc/screenshots",
"Tikiwiki developers" => "desenvolupadors de Tikiwiki",
"admin the category system" => "administra el sistema de categories",
"admin category" => "administra la categoria",
"list galleries" => "llista les galeries",
"monitor this gallery" => "Vigila aquesta galeria",
"stop monitoring this gallery" => "Deixa de vigilar aquesta galeria",
"hit" => "cop",
"slideshow forward" => "endarrera passi de diapositives",
"add item" => "afegeix ítem",
"change focus" => "Canvia focus",
"quarter" => "trimestre",
"semester" => "semestre",
"calendar view" => "vista de calendari",
"list view" => "vista de llista",
"Subscription List" => "Llista de subscripció",
"Format: mm/dd/yyyy hh:mm<br />..." => "Format: mm/dd/aaaa hh:mm<br />...",
"See strtotime php function" => "Consulta la funció php strtotime",
"Format: mm/dd/yyy hh:mm<br />..." => "Format: mm/dd/aaa hh:mm<br />...",
"save_to" => "guarda a",
"admin directory categories tpl" => "administra categories de directori tpl",
"Your time" => "El teu temps",
"Editing and Creating Blogs" => "Edicó i creació de blocs",
"For more information, please see <a href=\"{\$helpurl}Wiki+Syntax\">Wiki Syntax</a>" => "Per obtenir més informació, consulteu la <a href=\"{\$helpurl}Wiki+Syntax\">Sintaxi Wiki</a>",
"edit quiz questions" => "edita les preguntes del qüestionari",
"edit quiz questions tpl" => "edita la plantilla de les preguntes del qüestionari",
"save only in the theme:" => "desa només al tema:",
"Edit Translation:" => "Edita la Traducció:",
"edit translations" => "edita les traduccions",
"edit translations template" => "edita la plantilla de traduccions",
"Select the article for which the current article is the translation." => "Selecciona l'article del què l'article actual és la traducció.",
"<b>File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>.</b>" => "<b>L'arxiu ha de ser un arxiu SQL i existir en <i>\$tikiroot/temp</i> o en <i>\$tikiroot/img/wiki_up</i>.</b>",
"rebuild cache" => "reconstrueix la memòria cau",
"You need to set a <a href=\"tiki-admin.php?page=gmap\">Google Maps API key</a>" => "Has de configurar una <a href=\"tiki-admin.php?page=gmap\">clau de Google Maps API</a>",
"Welcome to the installation &amp; upgrade script!" => "Benvinguts/des al procés d'instal·lació &amp; actualitació!",
"Descriptions of the \navailable profiles" => "Descripcions dels \nperfils disponibles",
"For database update from 1.7.x, please visit <a target=\"help\" href=\"http://doc.tikiwiki.org/Upgrade+1.7+to+1.8\">Tiki database 1.7.x to 1.8x instructions" => "Per actualitzar bases de dades des de 1.7.x, si us plau, consulta <a target=\"help\" href=\"http://doc.tikiwiki.org/Upgrade+1.7+to+1.8\">les instruccions per bases de dades Tiki de la 1.7.x a la 1.8.x",
"For information about tiki-secdb_*.sql files, please see <a target=\"help\" \nhref=\"http://doc.tikiwiki.org/Security+Admin\">http://doc.tikiwiki.org/Security+Admin" => "Per informació sobre els arxius tiki-secdb_*.sql, mira si us plau <a target=\"help\" \nhref=\"http://doc.tikiwiki.org/Security+Admin\">http://doc.tikiwiki.org/Security+Admin",
"sql queries have successfully been executed." => "consultes sql s'han executat satisfactòriament.",
"Help for managing cache" => "Ajuda per gestionar la memòria cau",
"How to Use FAQs" => "Com emprar les PUF's",
"Blog Help" => "Ajuda de les Bitàcoles",
"list quizzes tpl" => "plantilla de llista de qüestionaris",
"edit quiz stats tpl" => "edita la plantilla de les estadístiques del qüestionari",
"actions" => "accions",
"take survey" => "omple l'enquesta",
"Trackers Help" => "Ajuda dels Formularis",
"list trackers tpl" => "plantilla de la llista de formularis",
"To display the objects you participate to:" => "Visualització dels objectes on has participat:",
"entire site" => "Lloc sencer",
"first" => "primer",
"clean" => "neteja",
"You can also <a class=\"rbox-link\" href=\"tiki-admin.php?page=theme\">change the default theme</a>." => "També pots <a class=\"rbox-link\" href=\"tiki-admin.php?page=theme\">canviar el tema per defecte</a>.",
"red" => "roig",
"use start date and time" => "utilitza la data i l'hora d'inici",
"use end date and time" => "utilitza data i hora finals",
"permanency" => "permanència",
"How to Use FAQs " => "Com emprar PUF's ",
"monitor this forum topic and thread" => "subscriu-te a aquest tòpic del fòrum i al fil de discussió sencer (les seves respostes)",
"stop monitoring this forum topic and thread" => "deixa d'estar subscrit/a a aquest tòpic del fòrum i al fil de discussió sencer (les seves respostes)",
"stop monitor" => "deixa d'estar subscrit/a",
"{\$tracker_info.name} - Tracker item" => "{\$tracker_info.name} - Element del formulari",
"{\$tracker_info.name} - Item" => "{\$tracker_info.name} - Element",
"Help on Administration Home" => "Ajuda sobre l'Inici d'Administració",
"You do not have permission to admin the calendars." => "No tens permís per administrar els calendaris.",
"Created account %s <%s>." => "Compte %s <%s> creada.",
"New %s created with %s %s (%s)." => "Nou/va %s creat/da amb %s %s (%s).",
"Site No validated yet" => "Lloc encara no validat",
"No permission to view the page" => "No tens permís per veure aquesta pàgina",
"This feature is disabled: feature_forums" => "Aquesta funcionalitat està desactivada: feature_forums",
"Please create a directory to hold your map files:" => "Si us plau, crea un directori per contenir els teus arxius de mapes:",
"An error occurred." => "Ha ocorregut un error.",
"You do not have permission to edit messages" => "No teniu permís per editar missatges",
"Permission denied you cannot remove trackbacks" => "Permís denegat, no pots eliminar els retroenllaços",
"Select tags in the list or put them separated by spaces." => "Selecciona etiquetes de la llista o afegeix-les separades per espais.",
"Remove Tags" => "Elimina etiquetes",
"The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, or ask your\nhosting provider.  Normally Tiki tables won't conflict with other product names" => "La base de dades ha d'existir prèviament. Pots crear la base de dades emprant mysqladmin, PHPMyAdmin, o demana al teu \nproveïdor d'internet.  Normalment les taules de Tiki no entraran en conflicte amb els noms d'altres productes",
"Com" => "Com",
"Vers" => "Vers",
"Browse category" => "Navega per la categoria",
"1 File attached" => "1 Arxiu adjunt",
"Use in CMS" => "Fes servir en el cms",
"Use in Wiki" => "Fes servir en el wiki",
"Use in newsletters" => "Empra en fulls de notícies",
"Use in HTML pages" => "Fes servir en pàgines HTML",
"Refresh rate (if dynamic) [secs]" => "Temps de refresc (si és dinàmic) [seg]",
"Create Zone" => "Crear zona",
"use square brackets for an external link: [URL] or [URL|link_description] or [URL|description|nocache]  (that last form prevents the local Wiki from caching the page; please use that form for large pages!)." => "empra corxets per a un enllaç extern: [URL] o [URL|descripció de l'enllaç] o [URL|descripció|nocache]  (aquest darrer evita que el Wiki local guardi una còpia temporal de la pàgina en memòria cau page; empri-ho, si us plau, per planes grans!).",
"Last ver" => "Darrera ver",
"A new major release branch is available." => "Hi ha disponible una nova branca major.",
"A new major release branch is also available." => "Hi ha també disponible una nova branca major.",
"Invalid old password" => "Contrasenya antiga invàlida",
"Your database has been configured and Tikiwiki is ready to run! {if isset(\$smarty.post.scratch)}If this is your first install, your admin password is <strong>admin</strong>.{/if} You can now log in into Tikiwiki as user <strong>admin</strong> and start configuring the application." => "La teva base de dades ha estat configurada i Tikiwiki està llest per funcionar! {if isset(\$smarty.post.scratch)}Si és la teva primera instal·lació, la teva contrasenya d'usuari admin (administrador) és <strong>admin</strong>.{/if} Ara pots connectar-te a Tikiwiki com a usuari <strong>admin</strong> i començar a configurar l'aplicació.",
"You have completed the TikiWiki {if isset(.post.scratch)}installation{else}upgrade{/if}. Use one of these links to continue" => "Has completat la {if isset(.post.scratch)}instal·lació{else}actualització{/if} de TikiWiki. Empra una d'aquests enllaços per continuar",
"You have completed the TikiWiki {if isset(\$smarty.post.scratch)}installation{else}upgrade{/if}. Use one of these links to continue" => "Has completat {if isset(\$smarty.post.scratch)}la instal·lació{else}l'actualització{/if} de TikiWiki. Empra algun dels següents enllaços per continuar",
"Republic_of_Montenegro" => "Montenegro",
"Republic_of_Serbia" => "Sèrbia",
"Include all post in a blog" => "Inclou totes les publicacions en una bitàcola",
"attach" => "adjunció",
"monitor this blog" => "subscriu-te a aquesta bitàcola",
"browse category" => "navega per la categoria",
"Edit this file gallery:" => "edita aquest galeria d'arxius:",
"Other users can upload files to this gallery" => "Altres usuaris poden pujar arxius a aquesta galeria",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\n{\$mail_machine}/tiki-remind_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nDone! You should be logged in." => "Si us plau, punxa en l'enllaç següent per confirmar que desitges canviar la teva contrasenya i ves a la pantalla on hauràs d'introduir una nova contrasenya \"permanent\". Si us plau, escull una contrasenya que només tu coneguis, i no la comparteixis amb ningú més.\n{\$mail_machine}/tiki-remind_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nFet! Hauries d'estar connectat ja.",
"usernames separated with ," => "noms d'usuaris separats per ,",
"Last Page Changes" => "Darrers canvis a Pàgines",
"Site Language: " => "Idioma del Lloc: ",
"Site Language :" => "Idioma del Lloc :",
"1 file attached" => "1 arxiu adjunt",
"IP not displayed in history" => "IP no mostrada en l'historial",
"Edit or add poll options" => "Editar o afegir opcions a la votació",
"Create/edit Polls" => "Crea o edita votacions",
"Rss channels" => "Canals Rss",
"show pubdate" => "mostrar data de publicació",
"Edit tracker fields" => "Edita els camps del formulari",
"visible by admin only" => "visible només per admins",
"The group will have all the permissions of the included groups" => "El grup tindrà tots els permisos dels grups inclosos",
"To use a relative link, use ex." => "Per emprar un enllaç relatiu, empra per ex.",
"watch only this category" => "vigila només aquesta categoria",
"watch this category and their descendants" => "vigila aquesta categoria i les seves descendents",
"stop watching only this category" => "deixa de vigilar només aquesta categoria",
"stop watching this category and their descendants" => "deixa de vigilar aquesta categoria i les seves descendents",
"Add or edit a site" => "Afegiu-hi o editeu un lloc web",
"Delete selected" => "Elimina seleccionats",
"browse image" => "Explorar imatge",
"translate" => "tradueix",
"Create or edit content" => "Crea o edita contingut",
"Edit FAQ questions" => "Edita preguntes PUF",
"Closing the window will reload your main browser" => "En tancar la finestra se't recarregarà la finestra principal del teu navegador",
"Create or edit content block" => "Crear o edita contingut d'un bloc",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods</a>." => "Per aprendre més sobre <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">Mods</a>.",
"Apache has the right to write in your file tree, which enables the installation, removal or \nupgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \n\"./setup.sh\" for example)." => "Apache te el permís per escriure en el teu arbre d'arxiu, el que habilita la instal·lació, esborrat o \nactualització de paquets. Quan hagis acabat amb aquestes operacions, pensa en modificar els permisos de nou per tornar a un estat segur (a través d'emprar \n\"./setup.sh\" per exemple).",
"To install, remove or upgrade packages you need to give the apache user the right\nto write files in your web tree (you can use \"./setup.sh open\" to set it up). After installation you need to remove that\npermission (using \"./setup.sh\")." => "Per instal·lar, esborrar o actualitzar paquets necessites donar-li a l'usuari apache el permís \nper escriure arxius a l'arbre web d'arxius (pots emprar \"./setup.sh open\" per fer-ho). Després de la instal·lació, cal que eliminis aquests \npermisos (emprant \"./setup.sh\").",
"Add or edit a news server" => "Afegeix o edita un nou servidor",
"Add or edit folder" => "Afegeix o edita carpeta",
"Add or edit a URL" => "Afegeix o edita URL",
"A new (and temporary) password and your IP address has been sent " => "S'ha enviat una nova (i temporal) contrasenya i la teva adreça IP d'internet en un correu-e ",
"Textarea options: quicktags,width,height,max,listmax - Use Quicktags is 1 or 0, width is indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax is the maximum number of characters that are displayed in list mode." => "Opcions d'Àrea de Text: marques_ràpides,amplada,alçada,max,llist_max - Utilització: marques_ràpides pot ser 1 (mostrar-les) o 0 (no mostrar-les), l'amplada s'indica en caràcters, l'alçada s'indica en línies, max és el número màxim de caracters que poden ser guardats, llist_max és el número màxim de caracters que són mostrats en el mode de llista.",
"A user can assign himself in groups" => "Un usuari es pot assignar all mateix a grups",
"Major" => "Major",
"Site-wide" => "Arreu del lloc",
"Technical" => "Tècniques",
"UI enhancement" => "Millores d'IU",
"Major Features" => "Funcionalitats Majors",
"Minor Features" => "Funcionalitats Menors",
"Site-wide Features" => "Funcionalitats emprables arreu del Lloc",
"Save the page, but do not send notifications." => "Desa la pàgina, però no enviïs notificacions.",
"Tracker items for" => "Items de formulari per",
"error" => "error",
"Country Selector options: 1|2 where 1 show only country name and 2 show only country flag. By default show both country name and flag" => "Opcions del selector de país: 1|2 on 1 mostra tan sols el nom del país i 2 mostra només la bandera. Per defecte es mostra el nom i la bandera del país",
"Zoom out x4" => "Disminuir zoom x4",
"Zoom out x3" => "Disminuir zoom x3",
"Zoom in x3" => "Augmentar zoom x3",
"Zoom in x4" => "Augmentar zoom x4",
"Language :" => "Idioma :",
"This page is up to date with the reference language:" => "Aquesta pàgina està actualitzada respecte l'idioma de referència:",
"This page and all its translations are up to date." => "Aquesta pàgina i les seves traduccions estan actualitzades.",
"cache" => "memòria cau",
"add" => "afegeix",
"del" => "esb",
"Use Quote plugin rather than &ldquo;>&rdquo; for quoting" => "Empra el plugin de Cita (QUOTE) més que no pas &ldquo;>&rdquo; per citar",
"with checked" => "amb comprovats/des o seleccionats/des",
"To use menus in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>, <a class=\"rbox-link\" href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu. To use <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes:" => "Per emprar menus en un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a>, <a class=\"rbox-link\" href=\"tiki-admin.php?page=siteid\">Identitat del Lloc</a> o plantilla, empra {literal}{menu id=x}{/literal}, on x és l'ID del menú. Per emprar <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a> (menús per capes), pots emprar alguna de les tres sintaxis següents:",
"Create/edit newsletters" => "Crea/edita butlletins",
"Use Admin Email" => "Fes servir el correu-e de l'admin",
"Admin tracker" => "Administra formulari",
"Edit this tracker" => "Edita aquest formulari",
"View this tracker items" => "Visualitza els punts d'aquest formulari",
"Import/export trackers fields" => "Importa/exporta els camps dels formularis",
"Edit this tracker fields" => "Edita els camps d'aquest formulari",
"Edit tracker" => "Edita el formulari",
"Create trackers" => "Crea formularis",
"Import/export" => "Importa/exporta",
"Duplicate tracker" => "Duplica el formulari",
"Create/edit trackers" => "Crea/edita formularis",
"No individual permissions global permissions apply" => "No hi ha permisos individuals, s'aplicaràn els permisos globals",
"Edit item" => "Edita punt",
"click here to send us an email" => "fes clic aquí per enviar-nos un correu electrònic",
"sites" => "llocs",
"cool sites" => "llocs fantàstics",
"this quiz stats" => "estadistiques d'aquest test",
"You can\n    \t\tnow log in into Tikiwiki as user <strong>admin</strong> and start configuring\n    \t\tthe application." => "Pots\n    \t\tara connectar-te a  Tikiwiki com a usuari <strong>admin</strong> i començar a configurar\n    \t\tl'aplicació.",
"subscribe" => "subscriue-me",
"Sent edition" => "Edició enviada",
"Subscribe to newsletter" => "Subscriure a butlletí",
"Hold down CTRL to select multiple" => "Manté premuda la tecla CTRL per fer seleccions múltiples",
"lowercase only" => "només minúscules",
"Save as draft" => "Desa-ho com a esborrany",
"You can include the file in an Wiki page using" => "Pots incloure l'arxiu en una pàgina Wiki emprant",
"You can include the file in an HTML page using" => "Pots incloure l'arxiu en una pàgina HTML emprant",
"Edit fields" => "Edita els camps",
"View item" => "Visualitza punt",
"Add a comment" => "Afegeix un comentari",
"I have refused your friendship request!" => "He rebutjat la teva petició d'inclusió a la meva xarxa d'amistat!",
"clip" => "clip",
"cc" => "cc",
"Isle_of_Man" => "Illa_de_Man",
"Phillippines" => "Filipines",
"sender" => "remitent",
"subject" => "tema",
"date" => "data",
"flagged" => "senyalat",
"mark" => "marca",
"find replied message" => "busca missatges contestats",
"replied" => "respost",
"Click" => "Fes clic",
"posted by" => "enviat per",
"email this post" => "envia per correu electrònic aquest enviament",
"Tag name" => "Nom de l'Etiqueta",
"Unique page name prefix to indicate staging copy" => "Prefix únic per al nom de les pàgines per indicar que és una còpia per revisar",
"Category for staging pages" => "Categoria per les pàgines per revisar",
"Category for approved pages" => "Categoria per les pàgines aprovades",
"Category for pages out of sync" => "Categoria per les pàgines desincronitzades",
"Replace freetags with that of staging pages on approval" => "Reemplaça les etiquetes lliures amb les de les pàgines per revisar en ser aprovades",
"If not in the group, edit is always redirected to the staging page edit" => "Si no és al grup, l'edició és sempre redireccionada a l'edició de la pàgina per revisar",
"Enable wiki 3D browser" => "Activa el navegador Wiki 3D",
"Load page on navigation" => "Carrega la pàgina en navegar per ella",
"Existing page node color" => "Color de node d'una pàgina existent",
"Missing page node color" => "Falta color del node de pàgina",
"Anonymous editors must input anti-bot code" => "Editors Anonymous han d'escriure un codi anti-robot",
"Edit idle timeout" => "edita temps de desconnexió",
"Use page description" => "Empra descripció de la pàgina",
"Show page title" => "Mostra el títol de la pàgina",
"Show page ID" => "Mostra ID de pàgina",
"Cache wiki pages (global)" => "Posar les planes wiki en memòria cau (global)",
"Users can lock pages (if perm)" => "Els usuaris poden bloquejar planes (si tenen perm)",
"Use WikiWords" => "Empra ParaulesWiki",
"Use Wiki paragraph formatting" => "Empra formatatge Wiki de paràgrafs",
"But still create line breaks within paragraphs" => "Però encara crea salts de línia entre paràgrafs",
"Create webhelp from structure" => "Crea ajuda web a partir de l'estructura",
"Use external link icons" => "Empra icones per als enllaços externs",
"User's Page" => "Plana de l'usuari",
"UserPage prefix" => "Prefix per a la PlanaUsuari",
"Import Page" => "Importa la Plana",
"List authors" => "Llista autors",
"When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page" => "Quan es vol mostrar una pàgina, si no existeix i té una pàgina similar, fes redireccionament automàtic a aquesta pàgina similar",
"Show/hide heading icon displayed before the heading" => "Mostra abans de l'encapçalament la icona per Mostrar/Amagar el contingut sota l'encapçalament",
"Print Page" => "Imprimeix pàgina",
"Maximum number of versions for history" => "Quantitat màxima de versions en l'historial",
"Never delete versions younger than days" => "Mai eliminar versions prèvies a dies",
"Diff style" => "Estil de diferències",
"Watch minor" => "Vigila canvis menors",
"This will work well (or not!) depending on your theme. To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "Això funcionarà bé (o no!) depenent del teu Tema (d'estil, estètica, de la web). Per aprendre més sobre <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">Temes</a>",
"Old vers" => "Versions antigues",
"Add or edit event" => "Afegeix o edita un esdeveniment",
"merge selected notes into" => "fusiona les notes seleccionades en",
"Faq Stats" => "Estadistiques de PUFs",
"Report to the Webmaster" => "Avisa al mestre del Web",
"Edit User Files" => "Edita els arxius de l'usuari",
"Your message has been queued for approval, the message will be posted after\na moderator approves it." => "El teu missatge ha estat posat en cua pendent d'aprovació, el missatge serà publicat després\nque un moderador l'aprovi.",
"Webmail Doc" => "Document Webmail",
"Webmail Doc template" => "Plantilla de document de correu web",
"settings" => "especificacions",
"mailbox" => "bustia de correu",
"compose" => "composa",
"contacts" => "contactes",
"back to mailbox" => "torna a bustia de correu",
"full headers" => "capçaleres senceres",
"normal headers" => "capçaleres normals",
"reply all" => "respon a tots",
"forward" => "reenvia",
"select from address book" => "selecciona del llibre d'adreces",
"item found" => "registre trobat",
"items found" => "registres trobats",
"Transparent" => "Transparent",
"can't open mypage" => "can't open mypage",
"Tools" => "Eines",
"Image (url)" => "Imatge (url)",
"Are you sure you want to delete this entry ?" => "Segur que vols esborrar aquesta entrada ?",
"Permission assigned to the group" => "Permís assignat al grup",
"Permission assigned to the group through a category" => "Permís assignat al grup a través de la categoria",
"Current permissions" => "PErmisos actuals",
"Read &amp; write" => "Lectura &amp; Escriptura",
"No specific permission" => "No hi ha cap permís específic",
"Apply permissions" => "Aplica permisos",
"Additional permissions" => "Permisos addicionals",
"Add Groups" => "Afegeix Grups",
"Add Users" => "Afegeix Usuaris",
"Add to List" => "Afegeix a la Llista",
"Share Page" => "Comparteix pàgina",
"ajax and mootools features mandatory for that feature" => "les funcionalitats ajax i mootools són necessàries per a aquesta funcionalitat",
"name already exists" => "ja existeix el nom",
"Then rerun the installer using tiki_1.9to1.10." => "Llavors torna a executar l'instal·lador emprant tiki_1.9to1.10.",
"A wildcard pattern of originating pages to be ignored.<br />" => "Un patró de comodí per pàgines originàries a ser ignorades.<br />",
"The character, by which ignored patterns are separated.<br />" => "El caràcter, pel qual patrons ignorats són separats.<br />",
"Whether to include external wikis in the list.<br />" => "Si incloure wikis externs a la llista.<br />",
"Collect either originating or wanted pages in a cell and display them in the second column.<br />" => "Recopila tant les pàgines originals com les buscades en una cel·la i les mostra a la segona columna.<br />",
"Multiple collected items are separated in distinct table rows, or by comma or line break in one cell.<br />" => "Diversos elements recopilats estan separats en diferents files de la taula, o bé per una coma o per un salt de línia en una mateixa cel·la.<br />",
"Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex.<br />" => "Filtra la llista de pàgines que vols segons page_regex o un filtre personalitzat. El valor per defecte és site's __current__ page_regex.<br />",
"A custom filter for wanted pages to be listed (only used when level=>custom).<br />" => "Un filtre personalitzat de les pàgines que es volen llistar (només s'utilitza quan el nivell=>personalitzat).<br />",
"Use context menus for actions (icons) (only in file galleries yet):" => "Empra menús contextuals per accions (icones) (només a galeries d'arxius, per ara):",
"Use context menus for actions (text) (only in file galleries yet):" => "Empra menús contextuals per accions (text) (només a galeries d'arxius, per ara):",
"Installation Script" => "Seqüència d'Instal·lació",
"This install script may be potentially harmful. We recommend that you disable the script before entering Tiki. To restore the script for reuse, follow the instructions in tiki-install.php." => "Aquest arxiu de seqüència d'instal·lació pot ser perillós potencialment. Et recomanem que el dehabilitis abans d'entrar a Tiki. Per restaurar-lo per emprar-lo de nou, segueix les instruccions que trobaràs a l'arxiu tiki-install.php.",
"You have completed the TikiWiki installation" => "Has completat la instal·lació de TikiWiki",
"You have completed the TikiWiki upgrade" => "Has completat l'actualtizació de TikiWiki",
"Use one of these links to continue" => "Empra un d'aquests enllaços per continuar",
"Disable the installation script and enter TikiWiki" => "Deshabilita la seqüència d'instal·lació i entra a Tikiwiki",
"Enter TikiWiki <em>without</em> disabling the installation script" => "Entra a TikiWiki <em>sense</em> deshabilitar la seqüència d'instal·lació",
"Paramaters" => "Paràmetres",
"To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> module</a>." => "Per utilitzar aquests enllaços cal assignar el <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> enllaços_destacats.",
"bad type name" => "el nom del tipus és incorrecte",
"Can edit categorized items" => "Pot editar ítems classificats",
"component class not found" => "no s'ha trobat la classe de l'element",
"component name is invalid" => "el nom de l'element no és vàlid",
"Name is empty" => "El nom és buit",
"Parameter not found :" => "No s'ha trobat el paràmetre:",
"This is the default text<br />---(version 3)-----------------------------<br />This is version 3 info<br />---(version 2)-----------------------------<br />This is version 2 info<br />---(version 1)-----------------------------<br />This is version 1 info" => "Aquest és el text per defecte<br />---(versió 3)-----------------------------<br />Això és informació de la versió 3<br />---(versió 2)-----------------------------<br />Això és informació de la versió 2<br />---(versió 1)-----------------------------<br />Això és informació de la versió 1",
"type class not found" => "no s'ha trobat la classe del tipus",
"window not found" => "no s'ha trobat la finestra",
"You are not the owner of this page" => "No ets el propietari d'aquesta pàgina",
"You cannot have more than one windows of this type." => "No pots tenir més d'una finestra d'aquest tipus.",
"You do not have permission to view this part of content" => "No tens permisos per veure aquesta part del contingut",
"hist" => "hist",
"Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opcions de Text: 1,mida,prefix,sufix,max amb la mida en caracters, prefix serà mostrat abans del camp, sufix serà mostrat just després, max és el número màxim de caracters que poden ser guardats, i si es posa un 1 inicial es fa que el següent camp es mostri en la mateixa fila del formulari. Si s'indica només 1, vol dir també que el següent camp serà mostrat a la mateixa fila.",
"Checkbox options: put 1 if you need that next field is on the same row." => "Opcions de requadres de verificació: posa un 1 si necessites que el següent camp sigui a la mateixa línia.",
"Numeric options: 1,size,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opcions numèriques: 1,mida,prefix,sufix amb la mida en caracters, el prefix serà mostrat abans del camp, el sufix serà mostrat just després, i si és posa un número 1 inicial es fa que el següent camp sigui en la mateixa línia. Si s'indica només 1, vol dir també que el següent camp serà mostrat a la mateixa fila.",
"Dropdown options: list of items separated with commas." => "Llista d'opcions: llista d'ítems separats per comes.",
"Default value is specified by having the value indicated twice consecutively" => "El valor per defecte s'indica posant el valor dos cops consecutius",
"Radio buttons options: list of items separated with commas." => "Opcions de botons Radio: llista d'items separats per comes.",
"User Selector options: automatic field feeding,email - feeding=1 for author login or feeding=2 for modificator login - email=1 to send an email to the user if the tracker is modified" => "Opcions del selector d'usuari: alimenatació automàtica del camp,correu-e - alimenatació=1 per al nom de l'usuari creador o alimentació=2 per al nom del modificador - correu-e=1 per enviar un correu-e a l'usuari si el formulari es modificat",
"Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered." => "Selector de grup: empra les opcions per a alimentació automàtica dels camps: pots emprar 1 per al grup de d'on va venir la creació creació i 2 per al grup d'on va venir la modificació. El grup per defecte ha d'estar especificat, o el primer grup que ve és l'agafat per a un usuari, o el grup per defecte és Registered.",
"IP selector" => "Selector d'adreça IP",
"IP Selector: use options for automatic field feeding : you can use 1 for author IP or 2 for modificator IP." => "Selector d'adreça IP: empra les següents opcions per a l'alimentació automàtica del camp: pots emprar 1 per a la IP de l'autor, i per a l'adreça del modificador.",
"Date Time options: date_time,year0,year1 where date_time=d|dt(default), d displays only date, year0 is the first year, year1 the last" => "Opcions de data i hora: data_hora,any0,any1 on data_hora=d|dt(per defecte), d mostra només la data, any0 és el primer any, any1 és el darrer",
"Jscalendar options: date_time where date_time=d|dt(default), d displays only date" => "Opcions del Jscalendar: data_hora on data_hora=d|dt(per defecte), d mostra només la data",
"Image options: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale indicated in pixels." => "Opcions d'imatges: MidaLlista_eixX,MidaLlista_eixY,MidaDetalls_eixX,MidaDetalls_eixY,EscalaLimitPujada són indicades en pixels.",
"Action options: Label,post,tiki-index.php,page:fieldname,highlight=test" => "Opcions d'accións: Etiqueta,post,tiki-index.php,page:nomdelcamp,highlight=test",
"Static text options: Wikisyntax,listmax - Use Wikisyntax is 1 or 0, listmax is the maximum number of characters that are displayed in list mode." => "Opcions de text estàtic: SintaxiWiki,maxlist - Empra SintaxiWiki pot ser 1 (si) )o 0 (no), maxlist és el nombre màxim de caràcters que es mostraran en el mode de llista.",
"Category options: parentId,d|m|radio|checkbox(default),1|0(default) to have a select all button, d for dropdown, m for multiple drop down" => "Opcions de categoria: IdMare,d|m|radio|checkbox(per defecte),1|0(per defecte) per tenir un botó de selecciona-ho tot, IdMare per indicar l'identificador numèric de la categoria mare que conté les categories filles que es volen mostrar com a seleccionables, d per desplegable, m per multiples desplegables",
"Item Link options: trackerId,fieldId,linkToItem,displayedfieldslist links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing.  Display displayedfieldslist(separate with |) instead of the target item" => "Opcions d'enllaç de l'ítem: IdFormulari,IdCamp,enllaç_a_Item,llista_de_camps_mostrats enllaça a l'ítem de l'IdFormulari en el qual l'IdCamp coincideix amb el contingut d'aquell camp. enllaç_a_Item pot ser 1 ó 0 per crear, o no, l'enllaç a l'ítem en el mode de visualització i llistat.  Mostra llista_de_camps_mostrats(separa amb |) enlloc de l'ítem diana",
"Items list options: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems displays the list of displayFieldIdThere from item in tracker trackerId where fieldIdThere matches fieldIdHere. linkToItems 1|0 to create a link to items in view mode and listing" => "Opcions de la llista d'Ítems: IdFormulari,IdCampAllà, IdCampAquí, IdCampMostratAllà, enllaç_a_Camps mostra la llista de IdCampMostratAllà dels ítems en el formulari IdFormulari on l'IdCampAllà coincideix amb l'IdCampAquí. enllaç_a_Camps 1 ó 0 per crear (o no) un enllaç als ítems en el mode de visualització i llistats",
"dynamic items list options: trackerId, filterFieldIdThere, filterFieldIdHere, listFieldIdThere, statusThere insert the list of listFieldIdThere from item in tracker trackerId where filterFieldIdThere matches filterFieldIdHere where status is statusThere." => "Opcions de la llista d'ítems dinàmica: IdFormulari, IdDeCampDeFiltratAllà, IdDeCampDeFiltratAquí, IdDelCampDeLlistaAllà, estatusAllà inserta la llista de IdDelCampDeLlistaAllà de l'ítem en el formulari IdFormulari on IdDeCampDeFiltratAllà coincideix amb IdDeCampDeFiltratAquí on l'estatus és estatusAllà.",
"Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto." => "Opcions de l'adreça de correu electrònic: 0|1|2 on 0 posa l'adreça com a text pla, 1 fa un enllaç mailto codificat hex (més difícil que web spiders recullin el mail i enviïn correu brossa) i 2 fa el href mailto normal.",
" 0|1|2|3|4|5 0,xsize,ysize. First record :0 for URL in file gal of MP3 only, 1 for URL of FLV in file gal video only , 2 for URL of MP3 or Video in file gal, 3 donwload MP3 only, 4 donwload FLV video only, 5 download FLV or MP3 (default is 0). Second record : X size of flash applet(default is 200) , Y size of flash applet (default is 100) " => " 0|1|2|3|4|5 0,mida_x,mida_y. Primer registre : 0 per URL a una galedia d'arxius de només MP3, 1 per URL de FLV a una galeria d'arxius de nomes vídeo, 2 per URL de MP3 o Video en galeria d'arxius, 3 descarerga només MP3, 4 descarrega només vídeo FLV, 5 descarrega FLV o MP3 (per defecte és 0). Segon registre : mida X de l'applet de flash (per defecte és 200) , mida Y de l'applet de flash (per defecte és 100) ",
"Sequential auto-increment number:initial_value,prepend,append,itemId: initial_value default is 1, prepend will be displayed before the field, append will be displayed just after, itemId will use the item Id" => "Número auto-incrementat seqüencialment: valor_inicial,prefix,sufix,IdItem: valor_inicial per defecte és 1, el prefix serà mostrat abans del camp, el sufix serà mostrat just després, l'IdItem emprarà l'ID de l'Ítem",
"Allow registered user to subscribe to an item. They can add a number of friends." => "Per als usuaris registrats de subscriure's a un ítem. Poden afegir un nombre d'amics.",
"Use Google Maps." => "Empra Mapes de Google.",
"Formula for computation, using # for indicating fields and +,*,/,- and parenthesis for operations." => "Formula per al càlcul, emprant # per indicar camps i +,*,/,- i parèntesis per a les operacions.",
"~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc)}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>NomDelTòpic, topicId=>id, type=>tipus, categId=>ID de la categoria mare, lang=>en, sort=>NomDeColuma_asc|NomDeColuma_desc)}{ARTICLES}~/np~",
"Formula" => "Fórmula",
"No formula specified." => "No s'ha especificat cap fórmula.",
"Impossible to render the graphic." => "No ha estat possible generar el gràfic.",
"View graphic" => "Visualitza el gràfic",
"new submissions" => "noves propostes d'articles'",
"new sites" => "nous llocs",
"new calendar events" => "nous esdeventiments al calendari",
"Message Broadcast" => "Émisió de Missatges",
"applicable for this item" => "aplicable per a aquest item",
"click to show/hide" => "clica per mostrar/amagar",
"Are you sure you want to remove this module?" => "Segur que vols eliminar aquest mòdul?",
"database queries used" => "consultes emprades a la base de dades",
"Created by:" => "Creat per:",
"Last Modification:" => "última modificació:",
"For" => "Per a",
"{\$atts_cnt} files attached" => "{\$atts_cnt} arxius adjunts",
"pass" => "contrasenya",
"Page generated in" => "Pàgina generada en",
"sent" => "enviat",
"Homework" => "Deures",
"Assignments" => "Deures",
"{|} Files Attached" => "{|} arxius adjunts",
"Favorites" => "Favorits",
"Member list" => "Llista de membres",
"Back to Homepage" => "Tornar a inici",
"Edit Summary" => "Resum de l'edició",
"Minor" => "Menor",
"RSS Trackers" => "Alimentacions RSS per a Formularis",
"Show/Hide Left Modules" => "Mostra/Amaga els mòduls de l'esquerra",
"Show/Hide Right Modules" => "Mostra/Amaga els mòduls de la dreta",
"Last update from CVS" => "Darrera actualització des de CVS",
"Translate in" => "Tradueix a",
"babelfish it" => "tradueix-ho amb babelfish",
"Welcome to" => "Benvingut a",
"Design by" => "Dissenyat per",
"Feature documentation links" => "Enllaços de documentació de les funcionalitats",
"Help System (Feature documentation links)" => "Sistema d'Ajuda (Enllaços de documentació de les funcionalitats)",
"Technical Features" => "Funcionalitats tècniques",
"Content Features" => "Funcionalitats de contingut",
"Contact Us (Anonymous)" => "contacta'ns (Anònim/a)",
"Freetags rock!" => "Les etiquetes lliures molen!",
"Preference syntax" => "Sintaxi de preferències",
"Prevent automatic/robot registration" => "Prevenir registre automàtic/robots",
"Required for all the following features" => "Requerit per totes les funcionalitats següents",
"Site Logo" => "Logo del Lloc",
"Admin Groups Template" => "Admin groups template",
"Help on Banning System" => "Ajuda en el sistema de pancartes",
"Admin banning tpl" => "Administrar plantilla per a prohibició",
"Create/edit Calendars" => "Crear/edita calendaris",
"Admin Categories tpl" => "Administrar plantilla per a categories",
"charts" => "gràfics",
"Chat Administration" => "Administració del Xat",
"Chat Admin" => "Administrar Xat",
"Chat Admin tpl" => "Administrador de xat tpl",
"Create/edit channel" => "Crea o edita canal",
"Half a second" => "Un segon",
"second" => "segon",
"Chat channels" => "canals del Xat",
"Help on Drawings" => "Ajuda sobre els Dibuixos",
"Admin DSN" => "Administra DSN",
"tiki-admin_dsn tpl" => "plantilla tiki-admin_dsn",
"Admin Hotwords Template" => "Administra la plantilla de paraules calentes",
"Tiki integrator" => "integrador Tiki",
"Admin Featured Links" => "Administració d'enllaços especialas",
"Admin Webmail" => "Administrar Correu-Web",
"Admin Mailing Template" => "Administrar plantilla per a butlletins",
"Admin Menu Builder" => "Constructor de menús d'administració",
"Assign Module" => "Assigna mòdul",
"Edit/Create" => "Edita/Crea",
"subscribed" => "subscrit",
"Admin Polls Template" => "Administra la Plantilla de les Votacions",
"Configure Polls" => "Configura Votació",
"tiki admin quicktags template" => "administrador tiki de plantilles de marques d'inserció ràpida",
"Score System" => "Sistema de puntuacions",
"security admin" => "Administració de Seguretat",
"security admin tpl" => "plantilla d'administració de seguretat",
"Edit survey questions" => "Edita preguntes de l'enquesta",
"administer surveys template" => "administra la plantilla de les enquestes",
"system admin" => "administrador de sistema",
"system admin tpl" => "administrador de sistema tpl",
"Admin Tracker" => "Administra formulari",
"User must already exist." => "L'usuari ha d'existir prèviament.",
"To create users and assign them to groups, got to admin->users" => "Per crear usuaris i assignar-los a grups, ves a admin->usuaris",
"Warning: changing the username will require the user to change his password and will mess with slave intertiki sites that use this one as master" => "Avís: canviar el nom d'usuari requerirà a l'usuari canviar-se la contrasenya i es liarà amb els llocs intertiki esclaus que utilitzen aquest com a mestre",
"Warning: changing the username will require the user to change his password" => "Avís: canviar el nom d'usuari requerirà a l'usuari canviar-se la contrasenya",
"Again" => "Un altre cop",
"User must change his password at first login" => "L'usuari ha de canviar la seva contrasenya en connectar-se per primera vegada",
"Approve page changes in staging" => "Aprova els canvis de la pàgina per revisar",
"Article Types tpl" => "plantilla per a Tipus d'article",
"Assign permissions to group" => "Assignar permisos al grup",
"Edit Article Tpl" => "Edita plantilla per a article",
"Browsing Gallery" => "Fullejant Galeria",
"Config Calendars" => "Configura els Calendaris",
"Admin Directory tpl" => "Administrar plantilla per a directori de categories",
"Admin Directory Related" => "Administració de directori relacionat",
"directory admin related tpl" => "plantilla per a directori relatiu a l'administració",
"Admin Directory Sites" => "Admin del Directori de Llocs",
"Admin Directory Sites tpl" => "Admin del Directori de Llocs tpl",
"Validate Sites" => "Valida Llocs",
"directory validate sites tpl" => "plantilla per a validar les dades del directori",
"Edit Article" => "Edita Article",
"Edit Blog Tpl" => "Edita plantilla per a bitàcola",
"Show Plugins Help" => "Mostra l'ajuda dels Plugins",
"Will display using the indicated HTML color or color name" => "Mostrarà utilitzant el color HTML o el nom del color (en anglès)",
"Show Text Formatting Rules" => "Mostra les Regles de Formateig de Text",
"Program dynamic content for block" => "Programar el contingut dinàmic per al bloc",
"Admin quizzes" => "Administrar qüestionaris",
"Admin Quizzes tpl" => "Administrar plantilla per a qüestionaris",
"Help on Articles" => "Ajuda amb els Articles",
"Edit Submissions Tpl" => "Edita plantilla per a submissions",
"EditTemplates" => "Editaplantilles",
"EditTemplates tpl" => "plantilla per a Editaplantilles",
"Edit Translations" => "Edita Traduccions",
"Edit Translations Template" => "Edita la plantilla de Traduccions",
"Message queue for" => "Cua de missatges per a ",
"back to forum" => "torna al fòrum",
"Reported messages for" => "Missatge reportat per",
"friends tpl" => "plantilla ambics",
"galleries tpl" => "Plantilla per a les Galeries",
"ImportingPagesPhpWikiPageAdmin" => "AdminImportantPàginesPhpWikiPage",
"tiki-import_phpwiki tpl" => "plantilla tiki-import_phpwiki",
"Backup your database with mysqldump, phpmyadmin, or other before upgrading." => "Fes una còpia de seguretat de la teva base de dades amb mysqldump, phpmyadmin, o altres abans d'actualitzar.",
"Update database using script" => "Actualitza la teva base de dades emprant la seqüència (script)",
"No scripts available." => "Cap arxiu de seqüències (script) disponible.",
"To upgrade from" => "Per actualitzar des de",
"Use this script" => "Empra aquesta arxiu de seqüències (script)",
"See <a target=\"help\" class=\"link\" href=\"http://doc.tikiwiki.org/Upgrade+1.7+to+1.8\">Tiki database 1.7.x to 1.8x instructions" => "Consulta les <a target=\"help\" class=\"link\" href=\"http://doc.tikiwiki.org/Upgrade+1.7+to+1.8\">instruccions de bases de dades Tiki 1.7.x a 1.8.x",
"For information about <strong>tiki-secdb_*.sql</strong> files, please see <a target=\"help\" class=\"link\" href=\"http://doc.tikiwiki.org/Security+Admin\">http://doc.tikiwiki.org/Security+Admin" => "Per informació sobre els arxius <strong>tiki-secdb_*.sql</strong>, si us plau consulta <a target=\"help\" class=\"link\" href=\"http://doc.tikiwiki.org/Security+Admin\">http://doc.tikiwiki.org/Security+Admin",
"TikiWiki requires <strong>at least</strong> 16MB of PHP memory for script execution. Use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 16M) and restart your webserver" => "TikiWiki necessita <strong>com a mínim</strong> 16MB de memòria PHP per a l'execució del programa. Empra la clau <strong>memory_limit</strong> al teu arxiu <strong>php.ini </strong> (per exemple: memory_limit = 16M) i reinicia el teu servidor web",
"List Articles Tpl" => "Plantilla per a llista d'articles",
"Admin Cache" => "Administrar caxé",
"Admin Cache tpl" => "Administrar plantilla per a caxé ",
"Orphan" => "Òrfan/ena",
"Help on Dynamic Content" => "Ajuda sobre contingut dinàmic",
"List FAQs Tpl" => "Llistat de preguntes més freqüents",
"games tpl" => "plantilla (tpl) de jocs",
"List Posts Tpl" => "Plantilla per a llista d'enviaments",
"Admin Live Support tpl" => "Xxx",
"back to admin" => "tornar a administració",
"User Calendar" => "Calendari de l'usuari",
"User Calendar Doc tpl" => "Plantilla de document d'usuari/a",
"User Calendar Doc" => "Document de calendari d'usuari/a",
"User Calendar Preferences Doc tpl" => "Plantilla de document de preferències de calendari de l'usuari/a",
"my tiki tpl" => "Plantilla per al meu tiki",
"Subscribe to This Newsletter" => "Subscriu",
"Stats for quiz" => "Estadistiques per test",
"received articles tpl" => "articles rebuts tpl",
"Help on Communication Center" => "Ajuda al centre de comunicació",
"received pages tpl" => "pàgines rebudes tpl",
"return to wikipage" => "torna a la pàgina wiki",
"Rename page" => "Renombrar la pàgina",
"to_version" => "a la versió",
"search stats tpl" => "estadístiques de cerca tpl",
"Admin Send Objects tpl" => "Administrar plantilla per a enviar objectes",
"sheets tpl" => "plantilla (tpl) de fulls",
"Stats for survey" => "Estadístiques per enquesta",
"system logs" => "registres del sistema",
"system logs tpl" => "Plantilla dels registres del sistema",
"Theme Control Center: categories" => "Centre de Control de Theme: categories",
"ThemeControl" => "ControldeTheme",
"ThemeControl tpl" => "Plantilla de ControldeTemes",
"ThemeControl Objects" => "Objectes de ControldeTemes",
"theme control objects tpl" => "plantilla d'objectes de control de temes",
"Theme Control Center: sections" => "Centre de control de temes: seccions",
"theme control sections tpl" => "plantilla de seccions de control de temes",
"File Title" => "Títol de l'arxiu",
"Unzip all zip files" => "Descomprimeix tots els arxius zip",
"Author if not the file creator" => "Autor si no ets el creador de l'arxiu",
"Image Gallery tpl" => "Plantilla per a Galeria d'images",
"User Assigned Modules" => "Mòduls assignats a l'usuari/a",
"User Assigned Modules tpl" => "Plantilla de mòduls assignats a l'usuari/a",
"User Bookmarks tpl" => "Preferits/Adreces d'interès tpl",
"UserPreferences tpl" => "Plantilla de Preferències d'Usuari (UserPreferences)",
"User Tasks tpl" => "Plantilla de tasques d'usuari/a",
"User Watches tpl" => "Plantilla (tpl) dels avisos de l'usuari/a",
"Watch language wiki page creations" => "Vigila les creacions de pàgines Wiki en l'idioma",
"Add watch" => "Vigila-ho",
"View FAQ Tpl" => "Visualitza plantilla de puf",
"Admin Menus tpl" => "Administrar plantilla per a menús",
"IRC log" => "Registre IRC",
"Edit mail account" => "Edita la compte de correu electrònic",
"Add new mail account" => "Afegeix un nou compte de correu",
"User accounts" => "Comptes d'usuari",
"View All" => "Visualitza Tots",
"Msg" => "Msstg",
"Can't parse remote HTML page" => "No es pot analitzar la pàgina HTML remota",
"Permission denied you cannot remove pages" => "Permís denegat, no podeu eliminar pàgines",
"Delete those pages:" => "Esborra aquestes pàgines:",
"Swffix" => "Swffix",
"Geourl" => "Geourl",
"meta robots" => "meta robots",
"Zoom" => "Zoom",
"MultiTiki setup" => "MultiTiki setup",
"\$title" => "\$title",
"Cannot write to this file" => "No es pot escriure a aquest arxiu",
"Your post has not been posted" => "L'enviament no ha estat publicat",
"Missing title or body when trying to post a comment" => "Manca títol o cos quan en intentar publicar un comentari",
"Antarctica" => "Antàrtida",
"\\n for rows" => "\\n per arxius",
"Use this thread to discuss the %s page." => "Empra aquest fil per discutir la pàgina %s .",
"Newsletter subscription information at " => "Butlletí d'informació de subscripció a ",
"Parse" => "Interpreta",
"Changes" => "Canvis",
"Hold down CTRL to select multiple categories" => "Prem la tecla CTRL per seleccionar múltiples categories",
"categorize this object" => "categoritza aquest objecte",
"Uncheck the above checkbox to uncategorize this page/object" => "Desmarca la casella de sobre per descategoritzar aquesta pàgina/objecte",
"Your account request have been stored and will be activated by the admin as soon as possible." => "La teva petició de compte ha estat arxivada i serà activada per la persona administradora tan aviat com li sigui possible.",
"New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Publicació d'un nou article: {\$mail_title} per {\$mail_user} el dia {\$mail_date|tiki_short_datetime}",
"New article post at %s" => "Nova publicació d'article a %s",
"New article post at" => "Nova publicació d'article a",
"Syntax highlighting" => "sintaxi resaltada",
"Mini calendar" => "Mini calendari",
"User list" => "Llista d'usuaris",
"Received pages" => "Pàgines rebudes",
"Browse directory" => "Explorar directori",
"List quizzes" => "Llista de Qüestionaris",
"List trackers" => "Llista formularis",
"To learn more, visit: <a href=\"http://www.tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://www.tikiwiki.org</a>" => "Per aprendre més, visita: <a href=\"http://www.tikiwiki.org\" title=\"La Comunitat de Tikiwiki\" target=\"_blank\">http://www.tikiwiki.org</a>",
"I forgot my pass" => "He oblidat la meva contrasenya",
"Click to see the ratings" => "Cliqueu per veure les valoracions",
"Note: if you want to use images please save the post first and you\n\twill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\n\tor use the image URL to include images using the WYSIWYG editor. " => "Nota: si vols emprar imatges, desa la publicació primer i podràs\n\tllavors editar/publicar imatges. Empra el codi &lt;img&gt; per incloure imatges pujades l'editor de l'àrea de text \n\to fer servir la URL de la imatge per incloure imatges emprant l'editor WYSIWYG. ",
"Send trackback pings to:" => "Enviar pings de seguiment a:",
"(comma separated list of URIs)" => "(coma llista separada d' URIs)",
"Use categories to regroup various Tiki objects" => "Empra categories per reagrupar varis objectes de Tiki",
"Link to" => "Enllaça a",
"User identity features" => "Funcionalitats de la identitat dels usuaris",
"Users sort order" => "Ordenació dels usuaris",
"Tikiwiki version" => "Versió de Tikiwiki",
"Use URI as Home Page" => "Fes servir URL com a pàgina incial",
"OS" => "Sistema operatiu",
"Log Mail in Tiki Logs:" => "Registra l'enviament de correu-e al Registre de Tiki:",
"Log SQL:" => "Registra SQL:",
"Default charset for sending mail:" => "Jocs de caracters per defecte per enviar correus-e:",
"Mail end of line:" => "Final de línia del correu-e:",
"Disallow access to the site (except for those with permission)" => "No permetre accès a la web (excepte aquells amb permís)",
"Message to display when site is closed" => "Missatge a mostrar quan una web és tancada",
"Disallow access when load is above the threshold (except for those with permission)" => "No permetre accès quan la càrrega encara no s'ha completat (excepte aquells amb permís)",
"Max average server load threshold in the last minute" => "Rendiment màxim de la càrrega del servidor en el darrer minut",
"Message to display when server is too busy" => "Missatge a mostrar quan el servidor està massa ocupat",
"Use cache for external images" => "Fer servir la memòria cau per a les imatges externes",
"Use gzipped output" => "Empra sortida comprimida amb gzip",
"output compression is active." => "compressió de sortida és activa.",
"compression is handled by" => "la compressió és controlada per",
"Sender Email" => "Correu-e de l'enviador",
"Allow anonymous users to \"Contact Us\"" => "Permet que els usuaris anònims vagin a \"Contacta'ns\"",
"contact feature disabled" => "Possibilitat de contacte deshabilitada",
"Session lifetime in minutes" => "Temps de vida de sessió en minuts",
"Proxy Host" => "Servidor Proxy",
"Proxy port" => "Port del Proxy",
"Please expect not found help-pages with the default-URL." => "Si us plau, és normal no trobar totes les planes d'ajuda amb la URL per defecte.",
"Any help with the documentation is welcome." => "Qualsevol ajuda amb la documentació és benvinguda.",
"Release check" => "Comprovació d'alliberament",
"Release checks are made when you browse admin main page only" => "Les comprovacions d'alliberaments de noves versions són efectuats només quan navegues la pàgina principal d'administració",
"Force immediate check" => "Força una comprovació immediata",
"When possible, show the real user name instead of login:" => "Quan sigui possible, mostra el nom real de l'usuari enlloc del nom de connexió:",
"Locations separator" => "Separador de Localitzacions",
"Choices separator" => "Separador d'opcions",
"User registration and login" => "Registre de l'usuari i connexió",
"Use WebServer authentication for Tiki" => "Empra autenticació del ServidorWeb per a Tiki",
"... but need admin validation" => "... però es necessita validació de la persona admin",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Cal establir <a href=\"tiki-admin.php?page=general\">correu electrònic emissor</a>",
"Create a group for each user <br />(with the same name as the user)" => "Crea un grup per a cada usuari <br />(amb el mateix nom que l'usuari)",
"Use tracker for more user information" => "Empra els formularis per més informació dels usuaris",
"Use tracker for more group information" => "Empra els formularis per més informació dels grups",
"Request passcode to register" => "Sol·licita codi de pas per a registrar-se",
"Php GD library required" => "Llibreria Php GD requerida",
"Use login as email" => "Empra nom de connexió com a correu-e",
"Validate users by email" => "Valida usuaris per correu-e",
"Validate user email server" => "Valida el servidor de correu-e de l'usuari",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Recorda contrasenyes per correu-e (si \"Desar contrasenyes en txt pur\" està activada.) Si no, re-assigna'n un de nou per correu-e",
"Store plaintext passwords" => "Desa contrasenyes en text pur",
"Crypt passwords method" => "Mètode de Xifrat de contrasenyes",
"Reg users can change password" => "Usuaris enregistrats poden canviar la seva contrasenya",
"Reg users can change language" => "Els usuaris registrats poden canviar l'idioma",
"Restrict available languages" => "Restringeix idiomes disponibles",
"Available languages:" => "Idiomes disponibles:",
"Minimum username length" => "Longitud mínima de nom d'usuari",
"Maximum username length" => "Longitud màxima de nom d'usuari",
"Force lowercase username" => "Força emprar nom d'usuari en minúscules",
"Force to use chars and nums in passwords" => "Força a emprar caracters i números en contrasenyes",
"Minimum password length" => "Mida mínima de contrasenya",
"Password invalid after days" => "Contrasenya invàlida després de dies",
"-1 for never" => "-1 per a mai",
"Re-validate user by email after days" => "Re-valida els usuaris per correu-e després del número de dies",
"Re-validate user by email after unsuccessful logins" => "Re-valida els usuaris per correu-e després del nombre d'intents de connexió sense èxit",
"Remember me feature" => "Característica per enrecordar-me",
"Duration:" => "Duració",
"Remember me name" => "Nom per enrecordar-me",
"Remember me domain" => "Domini per enrecordar-me",
"Remember me path" => "Ruta per enrecordar-me",
"Protect against CSRF with a confirmation step" => "Protegir contra CSRF amb un pas de confirmació",
"Highlight Group" => "Destaca Grup",
"User can choose beyond these groups at registration time" => "L'usuari pot escollir entre aquests grups al moment d'enregistrar-se",
"Specify the fields that will be asked in admin->groups" => "Especifica els camps que seran demanats a admin->grups",
"Displays user's contribution in the user information page" => "Mostra la contribució d'una persona usuària en la pàgina seva d'informació personal",
"Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …" => "Mostra la informació del Formulari de l'Usuari a la pàgina d'informació de l'Usuari. Format: trackerId, fieldId1, fieldId2, …",
"Deactivate login autocomplete (do not remember login and password)" => "Desactiva autocompletat de les dades de connexió (no recordis nom d'usuari ni contrasenya)",
"Create user if not in Tiki?" => "Crear usuari/a si no hi és al Tiki?",
"Create user if not in Auth?" => "Crear usuari/a si no és un Autor?",
"Just use Tiki auth for admin?" => "Només fes servir autor de Tiki per a administració?",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "URL LDAP<br />(si s'especifica, sobreescriurà el nom de servidor i port de sota)",
"LDAP Host" => "Servidor LDAP",
"LDAP Scope" => "Objectiu LDAP",
"LDAP Base DN" => "DN Base LDAP",
"LDAP User DN" => "LDAP usuari/a DN",
"LDAP User Attribute" => "LDAP Atribut d'usuari/a",
"LDAP User OC" => "LDAP usuari/a OC",
"LDAP Group DN" => "LDAP Grup DN",
"LDAP Group Attribute" => "LDAP Atribut de Grup",
"LDAP Group OC" => "LDAP Grup OC",
"LDAP Member Attribute" => "LDAP Atribut de Membre",
"LDAP Member Is DN" => "LDAP Membre és DN",
"LDAP Admin User" => "LDAP Administra Usuari",
"LDAP Admin Pwd" => "LDAP Administra Contrasenya",
"CAS server hostname" => "nom del servidor CAS",
"CAS server port" => "port del servidor CAS",
"CAS server path" => "ruta del servidor CAS",
"Change CAS preferences" => "Canvia preferències de CAS",
"Users Defaults" => "Per defecte per als nous usuaris",
"Change users defaults" => "Canvia els valors per defecte per als nous usuaris",
"Note: This feature also requires PHPLayers to be turned on in " => "Nota: Aquesta funcionalitat també requereix que PHPLayers estigui activat a ",
"Meta Keywords" => "Meta Paraules clau",
"Meta Description" => "Meta Descripció",
"Meta Author" => "Meta Autor",
"revisit after" => "revisita després de",
"Allow Smileys" => "Permetre Emoticones",
"Use File Galleries for images inclusion" => "Empra les Galeries d'arxius per la inclusió d'imatges",
"Hotwords in New Windows" => "Paraules calentes en finestres noves",
"Trackers attachments preferences" => "Preferències dels adjunts dels Formularis",
"Trackers attachments" => "Adjunts dels formularis",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Per afegir/editar planes wiki fàcilment, afegeix el mòdul d'edició ràpida (quick_edit) via \"Mòduls\" en el menú principal de l'aplicació, o",
"Create a Tag for the Current Wiki" => "Crea una Etiqueta per al Wiki actual",
"Restore the Wiki" => "Restaura el Wiki",
"restore" => "recuperar",
"Remove a Tag" => "Elimina l'Etiqueta",
"Wiki Comments Settings" => "Paràmetres dels Comentaris Wiki",
"Wiki Administration" => "Administració Wiki",
"Wiki Home Page" => "Pàgina Inicial del Wiki",
"Wiki Discussion" => "Discussió Wiki",
"Wiki Link Format" => "Format d'enllaç Wiki",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Controls de reconeixement dels enllaços Wiki usant la sintaxi de dos parèntesis <i>((nom de la pàgina ))</i>.",
"Wiki Page Staging and Approval" => "Pàgines Wiki per Revisar i Aprovar",
"Wiki Page List Configuration" => "Configuració de la llista de planes Wiki",
"Wiki 3D Browser Configuration" => "Configuració del Navegador Wiki 3D",
"Wiki Features" => "Funcionalitats del Wiki",
"Wiki History" => "Historial del Wiki",
"History only for data, description, comment change" => "Historial només per a canvi de dades, de descripció i de comentari",
"Wiki Watch" => "Avisos del Wiki",
"More Links" => "Més enllaços",
"browse the category system" => "navega el sistema de categories",
"Admin Charts" => "Administrar llistes",
"Add new rule" => "Afegir regla",
"EMail notifications" => "Notificacions de correu electrònic",
"Edit this RSS module:" => "edita aquest mòdul RSS:",
"Create new RSS module" => "Crear un nou mòdul RSS",
"Tikiwiki settings" => "Paràmetres de Tikiwiki",
"Create/edit questions for survey" => "Crear/edita preguntes per a enquesta",
"Wiki textaera" => "Àrea de Text del Wiki",
"Active?" => "Actiu?",
"Create Trackers" => "Crea formularis",
"Create/Edit Trackers" => "Crea/edita formularis",
"tracker name must be unique, field names must be unique \nfor a tracker and they must be valid in SQL" => "el nom del formulari ha de ser únic, els noms dels camps han de ser únics \nper a un formulari i han de ser vàlids en SQL (sense espais ni caràcters especials)",
"or list of fields separated by comma" => "o llista de camps separats per comes",
"Create item" => "Crea l'ítem",
"Warning: since this tiki site is in slave mode, all user information you enter manually will be automatically overriden by other site's data, including users permissions" => "Avís: com que aquest lloc tiki és en mode esclau, tota la informació d'usuari que introdueixis manualment se sobreescriurà automàticament amb dades d'altres llocs web, inclosos els permisos d'usuari",
"Assign to Groups" => "Assigna a grups",
"show help" => "mostra ajuda",
"Delete this type" => "Elimina aquest tipus",
"level configuration" => "configuració de nivells",
"Browse gallery" => "Fulleja galeria",
"Upload from disk" => "Pujar des del disc local",
"Browse file gallery" => "Navega per la Galeria d'Arxius",
"Directory batch" => "Directori per pujada en bloc",
"Browsing Image" => "Fullejant imatge",
"Duplicate to" => "Duplica a",
"Again please" => "Un altre cop si us plau",
"Admin category relationships" => "Administrar relacions de categoria",
"Validate links" => "Valida enllaços",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "Arxius amb noms pujats per -{\$user} són modificables, altres, només són duplicables i són fets servir com a model.",
"Im- Export Languages" => "Importar/Exportar Idiomes",
"disable" => "desactiva",
"Reset view to site-wide default" => "Torna a configurar la vista a la que hi ha per defecte a aquest lloc",
"To add a new virtual host" => "Per afegir un nou allotjament virtual",
"Please enter your database connection information" => "Si us plau, introdueix la informació de connexió a la teva base de dades",
"Host:" => "Allotjament:",
"Enter the hostname or IP for your database. Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Introdueix el nom de l'allotjament o IP de la teva base de dades. Empra <strong>localhost</strong> si la base de dades s'executa al mateix ordinador que Tiki",
"Database name" => "Nom de la Base de dades",
"Database User" => "Usuari de la base de dades",
"Enter the database user with administrator permission for the Database" => "Introdueix l'usuari de la base de dades amb permisos d'administració per a la Base de dades",
"Enter the password for the database user" => "Introdueix la contrasenya per a l'usuari de la base de dades",
"Connect" => "Connecta",
"Welcome to the installation{if \$tikidb_created} &amp; upgrade{/if} script!" => "Benvinguts al procés d'instal·lació{if \$tikidb_created} &amp; actualització{/if}!",
"Reinstall database." => "Reinstal·la la base de dades.",
"No profiles available." => "Cap perfil disponible.",
"See the documentation for <a target=\"_blank\" href=\"http://doc.tikiwiki.org/Profiles\" class=\"link\" title=\"{tr}Description of available profiles." => "Consulta la documentació per a la <a target=\"_blank\" href=\"http://doc.tikiwiki.org/Profiles\" class=\"link\" title=\"{tr}Descripció dels perfils disponibles.",
"Other Options" => "Altres opcions",
"Do nothing and enter Tiki" => "No facis res més que entrar a Tiki",
"Reset database connection settings" => "Torna a especificar els paràmetres de connexió a la base de dades",
"Important Information" => "Informació Important",
"Please read the following notes before entering Tikiwiki." => "Si us plau, llegeix les següents notes abans d'entrar a Tikiwiki.",
"Tiki has not detected your PHP memory_limit. This probably means you have no set limit (all is well)" => "Tiki no ha detectat la teva configuració PHP per al paràmetre memory_limit. Això vol dir probablement que no hi ha posat cap límit (tot està bé)",
"Entering TikiWiki" => "Entrant a TikiWiki",
"Do not use your browser's Back button." => "No empris el botó d'endarrere del teu navegador.",
"Create a file gallery" => "Crear una galeria d'arxius",
"Support tickets" => "Tiquets de suport",
"(Only .gif images, and aproximately 45px x 45px)" => "(En alguns servidors, només imatges .gif, i aproximadament 45px x 45px)",
"Return to HomePage" => "Torna a la pàgina d'Inici",
"{icon _id=information.png style=\"vertical-align:middle\"} Content may be out of date" => "{icon _id=information.png style=\"vertical-align:middle\"} El contingut pot estar desfasat",
"Stats for this survey Questions " => "Estadístiques per a les preguntes d'aquesta enquesta",
"SysLog" => "Registre del sistema (SysLog)",
"Batch upload" => "Puja al rerafons",
"watched events" => "esdeveniments vigilats",
"1 suggestion" => "1 suggeriment",
"suggestions" => "suggeriments",
"Another post with the same title and content already exists." => "Ja existeix una publicació amb el mateix títol i contingut.",
"Please change your title or content then click Post." => "Si us plau, canvia el teu títol o contingut i clica de nou a Publicar.",
"Format : x,y,zoom - You can use Google Map Locator in the item view script." => "Format : x,y,zoom - Pots emprar el localitzador de mapes de Google quan visualitzis la fitxa de l'item.",
"fields marked with a * are mandatory" => "Els camps marcats amb un asterisc * són obligatoris",
"Show Filters" => "Mostra filtres",
"Minor Edit" => "Edició Menor",
"The \"Snarf Wikiplugin\" is installed. It can be used by wiki editors to include pages from the local network and via regex replacement create any html." => "El connector \"Snarf Wikiplugin\" està instal·lat. Pot ser emprat fàcilment per editors Wiki per incloure pàgines des de la xarxa local i via reemplaçament d'expressions regulars crear qualsevol html.",
"The \"Regex Wikiplugin\" is installed. It can be used by wiki editors to create any html via regex replacement." => "El connector \"Regex Wikiplugin\" està instal·lat. Pot ser emprat per editors Wiki per crear qualsevol html via reemplaçament a través d'expressions regulars.",
"The \"Lsdir Wikiplugin\" is installed. It can be used by wiki editors to view the contents of any directory." => "S'ha instal·lat el \"Lsdir Wikiplugin\". El poden utilitzar els editors de wiki per veure el contingut de qualsevol directori.",
"The \"Bloglist Wikiplugin\" is installed. It can be used by wiki editors to disclose private blog posts." => "Està instal·lat el connector \"Bloglist Wikiplugin\". Pot ser emprat per editors Wiki per mostrar publicacions privades de bitàcoles.",
"You can not download files" => "No pots descarregar fitxers",
"cannot be found" => "no es pot trobar",
"You are not yet validated" => "Encara no estàs validat",
"Invalid password.  Your current password is required to change administrative information" => "Contrasenya invàlida. Es requereix la teva contrasenya actual per canviar informació administrativa",
"Please wait 2 minutes between posts" => "Si us plau, esperi 2 minuts entre missatges",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\n{\$mail_machine}/tiki-change_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nDone! You should be logged in." => "Si us plau, clica al següent enllaç per confirmar el teu desig de re-especificar la teva contrasenya i anar a la pantalla on hauràs d'introduir una contrasenya nova i \"permanent\". Si us plau, escull una contrasenya que només sàpigues tu, i no la comparteixis amb ningú més.\n{\$mail_machine}/tiki-change_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nFet! Hauries d'estar a dins.",
"Wiki page %s changed" => "La pàgina Wiki %s ha canviat",
"Blog features" => "Funcionalitats de les Bitàcoles",
"Blog level comments" => "Comentaris a nivell de Bitàacola",
"Post level comments" => "Comentaris a nivell de publicació",
"Trackbacks Pings" => "Pings Trackbacks",
"Post level trackback pings" => "Trackback pings a nivell de publicació",
"Spellchecking" => "Comprovació ortogràfica",
"Blogs have a custom heading" => "Les bitàcoles tenen una capçalera adpatable",
"Default ordering for blog listing" => "Ordenació predeterminada per a la llista de bitàcoles",
"Blog listing configuration (when listing available blogs)" => "Configuració del llisat de bitàcoles (quan es llistin les bitàcoles disponibles)",
"Last modification time" => "Data de la Darrera modificació",
"Blog comments settings" => "Configuració de comentaris de les bitàcoles",
"Group calendar sticky popup" => "Emergent enganxós del calendari de grup",
"Group calendar item view tab" => "Pestanya de visualització de l'ítem del calendari de grup",
"Calendar manual selection of time/date" => "Selecció manual de hora/dia per al Calendari",
"First year in the dropdown, either year number, or relative to current year (+/- N)" => "Primer any al desplegable, o número d'any, o relatiu a l'any actual (+/- N)",
"if no jscalendar" => "si no es fa servir el Calendari en javascript (jscalendar)",
"Last year in the dropdown, either year number, or relative to current year (+/- N)" => "Darrer any al desplegable, o número d'any, o relatiu a l'any actual (+/- N)",
"Show Category Path" => "Mostrar camins de les categories",
"Exclude These Category IDs from Path (comma delimited)" => "Exclou aquests IDs de categories de la Ruta (separats per comes)",
"Show Category Objects" => "Mostrar objectes de les categories",
"Search may show forbidden results. Much better performance though." => "Les cerques poden mostrar resultats prohibits. Tot i això, es generen uns millors resultats.",
"Categories browse uses PhpLayers" => "La navegació de categories empra la funcionalitat de capes de php (PhpLayers)",
"The feature must be activated" => "La funcionalitat ha de ser activada",
"CMS features" => "Funcionalitats del CMS",
"Use templates" => "Empra plantilles",
"Print article" => "Imprimeix article",
"Can specify notification emails when creating an article" => "Pot especificar correus-e de notificació quan es crea un article",
"Settings for page articles home" => "Paràmetres de l'inici de la pàgina d'articles",
"Maximum number of articles in home" => "Quantitat màxima d'articles a l'inici ?",
"Article comments settings" => "Configuració dels comentaris d'articles",
"Fields to display on page" => "camps que es mostraran dins la pàgina",
"Expire Date" => "Expira la Data",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Per afegir/eliminar galeries d'arxius, ves a \"Galeries d'Arxius\" en el menú de principal l'aplicació, o",
"File author" => "Autor de l'arxiu",
"For not registered author" => "Per a autors no registrats",
"Uploaded filenames must match regex" => "Els arxius penjats han de coincidir amb aquesta regex ",
"Uploaded filenames cannot match regex" => "Els arxius penjats no han de coincidir amb aquesta regex",
"File galleries comments settings" => "Configuració dels comentaris de les galeries d'arxius",
"File galleries search indexing" => "Indexat de cerca de galeries d'arxius",
"Leave command blank to delete handler" => "Deixa l'ordre en blanc per esborrar el gestor",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Empra %1 per al cas en que nom d'arxius interns haurien de ser substituïts  (exemple: \"strings %1\" per convertir el document a text emprant la comanda de Unix 'strings')",
"Enable auto indexing on file upload or change" => "Habilita l'auto indexat en pujar l'arxiu o canviar-lo",
"System command" => "Comanda del Sistema",
"Home Forum" => "Fòrum inicial",
"Forums features" => "Funcionalitats dels Fòrums",
"Forum quick jumps" => "Dreceres del Fòrum",
"Ordering for forums in the forum listing" => "Ordre dels fòrums a la llista de fòrums",
"Forum listing configuration" => "Configuració del llistant de Fòrums",
"Default thread style" => "Estil per defecte del fil",
"Default thread sort mode" => "Mode d'ordenació per defecte del fil",
"Freetag Browsing" => "Navegació per les etiquetes lliures",
"Show Tag Cloud" => "Mostra Núvol d'Etiquetes",
"Random tag cloud colors (separated by comma)" => "Colors a l'atzar dels núvols d'etiquetes (separats per comes)",
"Handle multilingual freetags" => "Gestiona les etiquetes lliure multiidioma",
"I18n setup" => "Configuració de I18n ",
"Default Language" => "Idioma per defecte",
"Available languages (Ctrl+Click to select multiple languages):" => "Idiomes disponibles (Fes Ctrl+Click per seleccionar-ne múltiples):",
"Show Babelfish Translation URLs" => "Mostrar URLs de traducció de Babelfish",
"Show Babelfish Translation Logo" => "Mostrar Logo de traducció de Babelfish",
"Allow Anonymous Poll Voting" => "Permet votacions anònimes",
"Parse the result (can be slow)" => "Interpreta el resultat (pot ser lent)",
"Database Search using MySQL 'Full-Text' Feature" => "Cerca a la base de dades emprant la funcionalitat de 'Text-complet' de MySQL",
"Activate MySQL Full-Text feature" => "Activa la funcionalitat de Text-complet de MySQL",
"Activate MySQL 'Full-Text' feature" => "Activa la funcionalitat de 'Text-complet' de MySQL",
"Performance issues" => "Opcions de funcionament",
"Database Independent Full Text Search or Tiki Search" => "Cerca per Text-complet independentment de la base de dades o Cerca pròpia del Tiki",
"This is activated by default if MySQL 'Full-Text' feature is not activated above" => "Això s'activa per defecte si la funcionalitat de 'Text-complet' de MySQL no s'ha activat més amunt",
"Search features" => "Funcionalitats de cerca",
"SearchStats" => "Estadístiques de cerca",
"Settings for searching content" => "Paràmetres de cerca de continguts",
"Search refresh mode" => "Mode de refresc de la cerca",
"Search refresh rate" => "Ritme de refresc de busqueda",
"0 for no refresh" => "0 per cap refresc",
"Number of lines" => "Nombre de línies",
"this survey stats" => "estadistiques d'aquesta enquesta",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>." => "Per aprendre més sobre <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">Temes</a> (d'estil, estètica).",
"theme" => "tema",
"You have {\$unread} unread private messages" => "Tens {\$unread} missatges privats sense llegir",
"unread private messages" => "missatges privats no llegits",
"Textarea options: quicktags,width,height,max,listmax,wordmax - Use Quicktags is 1 or 0, width is indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax is the maximum number of characters that are displayed in list mode, wordmax>0 alert if word count exceeded, wordmax<0 display word count." => "Opcions d'àrea de text: quicktags,width,height,max,listmax,wordmax - Utilització. Quicktags és 1 o 0, width s'indica en caràcters, height s'indica en línies, max és el nombre màxim de caràcters que es poden gravar, listmax és el nombre màxim de caràcters que es visualitzen en el mode llista, wordmax>0 avisa si se supera el recompte de paraules, wordmax<0 visualitza el recompte de paraules.",
"Country Selector options: name/flag, sortorder - name/flag is 0,1 or 2 where 1 shows only country name, 2 shows only country flag, 0 shows both (default). sortorder is 0 or 1 where 0 sorts according to translated text (default) and 1 sorts according to english country names even if country names are translated" => "Opcions de selector de país: nom/bandera, el criteri d'ordenació segons nom/bandera és 0,1 o 2, on 1 mostra només el nom del país, 2 mostra només la bandera del país, 0 mostra ambdues coses (per defecte). El criteri d'ordenació és 0 o 1, on 0 ordena segons el text traduït (per defecte) i 1 ordena segons els noms de país en anglès encara que estiguin traduïts",
"listview=nst, n to see name/t to see type/s to see type/u to see user in list mode" => "listview=nst, n per veure nom/t per veure tipus/s per veure tipos/u per veure usuari en el mode llista",
"blogId is mandatory" => "blogId és obligatori",
"Includes blog posts listing into a wiki page" => "Inclou un llistat de publicacions del bloc en una pàgina wiki",
"Tiki is unable to connect to the database " => "Tiki no pot connectar a la base de dades ",
"Tiki was unable to retrieve login data from the database " => "Tiki no ha pogut obtenir les dades de connexió de la base de dades ",
"Is your database up and running" => "Està ben instal·lada i funcionant la teva base de dades?",
"Are your database login credentials correct" => "Són correctes les teves credencials de connexió",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Vas completar <a href='tiki-install.php' >l'instal·lador",
"Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Si us plau, consulta <a href=\"http://doc.tikiwiki.org/\">la documentació</a> per a més informació",
"Sample plugin" => "connector (Plugin) de prova",
"Font family to use" => "Familia de fonts a emprar",
"As defined by CSS" => "Com es troba definit per CSS",
"Flash player not available" => "El reproductor Flash player no està disponible",
"__WARNING__: Plugin disabled \$plugin" => "__ATENCIÓ__: El Connector (Plugin) \$plugin està deshabilitat",
"Image alignment. Possible values: left, right, center" => "Alineació de la imatge. Possibles valors: esquerra, dreta, centre",
"Image annotations changed" => "Les anotacions de la imatge han canviat",
"Displays an image and allow the users to define zones to highlight information on the image" => "Mostra una imatge i permet als usuaris definir zones per ressaltar informació a la imatge",
"Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Mostra un gràfic a partir d'un Full de càlcul Tiki. Aquest connector pot ser generat per l'eina de gràfics dels FullsTiki",
"Chart caption" => "Títol del gràfic",
"List of colors to use" => "Llistat de colors a emprar",
"List of styles to use" => "Llista d'estils a emprar",
"Labels for the series or values in the legend" => "Etiquetes per les sèries o valors a la llegenda",
"Code snippet label" => "Etiqueta del tros de codi",
"Name of the drawing to display" => "Niom del dibuix a mostrar",
"Renders an equation written in LaTeX syntax as an image" => "Mostra com a imatge una equació escrita en sintaxi LaTeX",
"Includes the list of events from a calendar in the page" => "Inclou una llista d'esdeveniments d'un calendari a la pàgina",
"Displays a label. On click, the block of content will fade in and fade out" => "Mostra una etiqueta. En clicar-hi, el bloc de contingut es mostrarà gradualment o s'esvairà gradualment",
"One item per line starting with anything followed by \")\"" => "Un ítem per línia començant per quelcom seguit de  \")\"",
"One row per line, cells separated by ~|~" => "Una fila per línia, cel·les separades per ~|~",
"Complete URL to the movie to include" => "URL completa de la pel·lícula a incloure",
"Since your last visit.." => "Desde la teva darrera visita..",
"To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The TikiWiki Community\" target=\"_blank\">http://tikiwiki.org</a>" => "Per aprendre més, visita: <a href=\"http://tikiwiki.org\" title=\"La Comunitat TikiWiki\" target=\"_blank\">http://tikiwiki.org</a>",
"Select from available options.." => "Selecciona de la llista d'opcions disponibles..",
"Change the style used to display differences to be translated" => "Canvia l'estil emprat per mostrar les diferències que s'han de traduir",
"Switch to WYSIWYG editor" => "Canvia a editor WYSIWYG (visual)",
"Switch to normal (wiki) editor" => "Canvia a editor normal (wiki)",
"Welcome to the TikiWiki installation and upgrade script" => "Benvinguts a l'instal·lador i actualitzador de TikiWiki",
"Select your language" => "Selecciona el teu idioma",
"Please read the following license agreement" => "Si us plau, llegeix el següent acord de llicència",
"Tiki was able to send a test message to info@tikiwiki.org" => "Tiki ha pogut enviar un missatge de prova a info@tikiwiki.org",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Revisa els paràmetres del correu en l'arxiu <strong>php.ini</strong> del teu sistema (per exemple: confirma que la ruta <strong>sendmail_path</strong> és correcta)",
"Host name" => "Nom de l'hoste",
"Enter the host name or IP for your database" => "Introdueix el nom de l'hoste o IP per a la teva base de dades",
"See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"{tr}Description of available profiles" => "Mira la documentació per a la <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"{tr}Description of available profiles",
"No Internet Connection has been found" => "No s'ha trobat cap connexió a Internet",
"The default installation profile will be used" => "S'emprarà el perfil d'instal·lació per defecte",
"You can now log in into Tikiwiki as user <strong>admin</strong> and start configuring the application" => "Ara pots entrar a Tikiwiki com a usuari <strong>admin</strong> i començar a configurar l'apliacció",
"Database was left unchanged" => "S'ha deixat la base de dades sense canvis",
"Your database has been configured and Tikiwiki is ready to run" => "La teva base de dades ha estat configurada i Tikiwiki està llest per funcionar",
"TikiWiki is an opensource project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>" => "TikiWiki és un projecte de programari lliure: <em>pots</em> <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>ajuntar-te amb altres de la Comunitat</a> i ajudar  <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>a desenvolupar Tiki</a>",
"hr" => "hr",
"The text in RED is" => "El text en vermell és",
"Old:" => "Antic:",
"New:" => "Nou:",
"Show Categories" => "Mostra categories",
"Hide Categories" => "Oculta categories",
"MyTiki Home" => "Inici ElmeuTiki",
"My Files" => "Els meus arxius",
"FriendsMenu" => "MenúAmics",
"Send Pages" => "Enviar pàgines",
"Received Articles" => "Articles rebuts",
"Admin Posts" => "Administra missatges",
"Submit a New Link" => "Enviar un nou enllaç",
"Admin Directory" => "Administrar directori",
"Layer Management" => "Controlant capes",
"Ephemerides Admin" => "Administrar efemèrides",
"Charts Admin" => "Administrador de sondejos (charts)",
"Debugger console" => "Consol·la Depuradora",
"This is" => "Això és",
"by the" => "pel",
"Tiki community" => "Comunitat del Tiki",
"Copyright Management" => "Control de Copyright",
"License Page" => "Pàgina de Llicència",
"Submit Notice" => "Enviar Avis",
"Enable Feature for Wiki" => "Habilita funcions per al Wiki",
"Enable Feature for Articles" => "Habilita funcions per a articles",
"Enable Feature for Blogues" => "Habilita funcions per a blocs",
"Enable Feature for Faqs" => "Habilita funcions per a pmf",
"Right &amp; left boxes" => "Els mòduls són els Requadres a la dreta &amp; esquerra amb contingut prefabricat a dins. (No s'han de confondre amb els 'Mods' o paquets externs addicionals que es poden instal·lar com a complements al teu tiki)",
"Administer modules" => "Administra mòduls",
"Show Module Controls" => "Mostrar Controls de Mòdul",
"Users can Configure Modules" => "Els usuaris poden configurar mòduls",
"Users can Shade Modules" => "Els usuaris poden ocultar mòduls",
"module decides" => "decisió a nivell de mòdul",
"seconds (0 = cache inactive)" => "segons (0 = memòria cau inactiva)",
"Enable now." => "Habilita-ho ara.",
"bold" => "negreta",
"italic" => "cursiva",
"underline" => "subratllat",
"Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"./setup.sh\" for example)." => "Apache té el permís d'escriure al teu arbre d'arxius, el que permet la instal·lació, esborrat o actualització de paquets. Quan hagis acabat amb aquestes operacions, pensa en arreglar aquests permisos de nou a un estat segur (a travś de \"./setup.sh\" per exemple).",
"To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"./setup.sh open\" to set it up). After installation you need to remove that permission (using \"./setup.sh\")." => "Per instal·lar, eliminar o actualitar paquets necessites donar a l'usuari apache el dret per escriure arxius en el teu arbre web (pots emprar \"./setup.sh open\" per configurar-ho com es necessita). Després de la instal·lació, necessites eliminar aquests permisos (emprant \"./setup.sh\").",
"GalMenu" => "GalMenu",
"ForMenu" => "ForMenu",
"Enter a database user with administrator permission for the Database" => "Enter a database user with administrator permission for the Database",
"TikiWiki" => "TikiWiki",
"Status:" => "Estat:",
"(unchanged)" => "(sense canvis)",
"Remaining:" => "Queda:",
"you or someone registered this email address at" => "tu o alguna persona ha registrat aquesta adreça de correu-e a",
"Your Tiki information registration" => "El teu registre d'informació de Tiki",
"left/right" => "esquerra/dreta",
"Unassign module" => "Mòdul no assignat",
"home" => "inici",
"chat" => "xat",
"contact us" => "contacta'ns",
"debugger console" => "consol·la depuradora",
"MyMenu" => "Elmeumenú",
"User menu" => "Menú de l'usuari",
"WikiMenu" => "MenuWiki",
"dump" => "buidat",
"rankings" => "posicions",
"orphan pages" => "pàgines òrfenes",
"sandbox" => "llocdeproves",
"received pages" => "pàgines rebudes",
"structures" => "estructures",
"Articles Home" => "Inici dels articles",
"Send articles" => "Envia articles",
"Create/Edit Blog" => "Crea/Edita bitàcoles",
"DirMenu" => "DirMenú",
"Browse Directory" => "Explorar directori",
"FileGalMenu" => "MenuGalArx",
"Admin FAQs" => "Administrar PUFs",
"Edit mapfiles" => "edita mapa d'arxius",
"QuizMenu" => "Menú del test",
"Admin quiz" => "Administrar test",
"TrkMenu" => "MenuTrk",
"Admin trackers" => "Administra formularis",
"Send newsletters" => "Envia butlletins",
"Send events" => "Envia events",
"Admin events" => "Administra events",
"EphMenu" => "Menú d'efemèrides",
"Ephemerides" => "Efemèrides",
"ChartMenu" => "MenúdeGràfics",
"AdmMenu" => "Menúd'Adm",
"Admin home" => "Admin Inici",
"Backups" => "Còpies de seguretat",
"Edit languages" => "Edita els idiomes",
"External wikis" => "Wikis externs",
"Mods Admin" => "Administració de Mods",
"UsrMenu" => "MenúUsr",
"Click here to manage your personal menu" => "Cliqueu aquí per configurar-vos el vostre menú personal",
"Quick edit a Wiki page" => "Edició ràpida de pàgina Wiki",
"Language: " => "Idioma: ",
"Sort posts by:" => "Ordena correus per",
"read more" => "llegiu-ne més",
"For more information, please see <a href=\"{\$prefs.helpurl}Wiki Page Editor\">Wiki Page Editor</a>" => "Per més informació, si us plau consulta l'<a href=\"{\$prefs.helpurl}Wiki Page Editor\">Editor de Pàgines Wiki</a>",
"Quicktag" => "Marca ràpida",
"Use this script to install a new TikiWiki database or upgrade your existing database to release" => "Empra aquesta utilitat per instal·lar una nova base de dades de TikiWiki o actualitzar la teva base de dades existent a l'alliberament",
"For more information about TikiWiki, please visit" => "Per més informació sobre TikiWiki, si us plau visita",
"TikiWiki is software distributed under the LGPL license" => "TikiWiki és programari distribuït sota la llicència LGPL",
"Before installing TikiWiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Abans d'instal·lar TikiWiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">revisa la documentació</a> i confirma que el teu sistema compleix els requeriments mínims",
"This installer will perform some basic checks automatically" => "Aquest instal·lador realitzarà algunes comprovacions bàsiques automàticament",
"Tiki has not detected your PHP memory_limit" => "Tiki no ha detectat el teu  memory_limit de PHP",
"This probably means you have no set limit (all is well)" => "Això probablement vol dir que no tens límit específicat (tot està bé)",
"alert" => "alerta",
"Tiki has detected your PHP memory limit at" => "Tiki ha detectat que tens el limit de memòria de PHP a",
"TikiWiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "TikiWiki requireix <strong>com a mínim</strong> 32MB de memòria PHP per a executar-se correctament en totes les seves funcionalitats",
"Allocating too little memory will cause TikiWiki to display blank pages" => "Reservar massa poca memòria per cada aplicació PHP farà que TikiWiki mostri pàgines en blanc",
"To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "Per canviar el límit de memòria, empra el paràmetre  <strong>memory_limit</strong> al teu arxiu <strong>php.ini </strong> al servidor (per exemple: memory_limit = 32M) i re-inicia el servidor web",
"Tiki has detected your PHP memory_limit at" => "Tiki ha detectat el paràmetre de PHP memory_limit del teu servidor web en",
"TikiWiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "TikiWiki empra la funció <strong>mail</strong> de PHP per enviar notificacions de correu-e i missatges",
"To test your system configuration, TikiWiki will attempt to send a test message to info@tikiwiki.org" => "Per comprovar la teva configuració del sistema, TikiWiki provarà d'enviar un missatge de prova a info@tikiwiki.org",
"Tiki was not able to send a test message" => "Tiki no ha pogut enviar cap missatge de prova",
"Review your mail log for details" => "Revisa el registre del correu-e del servidor per més detalls",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Si el teu hoste requereix autenticació SMTP, pot ser necessària una mica més de configuració addicional",
"Tiki detected" => "Tiki ha detectat",
"Tiki was not able to detect the GD library" => "Tiki no ha pogut detectar la llibreria GD",
"TikiWiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "TikiWiki empra la llibreria GD per processar imatges per a la galeria d'imatges i el suport CAPTCHA",
"TikiWiki requires an active database connection" => "TikiWiki requireix una connexió activa a base de dades",
"You must create the database and user <em>before</em> completing this page" => "Has de crear la base de dades i el seu usuari <em>abans</em> de completar aquesta pàgina",
"Tiki cannot find a database connection" => "Tiki no pot trobar cap connexió amb la base de dades",
"This is normal for a new installation" => "Això és normal per a una instal·lació nova",
"Tiki found an existing database connection in your local.php file" => "Tiki ha trobat que ja existeix una connexió a base dades en el teu arxiu local.php",
"Use this page to create a new database connection" => "Empra aquesta pàgina per crear una nova connexió a base de dades",
"Enter your database connection information" => "Introdueix la informació de la teva connexió a base de dades",
"Database type" => "Tipus de Base de dades",
"Select the type of database to use with Tiki" => "Escull tipus de base de dades a emprar amb Tiki",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Empra <strong>localhost</strong> si la base de dades s'està executant a la mateixa màquina que el Tiki",
"For SQLite, enter the path and filename to your database file" => "Per a SQLite, introdueix la ruta i nom d'arxiu de la teva base de dades",
"The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "La base de dades ha d'existir. Pots crear la base de dades emprant mysqladmin, PHPMyAdmin, cPanel, o demanar-ho al proveïdor de l'hoste.  Les taules de Tiki normalment no creen cap conflicte amb altres programaris instal·lats a la mateixa base de dades",
"For Oracle" => "Per Oracle",
"Enter your TNS Name here and leave Host empty" => "Introdueix el teu nom TNS aquí i deixa l'allotjament buit",
"Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field" => "Sobreescriu tnsnames.ora , posa el teu SID aquí i introdueix el teu nomdallotjament:port al camp Allotjament",
"Select the installation" => "Selecciona la instal·lació",
"(or upgrade)" => "(o actualització)",
"script to use" => "arxiu de seqüències a emprar",
"This script will populate {if \$tikidb_created}(or upgrade){/if} the database" => "Aquesta utilitat omplirà {if \$tikidb_created}(o actualitzarà){/if} la base de dades",
"Profiles can be used to pre-configure your site with specific features and settings" => "Es pot emprar la funcionalitat 'Perfils' per pre-configurar el teu lloc amb funcionalitats i paràmetres de configuració específics",
"Visit <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> for more information" => "Visita <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> per a més informació",
"This will destroy your current database" => "Això destruirà la teva base de dades actual",
"Create a new database (clean install) with profile" => "Crea una nova base de dades (instal·lació neta) amb el perfil",
"This site has an admin account configured" => "Aquest lloc té un compte d'administrador configurat",
"Please login with your admin password to continue" => "Si us plau, connecta't amb la teva contrasenya d'administrador per continuar",
"Pass" => "Contrasenya",
"Review the" => "Revisa l'",
"Your database has been configured and Tikiwiki is ready to run!" => "La teva base de dades ha estat configurada i Tikiwiki està llest per funcionar!",
"operations executed successfully" => "operacions executades amb èxit",
"SQL queries" => "Consultes SQL",
"Operations failed" => "Operacions que no han tingut èxit",
"Display details" => "Mostra detalls",
"Go back and run another install/upgrade script" => "Torna enrera i executa una altra seqüència d'instal·lació / actualització",
"To secure your TikiWiki installation - and if you are using Apache web server - you should rename the <span style=\"font-weight: bold\">_htaccess</span> file to <span style=\"font-weight: bold\">.htaccess</span> (this file is in the main directory)" => "Per a fer més segura a teva instal·lació de TikiWiki - i si empres el servidor web Apache - hauries de reanomenar l'arxiu <span style=\"font-weight: bold\">_htaccess</span> a <span style=\"font-weight: bold\">.htaccess</span> (aquest arxiu es troba al directori principal)",
"Complete these fields to configure common, general settings for your site" => "Completa aquests camps per configurar paràmetres comuns i generals del teu lloc",
"The information you enter here can be changed later" => "La informació que introdueixis aquí la podràs canviar més endavant",
"Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Consulta la <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentació</a> per informació completa sobre aquests i altres paràmetres de configuració",
"This will appear in the browser title bar" => "Això apareixerà en la barra de títol del navegador",
"Email sent by your site will use this address" => "Els correus-e enviats pel teu lloc empraran aquesta adreça de sortida",
"HTTPS login" => "Connexió segura HTTPS",
"Admin email" => "Correu-e de l'admin",
"This is the email address for your administrator account" => "Aquesta és l'adreça de correu-e del teu compte d'administrador/a",
"Enter Your TikiWiki" => "Entra al teu TikiWiki",
"The installation is complete" => "S'ha acabat el procés d'instal·lació",
"If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "Si aquesta és una instal·lació inicial, ves a <strong>tiki-admin.php</strong> després de connectar-te per tal de començar a configurar la teva nova instal·lació Tiki",
"Enter TikiWiki and Lock Installer" => "Entra a TikiWiki i bloqueja l'Instal·lador",
"Enter TikiWiki Without Locking Installer" => "Entra a TikiWiki SENSE Bloquejar l'Instal·lador",
"To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "Per afegir un nou allotjament virtual executa l'arxiu setup.sh amb el nom del domini del nou allotjament com a últim paràmetre",
"Are you upgrading an existing Tiki site" => "Estàs actualitzant un lloc Tiki existent",
"Go directly to the <strong>Install/Upgrade Profile</strong> step" => "Ves directament al pas <strong>Perfil d'Instal·lació / Actualització</strong>",
"Restart the installer" => "Reinicia l'instal·lador",
"Reset the" => "Reconfigura el/la",
"Install/Upgrade Profile" => "Instal·lació / Actualització de Perfils",
"TikiWiki Web Site" => "Lloc Web TikiWiki",
"The following error message was returned" => "S'ha retornat el següent missatge d'error",
"Things to check" => "Coses a comprovar",
"This is an approximation based on your server memory limit" => "Això és una aproximació basada en el limit de memòria del teu servidor",
"Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "La teva base de dades requereix una actualització per coincidir amb la versió actual de Tikiwiki. Si us plau, dirigeix-te a <a href=\"tiki-install.php\">l'instal·lador</a>. Emprar Tiki amb una versió de base de dades normalment provoca errors",
"Displays various information about the client" => "Mostra informació variada sobre el navegador del visitant",
"Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Crea un enllaç a una àncora dins d'una pàgina. Es poden crear àncores emprant el connector ANAME",
"Anchor link label" => "Etiqueta de l'àncora",
"The anchor name as defined in the ANAME plugin" => "El nom de l'àncora tal i com es defineix en el connector ANAME",
"The name of the wiki page containing the anchor" => "El nom de la pàgina Wiki que conté l'àncora",
"Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserta una àncora a la pàgina Wiki. Es pot enllaçar a àncores emprant el connector ALINK",
"The name of the anchor" => "El nom de l'àncora",
"Autogenerated content. Leave blank initially" => "Contingut autogenerat. Deixa inicialment en blanc",
"Absolute URL to the image or relative path from tikiwiki root" => "URL absoluta a la imatge o ruta relativa de de l'arrel de Tikiwiki",
"Includes an article\\'s content within the page" => "Inclou el contingut d'un article dins de la pàgina",
"The article field to display. Default field is Heading" => "El camp de l'article a mostrar. El camp per omissió és la Capçalera",
"The article to display. If no value is provided, most recent article will be used" => "Article a mostrar. Si no es dóna cap valor, s'emprarà l'article més recent",
"Includes a list of articles within the page" => "Inclou una llista d'articles dins de la pàgina",
"The amount of articles to display in the list" => "La llista d'articles a mostrar de la llista",
"The ID of the category to list from" => "L'ID de la categoria des de la qual llistar el seu contingut",
"The article language to list" => "L'idioma de l'article a llistar",
"The column and order of the sort in columnName_asc or columnName_desc format" => "La columna a ordenar i tipus d'ordenació, de forma similar a NomDeColumna_asc o NomDeColumna_desc",
"Whether to not report when there are no articles" => "Si no s'ha d'informar quan ni hi hagin articles",
"Whether to only show the title of the articles" => "Si només s'ha de mostrar el títol dels articles",
"The wiki page the avatar will link to" => "La pàgina wiki a la que apuntarà l'avatar",
"List all pages linking to the specified page" => "Llista totes les pàgines que enllaçen a la pàgina especificada",
"The page links will point to. Default value is the current page" => "A on apuntaran els enllaços de la pàgina. El valor per omissió és a la mateixa pàgina",
"Use BLOGLIST to include posts from a blog" => "Empra BLOGLIST per incloure publicacions des d'una bitàcola",
"Maximum amount of entries to list" => "Número màxim d'entrades a llistar",
"As defined by CSS, name or Hex code" => "Tal i com es defineix pel CSS, nom o codi Hex",
"In pixels or percentage. Default value is 100%" => "En pixels o percentatge. El valor per omissió és 100%",
"for box with width lesser than 100%, make text wrap around the box" => "per a caixes amb amplada inferior al 100%, fes que el text envolti la caixa",
"Apply custom CSS class to the box" => "Aplica classe CSS particular a la caixa",
"List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "Llista d'IDs de categories separades per signes +. exemple: 1+2+3. Per omissió s'empra la categoria de la pàgina actual",
"String used to separate the categories in the path. Default character is >" => "Cadena emprada per separar les categories en la ruta. El caràcter per omissió és >",
"Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Ombrejat de sintaxi a emprar. Pot ser que no es pugui emprar amb números de línia. Disponible: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
"0|1, may not be used with colors" => "0|1, és possible que no es pugui emprar amb colors",
"0|1, parse wiki syntax within the code snippet" => "0|1, interpreta la sintaxi wiki dins del connector de codi",
"Includes content from the dynamic content system" => "Inclou contingut des del sistema de contingut dinàmic",
"Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Forma de mostrar el copyright a dins. Pot contenir ~title~ (títol), ~year~ (any) i ~authors~ (autors)",
"Displays a countdown from now until the specified date" => "Mostra un compte enrera des d'ara i fins la data especificada",
"Text to append to the countdown" => "Text a afegir al compte enrera",
"Target date. Multiple formats accepted" => "Data objectiu. S'accepten múltiples formats",
"The name of a DSN connection defined by the Wiki administrator" => "El nom d'una connexió a DSN definida per l'administrador del Wiki",
"0|1, parse wiki syntax within the report" => "0|1, interpreta la sintaxi wiki amb l'informe",
"0|1, display the parsed report definition" => "0|1, mostra la definició de l'informe interpretat",
"No DSN connection string found" => "No s'ha trobat text de connexió al DSN",
"left|right, for box with width lesser than 100%, make text wrap around the box" => "left|right, per a caixes amb amplada inferior al 100%, fes que el text envolti a la caixa",
"Welcome to the Tiki installation and upgrade script" => "Benvinguts/des a l'Instal·lador i actualitzador de Tiki",
"Tiki is software distributed under the LGPL license" => "Tiki és programari distribuït sota la llicència LGPL",
"Before installing Tiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Abans d'instal·lar Tiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">revisa la documentació</a> i confirma que el teu sistema té els requeriments mínims necessaris",
"Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requereix <strong>al menys</strong> 32MB de memòria PHP per a les execucions d'arxius php",
"Allocating too little memory will cause Tiki to display blank pages" => "Permetre massa poca memòria provocarà que Tiki mostri pàgines en blanc en algunes funcionalitats",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki empra la funció PHP <strong>mail</strong> per enviar notificacions per correu-e i missatges",
"To test your system configuration, Tiki will attempt to send a test message to info@tikiwiki.org" => "Per provar la teva configuració, Tiki provarà d'enviar un misatge de prova a info@tikiwiki.org",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki empra la llibreria GD per processar imatges a les galeries d'imatges i per al suport al CAPTCHA (imatges de verificació anti-robots)",
"Tiki requires an active database connection" => "Tiki requireix una connexió activa a base de dades",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" title=\"manual installation\">manual installation process</a>" => "Empra aquesta pàgina per crear una nova connexió a base de dades, o empra el <a href=\"http://doc.tikiwiki.org/Manual+Installation\" title=\"manual installation\">procés d'instal·lació manual</a>",
"Select the installation (or upgrade) profile to use. This profile will populate (or upgrade) the database" => "Selecciona el perfil que vols emprar d'instal·lació (o actualització). Aquest perfil s'instal·larà a (o actualitzarà) la base de dades",
"Select the installation profile to use. This profile will populate the database" => "Selecciona el perfil d'instal·lació que vols emprar. Aquest perfil s'instal·larà a la base de dades",
"See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles" => "Mira la documentació per a les <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Descripció de perfils disponibles.\">descripcions dels perfils disponibles",
"The installer could not connect to the Profiles repository" => "L'instal·lador no s'ha pogut connectar al dipòsit de Perfils",
"Your database has been configured and Tiki is ready to run" => "La teva base de dades ha estat configurada i Tiki està llest per funcionar",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Ara pots connectar-te al teu Tiki com a usuari <strong>admin</strong> i començar a configurar l'aplicació",
"Upgrade operations executed successfully" => "Operacions d'actualització executades amb èxit",
"Installation operations executed successfully" => "Operacions d'instal·lació executades amb èxit",
"To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "Per habilitar aquest arxiu, simplement reanomena l'arxiu <strong>_htaccess</strong> (que es troba al directori principal de la teva instal·lació de Tiki) a <strong>.htaccess</strong>",
"Tiki is an opensource project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki és un projecte de programari lliure, pel que <em>pots</em> <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>ajuntar-te amb la resta de la comunitat</a> i ajudar <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>a desenvolupar i documentar Tiki</a>",
"Adding a new host" => "Afegint un nou hoste",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Ves directament al pas d'<strong>Instal·lació / Actualització</strong> ",
"The cache is used by" => "La memòria cau és emprada per",
"You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "També pots emprar {literal}{content label=x}{/literal}, on x és l'etiqueta del bloc de contingut",
"Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Manca una dependència. Pots obtenir l'arxiu' <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> i pujar-lo a dins de la carpeta files/ al servidor",
"Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>" => "Els \"mods\" de Tiki són funcionalitats adicionals no incloses en l'alliberament public de Tiki. Aprèn més a <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>",
"Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache té permís per escriure en el teu arbre d'arxius, el que permet la instal·lació, esborrat o actualització de paquets. Quan hagis acabat amb aquestes operacions, pensa en tornar a deixar els permissos en un estat segur (emprant \"sh setup.sh\" per exemple)",
"To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "Per instal·lar, eliminar o actualitzar paquets necessites donar-li a l'usuari apache el dret a escriure arxius en el teu arbre de directoris (pots fer-ho emprant \"sh setup.sh open\" per configurar-ho així temporalment). Després de la instal·lació necessites eliminar aquests permisos (emprant \"sh setup.sh\")",
"No mods found" => "No s'han trobat mods",
"Object Watches" => "Subscripcions a l'objecte",
"Watching Groups" => "Grups subscrits",
"After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "Després de la validació dels arguments per un editor, es va denegar l'execució del connector. Aquesta ús del connector serà eventualment eliminat o corregit",
"This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "Aquest ús del connector ha estat afegit o midificat recentment. Fins que un edior del lloc en validi els paràmetres, la seva execució no és possible",
"You are allowed to" => "T'està permés de",
"This plugin does not contain any arguments" => "Aquest connector no conté arguments",
"This plugin's body is empty" => "El cos del connector és buit",
"Items found" => "Ítems trobats",
"Plugins pending validation are added to this list the first time they are encountered. Only their <em>signature</em> is preserved. Some of the plugins listed here may no longer be in use in the page originally using them. In this case, it's safe to clear them from this list. They will be added back next time they are encountered. Plugins can be approved or rejected from the page containing them" => "S'afegeixen a aquesta llista els usos de connectors que requereixen validació la primera vegada que es troben. Només es preserva la seva <em>signatura</em>. Alguns dels connectors mostrats aquí poden no trobar-se en ús a la pàgina original que els emprava. En aquest cas, és segur netejar-los d'aquesta llista. Seran afegits automàticament la propera vegada que siguin trobats. Es pot aprovar o denegar l'ús dels connectors des de la pàgina que els conté",
"No plugin pending approval" => "No hi ha cap ús de connectors esperant aprovació",
"Not your password" => "No la teva contrasenya",
"Generate a\tpassword" => "Genera una \tcontrasenya",
"Enter your username or email" => "Introdueix el teu nom d'usuari o correu-e",
"Enter your email" => "Introdueix el teu correu-e",
"A leading plus sign indicates that this word must be present in every object returned" => "Un signe més al davant indica que aquesta paraula ha de ser present en cada objecte retornat",
"A leading minus sign indicates that this word must not be present in any row returned" => "Un signe menys al davant indica que aquesta paraula no ha de ser present en cap fila retornada",
"By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher" => "Per omissió (quan no s'especifiqui ni signe més ni signe menys) la paraula és opcional, però l'objecte que la la contingui serà puntuat més a munt",
"These two operators are used to change a word's contribution to the relevance value that is assigned to a row" => "Aquests dos operadors s'empren per canviar la contribució de cada paraula al valor de rellevància que s'assigna a cada fila",
"Parentheses are used to group words into subexpressions" => "Els parèntesis s'empren per agrupar paraules en subexpressions",
"A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator" => "Una tilde per davant actua d'operador de negació, causant que la contribució de la paraula a la rellevància de l'objecte sigui negativa. És útil per indicar paraules que només generen soroll. Un operador que conté aquesta paraula serà marcat més baix que els altres, però no serà exclòs, com ho faria si s'emprès l'operador - ",
"An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended" => "Un asterisc és l'operador de truncat. A diferència dels altres operadors, hauria de ser afegit al final de la paraula, i no al principi",
"The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed" => "La frase, que sigui envoltada per cometes dobles &quot;, troba només objectes que continguin aquesta frase literalment, tal qual s'ha escrit",
"Advanced search" => "Cerca advançada",
"Date Search" => "Cerca per dates",
"System Admin" => "Admin Sistema (cau)",
"PHP version" => "Versió de PHP",
"Server" => "Servidor",
"0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Activa en trencament automàtic de línies en el codi per evitar trencat la disposició en pantalla",
"One entry per line. Each line is in \"Term: Definition\" format" => "Una entrada per línia. Cada línia és en el format \"Terme: Definició\"",
"Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Percentatge d'increment respecte la mida normal. 100 produeix la mida normal. 200 produeix una imatge el doble de gran",
"Wiki syntax containing the text to display" => "Sintaxi wiki que conté el text a mostrar",
"Heading row of the table, same format as the body section" => "Fila de la Capçalera de la taula, en el mateix format que la secció del cos",
"CSS Class to apply on the heading row" => "Classe CSS a aplicar a la fila de la capçalera",
"Displays a file attachment or a list of them" => "Mostra un arxiu adjunt o una llista d'ells",
"List files in a file gallery (with a category) or in a category or a file gallery od this category" => "Llista els arxius en una galeria d'arxius (amb una categoria) o en una categoria o una galeria d'arxius d'aquesta categoria",
"Displays a list of files" => "Mostra una llista d'arxius",
"Download box for a file on ftp server" => "Requadre de descàrrega per a un arxiu a un servidor ftp",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Per tal de provar la configuració del teu sistema, Tiki provarà d'enviar-te un missatge de correu-e de prova",
"Test email" => "Test email",
"Email address to send test to" => "Adreça de correu-e a on enviar el correu-e de prova",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Empra aquesta pàgina per crear una nova connexió a base de dades, o empra el <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">procés d'instal·lació manual</a>",
"Misc" => "Misc",
"Displays an miniquiz" => "Mostra un miniqüestionari",
"Plugin Help" => "Ajuda per als Connectors (Plugins)",
"underscores" => "guions baixos",
"colons" => "dos punts",
"some text" => "algun text ",
"equals" => "igual",
"One carat" => "Un carat",
"Creates a box with the data" => "Crea una caixa amb les dades",
"creates a title bar" => "crea una barra de títol",
"make headings" => "fes estils de títol",
"make autonumbered headings" => "fa estils de títol autonumerats",
"creates a table" => "crea una taula",
"makes a horizontal rule" => "fa una línia horitzontal",
"page|desc" => "pàg|desc",
"displays an image" => "mostra una imatge",
"imalign, height, width, desc, link, rel, title, usemap, class and align are optional" => "imalign, height, width, desc, link, rel, title, usemap, class i align són opcionals",
"Non cacheable images" => "Imatges sense memòria cau",
"height width desc link and align are optional" => "height width desc link i align són opcionals",
"Wiki File Attachments" => "Arxius adjunts del Wiki",
"Creates a link to the named file.  If page is not given, the file must be attached to the current page.  If desc is not given, the file name is used for the link text, unless showdesc is used, which makes the file description be used for the link text.  If image=1 is given, the attachment is treated as an image and is displayed directly on the page; no link is generated." => "Crea un enllaç a l'anomenat arxiu.  Si no es dóna la pàgina, l'arxiu ha de ser adjuntat a la pàgina actual.  Si no es dóna desc, s'empra el nom de l'arxiu per al text de l'enllaç, a menys que s'empri showdesc, que fa que s'empri la descripció de l'arxiu per al text de l'enllaç. Si es dóna image=1, l'adjunt és tractat com una imatge i mostrada directament a la pàgina; no es genera cap enllaç.",
"displays rss feed with id=n maximum=m items" => "mostra l'alimentació per rss amb id=n, essent n nombre màxim dóelements",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Serà substituït pel valor del bloc de contingut dinàamb id=n",
"\"~pp~ data ~/pp~\" Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  \"~pre~ data ~/pre~\" also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "\"~pp~ dades ~/pp~\" Mostra text/codi preformatat; no es processa la sintaxi wiki dins d'aquestes seccions (com amb np), i l'espaiat és fixe (no es fa ajustat d'amplada de frases).  \"~pre~ dades ~/pre~\" també mostra text preformatat amb espaiat fixe, però es processa el format Wiki de dins del text.",
"\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" escriuen una taula de continguts per a la pàgina en qüestió basades en estructures (toc) o ! capçaleres-estils de títol de qualsevol ordre (maketoc)",
"Update '{\$page}' based on '{\$source_page}'" => "Actualitza '{\$page}' basant-te en '{\$source_page}'",
"Customer Extranet" => "Extranet de Client",
"weeks" => "setmanes",
"Tiki \"mods\" are undergoing refubishment." => "Els \"mods\" de Tiki estan en procés de reformes.",
"You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "Probablement trobaràs que alguns mods mostrats com a compatibles amb versions antigues de Tiki fruncionaran amb versions posteriors de Tiki amb poques o cap modificació",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Si vols actualitzar des d'una versió prèvia de Tiki, assegura't d'haver llegit i entès les <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">instruccions d'Actualització</a>",
"Label displayed on the left side of the gauge" => "l'Etiqueta mostrada a l'esquerra de la barra de nivell",
"Bar width in pixels" => "Amplada de la barra en píxels",
"Width in pixels allocated to the label" => "Amplada en píxels destinada a l'etiqueta",
"true|false, if true then a percentage of the maximum is displayed" => "cert|fals, si és cert llavors es mostra un percentatge del màxim",
"true|false, if the numeric value is displayed" => "cert|fals, si el valor numèric és mostrat",
"Bar height in pixels" => "Alçada de la barra en píxels",
"Add the tracking code for Google Analytics" => "Afegir el codi de rastreig per a l'Analítica de Google",
"The account number for the site" => "El número de compte pel lloc",
"Leave this empty" => "Deixar això buit",
"Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Mida del marc, usa-ho en comptes d'amplada i alçada, faran servir exactament les mides de les presentacions de Google. Pot ser  petit|mig|gran",
"Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Text Wiki a mostrar si es compleixen les condicions. El cos pot contenir {ELSE}. El text de després del marcador serà mostrat als usuaris que no compleixin la condició",
"0|1, parse wiki syntax within the html code" => "0|1, interpreta la sintaxi wiki dins del html codi",
"Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "ID Numèric d'una imatge en una Galeria d'Arxius (o llista separada per comes). \"fileId\", \"id\" o \"src\" requerits",
"Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "ID Numèric d'una imatge en una Galeria d'Imatges (o llista separada per comes). \"fileId\", \"id\" o \"src\" requerits",
"Full URL to the image to display. \"fileId\", \"id\" or \"src\" required" => "URL sencera a la imatge a mostrar. \"fileId\", \"id\" o \"src\" requerits",
"0" => "The SandBox is a page where you can practice your editing skills, use the preview featureto preview the gina, no es guarden versions d'aquesta pàgina",
"Ex" => "Ex",
"Delete events older than" => "Esborra esdeveniments més antics de",
"If no role is provided, default role will be \"Chair participant\"" => "Si no es proveeix cap rol, el rol per omissió serà \"Participant ras\"",
"No articles yet" => "Cap article encara",
"Focus:" => "Focus:",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nova entrada a la bitàcola: {\$mail_title}, \"{\$mail_post_title}\", per {\$mail_user} a {\$mail_date|tiki_short_datetime}",
"Watch" => "Subscriu-te",
"Click to Navigate" => "Fes clic per navegar",
"You are alerted of a changement on " => "Està alertat de canvis sobre ",
"Tiki User Account Activated" => "Compte d'usuari Tiki activat",
"Tiki User Registration Request" => "Petició de Registre d'Usuari",
"Tiki email notification" => "Notificació de correu-e del Tiki",
"Your Tiki account information for %s" => "La informació del teu compte Tiki per %s",
"Reg users can change theme" => " Els usuaris registrats poden canviar el tema",
"Create/Edit Newsletters" => "Crea/edita butlletins",
"Creates an indentation for each plus(useful in list to continue at the same level)" => "Crea un sagnat de text per a cada més (útil en llistes per continuar amb la numeració més avall)",
"Last seen in wiki page <a href=\"%0\">%1</a>" => "La darrera vegada s'ha 'vist en la pàgina wiki <a href=\"%0\">%1</a>",
"Seen in unknown object" => "Vist en objecte desconegut",
"Clear checked items" => "Neteja els ítems marcats",
"Tiki Shoutbox" => "Quadre d'avisos del Tiki",
"Subcategories" => "Subcategories",
"Allow sites in this category" => "Permetre webs en aquesta categoria",
"Show number of sites in this category" => "Mostrar nombre de llocs dins aquesta categoria",
"Admin related categories" => "Administració de categories relacionades",
"Add a Category" => "Afegeix una categoria",
"in current category" => "a la categoria actual",
"Total categories" => "Categories totals",
"New article post" => "Nou publicació d'article",
"Days online" => "Díes en línia",
"Edit Section:" => "Edita la secció",
"View object" => "Mostra l'objecte",
"Not enable for this type of object" => "No està habilitat per aquest tipus d'objecte",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "Aland_Islands" => "Aland_Islands",
// "American_Samoa" => "American_Samoa",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Bouvet_Island" => "Bouvet_Island",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
// "Burkina_Faso" => "Burkina_Faso",
// "Cape_Verde" => "Cape_Verde",
// "Catalan_Countries" => "Catalan_Countries",
// "Cayman_Islands" => "Cayman_Islands",
// "Central_African_Republic" => "Central_African_Republic",
// "Christmas_Island" => "Christmas_Island",
// "Cocos_Islands" => "Cocos_Islands",
// "Congo_Democratic" => "Congo_Democratic",
// "Cook_Islands" => "Cook_Islands",
// "Costa_Rica" => "Costa_Rica",
// "Czech_Republic" => "Czech_Republic",
// "Dominican_Republic" => "Dominican_Republic",
// "El_Salvador" => "El_Salvador",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe_Islands" => "Faroe_Islands",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
// "Hong_Kong" => "Hong_Kong",
// "Ivory_Coast" => "Ivory_Coast",
// "Marshall_Islands" => "Marshall_Islands",
// "Netherlands_Antilles" => "Netherlands_Antilles",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
// "Norfolk_Island" => "Norfolk_Island",
// "North_Korea" => "North_Korea",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
// "Papua_New_Guinea" => "Papua_New_Guinea",
// "Puerto_Rico" => "Puerto_Rico",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Russian_Federation" => "Russian_Federation",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
// "San_Marino" => "San_Marino",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Sierra_Leone" => "Sierra_Leone",
// "Solomon_Islands" => "Solomon_Islands",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
// "Sri_Lanka" => "Sri_Lanka",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Trinidad_Tobago" => "Trinidad_Tobago",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
// "Viet_Nam" => "Viet_Nam",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western_Sahara" => "Western_Sahara",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "Slovene" => "Slovene",
// "\$feature set to \" . \$featureStr));\n\t\t\t\t} else {\n\t\t\t\t\t\$tikilib->set_preference(\$feature, \$_POST[\$feature]);\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to \" . \$featureStr));\n\t\t\t\t}\n\t\t\t} else if( \$isMultiple ) {\n\n\n\t\t\t\tif ( \$pref != '' ) {\n\t\t\t\t\t\$tikilib->set_preference(\$pref, array());\n\t\t\t\t\t\$prefs[\$feature] = \$_POST[\$feature];\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to nothing" => "\$feature set to \" . \$featureStr));\n\t\t\t\t} else {\n\t\t\t\t\t\$tikilib->set_preference(\$feature, \$_POST[\$feature]);\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to \" . \$featureStr));\n\t\t\t\t}\n\t\t\t} else if( \$isMultiple ) {\n\n\n\t\t\t\tif ( \$pref != '' ) {\n\t\t\t\t\t\$tikilib->set_preference(\$pref, array());\n\t\t\t\t\t\$prefs[\$feature] = \$_POST[\$feature];\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to nothing",
// "All Day" => "All Day",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>quicktags,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[quicktags]</strong> enables quicktags if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>quicktags,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[quicktags]</strong> enables quicktags if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "ip selector" => "ip selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example: \n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example: \n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its name (n), or display the username of the uploader (u);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its name (n), or display the username of the uploader (u);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "Info required - IP|SVRSW|BROWSER" => "Info required - IP|SVRSW|BROWSER",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Show body" => "Show body",
// "Whether to only show the body of the articles or just the heading" => "Whether to only show the body of the articles or just the heading",
// "Starting article" => "Starting article",
// "The article number that the list should start with" => "The article number that the list should start with",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings" => "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "Maximum number of entries to list" => "Maximum number of entries to list",
// "Simple list" => "Simple list",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "Latest date to select posts from" => "Latest date to select posts from",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "div|span|pre|b|i|tt|p|blockquote" => "div|span|pre|b|i|tt|p|blockquote",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML id" => "HTML id",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "Displays a link to an attachment to a wiki page and can display an image attachment. " => "Displays a link to an attachment to a wiki page and can display an image attachment. ",
// "Displays a list of files from the File Gallery" => "Displays a list of files from the File Gallery",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "CheckDuplicate" => "CheckDuplicate",
// "check for duplcate footnotes" => "check for duplcate footnotes",
// "Frame title" => "Frame title",
// "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded" => "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded",
// "Alias: lnk. Location the image should point to" => "Alias: lnk. Location the image should point to",
// "Link Relation" => "Link Relation",
// "\"rel\" attribute to add to the link" => "\"rel\" attribute to add to the link",
// "Link title" => "Link title",
// "Title text" => "Title text",
// "Image alt text" => "Image alt text",
// "Alternate text to display if impossible to load the image" => "Alternate text to display if impossible to load the image",
// "Alias:imalign. Image alignment in the page. (left, right)" => "Alias:imalign. Image alignment in the page. (left, right)",
// "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)" => "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)",
// "Image description to display on the page" => "Image description to display on the page",
// "Image Map" => "Image Map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)" => "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)",
// "CSS Style" => "CSS Style",
// "CSS styling to apply to the plugin. (Usually used in configuration rather than on individual images.)" => "CSS styling to apply to the plugin. (Usually used in configuration rather than on individual images.)",
// "Border options" => "Border options",
// "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options" => "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options",
// "Description options" => "Description options",
// "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)" => "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)",
// "Default configuration" => "Default configuration",
// "Default configuration definitions. (Usually used in configuration rather than on individual images.)" => "Default configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Mandatory configuration" => "Mandatory configuration",
// "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)" => "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content" => "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content",
// "Display an image" => "Display an image",
// "Displays an image" => "Displays an image",
// "Full URL to the image to display" => "Full URL to the image to display",
// "Alternate Text" => "Alternate Text",
// "Height of the image to display" => "Height of the image to display",
// "Width of the image to display" => "Width of the image to display",
// "Link Title" => "Link Title",
// "Image alignment in the page. (left, right, center) Uses HTML IMG tag" => "Image alignment in the page. (left, right, center) Uses HTML IMG tag",
// "Float Alignment" => "Float Alignment",
// "Image alignment in the flow of the document. (left, right, none) Uses CSS float property" => "Image alignment in the flow of the document. (left, right, none) Uses CSS float property",
// "Style to apply to the image" => "Style to apply to the image",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Page Name" => "Page Name",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Jabber" => "Jabber",
// "Applet height in pixels" => "Applet height in pixels",
// "'),\n\t\t\t\t'description' => tra('Applet width in pixels" => "'),\n\t\t\t\t'description' => tra('Applet width in pixels",
// "'),\n\t\t\t\t'description' => tra('jabber.org" => "'),\n\t\t\t\t'description' => tra('jabber.org",
// "Default Color" => "Default Color",
// "255,255,255" => "255,255,255",
// "JQuery" => "JQuery",
// "Insert JQuery javascript code. Requires feature_jquery" => "Insert JQuery javascript code. Requires feature_jquery",
// " (experimental - may change in future versions)" => " (experimental - may change in future versions)",
// "JQuery Code" => "JQuery Code",
// "NotOnReady" => "NotOnReady",
// "NoJQuery" => "NoJQuery",
// "Optional markup for when feature_jquery is off" => "Optional markup for when feature_jquery is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$jq(\"img\\" => "jquery code e.g. \$jq(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Result Count" => "Result Count",
// "Amount of results displayed in the list" => "Amount of results displayed in the list",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Structure Head" => "Structure Head",
// "Show Page Alias" => "Show Page Alias",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Exact Match" => "Exact Match",
// "Related to Find" => "Related to Find",
// "Only Orphan Pages" => "Only Orphan Pages",
// "For List Pages" => "For List Pages",
// "List Directory" => "List Directory",
// "Full path to the server-local directory" => "Full path to the server-local directory",
// "URL Prefix" => "URL Prefix",
// ".ext" => ".ext",
// "Limit" => "Limit",
// "Maximum amount of files to display" => "Maximum amount of files to display",
// "Map File" => "Map File",
// "Extents" => "Extents",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "One of" => "One of",
// "Mini Quiz" => "Mini Quiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Tracker ID" => "Tracker ID",
// "Insert Module" => "Insert Module",
// "Module name as known in Tikiwiki" => "Module name as known in Tikiwiki",
// "Decoration" => "Decoration",
// "Flip" => "Flip",
// "Max" => "Max",
// "np" => "np",
// "notitle" => "notitle",
// "Displays a module inlined in page. More parameters can be added, not supported by UI" => "Displays a module inlined in page. More parameters can be added, not supported by UI",
// "Monospace" => "Monospace",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Mouse Over" => "Mouse Over",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when moused-over text is clicked. Use http:// for external links" => "Destination link when moused-over text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouse over box width. Default: 400px" => "Mouse over box width. Default: 400px",
// "Mouse over box height. Default: 200px" => "Mouse over box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified amount of pixels in relation to the cursor. Default: 5px" => "Shifts the overlay to the right by the specified amount of pixels in relation to the cursor. Default: 5px",
// "Offset Y" => "Offset Y",
// "Shifts the overlay to the bottom by the specified amount of pixels in relation to the cursor. Default: 0px" => "Shifts the overlay to the bottom by the specified amount of pixels in relation to the cursor. Default: 0px",
// "Parse Body" => "Parse Body",
// "y|n, parse the body of the plugin as wiki content. (Default to y)" => "y|n, parse the body of the plugin as wiki content. (Default to y)",
// "Color of the inside popup" => "Color of the inside popup",
// "Default: #F5F5F5" => "Default: #F5F5F5",
// "Text popup color" => "Text popup color",
// "#FFFFFF" => "#FFFFFF",
// "Padding" => "Padding",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "fancy" => "fancy",
// "true|false" => "true|false",
// "wiki_classes" => "wiki_classes",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "Displays a table using MediaWiki syntax" => "Displays a table using MediaWiki syntax",
// "MySpace" => "MySpace",
// "MySpace Page" => "MySpace Page",
// "Object Hits" => "Object Hits",
// "Object ID" => "Object ID",
// "Object Type" => "Object Type",
// "Search for images uploaded by users" => "Search for images uploaded by users",
// " (deprecated - scheduled to be removed or changed significantly)" => " (deprecated - scheduled to be removed or changed significantly)",
// "Filename or full path to file" => "Filename or full path to file",
// "Plugin Manager" => "Plugin Manager",
// "Multiple values separated with | can be used" => "Multiple values separated with | can be used",
// "Poll ID" => "Poll ID",
// "Profile Installer" => "Profile Installer",
// "Adds controls required to install a profile" => "Adds controls required to install a profile",
// "Domain" => "Domain",
// "Profile repository domain. Default value is profiles.tikiwiki.org" => "Profile repository domain. Default value is profiles.tikiwiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile" => "Name of the profile",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes casted. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes casted. One vote per line. Either 0, +1 or -1 followed by a username",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Displays a proposal acceptance widget" => "Displays a proposal acceptance widget",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Quote" => "Quote",
// "Quoted text" => "Quoted text",
// "Reply to" => "Reply to",
// "Name of the quoted person" => "Name of the quoted person",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Includes random content from the dynamic content system" => "Includes random content from the dynamic content system",
// "Redirect" => "Redirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Regular Expression" => "Regular Expression",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Page name containing the regular expression" => "Page name containing the regular expression",
// "Remarks Box" => "Remarks Box",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Icon ID" => "Icon ID",
// "RSS Feed" => "RSS Feed",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Amount of results displayed" => "Amount of results displayed",
// "SourceForge" => "SourceForge",
// "aid?" => "aid?",
// "adit?" => "adit?",
// "groupid?" => "groupid?",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "sharethis" => "sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send services" => "Send services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "First post services shown" => "First post services shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Rotate image" => "Rotate image",
// "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Button text" => "Button text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header title" => "Header title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header background" => "Header background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header text color" => "Header text color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded elements" => "Embedded elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Sheet" => "Sheet",
// "Displays the content of a spreadsheet in the page" => "Displays the content of a spreadsheet in the page",
// "Internal ID of the TikiSheet" => "Internal ID of the TikiSheet",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Create new sheet" => "Create new sheet",
// "Show Pages" => "Show Pages",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "name|desc" => "name|desc",
// "Skype" => "Skype",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Snarf" => "Snarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "PCRE compliant regular expression" => "PCRE compliant regular expression",
// "Regular Expression Part" => "Regular Expression Part",
// "ex: \$1" => "ex: \$1",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "asc|desc|shuffle" => "asc|desc|shuffle",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute on the columns" => "Generate the width attribute on the columns",
// "Column Size" => "Column Size",
// "Editable" => "Editable",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom class" => "Custom class",
// "add a class to customize the design" => "add a class to customize the design",
// "SQL" => "SQL",
// "DNS Name" => "DNS Name",
// "ADODB DNS" => "ADODB DNS",
// "Subscript" => "Subscript",
// "Subscribe Group" => "Subscribe Group",
// "Group Name" => "Group Name",
// "As known in Tikiwiki" => "As known in Tikiwiki",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "Colon separated list of groups" => "Colon separated list of groups",
// "Superscript" => "Superscript",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Displays a survey" => "Displays a survey",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "Equivalent of the style attribute on the HTML tag" => "Equivalent of the style attribute on the HTML tag",
// "File ID from the file gallery" => "File ID from the file gallery",
// "Image ID from the image gallery" => "Image ID from the image gallery",
// "URL to the image" => "URL to the image",
// "Maximum Size" => "Maximum Size",
// "Maximum width or height for the image" => "Maximum width or height for the image",
// "Floating" => "Floating",
// "Link target of the image" => "Link target of the image",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "No image specified" => "No image specified",
// "Title Search" => "Title Search",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "hits|user" => "hits|user",
// "Exclude" => "Exclude",
// "Pipe separated list of page names to exclude from results" => "Pipe separated list of page names to exclude from results",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum amount of levels to display. On very large structures, this should be limited" => "Maximum amount of levels to display. On very large structures, this should be limited",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "asc|desc" => "asc|desc",
// "Show Description" => "Show Description",
// "0|1, show the page description instead of the page name" => "0|1, show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "0|1, display the section numbers or not" => "0|1, display the section numbers or not",
// "plain|fancy" => "plain|fancy",
// "Top Friends" => "Top Friends",
// "Maximum result count" => "Maximum result count",
// "Translate a string using Tikiwiki translation table" => "Translate a string using Tikiwiki translation table",
// "string" => "string",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button" => "Label on the submit button",
// "Show Title" => "Show Title",
// "Show Mandatory" => "Show Mandatory",
// "Embedded" => "Embedded",
// "Url used for the field links" => "Url used for the field links",
// "Values" => "Values",
// "Colon-separated list of values" => "Colon-separated list of values",
// "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or " => "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or ",
// "user|page" => "user|page",
// "itemId" => "itemId",
// "itemId if you want to edit an item" => "itemId if you want to edit an item",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Width of first column " => "Width of first column ",
// "Specify the width in pixels or percentage of the first column in the tracker form" => "Specify the width in pixels or percentage of the first column in the tracker form",
// "Display List" => "Display List",
// "Line" => "Line",
// "Tracker Filter" => "Tracker Filter",
// "notice" => "notice",
// "Tracker Item Field" => "Tracker Item Field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Item ID" => "Item ID",
// "Field ID" => "Field ID",
// "Colon separated list of field IDs" => "Colon separated list of field IDs",
// "o|p|c|op|oc|pc|opc" => "o|p|c|op|oc|pc|opc",
// "Value to compare against" => "Value to compare against",
// "Tracker List" => "Tracker List",
// "Notice" => "Notice",
// "Popup" => "Popup",
// "Colon-separated list of fields to display on click. Example: 6:7" => "Colon-separated list of fields to display on click. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Show Links" => "Show Links",
// "shownbitems" => "shownbitems",
// "Show Initials" => "Show Initials",
// "Show Status" => "Show Status",
// "Show Creation Date" => "Show Creation Date",
// "Show Last Modification" => "Show Last Modification",
// "Show Field Name" => "Show Field Name",
// "Status Filter" => "Status Filter",
// "Which item status to list. o = open, p = pending, c = closed" => "Which item status to list. o = open, p = pending, c = closed",
// "Sort Mode" => "Sort Mode",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Exact Value" => "Exact Value",
// "Checkbox" => "Checkbox",
// "goIfOne" => "goIfOne",
// "More URL" => "More URL",
// "Select automatically the item of the current user or the page" => "Select automatically the item of the current user or the page",
// "View User" => "View User",
// "Item ID separated with " => "Item ID separated with ",
// "List of items Ids" => "List of items Ids",
// "link url" => "link url",
// "Left Deliminator" => "Left Deliminator",
// "Right Deliminator" => "Right Deliminator",
// "If y, value will be truncated" => "If y, value will be truncated",
// "Export Button" => "Export Button",
// "Compute" => "Compute",
// "Sum or average all the values of a field  and displays it at the bottom of the table" => "Sum or average all the values of a field  and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Tracker Prefill" => "Tracker Prefill",
// "Tracker page name" => "Tracker page name",
// "Button label" => "Button label",
// "Field 1" => "Field 1",
// "Value 1" => "Value 1",
// "Content of the field" => "Content of the field",
// "Field 2" => "Field 2",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Value 5" => "Value 5",
// "Tracker Stats" => "Tracker Stats",
// "Show Percentage" => "Show Percentage",
// "Show Bar" => "Show Bar",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Tracker Timeline" => "Tracker Timeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "hour, day, week, month or year (default to hour)" => "hour, day, week, month or year (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "hour, day, week, month, year or empty (default to empty)" => "hour, day, week, month, year or empty (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link. (y|n)" => "Convert the group name to a link. (y|n)",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Translated" => "Translated",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "User Count" => "User Count",
// "Login Filter" => "Login Filter",
// "String to use between elements of the list" => "String to use between elements of the list",
// "Maximum" => "Maximum",
// "Result limit" => "Result limit",
// "Layout" => "Layout",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. Note: Do not work when nav=>y" => "Display the current version name as the title. Note: Do not work when nav=>y",
// "Default" => "Default",
// "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'",
// "Show Stats" => "Show Stats",
// "Show Stats After" => "Show Stats After",
// "Show Creator" => "Show Creator",
// "Wanted Pages" => "Wanted Pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "Split By" => "Split By",
// "Skip Extension" => "Skip Extension",
// "Collect" => "Collect",
// "Level" => "Level",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Lists ''wanted'' wiki pages" => "Lists ''wanted'' wiki pages",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "The character, by which ignored patterns are separated. possible values: characters" => "The character, by which ignored patterns are separated. possible values: characters",
// "Whether to include external wikis in the list. possible values" => "Whether to include external wikis in the list. possible values",
// "Collect either originating or wanted pages in a cell and display them in the second column. possible values" => "Collect either originating or wanted pages in a cell and display them in the second column. possible values",
// "Switch-on debug output with details about the items. possible values" => "Switch-on debug output with details about the items. possible values",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values",
// "non-valid custom regex" => "non-valid custom regex",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Youtube" => "Youtube",
// "URL to the Youtube video" => "URL to the Youtube video",
// "quality" => "quality",
// "Missing parameter movie to the youtube plugin" => "Missing parameter movie to the youtube plugin",
// "rollback version " => "rollback version ",
// "Plugin " => "Plugin ",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "List by month" => "List by month",
// "Please wait.." => "Please wait..",
// "updated tracker items" => "updated tracker items",
// "Can browse the calendar" => "Can browse the calendar",
// "Can edit items in categories" => "Can edit items in categories",
// "Can search on objects of this category" => "Can search on objects of this category",
// "Can admin the cms" => "Can admin the cms",
// "Can read article headings" => "Can read article headings",
// "Can ban users or ips" => "Can ban users or ips",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view referer stats" => "Can view referer stats",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can admin freetags" => "Can admin freetags",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can browse freetags" => "Can browse freetags",
// "Can view poll voters" => "Can view poll voters",
// "Can admin quicktags" => "Can admin quicktags",
// "Can admin shoutbox (Edit/remove msgs)" => "Can admin shoutbox (Edit/remove msgs)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can export tracker items" => "Can export tracker items",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can rollback pages" => "Can rollback pages",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can declare an instance as exception" => "Can declare an instance as exception",
// "Can send instances after completion" => "Can send instances after completion",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can use group webmail" => "Can use group webmail",
// "Can administrate group webmail accounts" => "Can administrate group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can administrate personal webmail accounts" => "Can administrate personal webmail accounts",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin" => "Can execute unapproved plugin",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Trust all user inputs (no security checks)" => "Trust all user inputs (no security checks)",
// "View page backlinks" => "View page backlinks",
// "Can admin mail notifications" => "Can admin mail notifications",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "feature print indexed" => "feature print indexed",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature page title" => "feature page title",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wysiwyg toolbar" => "wysiwyg toolbar",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "feature blog comments" => "feature blog comments",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastmodif" => "fgal list lastmodif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "ProgressBarPlay" => "ProgressBarPlay",
// "ProgressBarLoad" => "ProgressBarLoad",
// "ProgressBarButton" => "ProgressBarButton",
// "ProgressBar" => "ProgressBar",
// "VolumeOn" => "VolumeOn",
// "VolumeOff" => "VolumeOff",
// "VolumeButton" => "VolumeButton",
// "Button" => "Button",
// "ButtonPressed" => "ButtonPressed",
// "ButtonOver" => "ButtonOver",
// "ButtonInfo" => "ButtonInfo",
// "ButtonInfoPressed" => "ButtonInfoPressed",
// "ButtonInfoOver" => "ButtonInfoOver",
// "ButtonInfoText" => "ButtonInfoText",
// "ID3" => "ID3",
// "PlayTime" => "PlayTime",
// "TotalTime" => "TotalTime",
// "PanelDisplay" => "PanelDisplay",
// "AlertMesg" => "AlertMesg",
// "PreloadDelay" => "PreloadDelay",
// "VideoHeight" => "VideoHeight",
// "VideoLength" => "VideoLength",
// "URLAppend" => "URLAppend",
// "LimitedMsg" => "LimitedMsg",
// "MaxPlay" => "MaxPlay",
// "MultimediaGalerie" => "MultimediaGalerie",
// "MultimediaDefaultLength" => "MultimediaDefaultLength",
// "MultimediaDefaultHeight" => "MultimediaDefaultHeight",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "cms spellcheck" => "cms spellcheck",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trk with mirror tables" => "trk with mirror tables",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki workflow" => "users prefs mytiki workflow",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "validateRegistration" => "validateRegistration",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature newsreader" => "feature newsreader",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "feature charts" => "feature charts",
// "rss forums" => "rss forums",
// "rss forum" => "rss forum",
// "rss directories" => "rss directories",
// "rss articles" => "rss articles",
// "rss blogs" => "rss blogs",
// "rss image galleries" => "rss image galleries",
// "rss file galleries" => "rss file galleries",
// "rss wiki" => "rss wiki",
// "rss image gallery" => "rss image gallery",
// "rss file gallery" => "rss file gallery",
// "rss blog" => "rss blog",
// "rss tracker" => "rss tracker",
// "rss trackers" => "rss trackers",
// "rss calendar" => "rss calendar",
// "rss mapfiles" => "rss mapfiles",
// "rss cache time" => "rss cache time",
// "max rss forums" => "max rss forums",
// "max rss forum" => "max rss forum",
// "max rss directories" => "max rss directories",
// "max rss articles" => "max rss articles",
// "max rss blogs" => "max rss blogs",
// "max rss image galleries" => "max rss image galleries",
// "max rss file galleries" => "max rss file galleries",
// "max rss wiki" => "max rss wiki",
// "max rss image gallery" => "max rss image gallery",
// "max rss file gallery" => "max rss file gallery",
// "max rss blog" => "max rss blog",
// "max rss mapfiles" => "max rss mapfiles",
// "max rss tracker" => "max rss tracker",
// "max rss trackers" => "max rss trackers",
// "max rss calendar" => "max rss calendar",
// "summary rss blogs" => "summary rss blogs",
// "rssfeed default version" => "rssfeed default version",
// "rssfeed language" => "rssfeed language",
// "rssfeed editor" => "rssfeed editor",
// "rssfeed webmaster" => "rssfeed webmaster",
// "rssfeed creator" => "rssfeed creator",
// "rssfeed css" => "rssfeed css",
// "rssfeed publisher" => "rssfeed publisher",
// "rssfeed img" => "rssfeed img",
// "rss basic auth" => "rss basic auth",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "rnd num reg" => "rnd num reg",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth create user tiki" => "auth create user tiki",
// "auth create user auth" => "auth create user auth",
// "auth skip admin" => "auth skip admin",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "https login" => "https login",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category reinforce" => "feature category reinforce",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "feature games" => "feature games",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "lang use db" => "lang use db",
// "language" => "language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature topbar version" => "feature topbar version",
// "feature topbar debug" => "feature topbar debug",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "site style" => "site style",
// "site style option" => "site style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature copyright" => "feature copyright",
// "feature multimedia" => "feature multimedia",
// "feature swfobj" => "feature swfobj",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "quicktags over textarea" => "quicktags over textarea",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "feature floating help" => "feature floating help",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty notice reporting" => "smarty notice reporting",
// "smarty security" => "smarty security",
// "feature ajax" => "feature ajax",
// "feature ajax autosave" => "feature ajax autosave",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature drawings" => "feature drawings",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature workflow" => "feature workflow",
// "feature xmlrpc" => "feature xmlrpc",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "feature site report email" => "feature site report email",
// "session db" => "session db",
// "session lifetime" => "session lifetime",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "system os" => "system os",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature blogposts pings" => "feature blogposts pings",
// "feature create webhelp" => "feature create webhelp",
// "feature forums search" => "feature forums search",
// "feature trackbackpings" => "feature trackbackpings",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "feature mootools" => "feature mootools",
// "javascript enabled" => "javascript enabled",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "feature template zoom" => "feature template zoom",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "use minified scripts" => "use minified scripts",
// "valid email regex" => "valid email regex",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery sheet" => "feature jquery sheet",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery cycle" => "feature jquery cycle",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature tikitests" => "feature tikitests",
// "feature magic" => "feature magic",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "transition style ver" => "transition style ver",
// "magic last load" => "magic last load",
// "feature groupalert" => "feature groupalert",
// "lib spellcheck" => "lib spellcheck",
// "wiki spellcheck" => "wiki spellcheck",
// "blog spellcheck" => "blog spellcheck",
// "allowMsgs" => "allowMsgs",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki workflow" => "mytiki workflow",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "Group Monitor" => "Group Monitor",
// "Select Categories" => "Select Categories",
// "Select/deselect all categories" => "Select/deselect all categories",
// "Comments Locked" => "Comments Locked",
// "Comments are locked" => "Comments are locked",
// "Maximum size" => "Maximum size",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Post as Anonymous" => "Post as Anonymous",
// "Your comment will have to be approved by the moderator before it is displayed" => "Your comment will have to be approved by the moderator before it is displayed",
// "Users with perms and not only the owner of the gallery can upload in it" => "Users with perms and not only the owner of the gallery can upload in it",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "not in" => "not in",
// "Clear Filter" => "Clear Filter",
// "\\074span class=\"shortcut\"\\076C\\074/span\\076lose" => "\\074span class=\"shortcut\"\\076C\\074/span\\076lose",
// "\\074span class=\"shortcut\"\\076N\\074/span\\076ext" => "\\074span class=\"shortcut\"\\076N\\074/span\\076ext",
// "\\074span class=\"shortcut\"\\076P\\074/span\\076revious" => "\\074span class=\"shortcut\"\\076P\\074/span\\076revious",
// "Download the zip" => "Download the zip",
// "User Tracker" => "User Tracker",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}",
// "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}" => "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}",
// "Last attempt" => "Last attempt",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user} at" => "{\$mail_title} by {\$mail_user} at",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "The old page content follows below" => "The old page content follows below",
// "Wiki page %s created by {\$mail_user}" => "Wiki page %s created by {\$mail_user}",
// "Wiki page %s deleted by {\$mail_user}" => "Wiki page %s deleted by {\$mail_user}",
// "Wiki page %s changed by {\$mail_user}" => "Wiki page %s changed by {\$mail_user}",
// "Zoom out" => "Zoom out",
// "Zoom in" => "Zoom in",
// "from the mapfile" => "from the mapfile",
// "\$tpl_module_title" => "\$tpl_module_title",
// "Admin Drawings" => "Admin Drawings",
// "External Wikis" => "External Wikis",
// "Tiki Cache/Sys Admin" => "Tiki Cache/Sys Admin",
// "Syntax Highlighting" => "Syntax Highlighting",
// "\$module_title" => "\$module_title",
// "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>" => "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>",
// "Last `\$module_rows` blog comments" => "Last `\$module_rows` blog comments",
// "\$modcattitle" => "\$modcattitle",
// "\$type" => "\$type",
// "Login through Shibboleth" => "Login through Shibboleth",
// "CapsLock is on" => "CapsLock is on",
// "What is OpenID" => "What is OpenID",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
// "Videos on YouTube" => "Videos on YouTube",
// "More Videos" => "More Videos",
// "Send Newsletter" => "Send Newsletter",
// "By" => "By",
// "Read more" => "Read more",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Editing and Plugins" => "Editing and Plugins",
// "Semantic wiki links" => "Semantic wiki links",
// "Semantic links" => "Semantic links",
// "Webservices" => "Webservices",
// "Sef URL" => "Sef URL",
// "Blogs Listing" => "Blogs Listing",
// "Create a blog" => "Create a blog",
// "Spell checking" => "Spell checking",
// "Requires a separate download" => "Requires a separate download",
// "Custom blog headings" => "Custom blog headings",
// "Blog-level" => "Blog-level",
// "Post-level" => "Post-level",
// "Default number per page" => "Default number per page",
// "Default ordering" => "Default ordering",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "General settings" => "General settings",
// "Category path" => "Category path",
// "Exclude these categories" => "Exclude these categories",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Show category objects" => "Show category objects",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "PHPLayers is disabled" => "PHPLayers is disabled",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "Admin topics" => "Admin topics",
// "Admin types" => "Admin types",
// "Articles Listing" => "Articles Listing",
// "Title of articles home page" => "Title of articles home page",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "Default article image width" => "Default article image width",
// "Default article image height" => "Default article image height",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "Publication date" => "Publication date",
// "Expiration date" => "Expiration date",
// "Users Listing" => "Users Listing",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Requires User Preferences feature" => "Requires User Preferences feature",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Real name" => "Real name",
// "Feature is disabled" => "Feature is disabled",
// "Default user preferences" => "Default user preferences",
// "Character set for mail" => "Character set for mail",
// "User messages" => "User messages",
// "Notify sender when reading mail" => "Notify sender when reading mail",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
// "Enable copyright management for" => "Enable copyright management for",
// "Feature" => "Feature",
// "No tabs" => "No tabs",
// "Main" => "Main",
// "Global Features" => "Global Features",
// "More Functionality" => "More Functionality",
// "UI Enhancements" => "UI Enhancements",
// "Programmer" => "Programmer",
// "Main Features" => "Main Features",
// "Site Global Features" => "Site Global Features",
// "Additional Features" => "Additional Features",
// "HTML pages" => "HTML pages",
// "Minichat" => "Minichat",
// "Comments Moderation" => "Comments Moderation",
// "Comments Locking" => "Comments Locking",
// "Css Menus (suckerfish)" => "Css Menus (suckerfish)",
// "Mootools or JQuery" => "Mootools or JQuery",
// "Floating help aka the Big Blue Help Icon" => "Floating help aka the Big Blue Help Icon",
// "Seem ok" => "Seem ok",
// "Features that may change or might be re-worked in the future" => "Features that may change or might be re-worked in the future",
// "JQuery: JavaScript UI effects" => "JQuery: JavaScript UI effects",
// "Need polish" => "Need polish",
// "Features that need admin help and user patience to work well" => "Features that need admin help and user patience to work well",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "SEFURL" => "SEFURL",
// "Ajax auto-save" => "Ajax auto-save",
// "Malfunctioning" => "Malfunctioning",
// "These features have critical faults - not recommended" => "These features have critical faults - not recommended",
// "Magic Admin Panel" => "Magic Admin Panel",
// "Neglected" => "Neglected",
// "Old features no longer maintained" => "Old features no longer maintained",
// "SWFObject" => "SWFObject",
// "SwfObject" => "SwfObject",
// "Used to embed Flash content in wiki pages, banners etc" => "Used to embed Flash content in wiki pages, banners etc",
// "Group Watches" => "Group Watches",
// "Group Alert" => "Group Alert",
// "Programmer Features" => "Programmer Features",
// "TikiTests" => "TikiTests",
// "requires PHP5 or more" => "requires PHP5 or more",
// "Use Minified Scripts" => "Use Minified Scripts",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "Gallery Listing" => "Gallery Listing",
// "Search Indexing" => "Search Indexing",
// "Create a Gallery" => "Create a Gallery",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Podcast directory" => "Podcast directory",
// "Required for podcasts" => "Required for podcasts",
// "Default Ordering" => "Default Ordering",
// "Allow download limit per file" => "Allow download limit per file",
// "Prevent download if score becomes negative" => "Prevent download if score becomes negative",
// "Score is disabled" => "Score is disabled",
// "Batch uploading" => "Batch uploading",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Upload Regex" => "Upload Regex",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "System Command" => "System Command",
// "Forums Listing" => "Forums Listing",
// "Create a forum" => "Create a forum",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Threads" => "Threads",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Default sort mode" => "Default sort mode",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Search is disabled" => "Search is disabled",
// "Use Tiki (database-independent) search" => "Use Tiki (database-independent) search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "Description length" => "Description length",
// "3D Tag Browser" => "3D Tag Browser",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all charactrs" => "Accept all charactrs",
// "Lowercase tags only" => "Lowercase tags only",
// "Multilingual freetags" => "Multilingual freetags",
// "Multiligual disabled" => "Multiligual disabled",
// "&quot;More Like This&quot; algorithm" => "&quot;More Like This&quot; algorithm",
// "basic" => "basic",
// "weighted" => "weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "Cleanup unused tags" => "Cleanup unused tags",
// "Morcego 3D browser disabled" => "Morcego 3D browser disabled",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "Graph appearance" => "Graph appearance",
// "Node color" => "Node color",
// "Camera settinsg" => "Camera settinsg",
// "Physics engine" => "Physics engine",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
// "Display image informations in a mouseover box" => "Display image informations in a mouseover box",
// "yes, and don't display those informations under the image" => "yes, and don't display those informations under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Pixels Default" => "Pixels Default",
// "Default scale size" => "Default scale size",
// "Admin Password" => "Admin Password",
// "Release Check" => "Release Check",
// "Check for updates automatically" => "Check for updates automatically",
// "TikiWiki will check for updates when you access the main Administration page" => "TikiWiki will check for updates when you access the main Administration page",
// "Check for updates now" => "Check for updates now",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look &amp; Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look &amp; Feel</strong></a> section for additional site related customization preferences",
// "Use TikiWiki feature as homepage" => "Use TikiWiki feature as homepage",
// "Use different URL as home page" => "Use different URL as home page",
// "Miscellaneous" => "Miscellaneous",
// "Server OS" => "Server OS",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Default charset for sending mail" => "Default charset for sending mail",
// "Mail end of line" => "Mail end of line",
// "Logging and Reporting" => "Logging and Reporting",
// "PHP error reporting level" => "PHP error reporting level",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Visible to Admin only" => "Visible to Admin only",
// "Include Smarty notices" => "Include Smarty notices",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Log SQL" => "Log SQL",
// "Log queries using more than" => "Log queries using more than",
// "This may impact performance" => "This may impact performance",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "Site Access" => "Site Access",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Host" => "Host",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Send to URL" => "Send to URL",
// "Performance" => "Performance",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "GZip output" => "GZip output",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Session" => "Session",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Enabling this feature will immediately log you out when you save this preference" => "Enabling this feature will immediately log you out when you save this preference",
// "Session lifetime" => "Session lifetime",
// "The \"Contact Us\" feature is disabled" => "The \"Contact Us\" feature is disabled",
// "Allow anonymous visitors to use the \"Contact Us\"" => "Allow anonymous visitors to use the \"Contact Us\"",
// "The default help system may not be complete" => "The default help system may not be complete",
// "You can help with the TikiWiki documentation" => "You can help with the TikiWiki documentation",
// "Show user's real name instead of login (when possible)" => "Show user's real name instead of login (when possible)",
// "Highlight group" => "Highlight group",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Separators" => "Separators",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Sample" => "Sample",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Default language" => "Default language",
// "User preferences are disabled" => "User preferences are disabled",
// "Users can change site language" => "Users can change site language",
// "Available languages" => "Available languages",
// "Use Ctrl+Click to select multiple languages" => "Use Ctrl+Click to select multiple languages",
// "Display available translations" => "Display available translations",
// "Changing page language will also change the site language" => "Changing page language will also change the site language",
// "Translation assistant" => "Translation assistant",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Structures are disabled" => "Structures are disabled",
// "Multilingual One Page feature" => "Multilingual One Page feature",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "Look and Feel" => "Look and Feel",
// "Semantic" => "Semantic",
// "Webservices management" => "Webservices management",
// "CAS" => "CAS",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Validate by email" => "Validate by email",
// "You need to set <a href=\"tiki-admin.php?page=general&amp;cookietab=2\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general&amp;cookietab=2\">Sender Email</a>",
// "Validate user's email server" => "Validate user's email server",
// "Require validation by Admin" => "Require validation by Admin",
// "Require passcode to register" => "Require passcode to register",
// "Passcode" => "Passcode",
// "Users must enter this code to register" => "Users must enter this code to register",
// "Use CAPTCHA to prevent automatic/robot registrations" => "Use CAPTCHA to prevent automatic/robot registrations",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Include &quot;Generate Password&quot; option on registration form" => "Include &quot;Generate Password&quot; option on registration form",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display" => "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Re-validate user by email after" => "Re-validate user by email after",
// "Use <strong>-1</strong> for never" => "Use <strong>-1</strong> for never",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "Create a new group for each user" => "Create a new group for each user",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Use HTTPS login" => "Use HTTPS login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "Cookie name" => "Cookie name",
// "Use email as username" => "Use email as username",
// "Minimum length" => "Minimum length",
// "Maximum length" => "Maximum length",
// "Force lowercase" => "Force lowercase",
// "Username pattern" => "Username pattern",
// "Store password as plain text" => "Store password as plain text",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords </em>are stored<em> as plain text, the password will be emailed to the user" => "If passwords </em>are stored<em> as plain text, the password will be emailed to the user",
// "If passwords </em>are not<em> plain text, reset instructions will be emailed to the user" => "If passwords </em>are not<em> plain text, reset instructions will be emailed to the user",
// "Encryption method" => "Encryption method",
// "Users can change their password" => "Users can change their password",
// "Require characters and numerals" => "Require characters and numerals",
// "Password expires after" => "Password expires after",
// "You must change the Authentication Method to PEAR::Auth for these changes to take effect" => "You must change the Authentication Method to PEAR::Auth for these changes to take effect",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Create user if not in Auth" => "Create user if not in Auth",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "Will override the Host and Port settings" => "Will override the Host and Port settings",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Base DN" => "Base DN",
// "LDAP User" => "LDAP User",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "LDAP Group" => "LDAP Group",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group OC" => "Group OC",
// "LDAP Member" => "LDAP Member",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "LDAP Admin" => "LDAP Admin",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Create with default group" => "Create with default group",
// "Default group" => "Default group",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "Hostname" => "Hostname",
// "You must enable PHP CAS first" => "You must enable PHP CAS first",
// "UI Effects" => "UI Effects",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme options" => "Theme options",
// "Each group can have its theme" => "Each group can have its theme",
// "Shadow layer" => "Shadow layer",
// "Enable additional general layout layers for shadows, rounded corners or other decorative styling" => "Enable additional general layout layers for shadows, rounded corners or other decorative styling",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Activate will only show content for admin. Check Publish to use content for all users" => "Activate will only show content for admin. Check Publish to use content for all users",
// "Site Logo and Title" => "Site Logo and Title",
// "Site logo background style" => "Site logo background style",
// "Site title" => "Site title",
// "Site subtitle" => "Site subtitle",
// "Note: Needs feature PHPLayers on(default), or feature CSS Menu on  " => "Note: Needs feature PHPLayers on(default), or feature CSS Menu on  ",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Power by" => "Power by",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "JQuery plugins and add-ons" => "JQuery plugins and add-ons",
// "Requires jquery feature" => "Requires jquery feature",
// "JQuery Tooltips" => "JQuery Tooltips",
// "JQuery Tooltips: Customisable help tips" => "JQuery Tooltips: Customisable help tips",
// "JQuery Autocomplete" => "JQuery Autocomplete",
// "JQuery Superfish" => "JQuery Superfish",
// "JQuery Superfish (effects on CSS menus)" => "JQuery Superfish (effects on CSS menus)",
// "JQuery Reflection" => "JQuery Reflection",
// "JQuery Reflection (reflection effect on images)" => "JQuery Reflection (reflection effect on images)",
// "JQuery Cycle (slideshow)" => "JQuery Cycle (slideshow)",
// "For future use" => "For future use",
// "JQuery UI" => "JQuery UI",
// "JQuery UI: More JQuery functionality" => "JQuery UI: More JQuery functionality",
// "JQuery Sheet" => "JQuery Sheet",
// "JQuery Spreadsheet" => "JQuery Spreadsheet",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Standard UI effects" => "Standard UI effects",
// "Effect for modules etc" => "Effect for modules etc",
// "Main JQuery effect" => "Main JQuery effect",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect speed" => "Effect speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Effect direction" => "Effect direction",
// "Tab UI effects" => "Tab UI effects",
// "Effect for tabs" => "Effect for tabs",
// "JQuery effect for tabs" => "JQuery effect for tabs",
// "Effect speed for tabs" => "Effect speed for tabs",
// "Effect direction for tabs" => "Effect direction for tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "List of CSS selectors to be fixed, each selector separated by comma" => "List of CSS selectors to be fixed, each selector separated by comma",
// "List of HTMLDomElements to be fixed, each element separated by comma" => "List of HTMLDomElements to be fixed, each element separated by comma",
// "Context Menus (only in file galleries so far)" => "Context Menus (only in file galleries so far)",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Change Preferences" => "Change Preferences",
// "Meta tags" => "Meta tags",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Geo URL" => "Geo URL",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Show module controls" => "Show module controls",
// "Users can shade modules" => "Users can shade modules",
// "Module decides" => "Module decides",
// "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item" => "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item",
// "ProgressBarPlay Color" => "ProgressBarPlay Color",
// "ProgressBarLoad Color" => "ProgressBarLoad Color",
// "ProgressBarButton Color" => "ProgressBarButton Color",
// "ProgressBar Color" => "ProgressBar Color",
// "Volume On Color" => "Volume On Color",
// "Volume Off Color" => "Volume Off Color",
// "Volume Button Color" => "Volume Button Color",
// "Button Color" => "Button Color",
// "Button Pressed Color" => "Button Pressed Color",
// "Button Over Color" => "Button Over Color",
// "Button Info Color" => "Button Info Color",
// "Button Info Pressed Color" => "Button Info Pressed Color",
// "Button Info Over Color" => "Button Info Over Color",
// "Button Info Text Color" => "Button Info Text Color",
// "ID3 Tag Color" => "ID3 Tag Color",
// "Play Time Color" => "Play Time Color",
// "Total Time Color" => "Total Time Color",
// "Panel Display Color" => "Panel Display Color",
// "Alert Message Color" => "Alert Message Color",
// "Flash Length" => "Flash Length",
// "Flash Heigth" => "Flash Heigth",
// "Video Length" => "Video Length",
// "Video Heigth" => "Video Heigth",
// "Preload Delay" => "Preload Delay",
// "Max Play time" => "Max Play time",
// "URL Append" => "URL Append",
// "Message after limited time" => "Message after limited time",
// "ID of System File Galleries to upload multimedia files" => "ID of System File Galleries to upload multimedia files",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Categories disabled" => "Categories disabled",
// "Are you sure you want to install the profile" => "Are you sure you want to install the profile",
// "Profile repository" => "Profile repository",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Repository" => "Repository",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "More information" => "More information",
// "Feed for articles" => "Feed for articles",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Feed for blogs" => "Feed for blogs",
// "Individual blogs" => "Individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Individual image galleries" => "Individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "Feed for wiki" => "Feed for wiki",
// "Individual forums" => "Individual forums",
// "Individual trackers items" => "Individual trackers items",
// "Feed for directory" => "Feed for directory",
// "Map files" => "Map files",
// "Feed for maps" => "Feed for maps",
// "Defaults" => "Defaults",
// "Image Path" => "Image Path",
// "Use <strong>0</strong> for no caching" => "Use <strong>0</strong> for no caching",
// "Search Results" => "Search Results",
// "Search type" => "Search type",
// "Database search" => "Database search",
// "This search uses the MySQL Full-Text feature" => "This search uses the MySQL Full-Text feature",
// "Tiki search" => "Tiki search",
// "This database-independent search is always enabled" => "This database-independent search is always enabled",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "Refresh mode" => "Refresh mode",
// "Use <strong>0</strong> for no refresh" => "Use <strong>0</strong> for no refresh",
// "When the Database search is enabled, you must manually refresh the Tiki search indexes" => "When the Database search is enabled, you must manually refresh the Tiki search indexes",
// "Refresh all search index now" => "Refresh all search index now",
// "Parse the results" => "Parse the results",
// "May impact performance" => "May impact performance",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Pertinence" => "Pertinence",
// "Last modified date" => "Last modified date",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "Self" => "Self",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Plugin Aliases" => "Plugin Aliases",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "External link icon" => "External link icon",
// "External links will be identified with" => "External links will be identified with",
// "Use File Galleries to store pictures " => "Use File Galleries to store pictures ",
// "Allow to post comments as Anonymous" => "Allow to post comments as Anonymous",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "&lt;return&gt; for rows" => "&lt;return&gt; for rows",
// "Show quicktags above textareas" => "Show quicktags above textareas",
// "If disabled, quicktags will be shown to the left of textareas" => "If disabled, quicktags will be shown to the left of textareas",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting",
// "Plugin disabled" => "Plugin disabled",
// "Default size" => "Default size",
// "Comments " => "Comments ",
// "Forum reply" => "Forum reply",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Edit plugin icons" => "Edit plugin icons",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "(experimental - not comprehensively tested and requires new JQuery feature)" => "(experimental - not comprehensively tested and requires new JQuery feature)",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Validation" => "Validation",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely",
// "Tracker attachments" => "Tracker attachments",
// "No records" => "No records",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Available" => "Available",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Page Listings" => "Page Listings",
// "If the page does not exist, it will be created" => "If the page does not exist, it will be created",
// "Wiki link format" => "Wiki link format",
// "Latin" => "Latin",
// "Select the characters that can be used with Wiki link syntax: ((page name))" => "Select the characters that can be used with Wiki link syntax: ((page name))",
// "Page display" => "Page display",
// "Page ID" => "Page ID",
// "Page version" => "Page version",
// "Page name display stripper" => "Page name display stripper",
// "Enter a character to use as the delimiter when displaying page names. All characters after the delimiter will be stripped when displaying the page name.</em>" => "Enter a character to use as the delimiter when displaying page names. All characters after the delimiter will be stripped when displaying the page name.</em>",
// "Allow override per page" => "Allow override per page",
// "Display show/hide icon displayed before headings" => "Display show/hide icon displayed before headings",
// "Wiki action bar" => "Wiki action bar",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Page navigation bar location" => "Page navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line" => "Wiki top line",
// "Neither" => "Neither",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Wiki buttons" => "Wiki buttons",
// "Buttons: Edit, Source, Remove, .." => "Buttons: Edit, Source, Remove, ..",
// "Save draft" => "Save draft",
// "Requires AJAX" => "Requires AJAX",
// "experimental" => "experimental",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Allow minor edits" => "Allow minor edits",
// "Minor edits do not flag new content for translation and do not send watch notifications" => "Minor edits do not flag new content for translation and do not send watch notifications",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "Display by default" => "Display by default",
// "Manage attachments" => "Manage attachments",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
// "WikiWords" => "WikiWords",
// "Maximum number of versions" => "Maximum number of versions",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Display IP address" => "Display IP address",
// "Default diff style" => "Default diff style",
// "History includes only page data, description, and change comment" => "History includes only page data, description, and change comment",
// "Forums are disabled" => "Forums are disabled",
// "Forum for discussion" => "Forum for discussion",
// "View source" => "View source",
// "Polls are disabled" => "Polls are disabled",
// "Import pages" => "Import pages",
// "Slideshows" => "Slideshows",
// "User's page" => "User's page",
// "Users can lock pages" => "Users can lock pages",
// "When viewing a page, if it doesn't exist automatically redirect to a similarly  named page" => "When viewing a page, if it doesn't exist automatically redirect to a similarly  named page",
// "Wiki watch" => "Wiki watch",
// "Watch minor edits" => "Watch minor edits",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Staging" => "Staging",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "Freetags are disabled" => "Freetags are disabled",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Orphan page" => "Orphan page",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Name length" => "Name length",
// "Edit comments" => "Edit comments",
// "Edit Comments length" => "Edit Comments length",
// "Database Version Problem" => "Database Version Problem",
// "The following list of changes has been applied" => "The following list of changes has been applied",
// "information" => "information",
// "preference" => "preference",
// "preference name" => "preference name",
// "TikiCache/System" => "TikiCache/System",
// "Edit Languages" => "Edit Languages",
// "kb" => "kb",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "contributor" => "contributor",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumn per category" => "Volumn per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volumn per the users'group and per contribution" => "Volumn per the users'group and per contribution",
// "Volumn per group and per contribution" => "Volumn per group and per contribution",
// "Volumn per user and per contribution" => "Volumn per user and per contribution",
// "Volumn per users'contribution and time" => "Volumn per users'contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "recorded" => "recorded",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Browse the category system" => "Browse the category system",
// "Remove from this Category" => "Remove from this Category",
// "Admin charts" => "Admin charts",
// "Use in" => "Use in",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Admin External Wikis" => "Admin External Wikis",
// "Enable Features" => "Enable Features",
// "Duplicate forum" => "Duplicate forum",
// "View this forum" => "View this forum",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
// "Online" => "Online",
// "Set topics preferences" => "Set topics preferences",
// "Show topics preferences" => "Show topics preferences",
// "hide topics preferences" => "hide topics preferences",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default style for threads" => "Default style for threads",
// ".." => "..",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Use Ctrl+Click to select multiple groups" => "Use Ctrl+Click to select multiple groups",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "For example, the default icon is: pics/icons/folder.png" => "For example, the default icon is: pics/icons/folder.png",
// "The name of the \"open folder\" icon is: pics/icons/ofolder.png" => "The name of the \"open folder\" icon is: pics/icons/ofolder.png",
// "Assign/Edit modules" => "Assign/Edit modules",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Edit Newsletter" => "Edit Newsletter",
// "Batch e-mail subscribe" => "Batch e-mail subscribe",
// "txt file, one e-mail per line" => "txt file, one e-mail per line",
// "Export Subscriber Emails" => "Export Subscriber Emails",
// "Add subscribers of another newsletter" => "Add subscribers of another newsletter",
// "Create Newsletter" => "Create Newsletter",
// "Allow customized text message to be sent with the html version" => "Allow customized text message to be sent with the html version",
// "Mail notifications" => "Mail notifications",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "A user edits an article" => "A user edits an article",
// "A user deletes an article" => "A user deletes an article",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "Preload Admin Account" => "Preload Admin Account",
// "User / Group" => "User / Group",
// "Multiple" => "Multiple",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "Votes older than these days are no more considered" => "Votes older than these days are no more considered",
// "0 for no limit" => "0 for no limit",
// "Span" => "Span",
// "Quicktags category filter" => "Quicktags category filter",
// "Tips" => "Tips",
// "Edit this RSS Module" => "Edit this RSS Module",
// "Create new RSS Module" => "Create new RSS Module",
// "RSS channels" => "RSS channels",
// "Show Date" => "Show Date",
// "View feed" => "View feed",
// "TikiWiki settings" => "TikiWiki settings",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "View structure" => "View structure",
// "Xml Zip" => "Xml Zip",
// "Add a New Question" => "Add a New Question",
// "This survey stats" => "This survey stats",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
// "Wiki textarea" => "Wiki textarea",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "Min" => "Min",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "Directory to exterminate" => "Directory to exterminate",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "Directories to save" => "Directories to save",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to {\$zipPath}" => "A zip has been written to {\$zipPath}",
// "Directory is not writeable" => "Directory is not writeable",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Description text is wiki-parsed" => "Description text is wiki-parsed",
// "Error message" => "Error message",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Create Tracker" => "Create Tracker",
// "Create/Edit Tracker" => "Create/Edit Tracker",
// "Create a group for each item" => "Create a group for each item",
// "tracker name must be unique, field names must be unique\nfor a tracker and they must be valid in SQL" => "tracker name must be unique, field names must be unique\nfor a tracker and they must be valid in SQL",
// "ItemId" => "ItemId",
// "and display last comment user/date" => "and display last comment user/date",
// "Group of users alerted when tracker is modified" => "Group of users alerted when tracker is modified",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "will have all the permissions of the included groups" => "will have all the permissions of the included groups",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Add to group" => "Add to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login" => "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login",
// "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login" => "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login",
// "ago" => "ago",
// "Need to validate email" => "Need to validate email",
// "Assign to group" => "Assign to group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Template wiki page" => "Template wiki page",
// "Assign user to Groups" => "Assign user to Groups",
// "Lowercase only" => "Lowercase only",
// "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "Tikiwiki is configured to delegate the password managment to LDAP through PEAR Auth" => "Tikiwiki is configured to delegate the password managment to LDAP through PEAR Auth",
// "Repeat Password" => "Repeat Password",
// "User must change password at first login" => "User must change password at first login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "Last Login" => "Last Login",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "Overwrite but keep the previous login if the login exists in another case" => "Overwrite but keep the previous login if the login exists in another case",
// "Don't overwrite" => "Don't overwrite",
// "Overwrite groups" => "Overwrite groups",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Page has been approved" => "Page has been approved",
// "New attachments" => "New attachments",
// "Old attachments" => "Old attachments",
// "Show Help" => "Show Help",
// "Article type" => "Article type",
// "Actions on this article type" => "Actions on this article type",
// "Level configuration" => "Level configuration",
// "Assign User {\$assign_user} to Groups" => "Assign User {\$assign_user} to Groups",
// "Assign User to Group" => "Assign User to Group",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "available files" => "available files",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
// "Use Wysiwyg Editor" => "Use Wysiwyg Editor",
// "Use Normal Editor" => "Use Normal Editor",
// "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. ",
// "Report to Webmaster" => "Report to Webmaster",
// "TikiWiki CMS/Groupware" => "TikiWiki CMS/Groupware",
// "Last update from SVN" => "Last update from SVN",
// "Admin Category" => "Admin Category",
// "Admin the Category System" => "Admin the Category System",
// "\$feature_label" => "\$feature_label",
// "Categories checking is not done in the database search" => "Categories checking is not done in the database search",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Send another message" => "Send another message",
// "Group View" => "Group View",
// "Publish this contact to groups" => "Publish this contact to groups",
// "<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "Edit a site" => "Edit a site",
// "Add a site" => "Add a site",
// "Directory Categories" => "Directory Categories",
// "Use Ctrl+Click to select multiple directory categories" => "Use Ctrl+Click to select multiple directory categories",
// "Parent directory category" => "Parent directory category",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Directory Subcategories" => "Directory Subcategories",
// "Admin related directory categories" => "Admin related directory categories",
// "Directory Category" => "Directory Category",
// "Use Ctrl+Click to select multiple categories" => "Use Ctrl+Click to select multiple categories",
// "Perform action with selected" => "Perform action with selected",
// "Add a Directory Category" => "Add a Directory Category",
// "in current directory category" => "in current directory category",
// "Related directory categories" => "Related directory categories",
// "Total directory categories" => "Total directory categories",
// "-1 for unlimited" => "-1 for unlimited",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "ex" => "ex",
// "The file will be saved in" => "The file will be saved in",
// "For more information, please see <a href=\"{\$prefs.helpurl}Wiki+Page+Editor\" target=\"tikihelp\" class=\"tikihelp\" title=\"{tr}Wiki Page Editor" => "For more information, please see <a href=\"{\$prefs.helpurl}Wiki+Page+Editor\" target=\"tikihelp\" class=\"tikihelp\" title=\"{tr}Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in TikiWiki" => "The syntax system used for creating pages in TikiWiki",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
// "2 dashes" => "2 dashes",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "hard space" => "hard space",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "flash" => "flash",
// "{\$label}" => "{\$label}",
// "Im-Export Languages" => "Im-Export Languages",
// "Edit quiz results" => "Edit quiz results",
// "Auto-Approve Article" => "Auto-Approve Article",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look &amp; Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look &amp; Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Update '{\$page}'" => "Update '{\$page}'",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "Export to file" => "Export to file",
// "Format" => "Format",
// "Export Tracker Items" => "Export Tracker Items",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse as Wiki Text" => "Parse as Wiki Text",
// "These fields" => "These fields",
// "Use Ctrl+Click to select multiple fields" => "Use Ctrl+Click to select multiple fields",
// "Dump All Tracker Items" => "Dump All Tracker Items",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
// "Reported messages for forum" => "Reported messages for forum",
// "No records to display" => "No records to display",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Cancel friendship request" => "Cancel friendship request",
// "Edit Tpl" => "Edit Tpl",
// "Reset view to default" => "Reset view to default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page" => "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page",
// "Last 2 days" => "Last 2 days",
// "Last 3 days" => "Last 3 days",
// "Last 5 days" => "Last 5 days",
// "Last week" => "Last week",
// "Last 2 weeks" => "Last 2 weeks",
// "Last month" => "Last month",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on" => "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "My Articles" => "My Articles",
// "User Articles" => "User Articles",
// "My User Items" => "My User Items",
// "User Items" => "User Items",
// "Sent Edition" => "Sent Edition",
// "Delete errors" => "Delete errors",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Add a news server" => "Add a news server",
// "Edit news server" => "Edit news server",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "Permission denied. You do not have permission to read complete articles" => "Permission denied. You do not have permission to read complete articles",
// "Use Ctrl+Click to select multiple pages" => "Use Ctrl+Click to select multiple pages",
// "No pages selected" => "No pages selected",
// "Rank" => "Rank",
// "List all articles of this same topic" => "List all articles of this same topic",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "Blogs Post" => "Blogs Post",
// "octets" => "octets",
// "Attached Files" => "Attached Files",
// "To add a file, click here" => "To add a file, click here",
// "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need",
// "Content may be out of date" => "Content may be out of date",
// "page: %0/%1" => "page: %0/%1",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
// "Average number of replies per topic" => "Average number of replies per topic",
// "FAQ Stats" => "FAQ Stats",
// "Tiki Logs" => "Tiki Logs",
// "Friend's email" => "Friend's email",
// "Separate multiple email addresses with a comma" => "Separate multiple email addresses with a comma",
// "I found an interesting page that I thought you would like" => "I found an interesting page that I thought you would like",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Logout" => "Use Current Session/Logout",
// "Recorded Links" => "Recorded Links",
// "Request" => "Request",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "Additional Info" => "Additional Info",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "Unzip zip files" => "Unzip zip files",
// "Maximum amount of downloads" => "Maximum amount of downloads",
// "Add File" => "Add File",
// "Maximum file size is limited to" => "Maximum file size is limited to",
// "No gallery available" => "No gallery available",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// "The column is disabled" => "The column is disabled",
// "a folder" => "a folder",
// "a URL" => "a URL",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Manage Fields" => "Manage Fields",
// "Default view" => "Default view",
// "(non public)" => "(non public)",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Displays users' info tooltip on mouseover for every user who allows his information to be public" => "Displays users' info tooltip on mouseover for every user who allows his information to be public",
// "My user items" => "My user items",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Select event type" => "Select event type",
// "All watched events" => "All watched events",
// "A user edited an article" => "A user edited an article",
// "A user deleted an article" => "A user deleted an article",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
// "Pre" => "Pre",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
// "Forum Lock" => "Forum Lock",
// "Filter Posts" => "Filter Posts",
// "Posts Filtering" => "Posts Filtering",
// "Last post date" => "Last post date",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
// "Posts with no replies" => "Posts with no replies",
// "Topic List" => "Topic List",
// "Pending" => "Pending",
// "Edit/Delete" => "Edit/Delete",
// "There was an error connecting to your e-mail account" => "There was an error connecting to your e-mail account",
// "Add a new" => "Add a new",
// "Edit this" => "Edit this",
// " mail account" => " mail account",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "Click to activate" => "Click to activate",
// "This is the active account" => "This is the active account",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Latitude" => "Latitude",
// "Longitude" => "Longitude",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator",
// "Your vote" => "Your vote",
// "Click to vote for this value" => "Click to vote for this value",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "Reinstall" => "Reinstall",
// "Undecided" => "Undecided",
// "%s set" => "%s set",
// "%s unset" => "%s unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Look & Feel" => "Look & Feel",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "A new %s  major release branch is available" => "A new %s  major release branch is available",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Click here to delete the category" => "Click here to delete the category",
// "Test Image" => "Test Image",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "If you use apache, you need a .htaccess file to have this feature working" => "If you use apache, you need a .htaccess file to have this feature working",
// "Error opening uploaded file" => "Error opening uploaded file",
// "Invalid email" => "Invalid email",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Remove group: " => "Remove group: ",
// "Remove permission: %s on %s" => "Remove permission: %s on %s",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "User does not exist on master" => "User does not exist on master",
// "Deleted account %s" => "Deleted account %s",
// "approved by " => "approved by ",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "Last modifications to the blog" => "Last modifications to the blog",
// "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>",
// "Invalid old password or unknown user" => "Invalid old password or unknown user",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Last replied forum topics" => "Last replied forum topics",
// "Not supported yet" => "Not supported yet",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "Back to item" => "Back to item",
// "Only the administrator can upload language files" => "Only the administrator can upload language files",
// "Operations executed successfully" => "Operations executed successfully",
// "Page saved (version %d)" => "Page saved (version %d)",
// "Error writing in the databse: \$query" => "Error writing in the databse: \$query",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Remove file: " => "Remove file: ",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Permission denied you can edit this file" => "Permission denied you can edit this file",
// "Cannot read the file" => "Cannot read the file",
// "Feature Ajax Disabled. Please ask your site administrator to enable" => "Feature Ajax Disabled. Please ask your site administrator to enable",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named '.\$prefs['map_path'].' to hold your map files" => "Please create a directory named '.\$prefs['map_path'].' to hold your map files",
// "map edit" => "map edit",
// "No page provided" => "No page provided",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "Permission denied you cannot assign permissions for this object" => "Permission denied you cannot assign permissions for this object",
// "Permission denied you cannot view the source of this page" => "Permission denied you cannot view the source of this page",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "invalid email" => "invalid email",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Permission denied you cannot remove this sheet" => "Permission denied you cannot remove this sheet",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Clean the sql logs" => "Clean the sql logs",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "A new page is created in a language" => "A new page is created in a language",
// "Permission denied: you cannot view this blog post while it is marked private" => "Permission denied: you cannot view this blog post while it is marked private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// " The connection failed, so check the server names" => " The connection failed, so check the server names",
// "The connection was OK" => "The connection was OK",
// " But the login failed, so check the Username and Password" => " But the login failed, so check the Username and Password",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Re:" => "Re:",
"ID" => "ID",
"Explorer" => "Explorer",
"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Aruba" => "Aruba",
"Bahrain" => "Bahrain",
"Barbados" => "Barbados",
"Belize" => "Belize",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Botswana" => "Botswana",
"Brunei" => "Brunei",
"Burundi" => "Burundi",
"Congo" => "Congo",
"Cuba" => "Cuba",
"Djibouti" => "Djibouti",
"Dominica" => "Dominica",
"Eritrea" => "Eritrea",
"Fiji" => "Fiji",
"Gabon" => "Gabon",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Grenada" => "Grenada",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernsey",
"Guinea" => "Guinea",
"Guyana" => "Guyana",
"Iran" => "Iran",
"Iraq" => "Iraq",
"Israel" => "Israel",
"Jamaica" => "Jamaica",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Laos" => "Laos",
"Lesotho" => "Lesotho",
"Liechtenstein" => "Liechtenstein",
"Luxemburg" => "Luxemburg",
"Madagascar" => "Madagascar",
"Malawi" => "Malawi",
"Malaysia" => "Malaysia",
"Maldives" => "Maldives",
"Mali" => "Mali",
"Malta" => "Malta",
"Mayotte" => "Mayotte",
"Montenegro" => "Montenegro",
"Montserrat" => "Montserrat",
"Myanmar" => "Myanmar",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
"Nicaragua" => "Nicaragua",
"Niue" => "Niue",
"Oman" => "Oman",
"Pakistan" => "Pakistan",
"Palau" => "Palau",
"Pitcairn" => "Pitcairn",
"Portugal" => "Portugal",
"Reunion" => "Reunion",
"Romania" => "Romania",
"Rwanda" => "Rwanda",
"Samoa" => "Samoa",
"Senegal" => "Senegal",
"Seychelles" => "Seychelles",
"Sudan" => "Sudan",
"Surinam" => "Surinam",
"Taiwan" => "Taiwan",
"Timor-Leste" => "Timor-Leste",
"Togo" => "Togo",
"Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Turkmenistan" => "Turkmenistan",
"Tuvalu" => "Tuvalu",
"Uganda" => "Uganda",
"Uzbekistan" => "Uzbekistan",
"Vanuatu" => "Vanuatu",
"Wales" => "Wales",
"Zimbabwe" => "Zimbabwe",
"PostgeSQL 7.2+" => "PostgeSQL 7.2+",
"Oracle" => "Oracle",
"Sybase" => "Sybase",
"SQLLite" => "SQLLite",
"MSSQL" => "MSSQL",
"Farsi" => "Farsi",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"crypt-md5" => "crypt-md5",
"crypt-des" => "crypt-des",
"Shibboleth" => "Shibboleth",
"Admins" => "Admins",
"Wiki" => "Wiki",
"Articles" => "Articles",
"article" => "article",
"Foo" => "Foo",
"Article" => "Article",
"Simple" => "Simple",
"min" => "min",
"km" => "km",
"No" => "No",
"pvs" => "pvs",
"wiki" => "wiki",
"arts" => "arts",
"auto-increment" => "auto-increment",
"Info" => "Info",
"~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
"Avatar" => "Avatar",
"left|right" => "left|right",
"1|0" => "1|0",
"Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
"wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
"Colors" => "Colors",
"Copyright" => "Copyright",
"on|off" => "on|off",
"DBReport" => "DBReport",
"Div" => "Div",
"Events" => "Events",
"Numeric" => "Numeric",
"0|1" => "0|1",
"Desc" => "Desc",
"ftp" => "ftp",
"Color" => "Color",
"googledoc" => "googledoc",
"HTML" => "HTML",
"Iframe" => "Iframe",
"iframe" => "iframe",
"Font" => "Font",
"Id" => "Id",
"Original" => "Original",
"Error" => "Error",
"Test" => "Test",
"Mode" => "Mode",
"Versions" => "Versions",
", " => ", ",
"id" => "id",
"Copyrights" => "Copyrights",
"Total" => "Total",
"Perms" => "Perms",
"Pan" => "Pan",
"Ip" => "Ip",
"Normal" => "Normal",
"ERROR" => "ERROR",
"CC" => "CC",
"BCC" => "BCC",
"1" => "1",
"2" => "2",
"3" => "3",
"4" => "4",
"5" => "5",
"Cc" => "Cc",
"Categories" => "Categories",
"phpinfo" => "phpinfo",
"[-]" => "[-]",
"URI" => "URI",
"General" => "General",
"RSS" => "RSS",
"Intertiki" => "Intertiki",
"InterTiki" => "InterTiki",
"Visible" => "Visible",
"avatar" => "avatar",
"Mootools" => "Mootools",
"Ajax" => "Ajax",
"XMLRPC API" => "XMLRPC API",
"Unix" => "Unix",
"Port" => "Port",
"port" => "port",
"IP" => "IP",
"PAM" => "PAM",
"LDAP" => "LDAP",
"Vertical" => "Vertical",
"Robots" => "Robots",
"Editor" => "Editor",
"Quota (Mb)" => "Quota (Mb)",
"Similar" => "Similar",
"Mods" => "Mods",
"DSN" => "DSN",
"x" => "x",
"Loc" => "Loc",
"Participants" => "Participants",
"Cat" => "Cat",
"Url" => "Url",
"Prio" => "Prio",
"Perso" => "Perso",
"h" => "h",
"Update" => "Update",
"Ver" => "Ver",
"Coms" => "Coms",
"article-put" => "article-put",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"mn" => "mn",
"PDF" => "PDF",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
"bcc" => "bcc",
"Change Focus" => "Change Focus",
"+" => "+",
"o" => "o",
"%m/%d" => "%m/%d",
"URL:" => "URL:",
"editor" => "editor",
"Client" => "Client",
"col" => "col",
"%" => "%",
"Language of newly translated page" => "Language of newly translated page",
"Change Language" => "Change Language",
"Important" => "Important",
"normal" => "normal",
"idea" => "idea",
"neutral" => "neutral",
"Universal" => "Universal",
"Int" => "Int",
"Manual" => "Manual",
"#" => "#",
"inter" => "inter",
"val" => "val",
"ver:" => "ver:",
"Proc" => "Proc",
"auto" => "auto",
"int" => "int",
"Inst Status" => "Inst Status",
"MultiTiki" => "MultiTiki",
"v" => "v",
"Impressions" => "Impressions",
"/" => "/",
"Vers." => "Vers.",
"Prefs" => "Prefs",
"Errors:" => "Errors:",
"Notes" => "Notes",
"quota" => "quota",
"Avatar:" => "Avatar:",
"P/F" => "P/F",
"tikiwiki.org" => "tikiwiki.org",
"\$name" => "\$name",
"eek" => "eek",
"lol" => "lol",
"razz" => "razz",
"santa" => "santa",
"Params" => "Params",
"Pos" => "Pos",
"Dif" => "Dif",
"Q" => "Q",
"A" => "A",
"Emot" => "Emot",
"pts" => "pts",
"Categories:" => "Categories:",
"Error:" => "Error:",
"%H:%M %Z" => "%H:%M %Z",
"tiki-mobile.php" => "tiki-mobile.php",
"Error: " => "Error: ",
"no" => "no",
"unicode" => "unicode",
// ###
// ### end of possibly untranslated words
// ###

"This feature is disabled" => "Aquesta característica està deshabilitada",
"Permission denied you cannot view pages" => "No tens autorització per veure pàgines",
"Cookies must be allowed to vote" => "Les galetes haurien de tenir dret al vot",
"This forum is flat and doesn't allow replies to other replies" => "Aquest fòrum és pla i no permet respostes a altres respostes",
"This script cannot be called directly" => "No es pot cridar a aquesta rutina directament",
"The copyright management feature is not enabled." => "La opció de gestió de copyright no està activada.",
"Copyright management" => "Gestió de Copyright",
"No page indicated" => "No s'ha indicat cap pàgina",
"You must supply all the information, including title and year." => "Has de facilitar tota la informació, incloent títol i any.",
"You do not have permission to use this feature" => "No tens permís per emprar aquesta característica",
"This feature is for admins only" => "Aquesta funcionalitat és només per administradors/es",
"Type" => "Tipus",
"Name" => "Nom",
"Description" => "Descripció",
"Size" => "Mida",
"Created" => "Creada",
"Uploaded" => "Carregat",
"Last Modified" => "Darrera modificació",
"Creator" => "Creador",
"Author" => "Autor",
"Last editor" => "Darrer editor",
"Comment" => "Comentari",
"Files" => "Arxius",
"Hits" => "Cops",
"Locked by" => "Bloquejat per",
"Path" => "Ruta",
"Slideshow" => "Passi de diapositives",
"Default View" => "Visualització per omissió",
"Afghanistan" => "Afganistan",
"Aland Islands" => "Illes_Aland",
"Albania" => "Albània",
"Algeria" => "Algèria",
"American Samoa" => "Samoa_Americana",
"Armenia" => "Armènia",
"Australia" => "Austràlia",
"Austria" => "Àustria",
"Azerbaijan" => "Azerbaitjan",
"Bahamas" => "Bahames",
"Bangladesh" => "Bangla_Desh",
"Belarus" => "Bielorússia",
"Belgium" => "Bèlgica",
"Benin" => "Benín",
"Bolivia" => "Bolívia",
"Bosnia and Herzegovina" => "Bosnia_i_Herzegovina",
"Bouvet Island" => "Illa_Bouvet",
"Brazil" => "Brasil",
"British Indian Ocean Territory" => "Territori_Britànic_de_l'Oceà_Índic",
"British Virgin Islands" => "Illes_Verge_Britàniques",
"Bulgaria" => "Bulgària",
"Burkina Faso" => "Burkina_Faso",
"Cambodia" => "Cambodja",
"Cameroon" => "Camerun",
"Canada" => "Canadà",
"Cape Verde" => "Cap_Verd",
"Catalan Countries" => "Països_Catalans",
"Cayman Islands" => "Illes_Caiman",
"Central African Republic" => "República_Centreafricana",
"Chad" => "Txad",
"Chile" => "Xile",
"China" => "Xina",
"Christmas Island" => "Illa_Christmas",
"Cocos Islands" => "Illes_Cocos",
"Colombia" => "Colòmbia",
"Comoros" => "Comores",
"Congo Democratic" => "Congo,_Repúlica_Democràtica",
"Cook Islands" => "Illes_Cook",
"Costa Rica" => "Costa_Rica",
"Croatia" => "Croàcia",
"Cyprus" => "Xipre",
"Czech Republic" => "República_Txeca",
"Denmark" => "Dinamarca",
"Dominican Republic" => "República_Dominicana",
"Ecuador" => "Equador",
"Egypt" => "Egipte",
"El Salvador" => "El_Salvador",
"Equatorial Guinea" => "Guinea_Equatorial",
"Estonia" => "Estònia",
"Ethiopia" => "Etiòpia",
"Europe" => "Europa",
"Falkland Islands" => "Illes_Malvines_(Falkland)",
"Faroe Islands" => "Illes_Fèroe",
"Federated States of Micronesia" => "Micronèsia,_Estats_Federats_de",
"Finland" => "Finlàndia",
"France" => "França",
"French Guiana" => "Guaiana_Francesa",
"French Polynesia" => "Polinèsia_Francesa",
"French Southern Territories" => "Territoris_Francesos_del_Sud",
"Gambia" => "Gàmbia",
"Georgia" => "Geòrgia",
"Germany" => "Alemanya",
"Greece" => "Grècia",
"Greenland" => "Groenlàndia",
"Guadeloupe" => "Guadalupe",
"Guinea Bissau" => "Guinea_Bissau",
"Haiti" => "Haití",
"Heard Island and McDonald Islands" => "Illa_Heard_i_Illes_McDonald",
"Honduras" => "Hondures",
"Hong Kong" => "Hong_Kong",
"Hungary" => "Hongria",
"Iceland" => "Islàndia",
"India" => "Índia",
"Indonesia" => "Indonèsia",
"Ireland" => "Irlanda",
"Isle of Man" => "Illa de Man",
"Italy" => "Itàlia",
"Ivory Coast" => "Costa d'Ivori",
"Japan" => "Japó",
"Jersey" => "Jersei",
"Jordan" => "Jordània",
"Kazakstan" => "Kazakhstan",
"Kyrgyzstan" => "Kirguizistan",
"Latvia" => "Letònia",
"Lebanon" => "Líban",
"Liberia" => "Libèria",
"Libya" => "Líbia",
"Lithuania" => "Lituània",
"Macao" => "Macau",
"Macedonia" => "Macedònia",
"Marshall Islands" => "Illes_Marshall",
"Martinique" => "Martinica",
"Mauritania" => "Mauritània",
"Mauritius" => "Maurici",
"Mexico" => "Mèxic",
"Moldova" => "Moldàvia",
"Monaco" => "Mònaco",
"Mongolia" => "Mongòlia",
"Morocco" => "Marroc",
"Mozambique" => "Moçambic",
"Namibia" => "Namíbia",
"Netherlands Antilles" => "Antilles_Holandeses",
"Netherlands" => "Països_Baixos",
"New Caledonia" => "Nova_Caledònia",
"New Zealand" => "Nova_Zelanda",
"Niger" => "Níger",
"Nigeria" => "Nigèria",
"None" => "Cap",
"Norfolk Island" => "Illa_Norfolk",
"North Korea" => "Corea_del_Nord",
"Northern Mariana Islands" => "Illes_Marianes_del_Nord",
"Norway" => "Noruega",
"Other" => "Altre/a",
"Palestine" => "Palestina",
"Panama" => "Panamà",
"Papua New Guinea" => "Papua_Nova_Guinea",
"Paraguay" => "Paraguai",
"Peru" => "Perú",
"Philippines" => "Filipines",
"Poland" => "Polònia",
"Puerto Rico" => "Puerto_Rico",
"Quatar" => "Qatar",
"Republic of Macedonia" => "Macedònia",
"Russia" => "Rússia",
"Russian Federation" => "Rússia",
"Saint Helena" => "Saint_Helena",
"Saint Kitts and Nevis" => "Saint_Christopher_i_Nevis",
"Saint Lucia" => "Saint_Lucia",
"Saint Pierre and Miquelon" => "Saint_Pierre_i_Miquelon",
"San Marino" => "San_Marino",
"Sao Tome and Principe" => "Sao_Tome_i_Príncipe",
"Saudi Arabia" => "Aràbia_Saudita",
"Serbia" => "Sèrbia",
"Sierra Leone" => "Sierra_Leone",
"Singapore" => "Singapur",
"Slovakia" => "Eslovàquia",
"Slovenia" => "Eslovènia",
"Solomon Islands" => "Illes_Solomó",
"Somalia" => "Somàlia",
"South Africa" => "Sud-àfrica",
"South Georgia and South Sandwich Islands" => "Illes_Geòrgia_del_Sud_i_Sandwich_del_Sud",
"South Korea" => "Corea_del_Sud",
"Spain" => "Espanya",
"Sri Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "St._Vincent_i_les_Grenadines",
"Svalbard and Jan Mayen" => "Svalbard_i_Jan_Mayen",
"Swaziland" => "Swazilàndia",
"Sweden" => "Suècia",
"Switzerland" => "Suïssa",
"Syria" => "Síria",
"Tajikistan" => "Tadjikistan",
"Tanzania" => "Tanzània",
"Thailand" => "Tailàndia",
"Trinidad Tobago" => "Trinitat_i_Tobago",
"Tunisia" => "Tunísia",
"Turkey" => "Turquia",
"Turks and Caicos Islands" => "Illes_Turks_i_Caicos",
"US Virgin Islands" => "Illes_Verge_Americanes",
"Ukraine" => "Ucraïna",
"United Arab Emirates" => "Unió_dels_Emirats_Àrabs",
"United Kingdom" => "Regne_Unit",
"United Nations Organization" => "Organització de les Nacions Unides",
"United States Minor Outlying Islands" => "Illes_Perifèriques_Menors_dels_EUA",
"United States" => "Estats_Units_(EUA)",
"United_Nations_Organization" => "Organització_de_les_Nacions_Unides",
"Uruguay" => "Uruguai",
"Vatican" => "Vaticà",
"Venezuela" => "Veneçuela",
"Viet Nam" => "Vietnam",
"Wallis and Futuna" => "Wallis_i_Futuna",
"Western Sahara" => "Sàhara_Occidental",
"World" => "Món",
"Yemen" => "Iemen",
"Yugoslavia" => "Iugoslàvia",
"Zambia" => "Zàmbia",
"Text_Wiki libraries need to be installed. Please see http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter" => "Cal instal·lar les llibreries Text_Wiki. Si us plau, consulta http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter",
"MySQL Improved (mysqli). Requires MySQL 4.1+" => "Controlador de MySQL Millorat (mysqli). Requereix MySQL 4.1+",
"MySQL classic (mysql)" => "MySQL clàssic (mysql)",
"Email address not valid, test mail not sent" => "Adreça de correu-e invàlida, no s'ha pogut enviar el correu-e de prova",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Adreça de correu-e buida i la casella de verificació de \"copia\" no ha estat seleccionada, no s'ha enviat el correu-e de prova",
"Test mail from Tiki installer " => "Correu-e de prova des de l'instal·lador de Tiki ",
"Congratulations!\n\nYour server can send emails.\n\n" => "Felicitats!\n\nEl teu servidor pot enviar correus-e.\n\n",
"Arabic" => "Àrab",
"Catalan" => "Català",
"Simplified Chinese" => "Xinès Simplificat",
"Chinese" => "Xinès",
"Czech" => "Txec",
"Danish" => "Danès",
"German" => "Alemany",
"English" => "Anglès",
"English British" => "Anglès Britànic",
"Spanish" => "Castellà",
"Greek" => "Grec",
"Finnish" => "Finès",
"Fijian" => "Fijià",
"French" => "Francès",
"Galician" => "Gallec",
"Hebrew" => "Hebreu",
"Croatian" => "Croat",
"Italian" => "Italià",
"Japanese" => "Japonès",
"Korean" => "Coreà",
"Hungarian" => "Hongarès",
"Dutch" => "Dels Països Baixos",
"Norwegian" => "Noruec",
"Polish" => "Polonès",
"Português" => "Portuguès",
"Brazilian Portuguese" => "Portuguès-Brasiler",
"Russian" => "Rus",
"Pijin Solomon" => "Pidgin de les illes Salomó",
"Slovak" => "Eslovac",
"Serbian" => "Serbi",
"Serbian Latin" => "Serbi Llatí",
"Swedish" => "Suec",
"Tuvaluan" => "Tuvaluà",
"Traditional Chinese" => "Xinés traditional",
"Ukrainian" => "Ukranià",
"This instance of activity is already complete" => "Aquesta instància d'activitat ja és completa",
"Fatal error: cannot execute automatic activity \$activityId" => "Error crític: no es pot executar l'activitat automàtica  \$activityId",
"Fatal error: setting next activity to an unexisting activity" => "Error crític: dirigint propera activitat a una activitat inexistent",
"Fatal error: nextActivity does not match any candidate in autorouting switch activity" => "Error crític: nextActivity no coincideix amb el canvi programat d'activitat",
"Fatal error: non-deterministic decision for autorouting activity" => "Error crític: Decisió no determinant per a autodirigir l'activitat",
"Fatal error: trying to send an instance to an activity but no transition found" => "Error crític: intentant enviar una instància a una activitat però sense transició trobada",
"Cannot add transition only split activities can have more than one outbound transition" => "No es pot afegir una transició, només les activitats partides poden tenir més d'una transició externa",
"Circular reference found some activity has a transition leading to itself" => "referència Circular trobada , alguna activitat té una transició cap a sí mateixa",
"Process does not have a start activity" => "El procés no te cap activitat inicial",
"Process does not have exactly one end activity" => "El procés no te exactament cap activitat final",
"End activity is not reachable from start activity" => "Finalitzar l'activitat no és possible des del començament de l'activitat",
"Activity" => "Activitat",
"is interactive but has no role assigned" => "és interactiu però no té funció assignada",
"is non-interactive and non-autorouted but has no role assigned" => "no és interactiu ni tampoc autodirigit ni té funció assignada",
"is standalone but has transitions" => "està en solitari però té transicions",
"Role" => "Rol",
"is not mapped" => "no està mapejat",
"Activity '.\$res['name'].' is standalone and is using the \$instance object" => "L'activitat '.\$res['name'].' està per separat i està fent servir l'objecte \$instance",
"Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "L'activitat '.\$res['name'].' és interactiva ja que fa servir el mètode \$instance->complete()",
"Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "L'activitat '.\$res['name'].' no és interactiva ja que no fa servir el mètode \$instance->complete()",
"Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "L'activitat '.\$res['name'].' està canviant i farà servir el mètode \$instance->setNextActivity(\$actname)",
"Process %d has been activated" => "El procés %d s'ha activat",
"Process %d has been deactivated" => "El procés %d s'ha desactivat",
"Process %s %s imported" => "Importat el proces %s %s",
"Process %s removed" => "El procés %s s'ha borrat",
"Process %s has been updated" => "El procés %s s'ha actualitzat",
"Process %s has been created" => "El procés %s s'ha creat",
"points" => "punts",
"newest" => "el més nou",
"oldest" => "el més antic",
"on left side" => "a l'esquerra",
"on center" => "al centre",
"on right side" => "a la dreta",
"Disabled" => "Deshabilitades",
"Plain text" => "Text senzill",
"Link to user information" => "Enllaç a la informació d'usuari",
"User avatar" => "Avatar de l'usuari/a",
"Creation date (desc)" => "Data de creació (desc)",
"Last modification date (desc)" => "Data de l'última modificació (desc)",
"Blog title (asc)" => "Títol de la bitàcola (asc)",
"Number of posts (desc)" => "Nombre de publicacions (desc)",
"Visits (desc)" => "Visites (desc)",
"Activity (desc)" => "Activitat (desc)",
"Top bar" => "Barra d'encapçalament",
"Bottom bar" => "Barra al peu",
"no cache" => "Sense memòria cau",
"minute" => "minut",
"minutes" => "minuts",
"hour" => "hora",
"hours" => "hores",
"as Creator &amp; Last Editor" => "com Creador &amp; Darrer Editor",
"Business style" => "Estil de Negocis",
"Collaborative style" => "Estil col·laboratiu",
"Page last modified on" => "Darrera modificació de la pàgina el",
"no (disabled)" => "no (desactivat)",
"|| for rows" => "|| per files",
"<return> for rows" => "\n for rows",
"Only with last version" => "Només amb la darrera versió",
"Any 2 versions" => "Qualsevol parell de 2 versions",
"complete" => "complet/a",
"latin" => "llatí",
"english" => "anglès",
"Day" => "Dia",
"Week" => "Setmana",
"Month" => "Mes",
"Quarter" => "Quadrimestre",
"Semester" => "Semestre",
"Year" => "Any",
"Saturday" => "Dissabte",
"Sunday" => "Diumenge",
"Monday" => "dilluns",
"Depends user language" => "Depèn de l'idioma de l'usuari",
"No error reporting" => "Sense report d'errors",
"Report all PHP errors" => "Reportar tots els errors de PHP",
"Report all errors except notices" => "Reportar tots els errors excepte les notificacions",
"Creation Date (asc)" => "Data de creació (asc)",
"Creation Date (desc)" => "Data de creació (desc)",
"Topics (desc)" => "Temes (desc)",
"Threads (desc)" => "Missatges (desc)",
"Last post (desc)" => "Últim post (desc)",
"Name (desc)" => "Nom (desc)",
"Name (asc)" => "Nom (asc)",
"Score ascending" => "Ascendent per puntuació",
"Score descending" => "Descendent per puntuació",
"Name ascending" => "Ascendent per Nom de l'Usuari",
"Name descending" => "Descendent per Nom de l'Usuari",
"Login ascending" => "Ascendent per Nom de Connexió d'usuari",
"Login descending" => "Descendent per Nom de Connexió d'usuari",
"replace current window" => "susbtitueix la finestra actual",
"new window" => "nova finestra",
"inline frame" => "marc en línia",
"Q and A" => "P i R",
"Question ID" => "Identificador de pregunta",
"Each day" => "Cada dia",
"Each week" => "Cada setmana",
"Each month" => "Cada mes",
"CRLF (standard)" => "CRLF (estàndard)",
"LF (some Unix MTA)" => "LF (alguns MTA Unix)",
"5 minutes" => "5 minuts",
"15 minutes" => "15 minuts",
"30 minutes" => "30 minuts",
"1 hour" => "1 hora",
"2 hours" => "2 hores",
"10 hours" => "10 hores",
"20 hours" => "20 hores",
"1 day" => "1 dia",
"1 week" => "1 setmana",
"1 month" => "1 mes",
"1 year" => "1 any",
"Allow secure (https) login" => "Permet connexió segura (https)",
"Encourage secure (https) login" => "Anima a emprar connexió segura (https)",
"Consider we are always in HTTPS, but do not check" => "Considera que som sempre en HTTPS, però no comprovis",
"Require secure (https) login" => "Requereix connexió segura (https)",
"tikihash (old)" => "tikihash (vell)",
"Just Tiki" => "Només Tiki",
"Web Server" => "Servidor Web",
"Tiki and PEAR::Auth" => "Tiki i PEAR::Auth",
"Tiki and PAM" => "Tiki i PAM",
"CAS (Central Authentication Service)" => "CAS (Servei Central d'Autenticació)",
"OpenID and Tiki" => "OpenID i Tiki",
"choose a group ..." => "escull un grup ...",
"Registered" => "Enregistrats/des",
"Anonymous" => "Anònim/a",
"Never use transition css" => "No empris mai css de transició",
"Use @version:x.x specified in theme css or none if not specified" => "Empra @versio:x.x especificada en el css del tema d'estil o cap si no se n'ha especificat",
"Use @version:x.x specified in theme css or 1.9 if not specified" => "Empra @versio:x.x especificada en el css del tema d'estil o 1.9 si no se n'ha especificat",
"Use @version:x.x specified in theme css or 2.0 if not specified" => "Empra @versio:x.x especificada en el css del tema d'estil o 2.0 si no se n'ha especificat",
"LastModif" => "Última modificació",
"Use database to store files" => "Empra la base de dades per desar arxius",
"Use a directory to store files" => "Empra un directori per desar arxius",
"Ascending" => "Ascendent",
"Descending" => "Descendent",
"No forums" => "No hi ha fòrums",
"%s enabled" => "%s activat",
"\$feature is turned on" => "\$feature es troba activada",
"%s disabled" => "%s desactivat",
"\$feature is turned off" => "\$feature es troba desactivada",
"\$feature set to nothing" => "\$feature posada a res",
"Permission denied" => "Permís denegat",
"Template %s not registered" => "Plantilla %s no registrada",
"The file is not a CSV file or has not a correct syntax" => "El fitxer no és del tipus CSV file o no té una sintaxi correcta",
"Error line: %d" => "Línia amb error: %d",
"locked" => "bloquejat",
"locked by" => "bloquejat per",
"Administration:" => "Administració:",
"in" => "a",
"continued" => "continuat",
"New Image Uploaded by" => "Nova imatge pujada per",
"New Subscriptions" => "Subscripcions noves",
"New Item in Tracker" => "Nova entrada al formulari",
"tracker" => "formulari",
"by" => "per",
"Image Gallery" => "Galeria d'imatges",
"Blogs" => "Bitàcoles",
"Forums" => "Fòrums",
"Directory" => "Directori",
"File Gallery" => "Galeria d'arxius",
"FAQs" => "PUFs",
"Quizzes" => "Qüestionaris",
"Trackers" => "Formularis",
"Survey" => "Enquesta",
"Newsletter" => "Butlletins",
"Charts" => "Gràfics (en desús - no recomanat)",
"blog" => "bitàcola",
"directory" => "directori",
"faq" => "pmf",
"file gallery" => "galeria d'arxius",
"forum" => "fòrum",
"image gallery" => "galeria d'imatges",
"newsletter" => "butlletí",
"poll" => "votacions",
"quiz" => "qüestionari",
"survey" => "enquesta",
"wiki page" => "pàgina wiki",
"image" => "imatge",
"calendar" => "calendari",
"Invalid filename (using filters for filenames)" => "Nom d'arxiu Invàlid (usant filtres per a noms d'arxius)",
"Cannot upload this file maximum upload size exceeded" => "No es pot pujar aquest arxiu , supera el límit màxim de mida",
"(not registered)" => "(no registrat)",
"You have mistyped the anti-bot verification code; please try again." => "T'has confòs en teclejar el codi de verificació anti-robots; prova-ho de nou, si us plau.",
"Please wait %d secondes between posts" => "Si us plau, espera %d segons entre publicacions",
"Wrong password. Cannot post comment" => "Contrasenya errònia. No pots publicar el comentari",
"A contribution is mandatory" => "És necessari especificar algun tipus de contribució",
"You have to enter a title and text" => "Has d'introduir un títol i text",
"Invalid Email" => "Correu-e invàlid",
"Your message has been queued for approval, the message will be posted after a moderator approves it." => "El teu missatge ha estat posat a la qua de moderació per ser aprovat; es publicarà el missatge quan un moderador l'aprovi.",
"This forum is locked" => "Aquest fòrum està bloquejat",
"This thread is locked" => "Aquest fil de discussió està bloquejat",
"Those comments are locked" => "Aquests comentaris estan bloquejats",
"text" => "texte",
"Face" => "Cara",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::applica: manca de coincidència del contador de línies: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check: error",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: la seqüència d'edició no és óptima",
"WikiDiff Okay: LCS = %s" => "WikiDiff Ok: LCS = %s",
"Line:" => "Línia:",
"Lines:" => "Línies:",
"Newsletter subscription information at" => "La informació de subscripció a butlletins es troba a",
"Tiki Link - Insert internal link" => "Enllaç tiki - insereix un enllaç intern",
"Select a Wiki page to link to:" => "Selecciona una pàgina wiki per enllaçar:",
"Find" => "Cerca",
"find" => " troba",
"prev" => "ant",
"Page" => "Pàgina",
"next" => "prop",
"Link" => "Enllaç",
"Page name" => "Nom de la pàgina",
"Cannot open this file:" => "No puc obrir aquest arxiu:",
"This is the value of your server's PHP '%s' setting" => "Aquest és el valor de la configuració PHP '%s' del teu servidor",
"You are alerted by the server " => "Estàs alertat pel servidor ",
"You can check the modifications at : " => "Pots comprovar les modificacions a : ",
"You are alerted of a change on " => "Està alertat de canvis sobre ",
"Wiki Home" => "Inici del Wiki",
"Home" => "Inici",
"Blog" => "Bitàcola",
"previous page" => "pàgina anterior",
"next page" => "pàgina següent",
"posted on" => "publicat el",
"Continue" => "Continua",
"By:" => "Per",
"Read" => "Llegeix",
"List articles" => "Llistar articles",
"Last post" => "Darrer enviament",
"Invalid imagename (using filters for filenames)" => "Invàlid nom d'imatge (usant filtres per a noms d'arxius)",
"Errors detected" => "Errors detectats",
"Upload was not successful" => "La pujada no s'ha realitzat amb èxit",
"No image yet, sorry." => "Ho sento, encara no hi ha cap imatge.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "directori de destinació desconegut. Configura'l a <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "no s'ha pogut treure l'enllaç",
"Contributions" => "Contribucions",
"Query point:" => "Punt de la consulta:",
"layer:" => "capa:",
"Record:" => "Registre:",
"No valid ogr2ogr executable" => "No hi ha cap executable ogr2ogr vàlid",
"Could not create \$tdo.mif in data directory" => "No s'ha pogut crear \$tdo.mif en el directori de dades",
"Could not create \$tdo.mid in data directory" => "No s'ha pogut crear \$tdo.mid en el directori de dades",
"unknown" => "desconegut",
"User Map Generated in:" => "Mapa d'usuaris generat a:",
"Image Map Generated in:" => "Mapa d'imatges generat a:",
"You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it." => "Només pots utilitzar optionId = 0 per crear una nova opció, o optionId igual a una id que ja pertanyi al menú per actualitzar-la.",
"menu" => "menú",
"NONE" => "CAP",
"File %s not found" => "No s'ha trobat l'arxiu %s ",
"File %s is not a valid archive" => "L'arxiu %s no és un arxiu vàlid",
"Impossible to open %s : %s" => "Impossible obrir %s : %s",
"The content retrieved at %s is not a list of mods" => "El contingut recuperat a %s no és una llista de mods",
"Can't chdir to '%s'" => "No es pot chdir a '%s'",
"%s impossible to remove" => "No es pot eliminar %s",
"section edit" => "secció edició",
"This poll is closed." => "Votació tancada.",
"Created by profile installer" => "Creat per l'instal·lador de perfils",
"Page updated by profile installer" => "Pàgina actualitzada per l'instal·lador de perfils",
"Wiki top pages" => "Planes Wiki més actives",
"Most relevant pages" => "Pàgines més rellevants",
"Relevance" => "Rellevancia",
"Wiki last pages" => "Darreres planes Wiki",
"Modified" => "Modificat",
"Forums last topics" => "Fòrums: darrers temes",
"Topic date" => "Data de tòpic",
"Forums last posts" => "Fòrums: darrers enviaments",
"Forums most read topics" => "Temes més llegits dels Fòrums",
"Reads" => "Lectures",
"Forums best topics" => "Fòrums: millors temes",
"Score" => "Puntuació",
"Forums most visited forums" => "Fòrums més visitats",
"Visits" => "Visites",
"Forums with most posts" => "Fòrums amb més escrits",
"Posts" => "Publicacions",
"Wiki top galleries" => "Galeries d'imatges Wiki més actives",
"Wiki top file galleries" => "Galeries de fitxers Wiki més actives",
"Wiki top images" => "Imatges Wiki més visitades",
"Wiki top files" => "Fitxers Wiki més vists",
"Downloads" => "Descàrregues",
"Wiki last images" => "Darreres imatges Wiki",
"Upload date" => "Data de pujada",
"Wiki last files" => "Darrers fitxers Wiki",
"Wiki top articles" => "Articles Wiki més actius",
"Most visited blogs" => "Bitàcoles més visitades",
"Most active blogs" => "Bitàcoles s més actives",
"Blogs last posts" => "Darrers enviaments a la Bitàcola",
"Post date" => "Data de publicació",
"Wiki top authors" => "Autors Wiki més actius",
"Pages" => "Pàgines",
"Top article authors" => "Els autors d'articles més actius",
"The passwords do not match" => "Les contrasenyes no coincideixen",
"User already exists" => "Aquest usuari ja existeix",
"Wrong registration code" => "Codi de registrament erroni",
"Invalid username" => "El nom de l'usuari no és vàlid",
"Username is too long" => "El nom de l'usuari és massa llarg",
"Username cannot contain whitespace" => "El nou nom d'usuari ha de ser introduït sense espais en blanc",
"Wrong passcode you need to know the passcode to register in this site" => "Codi de registre no vàlid. Necessites saber el codi de registre per donar-te d'alta en aquest lloc web",
"Invalid email address. You must enter a valid email address" => "Adreça d'email Invàlida. Introdueix-ne una altra",
"The registration mail can't be sent. Contact the administrator" => "No es pot enviar el mail de registre. Contacteu amb l'administrador",
"Feed provided by %s. Click to visit." => "Canal d'informació proporcionat per %s. Fes clic per visitar-lo.",
"Login" => "Connecta't",
"See other user's profile" => "Mira el perfil dels altres usuaris",
"Have your profile seen" => "Tingues el teu perfil visible",
"Make friends" => "Fes amistats",
"Receive message" => "Rep missatge",
"Send message" => "Envia missatge",
"Read an article" => "Llegeix un article",
"Publish an article" => "Publica un article",
"Have your article read" => "Tingues el teu article llegit",
"Create new file gallery" => "Crea una nova galeria d'arxius",
"Upload new file to gallery" => "Puja un arxiu nou a la galeria",
"Download other user's file" => "Descarrega l'arxiu d'altres usuaris",
"Have your file downloaded" => "Tingues el teu arxiu descarregat",
"Create a new image gallery" => "Crea una nova galeria d'imatges",
"Upload new image to gallery" => "Puja una nova imatge a la galeria",
"See other user's gallery" => "Mira la galaeria d'altres usuaris",
"See other user's image" => "Mira la imatge d'altres usuaris",
"Have your gallery seen by other user" => "Tingues la teva galeria vista per altres usuaris",
"Have your image seen" => "Tingues la teva imatge vista",
"Create new blog" => "Crea una bitàcola nova",
"Post in a blog" => "Publica en una bitàcola",
"Read other user's blog" => "Llegeix la bitàcola d'altres usuaris",
"Have your blog read" => "Tingues la teva bitàcola llegida",
"Create a new wiki page" => "Crea una nova pàgina wiki",
"Edit an existing page" => "Edita una pàgina existent",
"Attach file" => "Adjuntar arxiu",
"Tracker" => "Formulari",
"Unknown" => "Desconegut/da",
"Trackeritem" => "Ítemdeformulari",
"Image" => "Imatge",
"Directory category" => "Directori de la categoria",
"FAQ" => "PUF",
"Forum" => "Fòrum",
"Wiki Comment" => "Comentari Wiki",
"Calendar item" => "Ítem del Calendari",
"Gallery" => "Galeria",
"Blog post" => "Publicació de Bitàcola",
"Tracker item" => "Item del formulari",
"Advanced" => "Avançat",
"_HOMEPAGE_CONTENT_" => "{GROUP(groups=Admins)}\n! Gràcies per instal·lar Tiki.\n\nLa Comunitat de Tiki en conjunt voldria donar-te les gràcies i ajudar-te amb la teva introducció a Tiki.\n\n! Com començar\nTiki té més de 1000 funcionalitats i ajustaments.\n\nAixò li permet crear llocs web des de molt simples fins a molt complexos.\n\nEntenem que un programari amb tantes característiques pot semblar aclaparador al principi. Aquesta és la raó per la que t'oferim dues maneres diferents per __Posar-te en marxa__ amb Tiki.\n\n{SPLIT()}\n-= Ajust fàcil emprant Perfils =-\n!! [tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|Posa't en marxa emprant Perfils]\n__Qui hauria d'emprar això__\n* Vols començar ràpidament\n* No tens ganes d'aprendre el Panell d'Administració immediatament\n* Vols provar de forma ràpida algunes funcionalitats de Tiki\n\n!! Perfils destacats\n\n__Comunitat Col·laborativa__ ([tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instal·la el perfil ara])\nConfiguració per ajudar a entusiastes i experts en les vostres matèries a treballar conjuntament per construir una Base de Coneixement\n* Edició de Wiki\n* Espais personals per als membres\n* Fòrums\n* Bitàcoles\n\n__Bitàcola i perfil personal__ ([tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instal·la el perfil ara])\nConfiguració amb moltes funcionalitats guais per ajudar-te a ser part de la Web Social i establir-te una presència notable a la Blogosfera\n* Bitàcola (Conjunt complert de característiques relacionades amb la bitàcola)\n* Galeria d'Imatges\n* Calendari\n* Integració RSS\n* Registre de vídeos\n\n__Intranet d'Empresa__ ([tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instal·la el perfil ara])\nConfiguració per a una intranet d'Empresa d'un negoci típic de mida mitjana (PIME).\n* Articles de Notícies de l'Empresa\n* Bloc Executiu\n* Gestió d'arxius i repositoris\n* Wiki col·laboratiu\n\n__Presència Web d'una Organització Petita__ ([tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instal·la el perfil ara])\nConfiguració per a la presència web d'una entitat sense ànim de lucre, ONG o petita empresa típica.\n* Notícies de l'entitat i actualitzacions\n* Destacar els Productes i Serveis de l'entitat\n* Galeria d'arxius (ideal per a un kit per als mitjans de comunicació)\n* Formulari de Contacte\n---\n-= Configuració Manual emprant el Panell d'Administració =-\n! [tiki-admin.php|Posa't en marxa emprant el Panell d'Administració]\n__Qui hauria d'emprar això__\n* Estàs familiaritzat amb panells d'administració de programes\n* T'agrada explorar i jugar amb moltes opcions\n* Ja coneixes Tiki\n\n\n{SPLIT}\n{ELSE}\n\n! Felicitats\nAquesta és la pàgina Inicial per omissió per al teu Tiki. Si veus aquesta pàgina, la teva instal·lació s'ha realitzat correctament.\n\nPots canviar aquesta pàgina després de connectar-te. Si us plau, revisa la [http://doc.tikiwiki.org/wiki+syntax|sintaxi wiki] per als detalls d'edició.\n\n!!{img src=pics/icons/star.png alt=\"Star\"} Posa't en marxa.\n\nPer començar la configuració del teu lloc:\n{FANCYLIST()}\n1) Inicia la sessió com a usuari __admin__ amb contrasenya __admin__.\n2) Canvia la contrasenya d'administrador.\n3) Habilita funcionalitats específiques de Tiki.\n4) Configura les funcionalitats.\n{FANCYLIST}\n\n\n!!{img src=pics/icons/help.png alt=\"Help\"} Necessites ajuda?\nPer a més informació:\n* [http://info.tikiwiki.org/Learn+More|Més informació sobre TikiWiki].\n* [http://info.tikiwiki.org/Help+Others|Obtenir ajuda], inclosos la [http://doc.tikiwiki.org|documentació oficial] i els [http://www.tikiwiki.org/forums|fòrums de suport].\n* [http://info.tikiwiki.org/Join+the+community| Uneix-te a la comunitat TikiWiki].\n{GROUP}",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- connector smarty jq inactiu: feature_jquery desactivada -->",
"Fast Next" => "Següent ràpid",
"Fast Prev" => "Previsualització ràpida",
"Prev" => "Previ",
"Next" => "Següent",
"First {\$params['itemname']}" => "Primer {\$params['itemname']}",
"Last {\$params['itemname']}" => "Últim {\$params['itemname']}",
"Next {\$params['itemname']}" => "Següent {\$params['itemname']}",
"Prev {\$params['itemname']}" => "Previ {\$params['itemname']}",
"You need either JQuery or MooTools enabled for this feature" => "Necessites o bé JQuery o MooTools habilitats per a aquesta funcionalitat",
"Help page:" => "Pàgina d'ajuda:",
"View tpl:" => "Visualitza tpl:",
"Edit Template" => "Edita plantilla",
"Admin Feature" => "Administra Funcionalitat",
"Hide" => "Oculta",
"help" => "ajuda",
"All" => "Tots",
"The text is" => "El text és",
"character(s) too long - please edit it." => "caràcter(s) massa llarg - si us plau edita-ho.",
"Date Selector" => "Selector de Data",
"phplayers are not available on this site" => "phplayers no estan disponibles en aquesta web",
"Select All" => "Selecciona-ho tot",
"Invert Sort" => "Inverteix l'ordre",
"days" => "dies",
"day" => "dia",
"mins" => "minuts",
"secs" => "segs",
"sec" => "s",
"done" => "fet",
"Text cut here" => "Tall del text aquí",
"Task" => "Tasca",
"from" => "des de",
"for" => "per a",
"Priority" => "Prioritat",
"Start date:" => "Data d'inici:",
"End date:" => "Data de fi:",
"User information - Click for more info" => "Informació de l'usuari - Punxa per més informació",
"Friend" => "Amic",
"Last seen on" => "Vista per darrera vegada el",
"(idle for %s seconds)" => "(inactiu durant %s segons)",
"More info about \$other_user" => "Més informació sobre l'usuari \$other_",
"(idle for \$idletime seconds)" => "(inactiu durant \$idletime segons)",
"Yes" => "Si",
"Use this tree to copy the structure" => "Empra aquest arbre per copiar l'estructura",
"created from structure" => "creat des d'estructura",
"Table of contents" => "Taula de continguts (índex)",
"You have to make %d choice(s) for the question" => "Has de fer %d elecció(ons) per a la pregunta",
"You have to make at least %d choice(s) for the question" => "Has de fer al menys %d elecció(ons) per a la pregunta",
"You have to make less than %d choice(s) for the question" => "Has de fer menys de %d eleccions per a la pregunta",
"You have to choose at least %d choice(s) for the question" => "Has d'escollir al menys %d elecció(ons) per a la pregunta",
"unknown error" => "error desconegut",
"You are not logged in" => "No està connectat",
"Page cannot be found" => "No s'ha pogut trobar la pàgina",
"Page '%0' cannot be found" => "No es pot trobar la pàgina '%0'",
"Permission denied you cannot view this section" => "Permís denegat per accedir a aquesta secció",
"For the security of your password direct access to the feed is only available via https" => "Per la seguretat de la teva contrasenya, l'accés directe a l'alimentació només és troba disponible via https",
"An error occured in a database query!" => "Ha hagut un error en una petició de la base de dades!",
"Help link" => "Enllaç d'ajuda",
"Help" => "Ajuda",
"You are banned from" => "Estàs exclós des de",
"img-g" => "g-img",
"file-g" => "g-arx",
"faqs" => "pufs",
"quizzes" => "qüestionaris",
"blogs" => "bitàcoles",
"forums" => "fòrums",
"games" => "jocs",
"Edit Plugin" => "Edita el Connector (Plugin)",
"Click to edit dynamic variable" => "Punxa per editar variable dinàmica",
"Update variables" => "Actualitza variables",
"Edit Section" => "Edita la secció",
"index" => "índex",
"Show" => "Mostra",
"You are not allowed to upload this type of file." => "No tens permisos per penjar aquest tipus de fitxer.",
"The file you are trying upload was only partially uploaded." => "L'arxiu que proves de penjar només s'ha carregat parcialment.",
"You must select a file." => "Has de seleccionar un arxiu.",
"Altering database table failed" => "Ha fallat l'alteració de la taula de la base de dades",
"%d points" => "%d punts",
"Removed" => "Eliminat/da",
"__WARNING__: No such module \$plugin!" => "__ATENCIÓ__: No existeix el mòdul \$plugin!",
"at" => "a",
"new" => "nou",
"Create page:" => "Crea pàgina:",
"Unknown language" => "Llenguatge desconegut",
"Click here to confirm your action" => "Fes clic aquí per confirmar la teva acció",
"Sea Surfing (CSRF) detected. Operation blocked." => "Sea Surfing (CSRF) detectat. Operació bloquejada.",
"Rating" => "Puntuació",
"Upload was not successful. Duplicate file content ?" => "La càrrega no s'ha realitzat correctament. Vols duplicar el contingut de l'arxiu?",
"Item Modification" => "Modificació de l'ítem",
"Item" => "Ïtem",
"Item creation" => "Creació de l'ítem",
"Subject" => "Tema",
"Tracker was modified at " => "El formulari va ser modificat el ",
"View the tracker item at:" => "Visualitza l'ítem del formulari a:",
"Field is not numeric" => "El camp no és numèric",
"Field is not a link to mp3 in the gallery" => "El camp no és un enllaç a mp3 de la galeria",
"Field is not a link to FLV in the gallery" => "El camp no és un enllaç a FLV de la galeria",
"Field is not a link to FLV or MP3 in the gallery" => "El camp no és un enllaç a FLV o mp3 de la galeria",
"text field" => "camp de text",
"half column" => "mitja columna",
"size" => "mida",
"prepend" => "prefix",
"append" => "sufix",
"max" => "màx",
"textarea" => "areadetext",
"checkbox" => "requadre de verificació",
"numeric field" => "camp numèric",
"drop down" => "desplegable",
"drop down with other textfield" => "desplegable amb un altre camp de text",
"radio buttons" => "botons radio",
"user selector" => "selector de l'usuari",
"group selector" => "selector del grup",
"country selector" => "selector de país",
"date and time" => "data i hora",
"jscalendar" => "jscalendari",
"action" => "acció",
"header" => "capçalera",
"static text" => "text estàtic",
"category" => "categoria",
"item link" => "enllaç als ítems (desplegable)",
"items list" => "llista d'ítems",
"dynamic items list" => "Llista dinàmica d'ítems",
"email" => "correu-e",
"multimedia" => "multimèdia",
"user subscription" => "subscripció d'usuari",
"Google Maps" => "Mapes de Google",
"system" => "sistema",
"computed field" => "camp calculat",
"user preference" => "preferència de l'usuari",
"attachment" => "adjunt",
"open" => "obert",
"pending" => "pendent",
"closed" => "tancat",
"Message" => "Missatge",
"No extra information for that attached file. " => "No hi ha informació extra per aquest fitxer adjunt. ",
"child categories" => "categories infantils",
"objects in category" => "objectes dins la categoria",
"(AT)" => "(ARROBA)",
"(DOT)" => "(PUNT)",
"The administrator has not yet validated your account. Please wait." => "L'administrator no ha validat el teu compte encara. Si us plau, espera.",
"You must validate your account first. An email has been sent to you" => "Primer has de validar el teu compte. Se t'ha enviat un correu-e",
"Password should be at least" => "El password hauria de ser com a mínim",
"characters long" => "caràcters de llarg com a mínim",
"Password must contain both letters and numbers" => "La contrasenya ha de contenir tant lletres com números",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "No es pot enviar el correu-e de registre de noves altes per que no hi ha especificada cap adreça de correu-e, i la funcionalitat està desactivada",
"The user email confirmation can't be sent. Contact the administrator" => "No es pot enviar el correu-e de confirmació de l'usuari. Contacta l'administrador",
"Personal Phone" => "Telèfon personal",
"Personal Mobile" => "Mòbil personal",
"Personal Fax" => "Fax personal",
"Work Phone" => "Telèfon de la feina",
"Work Mobile" => "Mòbil de la feina",
"Work Fax" => "Fax de la feina",
"Company" => "Empresa",
"Organization" => "Organització",
"Department" => "Departament",
"Division" => "Divisió",
"Job Title" => "Càrrec",
"Street Address" => "Adreça",
"City" => "Població",
"State" => "Estat",
"Zip Code" => "Codi postal",
"Country" => "País",
"User-Agent Info" => "Informació sobre el User-Agent",
"Displays browser client info" => "Mostra informació del navegador de l'usuari",
"Anchor Link" => "Enllaç àncora",
"Puts a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which sets the location and name of the anchor" => "Posa un enllaç a una àncora en una pàgina wiki. Per ser emprada en conjunció amb el plugin ANAME, que especifica el lloc i nom de l'ancora",
"linktext" => "text d'enllaç",
"Anchor Name" => "Nom de l'Àncora",
"Puts an anchor into a wiki page. Use in conjunction with the ALINK plugin, which makes links to the anchor" => "Posa una àncora en una pàgina wiki. Per ser emprada en conjunció amb el plugin ALINK, que especifica l'enllaç a l'ancora",
"Image Annotation" => "Annotació d'Imatges",
"Location" => "Localització",
"Width" => "Amplada",
"Height" => "Alçada",
"Alignment" => "Alineació",
"Save changes to annotations" => "Desa els canvis a les anotacions",
"Creates an annotation block for an image." => "Crea un bloc d'anotacions per a una imatge.",
"Field" => "Camp",
"Article ID" => "ID de l'article",
"Includes an article" => "Inclou un article",
"Id is optional. If not given, last article is used. Default field is heading." => "L'Id és opcional. Si s'omet, es fa servir el darrer article. El camp per defecte és la capçalera.",
"Article List" => "Llista d'Articles",
"Articles displayed" => "Articles mostrats",
"Topics expression" => "Expressió de tòpics",
"Topic ID expression" => "Expressió de l'ID del tòpic",
"Type expression" => "Expressió de tipus",
"Category ID" => "ID de categoria",
"Language" => "Llenguatge",
"Sort order" => "Ordenació",
"Quiet" => "Silenciós",
"Title only" => "Només títol",
"Start date" => "Data d'inici",
"End date" => "Data de finalització",
"Includes articles listing into a wiki page" => "Inclou un listat d'articles a una pàgina wiki",
"Attachment" => "Adjunt",
"File" => "Fitxer",
"Show description" => "Mostrar descripció",
"Bullets" => "Vinyetes",
"Inline" => "Enlínia",
"Number" => "Número",
"Show icon" => "Mostra icona",
"No such attachment on this page" => "Aquest fitxer adjunt no és en aquesta pàgina",
"Displays an attachment or a list of them" => "Mostra un adjunt o una llista d'adjunts",
"Gives the name of the attached file to link to" => "Dóna el nom del fitxer adjunt per enllaçar-hi",
"Same as name" => "Igual que el nom",
"Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Dóna el nom d'una altra pàgina on hi ha l'arxiu adjunt. S'enllaça amb l'arxiu d'aquesta pàgina en lloc de l'altre. Només funciona amb pàgines wiki",
"Shows the description as the link text instead of the file name" => "Mostra la descripció com a text de l'enllaç en lloc del nom de l'arxiu",
"Makes the list of attachments a bulleted list" => "Converteix la llista de fitxers adjunts en una llista de pics",
"Says that this file is an image, and should be displayed inline using the img tag" => "Diu que aquest arxiu és una imatge, i s'ha de visualitzar inserit amb l'etiqueta img",
"Puts the stuff between {ATTACH} tags as the link text instead of the file name or description" => "Ho encaixa entre les etiquetes {ATTACH} com a enllaç de text en lloc del nom del fitxer o la descripció",
"Shows all attachments from the whole wiki" => "Mostra tots els fitxers adjunts de tot el wiki",
"Gives the number, in the list of attachments, of the attachment to link to" => "Dóna el número del fitxer adjunt de la llista amb el qual s'ha d'enllaçar",
"Gives the actual id of the attachment to link in. You probably should never use this" => "Dóna l'identificador real del fitxer adjunt amb què s'enllaça. Probablement no ho hauràs d'utilitzar mai",
"Puts the number of downloads in the alt comment" => "Inclou el nombre de descàrregues en el comentari alternatiu",
"Shows a file icon" => "Mostra una icona de fitxer",
"Displays the user Avatar" => "Mostra l'Avatar de l'usuari/a",
"username" => "usuari",
"Float" => "Flota",
"Back" => "Enrera",
"Displays a link that allows to go back in the browser history" => "Mostra un enllaç que permet retornar a la història del navegador",
"Insert back link on wiki page" => "Inserta els retro-enllaços a la pàgina wiki",
"Backlinks" => "Retroenllaços",
"Displayed information" => "Informació mostrada",
"Pipe separated list of fields to display. ex: hits|user" => "Lista de camps separada per barres verticalsa mostrar. exexmple: hits|user",
"Excluded pages" => "Pàgines excloses",
"Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Llista de pàgines separada per barres verticals a excloure del llistat. exemple: HomePage|Sandbox",
"Include Self" => "Inclou-re's a si mateix",
"No Header" => "Sense capçalera",
"List all pages which link to specific pages" => "Llista totes les planes que apunten a planes específiques",
"No pages links to" => "Cap pàgina apunta a",
"One page links to" => "Una pàgina apunta a",
"pages link to" => "planes que apunten a",
"Banner" => "Pancarta (Banner)",
"Insert a banner" => "Inserta una pancarta (banner)",
"Zone" => "Zona",
"Target" => "Destí",
"missing parameter" => "manca paràmetre",
"Blog List" => "Llista de bitàcoles",
"Blog ID" => "ID de la bitàcola",
"Numeric value" => "Valor numèric",
"Items" => "Ítems",
"Use BLOGLIST to include posts from a blog. Syntax is" => "Empra BLOGLIST per incloure publicacions d'una bitàcola. La Sintaxi és",
"where Id is the blog Id and Items is the max number of posts to display" => "on l'Id és l'Id de la bitàcola i Items és el nombre màxim de publicacions a mostrar",
"Box" => "Caixa",
"Insert theme styled box on wiki page" => "Insertar Formulari amb aspecte a la pàgina wiki",
"Box title" => "Títol de la caixa",
"Displayed above the content" => "Mostrat sobre el contingut",
"Background color" => "Color del rerafons",
"Box width" => "Amplada de la caixa",
"Text Alignment" => "Alineació del text",
"Float Position" => "Posició flotant",
"CSS Class" => "Classe CSS",
"Category" => "Categoria",
"Category IDs" => "IDs de les Categories",
"Types" => "Tipus",
"List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "Llista els tipus d'objectes a incloure en la llista, separats per signes més. exemple: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
"Sort Order" => "Ordenació",
"fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "NomDecamp_asc|NomDeCamp_desc, camps vàlids: type, created, name, hits, shuffle",
"Split" => "Separa",
"And" => "I",
"Insert list of items for the current/given category into wiki page" => "Insertar llista d'ítems per a la categoria actual on és la pàgina wiki",
"Categories are disabled" => "Les Categories han estat deshabilitades",
"Category Orphans" => "Orfans de categoria",
"Display Tiki objects that have not been categorized" => "Mostra objectes Tiki que no hagin estat categoritzats",
"Objects" => "Objectes",
"Category Path" => "Ruta a la categoria",
"Separator" => "Separador",
"Display top category" => "Mostra la categoria superior de totes",
"yes|no, default to no" => "yes|no, per omissió és no",
"Insert the full category path for each category that this wiki page belongs to" => "Insertar la ruta de la categoria completa per a cada categoria a la que aquesta pàgina wiki pertany",
"Center" => "Centra",
"Centers the plugin content in the wiki page" => "Centra el contingut connectat a la wikipàgina",
"Chart" => "Gràfic",
"Sheet ID" => "ID del Full",
"Data sheet ID" => "ID del Full de dades",
"Chart Type" => "Tipus de gràfic",
"BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "Grafic de barres apilades|Gràfic de múltiples barres|Gràfic de múltiples línies|Gràfic de formatgets",
"Chart Width" => "Amplada de gràfic",
"Chart Height" => "Alçada del gràfic",
"Value series" => "Sèries de valors",
"Required for pie charts" => "Requerit per gràfics de formatgets",
"Independant series" => "Sèrie independent",
"Required for types other than pie chart" => "Requerit per a tipus diferents dels gràfics de formatgets",
"Dependant series" => "Sèrie dependent",
"Styles" => "Estils",
"Labels" => "Etiquetes",
"title" => "títol",
"Chart as PDF" => "Sondeig (chart) com a PDF",
"Chart as PostScript" => "Sondeig (chart) com a PostScript",
"Code" => "Codi",
"Displays a snippet of code" => "Mostra un de codi",
"code" => "codi",
"Caption" => "Capçalera",
"Word Wrap" => "Doblega línies llargues",
"Line numbers" => "Números de línia",
"Wiki syntax" => "Sintaxi Wiki",
"Right to left" => "Dreta a esquerra",
"0|1, switch the text display from left to right to right to left" => "0|1, canvia la forma de mostrar text des de 'd'esquerra a dreta', cap a 'de dreta a esquerra'",
"Content is HTML" => "El contigut és HTML",
"0|1, display the content as is instead of escaping HTML special chars" => "0|1, mostra el contingut com està enlloc d'escapar (deixar d'interpretar) els caràcters especials HTML",
"note: colors and ln are exclusive" => "nota: colors i ln són exclusius",
"Dynamic Content" => "Contingut dinàmic",
"Content ID" => "ID del contingut",
"Cookie" => "Galeta",
"Also known as Fortune cookies or Taglines" => "També conegut com a galetes de Fortuna o Línies etiquetades",
"Insert copyright notices" => "Insertar avisos de drets d'autor",
"Countdown" => "Compte enrera",
"Locate Time" => "Localització del Temps",
"Example" => "Exemple",
"and" => "i",
"seconds" => "segons",
"Run a database report" => "Executa un informe sobre una base de dades",
"report definition" => "definició d'informe",
"Full DSN" => "DSN sencer",
"A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "Una text sencer de connexió a DSN (Data Source Name). exemple: mysql://usuari:contrasenya@servidor/basededades",
"Wiki DSN name" => "Nom de DSN Wiki",
"Debug" => "Debug (Neteja d'errors)",
"Missing db or dsn parameter" => "Manca base de dades o paràmetre dsn",
"You do not have permission to use this DSN" => "No tens permís per emprar aquest DSN",
"left|right|center|justify" => "esquerra|dreta|centre|justifica",
"Insert a division block on wiki page" => "Inserta un bloc de divisió en una pàgina Wiki",
"Definition List" => "Llista de definició",
"Creates a definition list" => "Cre una llista de definició",
"term" => "terme",
"definition" => "definició",
"one definition per line" => "una definició per línia",
"Draw" => "Dibuixa",
"Displays drawings in the wiki page" => "Mostra dibuixos a la pàgina wiki",
"drawing not found" => "esboç no trobat",
"Name parameter missing" => "Manca el paràmetre nom (name)",
"Equation" => "Equació",
"equation" => "equació",
"Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renderitza una equació escrita en sintaxi LaTeX com a png. La mida del paràmetre opcional per defecte és 100 i correspon al tant per cent de la mida normal, per exemple, size=200 indica que una equació fa dues vegades la mida normal",
"Calendar ID" => "ID del Calendari",
"Maximum days" => "Dies màxims",
"Maximum Rows" => "Files màximes",
"Datetime" => "Datahora",
"~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insereix una sortida de canal rss en una pàgina wiki",
"Upcoming events" => "Propers esdeveniments",
"Fade" => "Esvaeix",
"Label" => "Etiqueta",
"Label to display on first display" => "Etiqueta a mostrar en la primera visualització",
"Unspecified label" => "Etiqueta no especificada",
"Fancy List" => "Llista maca",
"Use div" => "Empra div",
"Use div instead of ol" => "Empra div enlloc de llista ordenada 'ol'",
"Class" => "Classe",
"CSS class of the fancylist" => "Classe CSS de la llista maca",
"Creates a fancy looking list" => "Crea una llista d'aparència més maca",
"num" => "núm",
"item text" => "text de l'ítem",
"one item per line" => "un ítem per línia",
"Fancy Table" => "Taula maca",
"Heading row" => "Fila de la capçalera",
"Heading CSS Class" => "Classe CSS Capçalera",
"Displays the data using the Tikiwiki odd/even table style" => "Mostra les dades usant el sistema de taules odd/even del Tikiwiki",
"cells" => "cel·les",
"heads and cells separated by ~|~" => "capçaleres i cel·les separades per     ~|~",
"Title" => "Títol",
"Gallery ID" => "ID de la Galleria",
"sort" => "ordenar",
"name_asc" => "nom_asc",
"Shows ID" => "Mostra ID",
"Shows Icon" => "Mostra Icona",
"Shows Name" => "Mostra Nom",
"Shows Filename" => "Mostra Nom de l'arxiu",
"Shows Size" => "Mostra Mida",
"Shows Description" => "Mostra Descripció",
"Shows Creation Date" => "Mostra la Data de Creació",
"Shows Hits" => "Mostra Cops",
"Shows Locked by" => "Mostra Per qui està bloquejat",
"Shows Modification Date" => "Mostra la Data de Modificació",
"Shows Author" => "Mostra Autor",
"Shows Creator" => "Mostra Creador",
"Shows Parent Gallery Name" => "Mostra el nom de la Galeria Mare",
"Shows Number of Files" => "Mostra el número d'Arxius",
"Shows the slideshow of a gallery" => "Mostra el passi de diapositives de la galeria",
"Flash video" => "Vídeo Flash",
"Displays a SWF on the wiki page" => "Mostra un arxiu flaix (SWF) dins la pàgina wiki",
"Movie URL" => "URL del vídeo",
"Default width: 425" => "Amplada per omissió: 425",
"Default height: 350" => "Alçada per omissió: 350",
"Quality" => "Qualitat",
"Flash video quality. Default value: high" => "Qualitat del vídeo Flash. Valor per defecte: high",
"Missing parameter movie to the plugin flash" => "Manca el paràmetre movie per al plugin flash",
"Footnote" => "Nota al peu",
"The footnote" => "La nota al peu",
"Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserta un superíndex de nota al peu, al costat del text, i pren el contingut de la nota al peu com a paràmetre",
"Footnotearea" => "Àrea amb les notes al peu",
"Inserts a section for collected footnotes within the wiki page" => "Inserta una secció per a les notes al peu recollides dins de la pàgia wiki",
"file name" => "nom de l'arxiu",
"Ftp Server Name" => "Nom del servidor Ftp",
"Ftp User name" => "Nom de l'usuari Ftp",
"Ftp password" => "Contrasenya Ftp",
"Download button label" => "Etiqueta del botó de Descàrrega",
"missing parameters" => "paràmetres que manquen",
"Connection failed" => "La connexió ha fallat",
"Incorrect param" => "Paràmetre Incorrecte",
"failed" => "sense èxit",
"Gauge" => "Barra de nivell",
"Displays a graphical gauge" => "Mostra una barra de nivell gràfic",
"description" => "descripció",
"Value" => "Valor",
"current value (REQUIRED)" => "valor actual (REQUERIT)",
"Maximum Value" => "Valor Màxim",
"Maximum possible value. Default: 100" => "Valor màxim possible. Per omissió: 100",
"Background Color" => "Color de Fons",
"Label Width" => "Amplada de l'etiqueta",
"Display Percentage" => "Percentatge de Pantalla",
"Display Value" => "Valor de Pantalla",
"Displays a graphical GAUGE" => "Mostra un gràfic GAUGE",
"Google Analytics" => "Analítica de Google",
"Account number" => "Número de compte",
"Missing parameter" => "Manca algun paràmetre",
"type" => "tipus",
"Type of Google document" => "Tipus de document de Google",
"key" => "clau",
"Google doc key - for example pXsHENf1bGGY92X1iEeJJI" => "Clau del document de Google - per exemple pXsHENf1bGGY92X1iEeJJI",
"Name of iframe" => "Nom de l'iframe",
"Pixels or %" => "Píxels o %",
"Margin Height" => "Alçada de Marge",
"Pixels" => "Píxels",
"Margin Width" => "Amplada de Marge",
"Scrolling" => "Desplaçament",
"editLink" => "Enllaçd'Edició",
"Required parameter \"type\" missing" => "Manca el paràmetre \"tipus\" requerit",
"Required parameter \"key\" missing" => "Manca el paràmetre \"clau\" requerit",
"Displays a Google document" => "Mostra un document de Google",
"Group" => "Grup",
"Allowed Groups" => "Grups Permesos",
"Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Lista separada per barres verticals dels grups permesos per veure el bloc. ex: Admins|Desenvolupadors",
"Denied Groups" => "Grups Denegats",
"Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Llista separada per barres verticals dels grups denegats per veure el bloc. ex: Gestors|Anònims",
"Display wiki text if user is in one of listed groups" => "Mostra el text wiki si l'usuari es troba en algun dels grups llistats",
"Include literal HTML in a Wiki page" => "Inclou literal HTML en un Wiki pàgina",
"HTML code" => "codi HTML",
"Include literal HTML" => "Inclou un literal HTML",
"URL" => "URL (Localitzador de Recurs Universal)",
"name" => "nom",
"Displays an iframe" => "Mostra un iframe",
" (experimental - possible successor to img in 4.0)" => " (experimental - successor possible a img en 4.0)",
"File ID" => "ID de l'arxiu",
"Image ID" => "Imatge ID",
"Image Source" => "Font d'Imatge",
"Image size" => "Mida de la imatge",
"Image height" => "Alçada de la imatge",
"Image width" => "Amplada d'Imatge",
"Img" => "Imatge",
"Include" => "Inclou",
"Start" => "Començament",
"Stop" => "Atura",
"Include a page" => "Incloure una pàgina",
"Runs a Java applet to access a local Jabber service" => "Executa un applet Java per accedir a un servidor Jabber local",
"Displays the text only if the language matchs" => "Mostra el text només si l'idioma concorda",
"Last Modification" => "Última modificació",
"The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "El connector last_mod se substitueix per l'hora de l'última modificació de la pàgina wiki que s'ha indicat, o per la pàgina actual si no s'ha donat cap nom",
"List Pages" => "Llista pàgines",
"List wiki pages." => "Llista pàgines wiki.",
"Sort" => "Ordena",
"or" => "o",
"Lists files in a directory" => "Llista arxius en un directori",
"Filter" => "Filtra",
"could not be opened because it doesn't exist or permission was denied" => "no es pot obrir perquè no hi és o s'ha denegat el permís",
"Map" => "Mapa",
"Displays a map" => "Mostra un mapa",
"Feature disabled" => "Característica deshabilitada",
"Style" => "Estil",
"Module Name" => "Nom del mòdul",
"Please choose a module" => "Si us plau, trieu un mòdul",
"to be used as argument" => "per ser emprat com a argument",
"Displays a module inlined in page" => "Mostra un mòdul en línia dins la pàgina",
"Sorry no such module" => "Perdó, aquest mòdul no existeix",
"Displays the data using a monospace font" => "Mostra les dades usant una font monoespaiada",
"Text" => "Texte",
"Sticky" => "Enganxós",
"data" => "dades",
"Displays a SWF myspace mp3 playlist on the wiki page" => "Mostra una llista de reproducció mp3 de myspace tipus SWF a la pàgina wiki",
"Object" => "Objecte",
"Days" => "Dies",
"Displays object hit info by object and days" => "Mostra informació de les visualitzacions de l'objecte per objecte i dies",
"Picture" => "Foto",
"picture not found" => "no s'ha trobat la imatge",
"Information" => "Informació",
"Provides a list of plugins on this wiki." => "Proporciona una llista de plugins sobre aquest wiki.",
"No version indicated" => "No s'ha indicat cap versió",
"No arguments indicated" => "Cap argument indicat",
"Poll" => "Votació",
"Displays the output of a poll, fields are indicated with numeric ids." => "Mostra la sortida d'una votació, els camps estan indicats amb ids numèrics.",
"missing poll ID for plugin POLL" => "falta l'ID del sondeig pel connector POLL",
"wrote:" => "va escriure:",
"Quote:" => "Cita:",
"Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Cita text a través d'envoltar-lo d'un requadre, com el de [QUOTE] BBCode",
"Redirects you to another wiki page" => "Redirecciona a una altra pàgina Wiki",
"one data per line" => "una dada per línea",
"Search" => "Cercar",
"Takes regex expressions and parses the content between the REGEX tags and replaces the text." => "Pren expressions regulars i interpreta el contingut entre etiquetes REGEX i reemplaça el text.",
"Displays a comment, tip, note or warning box" => "Mostra un comentari, consell, nota o quadre d'avís",
"remarks text" => "text de comentaris",
"Icon" => "Icona",
"Date" => "Data",
"You need to specify a RSS Id" => "Has d'especificar un identificador RSS",
"RSS Id incorrect:" => "Identificador RSS incorrecte:",
"~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Inserta la sortida d'alimentacions rss a una pàgina wiki",
"Automatically creates a link to the appropriate SourceForge object" => "Automaticament crea un enllaç a l'object SourceForge apropriat",
"Pop-up" => "Finestra emergent",
"Sheet Heading" => "Capçalera del full",
"TikiSheet" => "FullsTiki",
"Edit Sheet" => "Edita Full",
"List wiki pages" => "Llista les planes Wiki",
"Display" => "Mostra",
"Last modified by" => "Darrera modicicació per",
"Clickable Skype link" => "Enllaç clicable de Skype",
"Action" => "Acció",
"The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace." => "El connector SNARF  es reemplaça a si mateix pel cos html d'una URL. Es pot fer un reemplaçament arbitrari en aquest contingut emprant expressions regulars regex i regexres, la darrera emprada com a segon argument a preg_replace.",
"This data is put in a CODE caption." => "Aquestes dades es posen en un requadre de tipus CODI.",
"Missing url parameter for SNARF plugin." => "Falta el paràmetre url pel connector SNARF.",
"Sorts the plugin content in the wiki page" => "Ordena el contingut del plugin dins la pàgina wiki",
"Order" => "Ordre",
"Split a page into rows and columns" => "Divideix una pàgina en files i columnes",
"First" => "Primer",
"Edit" => "Editar",
"row1col1" => "fila1col1",
"row1col2" => "fila1col2",
"row2col1" => "fila2col1",
"row2col2" => "fila2col2",
"Run a sql query" => "Executa una consulta sql",
"sql query" => "consulta sql",
"Missing db param" => "Falta paràmetre de la bd",
"Displays text in subscript." => "Mostra text en subíndex.",
"Subscribe or unsubscribe to a group" => "Subscriu-te o desubscriu-te a un grup",
"Subscribe" => "Subscriu",
"Groups" => "Grups",
"Displays text in superscript." => "Mostra el text com a superíndex.",
"Tag" => "Marcador",
"Tag Name" => "Nom de marca",
"Displays text between an html tag" => "Mostra text entre etiquetes html",
"Thumbnail" => "Miniatura",
"Displays the thumbnail for an image" => "Mostra el contacte d'una imatge",
"Search the titles of all pages in this wiki" => "Buscar els títols de totes les pàgines del wiki",
"No pages found for title search" => "No s'ha trobat cap pàgina per la cerca de títols",
"One page found for title search" => "Una pàgina ha estat trobada a la cerca per al títol",
"pages found for title search" => "pàgines trobades pel títol de la cerca",
"Structure ID" => "ID de l'Estructura",
"Public" => "Públic",
"List top scoring users" => "Llista dels usuaris amb més punts",
"Translate" => "Tradueix",
"Translate a string" => "Tradueix una cadena",
"Fields" => "Camps",
"Preview" => "Vista prèvia",
"preview" => "vista prèvia",
"View" => "Visualitza",
"Incorrect fieldId:" => "Identificador de camp incorrecte:",
"Following mandatory fields are missing" => "Manquen els camps obligatoris següents",
"Following fields are incorrect" => "Els camps següents són incorrectes",
"Displays an input form for tracker submit" => "Mostra un formulari html d'enviament de dades per a un formulari Tiki (tracker)",
"You do not have permission to insert an item" => "No tens permís per insertar ítems",
"You do not have permission to modify an item" => "No tens permisos per modificar un element",
"Fields marked with a * are mandatory." => "Els camps marcats amb un asterisc (*) són obligatoris.",
"Filters" => "Filtres",
"tracker field type not processed yet" => "algun tipus emprat de camp de formulari no ha estat processat encara",
"Filters the items of a tracker, fields are indicated with numeric ids." => "Filtra els ítems d'un formulari, els camps són indicats amb els seus ids. numèrics",
"Wiki text" => "Text wiki",
"Status" => "estat",
"Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)." => "Visualitza el valor d'un camp d'un element de formulari o el text wiki si el valor del camp està configurat o té un valor (si no s'ha especificat itemId, utilitza itemId de la url o el formulari d'usuari).",
"Displays the output of a tracker content, fields are indicated with numeric ids." => "Mostra la sortida del contingut d'un formulari; els camps són indicats amb ids. numèrics",
"More" => "Més",
"Template" => "Plantilla",
"incorrect filterfield" => "camp de filtrat (filterfield) incorrecte",
"Error in tracker ID" => "Error a l'ID del formulari",
"No field indicated" => "No s'ha indicat cap camp",
"Displays a button to link to a page with a tracker plugin with prefilled tracker fields." => "Visualitza un botó per enllaçar a una pàgina amb un connector de formulari que ja té els camps de formulari pre-emplenats.",
"Displays some stat of a tracker content, fields are indicated with numeric ids." => "Visualitza estadístiques del contingut d'un formulari, els camps s'indiquen amb identificadors numèrics.",
"incorrect fieldId" => "Identificador de camp incorrecte",
"Start Date" => "Data d'inici",
"End Date" => "Data final",
"Links to a translated content" => "Enllaços a contingut traduït",
"Flag" => "Bandera",
"Displays the number of registered users" => "Mostra el número d'usuaris registrats",
"Group name" => "Nom del Grup",
"User List" => "Llistat d'usuaris",
"Displays a list of registered users" => "Mostra una llista dels usuaris registrats",
"users" => "usuaris",
"Preferences" => "Preferències",
"User Information" => "Informació de l'usuari",
"Split the text in parts visible only under some conditions" => "Divideix el text en parts només visibles sota determinades condicions",
"This is the default text" => "Aquest és el text per defecte",
"(version 3)" => "(versió 3)",
"This is version 3 info" => "Això és informació de la versió 3",
"(version 2)" => "(versió 2)",
"This is version 2 info" => "Això és informació de la versió 2",
"(version 1)" => "(versió 1)",
"This is version 1 info" => "Això és informació de la versió 1",
"Vote" => "Votar",
"Table" => "Taula",
"Lists ''wanted'' Wiki pages: " => "Llista les pàgines Wiki ''buscades'': ",
"Page-Pattern" => "Patró de pàgina",
"Custom-Level-Regex" => "Nivell-adaptat-Regex",
"^Parameters: key=>value,...\n" => "^Paràmetres: clau=>valor,...\n",
"__key__ | __default__ | __comments__\n" => "__clau__ | __defecte__ | __comentaris__\n",
"empty string" => "tros de text (cadena) buit/da",
"A wildcard pattern of originating pages to be ignored." => "Un patró comodí de pàgines d'origen que s'ignoraran.",
"(refer to PHP function fnmatch() for details)\n" => "(consulta la funció PHP fnmatch() per més detalls)\n",
"The character, by which ignored patterns are separated." => "El caràcter amb el qual se separen els patrons que s'ignoren.",
"possible values: characters\n" => "valors possibles: caràcters\n",
"Whether to include external wikis in the list." => "Si incloure (o no) wikis externs a la llista.",
"possible values: " => "valors possibles: ",
"Collect either originating or wanted pages in a cell and display them in the second column." => "Aplega tant les pàgines d'origen com les pàgines cercades en una cel·la i visualitza-les a la segona columna.",
"ignored" => "ignorat",
"External Wiki" => "Wiki Extern",
"dash-WikiWord" => "guio-ParaulaWiki",
"WikiWord" => "ParaulaWiki",
"not in level" => "no al nivell",
"valid" => "vàlid",
"End of debug output." => "Final de la sortida de depuració.",
"Wanted Page" => "Pàgina buscada",
"Referenced By Page" => "Referenciat per la pàgina",
"Display youtube video in a wiki page" => "Visualitza un vídeo youtube en una pàgina wiki",
"width" => "amplada",
"Width in pixels" => "Amplada en pixels",
"height" => "alçada",
"Height in pixels" => "Alçada en pixels",
"Removed version \$version" => "Versió \$version eliminada",
"Changed actual version to \$version" => "La versió actual s'ha canviat a \$version",
"Top" => "Dalt",
"Page locked" => "Pàgina bloquejada",
"Page unlocked" => "Pàgina desbloquejada",
"Removed last version" => "Úlitma versió eliminada",
"ERROR: Either the subject or body must be non-empty" => "ERROR: El títol o el cos no han d'estar buits",
"ERROR: No valid users to send the message" => "ERROR: No hi ha usuaris válids per enviar el missatge",
"Invalid user" => "Invàlid usuari",
"Message sent to" => "Missatge enviat a",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "La bústia Enviats és plena. Arxiveu o esborreu alguns missatges enviats si voleu enviar més missatges.",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Heu de poder rebre missatges per tal d'enviar-ne. Aneu a preferències de l'usuari i activa 'Permetre missatges d'altres usuaris'",
"User %s can not receive messages, mailbox is full" => "L'usuari %s no pot rebre missatges, la bústia de correu és plena",
"User %s can not receive messages" => "L'usuari %s no pot rebre missatges",
"Invalid user: %s" => "Usuari no vàlid: %s",
"Message will be sent to: " => "El missatge s'enviarà a: ",
"Archive is full. Delete some messages from archive first." => "L'arxiu és ple. Esborreu primer alguns missatges de l'arxiu.",
"No more messages" => "No hi ha mes missatges",
"Tiki Calendar" => "Calendari del Tiki",
"list topics with links to the articles" => "llista de temes amb enllaços als articles",
"Article Topics" => "Temes de l'article",
"Calendar" => "Calendari",
"Categorize %s in %s" => "Classifica %s en %s",
"Please provide an Id" => "Si us plau, proveïu una Id",
"no object here yet" => "encara no hi ha cap objecte aquí",
"Create/Edit" => "Crea/edita",
"Quick Edit a Wiki Page" => "Crea/Edita pàgina Wiki",
"Post" => "Publicar",
"Changes since" => "Canvis des de",
"new comments" => "comentaris nous",
"new posts" => "noves publicacions",
"wiki pages changed" => "pàgines del wiki modificades",
"new articles" => "articles nous",
"new FAQs" => "Noves FAQs",
"new blogs" => "bitàcoles noves",
"new blog posts" => "noves entrades a la bitàcola",
"new image galleries" => "noves galeries d'imatge",
"new images" => "imatges noves",
"new file galleries" => "noves galeries de fitxers",
"new files" => "arxius nous",
"new polls" => "votacions noves",
"new users" => "usuaris/es nous/ves",
"new tracker items" => "nous ítems del formulari",
"The task title must have at least 3 characters" => "El títol de la tasca ha de tenir com a mínim 3 caràcters",
"Invalid server key" => "Clau del servidor invàlida",
"Invalid username or password" => "Usuari o contrasenya  no vàlids",
"Cookie not found" => "No s'ha trobat la galeta",
"Can create/admin calendars" => "Pot crear/administrar calendaris",
"Can add events in the calendar" => "Pot afegir esdeveniments al calendari",
"Can change events in the calendar" => "Pot canviar esdeveniments del calendari",
"Can view events details" => "Pot visualitzar informació dels esdeveniments",
"Can view Tikiwiki tools calendar" => "Pot visualitzar les eines Tikiwiki del calendari",
"Can admin categories" => "Pot administrar categories",
"Can view categories" => "Pot visualitzar categories",
"Can view categorized items" => "Pot visualitzar ítems classificats",
"Can admin charts" => "Pot administrar sondejos (charts)",
"Autovalidate suggestions" => "Autovalida els suggeriments",
"Can suggest items" => "Pot suggerir ítems",
"Can view charts" => "Pot visualitzar sondejos (charts)",
"Can vote" => "Pot votar",
"Administrator, can create channels remove channels etc" => "Administrador, pot crear canals, eliminar canals, etc.",
"Can use the chat system" => "Pot utilitzar el sistema de xat",
"Can approve submissions" => "Pot aprovar trameses",
"Can admin article topics" => "Pot administrar temes d'articles",
"Can admin article types" => "Pot administrar tipus d'articles",
"Submited articles automatically approved" => "Els articles tramesos s'aproven automàticament",
"Can edit articles" => "Pot editar articles",
"Can edit submissions" => "Pot editar trameses",
"Can read articles" => "Pot llegir articles",
"Can remove articles" => "Pot esborrar articles",
"Can remove submissions" => "Pot esborrar trameses",
"Can submit articles" => "Pot trametre articles",
"Can read a topic (Applies only to individual topic perms)" => "Pot llegir un tema (només per als casos amb permisos individuals per a temes)",
"Can admin contributions" => "Pot administrar contribucions",
"Can admin the directory" => "Pot administrar el directori",
"Can admin directory categories" => "Pot administrar categories de directoris",
"Can admin directory sites" => "Pot administrar enllaços",
"Submited links are valid" => "Els enllaços tramesos són vàlids",
"Can submit sites to the directory" => "Pot trametre llocs web al directori",
"Can validate submited links" => "Pot validar els enllaços tramesos",
"Can use the directory" => "Pot utilitzar el directori",
"Can admin drawings" => "Pot administrar dibuixos",
"Can edit drawings" => "Pot editar dibuixos",
"Can admin faqs" => "Pot administrar pmf",
"Can suggest faq questions" => "Pot suggerir preguntes pmf",
"Can view faqs" => "Pot visualitzar pmf",
"Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrador, pot gestionar grups d'usuaris i permisos, paraules calentes i totes les característiques de bloc",
"Can admin users" => "Pot administrar usuaris",
"Can access site when closed" => "Pot accedir al lloc web quan està tancat",
"Administrator, can admin banners" => "Administrador, pot administrar bàners",
"Can admin the dynamic content system" => "Pot administrar el sistema de contingut dinàmic",
"Can admin mail-in accounts" => "Pot administrar comptes de correu-dins",
"Can edit object permissions" => "Pot editar permisos d'objectes",
"Can admin rss modules" => "Pot administrar mòduls rss",
"Can clean cache" => "Pot esborrar la memòria cau",
"Can remove association between two pages in a translation set" => "Pot eliminar l'associació entre dues pàgines en un conjunt de traducció",
"Can admin cookies" => "Pot administrar galetes",
"Can edit translations and create new languages" => "Pot editar traduccions i crear nous llenguatges",
"Can edit menu" => "Pot editar menús",
"Can edit menu option" => "Pot editar opcions de menú",
"Can edit site templates" => "Pot editar plantilles de lloc web",
"Can search" => "Pot buscar",
"Can report a link to the webmaster" => "Pot informar d'un enllaç a l'administrador",
"Can subscribe to groups" => "Pot subscriure a grups",
"Can send a link to a friend" => "Pot enviar un enllaç a un amic",
"Can use HTML in pages" => "Pot utilitzar HTML a les pàgines",
"Can view integrated repositories" => "Pot visualitzar repositoris integrats",
"Can view site stats" => "Pot visualitzar estadístiques",
"Can view site templates" => "Pot visualitzar plantilles de llocs web",
"Can admin blogs" => "Pot administrar blogs",
"Can assign perms to blog" => "Pot assignar permisos a blocs",
"Can post to a blog" => "Pot publicar en un bloc",
"Can create a blog" => "Pot crear un blog",
"Can read blogs" => "Pot llegir blocs",
"Can admin file galleries" => "Pot administrar galeries d'arxius",
"Can assign perms to file gallery" => "Pot assignar permisos a galeries d'arxius",
"Can upload zip files with files" => "Pot penjar arxius zip amb arxius",
"Can create file galleries" => "Pot crear galeries d'arxius",
"Can download files" => "Pot descarregar arxius",
"Can edit a gallery file" => "Pot editar un arxiu de la galeria",
"Can list file galleries" => "Pot llistar galeries d'arxius",
"Can upload files" => "Pot penjar arxius",
"Can view file galleries explorer" => "Pot visualitzar l'explorador de galeries d'arxius",
"Can view file galleries path" => "Pot visualitzar el camí de les galeries d'arxius",
"Can view file galleries" => "Pot visualitzar galeries d'arxius",
"Can admin forums" => "Pot administrar fòrums",
"Can attach to forum posts" => "Pot adjuntar a publicacions del fòrum",
"Auto approve forum posts" => "Auto aprova les publicacions dels fòrums",
"Can edit own forum posts" => "Pot editar les seves publicacions del fòrum",
"Can post in forums" => "Pot publicar als fòrums",
"Can start threads in forums" => "Pot iniciar fils de discussió als fòrums",
"Can read forums" => "Pot llegir fòrums",
"Can report msgs to moderator" => "Pot informar de missatges al moderador",
"Can vote comments in forums" => "Pot votar comentaris de fòrums",
"Can admin Image Galleries" => "Pot administrar galeries d'imatges",
"Can upload zip files with images" => "Pot penjar arxius zip amb imatges",
"Can create image galleries" => "Pot crear galeries d'imatges",
"Can tag objects" => "Pot etiquetar objectes",
"Can list image galleries" => "Pot llistar galeries d'imatges",
"Can unassign tags from an object" => "Pot desassignar etiquetes d'un objecte",
"Can upload images" => "Pot penjar imatges",
"Can view image galleries" => "Pot visualitzar galeries d'imatges",
"Can admin games" => "Pot administrar jocs",
"Can play games" => "Pot jugar",
"Can admin newsletters" => "Pot administrar butlletins",
"Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Pot subscriure molts correus-e alhora (requereix tiki_p_subscribe email)",
"Can send newsletters" => "Pot enviar butlletins",
"Can subscribe any email to newsletters" => "Pot subscriure els correus-e als butlletins",
"Can subscribe to newsletters" => "Pot subscriure a butlletins",
"Can admin polls" => "Can admin votacions",
"Can view poll results" => "Pot veure resultats de les votacions",
"Can vote polls" => "Pot votar a les votacions",
"Can admin quizzes" => "Pot administrar concursos",
"Can take quizzes" => "Pot participar a concursos",
"Can view quiz stats" => "Pot visualitzar estadístiques dels concursos",
"Can view user quiz results" => "Pot visualitzar resultats dels usuaris en els concursos",
"Can admin sheet" => "Pot administrar fulls",
"Can create and edit sheets" => "Pot crear i editar fulls",
"Can view sheet" => "Pot visualitzar un full",
"Can view sheet history" => "Pot visualitzar l'historial de fulls",
"Can admin surveys" => "Pot administrar enquestes",
"Can take surveys" => "Pot fer enquestes",
"Can view survey stats" => "Pot visualitzar estadístiques d'enquestes",
"Can admin trackers" => "Pot administrar formularis",
"Can attach files to tracker items" => "Pot adjuntar fitxers a elements de formulari",
"Can insert comments for tracker items" => "Pot inserir comentaris per a registres de formulari",
"Can create new items for trackers" => "Pot crear nous registres per a formularis",
"Can list trackers" => "Pot llistar formularis",
"Can change tracker items" => "Pot canviar registres de formulari",
"Can view rating result for tracker items" => "Pot visualitzar el resultat de la valoració de registres de formulari",
"Can vote a rating for tracker items" => "Pot votar per a una valoració de registres de formularis",
"Can view trackers" => "Pot visualitzar formularis",
"Can view trackers closed items" => "Pot visualitzar registres de formulari tancats",
"Can view trackers pending items" => "Pot visualitzar registres de formulari pendents",
"Can watch tracker" => "Pot vigilar formulari",
"Can admin the wiki" => "Pot administrar el wiki",
"Can assign perms to wiki pages" => "Pot assignar permisos a pàgines wiki",
"Can edit pages" => "Pot editar pàgines",
"Can edit copyright notices" => "Pot editar avisos de copyright",
"Can edit dynamic variables" => "Pot editar variables dinàmiques",
"Can create and edit structures" => "Pot crear i editar estructures",
"Can lock pages" => "Pot bloquejar pàgines",
"Can save as minor edit" => "Pot guardar com a edició menor",
"Can remove" => "Pot esborrar",
"Can rename pages" => "Pot canviar noms de pàgines",
"Can upload pictures to wiki pages" => "Pot penjar imatges en pàgines wiki",
"Can view page/pages" => "Pot visualitzar pàgina/es",
"Can watch structure" => "Pot vigilar estructura",
"Can admin attachments to wiki pages" => "Pot administrar fitxers adjunts a pàgines wiki",
"Can add and change ratings on wiki pages" => "Pot afegir i canviar valoracions a les pàgines wiki",
"Can attach files to wiki pages" => "Pot adjuntar fitxers a pàgines wiki",
"Can view wiki attachments and download" => "Pot visualitzar fitxers wiki adjunts i descarregar-los",
"Can view wiki comments" => "Pot visualitzar comentaris wiki",
"Can view wiki history" => "Pot visualitzar historials wiki",
"Can view rating of wiki pages" => "Pot visualitzar la valoració de pàgines wiki",
"Can view source of wiki pages" => "Pot visualitzar l'origen de les pàgines wiki",
"Can participate to rating of wiki pages" => "Pot participar a la valoració de pàgines wiki",
"Can admin workflow processes" => "Pot administrar processos de flux de treball",
"Can abort a process instance" => "Pot interrompre una instància de procés",
"Can execute workflow activities" => "Pot executar activitats de flux de treball",
"Can admin received articles" => "Pot administrar articles rebuts",
"Can admin received pages" => "Pot administrar pàgines rebudes",
"Can send articles to other sites" => "Pot enviar articles a altres llocs web",
"Can send articles to this site" => "Pot enviar articles a aquest lloc web",
"Can send pages to this site" => "Pot enviar pàgines a aquest lloc web",
"Can send pages to other sites" => "Pot enviar pàgines a altres llocs web",
"Can configure modules" => "Pot configurar mòduls",
"Can create user bookmarks" => "Pot crear adreces d'interès d'usuari",
"Can use the mini event calendar" => "Pot utilitzar el minicalendari d'esdeveniments",
"Can use the newsreader" => "Pot utilitzar el lector de missatges",
"Can use the notepad" => "Pot utilitzar el bloc de notes",
"Can admin public tasks" => "Pot administrar tasques públiques",
"Can use tasks" => "Pot utilitzar tasques",
"Can receive tasks from other users" => "Pot rebre tasques d'altres usuaris",
"Can send tasks to other users" => "Pot enviar tasques a altres usuaris",
"Can upload personal files" => "Pot penjar arxius personals",
"Can create items in personal menu" => "Pot crear elements al menú personal",
"Can broadcast messages to all user" => "Pot difondre missatges a tots els usuaris",
"Can broadcast messages to groups" => "Pot difondre missatges a grups",
"Can use the messaging system" => "Pot utilitzar el sistema de missatgeria",
"Can admin comments" => "Pot administrar comentaris",
"Can edit all comments" => "Pot editar tots els comentaris",
"Can post new comments" => "Pot publicar nous comentaris",
"Can read comments" => "Pot llegir comentaris",
"Can delete comments" => "Pot esborrar comentaris",
"Can vote comments" => "Pot votar comentaris",
"Can admin content templates" => "Pot administrar plantilles de contingut",
"Can edit content templates" => "Pot editar plantilles de contingut",
"Can use content templates" => "Pot utilitzar plantilles de contingut",
"Can edit HTML pages" => "Pot editar pàgines HTML",
"Can view HTML pages" => "Pot visualitzar pàgines HTML",
"Can list registered users" => "Pot llistar usuaris registrats",
"Can use webmail" => "Pot utilitzar el correu web",
"change password" => "canvia la contrasenya",
"sender email" => "Correu-e de l'enviador",
"country" => "país",
"Anti-Bot verification code" => "Codi de verificació anti-robots",
"Random Image" => "Imatge aleatòria",
"Enter the code you see above" => "Introdueix el codi que veus més amunt",
"List of attached files" => "Llista de fitxers adjunts",
"desc" => "descripció",
"uploaded" => "pujat/s",
"Download" => "Descarregar",
"Delete" => "Esborra",
"Remove" => "Elimina",
"Upload file" => "Pujar un arxiu",
"Attach" => "Adjunció",
"Attach a file to this item" => "Afegeix un fitxer a aquest punt",
"Version" => "Versió",
"Attachments" => "Afegits",
"more info" => "més informació",
"No attachments for this item" => "No hi ha afegits per a aquest punt",
"debug" => "depurador",
"Fatal error" => "Error fatal",
"Created by" => "Creat por",
"on" => "en",
"RSS feed" => "Alimentació RSS",
"Edit blog" => "Edita bitàcola",
"Monitor this Blog" => "Subscriu-te a aquesta bitàcola",
"Stop Monitoring this Blog" => "Desubscriu-te a aquesta bitàcola",
"Activity=" => "Activitat",
"Watched by categories" => "Vigilat per categories",
"Actions" => "Accions",
"Properties" => "Propietats",
"No records found" => "No es trobaren registres",
"Categorize" => "Categoritzar",
"Admin Categories" => "Administrar categories",
"No categories defined" => "No hi ha categories definides",
"Browse Category" => "Navega per les categories",
"posts:" => "publicacions:",
"stars" => "estels",
"User Level" => "Nivell d'usuari/a",
"private message" => "missatge privat",
"Send eMail to User" => "Enviar email a usuari",
"user online" => "usuari/a en línia",
"user offline" => "usuari/a fora de línia",
"top of page" => "dalt de la pàgina",
"Reply" => "Respon",
"Approve" => "Aprovar",
"Reject" => "Rebutja",
"Report this post" => "Informa d'aquesta publicacó",
"Save to notepad" => "Guardar al bloc de notes",
"Monitor this Topic" => "Segueix aquest tema",
"Stop Monitoring this Topic" => "Deixa de seguir aquest tòpic",
"Errors" => "Error",
"Moderator actions" => "Accions del moderador",
"reported:" => "reportat:",
"queued:" => "a la cua:",
"Move to topic:" => "Moure al tema:",
"Move" => "Moure",
"Delete Selected" => "Esborrar seleccionats",
"Unlock" => "Desbloquejar",
"Lock" => "Bloquejar",
"Messages" => "Missatges",
"Plain" => "Senzill",
"Threaded" => "Per fils de discussió",
"Headers Only" => "Només capçaleres",
"Newest first" => "Primer els més nous",
"Oldest first" => "Els més antic primer",
"Title (desc)" => "Títol (desc)",
"Title (asc)" => "Títol (asc)",
"Threshold" => "Llindar mínim",
"Set" => "Configurar",
"Replies" => "Respostes",
"below your current threshold" => "sota el teu llindar actual",
"Note" => "Nota",
"New Reply" => "Resposta nova",
"Editing reply" => "Editant la resposta",
"Reply to the selected post" => "Respon a la publicació seleccionada",
"Post new message" => "Publica un nou missatge",
"Editing comment" => "Editant missatge",
"Comment on the selected post" => "Comenta la publicació seleccionada",
"Post new comment" => "Publicar comentari nou",
"required" => "requerit",
"Smileys" => "Emoticons",
"Quicktags" => "Marques ràpides",
"Enter your name" => "Introdueix el teu nom",
"Reply to parent post" => "Respon a la publicació original",
"Post new reply" => "Publica una resposta nova",
"Cancel" => "Cancel·lar",
"Posting replies" => "Publicant respostes",
"Posting comments" => "Publicant comentaris",
"Use" => "Ús",
"for links" => "per a enllaços",
"HTML tags are not allowed inside posts" => "No són permeses les etiquetes HTML dins les publicacions",
"Add Comment" => "Afegeix un comentari",
"1 comment" => "1 comentari",
"Comments" => "Comentaris",
"Go back" => "Tornar Enrera",
"Return to home page" => "Torna a la pàgina d'inici",
"Type of contribution:" => "Tipus de contribució:",
"Contributors" => "Contribuïdors",
"Authors" => "Autors",
"Add" => "Afegeix",
"Syntax" => "Sintaxi",
"Page generation debugging log" => "Pagina generadora del registre de depuració",
"Features state" => "Estat de les característiques",
"features matched" => "característiques coincidents",
"Watchlist" => "Llista de coses vigilades",
"Duplicate File Gallery" => "Duplica la galeria d'arxius",
"Duplicate categories" => "Duplica les categories",
"Duplicate perms" => "Duplica els permisos",
"duplicate" => "duplicat",
"There are individual permissions set for this file gallery" => "Existeixen permisos fixats individualment per a aquesta galeria de fitxers",
"Save" => "Guardar",
"View inserted gallery" => "Visualitza la galeria inserida",
"Display Properties" => "Visualitza les propietats",
"required field for podcasts" => "els podcasts requereixen aquest camp",
"any file" => "qualsevol arxiu",
"podcast (audio)" => "podcast (àudio)",
"podcast (video)" => "podcast (vídeo)",
"Gallery is visible to non-admin users?" => "Galeria visible per usuaris no autoritzats",
"This Gallery is Public" => "Aquesta galeria és pública",
"The files can be locked at download:" => "Els fitxers es poden bloquejar i descarregar:",
"Maximum number of archives for each file" => "Nombre màxim d'arxius per a cada fitxer",
"unlimited" => "sense límit",
"none" => "cap",
"Parent gallery" => "Galeria mare",
"Owner of the gallery" => "Propietari de la galeria",
"Default sort order" => "Ordre d'ordenació per defecte",
"descending" => "descendent",
"ascending" => "ascendent",
"Max description display size" => "Tamany màxim de la mostra de descripció",
"Max Rows per page" => "Files màx. per pàgina",
"Listing configuration" => "Llistant configuració",
"Please login" => "Connecta't, si us plau",
"Perhaps you were looking for:" => "Potser estaves cercant:",
"There are no wiki pages similar to '{\$page}'" => "No hi ha pàgines wiki similars a '{\$page}'",
"Go to Login Page" => "Ves a la pàgina de connexió",
"Create this page" => "Crear aquest pàgina",
"(page will be orphaned)" => "(la pàgina es quedarà òrfena)",
"Close Window" => "Tanca Finestra",
"Go to" => "Ves a",
"Private Gallery" => "Galeria privada",
"Active Perms" => "Activar permisos",
"Archives" => "Arxius",
"Upload New Version" => "Puja una nova versió",
"Replace" => "Reemplaçar",
"Download and lock" => "Descarrega i bloqueja",
"List" => "Llista",
"Browse" => "Visitar",
"Name-filename" => "Nom-nom del fitxer",
"Filename only" => "Només el nom del fitxer",
"Show as a column" => "Mostra-ho com una columna",
"Show in popup box" => "Mostra en requadre emergent",
"Both" => "Ambdues coses",
"Show an icon in a column" => "Mostra una icona en una columna",
"Close" => "Tanca",
"Exact&nbsp;match" => "Ocurrència&nbsp;exacta",
"any type" => "qualsevol tipus",
"all topic" => "tots els tòpics",
"any language" => "qualsevol idioma",
"any category" => "qualsevol categoria",
"Number of displayed rows" => "Nombre de columnes mostrades",
"Go" => "Ves-hi",
"in:" => "en:",
"Show php error messages" => "Mostra missatges d'error php",
"Folksonomy Tags" => "Marcadors de folcsonomia",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together." => "Posa etiquetes separades per espais. Per etiquetes amb més d'una paraula, posa les paraules juntes sense emprar espais.",
"Tags" => "Marques",
"Translate tags" => "Tradueix etiquetes",
"Images Galleries" => "Galeries d'imatges",
"RSS Wiki" => "RSS del Wiki",
"RSS Blogs" => "RSS de les Bitàcoles",
"RSS Articles" => "RSS dels Articles",
"RSS Image Galleries" => "RSS de les Galeries d'Imatges",
"RSS File Galleries" => "RSS de les Galeries d'Arxius",
"RSS Forums" => "RSS dels Fòrums",
"RSS Maps" => "RSS dels Mapes",
"RSS Directories" => "RSS dels Directoris",
"RSS Calendars" => "RSS dels Calendaris",
"You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page?" => "Estàs a punt de marxa d'aquestya pàgina. Si has fet canvis sense guardar-los, es perdran els teus canvis.  Segur que vols deixar aquesta pàgina?",
"Loading" => "Carregant",
"Show Tree" => "Mostra l'Arbre",
"Hide Tree" => "Amaga l'Arbre",
"Perform action with checked:" => "Amb els seleccionats, realitza l'acció:",
"Move Selected Files" => "Mou els arxius seleccionats",
"Are you sure you want to delete the selected files?" => "Segur que vols esborrar els següents arxius?",
"Assign Permissions" => "Assignar permisos",
"Move to" => "Mou a",
"Assign" => "Assigna",
"Filename" => "Nom d'arxiu",
"Other Sorts" => "Altres ordenacions",
"No Additionnal Sort" => "Cap ordenació addicional",
"No information" => "No hi ha informació",
"Hi {\$mail_user} has sent you this link:" => "Hola.En/Na {\$mail_user} t'ha enviat aquest enllaç:",
"Blog post:" => "Publicació de bitàcola:",
"at:" => "a:",
"Somebody or you tried to subscribe this email address at our site:" => "Algú o vostè ha intentat subscriure la seva adreça email al nostre lloc:",
"To the newsletter:" => "Als butlletins de notícies:",
"Description:" => " Descripció",
"In order to confirm your subscription you must access the following URL:" => "Per poder confirmar la teva subscripció hauries d'accedir a l'adreça (URL) següent:",
"To validate your account and login to the site, please click on the following link:" => "Per validar el teu compte i connectar-te al lloc, clica a l'enllaç següent, si us plau:",
"The administrator approved your account." => "L'administrador ha aprovat el teu compte.",
"Confirm your email at %s" => "Confirma el teu correu-e a %s",
"Author:" => "Autor:",
"A new message was posted to forum" => "Un nou missatge ha estat escrit al fòrum",
"New topic:" => "Tòpic nou:",
"Topic:" => "Tema:",
"Contribution" => "Contribucions (tipus)",
"You sent a request with the subject:" => "Has enviat una petició amb el tema:",
"Use the subject to indicate the operation to apply:" => "Utilitza l'assumpte per indicar quina operació s'ha d'aplicar:",
"GET:WikiName to get a wiki page" => "GET:NomWiki per obtenir una pàgina wiki",
"PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:NomWiki per actualitzar/crear una pàgina wiki (empra el cos per a les dades de la pàgina)",
"APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:NomWiki per afegir dades a una  pàgina Wiki (utilitza el cos per a les dades que vols afegir)",
"PREPEND:WikiName to append the data at the top" => "PREPEND:NomWiki per afegir les dades a sobre de tot",
"Tiki mail-in instructions" => "Intruccions de correu-dins del Tiki",
"Tiki mail-in auto-reply." => "Resposta automàtica del correu-dins de tiki.",
"Page not found:" => "Pàgina no trobada:",
"Hi," => "Hola,",
"A new message was posted to you at {\$mail_machine}" => "Un nou missatge ha estat escrit per a tu per {\$mail_machine}",
"From" => "Des de",
"New message arrived from %s" => "T'ha arribat un missatge nou de %s",
"Hi" => "Hola",
"Your account registration request for {\$mail_site} was validated by the site admin and your account is active now." => "El teu registre de nou compte de Tiki per al lloc {\$mail_site} ha estat validat per la persona administradora del lloc i ara el teu compte ja és actiu.",
"To login with your username and password, please follow this link:" => "Per connectar-te amb el teu nom d'usuari i contrasenya, segueix aquest enllaç, si us plau:",
"Enjoy the site!" => "Disfruta del lloc!",
"User Account Activated" => "Compte d'usuari Tiki activat",
"{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> ha demanat una nova contrassenya a {\$mail_site}, però primer has de validar el seu compte",
"has requested an account on" => "ha demanat un compte a",
"Group:" => "Grup:",
"To validate that account, please follow the link:" => "Per validar aquest compte, segueix aquest enllaç, si us plau:",
"best regards" => "records",
"your Tikiwiki" => "el teu Tikiwiki",
"User Registration Request" => "Petició de Registre d'Usuari",
"Go to your friendship network to accept or refuse this request" => "Ves a la teva xarxa d'amistat per acceptar o rebutjar aquesta petició",
"You're invited to join my network of friends!" => "Estàs convidat/da a unir-te a la meva xarxa d'amistats!",
"The user" => "L'usuari/a",
"registered at your site" => "registrat al seu lloc",
"New user registration" => "Registre d'usuari nou",
"Bye bye!" => "Adéu!",
"This email address has been removed to the list of subscriptors of:" => "Aquesta adreça de correu-e ha estat esborrada de la llista de subscriptors de:",
"Newsletter:" => "Butlletí:",
"Bye bye from %s at %s" => "Fins aviat, de %s en %s",
"You can unsubscribe from this newsletter following this link" => "Pots desubscriure't d'aquest butlletí seguint aquest enllaç",
"Welcome to our newsletter!" => "Benvingut/da al nostre butlletí!",
"This email address has been added to the list of subscriptors of:" => "Aquesta adreça de correu-e ha estat afegida a la llista de subscriptors de:",
"You can always cancel your subscription using:" => "Sempre pots cancel.lar la teva subscripció emprant:",
"Welcome to %s at %s" => "Benvingut/da %s  %s",
"Email notification" => "Notificació de correu-e del Tiki",
"Someone coming from IP Address" => "Algú des de l'adreça IP d'internet",
"requested a reminder of the password for your account" => "ha demanat un recordatori de la contrasenya del teu compte",
"requested password reset for your account" => "ha demanat que es posi una nova contrasenya per al teu compte",
"Since this is your registered email address we inform that the password for this account is" => "Com aquesta és la teva adreça registrada de correu-e, t'informem que la nova contrasenya per a aquest compte és",
"Important: Username & password are CaSe SenSitiVe" => "Important: el nom com a persona usuària i la contrasenya són sensibles a les Majúscules i minúscules",
"Important: The old password remains active if you don't click the link above." => "Important: La teva antiga contrasenya roman activa si no punxes sobre l'enllaç de més amunt.",
"Your account information for %s" => "La informació del teu compte Tiki per %s",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "Un nou article ha estat enviat per {\$mail_user} a {\$mail_site} el {\$mail_date|tiki_short_datetime}",
"You can edit the submission following this link:" => "Pots editar l'enviament seguint aquest enllaç:",
"Title:" => "Títol:",
"Heading:" => "Encapçalament:",
"Body:" => "Cos:",
"New article submitted at %s" => "Nou article enviat a %s",
"Look at this link:" => "Mira aquest enllaç:",
"A friend sends you a link from: " => "Un amic t'envia un enllaç des de: ",
"Download the file at:" => "Descarrega l'arxiu a:",
"Tracker was modified at" => "El formulari va ser modificat a",
"Please visit this link before login again:" => "Si us plau, visita aquest enllaç abans de connectar-te de nou:",
"User:" => "Usuari/a:",
"Confirm your account at %s" => "Confirma el teu compte a %s",
"You or someone registered this email address at" => "tu o alguna persona ha registrat aquesta adreça de correu-e a",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Si vols ser un usuari registrat en aquesta web hauràs de seguir aquest enllaç la primera vegada:",
"Your registration confirmation" => "El teu registre d'informació de Tiki",
"You will receive an email with information to login for the first time into this site" => "Rebràs un correu-e amb informació per entrar per primera vegada en aquest lloc",
"Your account request has been stored and will be activated by the admin as soon as possible." => "La teva petició de compte ha estat arxivada i serà activada per la persona administradora tan aviat com li sigui possible.",
"You'll receive email notification once your account is activated." => "Rebràs notificació per correu-e un cop ja s'hagi activat el teu compte.",
"Please do not attempt to login until you receive the email notification." => "Si us plau, no intentis connectar-te fins que rebis la notificació per correu-e.",
"View the article at:" => "Visualitza l'article a:",
"If you don't want to receive these notifications follow this link:" => "Si no vols rebre aquestes notificacions segueix aquest enllaç:",
"View the blog at:" => "Visualitza la bitàcola a:",
"New blog post at %s" => "Nova publicació a la bitàcola %s",
"View item calendar at:" => "Mostra l'entrada del calendari a:",
"Modified calendar item" => "Entrada del calendari modificada",
"New calendar item" => "Nova entrada al calendari",
"changed" => "modificat",
"A new category was created in" => "S'ha creat una nova categoria a",
"created" => "creat",
"A category was removed in" => "S'ha eliminat una categoria a",
"Removed by" => "Eliminat per",
"removed" => "eliminat/da",
"A category was updated" => "S'ha actualitzat una categoria",
"Updated by" => "Actualitzat per",
"Old" => "Vell/a",
"New" => "Nou",
"updated" => "Actualitzat",
"File Gallery %s changed" => "La galeria d'arxius %s ha canviat",
"A file was removed from the file gallery" => "Es va eliminar un arxiu de la galeria d'arxius",
"File Name" => "Nom d'arxiu",
"A new file was posted to file gallery" => "S'ha pujat un nou arxiu a la galeria d'arxius",
"Posted by" => "Publicat per",
"File Description" => "Descripció de l'arxiu",
"New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}:" => "Nova publicació al fòrum <{\$mail_forum|truncate:20:\"...\"}> per {\$mail_author}:",
"Image Gallery {\$galleryName} changed" => "Ha canviat la galeria d'imatges {\$galleryName}",
"A new file was posted to image gallery" => "Un nou arxiu s'ha publicat a la galeria d'imatges",
"The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "El mapa {\$mail_page} ha estat canviat per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"You can view the updated map following this link:" => "Pots veure el mapa actualitzat seguint aquest enllaç:",
"You can edit the map following this link:" => "Pots editar el mapa seguint aquest enllaç:",
"An object was added to category" => "S'ha afegit un nou objecte a la categoria",
"Added by" => "Afegit per",
"Object type" => "Tipus d'objecte",
"An object was removed from category" => "S'ha eliminat un nou objecte a la categoria",
"A page has been added to your watched sub-structure:" => "S'ha afegit una pàgina a la subestructura que estàs vigilant:",
"A page has been removed from your watched sub-structure:" => "S'ha afegit una pàgina a la subestructura que estàs vigilant:",
"A page has been promoted out your watched sub-structure:" => "S'ha mogut una pàgina fora de la subestructura que estàs vigilant:",
"A page has been demoted to your watched structure:" => "S'ha mogut una pàgina a la subestructura que estàs vigilant:",
"Structure modified" => "Estructura modificada",
"A new file have been attached to page" => "S'ha adjuntat un nou arxiu a la pàgina",
"File name" => "Nom de l'arxiu",
"New attachment on %s, page" => "Adjunt nou a la pàgina %s,",
"The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} ha estat creada per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} va ser canviada per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"Comment:" => "Comentari:",
"You can view the page by following this link:" => "Pots veure la pàgina si segueixes aquest enllaç:",
"You can view a diff back to the previous version by following this link:" => "Pots veure els canvis respecte la versió anterior si segueixes aquest enllaç:",
"The changes in this version follow below, followed after by the current full page text." => "Els canvis en aquesta versió són a sota, seguides després per la versió sencera actual del text de la pàgina.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Línies: {\$oldd} canviades per +Línies: {\$newd}",
"The new page content follows below." => "El nou contingut de la pàgina segueix a sota.",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La pàgina {\$mail_page} va ser comentada per {\$mail_user} el {\$mail_date|tiki_short_datetime}",
"Wiki page %s was commented on by" => "La pàgina Wiki %s ha estat comentada per",
"an anonymous user" => "un usuari anònim",
"Wiki page renamed" => "La pàgina Wiki ha estat reanomenada",
"Old name" => "Nom vell",
"New name" => "Nou nom",
"Thank you for your registration. You may log in now." => "Gràcies per registrar-te. Ara pots connectar-te.",
"click on the map to zoom or pan, do not drag" => "fes clic a sobre del mapa per ampliar o allunyar, no arrosseguisr",
"Query Results" => "Resultats de la consulta",
"Querying" => "Consultant",
"Scroll Up" => "Desplaça cap a munt",
"Scroll Down" => "Desplaça cap a baix",
"Scale" => "Escala",
"Query" => "Consulta",
"Redraw" => "Redibuixar",
"select zoom/pan/query and image size" => "seleccionar zoom/pan/consulta i tamany d'imatge",
"View the Map Only" => "Veure només el mapa",
"Reset Map" => "Reinicia el mapa",
"Click on the map or click redraw" => "Fes clic a sobre del mapa o fes clic a redibuixar",
"Last modification date" => "Data de la darrera modificació",
"Overview" => "Vista Esquema",
"Legend" => "Llegenda",
"Layer Manager" => "Control de Capa",
"Layer" => "Capa",
"On" => "Actiu",
"Download Layer" => "Capa de Descàrrega",
"This layer has been set by the maps administrator to not be downloadable" => "Aquesta capa ha estat configurada per l'administrador del mapa perquè no sigui descarregable",
"you have requested to download the layer:" => "has demanat descarregar la capa:",
"Here are the files to download, do not forget to rename them:" => "Aquí hi ha els fitxers a descarregar-se, no t'oblidis de renombrar-los:",
"Mapfiles" => "Fitxers de mapa",
"Mapfile" => "Fitxer de mapa",
"Available mapfiles" => "Permés mapa d'arxius",
"hits last 7 days" => "visites dels últims set dies",
"monitor this map" => "Segueix aquest mapa",
"Stop Monitoring this Map" => "Deixa de seguir aquest  mapa",
"Create a new mapfile" => "Crear un nou mapa de l'arxiu",
"Create" => "Crear",
"Mapfile listing" => "Llista de Mapfiles",
"Reload" => "Recarrega",
"History" => "Historial",
"You can view this map in your browser using" => "Pots veure aquest mapa en el teu navegador emprant",
"Zoom out x2" => "Disminuir zoom x2",
"Zoom in x2" => "Augmentar zoom x2",
"Mapfile History" => "Historial de fitxers de mapa",
"of" => "de",
"Compare" => "Comparar",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparant la versió {\$old.version} amb la versió {\$new.version}",
"Version:" => "Versió:",
"Current" => "Actual",
"Versions are identical" => "Les versions són idèntiques",
"Legend:" => "Llegenda:",
"v=view" => "v=visualització",
"c=compare" => "c=compara",
"d=diff" => "d=dif",
"Full side-by-side diff" => "Diferències en tot costat-a-costat",
"Unified diff" => "Diferències unificades",
"Side-by-side view" => "Vista costat-a-costat",
"User" => "Usuari",
"Diff" => "Dif",
"Older Version" => "Versió més vella",
"Directories" => "Directoris",
"back to" => "torna a",
"Upload From Disk:" => "Puja des de Disc:",
"Upload Files" => "Puja fitxers",
"Bytes maximum" => "Octets màxim",
"Create Directory:" => "Crear Directori:",
"index file (.shp):" => "arxiu índex (.shp):",
"files to index (regexp):" => "arxius a indexar (regexp):",
"Message Archive" => "Arxiu de missatges",
"messages" => "missatges",
"Archive is full!" => "L'arxiu és ple!",
"Unread" => "No llegit",
"Flagged" => "Senyalat",
"Unflagged" => "Desmarcat",
"Containing" => "Contingut",
"Sender" => "remitent",
"No messages to display" => "No hi ha cap missatge per mostrar",
"Broadcast message" => "Difondre un missatge",
"OK" => "D'acord",
"All users" => "Tots els usuaris",
"Lowest" => "El més baix",
"Low" => "Baix",
"High" => "Alt",
"Very High" => "Molt Alt",
"Send" => "Envia",
"Compose message" => "Escriu un missatge",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "Si vols que la gent et pugui respondre, habilita l'opció <a href='tiki-user_preferences.php'>Permet missatges d'altres usuaris</a> a les teves preferències.",
"Invalid" => "Invàlid",
"To" => "A",
"No messages to download" => "No hi ha missatges per descarregar",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "La bústia de correu és plena! Esborra o arxiva alguns missatges si vols rebre'n més.",
"is reply to" => "és resposta a",
"Find replied message" => "busca missatges contestats",
"Archive" => "Arxiu",
"Mark as read" => "Marca com llegit",
"Mark as unread" => "Marca com no llegit",
"Mark as flagged" => "Marca com a senyalat",
"Mark as unflagged" => "Marca com no senyalat",
"Mark" => "marca",
"Mailbox" => "Bústia",
"Compose" => "Redacta",
"Broadcast" => "Difon",
"Sent" => "Enviat",
"Auto-archive age for read messages:" => "Edat d'autoarxivament per als missatges llegits:",
"Read message" => "Llegeix missatge",
"Return to mailbox" => "Retorna a la bústia de correu",
"replyall" => "respondre tot",
"Unflag" => "Desmarca",
"Flag this message" => "Marca aquest missatge",
"Return to archive" => "Torna a l'arxiu",
"Return to outbox" => "Torna a la bústia de sortida",
"Sent Messages" => "Missatges enviats",
"Replied" => "Respost",
"Not replied" => "No repost",
"move to archive" => "mou a l'arxiu",
"receiver" => "receptor",
"'name' parameter for tikimodule missed" => "'nom del paràmetre pel mòdul tiki no trobat",
"Move module up" => "Pujar mòdul",
"Up" => "Cap a dalt",
"Move module down" => "Baixar mòdul",
"Down" => "Cap avall",
"Move module to opposite side" => "Moure mòdul al costat oposat",
"opp side" => "banda contrària",
"Unassign this module" => "Desassigna aquest mòdul",
"Are you sure you want to unassign this module?" => "Segur que vols desassignar aquest mòdul?",
"Toggle module contents" => "Intercanvia el contingut del mòdul",
"toggle" => "intercanvia",
"Admin Menu" => "Admin menú",
"Live Support" => "Suport en directe",
"Banning" => "Prohibici",
"Users" => "Usuaris",
"Cache" => "Memòria cau",
"Modules" => "Mòduls",
"Links" => "Enllaços",
"Hotwords" => "Paraules calentes",
"RSS Modules" => "mòduls RSS",
"Menus" => "Menús",
"Polls" => "Votacions",
"Mail Notifications" => "Notificacions per correu",
"Search Stats" => "Estadística de cerca",
"QuickTags" => "Marques ràpides",
"Chat" => "Xat",
"Banners" => "Pancartes",
"Edit Templates" => "edita plantilles",
"Cookies" => "Galetes",
"Mail-in" => "Correu-in",
"Content Templates" => "Plantilles de contingut",
"HTML Pages" => "Pàgines HTML",
"Shoutbox" => "Quadre d'avisos",
"Shoutbox Words" => "Paraules del Requadre d'Avisos",
"Referer Stats" => "Estadístiques de referenciadors",
"Import PHPWiki Dump" => "Importar PHPWiki Dump",
"Admin dsn" => "Administrar dsn",
"Security Admin" => "Admin Seguretat ",
"Display type unknown, you have to enter the banner type" => "Tipus de pantalla desconegut, has d'introduir el tipus de pancarta",
"You forgot your Google ad_client number !" => "Heu oblidat el vostre número de Google ad_client!",
"More..." => "Més...",
"Tikiwiki Assistant" => "Assitent Tikiwiki",
"Thank you for installing Tikiwiki" => "Gràcies per instal·lar Tikiwiki",
"To configure your Tiki" => "Per configurar el teu Tiki",
"Select" => "Seleccionar",
"Admin Home" => "Admin Inici",
"Admin" => "Administrar",
"from the menu" => "des del menú",
"Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Llegeix la <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Documentació de Tikiwiki\" target=\"_blank\">documentatió de configuració</a>",
"Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Mira els <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">videos de demostració",
"To remove this module" => "Per eliminar aquest mòdul",
"Admin Modules" => "Administració de Mòduls",
"and remove the assistant module" => "i eliminar el mòdul de l'assistent",
"You can also add other modules" => "Pots afegir també altres mòduls",
"To customize the menu" => "Per adaptar el menú",
"Admin Menus" => "Administració de Menús",
"and edit menu ID 42" => "i edita el menú ID 42",
"Or, create your own menu and add it to a module" => "O, crea el teu propi menú i afegeix-ho com a mòdul",
"To begin configuring Tiki, please" => "Per començar a configurar Tiki, si us plau",
"login" => "connecta't",
"as the Admin" => "com l'Administrador",
"The Tikiwiki Community" => "La Comunitat Tikiwiki",
"Tikiwiki Documentation" => "Documentació de Tikiwiki",
"For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "Per ajuda, visita <a href=\"http://doc.tikiwiki.org\" title=\"Documentació de Tikiwiki\" target=\"_blank\">http://doc.tikiwiki.org</a>",
"Last blog comments" => "Últim comentari de la bitàcola",
"on blogpost" => "a blogpost",
"Recently visited pages" => "Pàgines recentment visitades",
"January" => "Gener",
"February" => "Febrer",
"March" => "Març",
"April" => "Abril",
"May" => "Maig",
"June" => "Juny",
"July" => "Juliol",
"August" => "Agost",
"September" => "Setembre",
"October" => "Octubre",
"November" => "Novembre",
"December" => "Desembre",
"Tuesday" => "Dimarts",
"Wednesday" => "Dimecres",
"Thursday" => "Dijous",
"Friday" => "divendres",
"Today" => "Avui",
"Add event" => "Afegeix esdeveniment",
"Received objects" => "Objectes rebuts",
"Pages:" => "Pàgines:",
"Last `\$module_rows` Sites" => "darreres `\$module_rows` webs",
"Last Sites" => "Darrers Llocs",
"Directory Stats" => "Estadístiques del Directori",
"Sites" => "Llocs",
"Sites to validate" => "Llocs per validar",
"Searches" => "Cerques",
"Visited links" => "Enllaços visitats",
"Top \$module_rows Sites" => "\$module_rows llocs més visitats",
"Top Sites" => "Els llocs més visitats",
"Current events" => "Esdeveniments actuals",
"Featured links" => "enllaços suggerits",
"Top `\$module_rows` topics" => "`\$module_rows` tòpics més freqüents",
"Top topics" => "Temes principals",
"Last `\$module_rows` forum posts" => "Darrers `\$module_rows` enviaments del fòrum",
"Last forum posts" => "Darrers enviaments al fòrum",
"Last `\$module_rows` forum topics" => "Darrers `\$module_rows` temes del fòrum",
"Last forum topics" => "Últims temes en fòrums",
"Most commented forums" => "Fòrums amb més comentaris",
"Most read topics" => "temes més llegits",
"Most visited forums" => "Fòrums més visitats",
"Folksonomy" => "Folcsonomia",
"Tags This Page Has" => "Etiquetes que té aquesta pàgina",
"Add tags" => "Afegeix etiquetes",
"More Like This" => "Més com aquesta",
"Most popular tags" => "Marcadors més populars",
"List everything tagged" => "Llista tot el que estigui etiquetat",
"My prefered tags" => "Els meus marcadors preferits",
"Google Search" => "Cerca en el Google",
"Last `\$module_rows` actions" => "Últimes `\$module_rows` accions",
"Last actions" => "Últimes accions",
"Last `\$module_rows` articles" => "Darrers `\$module_rows` articles",
"Last articles" => "Els últims articles",
"Last `\$module_rows` blog posts" => "Darrers`\$module_rows` enviaments a la bitàcola",
"Last blog posts" => "Darreres publicacions a les bitàcoles",
"Last" => "Darrer",
"Last `\$module_rows` Created blogs" => "Darreres `\$module_rows` bitàcoles creades",
"Last Created blogs" => "Últimes bitàcoles creades",
"Last `\$module_rows` Created FAQs" => "Darreres `\$module_rows` PMF creades",
"Last Created FAQs" => "Últimes PUFs creades",
"Last `\$module_rows` Created Quizzes" => "Darrers `\$module_rows` qüestionaris creats",
"Last Created Quizzes" => "Darrers qüestionaris creats",
"Last `\$module_rows` modified file galleries" => "darreres `\$module_rows`  galeries d'arxiu modificades",
"Last modified file galleries" => "Galeria de darrers arxius modificats",
"Last `\$module_rows` Files" => "Darrers `\$module_rows` Arxius",
"Last Files" => "Últims arxius",
"Last `\$module_rows` galleries" => "Darreres`\$module_rows` galeries",
"Last galleries" => "Darreres galeries",
"Last `\$module_rows` Images" => "Últimes `\$module_rows` imatges",
"Last Images" => "Darreres imatges",
"insert original" => "inserta l'original",
"insert thumbnail" => "insert el contacte",
"Last `\$module_rows` modified events" => "Últims `\$module_rows` events modificats",
"Last modifed events" => "Últims events modificats",
"Last `\$module_rows` changes" => "Darrers `\$module_rows` canvis",
"Last changes" => "Últimes modificacions",
"more" => "més",
"Last `\$module_rows` Modified Items" => "Darrers `\$module_rows` Ítems modificats",
"Last Modified Items" => "Últims Punts modificats",
"Last `\$module_rows` Modified blogs" => "Darreres `\$module_rows` bitàcoles modificades",
"Last Modified blogs" => "Últimes bitàcoles modificades",
"Last `\$module_rows` submissions" => "darreres `\$module_rows` submissions",
"Last submissions" => "Últimes col·laboracions",
"Last `\$module_rows` Modified Comments" => "Últims `\$module_rows` comentaris modificats",
"Last Modified Comments" => "Últims comentaris modificats",
"Last `\$module_rows` Items" => "Darrers `\$module_rows` Items",
"Last Items" => "Últims Punts",
"Last `\$module_rows` visitors" => "Últims `\$module_rows` visitants",
"Last Visitors" => "Últims visitants",
"No avatar." => "Cap avatar.",
"Register" => "Registre",
"You" => "Tu",
"Live support" => "Suport Directe",
"Open operator console" => "Obre la consola d'operador",
"Online users" => "Usuaris en línia",
"We have" => "Tenim",
"online users" => "usuaris en línia",
"Logged in as" => "Connectat com a",
"Logout" => "Desconnecta't",
"Switch User" => "Canvia't per l'Usuari",
"Switch" => "Canvi",
"Switch user" => "Canvia usuari",
"Login through CAS" => "Connexió a través de CAS",
"Login as admin" => "Connecteu-vos com a administrador",
"Login as" => "Connecta't com a",
"Email" => "Correu-e",
"eMail" => "Correu-e",
"Password" => "contrasenya",
"Remember me" => "Recorda'm",
"week" => "setmana",
"month" => "mes",
"year" => "any",
"Click here to register" => "Fes clic aquí per registrar-te",
"Click here if you've forgotten your password" => "Fes clic aquí si has oblidat la teva contrasenya",
"I forgot my password" => "He oblidat la meva contrasenya",
"Click here to login using the default security protocol" => "Fes clic aquí per entrar usant el protocol de seguretat per defecte",
"Standard" => "Estàndar",
"Click here to login using a secure protocol" => "Fes clic aquí per entrar usant un protocol segur",
"Secure" => "Segur",
"Stay in ssl Mode" => "Roman en mode segur (ssl)",
"local account" => "compte local",
"OpenID Login" => "Connexió OpenID",
"Tiki Logo" => "Logo del Tiki",
"Menu" => "Menú",
"You have" => "Teniu",
"New Messages" => "Nous missatges",
"New Message" => "Nou missatge",
"You have 0 new messages" => "No teniu cap missatge nou",
"Waiting Submissions" => "Col·laboracions en espera",
"submissions waiting to be examined" => "col·laboracions esperant ser examinades",
"Old articles" => "Articles antics",
"Send a message to" => "Envia un missatge a",
"Send a message" => "Envieu un missatge",
"Random Images" => "Imatges aleatòries",
"Random Pages" => "Pàgines a l'atzar",
"Register as a new user" => "Registrar-se com a usuari nou",
"Your email could not be validated; make sure you email is correct and click register below." => "La vostra adreça de correu no ha esta validada; assegureu-vos que l'adreça és correcta i cliqueu el botó inferior de registre.",
"Your registration code:" => "El vostre codi de registre:",
"Username" => "Nom d'usuari",
"Passcode to register (not your user password)" => "Codi per registrar-te (no la teva contrasenya)",
"Registration code" => "Codi de registre",
"Repeat password" => "Repetiu la contrasenya",
"Generate a password" => "Generar una contrasenya",
"RSS Feeds" => "Alimentacions RSS",
"Wiki RSS" => "Alimentacions RSS per al Wiki",
"Blogs RSS" => "Alimentacions RSS per a Bitàcoles",
"Articles RSS" => "Alimentacions RSS per a Articles",
"Image Galleries RSS" => "Alimentació RSS de Galeries d'imatges",
"Image Galleries" => "Galeries d'imatges",
"File Galleries RSS" => "Alimentacions RSS per a Galeries d'Arxius",
"File Galleries" => "Galeries d'arxius",
"Forums RSS" => "Alimentacions RSS per a Fòrums",
"Maps RSS" => "Alimentacions RSS per a Mapes",
"Maps" => "Mapes",
"Calendars" => "Calendaris",
"Entire Site" => "Lloc complet",
"Wiki Pages" => "Pàgines del wiki",
"Image Gals" => "Imatges Gals",
"Images" => "Imatges",
"Blog Posts" => "Publicacions de bitàcoles",
"Advanced Search Help" => "Ajuda de la cerca avançada",
"Search Wiki PageName" => "Cerca NomdePàgina Wiki",
"Read More" => "Llegeix més",
"Since your last visit" => "Des de la teva última visita",
"Since your last visit on" => "Des de la teva última visita el...",
"New Images" => "Imatges noves",
"Wiki Pages Changed" => "Pàgines del wiki modificades",
"New Files" => "Arxius nous",
"New Comments" => "Comentaris nous",
"New Tracker Items" => "Nous ítems del formulari",
"New Calendar Events" => "Nous Esdeveniments al Calendari",
"New Users" => "Usuaris/es nous/ves",
"click to edit" => "fes clic per editar",
"Nothing has changed" => "Res no ha canviat",
"Site Language:" => "Idioma del Lloc: ",
"Theme" => "Tema",
"Site default" => "El que hi ha per defecte a aquest lloc",
"Most Active blogs" => "Bitàcoles més actives",
"Top `\$module_rows` articles" => "`\$module_rows` articles més llegits",
"Top articles" => "Articles més llegits",
"Top `\$module_rows` File Galleries" => "`\$module_rows` Galeries de fitxers més emprades",
"Top File Galleries" => "Galeria d'arxius principals",
"Top `\$module_rows` files" => "`\$module_rows` fitxers més emprats",
"Top files" => "Els fitxers més emprats",
"Top `\$module_rows` Forum Posters" => "`\$module_rows` publicadors més actius dels fòrums",
"Top Forum Posters" => "Els publicadors de Fòrums més actius",
"Top `\$module_rows` games" => "`\$module_rows` jocs més emprats",
"Top games" => "Jocs principals",
"Top `\$module_rows` galleries" => "`\$module_rows` galleries més actives",
"Top galleries" => "Galeries per dalt",
"Top `\$module_rows` Images" => "`\$module_rows` images més visitades",
"Top Images" => "Imatges per dalt",
"Top `\$module_rows` Objects" => "`\$module_rows` Objectes més Actius",
"Top Objects" => "Objects més actius",
"Top `\$module_rows` Pages" => "`\$module_rows` Planes més actives",
"Top Pages" => "Pàgines per dalt",
"Top `\$module_rows` Quizzes" => "`\$module_rows` qüestionaris més actius",
"Top Quizzes" => "Qüestionaris principals",
"Most `\$module_rows` visited blogs" => "Les `\$module_rows` bitàcoles més visitats",
"Top `\$module_rows` Visited FAQs" => "`\$module_rows` PUF's més visitades",
"Top Visited FAQs" => "PUFs més visitades",
"Page translation" => "Traducció de la pàgina",
"There are no translations of this page." => "No hi ha traduccions d'aquesta pàgina.",
"Up-to-date-ness" => "Nivell d'actualització",
"Better translations" => "Traduccions millors",
"update from it" => "actualitza-ho des d'ella",
"view" => "veure",
"None match your" => "Cap encaixa amb els teus",
"Set your preferred languages." => "Especifica el teu idioma preferit.",
"preferred languages" => "idiomes preferits",
"Equivalent translations" => "Traduccions equivalents",
"Translations that need improvement" => "Traduccions que necessiten millores",
"update it" => "actualitza des d'ella",
"Upcoming `\$module_rows` events" => "Properes `\$module_rows` esdeveniments",
"The Next Event" => "El Següent Esdeveniment",
"No Upcoming Events" => "Cap esdeveniment per venir",
"click to view" => "punxa per veure",
"My blogs" => "Les meves bitàcoles",
"Bookmarks" => "Adreces d'interès",
"My galleries" => "Les meves galeries",
"My Pages" => "Les meves pàgines",
"User tasks" => "Tasca d'usuari/a",
"Done" => "fet",
"Del" => "Esb",
"Public tasks" => "Tasques públiques",
"select" => "selecciona",
"User informations" => "Informacions d'ususari",
"Group informations" => "Informacions de grup",
"You need to activate user and/or group trackers" => "Necessites activar el formulari d'usuari i/o de grup",
"Top users" => "Usuaris més actius",
"Whats related" => "Qué hi ha relacionat",
"online user" => "usuari en línia",
"on host" => "al servidor",
"Last `\$module_rows` wiki comments" => "darrers `\$module_rows` wiki comentaris",
"Last wiki comments" => "Darrers wiki comentaris",
"on page" => "a la pàgina",
"Changes that need to be reproduced are highlighted below." => "Es destaquen més avall els canvis que han de ser reproduïts",
"Real Name" => "Nom real",
"vote" => "vota",
"Insert/Edit an internal wiki link" => "Inserta/Edita un enllaç wiki inter",
"Wiki Link insert" => "Inserció d\\'enllaç Wiki",
"Please make a selection of text in order to create a link" => "Fes una selecció de text per crear un enllaç",
"Insert an image" => "Inserta una imatge",
"Tiki Image - Insert an image" => "Imatge de Tiki - Inserta una imatge",
"Structures:" => "Estructures:",
"show structures" => "mostrar estructures",
"hide structures" => "amaga estructures",
"Manage structures" => "Gestioneu estructures",
"Location : " => "Lloc : ",
"Find:" => "Troba:",
"pages" => "pàgines",
"To edit the copyright notices" => "Per editar els avisos de Copyright",
"Click Here" => "Cliqueu aquí",
"The content on this page is licensed under the terms of the" => "El contingut d'aquesta pàgina està sota llicència amb els termes de",
"Print" => "Multi-Impressió",
"Email This Post" => "envia per correu electrònic aquest enviament",
"Permalink" => "Enllaç de Permanència",
"comment" => "comentari",
"comments" => "comentaris",
"First page" => "Primera pàgina",
"Previous page" => "Pàgina anterior",
"page" => "pàgina",
"Next page" => "Pàgina següent",
"Last page" => "Última pàgina",
"referenced by" => "citat per",
"references" => "referències",
"View Comments" => "Visualitza comentaris",
"Trackback pings" => "Pings de retrorastreig",
"Blog name" => "Nom de la Bitàcola",
"Enlarge area height" => "fes més gran l'alçada",
"Reduce area height" => "Reduir l'alçada de l'àrea",
"Do not group by item" => "No agrupis per ítem",
"Group by item" => "Agrupa per ítem",
"Calendar View" => "Vista de Calendari",
"List View" => "Vista de Llista",
"Tiki Action Calendar" => "Calendari d'accions del Tiki",
"Tools Calendars" => "Eines de Calendaris",
"Check / Uncheck All" => "Marcar / desmarcar tot",
"Refresh" => "Refrescar",
"Tip" => "Pista",
"Cancel Edit" => "Cancel·la edició",
"Change preferences" => "Canviar preferències",
"Site Ads and Banners" => "Anuncis i pancartes del lloc",
"Content" => "Contingut",
"Activate" => "Activa",
"Publish" => "Publica",
"Features" => "Funcionalitats",
"Profiles" => "Perfils",
"Customize look and feel of your Tiki" => "Adapta l'aparença del teu Tiki",
"Look &amp; Feel" => "Aparença",
"i18n" => "i18n (Internacionalització i idiomes)",
"Text area" => "Àrea de Text",
"Module" => "Mòdul",
"Meta Tags" => "Meta Etiquetes",
"Community" => "Comunitat",
"Freetags" => "Etiquetes lliures",
"Multimedia" => "Multimèdia",
"User files" => "Fitxers de l'usuari",
"Webmail" => "CorreuWeb",
"Wysiwyg editor" => "Editor Wysiwyg",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Per afegir/eliminar bitàcoles, ves a \"Crea/Edita bitàcola\" dins de \"Bitàcoles\" en el menú principal de l'aplicació, o",
"General Settings" => "Configuracions Generals",
"Home Blog (main blog)" => "Bitàcola Inicial (principal)",
"Rankings" => "Posicions",
"Not Installed" => "No instal·lat",
"Points" => "Punts",
"Force and limit categorization to within subtree of" => "Força i limita la categorització a dins del subarbre de",
"Title length" => "Longitud del Títol",
"Creation date" => "Data de creació",
"Last modified" => "Darrers canvis",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Per afegir/eliminar calendaris, cerca \"Calendari\" dins de \"Admin\" en el menú principal de l'aplicació, o",
"Change settings" => "Canvia els paràmetres",
"Default calendars to display" => "Calendaris per omissió a mostrar",
"All calendars" => "Tots els calendaris",
"A subset of available calendars" => "Un subconjunt dels calendaris disponibles",
"Create calendar" => "Crea un calendari",
"Default view mode" => "Mode de vista per defecte",
"View list begins" => "Llista de vista comença",
"Focus Date" => "Data d'interès",
"Period beginning" => "Inici del període",
"First day of the week" => "Primer dia de la setmana",
"Split hours in periods of" => "Divideix hores en períodes de",
"1 minute" => "1 minut",
"10 minutes" => "10 minuts",
"Manual selection of time/date" => "Selecció manual de dia/hora",
"JS calendar" => "Calendari JavaScript (JS)",
"Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "La selecció d'any és vàlida quan <strong>no s'ha activat</strong> el Calendari JavaScript (JS)",
"First year in the dropdown" => "Primer any al desplegable",
"Enter a year or use +/- N to specify a year relative to the current\n\tyear" => "Introdueix un any o empra +/- N per especificar un any relatiu a l'any \n\tactual",
"Last year in the dropdown" => "Darrer any al desplegable",
"Group calendars" => "Calendaris de grup",
"Sticky popup" => "Emergent enganxós",
"Item view tab" => "Pestanya de visualització d'ítem",
"Browse categories" => "Navega per les categories",
"Administer categories" => "Administra categories",
"Enable now" => "Habilita-ho ara mateix",
"Permissions" => "permisos",
"Ignore category viewing restrictions" => "Ignora les restriccions de visualització de categories",
"Permission to all (not just any) of an object's categories is required for access" => "Per poder accedir a un objecte, cal tenir permís per a totes les categories a les que està associat (i no pas a qualsevol d'elles)",
"Look under \"Articles\" on the application menu for links to" => "Cerca dins de \"Articles\", en el menú principal de l'aplicació, per enllaços a",
"Topic" => "Tema",
"Submissions" => "col·.laboracions",
"Import CSV file" => "Importeu un fitxer CSV",
"Batch upload (CSV file)" => "Pujada en bloc (arxiu CSV)",
"Import" => "Importa",
"Gender" => "Gènere",
"Number of friends" => "Nombre d'amics/gues",
"E-mail" => "Correu electrònic",
"Last login" => "Última connexió",
"Distance" => "Distància",
"Users Default Preferences" => "Preferències per defecte per als nous usuaris",
"default" => "per defecte",
"Number of visited pages to remember" => "Quantitat de pàgines visitades a recordar",
"Displayed time zone" => "Zona horària mostrada",
"Detect user timezone if browser allows, otherwise site default" => "Detecta la zona horària de l'usuari si el navegador ho permet, d'altra forma, per defecte del lloc",
"User information" => "Informació d'usuari/a",
"Private" => "Privat",
"public" => "públic",
"Use double-click to edit pages" => "Empra doble-clic per editar planes",
"Show user's info on mouseover" => "Mostra la informació de l'usuari en passar el punter del ratolí per sobre",
"Tasks per page" => "Tasques per pàgina",
"Messages per page" => "Missatge per pàgina",
"Allow messages from other users" => "Permetre missatges d'altres usuaris",
"Send me an email for messages with priority equal or greater than" => "Envia'm un email per els missatges amb prioritat més gran o igual que",
"Auto-archive read messages after x days" => "Auto-arxiva missatges llegits després de x dies",
"never" => "mai",
"My Tiki" => "El meu Tiki",
"My pages" => "Les meves pàgines",
"My messages" => "Els meus missatges",
"My tasks" => "Les meves tasques",
"My forum topics" => "Els meus tòpics de fòrums",
"My forum replies" => "Les meves respostes de fòrums",
"My items" => "Els meus ítems",
"My workflow" => "El meu flux de treball",
"Copyright allows to determine a copyright for all the objects of tikiwiki" => "El copyright permet determinar un copyright per a tots els objectes del tikiwiki",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Per configurar el teu directori, troba \"Admin directori\" dins de \"Directori\" en el menú principal de l'aplicació, o",
"Number of columns per page when listing categories" => "Nombre de columnes per pàgina en llistar les categories",
"Links per page" => "Enllaços per pàgina",
"Validate URLs" => "Validació de URLs",
"enable cool sites" => "habilita llocs guais",
"Show Country Flag" => "Mostra la bandera del país",
"Method to open directory links" => "Mètode per obrir el directori d'enllaços",
"New Window" => "Nova finestra",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "Per afegir/eliminar PUFs, cerca \"Admin FAQs\" dins de \"PUFs\" en el menú principal de l'aplicació, o",
"Default number of comments per page" => "Nombre per defecte de comentaris per pàgina",
"Comments default ordering" => "Ordre per defecte dels comentaris",
"Question and Answer prefix on Answers" => "Prefix de pregunta i resposta a les respostes",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Si us plau, consulta l'<a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>avaluació de cada funcionalitat</a> al lloc web de documentació de Tiki.",
"Apply" => "Aplica",
"Reset" => "Reespecifica",
"Experimental" => "Experimentals",
"Newsletters" => "Butlletins",
"Action Log" => "Registre d'accions",
"Action log setting" => "Configuració del registre d'accions",
"Internationalization" => "Internacionalització (I18n)",
"Multilingual" => "Multilingualitat",
"Surveys" => "Enquestes",
"Featured Help" => "Ajuda oferta",
"Copyright System" => "Sistema de Copyright",
"Copyright system" => "Sistema de Copyright",
"Live support system" => "Sistema de suport en directe",
"Tell a Friend" => "Digues-li a les teves amistats",
"Contact Us" => "Contacta'ns",
"User interface enhancement features" => "Funcionalitats de millores de la interfície de l'usuari",
"JsCalendar" => "JsCalendari",
"JavaScript popup date selector" => "Selector de dates emergent de JavaScript",
"PHPLayers" => "CapesPHP",
"PhpLayers Dynamic menus" => "Menús dinàmics a capes Php",
"Fullscreen" => "Pantalla Sencera",
"Allow users to activate fullscreen mode" => "Permet als usuaris activar el mode de pantalla completa",
"Shadowbox" => "Shadowbox (permet efectes gràfics moderns en imatges)",
"Experimental Features" => "Funcionalitats Experimentals",
"HTML Purifier" => "Purificador d'HTML",
"HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "Purificador d'HTML (El contingut és netejat a XHTML 1.1 Strict cada cop que es desa)",
"Mobile" => "Mòbil",
"Morcego 3D browser" => "Navegador 3D Morcego",
"Search engine friendly url" => "URLs amigables als cercadors",
"Spreadsheet" => "Full de càlcul",
"Tiki Sheet" => "Full Tiki",
"Drawings" => "Dibuixos",
"Friendship" => "Amistat",
"Friendship Network" => "Xarxa d'amistats",
"Games" => "Jocs",
"Administration Features" => "Prestacions de l'Administració",
"Banning System" => "Sistema de Prohibició",
"Banning system" => "Sistema de prohibició",
"Stats" => "Estadístiques",
"Action Calendar" => "Calendari d'Accions",
"Tiki action calendar" => "Calendari d'accions del Tiki",
"Redirect On Error" => "Redirigeix en trobar Errors",
"Communications (send/receive objects)" => "Comunicacions (enviar/rebre objectes)",
"Custom Home" => "Personalitzar Inici",
"User Features" => "Funcionalitats de l'usuari/a",
"Display 'MyTiki' in the application menu" => "Mostra 'ElMeuTiki' al menú de l'aplicació",
"Mini Calendar" => "Mini Calendari",
"User Preferences Screen" => "Pantalla de preferències d'usuari/a",
"User Notepad" => "Bloc de notes de l'usuari",
"User Bookmarks" => "Adreces d'interès de l'usuari",
"User Contacts" => "Contactes d'usuari",
"User Watches" => "Avisos d'usuari/a",
"User Watches Translations" => "L'usuari vigila les traduccions",
"User Menu" => "Menú d'Usuari ",
"User Tasks" => "Tasques d'usuari",
"User Messages" => "Missatges d'usuari",
"User Files" => "Arxius d'Usuari",
"Newsreader" => "Lector de noticies",
"User Levels" => "Nivells d'Usuari",
"Integrator" => "Integrador",
"Debugger Console" => "Consol·la Depuradora",
"Workflow" => "Fluxdetreball",
"Workflow engine" => "Motor del Fluxdetreball",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Si decideixes guaradr arxius en un directori, t'has assegurar que l'usuari no pot accedir directament el directori.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Tens dues opcions per aconseguir això:<br /><ul><li>Empra un directori fora de la teva carpeta arrel de documents web; assegura't que els teus arxius mphp poden llegir i esciure a aquest directori</li><li>Empra un directori dins la carpeta arrel de documents web i empra .htaccess per prevenir que l'usuari pugui llistar el contingut d'aquest directori</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Per configurar la ruta al directori empra rutes estil UNIX; per exemple arxius/ o c:/foo/arxius o /www/arxius/",
"Home Gallery (main gallery)" => "Galeria principal",
"The server must be able to read/write the directory." => "El servidor ha de poder llegir/escriure el directori.",
"The directory can be outside the web space." => "El directori pot ser fora de l'espai web.",
"Allow same file to be uploaded more than once" => "Permet que es pugui pujar el mateix arxiu més d'un cop",
"Never" => "Mai",
"Yes, even in the same gallery" => "Sí, fins i tot a la mateixa galeria",
"Only in different galleries" => "Només en galeries diferents",
"MIME Type" => "Tipus MIME",
"Reindex all files for search" => "Reindexa tots els arxius per a la cerca",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Per afegir/eliminar fòrums, cerca \"Admin fòrums\" dins de \"Fòrums\" en el menú de principal l'aplicació, o",
"Home Forum (main forum)" => "Fòrum Inicial (principal)",
"Accept wiki syntax" => "Aceptar sintaxi-wiki",
"Topics" => "Temes",
"Posts per day" => "Publicacions per dia",
"Tag Management" => "Gestió d'Etiquetes",
"Browser width" => "Amplada del navegador",
"Browser height" => "Alçada del navegador",
"Navigation depth" => "Profunditat de navegació",
"Node size" => "Mida del node",
"Text size" => "Mida del text",
"Spring (connection) size" => "Mida (de la connexió) de la molla",
"Camera distance adjusted relative to nearest node" => "La distància a la càmera s'ajusta en funció del node més proper",
"Camera distance" => "Distància a la càmera",
"Field of view" => "Camp de vista",
"Feed animation interval (milisecs)" => "Interval d'animació del canal (milisegons)",
"Friction constant" => "Constant de fricció",
"Elastic constant" => "Constant elàstica",
"Eletrostatic constant" => "Constant electrostàtica",
"Node mass" => "Massa del node",
"Node charge" => "Càrrega del node",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Per afegir/eliminar galeries d'imatges, ves a \"Galeries d'Imatges\" en el menú de principal l'aplicació, o",
"You can upload images of a size of " => "Pots pujar imatges fins la mida de ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Altera les variables de l'arxiu php.ini file_uploads, upload_max_filesize, post_max_size i database variables (max_allowed_packet for mysql) per canviar aquest valor",
"Home Gallery" => "Galeria inicial",
"Galleries features" => "Preferència de galeries",
"Uses Slideshow" => "Empra Pasi de diapos",
"Use database to store images" => "Empra la base de dades per desar les imatges",
"Use a directory to store images" => " Empra el directori per desar les imatges",
"Directory path" => "Ruta cap al directori",
"Library to use for processing images" => "Llibreria per a fer servir per a processament d'imatges",
"Uploaded image names must match regex" => "Els noms de les imatges penjades han de coincidir amb el regex",
"Uploaded image names cannot match regex" => "Els noms de les imatges penjades no han de coincidir amb el regex",
"Directory Batch Loading" => "Directori per Pujades en Bloc",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Si habilites el Directori per Pujades en Bloc, necessites configurar un directori llegible per la web (fora del teu espai web és millor). Llavors posa a punt una manera per pujar les teves imatges en aquest directori, sigui via scp, sftp, ssh, ftp, o altres protocols",
"Enable directory batch loading" => "Habilita la carrega en bloc al directori",
"Batch loading directory" => "Directori per càrregues en bloc",
"Images per row" => "Imatges per fila",
"Thumbnails size X" => "Mida x per a miniatures",
"Thumbnails size Y" => "Mida Y per a miniatures",
"pixels" => "píxels",
"Set features" => "Fixar Funcionalitats",
"Exterminator" => "Exterminador",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Treure imatges de la galeria del sistema, no emprades en planes wiki, galeries o publicacions de les bitàcoles",
"Mover" => "Translocador",
"Move images from database storage to filesystem storage" => "Moure les imatges des de l'emmagatzematge en base de dades a l'emmagatzematge en el sistema d'arxius",
"Move images from filesystem storage to database storage" => "Moure les imatges des de l'emmagatzematge en el sistema d'arxius a l'emmagatzematge en base de dades",
"All galleries" => "Totes les galeries",
"System Gallery" => "Galeria del sistema",
"Move images from old filesystem store to new directory" => "Moure les imatges des de l'emmagatzematge en sistema d'arxius vell al nou directori",
"Moved" => "Moguts/des",
"Gallery listing configuration" => "Configuració de llistat de galeries",
"Parent" => "Pare",
"Change configuration" => "Canvia la configuració",
"Image galleries comments settings" => "Configuració dels comentaris de les galeries d'imatges",
"General Preferences" => "Preferències Generals",
"Date and Time Formats" => "Data i Formats de Temps",
"Tiki version" => "Versió de Tiki",
"Reset or upgrade your database" => "Torna a especificar o actualitza la teva base de dades",
"Check frequency" => "Freqüència de comprovació",
"Site Identity" => "Identitat del Lloc",
"Browser title" => "Títol (finestra del navegador)",
"Sender email" => "correu-e de l'enviador",
"Home Page" => "Pàgina Inicial",
"Use group homepages" => "Empra planes d'inici de grup",
"Go to group homepage only if login from default homepage" => "Ves a la pàgina de grup només si la connexió es fa des de la pàgina inicial per defecte",
"Custom home" => "Inici personalitzat",
"Windows" => "Finestres",
"Unknown/Other" => "Desconegut/Altres",
"(standard)" => "(estàndard)",
"(some Unix MTA)" => "(alguns MTA Unix)",
"Protect against CSRF with a ticket" => "Protegir contra CSRF amb un tiquet",
"Use proxy" => "Empra proxy",
"Tikiwiki.org help" => "Ajuda en Tikiwiki.org",
"Store session data in database" => "Guardar informació de sessió a la base de dades",
"Contact" => "Contacte",
"Contact user" => "Usuari de contacte",
"Count admin pageviews" => "Compta visualitzacions de pàgines per l'admin",
"Temporary directory" => "Directori temporal",
"Help System" => "Ajuda del Sistema",
"Help URL" => "URL d'Ajuda",
"Examples" => "Exemples",
"Default timezone" => "Zona horària per defecte",
"Long date format" => "Format llarg de data",
"Short date format" => "Format curt de data",
"Long time format" => "Format llarg d'hora",
"Short time format" => "Format curt d'hora",
"Fields display order" => "Ordenació per mostrar els camps",
"Date and Time Format Help" => "ajuda Data i Format de Temps",
"Change admin password" => "Canviar contrasenya de l'administrador",
"New password" => "Nova contrasenya",
"Change password" => "Canvia la contrasenya",
"Google Map setup" => "Paràmetres dels Mapes de Google",
"You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at :" => "Necessites demanar una Clau de Mapes de Google per a aquest lloc. La pots generar fàcilment a :",
"Google Map Key" => "Clau del Mapa de Google",
"Default x for map center" => "Coordenada x per defecte per al centre del mapa",
"Default y from map center" => "Coordenada y per defecte per al centre del mapa",
"Default zoom level" => "Nivell de zoom per defecte",
"whole earth" => "tota la Terra",
"country size" => "mida de país",
"city size" => "mida de ciutat",
"max zoom" => "zoom màxim",
"Detect browser language" => "Detecta l'idioma del navegador",
"Show pages in user's preferred language" => "Mostra la pàgines en l'idioma preferit de l'usuari",
"Restrict supported languages" => "Restringeix els idiomes suportats",
"Quantify change size" => "Quantifica la mida del canvi",
"Multilingual structures" => "Estructures Multilíngües",
"Use database for translation" => "Empra base de dades per a la traducció",
"Edit or ex/import Languages" => "Edita o exporta/importa Idiomes",
"Record untranslated" => "Registre no traduït",
"Syntax error" => "Error de Sintaxi",
"Intertiki exchange feature" => "Funció d'intercanvi Intertiki",
"Intertiki client" => "Client InterTiki",
"Tiki Unique key" => "Clau Tiki Única",
"InterTiki Slave mode" => "Mode esclau de l'InterTiki",
"Warning: overrides manually registered local users" => "Avís: sobreescriu manualment els usuaris locals registrats",
"as master" => "com a mestre",
"Import user preferences" => "Importa les preferències d'usuari",
"Import user groups" => "Importa els grups d'usuari",
"Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limita la importació de grups (llista separada per comes de grups importats, deixa en blanc per evitar la limitació)",
"InterTiki Server" => "Servidor InterTiki",
"host" => "servidor",
"Add new server" => "Afegeix nou servidor",
"Intertiki server" => "Servidor Intertiki",
"Intertiki Server enabled" => "Servidor Intertiki disponible",
"Access Log file" => "Arxiu de registre d'accessos",
"Errors Log file" => "Fitxer de registre d'errors",
"Known hosts" => "Servidors coneguts",
"Key" => "Clau",
"Enable/disable Tiki features in " => "Habilita/deshabilita funcionalitats de Tiki en ",
", but configure them elsewhere" => ", però configura-les en un altres lloc",
"Text Area" => "Àrea de Text",
"Wysiwyg" => "Wysiwyg (Editor Visual)",
"Admin Groups" => "Administarció de grups",
"Admin Users" => "Administrar usuaris",
"PEAR::Auth" => "PEAR::Autor",
"Authentication method" => "Mètode d'Autentificació",
"Tiki and HTTP Auth" => "Auth Tiki i HTTP",
"Registration" => "Registre",
"Users can register" => "Usuaris poden registrar-se",
"Use challenge/response authentication" => "Empra autenticació de repte/resposta",
"HTTP port" => "Port HTTP",
"HTTPS port" => "Port HTTPS",
"User's choice" => "Elecció de l'usuari",
"Always" => "Sempre",
"Duration" => "Durada",
"PAM service" => "Servei PAM",
"Currently unused" => "No utilitzat actualment",
"You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/." => "També et cal pujar el <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/.",
"CAS server version" => "versió del servidor CAS",
"Version 1.0" => "Versió 1.0",
"Version 2.0" => "Versió 2.0",
"General Layout" => "Disposició General",
"Users can change theme" => " Els usuaris registrats poden canviar el tema",
"Restrict available themes" => "Restringeix els temes d'estètica disponibles",
"Available styles:" => "Estils disponibles:",
"Slideshows theme" => "Tema dels passis de diapositives",
"Use transition style sheet from version" => "Empra el full d'estil de transició de la versió",
"Edit CSS" => "Edita CSS",
"Theme Control" => "Control de Temes",
"Template Viewing" => "Vista de Plantilles",
"Tiki Template Viewing" => "Visualització de plantilles del Tiki",
"View Templates" => "Visualitza les plantilles",
"General Layout options" => "Opcions generals de format",
"Custom Site Header" => "Capçalera del Lloc Adaptada",
"logged as" => "connectat com",
"Site logo source (image path)" => "Font del logo del lloc (ruta de la imatge)",
"Site logo background color" => "Color del rerafons del logo",
"Site logo alignment" => "Alineació del logo del lloc",
"Site logo title (on mouse over)" => "Títol del logo del lloc (en passa el ratolí per sobre)",
"Alt. description (e.g. for text browsers)" => "Descripció alt. (p.e. per navegadors basats en text)",
"Site Search Bar" => "Barra de Cerca del Lloc",
"Site Login Bar" => "Barra de Connexió al Lloc",
"Top Bar" => "Barra de Dalt",
"Site menu bar" => "Barra del menú del lloc",
"Menu ID" => "ID del Menu",
"Current Version" => "Versió actual",
"Custom code" => "Codi adaptat",
"Users can Flip Columns" => "Els usuaris poden amagar temporalment les columnes",
"Left column" => "Columna esquerra",
"always" => "sempre",
"user decides" => "l'usuari decideix",
"Site Breadcrumbs" => "Rastres en el Lloc",
"Site location bar" => "Barra de localització del lloc",
"at top of page" => "a la part superior de la pàgina",
"at top of center column" => "a la part superior de la columna central",
"Prefix breadcrumbs with 'Location : '" => "Prefix de les molles de pa amb 'Lloc : '",
"Larger font for" => "Font més gran per a",
"entire location" => "lloc sencer",
"page name" => "nom de pàgina",
"Use page description:" => "Empra descripció de planes:",
"Right column" => "Columna dreta",
"Site Report Bar" => "Barra d'Informes del Lloc",
"Webmaster Report" => "Informa al Mestre de la Web",
"Webmaster Email" => "Correu-e del Mestre de la Web",
"Left blank to use the default sender email" => "Deixa-ho en blanc per emprar el correu-e per defecte de l'enviador",
"Email this page" => "Envia aquesta pàgina per Correu-e",
"Custom Site Footer" => "Barra al peu Adaptada del Lloc",
"Bottom bar icons" => "Icones de la barra al peu",
"Bottom bar debug" => "Barra del peu de depuració",
"Pagination links" => "Enllaços de Paginació",
"Maximum number of records in listings" => "Quantitat màxima de registres en llistats",
"Use relative (next / previous) pagination links" => "Empra enllaços relatius de paginació (següent / previ)",
"Use direct pagination links" => "Empra enllaços directes de paginació",
"Max. number of links around the current item:" => "Màx. nombre d'enllaços sobre l'ítem actual:",
"Max. number of links after the first or before the last item:" => "Màx. nombre d'enllaços després del primer ítem o abans del darrer:",
"Display 'First' and 'Last' links" => "Mostra Enllaços 'Primer/a' i 'Darrer/a'",
"Display fast move links (by 10 percent of the total number of pages) " => "Mostra enllaços per moure's ràpid (per 10 per cent del nombre total de pàgines) ",
"Use Icons" => "Empra Icones",
"Warning" => "Avís",
"Horizontal" => "Horitzontal",
"Left" => "Cap a l'esquerra",
"Right" => "Cap a la dreta",
"Other options" => "Altres opcions",
"Use Tabs" => "Empra tabuladors",
"Display menus as folders" => "Mostra menús com a carpetes",
"Layout per section" => "Format per secció",
"Admin layout per section" => "Administra formats per seccions",
"Favicon icon file name:" => "Nom d'icona Favicon:",
"Favicon icon MIME type:" => "Tipus MIME d'icona Favicon:",
"image/png" => "imatge/png",
"image/bmp" => "imatge/bmp",
"image/x-icon" => "imatge/x-icon",
"full path to mapfiles" => "ruta sencera als mapfiles",
"default mapfile" => "arxiudemapa per defecte",
"Wiki Page for Help" => "Plana Wiki d'Ajuda",
"Wiki Page for Comments" => "Plana Wiki per Comentaris",
"Full path to gdaltindex" => "Ruta sencera al gdaltindex",
"Full path to ogr2ogr" => "Camí complet a ogr2ogr",
"Map Zone" => "Zona del Mapa",
"Generate User Map" => "Genera Mapa d'usuaris",
"Users can opt-out internal messages" => "Els usuaris poden escollir no rebre missatges interns",
"Users accept internal messages by default" => "Els usuaris poden acceptar missatges interns per defecte",
"Maximum mailbox size (messages, 0=unlimited)" => "Mida màxima de la bústia de correu-e (missatges, 0=sense límit)",
"Maximum mail archive size (messages, 0=unlimited)" => "Mida màxima dels arxius de correu-e (missatges, 0=sense límit)",
"Maximum sent box size (messages, 0=unlimited)" => "Mida màxima de la bústia de sortida (missatges, 0=sense límit)",
"geo.position" => "geo.posició",
"geo.region" => "geo.regió",
"geo.placename" => "geo.nomdellloc",
"Users can configure modules" => "Usuaris poden configurar mòduls",
"Display modules to all groups always" => "Mostra sempre els mòduls a tots els grups",
"Hide anonymous-only modules from registered users" => "Amaga els mòduls per a anònims dels usuaris registrats",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Per afegir/eliminar votacions, cerca \"Votacions\" dins d'\"Admin\" en el menú principal de l'aplicació, o",
"Show categories" => "Mostra categories",
"Show objects" => "Mostra objectes",
"TikiWiki Profiles" => "Perfils de TikiWiki",
"Last update" => "Última actualització",
"Profile" => "Perfil",
"installed" => "instal·lat",
"Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS Modules</strong> menu option, or" => "Empra aquesta pàgina per configurar les alimentacions RSS generades per Tiki. Per sindicar les alimentacions RSS d'altres llocs, empra l'opció del menú <strong>Admin</strong> &gt; <strong>Mòduls RSS</strong>, o",
"Feature is disabled." => "La funcionalitat està deshabilitada.",
"Maximum number of items to display" => "Màximu nombre d'ítems per mostrar",
"Image galleries" => "Galeries d'imatges",
"Feed for forums" => "Alimentació per fòrums",
"Calendar events" => "Esdeveniments del calendari",
"Default RDF version" => "versió RDF per defecte",
"Specification" => "Especificació",
"Documentation" => "Documentació",
"Webmaster" => "Mestre Web",
"Caching time:" => "Temps en memòria cau (caché):",
"Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public." => "Permetre guardar una còpia en memoria cau manarà per sobre dels permisos existents - tot el contingut serà públic. Habilita aquesta opció <strong>només</strong> si el teu contingut sindicat hauria de ser públic.",
"You can see users rank by score in the module users_rank, for that go to" => "Pots veure un ranking d'usuaris per puntuació en el mòdul de ranking d'usuaris (users_rank); si t'interessa, ves a",
"Admin modules" => "Admin moòuls",
"Expiration" => "Caducitat",
"Search stats" => "Estadístiques de les cerques",
"can be seen on page" => "pot ser vist a la pàgina",
"in Admin menu" => "al menú d'Administració",
"random" => "aleatori",
"Refresh rate" => "Temps de refresc",
"Minimum length of search word" => "Llargada mínima de mot a cercar",
"Max. number of words containing a syllable" => "Nombre màxim de mots que continguin una síl·laba",
"Max. age in hours of syllable search cache" => "Temps màxim (en hores) de la recerca al caxé",
"LRU list purging rate" => "Valoració de la purga de llista LRU",
"LRU list length" => "llargada de llista LRU",
"Refresh wiki search index now" => "Refresca l'index de cerca wiki ara",
"Refresh trackers search index now" => "Refresca ara l'índex de cerca de formularis",
"Refresh tracker search index now" => "Refresca ara l'índex de cerca de formulari",
"Refresh files search index now" => "Refresca l'índex de cerca ara mateix",
"Referer Search Highlighting" => "Ressaltat dels referenciadors de les cerques",
"Ignore individual object permissions" => "Ignora els permisos individuals dels objectes",
"hits" => "cops",
"Text area (that apply throughout many features)" => "Àrea de text (que té aplicació a través de moltes funcions)",
"Plugins" => "Connectors (Plugins)",
"Protect email against spam" => "Protegeix el correu-e contra el correu brossa",
"Open external links in new window" => "Obrir enllaços externs en una finestra nova",
"Dynamic Content System" => "sistema contingut Dinàmic",
"Automonospaced text" => "Text Automonoespaiat",
"Tables syntax" => "Sintaxi de taules",
"AutoLinks" => "Autoenllaços",
"rows" => "línies",
"Enable" => "Habilita",
"Required" => "Requerit",
"Parameters" => "Paràmetres",
"To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "Per configurar els teus formularis, busca \"Administra formularis\" sota \"Formularis\" en el menú de l'aplicació, o",
"Trackers with mirror tables" => "Formularis amb taules mirall",
"Use trackers with mirror tables" => "Empra formularis amb taules mirall",
"Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Els valors són guardats en una taula dedicada per a cada formulari; així pots manipular les dades fàcilment fora de Tikiwiki",
"Validate choice" => "Valida l'elecció",
"dls" => "baixades",
"Storage" => "Emmagatzematge",
"Change" => "Canvia",
"Change all to db" => "Canvia-ho tot a base de dades",
"Change all to file" => "Canvia-ho tot a arxius",
"Use database to store userfiles" => "Utilitza una base de dades per emmagatzemar les dades dels usuaris",
"Use a directory to store userfiles" => "Utilitza un directori per emmagatzemar les dades dels usuaris",
"Allow viewing HTML mails?" => "Permetre veure correus en HTML?",
"Maximum size for each attachment" => "Mida màxima per cada afegit",
"Unlimited" => "Il·limitat",
"Create New" => "Crear nou",
"Home page" => "Pàgina Principal",
"Complete" => "Complet",
"Individual cache" => "Caxé Individual",
"Content templates" => "Plantilles de contingut",
"Warn on edit conflict" => "Conflicte d'avís en editar",
"Undo" => "Desfès",
"Footnotes" => "Notes al peu",
"Permission" => "Permís",
"Allow HTML" => "Permetre HTML",
"Regex search and replace" => "Cerca i reemplaça amb Regex",
"Sandbox" => "LlocdeProves",
"Dumps" => "Buidats",
"Remove a tag" => "Elimina una etiqueta",
"Generate dump" => "Generar volcat",
"Download last dump" => "Baixar darrer volcat",
"Pictures" => "Fotos",
"Remove unused pictures" => "Elimina fotos no emprades",
"Export" => "Exporta",
"Export Wiki Pages" => "Exporta Pàgines del Wiki",
"Accept dashes and underscores in WikiWords" => "Accepta guions normals (-) i guions baixos (_) en ParaulesWiki",
"Link plural WikiWords to their singular forms" => "Enllaç plural a les WikiParaules als seus formularis particulars",
"HTML diff" => "Diferències en HTML",
"Side-by-side diff" => "Diferències costat-a-costat",
"Side-by-side diff by characters" => "Diferències costat a costat per caràcters",
"Inline diff" => "Diferències en línia",
"Inline diff by characters" => "Diff en línia per caràcters",
"Full side-by-side diff by characters" => "Diff costat-a-costat sencer per caràcters",
"Full inline diff" => "Diff en línia sencer",
"Full inline diff by characters" => "Diff en línia sencer per caràcters",
"Discuss pages on forums" => "Pàgines de Debat als fòrums",
"like pages" => "pàgines similars",
"Structures" => "Estructures",
"Open page as structure" => "Obre la pàgina com una estructura",
"Make structure from page" => "Fes estructura a partir de la pàgina",
"Categorize structure pages together" => "Categoritza les pàgines de l'estructura totes juntes",
"Import HTML" => "Importar HTML",
"Page creators are admin of their pages" => "Els creadors de pàgines en son els adminsitradors",
"MultiPrint" => "MultiImpressió",
"Create watch for author on page creation" => "L'autor vigila la pàgina en crear-la",
"Enable watch events when I am the editor" => "Permet vigilar canvis quan sóc l'editor",
"Enable watches on comments" => "Permet vigilar comentaris",
"Use wiki page staging and approval" => "Empra les pàgines Wiki en mode de pendents de revisió i aprovació",
"Delete staging pages at approval" => "Esborra les pàgines per revisar en aprovar-les",
"Hide page name prefix" => "Amaga el prefix del nom de la pàgina",
"Categorize approved pages with categories of staging copy on approval" => "Categoritza les pàgines aprovades amb les categories de la còpia per revisar en ser aprovades",
"Add new freetags of approved copy (into tags field) when editing staging pages" => "Afegeix noves etiquetes lliures de les còpies aprovades (en el camp d'etiquetes) quan s'estigui editant còpies per revisar",
"List pages" => "Llistar pàgines",
"Categories path" => "Ruta de les categories",
"Wiki attachments" => "Adjuncions del Wiki",
"Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "Wysiwyg vol dir El Que Veus És El Que Obtens (What You See Is What You Get), és a dir, un editor visual de text amb format, i és gestionat a Tikiwiki per <a href=\"http://fckeditor.net\">FCKeditor</a>",
"Wysiwyg Editor Features" => "Funcionalitat d'Edició Wysiwyg",
"Wysiwyg Editor is optional" => "L'editor Wysiwyg és opcional",
"... and is displayed by default" => "... i es mostra per defecte",
"Reopen with the same editor" => "Reobre amb el mateix editor",
"Content is parsed like wiki page" => "El contingut és processat com una pàgina Wiki",
"Content is partially parsed" => "El contingut es processat parcialment",
"Toolbar skin" => "Estètica de la barra d'eines",
"Toolbar content" => "Contingut de la barra d'eines",
"Restore defaults" => "Recupera predeterminats",
"A new version of Tikiwiki, <b>{\$tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>." => "La nova versió de Tikiwiki, <b>{\$tiki_release}</b>, ja està disponible. Estàs fent servir actualment la versió <b>{\$tiki_version}</b>. Si us plau, visita <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>.",
"disabled" => "desabilitat",
"enabled" => "habilitat",
"Crosslinks to other features and settings" => "Enllaços creuats a altres funcionalitats i especificacions",
"Other sections" => "Altres seccions",
"Contact us" => "Contacta'ns",
"Administration features" => "Administració de Funcionalitats",
"Security" => "Seguretat",
"SysLogs" => "Registres del systema",
"Transversal features" => "Funcionalitats transversals",
"which apply to more than one section" => "que s'apliquen a més d'una secció",
"Navigation features" => "Funcionaliats de navegació",
"Look &amp; feel" => "Aparença",
"themes" => "temes",
"Text area features" => "Funcionalitats de l'àrea de text",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "funcionalitats que pots emprar en totes les arees de text, com planes wiki, bitàcoles, articles, fòrums, etc",
"Stats &amp; banners" => "Estadístiques &amp; i pancartes",
"Report" => "Informes",
"Setting" => "Configuració",
"Please select some actions to view." => "Si us plau, selecciona algunes accions per ser visualitzades.",
"Category:" => "Categoria:",
"bytes" => "octets",
"contribution" => "tipus de contribució",
"Statistics" => "Estadístiques",
"Weeks" => "Setmanes",
"viewed" => "vist",
"Add or edit a rule" => "Afegeix o edita una norma",
"Rule title" => "Titol de la regla",
"Username regex matching" => "Apaarellament de regex de nom d'usuari",
"IP regex matching" => "IP comprovació",
"Banned from sections" => "Expulsat de les seccions",
"Rule activated by dates" => "Regla activada per dates",
"Rule active from" => "Regla activa desde",
"Rule active until" => "Regla activa fins",
"Custom message to the user" => "Personalitzar missatge a l'usuari/a",
"Rules" => "Regles",
"User/IP" => "Usuari/a-IP",
"Sections" => "Seccions",
"Configure" => "Configura-ho",
"Admin Calendars" => "Administrar Calendaris",
"Create Calendar" => "Crea un Calendari",
"View Calendars" => "Visualitza els Calendaris",
"List of Calendars" => "Llista de calendaris",
"Edit Calendar" => "Edita el Calendari",
"Lang" => "Idm",
"Subscription" => "Subscripció",
"View Calendar" => "Visualitza el Calendari",
"Add Event" => "Afegeix Esdeveniment",
"Create/Edit Calendars" => "Crea/Edita Calendaris",
"Custom Locations" => "Personalitzar Llocs",
"Custom Participants" => "Participants customitzats",
"Custom Categories" => "Personalitzar Categories",
"Custom Languages" => "Personalitzar Idiomes",
"Custom URL" => "URL personalitzada",
"Custom Subscription List" => "Llista de subscripcions customitzada",
"Custom Priorities" => "Personalitzar Prioritats",
"Personal Calendar" => "Calendari personal",
"Start of day" => "Inici del dia",
"End of day" => "Final del dia",
"Standard Colors" => "Colors Estàndard",
"Green" => "Verd",
"Blue" => "Blau",
"Purple" => "Porpra",
"Red" => "Vermell",
"Orange" => "Taronja",
"Yellow" => "Groc",
"Let me select my own colors" => "Deixa'm escollir els meus propis colors",
"Custom foreground color" => "Color de davant personalitzat",
"Custom background color" => "Color del fons personalitzat",
"Default event status" => "Estatus per omissió dels esdeveniments",
"Show in calendar view" => "Mostra a la vissta de calendari",
"Group of users alerted when calendar event is modified" => "Grup d'usuaris notificats quan es modifica un esdeveniment del calendari",
"Current category" => "Categoria actual",
"Current Category ID:" => "Category Actual amb ID:",
"Child categories" => "Subcategories",
"Edit permissions for this category" => "Edita els permisos per a aquesta categoria",
"Edit this category:" => "edita aquesta categoria:",
"Add new category" => "Afegeix una nova categoria",
"Perms inherited from closest parent if possible or from global perms" => "Permisos heredats des de la categoria mare més propera si és possible o des dels permisos globals",
"Assign permissions automatically" => "Assigna permisos automàticament",
"recommended for best performance" => "recomanat per a un òptim rendiment",
"Batch upload (CSV file):" => "Càrrega de lots (arxiu CSV):",
"Objects in category" => "Objectes en la categoria",
"No records found." => "No s'han trobat registres.",
"Add objects to category" => "Afegir objectes a la categoria",
"image gal" => "Galeria d'images",
"file gal" => "galeria d'arxius",
"Admin chart items" => "Administrar ítems de la llista",
"Edit Chart" => "Edita chart",
"Add or edit an item" => "Afegeix o edita un ítem",
"Chart items" => "Gràfic d'items",
"No items defined yet" => "Encara no s'ha definit cap item",
"Add or edit a chart" => "Afegeix o edita una llista",
"Active" => "Actiu/va",
"Users can vote for only one item from this chart per period" => "Els usuaris poden votar només per un ítem d'aquest gràfic per període",
"Prevent users from voting for the same item more than once" => "Prevenir als usuaris de votar pel mateix item més d'una vegada",
"Users can suggest new items" => "Els usuaris poden suggerir nous ítems",
"Auto validate user suggestions" => "Auto validar suggeriment de l'usuari",
"Ranking shows" => "Ranking per mostres",
"All items" => "Tots els ítems",
"Top 10 items" => "Els 10 ítems més amunt",
"Top 20 items" => "Els 20 ítems més amunt",
"Top 40 items" => "Els 40 ítems més amunt",
"Top 50 items" => "Els 50 ítems més amunt",
"Top 100 items" => "Els 100 ítems més amunt",
"Top 250 items" => "Els 250 ítems més amunt",
"Voting system" => "Sistema de votació",
"Vote items" => "Vota ítems",
"Rank 1..5" => "Puntuació 1..5",
"Rank 1..10" => "Puntuació 1..10",
"Ranking frequency" => "Ranking per frequencia",
"Realtime" => "Temps real",
"Each 5 minutes" => "Cada 5 minuts",
"Daily" => "Diari",
"Weekly" => "Setmanal",
"Monthly" => "Mensual",
"Show Average" => "Mostrar Promig",
"Show Votes" => "Mostrar Vots",
"Use Cookies for unregistered users" => "Empra Cookies per a usuaris no registrats",
"Users can vote again after" => "Els usuaris poden votar de nou després",
"Anytime" => "a qualsevol hora",
"Ranks" => "Puntuacions",
"No charts defined yet" => "Encara no s'ha definit cap chart",
"Admin templates" => "Admin plantilles",
"Edit this template:" => "Edita aquesta plantilla:",
"Create new template" => "Crea una nova plantilla",
"Use wysiwyg editor" => "Empra editor wysiwyg",
"Use normal editor" => "Empra editor normal",
"CMS" => "SGC (CMS)",
"Templates" => "Plantilles",
"Admin Contributions" => "Administrar Tipus de Contribucions",
"Edit the contribution:" => "Edita el tipus de contribució:",
"Settings" => "Configuració",
"Contributions are mandatory in wiki pages" => "És obligatori especificar tipus de contribucions en les planes wiki",
"Contributions are mandatory in forums" => "És obligatori especificar tipus de contribucions en els fòrums",
"Contributions are mandatory in comments" => "És obligatori especificar tipus de contribucions en els comentaris",
"Contributions are displayed in the comment/post" => "Es mostren els tipus de contributions en els comentaris/publicacions",
"Create a new contribution" => "Crea un nou tipus de contribució",
"List of contributions" => "Llista de tipus de contribucions",
"Admin cookies" => "Administrar cookies",
"To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}." => "Per utilitzar una galeta en una àrea de text (pàgina wiki, etc.), un mòdul <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> </a> o una plantilla, utilitza {literal}{cookie}{/literal}.",
"Create/edit cookies" => "Crear/editar galetes",
"Upload Cookies from textfile" => "Puja Galetes des d'un arxiu de text ",
"Upload from disk:" => "Puja des del disc",
"Upload" => "Puja",
"Remove all cookies" => "Esborrar totes les cookies",
"cookie" => "galeta",
"Admin drawings" => "Admin dibuixos",
"To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link." => "Per crear un dibuix en una pàgina Wiki, empra {literal}{draw name=foo}{/literal}, on foo és el nom del dibuix. Després de guardar-ho, fes clic sobre l'enllaç del dibuix.",
"Available drawings" => "Dibuixos disponibles",
"Use Admin DSN to define the database to be used by the SQL plugin." => "Empra Admin DSN per definir la base de dades a ser emprada pel connector 'SQL plugin'.",
"Create/edit dsn" => "Crea/edita dsn",
"Admin external wikis" => "Administrar wikis externs",
"View template" => "Visualitza plantilla",
"tiki admin external wikis template" => "administrador tiki de plantilles de wikis externs",
"Edit template" => "Edita Plantilles",
"Create/Edit External Wiki" => "Crea/Edita un Wiki External",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (empra \$page per ser reemplaçat pel nom de la pàgina a l'exemple d'URL: http://www.example.com/tiki-index.php?page=\$page)",
"ExtWiki" => "Wikiext",
"Admin Forums" => "Administrar fòrums",
"Create new forum" => "Crear un nou fòrum",
"Import forums" => "Importa fòrums",
"List forums" => "Llista de fòrums",
"Edit this Forum:" => "edita aquest fòrum:",
"Create New Forum" => "Crear un Nou Fòrum",
"There are individual permissions set for this forum" => "Existeixen permisos fixats individualment per a aquest fòrum",
"Prevent flooding" => "Prevenir edicions simultànies",
"Minimum time between posts" => "Temps mínim entre publicacions",
"Section" => "Secció",
"Create new" => "Crea nou",
"Moderator user" => "Usuari moderador",
"Moderator group" => "Grup moderador",
"Password protected" => "Contrasenya protegida",
"Topics only" => "Només tòpics",
"All posts" => "Tots els escrits",
"Forum password" => "Contrasenya del Fòrum",
"Send this forums posts to this email" => "Enviar post d'aquest fòrum a aquest correu-e",
"Prune unreplied messages after" => "Eliminar missatges sense resposta després de ",
"Prune old messages after" => "Eliminar missatges antics després de",
"Topic list configuration" => "Configuració de la llista de tòpics",
"Posts can be rated" => "Les publicacions poden ser puntuades",
"Display last post titles" => "Mostra darrers títols enviats",
"no display" => "no mostrar",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Missatges reenviats a aquest fòrum per a aquesta adreça d'e-mail , en un format que pot ser emprat per a retornar a la primera adreça d'e-mail",
"Send mails even when the post is generated by inbound mail" => "Envia correus-e encara que un correu d'entrada hagi generat la publicació",
"Append a reply link to outbound mails" => "Afegeix un enllaç de resposta als correus enviats",
"Originating e-mail address for mails from this forum" => "Originant adreça d'e-mail  per a correus des de aquest fòrum",
"Add messages from this email to the forum" => "Afegeix missatges d'aquest correu-e al fòrum",
"POP3 server" => "servidor POP3",
"Use topic smileys" => "Empra emoticons",
"Show topic summary" => "Mostra el resum del tòpic",
"User information display" => "Mostra de la informació de l'usuari/a",
"Approval type" => "Tipus d'Aprovació",
"All posted" => "Tots els enviaments",
"Queue anonymous posts" => "Encua les publicacions anònimes",
"Queue all posts" => "Encua totes les publicacions",
"No attachments" => "Cap adjunt",
"Everybody can attach" => "Tots poden adjuntar",
"Only users with attach permission" => "Només usuaris/es amb permís per a adjuntar ",
"Moderators and admin can attach" => "Els Moderadors i administradors poden adjuntar",
"Store attachments in:" => "Guardar adjunts a:",
"Database" => "Base de Dades",
"Max attachment size (bytes)" => "Tamany Màxim d'adjunts (en octets)",
"Default ordering for topics" => "Ordre per defecte per a temes",
"Date (desc)" => "Data (desc)",
"Date (asc)" => "Data (asc)",
"Score (desc)" => "Punts (desc)",
"Replies (desc)" => "Respostes (desc)",
"Reads (desc)" => "Lectures (desc)",
"Topics per page" => "Temes per pàgina",
"Default ordering for threads" => "Ordre per defecte per a missatges",
"Duplicate Forum" => "Duplica el Fòrum",
"Duplicate" => "Duplica",
"List Forums" => "Llista Fòrums",
"Age" => "Edat",
"PPD" => "Ppd",
"Admin Hotwords" => "Admin paraules calentes",
"Add Hotword" => "Afegeix una paraula clau",
"Word" => "Paraula",
"Admin HTML pages" => "Administra pàginas HTML",
"Edit this page" => "edita aquesta pàgina",
"View page" => "Visualitza la pàgina",
"Edit zone" => "Edita zona",
"Dynamic zones" => "Zones dinàmiques",
"zone" => "zona",
"content" => "contingut",
"Mass update" => "Actualització massiva",
"Create new HTML page" => "Crea una nova pàgina HTML",
"Edit this HTML page:" => "Edita aquesta pàgina HTML:",
"Apply template" => "Aplica plantilla",
"Dynamic" => "Dinàmic",
"Static" => "Estàtic",
"Last Modif" => "Darrera modificació",
"An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature." => "Una manera fàcil d'integrar contingut d'un altre lloc web al Tiki és a través d'enllaços emmarcats utilitzant la funcionalitat Tiki <a class=\"rbox-link\" href=\"tiki-admin_links.php\">enllaços destacats</a>.",
"Edit Repository:" => "Edita Dipòsit:",
"Create New Repository" => "Crea Nou Dipòsit",
"List Repositories" => "Llista dipòsits",
"New Repository" => "Nou dipòsit",
"View Repository" => "Visualitza dipòsit",
"Human readable repository name" => "Nom de dipòsit en format llegible",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Ruta al dipòsit (sistemes de fitxers locals: adreça web relativa/absoluta, remots: prefixada amb 'http://')",
"File name of start page" => "Nom de l'arxiu de la pàgina de començament",
"Start page" => "Pàgina d'inici",
"CSS file to load when browse this repository" => "Fitxer CSS per carregar quan es navegui per aquest dipòsit",
"CSS file" => "arxiu CSS",
"Is repository visible to users" => "Dipòsit visible per a les persones usuàries?",
"Can files from repository be cached" => "Es poden posar en memòria cau els fitxers del dipòsit?",
"Cacheable" => "Captable en memòria cau",
"Are files from repository can be cached" => "Es poden posar en memòria cau els fitxers del dipòsit?",
"Clear all cached pages of this repository" => "Neteja totes les planes en memòria cau d'aquest dipòsit?",
"Clear cache" => "Neteja memòria cau",
"Seconds count 'till cached page will be expired" => "Segons que resten fins que la pàgina quedi expirada",
"Cache expiration" => "Expiració de la memòria cau",
"Human readable text description of repository" => "Text de descriptió en format llegible del dipòsit",
"Available Repositories" => "Dipòsits disponibles",
"CSS File" => "Arxiu CSS",
"Edit rules" => "edita normes",
"Edit Rules for Repository:" => "Editar Regles pel Dipòsit:",
"Configure Repositories" => "Configura dipòsits",
"Configure this Repository" => "Configurar aquest dipòsit",
"View this Repository" => "Veure aquest dipòsit",
"New Rule" => "Nova regla",
"Copy Rules" => "Copiar regles",
"view/hide copy rules dialog" => "veure/amagar diàleg de copies de regles",
"Source repository" => "Eines del dipòsit",
"Copy" => "Copiar",
"According this order rules will be applied ('0' or empty = auto)" => "Segons aquest ordre de regles, s'aplicarà ('0' o buit = auto)",
"Rule order" => "Ordre de regles",
"Text to search for" => "Text a cercar per",
"Text to replace" => "Texte a reemplaçar",
"Is this regular expression or simple search/replacer" => "És aquesta una expressió regular  o una simple paraula de recerca",
"Regex" => "Expresió Regular",
"Is case sensitive (for simple replacer)" => "És sensible a les majúscules (per a poder sobreescriure)",
"Case sensitive" => "Sensible a Majúscules",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subconjunt de caràcters:  imsxeADSXUu, els quals son modificadors d'expresions regulars",
"Regex modifiers" => "Modificadors d'expresions regulars",
"Human readable text description of rule" => "Norma escrita de forma llegible",
"Check to enable this rule" => "marcar per a habilitar aquesta norma",
"Enabled" => "Permès",
"Preview options" => "Previsualitzar opcions",
"Apply all rules or just this to generate preview" => "Aplica totes les normes o només per a generar aquesta vista prèvia",
"Apply all rules" => "Aplica totes les normes",
"View source code after rules applied" => "Visualitza el codi font després que s'apliquin les regles",
"Code preview" => "vista prèvia del Codi",
"Generate HTML preview" => "Generar vista prèvia",
"HTML preview" => "Vista prèvia en HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Fitxer test del dipòsit per generar previsualització per (buit = pàgina d'inici configurada)",
"Preview Results" => "Previsualitzar resultats",
"Rules List" => "Llista de Regles",
"Case" => "Cas",
"Configure/Options" => "Configura/Opcions",
"Admin layout" => "Administrar colocació dels elements",
"Theme control" => "Control de temes",
"layout options" => "opcions de format",
"Generate positions by hits" => "Genera posicions per cops",
"List of featured links" => "Llista d'enllaços destacats",
"Position" => "Posició",
"Add Featured Link" => "Afegeix un enllaç",
"Edit this Featured Link:" => "Edita aquest Enllaç Especial:",
"Create new Featured Link" => "Crea un nou Enllaç Especial",
"disables the link" => "deshabilita l'enllaç",
"Link type" => "Tipus d'enllaç",
"replace current page" => "reemplaçar la pàgina actual",
"framed" => "en un marc",
"open new window" => "obrir una finestra nova",
"Mail-in accounts" => "Comptes de Correu-in",
"Account" => "Compte",
"Add new Mail-in account" => "Afegeix un nou compte de Correu-dins",
"Edit Mail-in account" => "Edita el compte de correu-dins",
"Account name" => "Nom del compte",
"POP server" => "Servidor POP",
"SMTP server" => "Servidor SMTP",
"SMTP requires authentication" => "SMTP requereix autenticació",
"Article Topic" => "Tema de l'article",
"Admin Topics" => "Admin temes",
"Article Type" => "Tipus de l'article",
"Admin Types" => "Administrar tipus",
"Allow anonymous acces" => "Permetre accès anònim",
"Allow attachments" => "Permetre adjunts",
"Discard to the end from" => "Descarta fins al final des de",
"Check Mail-in accounts" => "comprovar comptes de Mail",
"Check automatically" => "comprovar automàticament",
"Frequency" => "Freqüència",
"List menus" => "Llista menús",
"Edit this menu" => "Edita menú",
"Edit menu options" => "Edita opcions de menú",
"Show Quick Urls" => "Mostra Urls Ràpides",
"Some useful URLs" => "Algunes URLS útils",
"Hide Quick Urls" => "Amaga Urls Ràpides",
"option" => "opció",
"section level 0" => "secció de nivell 0",
"section level 1" => "secció de nivell 1",
"section level 2" => "secció de nivell 2",
"section level 3" => "secció de nivell 3",
"sorted section level 0" => "secció ordenada de nivell 0",
"separator" => "separador",
"Choose" => "Escull",
"Home Blog" => "Bitàcola Inicial",
"Home Image Gal" => "Galeria d'imatges Inicial",
"Home Image Gallery" => "Galeria d'imatges Inicial",
"Home File Gal" => "Galeria d'arxius Inicial",
"Home File Gallery" => "Galeria d'arxius Inicial",
"User preferences" => "Preferències de l'usuari",
"User prefs" => "Prefs de l'usuari",
"List galleries" => "Llista les galeries",
"List image galleries" => "Llista galeries d'imatges",
"Upload image" => "Pujar imatge",
"Gallery Rankings" => "Posicions de galeries",
"Browse a gallery" => "Fulleja una galeria",
"Articles home" => "Inici d'articles",
"All articles" => "Tots els articles",
"Submit" => "Envia",
"List Blogs" => "Llista bitàcoles",
"Create blog" => "Crea bitàcola",
"File galleries" => "Galeries d'arxius",
"View a forum" => "Visualitza fòrum",
"View a thread" => "Visualitza missatge",
"View a FAQ" => "Veure una PUF",
"Take a quiz" => "Resol un test",
"Quiz stats" => "Estadístiques dels Tests",
"Stats for a Quiz" => "Estadístiques per un Test",
"Preview menu" => "Previsualitza menú",
"Menu options" => "Opcions del menú",
"Export CSV data" => "Exporta dades CSV",
"Import CSV data" => "Importa dades CSV",
"Edit this Menu:" => "Edita aquest menú:",
"Create new Menu" => "Crea un nou menú",
"dynamic collapsed" => "col·lapsat dinàmic",
"dynamic extended" => "dinàmic extès",
"fixed" => "fixat",
"Options" => "Opcions",
"Active Permissions" => "Permisos actius",
"Clear Cache" => "Esborra memòria cau",
"User Modules" => "Mòduls de l'usuari",
"Assigned Modules" => "Mòduls assignats",
"Left Modules" => "Mòduls a l'esquerra",
"Rows" => "Files",
"Move to Right Column" => "Moure ala columna dreta",
"Unassign" => "Desassigna",
"Right Modules" => "Mòduls a la dreta",
"Move to Left Column" => "Moure a la columna esquerra",
"Assign new module" => "Assigna un nou mòdul",
"Edit this assigned module:" => "Edita el mòdul asignat:",
"Cache Time" => "Temps en memòria cau",
"Visibility" => "Visibilitat",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrat ara per a tots els usuaris/es escollits inclós amb mòduls personalment assignats.",
"Displayed for the eligible users with no personal assigned modules" => "Mostrat per als usuaris/es escollits sense mòduls personalment no assignats",
"Displayed now, can't be unassigned" => "Mostrat ara, no es pot estar sense assignar",
"Not displayed until a user chooses it" => "No mostrat fins que l'usuari l'esculli",
"Create new user module" => "Crea un nou mòdul d'usuari",
"Edit this user module:" => "Edita aquest mòdul d'usuari:",
"Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site." => "Crea el teu nou mòdul personalitzat a continuació. Assegura't de previsualitzar-lo primer i que tot és correcte abans d'<a href=\"#assign\">assignar-lo</a>. Pots emprar html si vols a més. No obstant això, si utilizes la sintaxi wiki o un codi Smarty de manera incorrecta, pot ser que tu mateix t'expulsis del lloc web.",
"Must be wiki parsed" => "Interpreta el format Wiki",
"Objects that can be included" => "Objectes que es poden incloure",
"Available polls" => "Votacions disponibles",
"Random active poll" => "Votació activa aleatòria",
"Random current poll" => "Votació acutal aleatòria",
"Use Poll" => "Empra la votació",
"Random image from" => "Imatge a l'atzar de",
"Use Gallery" => "Empra galeria",
"Dynamic content blocks" => "Blocs de contingut dinàmic",
"Use Dynamic Content" => "Usa contingut dinàmic",
"Use RSS Module" => "Empra mòdul RSS",
"Use Menu" => "Empra menú",
"phpLayersMenus" => "Menus de Capes php",
"Use phplayermenu" => "Empra phplayermenu",
"Banner zones" => "Zones de banners",
"Use Banner Zone" => "Usa zones de banners",
"Use Wiki Structure" => "Empra Estructura Wiki",
"Data" => "Dades",
"Admin newsletter subscriptions" => "Administrar subscripcions al butlletí",
"List Newsletters" => "Llista fulls de notícies",
"Admin Newsletters" => "Administra fulls de notícies",
"Send Newsletters" => "Envia Butlletins",
"Add a subscription newsletters" => "Afegeix un butlletí de subscripcions",
"You can add several email addresses by separating them with commas." => "Pedeu afegir varies adreces de correu electrònic separant-les amb comes.",
"Add email:" => "Afegeix email:",
"Add user:" => "Afegeix usuari:",
"Group users" => "Usuaris del grup",
"Group subscription also subscribes included groups" => "La subscripció al grup també subscriu als grups inclosos",
"Don't send confirmation mail" => "No enviis un correu electrònic de confirmació",
"The user email will be refreshed at each newsletter sending" => "El correu-e de l'usuari s'actualitzarà cada vegada que s'envii un butlletí",
"Subscribe group" => "Subscriu al grup",
"Included group, group users and emails will be refreshed at each newsletter sending" => "Els grups inclosos, els usuaris del grup i els correus electrònics s'actualitzaran a cada butlletí enviat",
"Subscriptions" => "Subscripcions",
"Valid" => "Vàlid",
"Subscribed" => "subscrit",
"Admin newsletters" => "Administrar butlletins",
"There are individual permissions set for this newsletter" => "Hi ha permisos individuals fixats per a aquest butlletí",
"Users can subscribe/unsubscribe to this list" => "Els usuaris es poden subscriure/desubscriure a la llista d'aquest butlletí",
"Users can subscribe any email address" => "Els usuaris poden subscriure qualsevol adreça de correu-e",
"Add unsubscribe instructions to each newsletter" => "Afegir instruccions de desubscripció a cada butlletí",
"Validate email addresses" => "Valida adreces de correu-e",
"Editions" => "Edicions",
"Drafts" => "Esborranys",
"Last Sent" => "últims enviats",
"Add notification" => "Afegeix notificació",
"Alert" => "Alerta",
"Event" => "Aconeteixement",
"A user registers" => "Un usuari es registra",
"A user submits an article" => "Un usuari envia una col·laboració",
"Any wiki page is changed" => "No s'ha modificat cap pàgina wiki",
"Any wiki page is changed, even minor changes" => "Qualsevol pàgina wiki canvia, inclosos els canvis menors",
"PHP error" => "error de PHP",
"Email:" => "Correu-e:",
"List polls" => "Llista votacions",
"Edit this poll" => "Edita votació",
"Preview poll" => "Previsualitza votacions",
"Add poll option" => "Afegix opció per a la votació",
"Edit poll option" => "Edita l'opció de la votació",
"Option" => "Opció",
"Poll options" => "Opcions de la votació",
"Votes" => "Vots",
"Admin Polls" => "Administrar votacions",
"Set last poll as current" => "Posar l'última votació com actual",
"Close all polls but last" => "Tanca totes les votacions menys la darrera",
"Activate all polls" => "Activar totes les votacions",
"Create poll" => "Crea una votació",
"Edit poll" => "Edita la votació",
"active" => "actiu/va",
"current" => "actual",
"template" => "plantilla",
"object" => "objecte",
"PublishDate" => "DatadePublicació",
"Results" => "Resultats",
"Add poll to pages" => "Afegeix votació a pàgines",
"Wiki pages" => "Planes Wiki",
"Use Ctrl+Click to select multiple pages." => "Empra Ctrl+Click per seleccionar múltiples pàgines.",
"Lock the pages" => "Bloqueja les pàgines",
"Admin Quicktags" => "Administrar Marques ràpides",
"Create/Edit QuickTags" => "Crear/edita Marques ràpides",
"Insert (use 'text' for figuring the selection)" => "Insertar (usa 'text' per a figurar la selecció)",
"Path to the tag icon" => "Ruta a la icona d'etiqueta",
"Admin RSS Modules" => "Administrar mòduls RSS",
"This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "Aquesta pàgina és per configurar els paràmetres de les alimentacions RSS llegides/importades per Tiki. Per generar/exportar alimenacions RSS, cerca \"Alimentacions RSS\"  en el menú principal de l'aplicació, o",
"To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed." => "Per emprar alimentacions RSS en un area de text (pàgina Wiki, etc), un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> o una plantilla, empra {literal}{rss id=x}{/literal}, on x és l'ID de l'alimentació RSS.",
"Content for the feed" => "Contingut per a l'alimentació",
"show feed title" => "mostrar titol del feed",
"show publish date" => "mostrar data de publicació",
"To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>." => "Per <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">informar de qualsevol incidència relacionada amb la seguretat</a>.",
"PHP settings" => "Paràmetres de PHP",
"PHP variable" => "Variable PHP",
"Risk Factor" => "Factor de Risc",
"Explanation" => "Explicació",
"Tiki variable" => "Variable de Tiki",
"Check all tiki files" => "Comprova tots els arxius de tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Tingues present que això pot prendre's una estona molt llarga. Seria convenient comprovar el paràmetre del temps màxim d'execució (max_execution_time) a l'arxiu php.ini.",
"Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Nota: Has d'importar les dades de seguretat a través del sistema d'instal·lació (<a href=\"tiki-install.php\">tiki-install.php</a>). Importa els arxis d'actualització *secdb* a la teva base de dades.",
"File checks" => "Comprovacions d'arxius",
"user" => "usuari",
"group" => "grup",
"sticky" => "enganxós",
"Admin Shoutbox Words" => "Administra quadre d'avisos",
"Add Banned Word" => "Afegeix una paraula prohibida",
"Are you sure you want to delete this word?" => "Segur que voleu eliminar aquesta paraula?",
"The structure" => "L'Estructura",
"has just been created." => "ha estat creada ara mateix.",
"You will remove structure" => "Esborraràs lestructura",
"Destroy the structure leaving the wiki pages" => "Destrueix l'estructura deixant les pàgines wiki",
"Destroy the structure and remove the pages" => "Destrueix l'estructura i esborra les pàgines",
"Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict:" => "Pren nota que les pàgines següents formen part també d'una altra estructura. Assegura't que els permisos d'accés (si n'hi ha) no entren en conflicte:",
"The following pages have automatically been categorized with the same categories as the structure:" => "Les pàgines següents han estat categoritzades automàticament amb les mateixes categories que l'estructura:",
"The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent:" => "Les pàgines següents estan assignades a categories però l'estrucura no en té assignada cap. És possible que vulguis descategoritzar-les per ser consistent:",
"The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent:" => "Les següents pàgines es troben en categories a les quals l'estructura no es troba assignada. És possible qeu vulguis recategoritzar-les a fi i efecte de ser consistent:",
"Edit structure" => "Edita l'estructura",
"Export Pages" => "Exportar pàgines",
"Dump Tree" => "Baixa't l'arbre",
"Create WebHelp" => "Crear AjudaWeb",
"View WebHelp" => "Visualitza ajutweb",
"Create new structure" => "Crear nova estructura",
"Alias" => "Àlies",
"Tree" => "Arbre",
"Use single spaces to indent structure levels" => "Empra espais simples per indentar nivells d'estructura",
"Create New Structure" => "Crear nova estructura",
"List surveys" => "Llista enquestes",
"Survey Stats" => "Estadístiques d'enquestes",
"Edit this Survey" => "Edita aquesta enquesta",
"Admin Surveys" => "Administra enquestes",
"Question" => "Pregunta",
"One choice" => "Una opció",
"Multiple choices" => "Múltiples opcions",
"Short text" => "Text curt",
"Rate (1..5)" => "Valor (1..5)",
"Rate (1..10)" => "Valor (1..10)",
"Rate" => "Qualificació",
"For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "Per qüestions amb múltiples respostes escriu les respostes en el camp següent separades per comes. Exemple: un, dos, alguns, molts",
"For a rate, you can give the maximum value." => "Per a una valoració, pots donar el valor màxim.",
"Options (if apply)" => "Opcions (si és el cas)",
"Questions" => "Preguntes",
"Admin surveys" => "Administrar enquestes",
"List Surveys" => "Llista Enquestes",
"Edit this Survey:" => "edita aquesta Enquesta:",
"Create New Survey" => "Crea Nova Enquesta",
"There are individual permissions set for this survey" => "Hi ha permisos individuals fixats per a aquesta enquesta",
"Open" => "Obert",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Si el teu Tiki està actuant de forma rara, la primera cosa a provar és netejar la memòria cau de sota. També és molt important netejar la teva memòria cau després d'una actualització (per FTP/SSH si és necessari).",
"Exterminator of cached content" => "Exterminador de contingut en memòria cau",
"Empty" => "Buit",
"All user prefs sessions" => "Totes les sessions de preferències d'usuaris",
"Templates compiler" => "Compilador de plantilles",
"Compile" => "Compilar",
"Advanced feature" => "Funcionalitat avançada",
"Fix UTF-8 Errors in Tables" => "Repara errors UTF-8 a les Taules",
"Warning: Make a backup of your Database before using this function!" => "Alerta: Feu una copia de seguretat de la vostra base de dades abans d'utilitzar aquesta funció!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Avís: si vols convertir taules grans, augmenta al màxim el temps d'execució al teu php.ini!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Aquesta funció converteix a UTF-8 les cadenes codificades en ISO-8859-1 a les teves taules",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Això pot ser necessari si vas crear contingut amb Tiki &lt; 1.8.4 i els paràmetres del conjunt de caracters per defecte en apache estaven posats a ISO-8859-1",
"UTF-8 Errors fixed" => "Errors UTF-8 reparats",
"Investigate" => "Investiga",
"Fix it" => "Repara-la",
"Create a new topic" => "Crea un nou element",
"Topic Name" => "Nom d'element",
"Upload Image" => "Pujarimatge",
"List of topics" => "Llista d'elements",
"Articles (subs)" => "Articles (colabs)",
"topic image" => "imatge del tema",
"Inactive - Click to Activate" => "Inactiu/va - Clica per Activar",
"Deactivate" => "Desactiva",
"Active - Click to Deactivate" => "Actiu/va - Clica per Deactivar",
"Remove with articles" => "Esborrar amb els articles",
"List Trackers" => "Llista Formularis",
"Admin Trackers" => "Administra formularis",
"Edit This Tracker" => "Edita aquest formulari",
"View This Tracker's Items" => "Visualitza els punts d'aquest formulari",
"New tracker field" => "Nou camp del Formulari",
"Edit tracker field" => "Edita el camp del formulari",
"Select list items that will be displayed:" => "Selecciona la llista d'ítems que es mostraran:",
"Is column visible when listing tracker items?" => "És visible la columna quan es llisten els punts dels formulari?",
"Column links to edit/view item?" => "Enllaços de columna per editar/veure punt?",
"Multilingual content" => "Contingut Multilingüe",
"Column is searchable?" => "La columna és cercable?",
"Field is public? (viewed in trackerlist plugin)" => "El camp és públic? (visible a través del connector/plugin trackerlist)",
"Field is hidden?" => "El camp és ocult?",
"not hidden" => "no ocult",
"visible to admin only" => "visible només a l'administrador",
"editable by admin only" => "editable només per admins",
"visible by creator &amp; admin only" => "visible només pel creador &amp; admin",
"The option creator needs a field of type user selector and option 1" => "La opció creador necessita un camp del tipus selecció d'usuari amb l'opció 1",
"Field is mandatory?" => "El camp és obligatori?",
"Tracker fields" => "Camps de formulari",
"isMain" => "esPrincipal",
"Tbl vis" => "Vis Tbl",
"Searchable" => "Cercable",
"Hidden" => "Ocult",
"Mandatory" => "Obligatori",
"Import/Export Trackers Fields" => "Importa/exporta els camps dels formularis",
"Export fieldId also" => "Exporta també els fieldId",
"Edit This Tracker's Fields" => "Edita els camps d'aquest formulari",
"Edit Tracker" => "Edita el formulari",
"Import/Export" => "Importa/Exporta",
"Duplicate Tracker" => "Duplica el formulari",
"Found" => "Trobat",
"trackers" => "formularis",
"with" => "amb",
"There are individual permissions set for this tracker" => "Hi ha permisos individuals per a aquest formulari",
"No individual permissions. Global permissions apply." => "No hi ha permisos individuals, s'aplicaràn els permisos globals",
"Auto create corresponding categories" => "Auto crea les categories corresponents",
"Use \"explicit\" names in the mirror table" => "Empra noms \"explícits\" a la taula mirall",
"Show status" => "Mostra l'estat",
"Default status displayed in list mode" => "Mostrar l'estat per defecte en el mode de llista",
"Show status to tracker admin only" => "Mostra l'estat només als admins. dels formulari",
"Send copies of all activity in this tracker to this e-mail address" => "Envia còpies de tota l'activitat en aquest formulari a aquesta adreça de correu-e",
"Use simplified e-mail format" => "Empra el format de correu-e simplificat",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "El formulari emprarà el camp de text anomenat Subject si hi ha algun com a subject i emprarà el correu-e de l'usuari com a enviador, o per a usuaris anònims, el camp de correu-e si existeix",
"New items are created with status" => "Els nous ítems són creats amb estat",
"Authoritative status for modified items" => "Estat per força per als ítems modificats",
"No change" => "Cap canvi",
"Item creator can modify his items?" => "El creador de l'ítem pot modificar els seus ítems?",
"The tracker needs a user field with the option 1" => "El formulari necessita un camp d'usuari amb l'opció 1",
"Only one item per user or IP" => "Només un ítem per usuari o IP",
"The tracker needs a user or IP field with the option 1" => "El formulari necessita un camp d'usuari o IP amb l'opció 1",
"Member of the default group of creator can modify items?" => "Els membres del grup per defecte del creador poden modificar els ítems?",
"The tracker needs a group field with the option 1" => "El formulari necessita un camp de grup amb l'opció 1",
"Show creation date when listing tracker items?" => "Mostra la data de creació quan es llistin els punts del formulari?",
"Format if not the default short one:" => "Format en cas de no voler el curt per defecte:",
"Show creation date when viewing tracker item?" => "Mostra la data de creació quan es visualitzi un element de formulari?",
"Show lastModif date when listing tracker items?" => "Mostra la data de UltimaModif quan es llistin els punts del formulari?",
"Show lastModif date when viewing tracker item?" => "Mostra data de la darrera modificació quan es visualitzi  un element de formulari?",
"What field is used for default sort?" => "Quin camp serà emprat per a l'ordenació per defecte?",
"What is default sort order in list?" => "Quin és l'ordre per defecte en el llistat?",
"Tracker items allow ratings?" => "Els ítems del formulari permeten valoracions?",
"with values" => "amb els valors",
"and display rating results in listing?" => "i mostrar els resultats de les valoracions en el llistat?",
"Tracker items allow comments?" => "Els punts del formulari permeten comentaris?",
"and display comments in listing?" => "i mostrar els comentaris en el llistat?",
"Tracker items allow attachments?" => "Els punts del formulari permeten afegits?",
"and display attachments in listing?" => "i mostrar els adjunts en el llistat?",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Opcions per mostrar els adjunts (Empra números per ordenar els ítems, 0 no serà mostrat, i valors negatius es mostren en finestres emergents)",
"Filesize" => "Mida de l'arxiu",
"Filetype" => "Tipus d'arxiu",
"LongDesc" => "Descripció llarga",
"Items can be created only during a certain time" => "Es poden crear ítems només durant un cert temps",
"After:" => "Després:",
"Before:" => "Abans:",
"Do not show empty fields in item view?" => "No mostris els camps buits en la vista d'ítem?",
"Show these fields (ID comma separated) in a popup on item link when listing tracker items?" => "Mostra aquests arxius (ID separats per comes) en un requadre emergent sobre l'enllaç de l'ítem quan es llistin els elements del formulari?",
"Import/export trackers" => "Importa/exporta formularis",
"Charset encoding" => "Codificació de Caràcters",
"Admin groups" => "Administra grups",
"Admin users" => "Administra usuaris",
"Add new group" => "Afegeix un nou grup",
"Edit group" => "Edita el grup",
"Members" => "Membres",
"Add a New Group" => "Afegir un grup nou",
"List of existing groups" => "Llista de grups existents",
"Includes" => "Inclou",
"User Choice" => "elecció de l'usuari",
"Only directly included" => "Només inclosos directament",
"Group Homepage" => "Pàgina del Grup",
"Use wiki page name or full URL" => "Empra pàgina Wiki o URL sencera",
"Default category assigned to uncategorized objects edited by a user with this default group" => "Categoria per defecte assignada a objectes no categoritzats editats per un usuari amb aquest grup per defecte",
"Group Theme" => "Tema (d'estètica) per al Grup",
"Use site default" => "Fes servir el que hi ha per defecte al lloc",
"Group Information Tracker" => "Formulari per a la informació del Grup",
"choose a group tracker ..." => "escull un formulari de grup ...",
"choose a field ..." => "escull un camp ...",
"Users Information Tracker" => "Formulari per a la informació dels Usuaris",
"choose a users tracker ..." => "escull un formulari d'usuaris ...",
"Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Camps del Formulari d'Informació d'Usuaris que es demanaran en el moment de Regisstre<br />(IdsDeCamps separats amb :)",
"User can assign to the group himself" => "L'usuari es pot afegir ell mateix al grup",
"Group tracker item : {\$groupitemid}" => "Item del formulari de Grup : {\$groupitemid}",
"Edit Item" => "Edita punt",
"Group tracker item not found" => "No s'ha trobat l'ítem del formulari de Grup",
"Members List" => "Llista de membres",
"Remove from Group" => "Elimina del grup",
"users in group" => "usuaris en el grup",
"Download CSV export" => "Descarrega't exportació en format CSV",
"Charset encoding:" => "Codificació de caràcters:",
"Assign users to group:" => "Assigna usuaris al grup:",
"CSV File" => "Arxiu CSV",
"Add a New User" => "Afegeix un nou usuari",
"Updated users" => "Usuaris Actualitzats",
"Rejected users" => "usuaris rebutjats",
"Reason" => "Raó",
"Edit user" => "Editeu l'usuari",
"More Criteria" => "Més Criteris",
"Group (direct)" => "Grup (directe)",
"Edit Account Settings" => "Edita els paràmetres del compte",
"to groups" => "als grups",
"Edit Included Group" => "Edita el grup inclòs",
"Change user preferences" => "Canvia les preferències de l'usuari",
"Remove Users and their Userpages" => "Elimina els usuaris i les seves planes d'usuari",
"Manage Group Assignments" => "Gestiona les assignacions a grups",
"Set Default Groups" => "Especifica els grups per defecte",
"Assign selected to" => "Assigna els seleccionats a",
"Remove selected from" => "Elimina els escollits de",
"the following groups:" => "els següents grups:",
"Tip: Hold down CTRL to select multiple" => "Pista: menté apretada la tecla CTRL per a seleccions múltiples",
"Set the default group of the selected users to" => "Especifica que el grup per defecte dels usuaris seleccionats sigui",
"Use the email as username" => "Empra correu-e com a nom d'usuari",
"No password is required" => "No cal contrasenya",
"User tracker item : {\$usersitemid}" => "Ítem del formulari de l'usuari : {\$usersitemid}",
"Overwrite" => "Reescriure",
"Loading..." => "Carregant...",
"Changes from the following versions under staging have been merged into the approved version" => "Els canvis de les següents versions per revisar han estat fusionats amb la versió aprovada",
"Source" => "Codi font",
"Admin Article Types" => "Administrar Tipus d'Article",
"List of types" => "Llista de tipus",
"Shows up in the drop down list of article types" => "Es mostra en la llista desplegable de tipus d'articles",
"Allow ratings by the author" => "Permet valoracions per l'autor",
"Show before publish date" => "Mostrar avans de la data de publicació",
"non-admins can view before the publish date" => "els no administradors poden veure-ho abans de la data de publicació",
"Show after expire date" => "Mostrar despres de la data expirada",
"non-admins can view after the expire date" => "els no-administradors poden veure-ho després de la data d'expiració",
"Heading only" => "Encapçalament només",
"No article body, heading only" => "Sense cos de l'article, tan sols encapçalament",
"Allow comments for this type" => "Permet comentaris per aquest tipus",
"Comment Can Rate Article" => "un Comentari permet valorar l'Article",
"Allow comments to include a rating value" => "Permet que els comentaris incloguin una valoració numèrica",
"Show image" => "Mostrar imatge",
"Show topic or own image" => "Mostra el tema o la imatge pròpia",
"Show avatar" => "Mostrar avatar",
"Show author's avatar" => "Mostra l'avatar de l'autor",
"Show author" => "Mostrar autor",
"Show author name" => "Mostra el nom de l'autor",
"Show publish date" => "Mostrar data de publicació",
"Show expire date" => "Mostrar data d'expiració",
"Show reads" => "Mostrar lectures",
"Show the number of times the article was read" => "Mostra el nombre de vegades que s'ha llegit l'article",
"Show size" => "Mostrar tamany",
"Show the size of the article" => "Mostra la mida de l'article",
"Show topline" => "Mostra línea superior",
"Show a small title over the title" => "Mostra un  títol petit sobre el títol",
"Show subtitle" => "Mostra subtítol",
"Show the subtitle" => "Mostra el subtítol",
"Show source" => "Mostra font",
"Show link to source after article body" => "Mostra l'enllaç a la font després del cos de l'article",
"Show Image Caption" => "Mostra la llegenda de la imatge",
"Show a legend under the image" => "Mostra una llegenda sota la imatge",
"Show Language" => "Mostra idioma",
"Show the language" => "Mostra l'idioma",
"Creator can edit" => "El creador pot editar-ho",
"The person who submits an article of this type can edit it" => "Qui envia un atricle d'aquest tipus pot editar-lo",
"Show lang" => "Mostra idioma",
"Review" => "Revisió",
"Classified" => "Classificat",
"Create a new type" => "Crear un nou tipus",
"Group Information" => "Informació del grup",
"level" => "nivell",
"inherited from" => "heredat de",
"inherited" => "heredat",
"Create level" => "Crea nivell",
"all permissions in level" => "tots els permisos en el nivell",
"Default Group" => "grup per defecte",
"Assign Perms to this Group" => "Assigna permisos a aquest grup",
"backlinks to" => "retroenllaços cap a",
"No backlinks to this page" => "No hi ha retroenllaços a aquesta pàgina",
"Directory batch upload" => "Càrrega de lots de directoris",
"Browse Gallery" => "Fulleja galeria",
"Upload From Disk" => "Pujar des del disc local",
"available images" => "imatges disponibles",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "ex. per \"digicam0001.jpg\" s'utilitzarà digicam0001 pel camp nom",
"Select a Gallery" => "Selecciona una Galeria",
"Process" => "Procés",
"Browse File Gallery" => "Navega per la Galeria d'Arxius",
"Edit Post" => "Edita publicació",
"View Blog" => "Visualitza bitàcola",
"Use ...page... to separate pages in a multi-page post" => "Empra ...page... per separar planes en una publicació multi-page",
"Upload image for this post" => "Puja una imatge per a aquesta publicació",
"Trash" => "Brossa",
"Mark entry as private:" => "Marca la publicació com a privada:",
"Spellcheck" => "Comprovació ortogràfica",
"Save and Exit" => "Guardar i sortir",
"Powered by" => "Basat en",
"Made with" => "Fet amb",
"powered by" => "potenciat per",
"The TikiWiki Community" => "La comunitat TikiWiki",
"Execution time" => "Temps d'execució",
"Memory usage" => "Memòria d'ús",
"database queries used in " => "crides a la base de dades a ",
"Server load" => "Càrrega del servidor",
"Watch Only This Category" => "Vigila Només Aquesta Categoria",
"Watch This Category and Their Descendants" => "Vigila Aquesta Categoria i les Seves Descendents",
"Stop Watching Only This Category" => "Deixa de Vigilar Només Aquesta Categoria",
"Stop Watching This Category and Their Descendants" => "Deixa de Vigilar Aquesta Categoria i les Seves Descendents",
"Browse in" => "Navega per",
"Trackers Items" => "Ítems dels Formularis",
"Sheets" => "Fulls",
"in the current category - and its subcategories: " => "a la categoria actual - i les seves subcategories: ",
"Hide subcategories objects" => "Amaga els objectes de les subcategories",
"Show subcategories objects" => "Mostra els objectes de les subcategories",
"Upper level" => "Nivell de Pujada",
"Browse related tags" => "Navega per les etiquetes relacionades",
"Network of Tags related to" => "Xarxa d'etiquetes relacionades a ",
"Clear" => "Neteja",
"With all selected tags" => "Amb totes les etiquetes seleccionades",
"With one selected tag" => "Amb una etiqueta seleccionada",
"With last selected tag" => "Amb l'última etiqueta seleccionada",
"More Popular Tags" => "Etiquetes més populars",
"Sort:" => "Ordena:",
"Alphabetically" => "Alfabèticament",
"By Size" => "Per mida",
"Cloud" => "Núvol",
"results found" => "resultats trobats",
"List Galleries" => "Llista les Galeries",
"Edit Gallery" => "Edita la Galeria",
"Rebuild Thumbnails" => "Reconstrueix miniatures",
"Directory Batch" => "Directori per pujada en bloc",
"List Gallery" => "Llista la galeria",
"All Images" => "Totes les imatges",
"Monitor this Gallery" => "Vigila aquesta Galeria",
"Stop Monitoring this Gallery" => "Deixa de vigilar aquesta Galeria",
"Sort Images by" => "Ordena la imatge per",
"subgallery" => "subgaleria",
"Subgallery" => "Subgaleria",
"Hit" => "Cop",
"Original Size" => "Tamany original",
"rotate right" => "voltar a la dreta",
"rotate" => "voltar",
"Details" => "Detalls",
"popup" => "emergent",
"You can view this gallery's configured image (first, random, etc.) in your browser using" => "Pots veure la imatge configurada d'aquesta galeria (primera, a l'atzar, etc.) en el teu navegador emprant",
"You can include the gallery's image in an HTML page using one of these lines" => "Pots incloure la imatge de la galeria en una pàgina HTML emprant una d'aquestes línies",
"You can include the image in a tiki page using one of these lines" => "Pots incloure la imatge en una pàgina de Tiki emprant alguna d'aquestes línies",
"Return to Gallery" => "Torna a la galeria",
"Edit Image" => "Editar la imatge",
"First Image" => "Primera imatge",
"Prev Image" => "Imatge prèvia",
"Smaller" => "Més petit",
"Bigger" => "Més gran",
"Popup window" => "Finestra emergent",
"Next Image" => "Propera imatge",
"Slideshow Forward" => "Endavant el Passi de diapositives",
"Last Image" => "La última imatge",
"Cyclic" => "Cíclic",
"Direction" => "Direcció",
"Click to zoom" => "Fes clic per ampliar",
"Image Name" => "Nom de la imatge",
"Image Scale" => "Escala de la imatge",
"Latitude (WGS84/decimal degrees)" => "Latitud (WGS84/graus decimals)",
"Longitude (WGS84/decimal degrees)" => "Longitud (WGS84/graus decimals)",
"Move image" => "Moure la imatge",
"You can view this image in your browser using" => "Podeu visualitzar aquesta imatge en el vostre cercador emprant",
"You can include the image in an HTML page using one of these lines" => "Pots incloure la imatge en una pàgina HTML emprant una d'aquestes línies",
"Stop Monitoring this Page" => "Deixa de vigilar-ho",
"Monitor this Page" => "Vigila-ho",
"Admin Calendar" => "Administra el Calendari",
"Export Calendars" => "Exporta Calendaris",
"Click to export calendars" => "Clica per exportar calendaris",
"Visible Calendars" => "Calendaris Visibles",
"Click to select visible calendars" => "Clica per seleccionar calendaris visibles",
"Group Calendars" => "Calendaris de Grup",
"Export calendars" => "Exporta calendaris",
"advanced parameters" => "paràmetres avançats",
"Edit event" => "Edita esdeveniment",
"Delete event" => "Esborra esdeveniment",
"View event" => "Visualitza esdeveniment",
"All-Day" => "Tot el dia",
"Organized by" => "Organitzat per",
"Website" => "Lloc Web",
"Tentative" => "Tentativa",
"Confirmed" => "Confirmat",
"Cancelled" => "Cancel·lat",
"View this Week" => "Visualitza aquesta Setmana",
"View this Day" => "Visualitza aquest Dia",
"Calendar Item" => "Ítem del Calendari",
"New event" => "Nou esdeveniment",
"Edit Calendar Item" => "edita Item del calendari",
"New Calendar Item" => "Nova Cita al Calendari",
"Recurrence" => "Recurrència",
"This event depends on a recurrence rule" => "Aquest esdeveniment depèn d'una regla de recurrència",
"This event is not recurrent" => "Aquest esdeveniment no és recurrent",
"On a weekly basis" => "En una base setmanal",
"Each" => "Cada",
"of the week" => "de la setmana",
"On a monthly basis" => "En una base mensual",
"of the month" => "del mes",
"On a yearly basis" => "En una base anual",
"There's no such date as" => "No hi ha una data com el",
"Starting on" => "Començant el",
"ending by" => "acabant el",
"ending after" => "acabant després de",
"events" => "esdeveniments",
"Start period" => "Període d'inici",
"End after" => "Acaba després de",
"occurrences" => "occurrències",
"End before" => "Acaba abans de",
"Event is repeated" => "L'esdeveniment és repetit",
"times" => "vegades",
"every" => "cada",
"of every month" => "de cada mes",
"on each" => "a cada",
"End" => "Fi",
"Date and time of end" => "Dia i hora de finalització",
"Events cannot end before they start" => "Els esdeveniments no poden acabar abans que comencin",
"or new" => "o nou/va",
"Choose users to alert" => "Esculls els usuaris que hagin de ser notificats",
"Roles" => "Rols",
"chair" => "presideix",
"default role" => "rol per defecte",
"required participant" => "participant requerit",
"optional participant" => "participant opcional",
"non participant" => "no participant",
"Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in:" => "Posa la llista de participants separats per comes. Els rols han de ser posats en un prefix separats per dos punts com a:",
"role:login_or_email,login_or_email" => "rol:nom_d_usuari_o_correu-e,nom_d_usuari_o_correu-e",
"Update this event only" => "Actualitza només aquest esdeveniment",
"Update every unchanged events of this recurrence rule" => "Actualitzat tots els esdeveniments no modificats d'aquesta regla de recurrència",
"Update every events of this recurrence rule" => "Actualitza tots els esdeveniments d'aquesta regla de recurrència",
"Delete Recurrent events" => "Esborra esdeveniments recurrents",
"Calendar import" => "Importa calendari",
"Calendar has been updated" => "El calendari ha estat actualitzat",
"import" => "importa",
"Previous" => "Anterior",
"Avanced parameters for iCal export" => "Paràmetres avançats per a l'exportació iCal",
"Calendars to be exported" => "Calendaris que s'han d'exportar",
"Assign permissions to category" => "Assigna permisos a la categoria",
"Current permissions for this category" => "Permisos actuals per a aquesta categoria",
"Remove from this Category Only" => "Elimina només aquesta categoria",
"Remove from this Category &amp; all its Children" => "Elimina d'aquesta categoria &amp; i totes les seves filles",
"Perform action with checked" => "Als selecionats, realitza l'acció",
"Assign permissions" => "Assignar permisos",
"to group" => "per al grup",
"this category &amp; all its children" => "aquesta categoria &amp; totes les seves filles",
"this category only" => "aquesta categoria només",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "Es recomana, per a un òptim funcionament, assignar permisos per a <b>totes les filles</b>.",
"Change password enforced" => "Força a canviar contrasenya",
"Change your password" => "Canvia la contrasenya",
"Old password" => "Contrasenya antiga",
"Send a message to us" => "Envia'ns un missatge",
"Contact us by email" => "contacta'ns via correu-e",
"Click here to send us an email" => "Fes clic aquí per enviar-nos un correu electrònic",
"Contacts" => "Contactes",
"Create/edit contacts" => "Crea/edita contactes",
"First Name" => "Primer nom",
"Last Name" => "Darrer Nom",
"Nickname" => "Sobrenom",
"You can browse the generated WebHelp here" => "Pots navegar aquí l'AjutWeb generat",
"Structure" => "Estructura",
"Top page" => "La pàgina més activa",
"Tiki Debugger Console" => "Consola del depurador del Tiki",
"Current URL" => "Actual URL",
"Command" => "Comanda",
"exec" => "executa",
"Type <code>help</code> to get list of available commands" => "Escriu <code>help</code> (ajuda) per obtenir una llista de les comandes disponibles",
"Add a new site" => "Afegeix una nova web",
"You cannot add sites until Directory Categories are setup." => "No pots afegir enllaços fins que es configurin les categories d'enllaços.",
"Please contact the Site Administrator" => "Si us plau, contacteu amb l'administrador del portal",
"Site added" => "Lloc afegit",
"Directory Administration" => "Administració del Directori",
"There are" => "Hi ha/n",
"invalid sites" => "web Invàlida",
"valid sites" => "llocs vàlids",
"Users have visited" => "Els usuaris han visitat",
"sites from the directory" => "llocs desde el directori",
"Users have searched" => "Els usuaris han cercat",
"times from the directory" => "vegades del directori",
"Related" => "Relacionat",
"Validate" => "Valida",
"Admin directory categories" => "Administrar directori de categories",
"Add a directory category" => "Afegeix una categoria directori",
"Edit this directory category" => "edita aquest directori de categoria",
"Children type" => "tipus infantil",
"Most visited sub-categories" => "Sub-Categories més visitades",
"Category description" => "descripció de la Categoria",
"Random sub-categories" => "Subcategories al atzar",
"Maximum number of children to show" => "Nombre màxim de nens a mostrar",
"Editor group" => "Editor de grup",
"cType" => "cTipus",
"allow" => "permetre",
"count" => "compte",
"relate" => "relacionar",
"Parent category" => "Categoria inicial",
"Add a related category" => "Afegeix una categoria relacionada",
"Mutual" => "Mutu",
"Related categories" => "Categories relacionades",
"Admin sites" => "Administració de llocs web",
"Is valid" => "És vàlid",
"New Sites" => "Nous llocs",
"Cool Sites" => "Llocs fantàstics",
"Add a Site" => "Afegiu un lloc",
"any" => "qualsevol",
"in entire directory" => "a tot el directori",
"Sort by" => "Ordenat per",
"name (desc)" => "nom (desc)",
"name (asc)" => "nom (asc)",
"hits (desc)" => "visites (desc)",
"hits (asc)" => "visites (asc)",
"creation date (desc)" => "data de creació (desc)",
"creation date (asc)" => "data de creació (asc)",
"last updated (desc)" => "última modificació (desc)",
"last updated (asc)" => "última modificació (asc)",
"Added" => "Afegit",
"Last updated" => "Actualitzat per darrera vegada el",
"Total links" => "Enllaços totals",
"Links to validate" => "Enllaços per validar",
"Searches performed" => "Cerca enllestida",
"Total links visited" => "Nombre d'enllaços visitats",
"Directory ranking" => "llista de Directoris",
"Search results" => "Resultats de la cerca",
"Validate sites" => "Valida llocs",
"Edit article" => "Editar article",
"List Articles" => "Llista d'Articles",
"View Articles" => "Visualitza articles",
"One of the email addresses you typed is invalid" => "Una de les adreces de correu electrònic que heu escrit és invàlida",
"Topline" => "Línia superior",
"Subtitle" => "Subtítol",
"Author Name" => "Nom de l'autor",
"Own Image" => "Imatge pròpia",
"Article image" => "Imatge de l'article",
"Use own image" => "Empra imatge pròpia",
"Float text around image" => "text flotant al voltant de la imatge",
"Own image size x" => "Dimensió x d'imatge pròpia",
"Own image size y" => "Dimensió y d'imatge pròpia",
"Image caption" => "Requadre de la imatge",
"Heading" => "Capçalera",
"Body" => "Cos",
"Publish Date" => "Data de publicació",
"Expiration Date" => "Data de caducitat",
"Emails to be notified (separated with commas)" => "Correus-e que han de ser notificats(separats per comes)",
"From:" => "de part de:",
"Edit or create banners" => "Edita o crea blocs de publicitat",
"List banners" => "Llista butlletins",
"URL to link the banner" => "URL on enllaça el banner",
"Max impressions" => "Impressions màximes",
"Show the banner only between these dates" => "Mostrar el banner només en aquestes dates",
"From date" => "Des de la data",
"To date" => "Fins la data",
"Use dates" => "Utilitza dates",
"Show the banner only in this hours" => "Mostrar el banner només a aquestes hores",
"to" => "a",
"Show the banner only on" => "Mostrar el banner sempre on",
"Mon" => "Dl",
"Tue" => "Dm",
"Wed" => "Dc",
"Thu" => "Dj",
"Fri" => "Dv",
"Sat" => "Ds",
"Sun" => "Dg",
"Select ONE method for the banner" => "Seleccioneu UN mètode per al banner",
"Use HTML" => "Utilitza HTML",
"Use image" => "Utilitza imatge",
"Image:" => "Imatge:",
"Current Image" => "Imatge actual",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Emprar la imatge generada per la URL (la imatge serà manada a la URL per cada impressió)",
"Use Flash" => "Empra Flash",
"Movie Size" => "Mida del vídeo",
"FlashPlugin min version" => "Versió min del connector FlashPlugin",
"Use text" => "Utilitzar text",
"Save the Banner" => "Desar el banner",
"Remove Zones (you lose entered info for the banner)" => "Esborrar Zones (es perdrà l'informació entrada per el banner)",
"Create Blog" => "Crea Bitàcola",
"A category is mandatory" => "Una categoria és obligatòria",
"Current heading" => "Actual encapçalament",
"There are individual permissions set for this blog" => "Existeixen permisos fixats individualment per a aquesta bitàcola",
"Number of posts to show" => "Nombre de publicacions per mostrar",
"Allow other user to post in this blog" => "Permetre a altres usuaris de publicar en aquest diari interactiu",
"Use titles in blog posts" => "Empra títols en publicacions de bitàcoles",
"Allow search" => "Permetre cerca",
"Allow comments" => "Permetre comentaris",
"Show user avatar" => "Mostra l'avatar de l'usuari",
"Blog heading" => "Encapçalament",
"Edit Style Sheet" => "edita Full d'Estil",
"Style Sheet" => "Fulla d'Estil",
"choose a stylesheet" => "escull un full d'estil",
"Try" => "Prova",
"Wiki Help" => "Ajuda Wiki",
"Wiki Syntax" => "Sintaxi Wiki",
"Bold text" => "Text en negreta",
"Italic text" => "Text en cursiva",
"single quotes" => "Apòstrofs",
"Underlined text" => "Text subratllat",
"Colored text" => "Text en colors",
"Headings" => "Capçaleres (o Títols)",
"Show/Hide" => "Mostra/Amaga",
"show/hide heading section. + (shown) or - (hidden) by default" => "mostra/amaga la secció de la capçalera. + (mostrat) o - (amaga) per defecte",
"Autonumbered Headings" => "Estils de títol autonumerats",
"Horizontal rule" => "Regla horitzontal",
"Text box" => "Requadre de text",
"Box content" => "Contingut de la caixa",
"Centered text" => "Text centrat",
"Dynamic variables" => "variables Dinàmiques",
"Inserts an editable variable" => "Inserta una variable editable",
"External links" => "Enllaços externs",
"use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)." => "empra claudators per a un enllaç extern: [URL], [URL|descripció_de_l_enllaç],[URL|descripció_de_l_enllaç|relació] o [URL|descripció_de_l_enllaç|relació|nocache] (aquest darrer evita que el Wiki local desi una còpia de la pàgina enllaçada a la memòria cau; es pot emprar la relació per insertar l'atribut rel per a l'enllaç - útil , p.e., per als efectes visuals amb la funcionalitat shadowbox).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Per a un Wiki extern, empri NomWikiExtern:NomPlana o ((Nom Wiki Extern: Nom Plana))",
"Square Brackets" => "Corxets",
"Use [[foo] to show [foo]." => "Empra [[foo] per mostrar [foo].",
"Wiki References" => "Referències del Wiki",
"JoinCapitalizedWords or use" => "AjuntarParaulesEnMajúscula o usar",
"page|description" => "pàg|desc",
"for wiki references" => "per referències del wiki",
"page|#anchor" => "pàgina|#àncora",
"page|#anchor|desc" => "pàgina|#àncora|descripció",
"for wiki heading/anchor references" => "per a referències a estils de títol wiki/àncora",
"SomeName" => "AlgunNom",
"prevents referencing" => "impedeix referenciar",
"Lists" => "Llistes",
"for bullet lists" => "per a llistes de punts",
"for numbered lists" => "per a llistes numerades",
"for definiton lists" => "per a llistes de definicions",
"Indentation" => "Sagnat",
"Creates an indentation for each plus (useful in list to continue at the same level)" => "Crea un sagnat de text per a cada més (útil en llistes per continuar amb la numeració més avall)",
"Tables" => "Taules",
"row" => "fila",
"Title bar" => "Barra de títol",
"Line break" => "Salt de línia",
"(very useful especially in tables)" => "(molt útil especialment en les taules)",
"creates the editable drawing foo" => "crea el dibuix editable foo",
"Multi-page pages" => "Pàgines múltiples",
"to separate pages" => "per separar planes",
"Non parsed sections" => "Seccions no analitzades",
"Prevents wiki parsing of the enclosed data." => "Evita interpretar el codi wiki de les dades incloses.",
"Preformated sections" => "Seccions preformatades",
"Block Preformatting" => "Preformatat de Block",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Sagna (inserta espais al principi per alinear el paràgraf més a la dreta) el text amb qualsevol nombre d'espais per convertir-lo en un bloc monoespaiat que encara segŭeix altres instruccions de format Wiki. Serà sagnat amb el mateix nombre d'espais que has emprat. Nota que d'aquesta forma no es preseva ni l'espaiat exacte ni els salts de línia; empra ~pp~...~/pp~ per això.",
"Special characters" => "Caràcters especials",
"Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Com la funcionalitat de formatació de paràgrafs Wiki està activada, tots els grups de línies que no estiguin en blanc són agrupades en paràgrafs.  Les línies poden ser de qualseovl longitud, i seran formatades juntes amb la següent línia.  Els paràgrafs es separen amb línies en blanc.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Com la funcionalitat de formatació de paràgrafs Wiki està desactivada, cada línia es mostrarà tal i com l'escriguis. Això vol dir que si vols que els paràgrafs es formatin correctament, un paràgraf ha d'estar tot ell en una sola línia.",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Fixa't que els arguments dels connectors (plugins) es poden envoltar de cometes dobles (&quot;); això permet que continguin , o = o &gt;",
"No description available" => "No hi ha disponible cap descripció",
"text, bold" => "text, negreta",
"text, italic" => "text, cursiva",
"text, underline" => "text, subratlla",
"table" => "taula",
"table new" => "taula nova",
"external link" => "un enllaç extern",
"wiki link'" => "enllaç wiki'",
"heading1" => "titular1",
"title bar" => "barra de títol",
"box" => "caixa",
"rss feed" => "alimentació rss",
"dynamic content" => "contingut dinàmic",
"tagline" => "linea de marcador",
"horizontal rule" => "regla horitzontal",
"center text" => "centra text",
"colored text" => "text en color",
"dynamic variable" => "variable dinàmica",
"New wms Metadata" => "Noves Metadades wms",
"New Class" => "Nova Clase",
"New Projection" => "Nova projecció",
"New Query" => "Nova consulta",
"New Scalebar" => "Nova Barra d'escala",
"New Layer" => "Nova capa",
"New Label" => "Nova etiqueta",
"New Reference" => "Nova referència",
"New Legend" => "Nova Llegenda",
"New Web" => "Nova Web",
"New Outputformat" => "Nou format de sortida",
"New Mapfile" => "Nou Arxiudemapa",
"Add image from File Gallery" => "Afegeix una imatge des d'una galeria d'arxius",
"quote" => "cita",
"Add Image from File Gallery" => "Afegeix una Imatge des d'una galeria d'arxius",
"special chars" => "caracters especials",
"special characters" => "caràcters especials",
"Leave Fullscreen Edit" => "Deixa l'edició a pantalla completa",
"Fullscreen Edit" => "Edició a pantalla completa",
"Browse Images" => "Explorar Imatges",
"Edit successful!" => "Edició feta amb èxit!",
"The following image was successfully edited" => "La imatge següent ha estat editada amb èxit",
"Image Description" => "Descripció de la imatge",
"Upload from disk to change the image:" => "Puja des del disc per canviar la imatge:",
"Save and Go Next" => "Desa i ves al següent",
"Edit and create Languages" => "Edita i crear Idiomes",
"Toggle interactive translation off" => "Desactiva la traducció interactiva",
"Toggle interactive translation on" => "Activa la traducció interactiva",
"Edit and create languages" => "Edita i crear idiomes",
"Create Language" => "Crear Idioma",
"Shortname" => "Nom curt",
"like" => "com",
"Longname" => "Nom llarg",
"Select the language to edit" => "Selecionar l'idioma que es vol editar",
"Add a translation" => "Afegeix una traducció",
"Edit translations" => "edita traduccions",
"Translate recorded" => "Traducció gravada",
"Translation" => "Traducció",
"reset table" => "reiniciar la taula",
"Create New Block" => "Crear un nou bloc",
"Return to block listing" => "Torna a la llista de blocs",
"Block description: " => "Descripció del bloc",
"You are editing block:" => "Estàs editant el bloc:",
"Publishing date" => "Data de publicació",
"Publishing Date" => "Data de Publicació",
"Edit question options" => "edita opcions de pregunta",
"List Quizzes" => "Fes llista dels qüestionaris",
"Quiz Stats" => "Estadístiques de Tests",
"This Quiz Stats" => "Estadistiques d'aquest test",
"Edit this Quiz" => "Edita aquest test",
"Admin Quizzes" => "Administrar qüestionaris",
"Create/edit options for question" => "Crear/edita opcions per a una pregunta",
"Create/edit quizzes" => "Crea/edita qüestionaris",
"There are individual permissions set for this quiz" => "Hi ha permisos individuals per a aquest Test",
"Quiz can be repeated" => "El test pot repetir-se",
"Store quiz results" => "Desar resultats d'aquest test",
"Immediate feedback" => "Retroalimentació immediata",
"Show correct answers" => "Mostra les respostes correctes",
"Shuffle questions" => "Qüestions barrejades",
"Shuffle answers" => "Respostes barrejades",
"Questions per page" => "Preguntes per pàgina",
"Quiz is time limited" => "El test té un temps limitat",
"Maximum time" => "Temps màxim",
"Passing Percentage" => "Percentatge d'aprovació'",
"Quiz" => "Test",
"canRepeat" => "potRepetir",
"timeLimit" => "tempsLimit",
"Edit quiz questions" => "edita preguntes del test",
"Create/edit questions for quiz" => "Crear/edita preguntes per a test",
"Question Type" => "Tipus de pregunta",
"Import questions from text" => "Importa preguntes des de text",
"Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "Instruccions: Escriviu o enganxeu les preguntes amb respostes múltiples per escollir a sota. Una línia per la pregunta, després comenceu les opcions de resposta a les línies següents. Separeu les preguntes adicionals amb una línia en blanc. Indiqueu la resposta correcta començant la línia amb el caràcter \"*\" (sense les cometes).",
"Input" => "Entrada",
"maxScore" => "maxResultat",
"From Points" => "Des de punts",
"To Points" => "Fins a punts",
"Answer" => "Resposta",
"Modify Structure" => "Modifica l'estructura",
"You will remove" => "Eliminaràs",
"and its subpages from the structure, now you have two options:" => "i amb les seves subpàgines de l'estructura, ara tens dues opcions:",
"and its subpages from the structure" => "i les seves subpàgines de l'estructura",
"Remove only from structure" => "Esborrar nomès de l'estructura",
"Remove from structure and remove page too" => "Esborrar de l'estructura i també borrar la pàgina",
"The page already exists. The page that has been added to the structure is the existing one." => "La pàgina ja existeix. La pàgina que s'ha afegit a l'estructura és l'existent.",
"The following pages added have automatically been categorized with the same categories as the structure:" => "Les pàgines següents afegides han estat automàticament categoritzades amb les mateixes categories que l'estructura:",
"Structure Layout" => "Disseny de l'estructura",
"Monitor the Sub-Structure" => "Vigila la Sub-Estructura",
"Stop Monitoring the Sub-Structure" => "Deixa de vigilar la Sub-Estructura",
"Promote" => "Promocionar",
"Demote" => "Demot",
"Current Node" => "Actual Node",
"Page alias" => "Àlies Pàgina",
"Move in this structure" => "Mou en aquesta estructura",
"Move to another structure" => "Mou a una altra estructura",
"at the beginning" => "al principi",
"at the end" => "al final",
"Add pages to current node" => "Afegeix pàgines al nòdul actual",
"After page" => "Pàgina Següent",
"Create Page" => "Crear pàgina",
"Use pre-existing page" => "Empra pàgina pre-existent",
"Categorize all pages in structure together" => "Categoritza totes les planes de l'estructura juntes",
"Remove existing categories from ALL pages before recategorizing" => "Elimina les categories existents de TOTES les pàgines abans de recategoritzar",
"Submit article" => "Enviar col·laboracions",
"List Submissions" => "Llista de submissions",
"<b>*</b>=optional" => "<b>*</b>=opcional",
"<b>Topline</b>=small line above Title" => "<b>Línia superior</b>=línia petita sobre el Títol",
"<b>Subtitle</b>=small line below Title" => "<b>Subtítol</b>=linia petita sota el Títol",
"<b>Source</b>=URL to article source" => "<b>Font</b>=URL a la font de l'article",
"Submit Article" => "Nou Article",
"Edit templates" => "Editar plantilles",
"Template listing" => "Llistat de plantilles",
"Available templates" => "Plantilles Permesses",
"Save Only in the Theme:" => "Desa només en el Tema:",
"Delete the copy in the theme:" => "Esborra la còpia en el tema:",
"Edit a topic" => "Edita un tema",
"Add Notification Email" => "Afegeix Correu-e per Notificacions",
"Admin notifications" => "Administra les notificacions",
"Translate:" => "Tradueix:",
"View Page" => "Visualitza pàgina",
"View Article" => "Mira l'article",
"You must specify the object language" => "Has d'especificar l'idioma de l'objecte",
"The object doesn't exist" => "L'objecte no existeix",
"The object doesn't have a language" => "L'objecte no té un idioma",
"The object has already a translation for this language" => "L'objecte ja té una traducció per a aquest idioma",
"The object is already in the set of translations" => "L'objecte ja hi és en el conjunt de la traducció",
"Unspecified" => "No especificat",
"Name of newly translated page" => "Nom de la pàgina novament traduïda",
"Create translation" => "Crea la traducció",
"\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"T'has oblidat d'especificar l'idioma de la traducció. si us plau, escull un idioma de la llista.\"",
"Or" => "O",
"Add existing page as a translation of this page" => "Afegeix una pàgina existent com la traducció d'aquesta pàgina",
"Manage existing translations of this page" => "Gestiona les traduccions existents d'aquesta pàgina",
"detach" => "separa",
"Change language for this page" => "Canvia l'idioma per a aquesta pàgina",
"No language is assigned to this page." => "No hi ha cap idioma assignat a aquesta pàgina.",
"Please select a language before performing translation." => "Si us plau, selecciona un idioma abans de fer la traducció.",
"Set Current Page's Language" => "Especifica l'idioma de la pàgina actual",
"Your edit session will expire in" => "La teva sessió d'edició caducarà en",
"Your edit session will expire in 1 minute. You must PREVIEW or SAVE your work now, to avoid losing your edits." => "La teva sessió d'edició caducarà en 1 minut. Has de PREVISUALITZAR o DESAR la teva feina ara, per evitar perdre les teves edicions.",
"You are editing the staging copy of the approved version of this page. Changes will be merged in after approval." => "Estàs editant la còpia per revisar d'una versió aprovada d'aquesta pàgina. Es fusionaran els canvis després de l'aprovació.",
"The current staging copy may contain changes that have yet to be approved." => "La còpia per revisar actual pot contenir canvis que encara han de ser aprovats.",
"View changes since last approval." => "Mostra els canvis des de la darrera aprovació.",
"You are editing the approved copy of this page." => "Estàs editant la còpia aprovada d'aquesta pàgina.",
"There are currently changes in the staging copy that have yet to be approved." => "Hi ha canvis a la còpia per revisar que encara han de ser aprovats.",
"Are you sure you do not want to edit" => "Segur que no vols editar",
"the staging copy" => "la còpia per revisar",
"instead?" => "en el seu lloc?",
"Draft written on" => "Esborrany desat el",
"Warning: new versions of this page have been made after this draft" => "Avís: s'han fet noves versions d'aquesta pàgina després d'aquest esborrany",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "El LlocdeProves (SandBox) és una pàgina on pots practicar les teves habilitats d'edició, emprar la opció de previsualització per previsualitzar l'aspecte de la pàgina, i no es guarda cap versió per a aquesta pàgina.",
"Perhaps you are looking for:" => "Potser estaves cercant:",
"Change diff styles" => "Canvia l'estil de diff",
"This edit session will expire in {\$edittimeout} minutes" => "Aquesta sessió d'edició caducarà en {\$edittimeout} minuts",
"<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer." => "<strong>Previsualitza</strong> o <strong>Desa</strong> la teva feina per reiniciar el comptador de la sessió d'edició.",
"Categories will be inherited from the structure top page" => "S'heredaran les categories de la pàgina inicial de l'estructura",
"Admin Content Templates" => "Administrar contingut de les plantilles",
"Use rating" => "Empra valoració",
"Disable" => "Deshabilita",
"There is no available poll template." => "No hi ha cap plantilla de votació disponible.",
"You should ask an admin to create them." => "Haurieu de preguntar a l'administrador per crear-ho.",
"or use" => "o empra",
"an existing poll" => "una votació existent",
"votes" => "vots",
"AutoSave" => "AutoDesa",
"If you want the saved version instead of the autosaved one" => "Si preferixes la versió desada enlloc de l'autodesada",
"Regex search " => "Cerca per l'expressió regular ",
"Replace to" => "Substitueix a",
"Case Insensitivity" => "Insensible a majúscules/minúscules",
"My Footnotes" => "Les meves notes al peu de pàgina",
"Translation request" => "Petició de traducció",
"Send urgent translation request." => "Envia una petició de traducció urgent.",
"Edit Comment" => "Edita el comentari",
"Monitor this page" => "Segueix aquesta pàgina",
"Year:" => "Any:",
"Authors:" => "Autors:",
"Try to convert HTML to wiki" => "Prova de convertir HTML a wiki",
"Import page" => "Pàgina d'importació",
"export all versions" => "exporta totes les versions",
"Upload picture" => "Puja foto",
"Add another image" => "Afegeix una altra imatge",
"License" => "Llicència",
"Lock this page" => "Bloqueja aquesta pàgina",
"List Sheets" => "Llista fulls",
"Graph" => "Grafica",
"Autodetect" => "Autodetecta",
"status" => "estatus",
"lastModif" => "UltimaModif",
"Fields visible in items list" => "Camps visibles a la llista d'ítems",
"Fields searchable or visible in items list" => "Camps cercables o visibles a la llista d'ítems",
"Fields visible in an item view" => "Camps visibles en la vista d'ítem",
"All fields" => "Tots els camps",
"Dump" => "Volcat",
"Admin FAQ" => "Administració de PMF",
"List FAQs" => "Fer llista de PUFs",
"View FAQ" => "Veure PUF",
"Edit this FAQ" => "Edita aquesta PUF",
"New Question" => "Pregunta nova",
"Use a question from another FAQ" => "Empra pregunta d'una altra PUF",
"FAQ questions" => "Preguntes d'Ús Freqüent (PUFs)",
"Suggested questions" => "Preguntes suggerides",
"No suggested questions" => "No hi ha cap suggeriment",
"File Archive" => "Arxiva el fitxer",
"Upload File" => "Puja l'arxiu",
"View tpl" => "Visualitza plantilla",
"File Galleries tpl" => "Galeries d'arxius tpl",
"Create New File Gallery" => "Crea una Nova Galería d'Arxius",
"You can access the file gallery using the following URL" => "Pots accedir a la galeria d'arxius emprant la URL",
"Size (width x height)" => "Mida (amplada x alçada)",
"Forum Importer" => "Importador de Fòrums",
"Admin forums" => "Admin fòrums",
"Import from a Local SQL File" => "Importa a partir d'arxiu SQL Local",
"Forum Type" => "Tipus de Fòrum",
"DB Prefix" => "Prefix de DB",
"Local SQL Filename on Server (path will be stripped)" => "Arxiu SQL local al servidor (la ruta serà estripada)",
"Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Ha d'estar a tikiroot/{\$tmpdir} o a tikiroot/img/wiki_up",
"Verification" => "Verificació",
"File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred." => "No s'ha especificat l'arxiu, o no va ser possible trobar-lo en cap dels dos llocs.  Si us plau, posar l'arxiu en algun dels dos directoris i torna Enrere. Si l'arxiu hi és en ambdos llocs, el lloc \$tikiroot/{\$filecheck} serà escollit preferentment.",
"Select a Forum You Wish to Move (ONE at a time!)" => "Selecciona un Fòrum que vulguis moure (UN cada cop!)",
"Which Forum Do You Wish to Import this Into?" => "A quin fòrum vols importar això?",
"Edit queued message" => "edita missatge en cua",
"make this a thread of" => "fes aixó un missatge permanent de",
"None, this is a thread message" => "Cap, aquest és un missatge fil",
"summary" => "resum",
"announce" => "anunci",
"hot" => "calent",
"no feeling" => "sense sentiment",
"frown" => "front",
"exclaim" => "Exclamació",
"mad" => "boig",
"question" => "pregunta",
"sad" => "trist",
"happy" => "feliç",
"wink" => "parpadejar",
"Save and Approve" => "Desa i aprova",
"convert to topic" => "converteix a tema",
"List of messages" => "Llista de missatges",
"New Topic" => "Nou tema",
"no summary" => "sense resum",
"No messages queued yet" => "Encara no hi ha missatges a la cua",
"Search by name" => "Cerca pel nom",
"Search in content" => "Cerca al contingut",
"Last Post" => "Darrer missatge",
"Configure Forum" => "Configura el fòrum",
"Reported by" => "Reportat per",
"Tag translation" => "Etiqueta traducció",
"Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag." => "Fixa't que les etiquetes que han estat creades a pàgines sense idioma assignat romandran \n\tuniversals (és a dir, amb la mateixa etiqueta a tots els idiomes) fins que s'especifiqui un idioma per a l'etiqueta.",
"Until then, they cannot be translated." => "Fins llavors, no poden ser traduïdes.",
"Show checkboxes to clear language information on tags" => "Mostra caselles de verificació per netejar la informació d'idioma a les etiquetes",
"There are no tags on this page in your preferred languages" => "No hi ha etiquetes en aquesta pàgina per als teus idiomes preferits",
"Set language" => "Especifica idioma",
"Show the following languages" => "Mostra els següents idiomes",
"Pending requests" => "Peticions pendents",
"Request Time" => "Data de petició",
"Accept" => "Accepta",
"Refuse" => "Rebutja",
"Waiting requests" => "Esperant peticions",
"Your friends" => "Les teves amistats",
"break friendship" => "trenca amistat",
"Activity completed" => "Activitat completada",
"Admin process activities" => "Administrar processament d'activitats",
"To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tikiwiki.org\">Galaxia workflow engine</a>" => "Per aprendre més sobre el <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tikiwiki.org\">Motor de Flux de treball</a>",
"Add or edit an activity" => "Afegeix o edita una activitat",
"activity" => "activitat",
"split" => "dividir",
"join" => "entra",
"standalone" => "autònom",
"interactive" => "interactiu",
"auto routed" => "auto dirigit",
"Expiration Time" => "Temps d'expiració",
"Years" => "Anys",
"Months" => "Mesos",
"Hours" => "Hores",
"Minutes" => "Minuts",
"Add transitions" => "Afegir transicions",
"Add transition from:" => "Afegir transició des de:",
"Add transition to:" => "Afegirx transició a:",
"No roles associated to this activity" => "No hi ha cap rol associat a aquesta activitat",
"Add Role" => "Afegeix Rol",
"Add New" => "Afegeix nou/va",
"Process activities" => "Activitats de procés",
"Routing" => "Enrutament",
"Interactive" => "Interactiu",
"Automatic" => "Automàtic",
"Auto routed" => "Auto dirigit",
"route" => "enrutar",
"(no roles)" => "(sense funcions)",
"No activities defined yet" => "Encara no s'ha definit cap activitat",
"Process Transitions" => "Processar Transicions",
"List of transitions" => "Llista de transicions",
"Origin" => "Origen",
"No transitions defined yet" => "Encara no s'ha definit cap transició",
"Add a transition" => "Afegeix una transició",
"Process Graph" => "Gràfic de procès",
"Galaxia Admin Graph" => "Administra Gràfic de Galaxia",
"Galaxia Admin Graph tpl" => "Plantilla (tpl) d'administració de Gràfic de Galaxia",
"This process is invalid" => "Aquest procés és invàlid",
"Process Graph for" => "Gràfic de procès per a",
"No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed." => "El gràfic de procés no està disponible. O bé el procés encara conté errors, o el gràfic encara no s'ha generat, o bé no s'ha instal·lat correctament <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a>.",
"List of processes" => "Llista de processos",
"Inactive" => "Inactiu",
"act" => "acte",
"Active Process" => "Procés actiu",
"Invalid Process" => "Procés no vàlid",
"Valid Process" => "Procés vàlid",
"Activities" => "Activitats",
"New Minor" => "Nou menor",
"New Major" => "Nou major",
"No processes defined yet" => "Encara no s'ha definit cap procés",
"Admin instance" => "Administrar instància",
"Process:" => "Procés:",
"Instance" => "Instància",
"Workitems" => "Itemsdefeina",
"exception" => "excepció",
"completed" => "completat",
"Aborted" => "Abortat/da",
"Owner" => "Propietari",
"Send all to" => "Enviar-ho tot a",
"Don't move" => "No ho moguis",
"Started" => "Iniciat",
"Act status" => "Estat de l'acte",
"Ended" => "Finalitzat",
"Not Defined" => "No definit",
"Not Interactive" => "Not interactiu",
"Not Ended" => "No finalitzat",
"Property" => "Propietat",
"Add property" => "Afegeix propietat",
"run instance" => "executar instància",
"Executed" => "Executat",
"erase" => "esborra",
"Admin processes" => "Administrar processos",
"Galaxia Admin Processes" => "Administració de la Galàxia",
"Galaxia Admin Processes tpl" => "Plantilla per a l'Administració de la Galàxia",
"Add or edit a process" => "Afegeix o edita un procés",
"Process Name" => "Nom del Procés",
"is active?" => "és actiu?",
"Or upload a process using this form" => "O publica un procés utilitzant aquest formulari",
"Admin process roles" => "Administrar processament de funcions",
"Add or edit a role" => "Afegeix o edita una funció",
"Process roles" => "Processar rols",
"No roles defined yet" => "Encara no hi ha cap rol definit",
"Map users to roles" => "Assigna rols als usuaris",
"map" => "mapa",
"Map groups to roles" => "Mapeja els grups cap als rols",
"Operation" => "Operació",
"No roles are defined yet so no roles can be mapped" => "Enacara no heu definit cap rol i per tant no es poden assignar als usuaris",
"List of mappings" => "Llista de mappings",
"No mappings defined yet" => "Encara no hi ha cap mapping definit",
"Admin process sources" => "Administrar processament de fonts",
"select source" => "trieu font",
"Shared code" => "Codi compartit",
"Set next user" => "Determineu el proper usuari",
"Get property" => "Obtingueu propietat",
"Set property" => "Determineu propietat",
"Process form" => "Formulari de procés",
"Set Next act" => "Configurar el següent acte",
"If:SetNextact" => "Si:SetNextact",
"Switch construct" => "Construcció de canvi",
"Map process roles" => "Mapa de rols de procés",
"Admin Processes" => "Administració de processos",
"Admin Activities" => "Administarció d'activitats",
"Admin Roles" => "Administració de rols",
"Edit this Process" => "Edita aquest procés",
"Monitor Activities" => "Segueix activitats",
"Galaxia Monitor Activities" => "activitats del Monitor de la Galàxia Activities",
"Galaxia Monitor Activities tpl" => "Plantilla per a les activitats del Monitor de la Galàxia",
"List of activities" => "Llista d'activitats",
"routing" => "enrutament",
"Instances" => "Instàncies",
"run" => "executar",
"run activity" => "executar activitat",
"Enter the name of this instance" => "Introdueix el nom d'aquesta instància",
"The name is not valid. Please, enter the name again" => "El nom no és vàlid. Torna a introduir el nom",
"Monitor" => "Vigilància",
"monitor processes" => "monitor processos",
"monitor activities" => "monitor activitats",
"monitor instances" => "monitoritza instàncies",
"monitor workitems" => "monitoritza ítems de treball",
"Monitor Instances" => "Segueix instàncies",
"Galaxia Monitor Instances" => "Instàncies de Monitor de Galaxia",
"Galaxia Monitor Instances tpl" => "Plantilla per a les Instàncies del Monitor de la Galàxia",
"List of instances" => "Llista d'instàncies",
"Not ended" => "No finalitzat",
"No instances created yet" => "Encara no s'han creat instàncies",
"Monitor Processes" => "Segueix processos",
"Galaxia Monitor Processes" => "Processos del Monitor de la Galàxia",
"Galaxia Monitor Processes tpl" => "Plantilla per als Processos del Monitor de la Galàxia",
"processes" => "processos",
"being run" => "estar funcionant",
"Completed" => "Completada",
"Exceptions" => "Excepcions",
"Monitor workitems" => "Monitoritza ítems de treball",
"List of workitems" => "Llista d'ítems de treball",
"instance" => "instància",
"Instance Id" => "Identificador de la instància",
"Instance Name" => "Nom de la instància",
"Instance Status" => "Estat de la instància",
"Elapsed time" => "Temps transcorregut",
"My activities" => "Les meves activitats",
"Current Activity" => "Activitat actual",
"Assigned To" => "Assignat a",
"exception instance" => "instància d'excepció",
"exceptions instance" => "instància d'excepcions",
"Send Instance" => "Enviar instància",
"abort instance" => "abortar instància",
"grab instance" => "agafar instància",
"release instance" => "lliberar instancia",
"No activities found" => "No s'han trobat activitats",
"My instances" => "Les meves instàncies",
"No instances found" => "No s'han trobat instàncies",
"User Activities" => "Activitats de l'Usuari/a",
"Galaxia User Activities" => "Activitats dels Usuaris/es de la Galàxia",
"Galaxia User Activities tpl" => "Plantilla per a les Activitats dels Usuaris/es de la Galàxia",
"process" => "procés",
"No processes defined or activated yet" => "Encara no hi ha processos definits o activats",
"user processes" => "processos d'usuari/a",
"user activities" => "activitats de l'usuari/a",
"user instances" => "instàncies d'usuari/a",
"User Instances" => "Instàncies d'usuari/a",
"Galaxia User Instances" => "Instàncies dels Usuaris/es de la Galàxia",
"Galaxia User Instances tpl" => "Plantilla per a les instàncies dels Usuaris/es de la Galàxia",
"Not defined" => "No definit",
"No instances defined yet" => "Encara no s'ha definit cap instància",
"User Processes" => "Processos d'usuari/a",
"Galaxia User Processes" => "Processos dels Usuaris/es de la Galàxia",
"Galaxia User Processes tpl" => "Plantilla per als Processos dels Usuaris/es de la Galàxia",
"Browsing Workitem" => "Explorant Ítem de Treball",
"Workitem information" => "Informació de l'Itemdefeina",
"Galleries" => "Galeries",
"Create New Gallery" => "Crear una nova galeria",
"Create a gallery" => "Crear una galeria",
"Edit this gallery:" => "edita aquesta galeria:",
"There are individual permissions set for this gallery" => "Existeixen permisos fixats individualment per a aquesta galeria",
"Geographic" => "Geogràfic",
"Fields to show during browsing the gallery" => "Camps que es mostren quan es navega per la galeria",
"Creation Date" => "Data de creació",
"XY-Size" => "mida-XY",
"Gallery Image" => "Imatge de la galeria",
"Available scales" => "Permesses escales",
"Global default" => "Per defecte Global",
"Bounding box" => "Requadre delimitador",
"default scale" => "escala per defecte",
"No scales available" => "No hi ha cap escala disponible",
"Original image is default scale" => "La imatge original és a l'escala per defecte",
"Add scaled images with bounding box of square size" => "Afegeix imatges escalades amb requadre delimitador quadrat",
"Other users can upload images to this gallery" => "Permetre a altres usuaris afegir imatges en aquesta galeria",
"You can access the gallery using the following URL" => "Pots accedir a la galeria emprant la URL",
"Available Galleries" => "Galeries disponibles",
"Choose a filter" => "Escull un filtre",
"Imgs" => "Imtgs",
"Make Map" => "Fes el Mapa",
"Google Map Locator" => "Localitzador als Mapes de Google",
"Save clicked point" => "Guarda el punt on he clicat",
"Save current view as default" => "Guarda la visualització actual com a la visualització per defecte",
"Users Map" => "Mapa d'Usuaris",
"Select Graphic Type" => "Selecciona Tipus de Gràfic",
"Pie Chart" => "Gràfic de Pastís",
"Multiline" => "Multilínia",
"Multibar" => "Multibarra",
"Bar Stack" => "Barres apilades",
"Landscape" => "Apaisat",
"Portrait" => "Vertical",
"Independant Scale" => "Escala independent",
"Horizontal Scale" => "Escala horitzontal",
"Bottom" => "Fons",
"Vertical Scale" => "Escala vertical",
"Series" => "Sèries",
"Wiki plug-in" => "Connector Wiki (plug-in)",
"Im- Export languages" => "Im- Exportar idiomes",
"Select the language to Import" => "Selecionar l'idioma que es vol Importar",
"Select the language to Export" => "Selecionar l'idioma que es vol Exportar",
"Modify String in Source Language" => "Modifica la cadena de text en l'idioma Oigien",
"Original String" => "Cadena de text original",
"New String" => "Nova cadena de text",
"Import From File" => "Importa des d'un arxiu",
"Grab Wiki Tables" => "Agafa les Taules Wiki",
"Import pages from a Structured Text Dump" => "Importa planes d'una descarrega de text structurada",
"Name of the dump file (it has to be in dump/)" => "Nom de l'arxiu de descàrrega (ha d'estar a dump/)",
"Overwrite existing pages if the name is the same" => "Sobreescriu pàgines existents si el nom és el mateix",
"Previously remove existing page versions" => "Treu primer les versions existents de la pàgina",
"excerpt" => "extracte",
"Result" => "Resultat",
"body" => "cos",
"XML Zip" => "Zip XML",
"Locked" => "Bloquejat",
"Tiki installer" => "Instal·lador de Tiki",
"Welcome" => "Benvinguts",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Empra aquesta utilitat per instal·lar una nova base de dades o actualitzar la teva base de dades existent a la versió",
"For the latest information about this release, please read the" => "Per a la darrera informació sobre aquest alliberament, si us plau, llegeix les",
"Release Notes" => "Notes d'alliberament",
"For complete documentation, please visit" => "Per a la documentació completa, si us plau visita",
"For more information about Tiki, please visit" => "Per més informació sobre Tiki, si us plau visita",
"Read the License" => "Llegeix la Llicència",
" <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/deed.ca\" target=\"_blank\">Aquí tens un resum llegible per humans de la llicència de sota, incloent moltes traduccions.</a>",
"Review the System Requirements" => "Revisa els requeriments del Sistema",
"Memory" => "Memòria",
"Success" => "Èxit",
"Mail" => "Correu",
"Copy test mail to " => "Copia el correu-e de prova a ",
"Send Test Message" => "Envia missatge de prova",
"Tiki was able to send a test message to" => "Tiki ha pogut enviar el missatge de prova a ",
"Image Processing" => "Processat d'imatges",
"Set the Database Connection" => "Especifica la connexió a la base de dades",
"Use Existing Connection" => "Empra la connexió existent",
"Database information" => "Informació de la Base de dades",
"Select the type of database to use with Tiki." => "Selecciona el tipus de base de dades per emprar amb Tiki.",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension." => "Aquí només es mostren les bases de dades suportades per la teva instal·lació PHP. Si la teva base de dades no està a la llista, prova d'instal·lar l'extensió de PHP apropiada.",
"Enter the name of the database that Tiki will use." => "Introdueix el nom de la base de dades que emprarà Tiki.",
"Database user" => "Usuari de la Base de dades",
"User name:" => "Nom d'usuari:",
"Install &amp; Update Profile" => "Perfil d'Instal·lació &amp; Actualització",
"Install Profile" => "Instal·la el Perfil",
"Install" => "Instal·lació",
"Reinstall the database" => "Reinstal·la la base de dades",
"Bare-bones default install" => "Instal·lació per omissió Mínima (Bare-bones)",
"Personal Blog and Profile" => "Bitàcola i Perfil Personal",
"Small Organization Web Presence" => "Presència Web d'Organització Petita",
"Company Intranet" => "Intranet d'Empresa/Entitat",
"Collaborative community" => "Comunitat col·laborativa",
"Upgrade" => "Actualització",
"Automatically upgrade your existing database to v" => "Actualitza automàticament la teva base de dades existent a la v",
"Review the Upgrade" => "Revisa l'Actualització",
"Review the Installation" => "Revisa la Instal·lació",
"Upgrade complete" => "Actualització completa",
"Installation complete" => "Instal·lació completa",
"If this is your first install, your admin password is <strong>admin</strong>." => "Si és la teva primera instal·lació, la teva contrasenya d'administrador <strong>admin</strong>.",
"Failed" => "No  han tingut èxit",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages." => "Durant una actualització, és normal tenir missatges d'error SQL de l'estil <strong>La taula ja existeix</strong>.",
".htaccess File" => "Arxiu .htaccess",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Recomanem habilitar l'arxiu <strong>.htaccess</strong> per al teu Tiki",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Això et permetrà emprar les  SEFURLs (adreces d'internet amigables als cercadors) i ajudar a millorar la seguretat del teu lloc",
"Configure General Settings" => "Configuracions Generals",
"Secure Login" => "Connexió segura",
"Administrator" => "Administrador/a",
"Enter Your Tiki" => "Entra al teu Tiki",
"Installation" => "Instal·lació",
"If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu." => "Si això és una actualització, neteja la memòria cau (cache) de Tiki manualment (el directori <strong>templates_c</strong>) o a través d'emprar l'opció del menú d'administració <strong>Admin &gt; Sistema</strong>.",
"Enter Tiki and Lock Installer" => "Entra a Tiki i bloqueja l'Instal·lador",
"Recommended" => "Recomanat",
"Enter Tiki Without Locking Installer" => "Entra a Tiki SENSE bloquejar l'Instal·lador",
"MultiTiki Setup" => "Instal·lació MultiTiki",
"Default Installation" => "Instal·lació per omissió",
"DB OK" => "BD OK",
"No DB" => "Cap BD",
"Install/Upgrade" => "Instal·lació / Actualització",
"Database Connection" => "Connexió a la Base de dades",
"Reset the Database Connection" => "Re-especifica la connexió a la Base de dades",
"Configure the General Settings" => "Configura els paràmetres generals",
"Tiki Icon" => "Icona de Tiki",
"TikiWiki Project Web Site" => "Web del Projecte TikiWiki",
"Support Forums" => "Fòrums de Suport",
"TikiWiki CMS/Groupware Project" => "Projecte TikiWiki CMS/Groupware",
"Powered by TikiWiki" => "Potenciat per TikiWiki",
"Clear cached version and refresh cache" => "Neteja versió captada i actualitza memòria cau",
"configure rules" => "configura normes",
"Edit Repository" => "Edita dipòsit",
"Interactive translator" => "Traductor Interactiu",
"has been updated" => "ha estat actualitzat/da",
"Close this window" => "Tanca aquesta finestra",
"Go Back" => "Torna enrere",
"Clicking 'Close this window' will reload the main window from where it was opened" => "En clicar sobre 'Tanca aquesta finestra' s'actualitzarà la finestra principal des d'on s'havia obert",
"Last Changes" => "Últimes modificacions",
"Search by Date" => "Cerca per data",
"LastChanges" => "DarrersCanvis",
"Rollback" => "Restableix",
"Pages like" => "Pàgines similars",
"No pages found" => "No s'han trobat pàgines",
"Edit New Article" => "Edita nou article",
"View Submissions" => "Veure col·laboracions",
"ExpireDate" => "DataExpiració",
"AuthorName" => "NomAutor",
"To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "Per utilitzar un banner en un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> o una plantilla, utilitzeu {literal}{banner zone=ABC}{/literal}, on ABC és el nom de la zona.",
"Create banner" => "Crea una banner",
"Method" => "Mètode",
"Use Dates?" => "Utilitzar dates?",
"Max Impressions" => "Impressions màx",
"Max Clicks" => "Clics Max.",
"Clicks" => "Clics",
"Create New Blog" => "Crear una nova bitàcola",
"Use cache for external pages" => "Fer servir la memòria cau per a les pàgines externes",
"Approval" => "Aprova-ho",
"Rejected" => "Rebutjat",
"Dynamic content system" => "Sistema de contingut dinàmic",
"To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block." => "Per utilitzar blocs de continguts en una àrea de text (Pàgina wiki, etc), un <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">mòdul</a> o una plantilla, utilitzeu {literal}{content id=x}{/literal}, on x és l'ID del bloc de continguts.",
"Edit content block" => "Edita bloc de contingut",
"Create content block" => "Crea bloc de contingut",
"Available content blocks" => "Blocs disponibles",
"Current Value" => "Valor actual",
"Current ver" => "Versió actual",
"Next ver" => "Propera versió",
"Future vers" => "Vers. futura",
"Program" => "Programar",
"Edit this FAQ:" => "Editeu aquesta PMF:",
"Create new FAQ" => "Creeu una nova PMF",
"Create New FAQ:" => "Creeu una nova PMF:",
"Users can suggest questions" => "Els usuaris poden suggerir preguntes",
"Available FAQs" => "PMF disponibles",
"Create a File Gallery" => "Crear una galeria d'arxius",
"SlideShow" => "Passi de diapositives",
"Keep gallery window open" => "Manté la finestra de la galeria oberta",
"Your comment" => "El teu comentari",
"optional" => "opcional",
"Modifications" => "Modificacions",
"Gallery Images" => "Galeries d'imatges",
"All games are from" => "Tots els jocs són de",
"visit the site for more games and fun" => "visita el lloc per a més jocs i diversió",
"Upload a game" => "Puja un joc ",
"Upload a new game" => "Penjar un joc nou",
"Flash binary (.swf or .dcr)" => "Binaris de Flash (.swf o .dcr)",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Thumbnail (si el joc es diu foo.swf la imatge ha de ser foo.swf.gif ó foo.swf.jpg ó foo.swf.png)",
"Edit game" => "Edita joc",
"Played" => "Jugat",
"If you can't see the game then you need a flash plugin for your browser" => "Si no pots veure el joc, és que necessites un plugin flash per al teu navegador",
"Edit Blog" => "Edita bitàcola",
"Blog Title" => "Títol de la Bitàcola",
"Edit New Submission" => "Edita la nova petición",
"Survey stats" => "Estadístiques de l'enquesta",
"Take Survey" => "Omple l'enquesta",
"users registered" => "usuaris enregistrats",
"Distance (km)" => "Distància (km)",
"List Movies" => "Llista de Pel·lícules",
"Choose a movie" => "Escull una películ·la",
"Last mod" => "Darrera mod",
"Last modification" => "Darrera modificació",
"Page creator" => "Creador de la pàgina",
"Last author" => "Darrer autor",
"Last version" => "Darrera versió",
"Last ver." => "Darr. ver.",
"Status of the page" => "Estatus de la pàgian",
"Links to other items in page" => "enllaça a altres ítems a la pàgina",
"Links to this page in other pages" => "Enllaós a aquesta pàgina en altres pàgines",
"Backl." => "Retroenll.",
"Page size" => "Mida de pàgina",
"Lang." => "Idiom.",
"unlocked" => "desbloquejat/da",
" {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}i {/if}començant amb",
"Open client window" => "Obre la finestra de client",
"Generate HTML" => "Genera HTML",
"Transcripts" => "Transcripcions",
"Online operators" => "Operadors connectats",
"Operator" => "Operador",
"Accepted requests" => "Sol·licituds acceptades",
"since" => "des de",
"transcripts" => "transcripcions",
"offline" => "fora de línia",
"Offline operators" => "Operadors desconnectats",
"Add an operator to the system" => "Afegiu un operador al sistema",
"Operators must be tiki users" => "Els operadors han de ser usuaris del tiki",
"Set as Operator" => "Definit com a operador",
"Chat started" => "Xat iniciat",
"Operator:" => "Operador:",
"Live support:User window" => "Suport Directe:finestra de l'usuari/a",
"Request live support" => "Demanar soport en directe",
"Request support" => "Demanar suport",
"Open a support ticket instead" => "Obrir una butlleta de suport",
"Your request is being processed" => "La teva petició està essent processada",
"cancel request and exit" => "Cancel·lar petició i sortir",
"cancel request and leave a message" => "Cancel·lar petició i deixar un missatge",
"Live support:Console" => "Suport Directe:Consol·la",
"be online" => "estar connectat",
"be offline" => "estar desconnectat",
"Support requests" => "Peticións d'ajuda",
"Requested" => "Sol·licitat",
"Join" => "Uneix",
"Support chat transcripts" => "Suport de transcripcions de chat",
"Back to admin" => "Torna a admin",
"operator" => "operador",
"started" => "començat",
"reason" => "raó",
"msgs" => "mstgs",
"Transcript" => "Transcripció",
"For security purposes we must periodically validate your email address to allow continued access to this site." => "Per qüestions de seguretat hem de validar periòdicament la teva adreça de correu-e per permetre l'acés continuat en aquest lloc.",
"A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site." => "Se t'ha enviat un correu-e de validació. Si us plau, obre'l i segueix les instruccions per obtenir de nou accés al lloc.",
"Thank you" => "Gràcies",
"This is an experimental feature" => "Aquesta és una funcionalitat experimental",
"Requires" => "Requireix",
"Not Enabled" => "No habilitat/da",
"Mail-in feature" => "Prestació Correu-in",
"Remove old events" => "Elimina els esdeveniments antics",
"duration" => "durada",
"Mini Calendar: Preferences" => "Mini Calendari: Preferències",
"Calendar Interval in daily view" => "Vista diària dels intervals del calendari",
"Start hour for days" => "Hora d'inici per als dies",
"End hour for days" => "Hora d'acabament per als dies",
"Reminders" => "Recordatoris",
"no reminders" => "sense recordatoris",
"Or enter path or URL" => "O entreu-hi el camí o la URL",
"Add Topic" => "Afegiu-hi un tema",
"Tikiwiki Mods" => "Mods de Tikiwiki",
"Mods Configuration" => "Configuració de Mods",
"Update remote index" => "Actualitza índex remot",
"Rebuild local list" => "Reconstrueix la lista local",
"Republish all" => "Republica'ls tots",
"Publish all" => "Publica'ls tots",
"Unpublish all" => "Despublica'ls tots",
"Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more." => "Es necessita la teva ajuda! Si us plau, visita <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> per saber-ne mes.",
"Attention" => "Atenció",
"all types" => "tots els tipus",
"for version" => "per a la versió",
"all versions" => "totes les versions",
"or later" => "o posterior",
"Display only this type" => "Mostra només aquest tipus",
"Unpublish" => "Despublica",
"Republish" => "Republica",
"licence" => "llicència",
"Tikiwiki Mods Configuration" => "Configuració de Mods de Tikiwiki",
"Mods Install/uninstall" => "Instal·lació/Desinstal·lació de Mods",
"Enable Mods providing" => "Habilita el proveïemnt de Mods",
"Mods local directory" => "Directori local de Mods",
"Mods remote server" => "Directori remot de Mods",
"Package Config" => "Configuració de Paquets",
"User Pages" => "Pàgines de l'usuari",
"y" => "s",
"User Galleries" => "Galeries de l'usuari/a",
"Unread Messages" => "Missatges no llegits",
"Tasks" => "Tasques",
"User forum topics" => "Tòpics de l'usuari als fòrums",
"Forum topics" => "Tòpics del Fòrum",
"Date of post" => "Data de publicació",
"User forum replies" => "Respostes de l'usuari al forum",
"Forum replies" => "Respostes al Fòrum",
"User Blogs" => "Bitàcoles de l'usuari",
"To display the objects you participate:" => "Per mostrar els objectes en els que participes:",
"MyTiki" => "ElmeuTiki",
"My Infos" => "Les meves informacions",
"Contacts Preferences" => "Preferències dels contactes",
"Notepad" => "Bloc de notes",
"MyFiles" => "Elsmeusarxius",
"My Watches" => "Els meus avisos",
"My Contacts" => "Els meus contactes",
"My Wiki Pages" => "Les meves pàgines Wiki",
"My Galleries" => "Les meves galeries",
"My Tracker Items" => "Els meus ítems de formularis",
"Assigned items" => "Ítems Assignats",
"My Messages" => "Els meus missatges",
"My Tasks" => "Les meves tasques",
"Sent editions" => "Envia edicions",
"HTML version" => "Versió en HTML",
"Text version" => "Versió en Text senzill",
"The newsletter was sent to {\$sent} email addresses" => "El butlletí ha estat enviat a {\$sent} adreces de correu-e",
"Not sent" => "No s'ha enviat",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Gràcies per la vostra subscripció. Aviat rebreu un missatge  com a confirmació de la vostra subscripció. No rebreu cap butlletí fins que confirmeu la subscripció.",
"Your email address was removed from the list of subscriptors." => "La teva adreça de correu-e ha estat eliminada de la llista de subscriptors.",
"Subscription confirmed!" => "Subscripció confirmada!",
"Subscribe to Newsletter" => "Subscriure a butlletí",
"Subscribe to this Newsletter" => "Subscriu",
"Available Newsletters" => "Butlletins disponibles",
"Select news group" => "Selecciona un grup de notícies",
"Back to servers" => "tornar a servidors",
"Msgs" => "Mstgs",
"News from" => "Notícies desde",
"Back to groups" => "tornar a grups",
"Save position" => "Guardar la posició",
"Reading article from" => "Llegint l'article de",
"Back to list of articles" => "tornar a llista d'articles",
"Newsgroup" => "Grup de discussió",
"Configure news servers" => "Configura els servidors de notícies",
"Configure Newsreader" => "Configura lector de notícies",
"configure newsreader server tpl" => "plantilla per a configurar el servidor del lector de notícies",
"Select a news server to browse" => "Seleccionar un servidor de noticies per examinar",
"server" => "servidor",
"Read the news" => "Llegeix les notícies",
"News server" => "Servidor de notícies",
"Write a note" => "Escriu una nota",
"No notes yet" => "Encara no hi ha notes",
"Merge selected notes into" => "fusiona les notes seleccionades en",
"Reading note:" => "Nota de lectura:",
"List notes" => "Llista de notes",
"Write note" => "Escriu nota",
"Wiki Create" => "Crea wiki",
"Wiki Overwrite" => "Sobrescriu wiki",
"Added:" => "Afegit:",
"Removed:" => "Suprimit:",
"Assign permissions to " => "Assignar permisos a ",
"View Permissions" => "Mostra els permisos",
"Edit Permissions" => "Edita els permisos",
"These permissions override any global permissions or category permissions affecting this object." => "Aquests permisos manen per sobre de qualssevol permisos globals o permisos de categories que afectin a aquest objecte.",
"To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>." => "Per editar els permisos globals <a class=\"rbox-link\" href=\"tiki-admingroups.php\">clica aquí</a>.",
"Current permissions for this object" => "Permisos actuals per aquest objecte",
"No individual permissions, category permissions apply" => "No hi ha permisos individuals; s'apliquen els permisos de categoria",
"Current permissions for categories that this object belongs to" => "Permisos actuals per a les categories a les quals pertany aquest objecte",
"These permissions do not apply. Special permissions apply." => "No s'apliquen aquests permisos. S'apliquen permisos especials.",
"No category permissions; global permissions apply" => "No hi ha permisos de categoria; s'aplicaran els permisos globals",
"No category permissions; special permissions apply" => "No hi ha permisos a nivell de categoria; S'apliquen permisos especials",
"and also to all pages of the sub-structure:" => "i també a totes les pàgines de la sub-estructura:",
"Assign permissions to this object" => "Assigna permisos a aquest objecte",
"Perms Help" => "Ajuda dels permios",
"Published" => "Publicada",
"Your OpenID identity is valid" => "La teva identitat OpenID és vàlida",
"However, no account is associated to the OpenID identifier." => "Ara bé, no hi ha cap compte associat a l'identificador OpenID.",
"Create a new Tikiwiki account from OpenID" => "Crea un nou compte Tikiwiki a partir del meu OpenID",
"Associate OpenID with an existing Tikiwiki account" => "Associa l'OpenID amb un compte de Tiki existent",
"Your identity gives you access to multiple user accounts." => "La teva identitat et dona accés a múltiples comptes d'usuari.",
"Select account" => "Selecciona compte",
"Orphan Pages" => "Pàgines òrfenes",
"Browser not supported" => "Explorador no suportat",
"Rename" => "Reanomenar",
"Make Structure" => "Fes Estructura",
"Slides" => "Diapos",
"Discuss" => "Debat",
"Attach File" => "Adjuntar arxiu",
"1 File Attached" => "1 arxiu adjunt",
"{\$atts|@count} files attached" => "{\$atts|@count} arxius adjunts",
"Preview of version" => "Previsualitzacióde la versió",
"(current)" => "(actual)",
"Rollback to this version" => "Restableix aquesta versió",
"Source of version" => "Codi font de la versió",
"s=source" => "s=codi font",
"b=rollback" => "b=restableix",
"Updated from" => "Actualitza des de",
"Used to update" => "Emprat per actualitzar",
"Update Translation" => "Actualitza traducció",
"Hide translation history" => "Amaga l'historial de la traducció",
"Show translation history" => "Mostra l'historial de la traducció",
"Pick your avatar" => "Escull el teu avatar",
"User Preferences" => "Preferències de l'usuari",
"Your current avatar" => "El teu avatar actual",
"no avatar" => "cap avatar",
"reset" => "reiniciar",
"Pick avatar from the library" => "Trieu avatar de la biblioteca",
"Pick user Avatar" => "Escull l'Avatar de l'usuari",
"Hide all" => "Amaga-ho tot",
"icons" => "icones",
"Show all" => "Mostra-ho tot",
"Avatar Image" => "Imatge Avatar",
"Upload your own avatar" => "Puja el teu propi avatar",
"File (only .gif, .jpg and .png images approximately 45px × 45px)" => "Arxiu (només imatges .gif, .jpg i .png d'aproximadament 45px × 45px)",
"Plugin execution was denied" => "S'ha denegat l'execució del connector",
"Plugin execution pending approval" => "Execució del connector esperant aprovació",
"View arguments" => "Veure els arguments",
"Execute the plugin in preview mode (may be dangerous)" => "Executar el connector en mode de previsualització (pot ser perillós)",
"Approve the plugin for public execution" => "Aprovar l'ús del connector per a execució pública",
"View Details" => "Mostra detalls",
"Insert" => "Insertar",
"Any" => "Qualsevol",
"atts" => "adjunts",
"List Attachments" => "Llista els Deures",
"Average" => "Mitjana",
"Sum" => "Suma",
"Plugin Approval" => "Aprovació d'Ús de Connectors",
"Plugin" => "Connector (Plugin)",
"View Results" => "Visualitza resultats",
"Vote poll" => "Participa en la votació",
"Other Polls" => "Altres Votacions",
"Poll Results" => "Resultats de la Votació",
"Top Voted Polls" => "Votacions amb més participació",
"Edit Poll" => "Edita el Sondeig",
"Find the poll" => "Troba el sondeig",
"Number of top voted polls to show" => "Nombre a mostrar de votacions amb més participació",
"Vote range displayed" => "Rang de votació mostrat",
"List Votes" => "Llista Vots",
"Average:" => "Mitjana:",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Avís: Recorda que això és només una previsualització, i que no ha estat gravat encara!",
"on:" => "a:",
"Topic image" => "Imatge del tòpic",
"Viewing blog post" => "Visualitzant la publicació de la bitàcola",
"Return to blog" => "Retorna a la bitàcola",
"The original document is available at" => "El document original està disponible en",
"Print multiple pages" => "Imprimir múltiples pàgines",
"Selected Structures" => "Estructures seleccionades",
"Add Structure" => "Afegeix estructura",
"No structures" => "Cap estructura",
"Add Pages" => "Afegeix planes",
"No pages" => "Cap pàgina",
"Add Page" => "Afegeix pàgina",
"Add Pages from Structures" => "Afegeix planes des d'Estructures",
"Add Structure Pages" => "Afegeix pàgines de l'estructura",
"Selected Pages" => "Planes Seleccionades",
"Edit quiz" => "Edita el qüestionari",
"General Options" => "Opcions generals",
"Name:" => "Nom:",
"Publication Date" => "Data de publicació",
"at " => "a ",
"Use " => "Empra ",
"randomly selected questions." => "preguntes seleccionades a l'atzar.",
"Test-time Options" => "Opcions de test amb temps limitat",
"Limit questions displayed per page to " => "Limita les preguntes mostrades per pàgina a ",
"&nbsp question(s)." => "&nbsp pregunta/es.",
"Impose a time limit of " => "Imposa un temps limit de ",
"Allow students to store partial results and return to quiz." => "Permet als estudiants guardar els resultats parcials i tornar al qüestionari.",
"Allow students to retake this quiz " => "Permet als estudiants repetir aquest qüestionari ",
"Grading and Feedback" => "Avaluació i retroalimentació",
"Grading method " => "Mètode d'avaluació ",
"Show students their score " => "Mostra als estudiants la seva puntuació ",
"Show students the correct answers " => "Mostra als estudiants les respostes correctes",
"Publish statistics " => "Publica les estadístiques ",
"Extra Options" => "Opcions extres",
"Solicit additional questions from students" => "Solicita preguntes addicionals dels estudiants",
"Link quiz to forum named: " => "Enllaça la pregunta al fòrum anomenat: ",
"Prologue:" => "Pròleg:",
"Epilogue:" => "Epíleg:",
"Quiz result stats" => "Estadístiques dels resultats dels Tests",
"Time" => "Temps",
"User answers" => "Respostes de l'usuari/a",
"Stats for quizzes" => "Estadistiques de qüestionaris",
"taken" => "pres/os",
"Av score" => "Resultat mitjà",
"Av time" => "Temps mitjà",
"Clear Stats" => "Esborrar estadístiques",
"time taken" => "temps emprat",
"Passed" => "Aprovat",
"Stats for this quiz Questions " => "Estadístiques per a les preguntes d'aquest test",
"Top 10" => "10 per dalt",
"Top 20" => "20 per dalt",
"Top 50" => "50 per dalt",
"Top 100" => "100 per dalt",
"star" => "estrella",
"half star" => "mitja estrella",
"Send a link" => "Envia un enllaç",
"Received articles" => "Articles rebuts",
"Edit received article" => "Edita article rebut",
"Use Image" => "Empra imatge",
"Image x size" => "Mida x de la imatge",
"Image y size" => "Mida y de la imatge",
"Image name" => "Nom de la imatge",
"Accept Article" => "Accepta Article",
"Site" => "Lloc",
"Received Pages" => "Pàgines Rebudes",
"Edit Received Page" => "Edita la Pàgina Rebuda",
"The highlight pages already exist." => "Les planes ressaltades ja existeixen.",
"Please, change the name if you want the page to be uploaded." => "Si us plau, canvia el nom si vols que es pugi la pàgina.",
"Received Structures" => "Estructures rebudes",
"Referer stats" => "Estadístiques de referenciadors",
"Use your email as login" => "Empra el teu correu-e com a nom per connectar-te",
"Minimum {\$prefs.min_username_length} characters long" => "Com a mínim calen {\$prefs.min_username_length} caràcters de longitud",
"Passcode to register" => "Codi de pas per registrar-se",
"To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "Per requerir un codi de pas, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\tcontacta a les persones administradores del sistema{if \$prefs.feature_contact eq 'y'}</a>{/if}",
"A valid email is mandatory to register" => "Cal una adreça de correu-e vàlida per enregistrar-te",
"Select your group" => "Selecciona el teu grup",
"NOTE: Make sure to whitelist this domain to prevent registration emails being canned by your spam filter!" => "NOTA: Assegura't de posar aquest domini a la llista blanca per prevenir que els correus-e de registre siguin filtrats i eliminats automàticament pel teu filter de correu brossa (spam)!",
"Tiki site registered" => "Llocs Tiki registrats",
"The following site was added and validation by admin may be needed before appearing on the lists" => "El lloc web següent s'hi ha afegit i potser necessitarà ser validat per l'administrador abans d'aparèixer a les llistes",
"You don't have permission to use this feature." => "No tens permís per emprar aquesta característica. Prova (re)connectar-te primer, enregistrant-te abans si no ho has fet encara",
"Please register." => "Si us plau, registreu-vos.",
"Register this site at tikiwiki.org" => "Registra aquest lloc a tikiwiki.org",
"Read this first!" => "Llegeix això abans de començar!",
"On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites." => "En aquesta pàgina pots donar a conèixer el teu lloc tiki a tikiwiki.org per tal que consti al llistat de llocs tiki coneguts",
"Registering is voluntary." => "Registrar-se és voluntari.",
"Registering does not give you any benefits except one more link to your site." => "Registrar-se no et dona cap més avantatge que un enllaç més cap al teu lloc.",
"You don't get any emails, we don't sell the data about your site." => "No aconseguiràs adreces d'e-correus, no venem les dades dels llocs.",
"Registering is just for us to get an overview of Tiki's usage." => "El registre només és per fer-nos una idea de l'ús que es fa de Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Si el teu lloc és privat o està en una (intranet/xarxa interna), no et registris!",
"Information about your site" => "Informació del teu lloc",
"Send me my Password" => "Envia'm la meva contrasenya",
"Request Password Reset" => "Demana un canvi de contrasenya",
"Remove page" => "Eliminar pàgina",
"Last Version" => "última versió",
"Back to page" => "Retorna a la pàgina",
"You are about to remove the page" => "Esteu a punt d'eliminar la pàgina",
"permanently" => "permanentment",
"Remove all versions of this page" => "Elimina totes les versions d'aquesta pàgina",
"Replicate" => "Replica",
"Slave" => "Esclau",
"Master" => "Mestre",
"Operations" => "Operacions",
"Operations Log" => "Registre d'operacions",
"Rollback page" => "Restableix versió",
"to version" => "a la versió",
"Searched" => "Cercat",
"Search in" => "Buscar a",
"Faqs" => "Pufs (faqs)",
"Simple search" => "Cerca simple",
"No pages matched the search criteria" => "Cap pàgina ha encaixat en el criteri de cerca",
"All dates" => "Totes les dades",
"Calendar Items" => "Items del calendari",
"Send blog post" => "Envia la publicació a la bitàcola",
"A link to this post was sent to the following addresses:" => "Heu enviat un enllaç a aquest enviament a les adreces següents:",
"Send post to this addresses" => "Envia un eviament a aquestes adreces",
"List of email addresses separated by commas" => "Llista d'adreces electròniques separades per comes",
"Please Confirm" => "Si us plau, confirma-ho",
"This newsletter will be sent to {\$subscribers} email addresses." => "Aquest butlletí serà enviat a {\$subscribers} adreces de correu-e.",
"Prepare a newsletter to be sent" => "Prepara un butlletí per ser enviat",
"Apply content template" => "Aplica la plantilla de contingut",
"Data HTML" => "Dades HTML",
"Data Txt" => "Dades Txt",
"remove" => "eliminar",
"Save as Draft" => "Desa-ho com a esborrany",
"Send objects" => "Envia objectes",
"Transmission results" => "Resultats de la transmissió",
"Send Wiki Pages" => "Envia pàgines del Wiki",
"Send a structure" => "Envia una estructura",
"Send Articles" => "Envia articles",
"Add Article" => "Afegeix article",
"Send objects to this site" => "Envia objectes a aquest lloc",
"Ex: http://tikiwiki.org or localhost" => "Ex: http://tikiwiki.org o localhost",
"Create a sheet" => "Crea un full",
"Edit this sheet:" => "Edita aquest full:",
"Create New Sheet" => "Crea un nou full",
"There are individual permissions set for this sheet" => "Hi ha permisos individuals fixats per a aquest full",
"Class Name" => "Nom de Classe",
"Header Rows" => "Files de Capçalera",
"Footer Rows" => "Files de Peu de pàgina",
"Create new Sheet" => "Crea un nou full",
"You can access the sheet using the following URL" => "Pots accedir a aquest full emprant la següent URL",
"Available Sheets" => "Fulls disponibles",
"Change shoutbox general settings" => "canvia les opcions generals del diàleg",
"auto-link urls" => "auto-enllaç urls",
"Post or edit a message" => "Editar o enviar missatge",
"This is the staging copy of" => "Aquesta és la pàgina per revisar de",
"the approved version of this page." => "la versió aprovada d'aquesta pàgina.",
"Viewing of changes since last approval is possible only after first approval." => "La visualització dels canvis des de la darrera aprovació només és possible després de la primera aprovació.",
"Approve changes." => "Aprova els canvis.",
"Latest changes will be synchronized after approval." => "Els darrers canvis es sincronitzaran després de l'aprovació.",
"This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time." => "Aquesta és una nova pàgina per revisar que no ha estat aprovada encara. Edita-la i mou-la a la categoria per pàgines aprovades per aprovar-la la primera vegada.",
"An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages:" => "S'ha enviat una petició urgent de traducció. Fins que la pàgina no estigui actualitzada, pots veure una versió corregida a les pàgines següents:",
"Parent page" => "Pàgina filial",
"TOC" => "Índex",
"Child" => "Filla",
"Last edited by" => "Editat per darrera vegada per",
"based on work by" => "basat en treball fet per",
"Contributors to this page" => "Contribuïdors a aquesta pàgina",
"big grin" => "gran grin",
"confused" => "confós",
"cool" => "guai",
"cry" => "plorar",
"evil" => "dimoni",
"mr green" => "sr green",
"redface" => "avergonyit",
"rolleyes" => "rodaulls",
"smile" => "somriure",
"surprised" => "sorprès",
"twisted" => "girat",
"arrow" => "fletxa",
"Clean" => "Neteja",
"Most viewed objects" => "Objectes més visualitzats",
"Most viewed objects in the last 7 days" => "Objectes més visualitzats en els darrers 7 dies",
"Site Stats" => "Estadístiques del lloc",
"Total pageviews" => "Visualitzacions de pàgines en total",
"Average pageviews per day" => "Mitjana de visualització de pàgines per dia",
"Best day" => "Millor dia",
"Worst day" => "Pitjor dia",
"Wiki Stats" => "Estadístiques del Wiki",
"Size of Wiki Pages" => "Mida de les pàgines del Wiki",
"Mb" => "MegaOctets (Mb)",
"Average page length" => "Mida mitjana de les pàgines",
"Average versions per page" => "Mitjana de versions per pàgina",
"Visits to wiki pages" => "Visites a pàgines del wiki",
"Orphan pages" => "Pàgines òrfenes",
"Average links per page" => "Quantitat mitjana d'enllaços per pàgina",
"Image galleries Stats" => "Estadístiques de galeries d'imatges",
"Average images per gallery" => "Mitjana d'imatges per galeria",
"Total size of images" => "Mida total de les imatges",
"Average image size" => "Mida mitjana d'imatge",
"Visits to image galleries" => "Visites a galeries d'imatges",
"File galleries Stats" => "Estadístiques de galeries d'arxius",
"Average files per gallery" => "Mitjana d'arxius per galeria",
"Total size of files" => "Mida total dels arxius",
"Average file size" => "Mida mitjana d'arxiu",
"Visits to file galleries" => "Visites a les galeries d'arxius",
"CMS Stats" => "Estadístiques del CMS",
"Total reads" => "Quantitat de notes llegides",
"Average reads per article" => "Mitjana de lectures per article",
"Total articles size" => "Mida total dels articles",
"Average article size" => "Mida mitajana d'un article",
"Forum Stats" => "Estadístiques de fòrums",
"Total topics" => "Quantitat de temes",
"Average topics per forums" => "Quantitat mitjana de temes per fòrum",
"Total replies" => "Respostes totals",
"Visits to forums" => "Visites als fòrums",
"Blog Stats" => "Estadístiques de les Bitàcoles web",
"Weblogs" => "Bitàcoles Web",
"Total posts" => "Publicacions totals",
"Average posts per weblog" => "Mitjana enviaments per bitàcola web",
"Total size of blog posts" => "Mida total de les publicacions per bitàcola web",
"Average posts size" => "Mida mitjana d'una publicació",
"Visits to weblogs" => "Visites a les bitàcoles web",
"Poll Stats" => "Estadístiques de votacions",
"Total votes" => "Vots totals",
"Average votes per poll" => "Mitjana de vots per votació",
"Total questions" => "Preguntes en total",
"Average questions per FAQ" => "Mitjana de preguntes per PUF",
"User Stats" => "Estadístiques d'usuaris",
"User bookmarks" => "Adreces d'interès de l'usuari",
"Average bookmarks per user" => "Mitjana d'enllaços d'interès per usuari",
"Average questions per quiz" => "Mitjana de preguntes per Test",
"Quizzes taken" => "Qüestionaris presos",
"Average quiz score" => "Puntuació mitjana de tests",
"Average time per quiz" => "Temps mitjà per test",
"Usage chart" => "Gràfica d'ús",
"Usage chart image" => "Emprar imatge de gràfic",
"Daily Usage" => "Ús diari",
"Stats for surveys" => "Estadístiques per enquestes",
"Last taken" => "Darrer pres",
"Clean logs older than" => "Esborra els registres més antics de",
"months" => "mesos",
"Time Left" => "Temps Restant",
"Send Answers" => "Envia respostes",
"Thank you for your submission" => "Gràcies pel teu enviament",
"Send a link to a friend" => "Envia un enllaç a un amic/ga",
"Your email was sent" => "El teu correu-e ha estat enviat",
"The link was sent to the following addresses:" => "S'ha enviat l'enllaç a les següents adreces:",
"Your name" => "El teu nom",
"Your email" => "El teu correu-e",
"Config" => "Configuració",
"Failure" => "Fallada",
"Theme is selected as follows" => "Theme se selecciona de la manera següent",
"If a theme is assigned to the individual object that theme is used." => "Si assigneu un theme a un objecte individual, aquest theme sera l'utilitzat.",
"If not then if a theme is assigned to the object's category that theme is used" => "Si no és així, si assigneu un theme a una categoria d'objecte, aquest tema serà l'utilitzat",
"If not then a theme for the section is used" => "Si no és així, s'utilitzarà un theme per a la secció",
"If none of the above was selected the user theme is used" => "Si no trieu cap de les opcions anteriors, s'utilitzarà el theme de l'usuari",
"Finally if the user didn't select a theme the default theme is used" => "Finalment, si l'usuari no ha seleccionat cap theme, s'utilitzarà el theme per defecte",
"Control by Objects" => "Control per objectes",
"Control by Sections" => "Control per Seccions",
"Assign themes to categories" => "Assigna themes a categories",
"Assigned categories" => "Categories assignades",
"Theme Control Center: Objects" => "Centre de control de temes: Objectes",
"Control by Categories" => "Control per Categories",
"Assign themes to objects" => "Assignar aspectes als objectes",
"Assigned objects" => "Objectes Assignats",
"Assign themes to sections" => "Assignar aspectes a les seccions",
"Assigned sections" => "Seccions Assignades",
"Edit File:" => "Edita Fitxer:",
"The following file was successfully uploaded" => "El següent fitxer s'ha pujat correctament",
"You can download this file using" => "Podeu baixar l'arxiu emprant",
"You can link to the file from a Wiki page using" => "Pots incloure l'arxiu en una pàgina Wiki emprant",
"You can display an image in a Wiki page using" => "Pots incloure l'arxiu en una pàgina HTML emprant",
"You locked the file" => "Has bloquejat l'arxiu",
"The file is locked by {\$fileInfo.lockedby}" => "L'arxiu està bloquejat per {\$fileInfo.lockedby}",
"You have to create a gallery first!" => "Has de crear una galeria primer!",
"Batch Upload Results" => "Pujada en bloc: Resultats",
"Upload successful!" => "Pujada amb èxit!",
"The following image was successfully uploaded" => "La següent imatge s'ha pujat correctament",
"Image ID thumb" => "Diapositiva de la Imatge ID",
"You can include the image in an Wiki page using" => "Pots incloure la imatge a una pàgina wiki emprant",
"or use filename" => "o utilitza el nom del fitxer",
"Now enter the image URL" => "Introduïu ara la URL de la imatge",
"or upload a local image from your disk" => "o puja una imatge local des del teu disc",
"Batch Upload" => "Puja al rerafons",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatures (opcional, impedeix que es generin contactes pel sistema)",
"Note: Maximum image size is limited to" => "Nota: tamany màxim de l'imatge limitat a",
"User assigned modules" => "Mòduls assignats per l'usuari",
"Assign module" => "Assigna mòdul",
"Column" => "Columna",
"top" => "més actius/ves",
"Current folder" => "Carpeta actual",
"Folders" => "Carpetes",
"Folder in" => "En la carpeta",
"Remove Folder" => "Elimina carpeta",
"Refresh Cache" => "Refresca memòria cau",
"Admin folders and bookmarks" => "Administració de carpetes i adreces d'interès",
"Send me a message" => "Envia'm un missatge",
"Assign Group" => "Assignar Grup",
"Homepage" => "Plana inicial",
"Users HomePage" => "Plana inicials dels usuaris",
"Personal Wiki Page" => "Pàgina Wiki Personal",
"Create page" => "Crea pàgina",
"System" => "Sistema",
"This user is your friend" => "Aquest usuari és el teu amic",
"Request friendship from this user" => "Demana l'amistat d'aquest usuari",
"Forum comments" => "Comentaris del Fòrum",
"Toggle options" => "Opcions de commutació",
"Toggle" => "Commuta",
"Personal Information" => "Informació Personal",
"Male" => "Home",
"Female" => "Dona",
"Use Google Map locator" => "Empra el localitzador dels mapes de google",
"Your personal Wiki Page" => "La teva pàgina personal al Wiki",
"Your personal tracker information" => "Informació del teu formulari personal",
"View extra information" => "Visualitza informació extra",
"Is email public? (uses scrambling to prevent spam)" => "És públic aquest correu-e ? (per a provenir spam)",
"Unavailable - please set your e-mail below" => "No disponible - si us plau, posa el teu correu-e a sota",
"Does your mail reader need a special charset" => "Necessita el teu programa lector de correu-e un conjunt de caracters especial",
"Your preferred language" => "El teu idioma preferit",
"Can you read more languages?" => "Pots llegir més idiomes?",
"Other languages you can read (select on the left to add to the list on the right)" => "Altres idiomes que pots llegir (selecciona a l'esquerra per afegir a la llista de la dreta - l'ordre importa)",
"Select language..." => "Selecciona l'idioma...",
"Note author when reading his mail" => "Avisa l'autor quan llegiu el seu missatge",
"My level" => "El meu nivell",
"Account Information" => "Informació del compte",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Deixa els camps \"Contrasenya nova\" i \"Confirma contrasenya nova\" en blanc per mantenir la contrasenya actual",
"Email address" => "Adreça de correu-e",
"Confirm new password" => "Confirma contrasenya nova",
"Current password (required)" => "Contrasenya actual (requerida)",
"Change administrative info" => "Canvia la informació administrativa",
"New task" => "Tasca nova",
"Task list" => "Llista de tasques",
"Admin mode off" => "Mode Administrador inactiu",
"Admin mode on" => "Mode Administrador activat",
"Task help" => "Ajuda de tasques",
"Empty Trash" => "Buida paperea",
"Received task" => "Tasca rebuda",
"You received this task, please read and execute it" => "Heu rebut aquesta tasca, si us plau, llegiu-la i executeu-la",
"Send task" => "Envia tasca",
"You send this task to a other user" => "Envies aquesta tasca a un altre usuari/a",
"Shared task" => "Tasca compartida",
"This task is public to a special group" => "Aquesta tasca és pública a un grup especial",
"Accepted by Task User and Creator" => "Acceptada per l'usuari de la tasca i creador",
"Accepted User and Creator" => "Ususari i creador acceptat",
"Task is accepted by user and creator" => "La tasca ha estat acceptada per l'usuari/a i creador/a",
"Not Accepted by One User" => "No acceptada per un/a usuari/a",
"Not Accepted User" => "Usuari no acceptat",
"Task is rejected by one user" => "La tasca ha estat rebutjada per un/a usuari/a",
"Waiting for Me" => "Esperant-me a mi",
"Task is not accepted by you, read the task and accept or reject it" => "La tasca no ha estat acceptada per tu, llegeix-la i accepta-la o rebutja-la",
"Waiting for Other User" => "Esperant a un altre/a usuari/a",
"Task is not accepted/rejected by other user" => "La tasca no ha estat acceptada/rebutjada per un altre usuari",
"Admin Mode" => "Mode administrador",
"Edit task" => "Edita tasca",
"NOT accept" => "NO acceptis",
"Remove from Trash" => "Elimina de la paperera",
"Move into Trash" => "Mou a la paperera",
"Task saved" => "Tasca guardada",
"Edit Task" => "Edita la tasca",
"View Task" => "Mostra la tasca",
"Open a new task" => "Obre una nova tasca",
"taskId" => "IdTasca",
"Task user" => "Usuari de la tasca",
"Only the creator can delete this task" => "Només el creador pot esborrar aquesta tasca",
"Use start date and time" => "Empra data i hora d'inici",
"Use end date and time" => "Empra data i hora de finalització",
"Open / In Process" => "Oberta / en procés",
"Waiting / Not Started" => "En espera / no iniciada",
"Percentage completed" => "Percentatge completat",
"Waiting" => "Esperant",
"Shared for Group" => "Compartida per al group",
"Accepted by User" => "Acceptada per l'usuari/a",
"No / Rejected" => "No / rebutjada",
"Accepted by Creator" => "Acceptada pel creador",
"This message will be send to users if you are makeing changes of assigned tasks" => "Aquest missatge serà enviat als usuaris si fas canvis a tasques assignades",
"Send message with changes" => "Envia missatge amb canvis",
"Modified by" => "Modificada per",
"Marked as deleted" => "Marcat com a eliminat",
"Inform task user by email" => "Informa a l'usuari de la tasca per correu-e",
"You can only view this task" => "Pots veure només aquesta tasca",
"%m/%d/%Y [%H:%M]" => "%d/%m/%Y [%H:%M]",
"No tasks entered" => "No hi ha cap tasca",
"Select One" => "Selecciona un/a",
"Undo Trash" => "Desfés paperera",
"Show:" => "Mostra:",
"Received" => "Rebut/da",
"Submitted" => "Enviat/da",
"Shared" => "Compartit/da",
"All Shared Tasks" => "Totes les tasques compartides",
"completed (100%)" => "completat/da (100%)",
"Public for group" => "Pública per al grup",
"Use \"watches\" to monitor wiki pages or other objects." => "Fes servir els \"seguiments\" per vigilar pàgines wiki o altres objectes.",
"Watch new items by clicking the {icon _id=eye} button on specific pages." => "Vigila nous ítems en clicar al botó de l'ull {icon _id=eye} de pàgines específiques.",
"Add Watch" => "Afegeix avís",
"Watches" => "Avisos",
"A user submits a blog post" => "Un usuari envia una publicació de blog",
"A user posts a forum thread" => "Una persona usuària publica un fil de discussió del fòrum",
"A user posts a forum topic" => "Una persona usuària publica un topic del fòrum",
"A user edited a wiki page" => "Un usuari edita una pàgina wiki",
"A user created a wiki page in a language" => "Un usuari ha creat una pàgina a l'idioma",
"May need to refresh twice to see changes" => "Es necessita actualitzar dos cops per tal de veure els canvis",
"Add top level bookmarks to menu" => "Afegeix els millors favorits al menú",
"replace window" => "reemplaçar la finestra",
"User_versions_for" => "Versions de l'usuari per a",
"This page is being edited by" => "Aquesta pàgina està essent editada per ",
"Proceed at your own peril" => "Procedir al teu propi risc",
"Insert Row" => "Inserta Fila",
"Insert Column" => "Inserta Columna",
"Remove Row" => "Elimina Fila",
"Remove Column" => "Elimina Columna",
"Merge Cells" => "Fusiona Cel·les",
"Restore Cells" => "Restaura Cel·les",
"Copy Calculation" => "Copia càlcul",
"Format Cell" => "Formata Cel·la",
"Before" => "Abans de",
"After" => "Després de",
"expires:" => "expira:",
"Add an article" => "Afegeix un article",
"Banner stats" => "Pancarta: estadístiques",
"Create new banner" => "Crea un nou banner",
"Banner Information" => "Informació de la Pancarta",
"Click ratio" => "Taxa de clicks",
"Weekdays" => "Dies de la setmana",
"mon" => "dl",
"tue" => "dm",
"wed" => "dc",
"thu" => "dj",
"fri" => "dv",
"sat" => "ds",
"sun" => "dg",
"Banner raw data" => "Dades en brut del bànner",
"Cached" => "Carregat en memòria cau",
"This is a cached version of the page." => "Aquesta és una versió en memòria cau de la pàgina",
"Click here to view the Google cache of the page instead." => "Cliqueu aquí per veure la memòria cau Google de la pàgina.",
"Edit Items" => "Edita items",
"List Charts" => "Llista de gràfiques",
"Last Chart" => "Darrera llista",
"Previous Chart" => "Chart anterior",
"Chart created" => "Gràfic creada",
"Next Chart" => "Diagrama següent",
"Permanency" => "Permanència",
"chg" => "canvi",
"Avg" => "Mtj",
"info/vote" => "info/vot",
"Next chart will be generated on" => "El proper chart es generarà a",
"View or vote items not listed in the chart" => "Visualitza o vota ítems no listats en el gràfic",
"Select something to vote on" => "Selecionar quelcom per votar",
"Item information" => "informació de l'Ítem",
"Best Position" => "Millor Posició",
"Vote this item" => "Vota aquest ítem",
"Highest" => "El més alt",
"Answers" => "Respostes",
"Add Suggestion" => "Afegeix un suggeriment",
"Forum List" => "Llista de fòrums",
"Edit Forum" => "Editar fòrum",
"Monitor Topics of this Forum" => "Vigila els Tòpics d'aquest Fòrum",
"Stop Monitoring Topics of this Forum" => "Deixa de vigilar els Tòpics d'aquest Fòrum",
"Monitor Topics and Threads of this Forum" => "Vigila Tòpics i respostes d'aquest fòrum",
"Stop Monitoring Topics and Threads of this Forum" => "Deixa de vigilar Tòpics i respostes d'aquest fòrum",
"Editing" => "Editant",
"Post New" => "Publica un nou",
"Summary" => "Resum",
"Watch for replies" => "Vigila per correu-e les respostes",
"Send me an e-mail when someone replies to my topic" => "Envia'm un missatge de correu-e quan algú respongui al meu tòpic",
"Don't send me any e-mails" => "No m'enviïs missatges de correu-e",
"Editing posts" => "Editant publicacions",
"Moderator Actions" => "Accions del moderador",
"Move Selected Topics" => "Moure temes seleccionats",
"Unlock Selected Topics" => "Desbloqueja tòpics seleccionats",
"Lock Selected Topics" => "Bloqueja temes escollits",
"Delete Selected Topics" => "Esborrar temes seleccionats",
"Merge" => "Escapçar",
"Merge Selected Topics" => "Escapçar els temes escollits",
"Reported Messages:" => "Missatges reportats:",
"Queued Messages:" => "Missatges a la cua:",
"Merge into topic" => "Encabir dins el tema",
"Announce" => "Anunci",
"Hot" => "Calent",
"Unarchive" => "Desarxiva",
"No topics yet" => "Encara no hi ha cap tema",
"posts in this forum" => "publicacions en aquest fòrum",
"Jump to forum" => "Saltar al fòrum",
"Last hour" => "La última hora",
"Last 24 hours" => "Les últimes 24 hores",
"Last 48 hours" => "Les últimes 48 hores",
"Show archived posts" => "Mostra publicacions arxivades",
"Archived" => "Arxivada/des",
"The post has been reported and will be reviewed by a moderator." => "S'ha informat de la publicació i serà revisada per un moderador.",
"prev topic" => "tòpic ant",
"next topic" => "tema següent",
"Print this page only" => "Imprimeix només aquesta pàgina",
"Print all pages" => "Imprimeix totes les pàgines",
"Show posts" => "Mostrar publicacions",
"Stop Monitor" => "Deixa de vigilar per correu-e",
"Insert New Item" => "Inserta un nou ítem",
"Edit Fields" => "Edita els camps",
"Tracker Items" => "Punts del formulari",
"View inserted item" => "Mostra el registre insertat",
"Insert new item" => "Inserta un nou ítem",
"Tracker Item:" => "Registre del formulari:",
"View Item" => "Visualitza punt",
"Filter Tracker Items" => "Filtra registres del formulari",
"Add a Comment" => "Afegeix un comentari",
"Items list" => "Llista d'ítems",
"Special Operations" => "Operacions especials",
"close" => "tanca",
"Show All" => "Mostrar Tot",
"Clip" => "clip",
"Back To Mailbox" => "torna a bustia de correu",
"Full Headers" => "capçaleres senceres",
"Normal Headers" => "capçaleres normals",
"Reply To All" => "respon a tots",
"Forward" => "reenvia",
"Select from address book" => "selecciona del llibre d'adreces",
"Use HTML mail" => "Empra correu HTML",
"The following addresses are not in your address book" => "La següent adreça no es troba en el teu llibre d'adreces",
"Add Contacts" => "Afegeix contactes",
"Attachment 1" => "Afegit 1",
"Attachment 2" => "Afegit 2",
"Attachment 3" => "Afegit 3",
"Address book" => "Llibre d'adreces",
"page id" => "id de pàgina",
"3d browser" => "navegador 3d",
"Jump to Content" => "Salta al Contingut",
"Cancel Fullscreen" => "Cancel·la Pantalla Sencera",
"Show/Hide Left Menus" => "Mostra/Amaga Menús de l'esquerra",
"Show/Hide Right Menus" => "Mostra/Amaga Menús de la dreta",
"Remove Image" => "Elimina imatge",
"Other:" => "Altre/a:",
"Number of voices" => "Nombre de veus",
"You have ever subscribed" => "Ja t'havies subscrit abans",
"You have not yet subscribed" => "Encara no t'has subscrit",
"friends" => "amics",
"Unsubscribe" => "De-subscriu-me",
"Use this thread to discuss the page:" => "Utilitza aquest fòrum per parlar de la pàgina:",
"list" => "llista",
"Subscribe to a group" => "Subscriu-te a un grup",
"Toggle display" => "Intercanvia com es mostra",
"Start:" => "Inici:",
"Close:" => "Tanca:",
"Preview your changes." => "Previsualitza els teus canvis.",
"Save the page as a partial translation." => "Desa la pàgina com a traducció parcial.",
"Partial Translation" => "Traducció Parcial",
"Save the page as a completed translation." => "Desa la pàgina com a traducció completa.",
"Complete Translation" => "Traducció Completa",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Desa la pàgina, però no enviïs notificacions <br/>i no ho comptis com a nou contingut<br/> per ser traduït",
"Save Minor Edit" => "Edició Menor",
"Save the page." => "Desa la pàgina.",
"Save the page as a draft." => "Desa la pàgina com a esborrany.",
"Save Draft" => "Desa esborrany",
"Cancel the edit, you will lose your changes." => "Cancel·la l'edició, perdràs els teus canvis.",
"Compose Message" => "Escriu un Missatge",
"If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>" => "Si voleu que la gent pugui contestar-vos heu de comprovar <a href='tiki-user_preferences.php'>Permetre missatges d'altres usuaris</a>",
"Separate multiple usernames with a comma (&nbsp;,&nbsp;)." => "Separa múltiples noms d'usuaris amb una coma (&nbsp;,&nbsp;).",
"Permission denied you cannot view the Tiki calendar" => "Permís denegat, no pots veure el calendari del Tiki",
"Administration" => "Administració",
"Enable/disable Tiki features here, but configure them elsewhere" => "Habilita/deshabilita funcionalitats de Tiki aquí, però configura-les en un altre lloc",
"General preferences and settings" => "Preferències i característiques generals",
"User registration, login and authentication" => "Registre d'usuaris, connexió i autenticació",
"Wiki settings" => "Configuració del Wiki",
"Wiki Attachments" => "Adjunts al Wiki",
"Article/CMS settings" => "Paràmetres per als Articles/CMS",
"Poll comments settings" => "Configuració dels comentaris de vots",
"Configuration options for all blogs on your site" => "Opcions de configuració per a totes les bitàcoles en el teu lloc",
"Forums settings" => "Configuració de fòrums",
"FAQ comments settings" => "Paràmetres dels comentaris de les PUF",
"Trackers settings" => "Paràmetres dels formularis",
"RSS feeds" => "Alimentació per RSS",
"RSS settings" => "Paràmetres de les Alimentacions per RSS",
"Directory settings" => "Paràmetres del Directori (d'enllaços)",
"Maps configuration" => "Configuració dels Mapes",
"Meta Tags settings" => "Paràmetres de les Meta Etiquetes",
"Search settings" => "Paràmetres de cerca",
"Score settings" => "Paràmetres del sistema de Puntuació",
"Community settings" => "Paràmetres de la Comunitat",
"Calendar settings" => "Paràmetres del Calendari",
"Intertiki settings" => "Paràmetres de l'Intertiki",
"Freetags settings" => "Configuració de les Etiquetes Lliures",
"Help on \$admintitle Config" => "Ajuda sobre la configuració de \$admintitle ",
"Current version is up to date : <b>%s</b>" => "La versió actual és la més actualitzada : <b>%s</b>",
"You can not create a category with a name already existing at this level" => "No es pot crear una categoria amb un nom que ja existeix en aquest nivell",
"The file does not have the required header:" => "L'arxiu no té l'encapçalamet requerit:",
"Category can`t be parent of itself" => "La categoria no pot ser mare de si mateixa",
"No chart indicated" => "No s'ha indicat cap chart",
"Upload failed" => "Ha fallat la pujada",
"You have to provide a hotword and a URL" => "Has de proveïr una paraula calenta i una URL",
"moved %d images, %d errors occured." => "mogudes: %d imatges; han ocorregut %d errors.",
"a timeout occured. Hit the reload button to move the rest" => "ha ocorregut una desconnexió. Prem el botó Actualitza per moure la resta",
"Detected, Version:" => "Detectat/da, Versió:",
"Not detected." => "No detectat/da.",
"Your admin password has been changed" => "La teva contrasenya d'admin ha estat canviada",
"You cannot have a blank password" => "No pots deixar la contrasenya en blanc",
"All Fields except gdaltindex must be filled" => "Tots els camps excepte gdaltindex han de ser omplerts",
"No valid gdaltindex executable" => "No hi ha cap gdaltindex vàlid executable",
"You cannot mix old and new trackers" => "No pots barrejar formularis vells i nous",
"Tag already exists" => "El marcador ja existeix",
"Tag not found" => "No s'ha trobat el marcador",
"Repository name can't be an empty" => "El nom de dipòsit no pot quedar buit",
"Requested action is not supported on repository" => "L'acció demanada no és suportada al dipòsit",
"No repository" => "Cap dipòsit",
"Search is mandatory field" => "Buscar es camp obligatori",
"File not found " => "No s'ha trobat el fitxer ",
"Requested action in not supported on repository" => "L'acció demanada no és suportada al dipòsit",
"Non-existent link" => "Aquest enllaç no existeix",
"Mail-in account %s incorrect" => "Compte %s de Correu-dins incorrecta",
"Mail-in account %s saved" => "Compte %s de Correu-dins desada",
"Frequency should be a positive integer!" => "la Freqüència hauria de ser un integrador positiu",
"Mail-in accounts set to be checked every %s minutes" => "S'ha especificat que es comprovin cada %s minuts els comptes de Correu-dins",
"Automatic Mail-in accounts checking disabled" => "Està desactivada la comprovació de comptes correu-dins automàtica",
"No menu indicated" => "No s'indica cap menú",
"Cannot create or update module: You need to specify a name to the module" => "No es pot crear o actualitzar el mòdul: cal especificar el nom del mòdul",
"Cannot create or update module: You cannot leave the data field empty" => "No es pot crear o actualitzar el mòdul: no es pot deixar buit el camp data",
"No newsletter indicated" => "No s'ha indicat cap butlletí",
"You need to provide a username or an email" => "Ha d'indicar un nom d'usuari o un correu-e",
"No poll indicated" => "No s'indica cap votació",
"unsafe" => "insegur",
"register_globals should be off by default. See the php manual for details." => "el paràmetre register_globals hauria d'estar com a desactivat (off) per defecte. Mira el manual de php per més detalls.",
"safe" => "segur",
"session.use_trans_sid should be off by default. See the php manual for details." => "el paràmetre session.use_trans_sid hauria d'estar com a desactivat (off) per defecte. Mira el manual de php per més detalls.",
"upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "Probablement upload_tmp_dir és al teu directori Tikiwiki. Hi ha el risc que algú pugui carregar un arxiu qualsevol en aquest directori i accedir-hi a través d'un navegador web",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "no es pot comprovar si el upload_tmp_dir és accessible a través d'un navegador web. Per assegurar-te'n has de comprovar la configuració del teu servidor web.",
"setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "especificar la opció xbithack és insegur. Depenent de la gestió d'arxius del teu servidor web i de la configuració del teu tiki, un atacant podria pujar arxius de seqüències de comandes a la galeria d'arxius i executar-los",
"risky" => "arriscat",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "el paràmetre allow_url_fopen podria ser emprat per carregar dades remotes o arxius de seqüències d'instruccions. Si no utilitzes la funcionalitat bitàcola, la pots desactivar.",
"The Path to store files in the filegallery should be outside the tiki root directory" => "El camí per emmagatzemar arxius a la galeria d'arxius ha d'estar fora del directori arrel de tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "El camí per emmagatzemar arxius a la galeria d'imatges ha d'estar fora del directori arrel de tiki",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "La funcionalitat \"Edita Plantilles\" està activada. No permetis emprar aquesta funcionalitat a ningú amb qui no confiïs. Pot ser emprada fàcilment per injectar codi php.",
"Path disclosure" => "Desglossament del camí",
"Path disclosure through error message" => "Desglossament del camí mitjançant un missatge d'error",
"SQL injection" => "Injecció SQL",
"SQL injection by authenticated user" => "Injecció SQL per un usuari autenticat",
"SQL injection by authenticated user with special privileges" => "Injecció SQL per un usuari autenticat amb privilegis especials",
"SQL injection without authentication" => "Injecció SQL sense autenticació",
"PHP command injection" => "Injecció de comanda PHP",
"PHP command injection by authenticated user" => "Injecció de comanda PHP per usuari autenticat",
"PHP command injection by authenticated user with special privileges" => "Injecció de comanda PHP per usuari autenticat amb privilegis especials",
"PHP command injection without authentication" => "Injecció de comanda PHP sense autenticació",
"File upload" => "Arxiu pujat",
"File is not readable. Unable to check." => "L'arxiu no es pot llegir. No es pot comprovar.",
"This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous." => "Aquest no és un arxiu de Tikiwiki. Comproveu si aquest arxiu ha estat pujat i si és perillós.",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Aquest és un arxiu modificat. No es pot comprovar la versió. Comprova si és perillós.",
"This file is from another Tikiwiki version: " => "Aquest arxiu és d'una altra versió de Tikiwiki: ",
"You have to provide a word" => "Cal que poseu una paraula",
"Permission denied you cannot view this page" => "No tens autorització per veure aquesta pàgina",
"Permission denied you cannot edit this page" => "No teniu autorització per a editar aquesta pàgina",
"You must specify a page name, it will be created if it doesn't exist." => "Has d'especificar un nom de pàgina, serà creada si no existeix.",
"page not added (Exists)" => "pàgina no afegida (ja existeix)",
"No survey indicated" => "No s'ha indicat cap enquesta",
"You don't have permission to use this feature" => "No tens permís per emprar aquesta funcionalitat",
"No Errors detected" => "No s'ha detectat cap error",
"No tracker indicated" => "No s'ha indicat cap formulari",
"Group already exists" => "Aquest grup ja existeix",
"User doesn't exist" => "Aquest usuari no existeix",
"Invalid or unknown email" => "Correu-e invàlid o desconegut",
"No records were found. Check the file please!" => "No s'ha trobat cap registre. Revisa el fitxer si us plau!",
"User login or email is required" => "És necessari un nom o correu-e de l'usuari",
"User login is required" => "Es requereix l'entrada de l'usuari/a",
"Password is required" => "Contrasenya requerida",
"Email is required" => "correu-e requerit",
"User is duplicated" => "Usuari/a duplicat/da",
"Created account %s <%s>" => "S'ha creat el compte %s <%s>",
"Assigned %s in group %s" => "Assignat %s al grup %s",
"User %s already exists" => "L'usuari %s ja existeix",
"User login contains invalid characters" => "El nom d'usuari per connectar-te conté caràcters invàlids",
"New %s created with %s %s." => "Nou/va %s creat/a amb %s %s.",
"Impossible to create new %s with %s %s." => "No ha estat possible de crear cap nou/va %s amb %s %s.",
"%s %s successfully deleted." => "%s %s s'ha eliminat amb èxit.",
"%s %s removed from %s %s." => "%s %s eliminat de %s %s.",
"%s <b>%s</b> successfully deleted." => "%s <b>%s</b> s'ha eliminat amb èxit.",
"%s <b>%s</b> assigned to %s <b>%s</b>." => "%s <b>%s</b> assignat a %s <b>%s</b>.",
"%s <b>%s</b> removed from %s <b>%s</b>." => "%s <b>%s</b> eliminat de %s <b>%s</b>.",
"group <b>%s</b> set as the default group of user <b>%s</b>." => "grup <b>%s</b> establert com a grup per defecte de l'usuari <b>%s</b>.",
"Login contains invalid characters" => "El nom per la connexió conté caràcters invàlids",
"%s changed from %s to %s" => "%s canviat de %s a %s",
"Impossible to change %s from %s to %s" => "Impossible canviar %s de %s a %s",
"%s modified successfully." => "%s s'ha modificat amb èxit.",
"password" => "contrasenya",
"%s modification failed." => "la modificació de %s ha fallat.",
"This function is only for staging pages" => "Aquesta funció és només per pàgines per revisar",
"Permission denied you cannot approve staging pages" => "Permís denegat: no pots aprovar planes pendents de revisió",
"Approved page was last saved after most recent staging edit" => "La pàgina aprovada va ser gravada després de l'edició per revisar més recent",
"rss feed disabled" => "alimentació rss desactivada",
"Tiki RSS feed for articles" => "Alimentació RSS del Tiki per a articles",
"Last articles." => "Els últims articles.",
"Unknown group" => "Grup desconegut",
"Group doesn't exist" => "Aquest grup no existeix",
"You have to indicate a group" => "Cal indicar un grup",
"This group is invalid" => "Aquest grup és invàlid",
"Permission denied you cannot view backlinks for this page" => "No estàs autoritzat a veure els retroenllaços d'aquesta pàgina",
"The page cannot be found" => "No s'ha pogut trobar la pàgina",
"Image Galleries Admin Panel" => "Panell d'administració de les galeries d'imatges",
"Could not read image %s." => "No es pot llegir la imatge %s.",
"Image %s upload failed." => "La pujada de la imatge %s ha fallat.",
"Image %s uploaded successfully." => "La imatge %s ha pujat correctament.",
"Image %s removed from Batch directory." => "La imatge %s ha estat eliminada del directori de lots.",
"Impossible to remove image %s from Batch directory." => "És impossible eliminar la imatge %s del directori de lots.",
"Permission denied you cannot use the batch directory loading" => "Permís denegat, no pots utilitzar la càrrega de directoris",
"Incorrect directory chosen for batch upload of images." => "S'ha escollit un directori incorrecte per a la càrrega de lots d'imatges.",
"Please setup that dir on " => "Si us plau, configureu aquest directori a ",
"Please contact the website administrator." => "Si us plau, contacta l'administrador de lloc web.",
"Invalid directory name" => "Nom de directori Invàlid",
"Could not read file %s." => "No s'ha pogut llegir l'arxiu %s.",
"Could not write to file %s." => "No s'ha pogut escriure a l'arxiu %s.",
"File %s upload failed." => "No s'ha pogut pujar l'arxiu %s.",
"Upload was successful" => "Pujada amb èxit",
"You can't post in any blog maybe you have to create a blog first" => "No podeu publicar sense crear primer una bitàcola",
"Permission denied you cannot post" => "Permís denegat per publicar",
"Permission denied you cannot edit this post" => "Permís denegat per editar aquesta publicació",
"Top visited blogs" => "Les bitàcoles més visitades",
"Last posts" => "Darrers enviaments",
"Top active blogs" => "Les bitàcoles més actives",
"Tiki RSS feed for blog: " => "Alimentació RSS del Tiki per a la bitàcola: ",
"No blogId specified" => "No s'ha especificat cap bitàcola",
"Tiki RSS feed for weblogs" => "Alimentació RSS del Tiki per a bitàcoles web",
"Last posts to weblogs." => "Darrers enviaments a les bitàcoles.",
"TOP" => "MÉS ACTIUS/VES",
"Nothing tagged yet" => "No hi ha res etiquetat encara",
"You must clear your browser cache." => "Has d'esborrar la memòria cau (cache) del teu navegador.",
"Permission denied you cannot access this gallery" => "No estàs autoritzat/da a accedir a aquesta galeria",
"No gallery indicated" => "No s'ha indicat cap galeria",
"Permission denied you can not view this section" => "Permís denegat, no podeu veure aquesta secció",
"Permission denied you cannot remove images from this gallery" => "No tens autorització per suprimir imatges d'aquesta galeria",
"Permission denied you cannot rebuild thumbnails in this gallery" => "Permís denegat, no podeu refer miniatures en aquesta galeria",
"Permission denied you cannot rotate images in this gallery" => "Permís denegat, no podeu rotar les imatges d'aquesta galeria",
"No image indicated" => "No s'ha indicat cap imatge",
"Permission denied you cannot move images from this gallery" => "No estàs autoritzat/da a moure imatges d'aquesta galeria",
"Permission denied you cannot view the calendar" => "Permís denegat, no podeu veure el calendari",
"event without name" => "Event sense nom",
"Permission denied you can not view this page" => "Permís denegat: no pots veure aquesta pàgina",
"Access Denied" => "Accés Denegat",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "1",
"Mo" => "Dl",
"Tu" => "Dt",
"We" => "Dc",
"Th" => "Dj",
"Fr" => "Dv",
"Sa" => "Ds",
"Su" => "Du",
"Tiki RSS feed for calendars" => "Alimentacions RSS de Tiki per als calendariss",
"Upcoming events." => "Propers aconteixements.",
"End:" => "Final:",
"No category indicated" => "Cap categoria indicada",
"Permission denied; you cannot assign permissions for this category" => "Permís denegat; no teniu assignats permisos per aquesta categoria",
"Invalid username or activation code. Maybe this code has already been used." => "Nom d'usuari o codi d'activació invàlids. Potser ja s'ha fet servir aquest codi d'activació.",
"You can not use the same password again" => "No pots emprar la mateixa contrasenya de nou",
"Top authors" => "Els autors més actius",
"Account validated successfully." => "Compte validat satisfactòriament.",
"Problem. Try to log in again to receive new confirmation instructions." => "Problema. Prova de connectar-te de nou per rebre noves intruccions de confirmació.",
"ERROR: you must include a subject or a message at least" => "ERROR: has de incloure un títol o un missatge almenys",
"You need to change chmod 'whelp' manually to 777" => "Necessites canviar via chmod 'whelp' manualment a 777",
"This feature has been disabled" => "Aquesta secció ha estat deshabilitada",
"Tiki RSS feed for directory sites" => "Alimentació RSS del Tiki per a llocs del directori",
"Last sites." => "Darreres webs.",
"Must enter a name to add a site. " => "Has d'afegir un nom per afegir un nou lloc. ",
"Must enter a url to add a site. " => "Has d'afegir una url per afegir un nou lloc. ",
"URL already added to the directory. Duplicate site? " => "L'URL ja ha estat afegida al directori. Lloc duplicat? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "No es pot accedir a l'URL (URL errònia or el lloc està fora de línea i no pot ser afegit al directori). ",
"Must select a category. " => "Has de seleccionar una categoria. ",
"Must enter a name to add a site" => "Has d'escriure un nom per a la web a afegir",
"Must enter a url to add a site" => "Has d'escriure una dreça URL per a afegir una web",
"URL already added to the directory. Duplicate site?" => "L'URL ja ha estat afegida al directori. Lloc duplicat?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "No es pot accedir a l'URL (URL errònia or el lloc està fora de línea i no pot ser afegit al directori)",
"Must select a category" => "Has d'escollir una categoria",
"No site indicated" => "No s'ha indicat cap lloc",
"No parent specified" => "No s'ha especificat cap pare",
"Last sites of directory \".\$rc[\"name\"].\" ." => "Darreres webs del directori \".\$rc[\"name\"].\" .",
"Error : The file %s doesn't exist." => "Error: El fitxer %s no existeix.",
"Invalid email:" => "Correu Invàlid:",
"Article not found" => "Article no trobat",
"Permission denied you cannot edit this article" => "No té permís per editar l'article",
"The language can't be changed as its set of translations has already this language" => "No es pot canviar a aquest idioma per que el conjunt de traduccions ja té aquest idioma",
"You do not have permissions to edit banners" => "No teniu permís per editar banners",
"Banner not found" => "No s'ha trobat banner",
"You do not have permission to edit this banner" => "No teniu permís per editar aquest banner",
"Permission denied you cannot create or edit blogs" => "Permís denegat per crear o editar bitàcoles",
"Permission denied you cannot edit this blog" => "Permís denegat per editar aquesta bitàcola",
"You do not have permission to write the style sheet" => "No teniu permís per escriure al full d'estil",
"Invalid request to edit an image" => "La petició per editar la imatge no és vàlida",
"Permission denied you cannot edit images" => "No tens autorització per editar imatges",
"Permission denied you can edit images but not in this gallery" => "No estàs autoritzat per editar imatges en aquesta galeria",
"Failed to edit the image" => "s'ha produït un error en editar la imatge",
"Permission denied to use this feature" => "Permís denegat per accedir a aquesta secció",
"Shortname must be 2 Characters" => "Nom curt (2 caràcters)",
"You must provide a longname" => "Has de proporcionar un nom llarg",
"Language created" => "Idioma creat",
"No content id indicated" => "Cap id de contingut especificat",
"No question indicated" => "No s'ha indicat cap pregunta",
"No quiz indicated" => "No has indicat cap test",
"No structure indicated" => "No s'ha indicat cap estructura",
"Invalid structure_id or page_ref_id" => "Estructura Invàlida o referència invàlida",
"Permission denied you cannot send submissions" => "Permís denegat per enviar col·laboracions",
"Permission denied you cannot edit submissions" => "Permís denegat per editar col·laboracions",
"You have to create a topic first" => "Has de crear un tòpic primer",
"You do not have permission to do that" => "No teniu permís per fer això",
"You do not have permission to write the template:" => "No teniu permís per escriure la plantilla:",
"You do not have permission to read the template" => "No teniu permís per llegir la plantilla",
"No topic id specified" => "No s'ha especificat cap id de tema",
"Invalid topic id specified" => "Tema Invàlid",
"Translation in progress." => "Traducció en curs.",
"No object indicated" => "No s'ha indicat cap objecte",
"Page is a staging copy. Translation must begin from the approved copy." => "La pàgina és una còpia per revisar. La traducció ha de començar des de la còpia aprovada.",
"No type indicated" => "No s'ha indicat cap tipus",
"Override lock and carry on with edit" => "Ignora el bloqueig i continua per editar",
"Page is currently being edited" => "La pàgina està essent editada en aquest moment",
"page imported" => "pàgina importada",
"created from import" => "creada des de l'importació",
"This page is being edited by " => "Aquesta pàgina està essent editada per ",
"Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Si us plau, comprova amb l'usuari abans de d'editar la pàgina,\n\t\t\td'altra forma es guardaran els canvis en dues versions separades a l'historial i\n\t\t\thaureu de fusionar-los manualment després. ",
"Can't import remote HTML page" => "No es pot importar la pàgina HTML remota",
"The SandBox is disabled" => "El LlocdeProves està deshabilitat",
"Cannot edit page because it is locked" => "No es pot editar la pàgina perquè està bloquejada",
"Page already exists. Go back and choose a different name." => "La pàgina ja existeix. Ves enrere i escull un nom diferent.",
"The translation set already contains a page in this language." => "El conjunt de traducció ja conté una pàgina en aquest idioma.",
"No questions group indicated" => "No s'ha indicat cap grup de preguntes",
"Permission denied you cannot edit this file" => "Permís denegat, no podeu editar aquest fitxer",
"Permission denied you cannot remove files from this gallery" => "Permís denegat, no podeu eliminar arxius dóaquesta galeria",
"Top visited file galleries" => "Les galeries de fitxers més visitades",
"Most downloaded files" => "Arxius més descarregats",
"Last files" => "Els últims fitxers",
"Tiki RSS feed for file galleries" => "Alimentació RSS del Tiki per a galeries de fitxers",
"Last files uploaded to the file galleries." => "Darrers arxius pujats a les galeries d'arxius.",
"No galleryId specified" => "No s'ha especificat el galleryId",
"Tiki RSS feed for the file gallery: " => "Alimentació RSS del Tiki per a la galeria de fitxers: ",
"Form error - no import method selected for some reason." => "Error de formulari html - no s'ha seleccionat cap mètode d'importació per alguna raó.",
"Form error - no server-side filename entered for selected import method." => "Error de formulari html - no s'ha introduït cap nom d'arxiu al costat del servidor per al mètode d'importaicó seleccionat.",
"No forum indicated" => "No s'ha indicat cap fòrum",
"Forum posts" => "Escrits del Fòrum",
"No forumId specified" => "No s'ha especificat el fòrumId",
"Tiki RSS feed for forum: " => "Alimentació RSS del Tiki per al fòrum: ",
"Tiki RSS feed for forums" => "Alimentació RSS del Tiki per a fòrums",
"Last topics in forums." => "Darrers Temes als fòrums.",
"Accepted friendship request from %s" => "Petició d'inclusió a la xarxa d'amistat de %s acceptada",
"Refused friendship request from %s" => "Petició d'inclusió a la xarxa d'amistat de %s rebutjada",
"Broke friendship with %s" => "Elimina de la teva xarxa d'amistat a %s",
"I have broken our friendship!" => "He trencat la teva inclusió a la meva xarxa d'amistat en aquesta web!",
"You must be logged in to use this feature" => "Has d'estar connectat per emprar aquesta funcionalitat",
"Friendship request sent to %s" => "Petició d'inclusió a la seva xarxa d'amistat enviada a %s",
"You're already friend of %s" => "Ja ets amic/ga de %s",
"I have accepted your friendship request!" => "He acceptat la teva petició d'inclusió a la meva xarxa d'amistat!",
"No process indicated" => "No s'ha indicat cap procés",
"Role name cannot be empty" => "El nom del rol no pot quedar buit",
"Activity name cannot be empty" => "El nom de l'activitat no pot quedar buit",
"Activity name already exists" => "El nom de l'activitat ja existeix",
"indicates if the process is active. Invalid processes cant be active" => "Indica si el procès és actiu. Els processos invàlids no poden ser activats",
"No instance indicated" => "No s'ha indicat cap instància",
"No activity indicated" => "No s'ha indicat cap activitat",
"The process name already exists" => "El nom del procés ja existeix",
"Process already exists" => "El procés ja existeix",
"Invalid source path" => "Ruta d'origen invàlida",
"A start activity requires a name for the instance" => "L'inici de l'activitat requereix un nom per a la instància",
"You cant execute this activity" => "No pots realitzar aquesta activitat",
"You couldn't abort a instance" => "No podeu abortar una instància",
"You couldn't exception a instance" => "No pots exceptuar una instància",
"No user indicated" => "No s'ha indicat usuari",
"No title indicated" => "No s'ha indicat cap títol",
"No comment indicated" => "No s'ha indicat cap comentari",
"No date indicated" => "No s'ha indicat cap data",
"No item indicated" => "No s'ha indicat cap punt",
"first uploaded image" => "primera imatge pujada",
"last uploaded image" => "última imatge pujada",
"first image" => "primera imatge",
"last image" => "La última imatge",
"random image" => "imatge aleatòria",
"Permission denied you cannot create galleries and so you cant edit them" => "Permís denegat, no podeu crear galeries ni editar-les",
"Permission denied you cannot edit this gallery" => "Permís denegat, no podeu editar aquesta galeria",
"Permission denied you cannot remove this gallery" => "Permís denagat, no podeu eliminar aquesta galeria",
"Permission denied you cannot make the map of this gallery" => "Permís denegat, no pots fer el mapa d'aquesta galeria",
"Top images" => "Les imatges més emprades",
"Last images" => "Les últimes imatges",
"Back to preferences" => "Torna a preferències",
"No valid renderer found. GD or PDFLib required." => "No s'ha trobat un renderitzador vàlid. Es requereix un GD o PDFLib.",
"No sheet specified." => "No s'ha especificat cap full.",
"You must select a renderer." => "Has de seleccionar un renderitzador.",
"Invalid Series for current graphic." => "Sèrie no vàlida per al gràfic actual.",
"Tiki RSS feed for image galleries" => "Alimentació RSS del Tiki per a galeries d'imatges",
"Last images uploaded to the image galleries." => "darreres imatges pujades a les galeries d'imatges.",
"Tiki RSS feed for the image gallery: " => "Alimentació RSS del Tiki per a la galeria d'imatges: ",
"overwriting old page" => "Reescriure la pàgina antiga",
"updated from structured text import" => "actualitzat amb la importació de text estructurada",
"page created" => "pàgina creada",
"created from structured text import" => "creat a partir de la importació de text estructurat",
"No name indicated for wiki page" => "No s'ha indicat cap nom per la pàgina wiki",
"No repository given" => "Cap dipòsit indicat",
"Permission denied you cannot view pages like this page" => "No tens autorització per veure pàgines com aquesta",
"Permission denied you cannot remove articles" => "No té permís per eliminar l'article",
"Permission denied you cannot remove banners" => "No té autorització per eliminar banners",
"Permission denied you cannot remove this blog" => "Permís denegat per traslladar aquesta bitàcola",
"Non-existent gallery" => "Aquesta galeria no existeix",
"Permission denied you can upload files but not to this file gallery" => "Premís denegat, no podeu pujar fitxers a aquesta galeria",
"Could not upload the file" => "No pot pujar l'arxiu",
"Could not find the file requested" => "L'arxiu demanat no es troba",
"Upload was not successful. Duplicate file content" => "La pujada ha fallat. Duplica el contingut de l'arxiu",
"File update was successful" => "L'actualització de l'arxiu ha tingut èxit",
"Permission denied you can't upload files so you can't edit them" => "Permís denegat, no podeu pujar fitxers i per tant no podeu editar-los",
"This gallery does not exist" => "Aquesta galeria no existeix",
"The game file must have .swf or .dcr extension" => "El fitxer del joc ha de tenir l'extenció .swf o .dcr",
"The thumbnail name must be" => "El nom de la miniatura ha de ser...",
"Please supply both files" => "Aporta els dos arxius, si us plau",
"You cannot admin blogs" => "No té permís per administrar bitàcoles",
"Permission denied you cannot remove submissions" => "Permís denegat per eliminar col·laboracions",
"Permission denied you cannot approve submissions" => "Permís denegat per aprovar col·laboracions",
"You have to enable cookies to be able to login to this site" => "Has d'habilitar les galetes 'cookies' per que puguis entrar en aquest lloc",
"Unable to contact remote server." => "No es pot contactar amb el servidor remot.",
"XMLRPC Error: " => "Error XMLRPC: ",
"Unable to create login" => "Incapaç de crear el compte (login)",
"More than %d unsuccessful login attempts have been made." => "S'han produït més de %d intents de connexió sense èxit.",
"An email has been sent to you with the instructions to follow." => "Se t'ha enviat un correu-e amb instruccions a seguir.",
"Your default nickname is already in use. A new one has to be selected." => "El teu nom d'usuari per defecte ja està en ús. Has d'escollir-ne un altre.",
"The selected account is not associated with your identity." => "El compte seleccionat no està associat amb la teva identitat.",
"unknown action" => "acció no coneguda",
"Authentication method is not OpenID" => "El mètode d'autenticació no és OpenID",
"Invalid password" => "Contrasenya invàlida",
"Account disabled" => "Compte desactivat",
"You must use the right case for your user name" => "Has d'emprar exactament les majúscules i minúscules del teu nom d'usuari",
"Tiki mail-in auto-reply" => "Autoresposta de correu-dins del Tiki",
"Sorry, you can't use this feature." => "Disculpa, no pots fer servir aquesta funcionalitat.",
"edit" => "editar",
"You do not have permissions to view the maps" => "No tens permís per veure els mapes",
"Maps feature is not correctly setup : Maps path is missing." => "L'opció de mapes no està correctament configurada: la ruta dels Mapes falta.",
"mapfile name incorrect" => "Nom de mapfile incorrecte",
"This mapfile already exists" => "Aquest fitxer de mapa ja existeix",
"You do not have permission to write to the mapfile" => "No tens permisos per escriure en el fitxer de mapes",
"You do not have permission to delete the mapfile" => "No tens permisos per esborrar el fitxer de mapes",
"I could not make a copy" => "No es pot fer una copia",
"You do not have permission to read the mapfile" => "No tens permisos per llegir el fitxer de mapes",
"You dont have permission to do that" => "No tens permís per fer això",
"Tiki RSS feed for maps" => "Alimentació RSS del Tiki per als mapes",
"List of maps available." => "Llista de mapes existents.",
"You do not have permissions to view the layers" => "No tens permís per veure les capes",
"You do not have permissions to delete a file" => "No tens permís per esborrar un fitxer",
"File not found" => "No s'ha trobat el fitxer",
"You do not have permissions to create a directory" => "No tens permís per crear un directori",
"The Directory is not empty" => "El directori no està buit",
"You do not have permissions to delete a directory" => "No tens permís per esborrar un directori",
"You do not have permissions to create an index file" => "No tens permís per crear un fitxer d'índex",
"Invalid file name" => "Nom d'arxiu Invàlid",
"Invalid files to index" => "Invàlids arxius a indexar",
"I do not know where is gdaltindex. Set correctly the Map feature" => "No sé on està el gdaltindex. Configura correctament el Mapa",
"I could not create the index file" => "No puc crear el fitxer d'index",
"Must be logged to use this feature" => "Has d'haver entrat per a fer servir aquesta prestació",
"Welcome at Hawiki" => "Benvingut/da a Hawiki",
"This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more." => "Aquest lloc Tikiwiki està preparat per l'accés a través de molts aparells mòbils, e.g. telèfons WAP, PDA, aparells i-mode and molts més.",
"You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:" => "Pots navegar pel lloc en el teu aparell mòbil a través de dirigir el navegador del teu aparell a la següent URL d'aquest lloc:",
"About" => "Sobre",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "Has d'executar setup.sh :<br />./setup.sh \$APACHEUSER all<br />Usuaris freqüents de l'Apache són www-data, apache o nobody",
"Your PHP installation does not have zlib enabled." => "La teva instal·lació PHP no té zlib activat.",
"You must log in to use this feature" => "Heu d'estar connecta't per emprar aquesta característica",
"You do not have permission to view other users data" => "No tens permís per veure les dades de les altres persones usuàries",
"You must be logged in to subscribe to newsletters" => "Has d'estar connectat per subscriure't a un butlletí",
"No server indicated" => "No s'ha indicat cap servidor",
"Cannot connect to" => "No es pot connectar a",
"Missing information to read news (server,port,username,password,group) required" => "Falta informació per a llegir les notícies (servidor, port, usuari, contrasenya, grup) requerits/des",
"Cannot get messages" => "No es poden obtenir missatges",
"No note indicated" => "No s'ha indicat cap nota",
"merged note:" => "nota escapçada:",
"File is too big" => "El fitxer es massa gran",
"created from notepad" => "creada des del bloc de notes",
"Page already exists" => "la pàgina ja existeix",
"Not enough information to display this page" => "No hi ha suficient informació per mostrar aquesta pàgina",
"Permission denied you cannot browse this page history" => "No tens autorització per accedir a l'historial d'aquesta pàgina",
"No article indicated" => "No s'indica un article",
"Article is not published yet" => "L'article no ha estat publicat",
"No post indicated" => "No s'ha indicat cap publicació",
"Blog not found" => "No es troba la bitàcola",
"No pages indicated" => "No s'han indicat les planes",
"Pageviews" => "Visualitzacions de planes",
"You don't have permission to edit quizzes." => "No teniu permís per editar qüestionaris.",
"No result indicated" => "No hi ha cap resultat indicat",
"You must choose a group" => "Has d'escollir un grup",
"The passwords don't match" => "Les contrasenyes no coincideixen",
"Username cannot contain uppercase letters" => "El nom d'usuari no pot contenir majúscules",
"Username must be at least" => "El nom d'usuari ha de ser com a mínim de ",
"Username cannot contain more than" => "El nom d'usuari no pot contenir més de ",
"characters" => "caràcters",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Si us plau, introdueix un/a %s vàlid/a. Sense espais, més de %d caràcters i que contingui %s",
"This is not a valid mail adress" => "Aquesta no és un adressa de correu electrònic vàlida",
"mail adress" => "adreça de correu electrònic",
"empty" => "buit",
"Invalid or unknown username" => "El nom de l'usuari es invàlid o desconegut",
"Unable to send mail. User has not configured email" => "No es pot enviar el mail. L'usuari no té el correu electrònic configurat",
"Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password." => "Si us plau, contacta a l'Administrador si no reps el correu-e, o si hi ha algun problema en canviar-te la contrasenya.",
"The mail can't be sent. Contact the administrator" => "El missatge no es pot enviar. Contacta l'administrador",
"A password and your IP address reminder email has been sent " => "S'ha enviat un recordatori de contrasenya i la teva adreça IP d'internet en un correu-e",
"An email with a link to reset your password has been sent " => "S'ha enviat el correu-e amb l'enllaç per canviar la teva contrasenya ",
"to the email" => "al correu-e",
"to the registered email address for" => "a l'adreça de correu-e registrada per a",
"last version" => "última versió",
"Permission denied you cannot remove versions from this page" => "No tens autorització per eliminar versions d'aquesta pàgina",
"You cannot rename staging pages. Please rename the approved page instead." => "No pots reanomenar pàgines per revisar. En el seu lloc, reanomena la pàgina aprovada, si us plau.",
"Permission denied you cannot rename this page" => "Permís denegat, no podeu canviar el nom d'aquesta pàgina",
"Cannot rename page because the new name begins with reserved prefix" => "No es pot reanomenar la pàgina perquè el nom nou comença amb un prefix reservat",
"Cannot rename page maybe new page already exists" => "No es pot reanomenar pàgina, potser la pàgina ja existeix",
"Cannot rename page because maybe new staging page name already exists" => "No pots reanomenar la pàgina per que potser ja existeix aquest nou nom de pàgina per revisar",
"changed '%s' from '%s' to '%s'" => "canviat '%s' de '%s' a '%s'",
"Non-existent version" => "Aquesta versió no existeix",
"Permission denied you cannot rollback this page" => "No tens autorització per restablir una versió anterior d'aquesta pàgina",
"Error Message" => "Missatge d'error",
"Tiki RSS Feed Error Message: \$errmsg" => "Missatge d'error de l'alimentador RSS de Tiki: \$errmsg",
"Post recommendation at" => "Enviar recomanació a",
"No newsletters available." => "No hi ha cap butlletí disponible.",
"successfully sent" => "enviat amb èxit",
"not sent" => "no enviat",
"Notice: invalid variable value:" => "Avís: valor de variable no vàlid:",
"Page must be defined inside a structure to use this feature" => "La Pàgina ha d'estar definida dins una estructura per a fer servir aquesta prestació",
"You cannot take this quiz twice" => "No pots accedir a aquest test dues vegades",
"Quiz time limit exceeded quiz cannot be computed" => "S'ha excedit el temps límit del qüestionari i no pot ser completat",
"You cannot take this survey twice" => "No pots fer aquesta enquesta dues vegades",
"Report to the webmaster" => "Informa al mestre Web",
"Please create a category first" => "Si us plau, primer creeu una categoria",
"Tracker item:" => "Registre del formulari:",
"No trackerId specified" => "No s'ha especificat cap trackerId",
"Tiki RSS feed for individual trackers: " => "Alimentació RSS del Tiki per a formularis individuals: ",
"No permission to upload zipped file packages" => "No hi ha permisos per baixar-se paquets de fitxers enzipats",
"Error processing zipped image package" => "Error al processar la imatge comprimida amb zip",
"No permission to upload zipped image packages" => "No hi ha permisos per pujar paquets d'imatges enzipades",
"The uploaded file ist not recognized as a image" => "El fitxer pujat no és reconegut com a imatge",
"Permission denied you cannot upload images" => "No tens autorització per pujar imatges",
"Permission denied you can upload images but not to this gallery" => "Tens autorització per penjar imatges, malgrat no en aquesta categoria",
"Cannot get image from URL" => "No s'ha pogut aconseguir la imatge des de la URL",
"That is not an image (or you have php < 4.0.5)" => "Això no es una imatge (o be te php < 4.0.5)",
"Usage" => "Ús",
"No url indicated" => "No s'ha indicat cap url",
"Unknown user" => "Usuari desconegut",
"You are not logged in and no user indicated" => "No has entrat al sistema i no has indicat cap usuari",
"The user has chosen to make his information private" => "L'usuari ha escollit convertir la seva informació en privada",
"Password has been changed" => "S'ha canviat la contrasenya",
"Email is set to %s" => "El correu-e ha estat canviar a %s",
"The passwords did not match" => "Les contrasenyes no coincideixen",
"was moved into trash" => "va ser mogut/da a la paperera",
"trashed by" => "llençat a la paperera per",
"open / in process" => "oberta / en procés",
"Rights by creator" => "Drets per creador",
"END" => "FI",
"Percentage" => "Percentatge",
"Task accepted by creator" => "Tasca acceptada pel creador",
"Task accepted by task user" => "Tasca acceptada per l'usuari de la tasca",
"Task NOT accepted by creator" => "Tasca NO acceptada pel creador",
"Task NOT accepted by task user" => "Tasca NO acceptada per l'usuari de la tasca",
"Sorry this task does not exist or you have no rights to view this task" => "Disculpeu, aquesta tasca no existeix o no teniu permís per veure-la",
"Task entries:" => "Entrades de tasques:",
"Changes:" => "Canvis:",
"Info message" => "Missatge d'info",
"NEW Task" => "Tasca NOVA",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Disculpeu, no tens autorització per enviar tasques a altres usuaris o l'usuari no té autorització per rebre'n!",
"Changes on Task" => "Canvis a la tasca",
"You received a new task" => "Heu rebut una tasca nova",
"The priority is" => "La prioritat és",
"very low" => "molt baixa",
"low" => "baixa",
"high" => "alta",
"very high" => "molt alta",
"You've to start your work at least on" => "Heu de començar la vostra feina com a mínim el",
"You've to finish your work on" => "Heu de finalizar la vostra feina el",
"Login and click the link below" => "Connecta't i punxa en l'enllaç de sota",
"Please read the task and work on it!" => "Si us plau, llegiu la tasca i treballeu-hi!",
"Sorry, there was an error while trying to write data into the database" => "Disculpeu, hi ha hagut un error mentre s'intentava escriure informació a la base de dades",
"Language watch" => "Vigila l'idioma",
"Cannot upload this file not enough quota" => "No es pot pujar aquest arxiu , no hi ha espai suficient",
"Non-existent user" => "Aquest usuari no existeix",
"No banner indicated" => "No s'ha indicat cap banner",
"No blog indicated" => "No s'indica cap bitàcola",
"Permission denied you cannot remove the post" => "No té permís per eliminar aquesta publicació",
"No cache information available" => "No hi ha informació disponible a la memòria cau",
"No faq indicated" => "no s'ha indicat cap PUF",
"You are not permitted to remove someone else\\'s post!" => "No tens permís per eliminar la publicació d'algú altre!",
"No thread indicated" => "No s'ha indicat cap tema",
"Incorrect thread" => "Fil de discussió incorrecte",
"A SheetId is required." => "Cal un SheetId.",
"That tracker don't use extras." => "Aquell formulari no empra extres.",
"No subject" => "No hi ha cap assumpte",
"Top pages" => "Les planes més actives",
"Last pages" => "Les últimes pàgines",
"Tiki RSS feed for the wiki pages" => "Alimentació RSS del Tiki per a planes wiki",
"Last modifications to the Wiki." => "Darreres modificacions al Wiki.",
"###end###"=>"###end###");
?>
