<?php // -*- coding:utf-8 -*-
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then TikiWiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tikiwiki.org/tiki-index.php?page=UnusedWords for further info
"Tip: hold down CTRL to select multiple categories" => "Tip: Strg halten um mehrere Kategorien auszuw&auml;hlen",
"Tip: uncheck the above checkbox to uncategorize this page/object" => "Tip: die Checkbox deaktivieren um die Kategorien dieser Seite/dieses Objekts zu entfernen",
"from\r\nthe mapfile:" => "aus\r\nder Kartendatei:",
"reply to" => "Antwort auf",
"WARNING : Old and New trackers cannot coexist. Trackers created with new library\r\nwill not work with old library and conversely" => "WARNUNG: Alte und Neue Tracker k&ouml;nnen nicht parallel existieren. Tracker die mit der neuen Bibliothek erstellt wurden, funktionieren nicht mit der alten Bibliothek und andersherum.",
"Field is public? (for use thru trackerlist plugin)" => "Feld &ouml;ffentlich? (f&uuml;r Nutzung &uuml;ber das TrackerList-PlugIn)",
"use ...page... to separate pages" => "Benutze ...page... um Seiten in mehrere zu untergliedern",
"cms" => "Artikel",
"Your message has been queued for approval, the message will be posted after\r\na moderator approves it." => "Ihre Nachricht wurde in die Warteschlange f&uuml;r Best&auml;stigungen eingereiht. Sie wird angezeigt, sobald sie ein Moderator freigegeben hat.",
"comm" => "Schnittstellen",
"community" => "Community",
"content templates" => "Inhaltsvorlagen",
"drawings" => "Zeichnungen",
"file galleries" => "Dateiarchive",
"freetags" => "Freetags",
"html pages" => "HTML-Seiten",
"image galleries" => "Bildergalerien",
"maps" => "Karten",
"messu" => "Nachrichten",
"newsletters" => "Rundbriefe",
"sheet" => "Tiki Sheets",
"shoutbox" => "Shoutbox",
"tiki" => "Tiki",
"support" => "Online-Support",
"surveys" => "Umfragen",
"workflow" => "Workflow",
"webmail" => "Webmail",
"Removed version" => "Version gel&ouml;scht",
"Renamed" => "Umbenannt",
"Updated" => "Aktualisiert",
"Viewed" => "Angesehen",
"Posted" => "Erstellt",
"Downloaded" => "Heruntergeladen",
"Admin Mods" => "MODs verwalten",
"File %s uploaded successfully." => "Datei %s erfolgreich hochgeladen.",
"usernames separated with ;" => "mehrere Benutzernamen mit Semikolon ; trennen",
"uploaded by" => "hochgeladen von",
"not specified" => "nicht definiert",
"The file you are trying to upload is too big." => "Die hochgeladene Datei ist zu gro&szlig;.",
"Invalid remote file on url %s" => "Ung&uuml;tige Datei unter %s",
"%A %d of %B, %Y" => "%A %d im %B, %Y",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A %d im %B, %Y[%H:%M:%S %Z]",
"%a %d of %b, %Y" => "%a %d im %b, %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a %d im %b, %Y[%H:%M %Z]",
"delete" => "l&ouml;schen",
"post" => "Eintrag",
"stop monitoring this blog" => "diesen Blog nicht mehr beobachten",
"posts" => "Eintr&auml;ge",
"visits" => "Besuche",
"show categories" => "Kategorien zeigen",
"author" => "Autor",
"user level" => "Benutzerlevel",
"send email to user" => "eMail an Benutzer schicken",
"score" => "Punkte",
"delete selected" => "markierte l&ouml;schen",
"move" => "verschieben",
"Posted messages" => "gepostete Beitr&auml;ge",
"set" => "Ok",
"replies" => "Antworten",
"new reply" => "neue Antwort",
"cancel" => "abbrechen",
"up" => "rauf",
"down" => "runter",
"add" => "hinzuf&uuml;gen",
"stop monitoring this map" => "diese Karte nicht mehr beobachten",
"create" => "hinzuf&uuml;gen",
"save" => "Speichern",
"send" => "verschicken",
"Hide module contents" => "Modul auf-/zuklappen",
"Last visitors" => "Letzte Besucher",
"register" => "Registrieren",
"standard" => "Standard",
"secure" => "sicher",
"stay in ssl mode" => "In SSL-Modus bleiben",
"new messages" => "neue Nachrichten",
"new message" => "neue Nachricht",
"go" => "los",
"cache" => "Cache",
"use" => "benutzen",
"cached" => "gecached",
"refresh" => "aktualisieren",
"print" => "drucken",
"create pdf" => "PDF erstellen",
"monitor this page" => "diese Seite beobachten",
"stop monitoring this page" => "diese Seite nicht mehr beobachten",
"backlinks" => "Verweise",
"click here" => "hier klicken",
"rename" => "umbenennen",
"unlock" => "entsperren",
"lock" => "sperren",
"perms" => "Berecht.",
"history" => "Historie",
"similar" => "&auml;hnlich",
"undo" => "r&uuml;ckg&auml;ngig",
"slides" => "Dias",
"export" => "exportieren",
"discuss" => "diskutieren",
"add comment" => "kommentieren",
"attach file" => "Datei anh&auml;ngen",
"translation" => "&Uuml;bersetzung",
"last modification" => "letzte &Auml;nderung",
"attachments" => "Anh&auml;nge",
"stats" => "Statistiken",
"last changes" => "zuletzt ge&auml;ndert",
"list pages" => "Seiten auflisten",
"back to homepage" => "Zur&uuml;ck zur Startseite",
"cancel edit" => "Bearbeitung verwerfen",
"No attachments for this page" => "Keine Anh&auml;nge f&uuml;r diese Seite",
"view blog" => "Blog betrachten",
"list blogs" => "Blogs auflisten",
"save and exit" => "Speichern und verlassen",
"reads" => "Zugriffe",
"view comments" => "Kommentare ansehen",
"Click here to create it" => "Zum Anlegen hier klicken",
"wiki help" => "Wiki Hilfe",
"General preferences" => "Allgemeine Einstellungen",
"Other preferences" => "Sonstige Einstellungen",
"flag" => "Kennzeichen",
"Change information" => "Einstellungen &uuml;bernehmen",
"ok" => "OK",
"Best language" => "Beste Sprache",
"PodCast directory (must be web accessable):" => "PodCast Verzeichnis (mu&szlig; per Browser erreichbar sein):",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload filed in that dir, either by scp, ftp, or other protocols" => "Wenn 'Batch-Upload aus Verzeichnis' aktiviert wird mu&szlig; ein vom Webserver lesbares Verzeichnis benutzt werden (am besten au&szlig;erhalb des Webspace). Dorthin m&uuml;ssen die Dateien dann mit scp, ftp o.&auml;. &uuml;bertragen werden.",
"Enable cache images to all galleries" => "Bildercache f&uuml;r alle Galerien aktivieren",
"Images cache directory" => "Bildercache-Verzeichnis",
"images" => "Bilder",
"Report PHP errors only for admin" => "Alle PHP Fehler nur f&uuml;r Admin ausgeben",
"Server name (for absolute URIs)" => "Servername (f&uuml;r absolute URIs)",
"Automatic (uses HTTPS variable)" => "Automatisch (benutzt HTTPS Variable)",
"Wiki_Tiki_Title" => "Wiki_Tiki_Titel",
"path" => "Pfad",
"groups" => "Gruppen",
"Admin->Features" => "Admin->Funktionen",
"must be turned on and notification is sent to the admin's" => "mu&szlig; aktiviert sein, Nachrichten an Admin geht an seine",
"inter-user message inbox" => "Tiki Mailbox",
"Validate email address (may not work)" => "eMail-Adresse &uuml;berpr&uuml;fen (funktioniert evtl. nicht)",
"Require HTTP Basic authentication" => "HTTP-Basic-Authentication notwendig",
"HTTP server name" => "HTTP-Servername",
"HTTP URL prefix" => "HTTP-URL-Pr&auml;fix",
"HTTPS server name" => "HTTPS-Servername",
"HTTPS URL prefix" => "HTTPS-URL-Pr&auml;fix",
"Only for users" => "Nur f&uuml;r Benutzer",
"Users and admins" => "Benutzer und Admins",
"Full Text Search" => "Volltextsuche",
"Database independant search or Tiki search" => "Unabh&auml;ngige Datenbanksuche oder Tiki Suche",
"Don't forget: to use feature you will need to enable it on" => "Hinweis: Um dieses Feature zu nutzen, aktivieren Sie es unter",
"Custom Code" => "Angepasster Code",
"Site breadcrumbs" => "Site Breadcrumbs",
"Site search bar" => "Balken f&uuml;r Site Suche",
"Site logo" => "Site-Logo",
"Site logo source" => "Site Logo Quelle",
"Site ads and banners" => "Site Werbung und Banner",
"Site Menu" => "Site Men&uuml;",
"Note: This feature also requires phplayers to be turned on in Admin->Features" => "Hinweis: Um dieses Feature verwenden zu k&ouml;nnen, m&uuml;ssen PHPLayer unter Admin->Funkionen",
"change" => "&auml;ndern",
"Manage attachment preferences" => "Einstellungen f&uuml;r Anh&auml;nge verwalten",
"HTML in Wiki Pages" => "HTML in Wiki Seiten",
"Wiki syntax used when a page contains HTML" => "Wiki Syntax benutzen wenn Seite HTML enth&auml;lt",
"full" => "voll",
"partial" => "teilweise",
"Search and replace" => "Suchen und ersetzen",
"Enable Feature" => "Funktion einschalten",
"loc" => "Ort",
"participants" => "Teilnehmer",
"cat" => "Kateg.",
"lang" => "Sprache",
"prio" => "Prio",
"subscription" => "Abonnement",
"permissions" => "Berechtigungen",
"admin categories" => "Kategorien verwalten",
"create new" => "erstelle neu",
"edit chart" => "Hitliste bearbeiten",
"update" => "aktualisieren",
"admin content templates" => "Inhaltsvorlagen verwalten",
"use in cms" => "Im CMS benutzen",
"use in wiki" => "In Wikis benutzen",
"use in newsletters" => "In Newslettern benutzen",
"use in HTML pages" => "In HTML-Seiten benutzen",
"last modif" => "letzte &Auml;nderung",
"sections" => "Bereiche",
"admin FortuneCookie" => "Spr&uuml;che verwalten",
"upload" => "Hochladen",
"dsn" => "DSN",
"Edit existing forums" => "Vorhandene Foren bearbeiten",
"topics" => "Themen",
"coms" => "Kommentare",
"age" => "Alter",
"ppd" => "PPT",
"last post" => "Neuester Eintrag",
"admin hotwords" => "Hotwords verwalten",
"list repositories" => "Repositories auflisten",
"new repository" => "Neues Repository",
"view repository" => "Repository anschauen",
"view this repository" => "Repository ansehen",
"new rule" => "neue Regeln",
"admin featured links" => "Linktips verwalten",
"url" => "URL",
"position" => "Position",
"admin Webmail" => "Webmail verwalten",
"section" => "Bereich",
"sorted section" => "Sortierter Bereich",
"options" => "Optionen",
"admin modules" => "Module verwalten",
"assign module" => "Modul zuweisen",
"left modules" => "Module links",
"right modules" => "Module rechts",
"edit/create" => "hinzuf&uuml;gen/bearbeiten",
"clear cache" => "Cache leeren",
"assign" => "zuweisen",
"left" => "links",
"right" => "rechts",
"order" => "Reihenfolge",
"parameters" => "Parameter",
"create/edit" => "hinzuf&uuml;gen/bearbeiten",
"use poll" => "Abstimmung benutzen",
"use gallery" => "Galerie benutzen",
"use dynamic  content" => "Dynamischen Inhaltsblock benutzen",
"use rss module" => "RSS-Modul benutzen",
"use menu" => "Men&uuml; benutzen",
"use phplayermenu" => "PHPLayerMen&uuml; benutzen",
"use banner zone" => "Bannerzone benutzen",
"list newsletters" => "Newsletter auflisten",
"admin newsletters" => "Newsletter verwalten",
"send newsletters" => "Newsletter versenden",
"editions" => "Ausgaben",
"last sent" => "zuletzt gesendet",
"send newsletter" => "Newsletter versenden",
"admin Email Notifications" => "Mail-Benachrichtigungen verwalten",
"use admin email" => "Admin eMail benutzen",
"event" => "Termin",
"admin polls" => "Abstimmungen verwalten",
"admin QuickTags" => "QuickTags verwalten",
"label" => "Beschriftung",
"admin RSS Modules" => "RSS-Module verwalten",
"admin shoutbox words" => "Shoutbox Words Verwaltung",
"export pages" => "Seiten exportieren",
"dump tree" => "Baum ausgeben",
"create webhelp" => "Web-Hilfe erstellen",
"tree" => "Baum",
"create new structure" => "neue Struktur anlegen",
"survey stats" => "Umfragen-Statistik",
"edit this survey" => "Diese Umfrage bearbeiten",
"admin surveys" => "Umfragen verwalten",
"list surveys" => "Umfragen auflisten",
"questions" => "Fragen",
"files" => "Dateien",
"advanced feature" => "Funktion f&uuml;r Fortgeschrittene",
"Edit fields for tracker" => "Felder bearbeiten von Tracker",
"items" => "Eintr&auml;ge",
"The tracker needs a text field named Subject" => "Der Tracker mu&szlig; ein Eingabefeld 'Subject' besitzen (auch f&uuml;r RSS Feed n&ouml;tig)",
"version" => "Version",
"admin groups" => "Gruppen verwalten",
"assign permissions" => "Berechtigungen vergeben",
"admin" => "Verwalten",
"admin users" => "Benutzer verwalten",
"more criteria" => "Erweiterte Suchoptionen",
"assign to groups" => "zu Gruppen hinzuf&uuml;gen",
"all" => "alle",
"Assign user" => "Benutzer zuweisen",
"Available groups" => "Verf&uuml;gbare Gruppen",
"assign perms to this group" => "dieser Gruppe Rechte zuweisen",
"admin backups" => "Backups verwalten",
"List of available backups" => "Liste der verf&uuml;gbaren Backups",
"Restoring a backup" => "Einen Backup wiederherstellen",
"Warning!" => "Warnung!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "Das Wiederherstellen eines Backups zert&ouml;rt alle bisherigen Daten in Ihrer Tiki Datenbank. Die Information in allen Tabellen wird durch das Backup ersetzt.",
"Click here to confirm restoring" => "Hier klicken, um den Start der Wiederherstellung zu best&auml;tigen",
"Create new backup" => "Neues Backup anlegen",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "Das Erstellen von Backups kann lange Zeit dauern. Falls der Prozess nicht abgeschlossen werden kann werden Sie einen blanken Bildschirm sehen. Falls dies der Fall ist m&uuml;ssen Sie den Parameter 'maximum script execution time' in Ihrer php.ini Datei erh&ouml;hen",
"If any of your forums have attachments stored in the directory you will need to backup these using FTP or SCP." => "Sollten Anh&auml;nge aus dem Forum im Verzeichnis gespeichert sein, m&uuml;ssen diese per FTP oder SCP gesichert werden.",
"Upload a backup" => "Ein Backup hochladen",
"Upload backup" => "Backup hochladen",
"remove file extension from image name" => "Dateiendung im Namensfeld entfernen",
"convert sub directories to sub galleries" => "Unterverzeichnisse in Unter-Galerien konvertieren",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named screenshots will be created" => "z.B. wird bei \"misc/screenshots/digicam0001.jpg\" das Bild in die Galerie screenshots gesteckt",
"use sub directory names as description" => "Namen von Unterverzeichnissen als Beschreibung verwenden",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description misc/screenshots will be created" => "z.B. wird von \"misc/screenshots/digicam0001.jpg\" der Text misc/screenshots als Beschreibung benutzt",
"admin category" => "Kategorien verwalten",
"list galleries" => "Galerien auflisten",
"edit gallery" => "Galerie bearbeiten",
"rebuild thumbnails" => "Thumbnails neu erzeugen",
"upload image" => "Bild hochladen",
"list gallery" => "Galerie als Liste zeigen",
"hit" => "Treffer",
"original size" => "Originalgr&ouml;&szlig;e",
"return to gallery" => "zur&uuml;ck zur Galerie",
"edit image" => "Bild bearbeiten",
"smaller" => "kleiner",
"bigger" => "gr&ouml;&szlig;er",
"prev image" => "vorh. Bild",
"popup window" => "Popup-Fenster",
"next image" => "n&auml;ch. Bild",
"slideshow forward" => "Diaschau vorw&auml;rts",
"stop" => "Anhalten",
"imagescale" => "Bildskalierung",
"add item" => "Eintrag hinzuf&uuml;gen",
"Subscription List" => "Empf&auml;ngerliste",
"or create a new category" => "oder neue Kategorie anlegen",
"or create a new location" => "oder neuen Ort eintragen",
"comma separated usernames" => "Usernamen durch Komma getrennt",
"comma separated username:role" => "Komma getrennte Liste 'Teilnehmer:Rolle'",
"with roles" => "mit den Rollen",
"Chair" => "Leiter",
"save_to" => "in",
"permission" => "Berechtigung",
"remove from this category &amp; all its children" => "von dieser und allen Unterkategorien entfernen",
"remove from this category only" => "nur von dieser Kategorie entfernen",
"remove page" => "Seite entf.",
"browse" => "im Verzeichnis st&ouml;bern",
"related" => "verwandt",
"validate" => "&uuml;berpr&uuml;fen",
"add a site" => "Link hinzuf&uuml;gen",
"add a category" => "Kategorie hinzuf&uuml;gen",
"search" => "Suche",
"list articles" => "Beitr&auml;ge auflisten",
"view articles" => "Beitr&auml;ge ansehen",
"create zone" => "Zone hinzuf&uuml;gen",
"save the banner" => "das Banner speichern",
"Allow trackback pings" => "Trackback-Pings erlauben",
"try" => "ausprobieren",
"display" => "anzeigen",
"admin quicktags" => "Quicktags verwalten",
"create new block" => "Neuen Block erzeugen",
"list quizzes" => "Quiz auflisten",
"quiz stats" => "Quiz-Statistik",
"edit this quiz" => "Dieses Quiz bearbeiten",
"admin quizzes" => "Quiz verwalten",
"results" => "Ergebnisse",
"create page" => "Seite erstellen",
"list submissions" => "Einreichungen auflisten",
"save only in the theme:" => "Nur f&uuml;r diesen Style speichern:",
"add to the set" => "zur Liste hinzuf&uuml;gen",
"Search " => "Suche",
"replace" => "ersetzen",
"Admin ephemerides" => "Terminkalender verwalten",
"All ephemerides" => "Alle Termine",
"new question" => "Neue Frage",
"approve" => "akzeptieren",
"configure listing" => "Liste konfigurieren",
"create new file gallery" => "neues Dateiarchiv anlegen",
"topic" => "Thema",
"save and approve" => "speichern und freigeben",
"new topic" => "neues Thema",
"accept" => "akzeptieren",
"refuse" => "ablehnen",
"add new" => "Neu hinzuf&uuml;gen",
"add role" => "Rolle hinzuf&uuml;gen",
"admin processes" => "Prozesse verwalten",
"admin activities" => "Aktivit&auml;ten verwalten",
"admin roles" => "Rollen verwalten",
"edit this process" => "Prozess bearbeiten",
"monitor" => "&Uuml;berwachen",
"create new gallery" => "neue Galerie anlegen",
"result" => "Ergebnis",
"reload" => "Aktualisieren",
"edit repository" => "Repository bearbeiten",
"source" => "Quellcode",
"edit new article" => "neuen Artikel erstellen",
"admin Banners" => "Banner verwalten",
"create new blog" => "Neuen Blog anlegen",
"admin cache" => "Cache verwalten",
"upload file" => "Datei hochladen",
"Edit a file using this form" => "Datei &uuml;ber dieses Formular bearbeiten",
"delete selected files" => "markierte Dateien l&ouml;schen",
"browse gallery" => "Galerie anzeigen",
"Flash binary (.sqf or .dcr)" => "Flash Binary (.sqf oder .dcr)",
"edit blog" => "Blog bearbeiten",
"edit new submission" => "neue Einreichung bearbeiten",
"actions" => "Aktionen",
"set as operator" => "Als Operator hinzuf&uuml;gen",
"add topic" => "Thema hinzuf&uuml;gen",
"install" => "installieren",
"back" => "zur&uuml;ck",
"Assign permissions to page" => "Berechtigungen f&uuml;r Seite vergeben",
"These permissions override any global permissions affecting this object. To edit global permissions " => "Diese Berechtigungen &uuml;berschreiben alle globalen Berechtigungen, die auf dieses Objekt wirken. Zum &Auml;ndern der globalen Berechtigungen ",
"Current permissions for this page" => "Aktuelle Berechtigungen f&uuml;r diese Seite",
"remove from this page" => "aus dieser Seite entfernen",
"remove from this structure" => "aus dieser Struktur entfernen",
"No individual permissions; category or global permissions apply" => "Keine individuellen Berechtigungen; Kategorie oder globale Berechtigungen vergeben",
"this page" => "diese Seite",
"this structure" => "diese Struktur",
"Current permissions for categories that this page belongs to" => "Diese Seite geh&ouml;rt zu den Kategorien mit folgenden Berechtigungen",
"Send email notifications when this page changes to" => "eMail-Benachrichtigung bei Seiten&auml;nderung verschicken an",
"add email" => "eMail hinzuf&uuml;gen",
"Notifications" => "Benachrichtigungen",
"clear stats" => "Statistiken zur&uuml;cksetzen",
"Edit received page" => "Empfangene Seite bearbeiten",
"last" => "letzte",
"send me my password" => "Mein Pa&szlig;wort senden",
"searched" => "gesucht",
"galleries" => "Galerien",
"blog posts" => "Blog-Eintr&auml;ge",
"articles" => "Artikel",
"wiki pages" => "Wiki-Seiten",
"site" => "Site",
"clear" => "zur&uuml;cksetzen",
"add article" => "Artikel hinzuf&uuml;gen",
"admin Tiki Shoutbox" => "Tiki-Shoutbox verwalten",
"list view" => "Listenansicht",
"send answers" => "Antworten senden",
"move to right column" => "in die rechte Spalte verschieben",
"unassign" => "Zuordnung aufheben",
"move to left column" => "in die linke Spalte verschieben",
"remove folder" => "Ordner l&ouml;schen",
"refresh cache" => "Cache aktualisieren",
"use google map locator" => "Google Map Locator benutzen",
"admin mode" => "Verwaltungsmodus",
"trash" => "in Papierkorb",
"empty trash" => "Papierkorb l&ouml;schen",
"remove from trash" => "aus dem Papierkorb",
"use start date and time" => "Startdatum/-zeit benutzen",
"use end date and time" => "Endedatum/-zeit benutzen",
"no comments" => "keine Kommentare",
"edit items" => "Eintr&auml;ge bearbeiten",
"list charts" => "Hitlisten anzeigen",
"last chart" => "neueste Hitliste",
"item" => "Eintrag",
"view faq" => "FAQ anzeigen",
"add suggestion" => "Vorschlag hinzuf&uuml;gen",
"monitor this forum" => "Dieses Forum beobachten",
"stop monitoring this forum" => "Beobachten dieses Forums beenden",
"delete selected topics" => "Ausgew&auml;hlte Themen l&ouml;schen",
"stop monitoring this topic" => "Beobachtung dieses Themas beenden",
"Comments below your current threshold" => "Kommentar unterhalb Ihres aktuellen Schwellenwerts",
"list attachments" => "Anh&auml;nge auflisten",
"add contacts" => "Kontakte hinzuf&uuml;gen",
"DATE-of" => "im",
"You cannot edit this page because it is a user personal page" => "Sie k&ouml;nnen diese Seite nicht bearbeiten, da es sich um eine pers&ouml;nliche Benutzer-Seite handelt.",
"Permission denied you cannot assign permissions for this page" => "Zugriff verweigert. Sie k&ouml;nnen dieser Seite keine Berechtigungen zuweisen",
"You do not have permission to edit messages" => "Sie haben keine Berechtigung, diese Nachrichten zu bearbeiten",
"Cannot read file" => "Kann Datei nicht lesen",
"Permission denied you cannot upload files" => "Berechtigung zum Hochladen von Dateien nicht vorhanden",
"cannot process upload" => "Kann Upload nicht verarbeiten",
"Your email address has been removed from the list of addresses monitoring this tracker" => "Ihre Mail-Adresse wurde von der Liste der Adressen, die diesen Tracker &uuml;berwachen entfernt",
"Your email address has been added to the list of addresses monitoring this tracker" => "Ihre Mail-Adresse wurde zu der Liste der Adressen, die diesen Tracker &uuml;berwachen hinzugef&uuml;gt",
"Cancel monitoring" => "&Uuml;berwachung beenden",
"Your email address has been removed from the list of addresses monitoring this item" => "Ihre Adresse wurde aus der Liste derer entfernt, die diesen Eintrag beobachten",
"Your email address has been added to the list of addresses monitoring this item" => "Ihre Adresse wurde zu denen hinzugef&uuml;gt, die diesen Eintrag beobachten",
"new image uploaded by" => "neue Bilder hochgeladen von",
"new subscriptions" => "neue Abonnenten",
"new item in tracker" => "Neuer Eintrag im Tracker",
"show" => "zeigen",
"hide" => "verstecken",
"message" => "Nachricht",
"Include an article" => "Artikel einbinden",
"select all" => "alle ausw&auml;hlen",
"filter" => "filtern",
"no such file" => "Datei nicht gefunden",
"downloads" => "Downloads",
"attach" => "anh&auml;ngen",
"monitor this blog" => "diesen Blog beobachten",
"hide categories" => "Kategorien verbergen",
"Admin categories" => "Kategorien verwalten",
"browse category" => "Kategorien durchst&ouml;bern",
"reply" => "antworten",
"monitor this topic" => "Thema beobachten",
"with checked" => "markierte",
"move selected files" => "markierte Dateien verschieben",
"Thank you for you registration. You may log in now." => "Vielen Dank f&uuml;r die Registrierung. Sie k&ouml;nnen sich jetzt anmelden.",
"compare" => "vergleichen",
"diff" => "Diff",
"sender" => "Absender",
"subject" => "Betreff",
"date" => "Datum",
"flagged" => "gekennzeichnet",
"mark" => "setzen",
"find replied message" => "suche beantwortete Nachricht",
"replied" => "beantwortet",
"Click the :: options in the Menu for more options." => "",
"Please, also see" => "Bitte auch",
"for more setup details." => "f&uuml;r weitere Konfigurationsdetails anschauen.",
"Note 1:" => "Hinweis 1:",
"You can remove this module in" => "Entfernen dieses Moduls &uuml;ber",
"as well as assign or edit many others." => "wo auch andere Module zugewiesen oder erstellt werden k&ouml;nnen.",
"Note 2:" => "Hinweis 2:",
"The menu module installed by default is named" => "Das Modul mit den Standard Men&uuml;s hei&szlig;t",
"it is a \"custom module\" which includes menu ID " => "es ist ein \"editierbares Modul\", es enth&auml;lt das Men&uuml; mit der ID ",
"That menu is stored in database and it can be edited from " => "Das Men&uuml; ist in der Datenbank gespeichert und kann ge&auml;ndert werden &uuml;ber ",
"Do not mix this with the original <em>application_menu</em> module" => "Bitte nicht verwechseln mit dem <em>application_menu</em> Modul",
"That one can be heavily customized to match style used but it can be currently done only by editing mod-application_menu.tpl file \"manually\"" => "Letzteres kann an eigene Styles etc. angepa&szlig;t werden, daf&uuml;r mu&szlig; aber die Datei mod-application_menu.tpl von Hand ge&auml;ndert werden.",
"del" => "l&ouml;schen",
"Create pdf" => "PDF erstellen",
"pdf" => "PDF",
"1 file attached" => "1 angeh&auml;ngte Datei",
"Click" => "Klick",
"categories" => "Kategorien",
"List pages where I am a creator" => "Seiten auflisten, die ich erstellt habe",
"by creator" => "nach Ersteller",
"by modificator" => "nach Bearbeiter",
"at tracker" => "Bei Tracker",
"posted by" => "eingetragen von",
"email this post" => "Diesen Beitrag verschicken",
"calendar view" => "Kalenderansicht",
"check / uncheck all" => "alle (ent)markieren",
"Mandatory category in the category tree" => "Pflichtkategorie im Kategorieverzeichnis",
"Tiki sections and features" => "Tiki-Bereiche und Funktionen",
"tikiwiki.org help" => "tikiwiki.org Hilfe",
"Site Logo and Identity" => "Site-Logo und Identit&auml;t",
"Use Quote plugin rather than &ldquo;>&rdquo; for quoting" => "Quote PlugIn statt festes &ldquo;>&rdquo; beim Quoten verwenden",
"Storing files in a directory" => "Speichern von Dateien in einem Verzeichnis",
"please read" => "Bitte lesen! (klick mich)",
"yes" => "ja",
"Click here for more details." => "F&uuml;r weitere Details hier klicken.",
"Best Language" => "Beste Sprache",
"Tiki preferences value field in db is set to be max. 250 characters long by default until now. That applies for the custom code content too. Check this field if you want to update your preferences database table to support more than 250 chars (although it was tested and works fine with mysql, it's recommended to backup your data manually before any database update)" => "Die Tiki Einstellungen beschr&auml;nken die max. Zeichenl&auml;nge standardm&auml;&szlig;ig auf 250. Die trifft auch auf angepassten Code zu. Um mehr Zeichen zuzulassen, setzen Sie hier den Haken (Erstellen Sie vorher ein Backup Ihrer Datenbank!).",
"Users &amp; groups" => "Benutzer &amp; Gruppen",
"Local" => "Lokal",
"private" => "privat",
"<b>Item</b>" => "<b>Eintrag</b>",
"<b>Value</b>" => "<b>Wert</b>",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS Modules\" on the application menu, or" => "Auf dieser Seite werden die RSS Feeds konfiguriert, die von Tiki erstellt und exportiert werden. Zum Einlesen/Importieren von RSS Feeds \"RSS Module\" im Men&uuml; w&auml;hlen oder",
"<b>Feed</b>" => "<strong>Feed</strong>",
"<b>enable/disable</b>" => "<strong>ein/aus</strong>",
"<b>Max number of items</b>" => "<strong>Max. Anzahl<br>Eintr&auml;ge</strong>",
"Feed for Articles" => "Feed f&uuml;r Artikel",
"Feed for Weblogs" => "Feed f&uuml;r Blogs",
"Feed for Image Galleries" => "Feed f&uuml;r Bildergalerien",
"Feed for File Galleries" => "Feed f&uuml;r Dateiarchive",
"Feed for the Wiki" => "Feed f&uuml;r Wiki-Seiten",
"Feed for individual Image Galleries" => "Feed f&uuml;r einzelne Bildergalerie",
"Feed for individual File Galleries" => "Feed f&uuml;r einzelnes Dateiarchiv",
"Feed for individual weblogs" => "Feed f&uuml;r einzelnen Blog",
"Feed for individual forums" => "Feed f&uuml;r einzelnes Forum",
"Feed for mapfiles" => "Feed f&uuml;r Kartendateien",
"Feed for directories" => "Feed f&uuml;r Verzeichnisse",
"Feed for individual tracker items" => "Feed f&uuml;r einzelne Tracker-Eintr&auml;ge",
"Feed for tracker items" => "Feed f&uuml;r Tracker-Eintr&auml;ge",
"Feed for upcoming calendar events" => "Feed f&uuml;r zuk&uuml;nftige Events",
"Caching time :" => "RSS Daten im Cache halten",
"Only enable caching if all syndicated content is public (visible to everyone) or private documents might leak out. Cache ignores existing permissions." => "Caching sollte nur f&uuml;r Inhalte aktiviert werden, die vollst&auml;ndig freigegeben sind, es k&ouml;nnten sonst private Dokumente verteilt werden. Bei Nutzung des Cache greifen die Rechteabfragen nicht.",
"Prefix breadcrumbs with 'Location:' label?" => "Pr&auml;fixe Breadcrumbs mit 'Position:'?",
"Site Search" => "Site Suche",
"Change style only" => "nur Style &auml;ndern",
"Tag name" => "Tag Name",
"Enable wiki 3D browser" => "Wiki 3D Browser aktivieren",
"Load page on navigation" => "Seite beim navigieren laden",
"Existing page node color" => "Farbe existierender Knoten",
"Missing page node color" => "Farbe fehlender Knoten",
"Anonymous editors must input anti-bot code" => "Anonyme Autoren m&uuml;ssen Anti-Robot Code eingeben",
"PDF generation" => "PDF-Erstellung",
"Edit idle timeout" => "Bearbeiten Idle-Timeout",
"Use page description" => "Seitenbeschreibung benutzen",
"Show page title" => "Seitentitel anzeigen",
"Show page ID" => "Seiten-ID anzeigen",
"Cache wiki pages (global)" => "Wikiseiten cachen (global)",
"Users can lock pages (if perm)" => "Benutzer kann Seiten sperren (falls berechtigt)",
"Use WikiWords" => "WikiWords benutzen",
"Use Wiki paragraph formatting" => "Wiki Absatzformatierung benutzen",
"Use external link icons" => "Symbole f&uuml;r externe Links benutzen",
"User's Page" => "Benutzerseite 'UserPageNAME'",
"UserPage prefix" => "UserPage Prefix",
"List authors" => "Autoren aufz&auml;hlen",
"When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page" => "Beim betrachten einer Seite, welche nicht existiert aber eine &auml;hnliche existiert, automatisch dahin umleiten",
"Show/hide heading icon displayed before the heading" => "Zeige/Verberge &Uuml;berschriftsicon vor der &Uuml;berschrift",
"Print Page" => "Seite ausdrucken",
"Maximum number of versions for history" => "Maximale Anzahl der Versionen in Historie",
"Never delete versions younger than days" => "Niemals l&ouml;schen: Versionen j&uuml;nger als",
"IP not displayed in history" => "IP nicht in der History anzeigen",
"Diff style" => "Vergleichs-Typ",
"Statistic" => "Statistik",
"Use in CMS" => "Im CMS benutzen",
"Use in Wiki" => "In Wikis benutzen",
"Use in newsletters" => "In Newslettern benutzen",
"Use in HTML pages" => "In HTML-Seiten benutzen",
"Edit Existing Forums" => "Vorhandene Foren bearbeiten",
"Refresh rate (if dynamic) [secs]" => "Aktualisierungsrate (falls dynamisch) [Sek.]",
"configure repositories" => "Repositories konfigurieren",
"configure this repository" => "dieses Repository konfigurieren",
"copy rules" => "Regeln kopieren",
"Create/edit newsletters" => "Newsletters hinzuf&uuml;gen/bearbeiten",
"subscriptions" => "Abonnements",
"archives" => "Archive",
"Use Admin Email" => "Admin eMail benutzen",
"Edit or add poll options" => "Abstimmungsoptionen hinzuf&uuml;gen/bearbeiten",
"Create/edit Polls" => "Abstimmungen hinzuf&uuml;gen/bearbeiten",
"Rss channels" => "RSS Kan&auml;le",
"show pubdate" => "Datum anzeigen",
"activate" => "Aktivieren",
"Admin tracker" => "Tracker verwalten",
"Edit this tracker" => "Diesen Tracker bearbeiten",
"View this tracker items" => "Eintr&auml;ge dieses Trackers ansehen",
"Edit tracker fields" => "Tracker-Felder bearbeiten",
"Import/export trackers fields" => "Tracker-Felder importieren/exportieren",
"Create trackers" => "Tracker anlegen",
"Import/export" => "Import/Export",
"fields" => "Felder",
"Create/edit trackers" => "Tracker hinzuf&uuml;gen/bearbeiten",
"filename" => "Dateiname",
"filesize" => "Dateigr&ouml;&szlig;e",
"filetype" => "Dateityp",
"longdesc" => "Beschreibung",
"Add a new group" => "Eine neue Gruppe hinzuf&uuml;gen",
"Edit item" => "Punkt bearbeiten",
"List all members" => "Alle Mitglieder auflisten",
"Add a new user" => "Neuen Benutzer hinzuf&uuml;gen",
"manage group assignments" => "Gruppenzuordnungen bearbeiten",
"set default groups" => "Standardgruppen setzen",
"watch only this category" => "Nur diese Kategorie beobachten",
"watch this category and their descendants" => "Diese Kategorien und deren Nachfolger beobachten",
"stop watching only this category" => "Nur diese Kategorie nicht mehr beobachten",
"stop watching this category and their descendants" => "Diese Kategorie und deren Nachfolger nicht mehr beobachten",
"Popup Window" => "Popup-Fenster",
"details" => "Details",
"zoom" => "Zoomen",
"change focus" => "hierher wechseln",
"quarter" => "Vierteljahr",
"semester" => "Halbjahr",
"No individual permissions global permissions apply" => "Keine individuellen Berechtigungen, globale Berechtigungen gelten",
"Welcome to the Tiki Chat Rooms" => "Willkommen bei den Tiki Chatr&auml;umen",
"Please select a chat channel" => "Bitte einen Chatraum ausw&auml;hlen",
"enter chat room" => "Chatraum betreten",
"There are no channels setup, please contact a site admin" => "Es sind keine Chatr&auml;ume eingerichtet, bitte den Admin kontaktieren.",
"Chatroom" => "Chatraum",
"Active Channels" => "Aktive ",
"Users in this channel" => "Benutzer in diesem Kanal",
"Channel Information" => "Channel-Informationen",
"Use :nickname:message for private messages" => "Benutzen Sie :nickname:Nachricht f&uuml;r private Nachrichten",
"Use [URL|description] or [URL] for links" => "Benutzen Sie [URL|Beschreibung] oder [URL] f&uuml;r Links",
"Use (:smileyname:) for smileys" => "(:smileyname:) f&uuml;r Smileys",
"Create PDF" => "PDF erstellen",
"PDF Settings" => "PDF Einstellungen",
"Keep screen pixel/point ratio" => "Pixel und Punkt Verh&auml;ltnis nicht &auml;ndern",
"Render images" => "Bilder rendern",
"Render hyperlinks" => "Hyperlinks rendern",
"Left Margin (mm)" => "Linker Abstand (mm)",
"Right Margin (mm)" => "Rechter Abstand (mm)",
"Top Margin (mm)" => "Oberer Abstand (mm)",
"Bottom Margin (mm)" => "Unterer Abstand (mm)",
"Show page border" => "Seitenrand anzeigen",
"PDF compatilbility level" => "PDF Kompatibilit&auml;t",
"Select Wiki Pages" => "Wiki-Seiten ausw&auml;hlen",
"Remove Page" => "Seite entf.",
"click here to send us an email" => "Hier klicken um uns eine eMail zu schicken",
"Add or edit a site" => "Link hinzuf&uuml;gen/bearbeiten",
"sites" => "Links",
"cool sites" => "Coole Links",
"Use ...page... to separate pages in a multi-page article" => "Benutze ...page... um Seiten in einen mehrseitigen Artikel aufzuteilen",
"Create Zone" => "Zone hinzuf&uuml;gen",
"browse image" => "Bild betrachten",
"translate" => "&uuml;bersetzen",
"Create or edit content" => "Inhalt hinzuf&uuml;gen/bearbeiten",
"this quiz stats" => "Statistik f&uuml;r dieses Quiz",
"answer" => "Antwort",
"Edit Translation:" => "&Uuml;bersetzungs-Einstellungen:",
"Set of Translations" => "Vorhandene &Uuml;bersetzungen",
"Select the article for which the current article is the translation." => "Artikel ausw&auml;hlen, vom dem dieser hier die &Uuml;bersetzung ist",
"Translation of:" => "&Uuml;bersetzung von:",
"Add to the Set" => "Zur Liste hinzuf&uuml;gen",
"graph" => "Graph",
"Edit FAQ questions" => "FAQ-Fragen bearbeiten",
"Edit this file gallery:" => "Dieses Dateiarchiv bearbeiten:",
"icon" => "Symbol",
"Other users can upload files to this gallery" => "Andere Benutzer k&ouml;nnen Dateien hochladen",
"Available File Galleries" => "Verf&uuml;gbare Dateiarchive",
"start" => "Beginn",
"end" => "Ende",
"roles" => "Rollen",
"Add role" => "Rolle hinzuf&uuml;gen",
"active process" => "aktiver Prozess",
"invalid" => "ung&uuml;ltig",
"invalid process" => "ung&uuml;ltiger Prozess",
"valid process" => "g&uuml;ltiger Prozess",
"activities" => "Aktivit&auml;ten",
"aborted" => "abgebrochen",
"value" => "Wert",
"proc" => "Prozesse",
"exceptions" => "Fehler",
"rollback" => "Rollback",
"Create or edit content block" => "Content-Block hinzuf&uuml;gen/bearbeiten",
"Old vers" => "Alte Version",
"Listing Gallery" => "Liste Galerie auf",
"Gallery Files" => "Archiv-Dateien",
"Last ver" => "letzte Ver.",
"Com" => "Kommentar",
"Vers" => "Ver.",
"Add or edit event" => "Termin hinzuf&uuml;gen/bearbeiten",
"Subscribe to newsletter" => "Newsletter abonnieren",
"Add or edit a news server" => "Newsserver hinzuf&uuml;gen/bearbeiten",
"merge selected notes into" => "Notizen verschmelzen mit",
"Print Wiki Pages" => "Wiki-Seiten drucken",
"add page" => "Seite hinzuf&uuml;gen",
"entire site" => "Ganze Site",
"click to navigate" => "zum Navigieren anklicken",
"Total threads" => "Threads gesamt",
"Average threads per topic" => "Durchschn. Threads pro Thema",
"Faq Stats" => "FAQ-Statistik",
"clean" => "l&ouml;schen",
"You can include the file in an HTML/Tiki page using" => "Sie k&ouml;nnen die Datei in eine HTML-/Tiki-Seite einf&uuml;gen mit",
"Now enter the file URL" => "Nun Datei-URL eingeben",
" or upload a local file from your disk" => " oder Datei von lokaler Disk hochladen",
"Add or edit folder" => "Ordner hinzuf&uuml;gen/bearbeiten",
"Add or edit a URL" => "URL hinzuf&uuml;gen/bearbeiten",
"received" => "erhalten",
"submitted" => "zugewiesen",
"shared" => "geteilt",
"move into trash" => "in den Papierkorb",
"waiting / not started" => "wartend / noch nicht begonnen",
"waiting" => "wartend",
"shared for group" => "wird geteilt von Gruppe",
"accepted by user" => "akzeptiert von Benutzer",
"no / rejected" => "nein / zur&uuml;ckgewiesen",
"accepted by creator" => "vom Ersteller akzeptiert",
"priority" => "Priorit&auml;t",
"select one" => "Status",
"undo trash" => "aus Papierkorb",
"show:" => "anzeigen:",
"all shared tasks" => "alle geteilten Aufgaben",
"previous chart" => "vorherige Hitliste",
"next chart" => "n&auml;chste Hitliste",
"pos" => "Position",
"pre" => "letzte",
"avg" => "Durchschnitt",
"post new comment" => "Neuen Kommentar posten",
"Post New Comment" => "Neuen Kommentar posten",
"HTML tags are not allowed inside comments" => "HTML-Tags innerhalb von Kommentaren nicht erlaubt",
"moderator actions" => "Moderator-Aktionen",
"move selected topics" => "Ausgew&auml;hlte Themen verschieben",
"unlock selected topics" => "Ausgew&auml;hlte Themen entsperren",
"lock selected topics" => "Ausgew&auml;hlte Themen sperren",
"merge" => "zusammenf&uuml;hren",
"merge selected topics" => "Ausgew&auml;hlte Themen zusammenf&uuml;hren",
"reported messages:" => "Gemeldete Nachrichten:",
"queued messages:" => "Aufgelaufene Nachrichten:",
"emot" => "Stimmung",
"Edit fields" => "Felder bearbeiten",
"View item" => "Eintrag ansehen",
"Add a comment" => "Kommentar hinzuf&uuml;gen",
"settings" => "Einstellungen",
"mailbox" => "Mailbox",
"compose" => "Erstellen",
"contacts" => "Kontakte",
"account" => "Account",
"pop" => "POP",
"back to mailbox" => "Zur&uuml;ck zum Briefkasten",
"full headers" => "Alle Header",
"normal headers" => "Normale Header",
"reply all" => "allen antworten",
"forward" => "weiterleiten",
"select from address book" => "Aus Adressbuch ausw&auml;hlen",
"cc" => "CC",
"Projects" => "Projekte",
"Projects configuration" => "Projekte Einstellungen",
"Site Identity features" => "Site Identit&auml;ts Features",
"Click here to delete this category" => "Zum L&ouml;schen der Kategorie hier klicken",
"Group doesnt exist" => "Gruppe existiert nicht",
"User doesnt exist" => "Benutzer existiert nicht",
"Event without Name" => "Ereignis ohne Name",
"Invalid old password" => "Ung&uuml;ltiges altes Pa&szlig;wort",
"No channel indicated" => "Kein Kanal angegeben",
"No nickname indicated" => "Kein Nickname angegeben",
"No permission to view the page" => "Keine Berechtigung zum Betrachten dieser Seite",
"Please create a directory named \$map_path to hold your map files." => "Bitte ein Verzeichnis \$map_path f&uuml;r die Kartendaten anlegen.",
"Permision denied" => "Zugriff verweigert",
"Technology" => "Technisches Brimborium",
"Content Related" => "Inhaltsbezogen",
"Feature documentation links" => "Doku-Links zu Komponenten",
"Help System (Feature documentation links)" => "Hilfesystem (Doku-Links zu Komponenten)",
"Technical Features" => "Technisches Brimborium",
"Checkbox options: put 1 if you need that next field is on the same row." => "Auswahlfeld-Optionen: 1 eintragen, falls das n&auml;chste Feld in derselben Spalte sein soll",
"new sites" => "Neue Links",
"Paramaters" => "Parameter",
"database queries used" => "durchgef&uuml;hrte Datenbankabfragen",
"{\$atts_cnt} files attached" => "{\$atts_cnt} angeh&auml;ngte Dateien",
"pass" => "Pa&szlig;wort",
"Page generated in" => "Seite erzeugt in",
"sent" => "Gesendet",
"Homework" => "Hausaufgaben",
"Assignments" => "Aufgaben",
"Favorites" => "Favoriten",
"Member list" => "Mitgliederliste",
"Back to Homepage" => "Zur&uuml;ck zur Startseite",
"Edit Summary" => "Zusammenfassung bearbeiten",
"Minor" => "geringf&uuml;gig",
"Content Features" => "Inhalts-Einstellungen",
"Contact Us (Anonymous)" => "Kontaktiere uns (anonym)",
"Prevent automatic/robot registration" => "Batch-Registrierung (z.B. per Script) unterbinden",
"Create/edit Calendars" => "Kalender hinzuf&uuml;gen/bearbeiten",
"charts" => "Hitlisten",
"Chat Administration" => "Chat-Verwaltung",
"Chat Admin" => "Chat verwalten",
"Create/edit channel" => "Chatraum hinzuf&uuml;gen/bearbeiten",
"Half a second" => "halbe Sekunde",
"second" => "Sekunde",
"Chat channels" => "Chatr&auml;ume",
"Admin DSN" => "DSN verwalten",
"Admin Featured Links" => "Linktips verwalten",
"Admin Webmail" => "Webmail verwalten",
"Assign Module" => "Modul zuweisen",
"Edit/Create" => "hinzuf&uuml;gen/bearbeiten",
"subscribed" => "abonniert",
"Score System" => "Punkte-System",
"Edit survey questions" => "Umfrage bearbeiten",
"Admin Tracker" => "Tracker verwalten",
"Again" => "Wiederholung",
"Assign permissions to group" => "Gruppenberechtigungen vergeben",
"Browsing Gallery" => "Galerie ansehen",
"Admin Directory Related" => "Verwandte Kategorien verwalten",
"Admin Directory Sites" => "Links verwalten",
"Validate Sites" => "Links &uuml;berpr&uuml;fen",
"Edit Article" => "Artikel erstellen/bearbeiten",
"Show Plugins Help" => "Zeige PlugIn Hilfe",
"Show Text Formatting Rules" => "Zeige Textformatierungs-Regeln",
"Program dynamic content for block" => "Dynamischen Inhalt f&uuml;r den Block programmieren",
"Admin quizzes" => "Quiz verwalten",
"EditTemplates" => "Vorlagen bearbeiten",
"Message queue for" => "Nachrichten-Liste f&uuml;r",
"back to forum" => "zur&uum;ck zum Forum",
"Reported messages for" => "Gemeldete Beitr&auml;ge f&uuml;r",
"Admin Cache" => "Cache verwalten",
"back to admin" => "zur&uuml;ck zur Verwaltung",
"Subscribe to This Newsletter" => "Abonnieren",
"Stats for quiz" => "Statistik f&uuml;r das Quiz",
"Received Articles" => "Erhaltene Artikel",
"Rename page" => "Seite umbenennen",
"to_version" => "zu_Version",
"Stats for survey" => "Statistik f&uuml;r Umfrage",
"Theme Control Center: categories" => "Theme Kontrollcenter: Kategorien",
"ThemeControl" => "Theme-Konfiguration",
"ThemeControl Objects" => "Objekte Theme-Konfiguration",
"Theme Control Center: sections" => "Theme Kontrollcenter: Bereiche",
"Upload big files (e.g. PodCast files) here:" => "Gro&szlig;e Dateien (z.B. PodCasts) hier hochladen:",
"File Title" => "Dateititel",
"User Assigned Modules" => "Vom Benutzer zugewiesene Module",
"IRC log" => "IRC Log",
"Add new mail account" => "Neuen eMail-Account hinzuf&uuml;gen",
"User accounts" => "Benutzer-Accounts",
"View All" => "Alle ansehen",
"Msg" => "Nachricht",
"Can't parse remote HTML page" => "Kann externe HTML-Seite nicht verarbeiten",
"Permission denied you cannot remove pages" => "Berechtigung zum Entfernen von Seiten nicht vorhanden",
"Cannot write to this file" => "Kann diese Datei nicht schreiben",
"Missing title or body when trying to post a comment" => "Fehlender Titel oder Textk&ouml;rper beim Posten eines Kommentars",
"\\n for rows" => "\\n f&uuml;r Spalten",
"Consider we are in always in HTTPS, but do not check" => "Gehe von HTTPS aus, aber pr&uuml;fe nicht nach",
"Newsletter subscription information at " => "Newsletter Registrierungsinfos auf ",
"Changes" => "&Auml;nderungen",
"Hold down CTRL to select multiple categories" => "Zum Markieren mehrerer Kategorien STRG gedr&uuml;ckt halten",
"categorize this object" => "Dieses Objekt kategorisieren",
"Uncheck the above checkbox to uncategorize this page/object" => "Die Checkboxmarkierung l&ouml;schen um die Kategorien von dieser Seite/diesem Objekt zu entfernen",
"Your account request have been stored and will be activated by the admin as soon as possible." => "Die Anfrage wurde gespeichert und wird vom Administrator schnellst m&ouml;glich bearbeitet.",
"New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Neuer Artikel erschienen: {\$mail_title} von {\$mail_user} am {\$mail_date|tiki_short_datetime}",
"Syntax highlighting" => "Syntax-Highlighting",
"MyTiki Home" => "Mein Tiki-Startseite",
"My Files" => "Meine Dateien",
"Mini calendar" => "Mini-Kalender",
"User list" => "Benutzerliste",
"Send Pages" => "Seiten verschicken",
"Received pages" => "Erhaltene Seiten",
"New Article" => "Neuer Artikel",
"Admin Posts" => "Eintr&auml;ge verwalten",
"Submit a New Link" => "Neuen Link eintragen",
"Browse directory" => "Verzeichnis durchst&ouml;bern",
"Admin Directory" => "Linkverzeichnis verwalten",
"Layer Management" => "Layer Management",
"List quizzes" => "Quiz auflisten",
"List trackers" => "Tracker auflisten",
"Ephemerides Admin" => "Terminkalender verwalten",
"Charts Admin" => "Hitlisten verwalten",
"Debugger console" => "Debug-Konsole",
"I forgot my pass" => "Ich habe mein Pa&szlig;wort vergessen",
"Send trackback pings to:" => "Trackback pings senden an:",
"(comma separated list of URIs)" => "(kommagetrennte URI-Liste)",
"This is" => "Dies ist",
"by the" => "von der",
"Tiki community" => "Tiki Community",
"User identity features" => "Benutzeridentit&auml;ts-Einstellungen",
"Tikiwiki version" => "Tikiwiki Version",
"Use URI as Home Page" => "URI als Home-Seite benutzen",
"OS" => "Betriebssystem",
"Enable Smarty Security (e.g. do not allow php code in smarty templates)" => "Smarty Sicherheit aktivieren (z.B. keinen PHP-Code in Smarty Templates erlauben)",
"Log Mail in Tiki Logs:" => "eMails im Log protokollieren:",
"Log SQL:" => "SQL protokollieren:",
"Default charset for sending mail:" => "Standard-Kodierung ausgehender eMails:",
"Mail end of line:" => "Zeilenende in eMails:",
"Disallow access to the site (except for those with permission)" => "Zugriff auf den Server verbieten (au&szlig;er f&uuml;r Personen mit Berechtigung)",
"Message to display when site is closed" => "Angezeigte Meldung, wenn der Server geschlossen ist",
"Disallow access when load is above the threshold (except for those with permission)" => "Zugriff auf den Server bei &Uuml;berschreiben der eingestellten Maximallast verbieten (au&szlig;er f&uuml;r Personen mit Berechtigung)",
"Max average server load threshold in the last minute" => "H&ouml;chste Durchschnittslast in der letzten Minute",
"Message to display when server is too busy" => "Angezeigte Meldung, wenn der Server &uuml;berlastet ist",
"Use cache for external images" => "Cache f&uuml;r externe Bilder benutzen",
"Use gzipped output" => "Ausgabe durch gzip",
"output compression is active." => "Ausgabe-Komprimierung ist aktiv.",
"compression is handled by" => "Komprimierung erfolgt durch",
"Sender Email" => "eMail-Absender",
"Allow anonymous users to \"Contact Us\"" => "\"Kontaktiere uns\" Feature f&uuml;r Anonym erlauben",
"contact feature disabled" => "Kontakt-Funktion deaktiviert",
"Session lifetime in minutes" => "Session-Lebenszeit in Minuten",
"Proxy Host" => "Proxy Server",
"Proxy port" => "Proxy Port",
"Please expect not found help-pages with the default-URL." => "Teilweise fehlen die Hilfeseiten noch.",
"Any help with the documentation is welcome." => "Hilfe bei der Dokumentation ist willkommen.",
"Release check" => "Auf neue Version pr&uuml;fen",
"Release checks are made when you browse admin main page only" => "Die &Uuml;berpr&uuml;fung wird beim Aufruf der Admin-Hauptseite durchgef&uuml;hrt",
"Force immediate check" => "Jetzt pr&uuml;fen",
"When possible, show the real user name instead of login:" => "Zeige vollen Namen statt Benutzerkennen (sofern vorhanden):",
"Locations separator" => "Trennzeichen zwischen Locations",
"Choices separator" => "Auswahl Abgrenzer",
"User registration and login" => "Benutzerregistrierung und -login",
"Use WebServer authentication for Tiki" => "Webserver-Authentifizierung f&uuml;r Tiki benutzen",
"... but need admin validation" => "... ben&ouml;tigen aber Best&auml;tigung durch den Admin",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Die <a href=\"tiki-admin.php?page=general\">Sendeadresse</a> mu&szlig; gesetzt sein",
"Create a group for each user <br />(with the same name as the user)" => "F&uuml;r jeden Benutzer eine eigene<br />Gruppe anlegen (Gruppenname = Benutzername)",
"Use tracker for more user information" => "Tracker f&uuml;r weitere Benutzer-Informationen benutzen",
"Use tracker for more group information" => "Tracker f&uuml;r weitere Gruppen-Informationen benutzen",
"Request passcode to register" => "Passcode zur Registrierung abfragen",
"Php GD library required" => "Php GD Bibliothek erforderlich",
"Use login as email" => "Login als eMail-Adresse benutzen",
"Validate users by email" => "Benutzer per eMail validieren",
"Validate user email server" => "Mailserver des Benutzers validieren",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Pa&szlig;worterinnerungen per eMail (wenn \"Pa&szlig;w&ouml;rter im Klartext speichern\" aktiviert ist.) Sonst, Pa&szlig;w&ouml;rter per eMail zur&uuml;cksetzen",
"Store plaintext passwords" => "Speichere Klartext-Pa&szlig;w&ouml;rter",
"Crypt passwords method" => "Pa&szlig;wort-Verschl&uuml;sselung",
"Reg users can change password" => "Reg. Benutzer k&ouml;nnen Pa&szlig;wort &auml;ndern",
"Reg users can change language" => "Reg. Benutzer k&ouml;nnen Sprache &auml;ndern",
"Restrict available languages" => "Verf&uuml;gbare Sprachen einschr&auml;nken",
"Available languages:" => "Verf&uuml;gbare Sprachen:",
"Minimum username length" => "Minimall&auml;nge Benutzername",
"Maximum username length" => "Maximall&auml;nge Benutzername",
"Force lowercase username" => "Nur Kleinbuchstaben im Benutzernamen",
"Force to use chars and nums in passwords" => "Erzwinge Benutzung von Buchstaben und Zahlen in Pa&szlig;w&ouml;rtern",
"Minimum password length" => "Minimale Pa&szlig;wortl&auml;nge",
"Password invalid after days" => "Tage bis zur Ung&uuml;ltigkeit des Pa&szlig;wortes",
"-1 for never" => "-1 f&uuml;r niemals",
"Re-validate user by email after days" => "Tage bis der Benutzer erneut per eMail validiert wird",
"Re-validate user by email after unsuccessful logins" => "Fehlgeschlagene Anmeldungen, nach denen der Benutzer erneut per eMail validiert wird",
"Generate a password option" => "Option zum automatischen Passwort-Erstellen anzeigen",
"Remember me feature" => "Erkenne mich-Funktion",
"Duration:" => "Dauer:",
"Remember me name" => "Erkenne mich-Name",
"Remember me domain" => "Erkenne mich-Domain",
"Remember me path" => "Erkenne mich-Pfad",
"Protect against CSRF with a confirmation step" => "Durch Best&auml;tigungs-Schritt gegen CSRF sch&uuml;tzen",
"Highlight Group" => "Gruppe hervorheben",
"User can choose beyond these groups at registration time" => "Benutzer kann beim Registrieren zwischen diesen Gruppen w&auml;hlen",
"Specify the fields that will be asked in admin->groups" => "Definiere die zus&auml;tzlicen Felder in Admin->Gruppen",
"Displays user's contribution in the user information page" => "Zeigt die Nutzeraktivit&auml;t auf der Benutzer-Infoseite an",
"Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …" => "Zeige diese UserTracker-Infos auf der Benutzerseite an. Format: trackerId, fieldId1, fieldId2, ...",
"Deactivate login autocomplete (do not remember login and password)" => "Automatisches Vervollst&auml;ndigen beim Login abschalten (Kennung und Passwort nicht merken)",
"On permission denied, display login box for anonymous:" => "Bei Zugriffsfehlermeldung f&uuml;r anonyme Benutzer die Loginbox anzeigen:",
"On permission denied, send to this url:" => "Bei Zugriffsfehlermeldung auf diese Seite springen:",
"Create user if not in Tiki?" => "Benutzer anlegen falls im Tiki nicht vorhanden?",
"Create user if not in Auth?" => "Benutzer anlegen falls in Auth nicht vorhanden?",
"Just use Tiki auth for admin?" => "Nur Tiki-Authentifizierung f&uuml;r Administrator?",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "LDAP URL<br />(wenn gesetzt werden Host und Port (s.u.) nicht benutzt)",
"LDAP User DN" => "LDAP Benutzer DN",
"LDAP User Attribute" => "LDAP Benutzer Attribut",
"LDAP User OC" => "LDAP Benutzer OC",
"LDAP Group DN" => "LDAP Gruppen DN",
"LDAP Group Attribute" => "LDAP Gruppen Attribut",
"LDAP Group OC" => "LDAP Gruppen OC",
"LDAP Member Attribute" => "LDAP Member Attribut",
"LDAP Admin User" => "LDAP Admin Benutzername",
"LDAP Admin Pwd" => "LDAP Admin Passwort",
"CAS server hostname" => "CAS Server Hostname",
"CAS server port" => "CAS Server Port",
"CAS server path" => "CAS Server Pfad",
"Change CAS preferences" => "Einstellungen &uuml;bernehmen",
"Valid Affiliations (separated by commas)" => "G&uuml;ltige Zugeh&ouml;rigkeiten (kommagetrennt)",
"Create with default group?" => "Standardgruppe erstellen?",
"Default group: " => "Standardgruppe",
"Change Shibboleth preferences" => "Einstellungen &uuml;bernehmen",
"Users Defaults" => "Standardeinstellungen der Benutzer",
"Change users defaults" => "Einstellungen &uuml;bernehmen",
"Meta Keywords" => "Schl&uuml;sselw&ouml;rter",
"Meta Description" => "Beschreibung",
"Meta Author" => "Autor",
"meta robots" => "Meta Robots",
"revisit after" => "erneut besuchen nach",
"Allow Smileys" => "Smileys erlauben",
"Use File Galleries for images inclusion" => "Bildergalerien f&uuml;r Bildeinbindung in Seiten erlauben",
"Hotwords in New Windows" => "Hotwords in neuem Fenster",
"Trackers attachments preferences" => "Einstellungen f&uuml;r Tracker Anh&auml;nge",
"Trackers attachments" => "Tracker Anh&auml;nge",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Zum einfachen Erstellen/Bearbeiten von Wikiseiten das Modul quick_edit hinzuf&uuml;gen &uuml;ber Men&uuml;punkt \"Module\" im Seitenbalken oder",
"Create a Tag for the Current Wiki" => "Tag f&uuml;r die aktuelle Wikiseite erstellen",
"Restore the Wiki" => "Wikiseiter wiederherstellen",
"restore" => "wiederherstellen",
"Remove a Tag" => "Tag entfernen",
"Wiki Comments Settings" => "Einstellungen f&uuml;r Wiki-Kommentare",
"Wiki Home Page" => "Wiki-Home-Page",
"Wiki Discussion" => "Wiki Diskussion",
"Wiki Link Format" => "Wiki Link Erkennung",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Definiert, welche <i>((Strings))</i> in Wiki Links umgewandelt werden",
"Wiki Page List Configuration" => "Einstellungen f&uuml;r Wikiliste",
"Wiki 3D Browser Configuration" => "Wiki 3D Browser Konfiguration",
"Wiki Features" => "Wiki-Funktionen",
"Print Page:" => "Seite drucken:",
"Allow HTML:" => "HTML erlauben:",
"Show page version:" => "Seitenversion anzeigen:",
"Regex search and replace:" => "Regex Suchen und Ersetzen:",
"Wiki History" => "Wiki Historie",
"Wiki Watch" => "Wiki Beobachtung",
"Enable watches on comments:" => "Beobachtungspunkte auf Kommentaren aktivieren:",
"Watch minor:" => "Geringf&uuml;gige &Auml;nderungen beobachten:",
"More Links" => "Weitere Links",
"Admin Charts" => "Hitlisten verwalten",
"Add new rule" => "Neue Regel hinzuf&uuml;gen",
"EMail notifications" => "eMail-Benachrichtigungen",
"Edit this RSS module:" => "Dieses RSS-Modul bearbeiten:",
"Create new RSS module" => "Neues RSS-Modul erstellen",
"Tikiwiki settings" => "Tiki Einstellungen",
"Create/edit questions for survey" => "Fragen f&uuml;r Umfrage erstellen/bearbeiten",
"Active?" => "Aktiv?",
"Create Trackers" => "Tracker anlegen",
"Create/Edit Trackers" => "Tracker hinzuf&uuml;gen/bearbeiten",
"Assign to Groups" => "Zu Gruppen hinzuf&uuml;gen",
"show help" => "Hilfe zeigen",
"Delete this type" => "Diesen Typ l&ouml;schen (nur wenn keine Artikel dieses Typs vorhanden sind)",
"level configuration" => "Level-Konfiguration",
"Browse gallery" => "Galerie durchsehen",
"Upload from disk" => "Hochladen von Disk",
"Browse file gallery" => "Dateiarchiv durchsehen",
"Directory batch" => "Aus Verzeichnis einlesen",
"Browsing Image" => "Bild ansehen",
"Zoom" => "Zoomen",
"Again please" => "Bitte nochmal",
"Admin category relationships" => "Beziehungen zwischen Kategorien verwalten",
"Validate links" => "Links &uuml;berpr&uuml;fen",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "Dateien mit angeh&auml;ngtem -{\$user} sind editierbar, andere sind schreibgesch&uuml;tzt, aber als Vorlage verwendbar.",
"Im- Export Languages" => "Sprachen im/exportieren",
"Create a file gallery" => "Dateiarchiv anlegen",
"Support tickets" => "Support-Ticket",
"Return to HomePage" => "Zur&uuml;ck zur Hauptseite",
"Stats for this survey Questions " => "Statistik f&uuml;r diese Umfrage-Frage ",
"Batch upload" => "Batch hochladen",
"1 suggestion" => "1 Vorschlag",
"suggestions" => "Vorschl&auml;ge",
"Minor Edit" => "geringf&uuml;gig",
"The \"Snarf Wikiplugin\" is installed. It can be used by wiki editors to include pages from the local network and via regex replacement create any html." => "Das \"Snarf Wikiplugin\" ist installiert. Es kann verwendet werden um Seiten aus dem lokalen Netzwerk via RegEx in HTML ausdr&uuml;cken.",
"The \"Regex Wikiplugin\" is installed. It can be used by wiki editors to create any html via regex replacement." => "Das \"Regex Wikiplugin\" ist installiert. Es kann verwendet werden um HTML Code durch RegEx zu ersetzen.",
"You can not download files" => "Du darst keine Dateien herunterladen",
"Please wait 2 minutes between posts" => "Bitte zwei Minuten zwischen Posts warten",
"The text in RED is" => "Der Text in ROT ist",
"Show Categories" => "Kategorien zeigen",
"Hide Categories" => "Kategorien verbergen",
"Wiki page %s changed" => "Die Wiki Seite %s wurde ge&auml;ndert",
"Blog features" => "Blog-Funktionen",
"Blog level comments" => "Kommentare auf Blog-Ebene",
"Post level comments" => "Kommentare auf Blogeintrag-Ebene",
"Post level trackback pings" => "Trackback Pings auf Blogeintrag-Ebene",
"Spellchecking" => "Rechtschreibpr&uuml;fung",
"Default ordering for blog listing" => "Standardsortierung f&uuml;r Blog-Listen",
"Blog listing configuration (when listing available blogs)" => "Einstellungen Blog-Liste (f&uuml;r Liste der verf&uuml;gbaren Blogs)",
"Last modification time" => "&Auml;nderungszeit",
"Blog comments settings" => "Blog-Kommentareinstellungen",
"Group calendar sticky popup" => "Sticky PopUp f&uuml;r Gruppenkalender",
"Group calendar item view tab" => "Elementanzeigespalte f&uuml;r Gruppenkalender",
"Calendar manual selection of time/date" => "manuelle Auswahl von Zeit/Datum im Kalender",
"Show Category Path" => "Kategorie-Pfad zeigen",
"Show Category Objects" => "Kategorie-Objekte anzeigen",
"CMS features" => "Artikel-Funktionen",
"Use templates" => "Vorlagen benutzen",
"Print article" => "Artikel drucken",
"Settings for page articles home" => "Einstellungen f&uuml;r die Artikel-Startseite",
"Maximum number of articles in home" => "Maximale Anzahl von Artikeln auf der Artikel-Startseite",
"Article comments settings" => "Artikelkommentareinstellungen",
"Fields to display on page" => "Folgende Felder anzeigen auf der Seite",
"Expire Date" => "Ablaufdatum",
"License Page" => "Lizenzseite",
"Submit Notice" => "Nachricht einstellen",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Dateiarchive hinzuf&uuml;gen/l&ouml;schen &uuml;ber Men&uuml;punkt 'Dateiarchive' im Men&uuml; im Seitenbalken oder",
"Uploaded filenames must match regex" => "Hochgeladene Dateinamen m&uuml;ssen diese RegEx erf&uuml;llen",
"Uploaded filenames cannot match regex" => "Hochgeladene Dateinamen d&uuml;rfen dieser RegEx nicht entsprechen",
"File galleries comments settings" => "Dateiarchiv-Kommentareinstellungen",
"File galleries search indexing" => "Dateiarchiv Suchindex",
"Leave command blank to delete handler" => "'Systembefehl' leer lassen, damit keine Aktion ausgef&uuml;hrt wird.",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Platzhalter %1 benutzen, wo der Dateiname eingesetzt werden soll (Beispiel: 'strings %1' benutzen um das Dokument &uuml;ber den Unix-Befehl strings in reinen Text zu konvertieren.)",
"Enable auto indexing on file upload or change" => "Indizierung bei Dateiupload oder &Auml;nderung automatisch aktivieren",
"System command" => "Systembefehl",
"Home Forum" => "Hauptforum",
"Forums features" => "Foren-Einstellungen",
"Forum quick jumps" => "Foren Schnellspr&uuml;nge",
"Ordering for forums in the forum listing" => "Sortierung der Foren in Forenliste",
"Forum listing configuration" => "Konfiguration Forenliste",
"I18n setup" => "I18n Konfiguration (Mehrsprachigkeit)",
"Show Babelfish Translation URLs" => "Babelfish &Uuml;bersetzungslink zeigen",
"Show Babelfish Translation Logo" => "Babelfish &Uuml;bersetzungs-Logo zeigen",
"Show Module Controls" => "Modul-Verschiebebuttons zeigen",
"Users can Configure Modules" => "Benutzer k&ouml;nnen Module konfigurieren",
"Users can Shade Modules" => "Benutzer kann Module minimieren",
"module decides" => "Modul entscheidet",
"Allow Anonymous Poll Voting" => "Anonyme Teilnehmer bei Umfragen erlauben",
"seconds (0 = cache inactive)" => "Sekunden (0 = Cache deaktiviert)",
"Performance issues" => "Performance-Einstellungen",
"Search features" => "Suche Einstellungen",
"SearchStats" => "Such-Statistik",
"Settings for searching content" => "Einstellung f&uuml;r die Suche in Inhalten",
"Search refresh rate" => "Suche Refreshrate",
"0 for no refresh" => "0 f&uuml;r nicht aktualisieren",
"this survey stats" => "Statistik dieser Umfrage",
"bold" => "fett",
"italic" => "kursiv",
"underline" => "unterstreichen",
"theme" => "Theme",
"unread private messages" => "ungelesene pers&ouml;nliche Nachrichten",
"you or someone registered this email address at" => "Sie oder jemand anderes hat Ihre eMail-Adresse bei",
"Your Tiki information registration" => "Ihre Tiki Registrierungsinformationen",
"left/right" => "links/rechts",
"Unassign module" => "Modul wegnehmen",
"home" => "Hauptseite",
"chat" => "Chat",
"contact us" => "Kontaktiere uns",
"debugger console" => "Debug-Konsole",
"MyMenu" => "Mein Men&uuml;",
"User menu" => "Benutzer-Men&uuml;",
"dump" => "Datenbankabzug",
"rankings" => "Bewertungen",
"orphan pages" => "Verwaiste Seiten",
"sandbox" => "Sandbox",
"received pages" => "Empfangene Seiten",
"structures" => "Strukturen",
"Articles Home" => "Artikel Hauptseite",
"Send articles" => "Artikel senden",
"Create/Edit Blog" => "Blog hinzuf&uuml;gen/bearbeiten",
"Browse Directory" => "Verzeichnis durchst&ouml;bern",
"Admin FAQs" => "FAQs verwalten",
"Edit mapfiles" => "Kartendateien bearbeiten",
"Admin quiz" => "Quiz verwalten",
"Admin trackers" => "Tracker verwalten",
"Send newsletters" => "Newsletter versenden",
"Ephemerides" => "Terminkalender",
"Admin home" => "Verwaltung Hauptseite",
"Edit languages" => "Sprachen bearbeiten",
"External wikis" => "Externe Wikis",
"Mods Admin" => "MODs verwalten",
"UsrMenu" => "Benutzer-Men&uuml;",
"Click here to manage your personal menu" => "Klicken Sie hier zum &Auml;dern ihres pers&ouml;nlichen Men&uuml;s",
"Quick edit a Wiki page" => "Schnellbearbeitung einer Wiki-Seite",
"Language: " => "Sprache: ",
"Sort posts by:" => "Eintr&auml;ge sortieren nach:",
"read more" => "mehr lesen",
"Pass" => "Pa&szlig;wort",
"HTTPS login" => "HTTPS-Login",
"System Admin" => "System Verwaltung",
"some text" => "Ein Text",
"Creates a box with the data" => "Erzeugt eine Box mit den Daten",
"creates a title bar" => "erzeugt einen Titelbalken",
"creates a table" => "erzeugt eine Tabelle",
"makes a horizontal rule" => "erzeugt einen horizontalen Balken",
"page|desc" => "Seite|Beschr.",
"displays an image" => "zeigt ein Bild an",
"Non cacheable images" => "Ungecachte Bilder",
"height width desc link and align are optional" => "height width desc link und align sind optional",
"Wiki File Attachments" => "Wiki Dateianh&auml;nge",
"displays rss feed with id=n maximum=m items" => "RSS-Feed mit id=n maximum=m Eintr&auml;gen",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Wird mit dem tats&auml;chlichen Wert des dynamischen Inhaltsblocks mit id=n ersetzt",
"Misc" => "Verschiedenes",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Bevor sie ihre Tiki Installation aktualisieren, lesen sie bitte die <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade-Anweisungen</a>",
"Click to Navigate" => "Zum Navigieren anklicken",
"Focus:" => "Fokus:",
"Tiki User Registration Request" => "Anfrage Tiki Benutzerregistrierung",
"Tiki email notification" => "Tiki eMail-Benachrichtigung",
"Your Tiki account information for %s" => "Ihre Tiki-Accountinformationen f&uuml;r %s",
"Reg users can change theme" => "Reg. Benutzer k&ouml;nnen Theme &auml;ndern",
"Create/Edit Newsletters" => "Newsletters hinzuf&uuml;gen/bearbeiten",
"Tiki Shoutbox" => "Tiki-Shoutbox",
"Name length" => "Namensl&auml;nge",
"Perform action with selected" => "Aktion auf alle markierten ausf&uuml;hren",
"Tiki cannot find a database connection" => "Tiki findet keine Datenbankverbindung",
"Database type" => "Database type",
"Database name" => "Datenbank Name",
"This site has an admin account configured" => "Diese Seite ben&ouml;tigt die Rechte des admin",
"Author if not the file creator" => "Schreiber ist nicht Dateiersteller",
"Tracker Item" => "Tracker-Eintrag",
"Allow sites in this category" => "Links in dieser Kategorie erlauben",
"Show number of sites in this category" => "Anzahl der Links in dieser Kategorie anzeigen",
"Subcategories" => "Unterkategorien",
"Admin related categories" => "Verwandte Kategorien verwalten",
"Add a Category" => "Kategorie hinzuf&uuml;gen",
"in current category" => "in der ausgew&auml;hlten Kategorie",
"Total categories" => "Themen gesamt",
"Days online" => "Tage online",
"View object" => "Objekt betrachten",
"Not enable for this type of object" => "nicht aktivieren f&uuml;r diesen Objekttyp",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "Cookies must be allowed to vote" => "Cookies must be allowed to vote",
// "This forum is flat and doesn't allow replies to other replies" => "This forum is flat and doesn't allow replies to other replies",
// "Tiki is unable to connect to the database " => "Tiki is unable to connect to the database ",
// "Tiki was unable to retrieve login data from the database " => "Tiki was unable to retrieve login data from the database ",
// "The following error message was returned" => "The following error message was returned",
// "Things to check" => "Things to check",
// "Is your database up and running" => "Is your database up and running",
// "Are your database login credentials correct" => "Are your database login credentials correct",
// "Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Did you complete the <a href='tiki-install.php' >Tiki Installer",
// "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information",
// "ID" => "ID",
// "Name" => "Name",
// "Explorer" => "Explorer",
// "Slideshow" => "Slideshow",
// "Default View" => "Default View",
// "Afghanistan" => "Afghanistan",
// "Aland Islands" => "Aland Islands",
// "Aland_Islands" => "Aland_Islands",
// "American Samoa" => "American Samoa",
// "American_Samoa" => "American_Samoa",
// "Anguilla" => "Anguilla",
// "Belize" => "Belize",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Bosnia_and_Herzegovina" => "Bosnia_and_Herzegovina",
// "Bouvet Island" => "Bouvet Island",
// "Bouvet_Island" => "Bouvet_Island",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "British_Indian_Ocean_Territory" => "British_Indian_Ocean_Territory",
// "British_Virgin_Islands" => "British_Virgin_Islands",
// "Burkina Faso" => "Burkina Faso",
// "Burkina_Faso" => "Burkina_Faso",
// "Cape Verde" => "Cape Verde",
// "Cape_Verde" => "Cape_Verde",
// "Catalan Countries" => "Catalan Countries",
// "Catalan_Countries" => "Catalan_Countries",
// "Cayman Islands" => "Cayman Islands",
// "Cayman_Islands" => "Cayman_Islands",
// "Central African Republic" => "Central African Republic",
// "Central_African_Republic" => "Central_African_Republic",
// "Christmas Island" => "Christmas Island",
// "Christmas_Island" => "Christmas_Island",
// "Cocos Islands" => "Cocos Islands",
// "Cocos_Islands" => "Cocos_Islands",
// "Comoros" => "Comoros",
// "Congo Democratic" => "Congo Democratic",
// "Congo" => "Congo",
// "Congo_Democratic" => "Congo_Democratic",
// "Cook Islands" => "Cook Islands",
// "Cook_Islands" => "Cook_Islands",
// "Costa Rica" => "Costa Rica",
// "Costa_Rica" => "Costa_Rica",
// "Czech Republic" => "Czech Republic",
// "Czech_Republic" => "Czech_Republic",
// "Djibouti" => "Djibouti",
// "Dominican Republic" => "Dominican Republic",
// "Dominican_Republic" => "Dominican_Republic",
// "El Salvador" => "El Salvador",
// "El_Salvador" => "El_Salvador",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Equatorial_Guinea" => "Equatorial_Guinea",
// "Eritrea" => "Eritrea",
// "Falkland Islands" => "Falkland Islands",
// "Falkland_Islands" => "Falkland_Islands",
// "Faroe Islands" => "Faroe Islands",
// "Faroe_Islands" => "Faroe_Islands",
// "Federated States of Micronesia" => "Federated States of Micronesia",
// "Federated_States_of_Micronesia" => "Federated_States_of_Micronesia",
// "French Guiana" => "French Guiana",
// "French Polynesia" => "French Polynesia",
// "French Southern Territories" => "French Southern Territories",
// "French_Guiana" => "French_Guiana",
// "French_Polynesia" => "French_Polynesia",
// "French_Southern_Territories" => "French_Southern_Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Guinea Bissau" => "Guinea Bissau",
// "Guinea_Bissau" => "Guinea_Bissau",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Heard_Island_and_McDonald_Islands" => "Heard_Island_and_McDonald_Islands",
// "Hong Kong" => "Hong Kong",
// "Hong_Kong" => "Hong_Kong",
// "Isle of Man" => "Isle of Man",
// "Ivory Coast" => "Ivory Coast",
// "Ivory_Coast" => "Ivory_Coast",
// "Jersey" => "Jersey",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Maldives" => "Maldives",
// "Marshall Islands" => "Marshall Islands",
// "Marshall_Islands" => "Marshall_Islands",
// "Mayotte" => "Mayotte",
// "Moldova" => "Moldova",
// "Mongolia" => "Mongolia",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
// "Myanmar" => "Myanmar",
// "Netherlands Antilles" => "Netherlands Antilles",
// "Netherlands_Antilles" => "Netherlands_Antilles",
// "New Caledonia" => "New Caledonia",
// "New Zealand" => "New Zealand",
// "New_Caledonia" => "New_Caledonia",
// "New_Zealand" => "New_Zealand",
// "Norfolk Island" => "Norfolk Island",
// "Norfolk_Island" => "Norfolk_Island",
// "North Korea" => "North Korea",
// "North_Korea" => "North_Korea",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "Northern_Mariana_Islands" => "Northern_Mariana_Islands",
// "Oman" => "Oman",
// "Palau" => "Palau",
// "Palestine" => "Palestine",
// "Papua New Guinea" => "Papua New Guinea",
// "Papua_New_Guinea" => "Papua_New_Guinea",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Puerto Rico" => "Puerto Rico",
// "Puerto_Rico" => "Puerto_Rico",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Republic_of_Macedonia" => "Republic_of_Macedonia",
// "Russian Federation" => "Russian Federation",
// "Russian_Federation" => "Russian_Federation",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Saint_Helena" => "Saint_Helena",
// "Saint_Kitts_and_Nevis" => "Saint_Kitts_and_Nevis",
// "Saint_Lucia" => "Saint_Lucia",
// "Saint_Pierre_and_Miquelon" => "Saint_Pierre_and_Miquelon",
// "San Marino" => "San Marino",
// "San_Marino" => "San_Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Sao_Tome_and_Principe" => "Sao_Tome_and_Principe",
// "Saudi Arabia" => "Saudi Arabia",
// "Saudi_Arabia" => "Saudi_Arabia",
// "Sierra Leone" => "Sierra Leone",
// "Sierra_Leone" => "Sierra_Leone",
// "Solomon Islands" => "Solomon Islands",
// "Solomon_Islands" => "Solomon_Islands",
// "South Africa" => "South Africa",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
// "South Korea" => "South Korea",
// "South_Africa" => "South_Africa",
// "South_Georgia_and_South_Sandwich_Islands" => "South_Georgia_and_South_Sandwich_Islands",
// "South_Korea" => "South_Korea",
// "Sri Lanka" => "Sri Lanka",
// "Sri_Lanka" => "Sri_Lanka",
// "St Vincent Grenadines" => "St Vincent Grenadines",
// "St_Vincent_Grenadines" => "St_Vincent_Grenadines",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Svalbard_and_Jan_Mayen" => "Svalbard_and_Jan_Mayen",
// "Syria" => "Syria",
// "Tajikistan" => "Tajikistan",
// "Trinidad Tobago" => "Trinidad Tobago",
// "Trinidad_Tobago" => "Trinidad_Tobago",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Turks_and_Caicos_Islands" => "Turks_and_Caicos_Islands",
// "US Virgin Islands" => "US Virgin Islands",
// "US_Virgin_Islands" => "US_Virgin_Islands",
// "United Arab Emirates" => "United Arab Emirates",
// "United Kingdom" => "United Kingdom",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "United States" => "United States",
// "United_Arab_Emirates" => "United_Arab_Emirates",
// "United_Kingdom" => "United_Kingdom",
// "United_Kingdom_-_England_and_Wales" => "United_Kingdom_-_England_and_Wales",
// "United_Kingdom_-_Northern_Ireland" => "United_Kingdom_-_Northern_Ireland",
// "United_Kingdom_-_Scotland" => "United_Kingdom_-_Scotland",
// "United_Nations_Organization" => "United_Nations_Organization",
// "United_States" => "United_States",
// "United_States_Minor_Outlying_Islands" => "United_States_Minor_Outlying_Islands",
// "Viet Nam" => "Viet Nam",
// "Viet_Nam" => "Viet_Nam",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Wallis_and_Futuna" => "Wallis_and_Futuna",
// "Western Sahara" => "Western Sahara",
// "Western_Sahara" => "Western_Sahara",
// "the former Yugoslav Republic of Macedonia" => "the former Yugoslav Republic of Macedonia",
// "the_former_Yugoslav_Republic_of_Macedonia" => "the_former_Yugoslav_Republic_of_Macedonia",
// "Text_Wiki libraries need to be installed. Please see http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter" => "Text_Wiki libraries need to be installed. Please see http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter",
// "MySQL Improved (mysqli). Requires MySQL 4.1+" => "MySQL Improved (mysqli). Requires MySQL 4.1+",
// "MySQL classic (mysql)" => "MySQL classic (mysql)",
// "PostgeSQL 7.2+" => "PostgeSQL 7.2+",
// "Oracle" => "Oracle",
// "Sybase" => "Sybase",
// "SQLLite" => "SQLLite",
// "MSSQL" => "MSSQL",
// "Email address not valid, test mail not sent" => "Email address not valid, test mail not sent",
// "Email address empty and \"copy\" checkbox not set, test mail not sent" => "Email address empty and \"copy\" checkbox not set, test mail not sent",
// "Test mail from Tiki installer " => "Test mail from Tiki installer ",
// "Tiki version" => "Tiki version",
// "PHP version" => "PHP version",
// "Server" => "Server",
// "Congratulations!\n\nYour server can send emails.\n\n" => "Congratulations!\n\nYour server can send emails.\n\n",
// "Slovene" => "Slovene",
// "Farsi" => "Farsi",
// "Galician" => "Galician",
// "Brazilian Portuguese" => "Brazilian Portuguese",
// "This instance of activity is already complete" => "This instance of activity is already complete",
// "Fatal error: nextActivity does not match any candidate in autorouting switch activity" => "Fatal error: nextActivity does not match any candidate in autorouting switch activity",
// "Fatal error: non-deterministic decision for autorouting activity" => "Fatal error: non-deterministic decision for autorouting activity",
// "Cannot add transition only split activities can have more than one outbound transition" => "Cannot add transition only split activities can have more than one outbound transition",
// "Circular reference found some activity has a transition leading to itself" => "Circular reference found some activity has a transition leading to itself",
// "is non-interactive and non-autorouted but has no role assigned" => "is non-interactive and non-autorouted but has no role assigned",
// "is not mapped" => "is not mapped",
// "Activity '.\$res['name'].' is standalone and is using the \$instance object" => "Activity '.\$res['name'].' is standalone and is using the \$instance object",
// "Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method",
// "Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method",
// "Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method",
// "newest" => "newest",
// "oldest" => "oldest",
// "Depends user language" => "Depends user language",
// "Creation Date (asc)" => "Creation Date (asc)",
// "Q and A" => "Q and A",
// "Question ID" => "Question ID",
// "utf-8" => "utf-8",
// "iso-8859-1" => "iso-8859-1",
// "CRLF (standard)" => "CRLF (standard)",
// "LF (some Unix MTA)" => "LF (some Unix MTA)",
// "1 hour" => "1 hour",
// "2 hours" => "2 hours",
// "10 hours" => "10 hours",
// "20 hours" => "20 hours",
// "1 year" => "1 year",
// "crypt-md5" => "crypt-md5",
// "crypt-des" => "crypt-des",
// "Shibboleth" => "Shibboleth",
// "OpenID and Tiki" => "OpenID and Tiki",
// "Admins" => "Admins",
// "Never use transition css" => "Never use transition css",
// "Use @version:x.x specified in theme css or none if not specified" => "Use @version:x.x specified in theme css or none if not specified",
// "Use @version:x.x specified in theme css or 1.9 if not specified" => "Use @version:x.x specified in theme css or 1.9 if not specified",
// "Use @version:x.x specified in theme css or 2.0 if not specified" => "Use @version:x.x specified in theme css or 2.0 if not specified",
// "Ascending" => "Ascending",
// "Descending" => "Descending",
// "No forums" => "No forums",
// "\$feature is turned on" => "\$feature is turned on",
// "\$feature is turned off" => "\$feature is turned off",
// "\$feature set to \" . \$featureStr));\n\t\t\t\t} else {\n\t\t\t\t\t\$tikilib->set_preference(\$feature, \$_POST[\$feature]);\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to \" . \$featureStr));\n\t\t\t\t}\n\t\t\t} else if( \$isMultiple ) {\n\n\n\t\t\t\tif ( \$pref != '' ) {\n\t\t\t\t\t\$tikilib->set_preference(\$pref, array());\n\t\t\t\t\t\$prefs[\$feature] = \$_POST[\$feature];\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to nothing" => "\$feature set to \" . \$featureStr));\n\t\t\t\t} else {\n\t\t\t\t\t\$tikilib->set_preference(\$feature, \$_POST[\$feature]);\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to \" . \$featureStr));\n\t\t\t\t}\n\t\t\t} else if( \$isMultiple ) {\n\n\n\t\t\t\tif ( \$pref != '' ) {\n\t\t\t\t\t\$tikilib->set_preference(\$pref, array());\n\t\t\t\t\t\$prefs[\$feature] = \$_POST[\$feature];\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to nothing",
// "\$feature set to nothing" => "\$feature set to nothing",
// "Error line: %d" => "Error line: %d",
// "Administration" => "Administration",
// "All Day" => "All Day",
// "Newsletter" => "Newsletter",
// "survey" => "survey",
// "(not registered)" => "(not registered)",
// "You have mistyped the anti-bot verification code; please try again" => "You have mistyped the anti-bot verification code; please try again",
// "Please wait %d secondes between posts" => "Please wait %d secondes between posts",
// "Invalid Email" => "Invalid Email",
// "Your message has been queued for approval, the message will be posted after a moderator approves it" => "Your message has been queued for approval, the message will be posted after a moderator approves it",
// "This forum is locked" => "This forum is locked",
// "This thread is locked" => "This thread is locked",
// "Those comments are locked" => "Those comments are locked",
// "Foo" => "Foo",
// "Sample plugin" => "Sample plugin",
// "Face" => "Face",
// "Font family to use" => "Font family to use",
// "As defined by CSS" => "As defined by CSS",
// "WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
// "WikiDiff::_check: failed" => "WikiDiff::_check: failed",
// "WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
// "WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
// "Newsletter subscription information at" => "Newsletter subscription information at",
// "Select a Wiki page to link to" => "Select a Wiki page to link to",
// "Cannot open this file" => "Cannot open this file",
// "This is an approximation based on your server memory limit" => "This is an approximation based on your server memory limit",
// "This is the value of your server's PHP '%s' setting" => "This is the value of your server's PHP '%s' setting",
// "You are alerted by the server " => "You are alerted by the server ",
// "You can check the modifications at : " => "You can check the modifications at : ",
// "You are alerted of a change on " => "You are alerted of a change on ",
// "Blog" => "Blog",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "Query point" => "Query point",
// "layer" => "layer",
// "Record" => "Record",
// "No valid ogr2ogr executable" => "No valid ogr2ogr executable",
// "Could not create \$tdo.mif in data directory" => "Could not create \$tdo.mif in data directory",
// "Could not create \$tdo.mid in data directory" => "Could not create \$tdo.mid in data directory",
// "User Map Generated in" => "User Map Generated in",
// "Image Map Generated in" => "Image Map Generated in",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "menu" => "menu",
// "File %s not found" => "File %s not found",
// "File %s is not a valid archive" => "File %s is not a valid archive",
// "Impossible to open %s : %s" => "Impossible to open %s : %s",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "This poll is closed" => "This poll is closed",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "The passwords do not match" => "The passwords do not match",
// "Feed provided by %s. Click to visit" => "Feed provided by %s. Click to visit",
// "FAQ" => "FAQ",
// "Forum" => "Forum",
// "Wiki Comment" => "Wiki Comment",
// "Calendar item" => "Calendar item",
// "_HOMEPAGE_CONTENT_" => "_HOMEPAGE_CONTENT_",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "First {\$params['itemname']}" => "First {\$params['itemname']}",
// "Last {\$params['itemname']}" => "Last {\$params['itemname']}",
// "Next {\$params['itemname']}" => "Next {\$params['itemname']}",
// "Prev {\$params['itemname']}" => "Prev {\$params['itemname']}",
// "You need either JQuery or MooTools enabled for this feature" => "You need either JQuery or MooTools enabled for this feature",
// "Help page" => "Help page",
// "Edit Template" => "Edit Template",
// "phplayers are not available on this site" => "phplayers are not available on this site",
// "Invert Sort" => "Invert Sort",
// "sec" => "sec",
// "No pageviews yet" => "No pageviews yet",
// "n/a" => "n/a",
// "You have to make %d choice(s) for the question" => "You have to make %d choice(s) for the question",
// "You have to make at least %d choice(s) for the question" => "You have to make at least %d choice(s) for the question",
// "You have to make less than %d choice(s) for the question" => "You have to make less than %d choice(s) for the question",
// "You have to choose at least %d choice(s) for the question" => "You have to choose at least %d choice(s) for the question",
// "Page '%0' cannot be found" => "Page '%0' cannot be found",
// "For the security of your password direct access to the feed is only available via https" => "For the security of your password direct access to the feed is only available via https",
// "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors",
// "An error occured in a database query" => "An error occured in a database query",
// "Help link" => "Help link",
// "Edit Plugin" => "Edit Plugin",
// "You are not allowed to upload this type of file" => "You are not allowed to upload this type of file",
// "The file you are trying upload was only partially uploaded" => "The file you are trying upload was only partially uploaded",
// "You must select a file" => "You must select a file",
// "Flash player not available" => "Flash player not available",
// "Altering database table failed" => "Altering database table failed",
// "__WARNING__: Plugin disabled \$plugin" => "__WARNING__: Plugin disabled \$plugin",
// "__WARNING__: No such module \$plugin" => "__WARNING__: No such module \$plugin",
// "Sea Surfing (CSRF) detected. Operation blocked" => "Sea Surfing (CSRF) detected. Operation blocked",
// "Upload was not successful. Duplicate file content " => "Upload was not successful. Duplicate file content ",
// "Item Modification" => "Item Modification",
// "View the tracker item at" => "View the tracker item at",
// "Field is not a link to mp3 in the gallery" => "Field is not a link to mp3 in the gallery",
// "Field is not a link to FLV in the gallery" => "Field is not a link to FLV in the gallery",
// "Field is not a link to FLV or MP3 in the gallery" => "Field is not a link to FLV or MP3 in the gallery",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>quicktags,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[quicktags]</strong> enables quicktags if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>quicktags,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[quicktags]</strong> enables quicktags if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "drop down with other textfield" => "drop down with other textfield",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "radio buttons" => "radio buttons",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "ip selector" => "ip selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example: \n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example: \n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>",
// "static text" => "static text",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "dynamic items list" => "dynamic items list",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "multimedia" => "multimedia",
// "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>",
// "auto-increment" => "auto-increment",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "user subscription" => "user subscription",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "computed field" => "computed field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "user preference" => "user preference",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its name (n), or display the username of the uploader (u);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its name (n), or display the username of the uploader (u);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "The administrator has not yet validated your account. Please wait" => "The administrator has not yet validated your account. Please wait",
// "You must validate your account first. An email has been sent to you" => "You must validate your account first. An email has been sent to you",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Department" => "Department",
// "Division" => "Division",
// "Job Title" => "Job Title",
// "User-Agent Info" => "User-Agent Info",
// "Displays various information about the client" => "Displays various information about the client",
// "Info required - IP|SVRSW|BROWSER" => "Info required - IP|SVRSW|BROWSER",
// "Anchor Link" => "Anchor Link",
// "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin",
// "Anchor link label" => "Anchor link label",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "The name of the wiki page containing the anchor" => "The name of the wiki page containing the anchor",
// "Puts a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which sets the location and name of the anchor" => "Puts a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which sets the location and name of the anchor",
// "Anchor Name" => "Anchor Name",
// "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin",
// "The name of the anchor" => "The name of the anchor",
// "Puts an anchor into a wiki page. Use in conjunction with the ALINK plugin, which makes links to the anchor" => "Puts an anchor into a wiki page. Use in conjunction with the ALINK plugin, which makes links to the anchor",
// "Image Annotation" => "Image Annotation",
// "Autogenerated content. Leave blank initially" => "Autogenerated content. Leave blank initially",
// "Absolute URL to the image or relative path from tikiwiki root" => "Absolute URL to the image or relative path from tikiwiki root",
// "Width" => "Width",
// "Image width" => "Image width",
// "Height" => "Height",
// "Image height" => "Image height",
// "Alignment" => "Alignment",
// "Image alignment. Possible values: left, right, center" => "Image alignment. Possible values: left, right, center",
// "Save changes to annotations" => "Save changes to annotations",
// "Image annotations changed" => "Image annotations changed",
// "Creates an annotation block for an image" => "Creates an annotation block for an image",
// "Displays an image and allow the users to define zones to highlight information on the image" => "Displays an image and allow the users to define zones to highlight information on the image",
// "Includes an article\\'s content within the page" => "Includes an article\\'s content within the page",
// "The article field to display. Default field is Heading" => "The article field to display. Default field is Heading",
// "Article ID" => "Article ID",
// "The article to display. If no value is provided, most recent article will be used" => "The article to display. If no value is provided, most recent article will be used",
// "Includes an article" => "Includes an article",
// "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
// "Id is optional. If not given, last article is used. Default field is heading" => "Id is optional. If not given, last article is used. Default field is heading",
// "Article List" => "Article List",
// "Includes a list of articles within the page" => "Includes a list of articles within the page",
// "Articles displayed" => "Articles displayed",
// "The amount of articles to display in the list" => "The amount of articles to display in the list",
// "Topics expression" => "Topics expression",
// "Topic ID expression" => "Topic ID expression",
// "Type expression" => "Type expression",
// "Category ID" => "Category ID",
// "The ID of the category to list from" => "The ID of the category to list from",
// "The article language to list" => "The article language to list",
// "Sort order" => "Sort order",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Quiet" => "Quiet",
// "Whether to not report when there are no articles" => "Whether to not report when there are no articles",
// "Title only" => "Title only",
// "Whether to only show the title of the articles" => "Whether to only show the title of the articles",
// "Show body" => "Show body",
// "Whether to only show the body of the articles or just the heading" => "Whether to only show the body of the articles or just the heading",
// "Starting article" => "Starting article",
// "The article number that the list should start with" => "The article number that the list should start with",
// "Start date" => "Start date",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "End date" => "End date",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings" => "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Includes articles listing into a wiki page" => "Includes articles listing into a wiki page",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "Bullets" => "Bullets",
// "Inline" => "Inline",
// "Number" => "Number",
// "Show icon" => "Show icon",
// "No such attachment on this page" => "No such attachment on this page",
// "Displays an attachment or a list of them" => "Displays an attachment or a list of them",
// "Gives the name of the attached file to link to" => "Gives the name of the attached file to link to",
// "Same as name" => "Same as name",
// "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages",
// "Shows the description as the link text instead of the file name" => "Shows the description as the link text instead of the file name",
// "Makes the list of attachments a bulleted list" => "Makes the list of attachments a bulleted list",
// "Says that this file is an image, and should be displayed inline using the img tag" => "Says that this file is an image, and should be displayed inline using the img tag",
// "Puts the stuff between {ATTACH} tags as the link text instead of the file name or description" => "Puts the stuff between {ATTACH} tags as the link text instead of the file name or description",
// "Shows all attachments from the whole wiki" => "Shows all attachments from the whole wiki",
// "Gives the number, in the list of attachments, of the attachment to link to" => "Gives the number, in the list of attachments, of the attachment to link to",
// "Gives the actual id of the attachment to link in. You probably should never use this" => "Gives the actual id of the attachment to link in. You probably should never use this",
// "Puts the number of downloads in the alt comment" => "Puts the number of downloads in the alt comment",
// "Shows a file icon" => "Shows a file icon",
// "Avatar" => "Avatar",
// "The wiki page the avatar will link to" => "The wiki page the avatar will link to",
// "Float" => "Float",
// "left|right" => "left|right",
// "Displays a link that allows to go back in the browser history" => "Displays a link that allows to go back in the browser history",
// "Insert back link on wiki page" => "Insert back link on wiki page",
// "Backlinks" => "Backlinks",
// "List all pages linking to the specified page" => "List all pages linking to the specified page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed information" => "Displayed information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "1|0" => "1|0",
// "No Header" => "No Header",
// "List all pages which link to specific pages" => "List all pages which link to specific pages",
// "Banner" => "Banner",
// "Insert a banner" => "Insert a banner",
// "Target" => "Target",
// "missing parameter" => "missing parameter",
// "Blog List" => "Blog List",
// "Use BLOGLIST to include posts from a blog" => "Use BLOGLIST to include posts from a blog",
// "Blog ID" => "Blog ID",
// "Numeric value" => "Numeric value",
// "Maximum number of entries to list" => "Maximum number of entries to list",
// "Simple list" => "Simple list",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "Latest date to select posts from" => "Latest date to select posts from",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// "where Id is the blog Id and Items is the max number of posts to display" => "where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "Box" => "Box",
// "Box title" => "Box title",
// "Displayed above the content" => "Displayed above the content",
// "Background color" => "Background color",
// "As defined by CSS, name or Hex code" => "As defined by CSS, name or Hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default value is 100%" => "In pixels or percentage. Default value is 100%",
// "Text Alignment" => "Text Alignment",
// "Float Position" => "Float Position",
// "for box with width lesser than 100%, make text wrap around the box" => "for box with width lesser than 100%, make text wrap around the box",
// "CSS Class" => "CSS Class",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "Category IDs" => "Category IDs",
// "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page",
// "Types" => "Types",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
// "Sort Order" => "Sort Order",
// "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle",
// "Split" => "Split",
// "And" => "And",
// "Category Orphans" => "Category Orphans",
// "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
// "Category Path" => "Category Path",
// "Separator" => "Separator",
// "String used to separate the categories in the path. Default character is >" => "String used to separate the categories in the path. Default character is >",
// "Display top category" => "Display top category",
// "yes|no, default to no" => "yes|no, default to no",
// "Center" => "Center",
// "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool",
// "Chart caption" => "Chart caption",
// "Sheet ID" => "Sheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic",
// "Chart Width" => "Chart Width",
// "Width in pixels" => "Width in pixels",
// "Chart Height" => "Chart Height",
// "Height in pixels" => "Height in pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independant series" => "Independant series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependant series" => "Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "List of colors to use" => "List of colors to use",
// "Styles" => "Styles",
// "List of styles to use" => "List of styles to use",
// "Labels" => "Labels",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "Caption" => "Caption",
// "Code snippet label" => "Code snippet label",
// "Word Wrap" => "Word Wrap",
// "0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Enable word wrapping on the code to avoid breaking the layout",
// "Colors" => "Colors",
// "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Line numbers" => "Line numbers",
// "0|1, may not be used with colors" => "0|1, may not be used with colors",
// "Wiki syntax" => "Wiki syntax",
// "0|1, parse wiki syntax within the code snippet" => "0|1, parse wiki syntax within the code snippet",
// "Right to left" => "Right to left",
// "0|1, switch the text display from left to right to right to left" => "0|1, switch the text display from left to right to right to left",
// "Content is HTML" => "Content is HTML",
// "0|1, display the content as is instead of escaping HTML special chars" => "0|1, display the content as is instead of escaping HTML special chars",
// "note: colors and ln are exclusive" => "note: colors and ln are exclusive",
// "Includes content from the dynamic content system" => "Includes content from the dynamic content system",
// "Content ID" => "Content ID",
// "Also known as Fortune cookies or Taglines" => "Also known as Fortune cookies or Taglines",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "Displays a countdown from now until the specified date" => "Displays a countdown from now until the specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date. Multiple formats accepted" => "Target date. Multiple formats accepted",
// "Locate Time" => "Locate Time",
// "on|off" => "on|off",
// "DBReport" => "DBReport",
// "Run a database report" => "Run a database report",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN name" => "Wiki DSN name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "0|1, parse wiki syntax within the report" => "0|1, parse wiki syntax within the report",
// "Debug" => "Debug",
// "0|1, display the parsed report definition" => "0|1, display the parsed report definition",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "You do not have permission to use this DSN" => "You do not have permission to use this DSN",
// "No DSN connection string found" => "No DSN connection string found",
// "Div" => "Div",
// "div|span|pre|b|i|tt|p|blockquote" => "div|span|pre|b|i|tt|p|blockquote",
// "left|right|center|justify" => "left|right|center|justify",
// "left|right, for box with width lesser than 100%, make text wrap around the box" => "left|right, for box with width lesser than 100%, make text wrap around the box",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML id" => "HTML id",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "Insert a division block on wiki page" => "Insert a division block on wiki page",
// "Definition List" => "Definition List",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "Draw" => "Draw",
// "Displays drawings in the wiki page" => "Displays drawings in the wiki page",
// "Name of the drawing to display" => "Name of the drawing to display",
// "Name parameter missing" => "Name parameter missing",
// "Equation" => "Equation",
// "Renders an equation written in LaTeX syntax as an image" => "Renders an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "Includes the list of events from a calendar in the page" => "Includes the list of events from a calendar in the page",
// "Calendar ID" => "Calendar ID",
// "Numeric" => "Numeric",
// "Maximum days" => "Maximum days",
// "Maximum Rows" => "Maximum Rows",
// "Datetime" => "Datetime",
// "0|1" => "0|1",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "Fade" => "Fade",
// "Displays a label. On click, the block of content will fade in and fade out" => "Displays a label. On click, the block of content will fade in and fade out",
// "Wiki syntax containing the text to display" => "Wiki syntax containing the text to display",
// "Label to display on first display" => "Label to display on first display",
// "Unspecified label" => "Unspecified label",
// "Fancy List" => "Fancy List",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use div" => "Use div",
// "Use div instead of ol" => "Use div instead of ol",
// "Class" => "Class",
// "CSS class of the fancylist" => "CSS class of the fancylist",
// "Creates a fancy looking list" => "Creates a fancy looking list",
// "num" => "num",
// "item text" => "item text",
// "one item per line" => "one item per line",
// "Fancy Table" => "Fancy Table",
// "One row per line, cells separated by ~|~" => "One row per line, cells separated by ~|~",
// "Heading row" => "Heading row",
// "Heading row of the table, same format as the body section" => "Heading row of the table, same format as the body section",
// "Heading CSS Class" => "Heading CSS Class",
// "CSS Class to apply on the heading row" => "CSS Class to apply on the heading row",
// "Displays a link to an attachment to a wiki page and can display an image attachment. " => "Displays a link to an attachment to a wiki page and can display an image attachment. ",
// "Gallery ID" => "Gallery ID",
// "name_asc" => "name_asc",
// "Shows ID" => "Shows ID",
// "Shows Icon" => "Shows Icon",
// "Shows Name" => "Shows Name",
// "Shows Filename" => "Shows Filename",
// "Shows Size" => "Shows Size",
// "Shows Description" => "Shows Description",
// "Shows Creation Date" => "Shows Creation Date",
// "Shows Hits" => "Shows Hits",
// "Shows Locked by" => "Shows Locked by",
// "Shows Modification Date" => "Shows Modification Date",
// "Shows Author" => "Shows Author",
// "Shows Creator" => "Shows Creator",
// "Shows Parent Gallery Name" => "Shows Parent Gallery Name",
// "Shows Number of Files" => "Shows Number of Files",
// "Shows the slideshow of a gallery" => "Shows the slideshow of a gallery",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "Displays a list of files from the File Gallery" => "Displays a list of files from the File Gallery",
// "Flash video" => "Flash video",
// "Displays a SWF on the wiki page" => "Displays a SWF on the wiki page",
// "Movie URL" => "Movie URL",
// "Complete URL to the movie to include" => "Complete URL to the movie to include",
// "Default width: 425" => "Default width: 425",
// "Default height: 350" => "Default height: 350",
// "Quality" => "Quality",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Footnote" => "Footnote",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "The footnote" => "The footnote",
// "Sameas" => "Sameas",
// "Tag to existing footnote" => "Tag to existing footnote",
// "CheckDuplicate" => "CheckDuplicate",
// "check for duplcate footnotes" => "check for duplcate footnotes",
// "Footnotearea" => "Footnotearea",
// "Inserts a section for collected footnotes within the wiki page" => "Inserts a section for collected footnotes within the wiki page",
// "Download box for a file on ftp server" => "Download box for a file on ftp server",
// "ftp" => "ftp",
// "file name" => "file name",
// "Ftp Server Name" => "Ftp Server Name",
// "Ftp User name" => "Ftp User name",
// "Ftp password" => "Ftp password",
// "Download button label" => "Download button label",
// "Connection failed" => "Connection failed",
// "Incorrect param" => "Incorrect param",
// "Gauge" => "Gauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "current value (REQUIRED)" => "current value (REQUIRED)",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: 100" => "Maximum possible value. Default: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Background Color" => "Background Color",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "true|false, if true then a percentage of the maximum is displayed" => "true|false, if true then a percentage of the maximum is displayed",
// "Display Value" => "Display Value",
// "true|false, if the numeric value is displayed" => "true|false, if the numeric value is displayed",
// "Bar height in pixels" => "Bar height in pixels",
// "Displays a graphical GAUGE" => "Displays a graphical GAUGE",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account number" => "Account number",
// "The account number for the site" => "The account number for the site",
// "Missing parameter" => "Missing parameter",
// "googledoc" => "googledoc",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "key" => "key",
// "Google doc key - for example pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe" => "Name of iframe",
// "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large",
// "Pixels or %" => "Pixels or %",
// "Margin Height" => "Margin Height",
// "Pixels" => "Pixels",
// "Margin Width" => "Margin Width",
// "Scrolling" => "Scrolling",
// "editLink" => "editLink",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Displays a Google document" => "Displays a Google document",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Display wiki text if user is in one of listed groups" => "Display wiki text if user is in one of listed groups",
// "HTML" => "HTML",
// "Include literal HTML in a Wiki page" => "Include literal HTML in a Wiki page",
// "0|1, parse wiki syntax within the html code" => "0|1, parse wiki syntax within the html code",
// "Include literal HTML" => "Include literal HTML",
// "URL" => "URL",
// "Iframe" => "Iframe",
// "Frame title" => "Frame title",
// "iframe" => "iframe",
// "Displays an iframe" => "Displays an iframe",
// " (experimental - possible successor to img in 4.0)" => " (experimental - possible successor to img in 4.0)",
// "File ID" => "File ID",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Image Source" => "Image Source",
// "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required" => "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required",
// "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded" => "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded",
// "Alias: lnk. Location the image should point to" => "Alias: lnk. Location the image should point to",
// "Link Relation" => "Link Relation",
// "\"rel\" attribute to add to the link" => "\"rel\" attribute to add to the link",
// "Link title" => "Link title",
// "Title text" => "Title text",
// "Image alt text" => "Image alt text",
// "Alternate text to display if impossible to load the image" => "Alternate text to display if impossible to load the image",
// "Alias:imalign. Image alignment in the page. (left, right)" => "Alias:imalign. Image alignment in the page. (left, right)",
// "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)" => "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)",
// "Image description to display on the page" => "Image description to display on the page",
// "Image Map" => "Image Map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)" => "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)",
// "CSS Style" => "CSS Style",
// "CSS styling to apply to the plugin. (Usually used in configuration rather than on individual images.)" => "CSS styling to apply to the plugin. (Usually used in configuration rather than on individual images.)",
// "Border options" => "Border options",
// "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options" => "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options",
// "Description options" => "Description options",
// "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)" => "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)",
// "Default configuration" => "Default configuration",
// "Default configuration definitions. (Usually used in configuration rather than on individual images.)" => "Default configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Mandatory configuration" => "Mandatory configuration",
// "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)" => "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content" => "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content",
// "Display an image" => "Display an image",
// "Displays an image" => "Displays an image",
// "Full URL to the image to display" => "Full URL to the image to display",
// "Alternate Text" => "Alternate Text",
// "Height of the image to display" => "Height of the image to display",
// "Width of the image to display" => "Width of the image to display",
// "Link Title" => "Link Title",
// "Image alignment in the page. (left, right, center) Uses HTML IMG tag" => "Image alignment in the page. (left, right, center) Uses HTML IMG tag",
// "Float Alignment" => "Float Alignment",
// "Image alignment in the flow of the document. (left, right, none) Uses CSS float property" => "Image alignment in the flow of the document. (left, right, none) Uses CSS float property",
// "Style to apply to the image" => "Style to apply to the image",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Page Name" => "Page Name",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Jabber" => "Jabber",
// "Runs a Java applet to access a local Jabber service" => "Runs a Java applet to access a local Jabber service",
// "Applet height in pixels" => "Applet height in pixels",
// "'),\n\t\t\t\t'description' => tra('Applet width in pixels" => "'),\n\t\t\t\t'description' => tra('Applet width in pixels",
// "'),\n\t\t\t\t'description' => tra('jabber.org" => "'),\n\t\t\t\t'description' => tra('jabber.org",
// "Default Color" => "Default Color",
// "255,255,255" => "255,255,255",
// "JQuery" => "JQuery",
// "Insert JQuery javascript code. Requires feature_jquery" => "Insert JQuery javascript code. Requires feature_jquery",
// " (experimental - may change in future versions)" => " (experimental - may change in future versions)",
// "JQuery Code" => "JQuery Code",
// "NotOnReady" => "NotOnReady",
// "NoJQuery" => "NoJQuery",
// "Optional markup for when feature_jquery is off" => "Optional markup for when feature_jquery is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$jq(\"img\\" => "jquery code e.g. \$jq(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Displays the text only if the language matchs" => "Displays the text only if the language matchs",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Result Count" => "Result Count",
// "Amount of results displayed in the list" => "Amount of results displayed in the list",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Structure Head" => "Structure Head",
// "Show Page Alias" => "Show Page Alias",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Exact Match" => "Exact Match",
// "Related to Find" => "Related to Find",
// "Only Orphan Pages" => "Only Orphan Pages",
// "For List Pages" => "For List Pages",
// "List Directory" => "List Directory",
// "Full path to the server-local directory" => "Full path to the server-local directory",
// "URL Prefix" => "URL Prefix",
// "Filter" => "Filter",
// ".ext" => ".ext",
// "Limit" => "Limit",
// "Maximum amount of files to display" => "Maximum amount of files to display",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
// "Displays a map" => "Displays a map",
// "Map File" => "Map File",
// "Extents" => "Extents",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "One of" => "One of",
// "Mini Quiz" => "Mini Quiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Tracker ID" => "Tracker ID",
// "Insert Module" => "Insert Module",
// "Module name as known in Tikiwiki" => "Module name as known in Tikiwiki",
// "Decoration" => "Decoration",
// "Flip" => "Flip",
// "Max" => "Max",
// "np" => "np",
// "notitle" => "notitle",
// "Displays a module inlined in page. More parameters can be added, not supported by UI" => "Displays a module inlined in page. More parameters can be added, not supported by UI",
// "Monospace" => "Monospace",
// "Font" => "Font",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Mouse Over" => "Mouse Over",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when moused-over text is clicked. Use http:// for external links" => "Destination link when moused-over text is clicked. Use http:// for external links",
// "Text" => "Text",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouse over box width. Default: 400px" => "Mouse over box width. Default: 400px",
// "Mouse over box height. Default: 200px" => "Mouse over box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified amount of pixels in relation to the cursor. Default: 5px" => "Shifts the overlay to the right by the specified amount of pixels in relation to the cursor. Default: 5px",
// "Offset Y" => "Offset Y",
// "Shifts the overlay to the bottom by the specified amount of pixels in relation to the cursor. Default: 0px" => "Shifts the overlay to the bottom by the specified amount of pixels in relation to the cursor. Default: 0px",
// "Parse Body" => "Parse Body",
// "y|n, parse the body of the plugin as wiki content. (Default to y)" => "y|n, parse the body of the plugin as wiki content. (Default to y)",
// "Color of the inside popup" => "Color of the inside popup",
// "Default: #F5F5F5" => "Default: #F5F5F5",
// "Text popup color" => "Text popup color",
// "#FFFFFF" => "#FFFFFF",
// "Sticky" => "Sticky",
// "Padding" => "Padding",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "fancy" => "fancy",
// "true|false" => "true|false",
// "wiki_classes" => "wiki_classes",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "Displays a table using MediaWiki syntax" => "Displays a table using MediaWiki syntax",
// "MySpace" => "MySpace",
// "MySpace Page" => "MySpace Page",
// "Displays a SWF myspace mp3 playlist on the wiki page" => "Displays a SWF myspace mp3 playlist on the wiki page",
// "Object Hits" => "Object Hits",
// "Object ID" => "Object ID",
// "Object Type" => "Object Type",
// "Displays object hit info by object and days" => "Displays object hit info by object and days",
// "Search for images uploaded by users" => "Search for images uploaded by users",
// " (deprecated - scheduled to be removed or changed significantly)" => " (deprecated - scheduled to be removed or changed significantly)",
// "Filename or full path to file" => "Filename or full path to file",
// "Plugin Manager" => "Plugin Manager",
// "Multiple values separated with | can be used" => "Multiple values separated with | can be used",
// "Provides a list of plugins on this wiki" => "Provides a list of plugins on this wiki",
// "Poll ID" => "Poll ID",
// "Displays the output of a poll, fields are indicated with numeric ids" => "Displays the output of a poll, fields are indicated with numeric ids",
// "missing poll ID for plugin POLL" => "missing poll ID for plugin POLL",
// "Profile Installer" => "Profile Installer",
// "Adds controls required to install a profile" => "Adds controls required to install a profile",
// "Domain" => "Domain",
// "Profile repository domain. Default value is profiles.tikiwiki.org" => "Profile repository domain. Default value is profiles.tikiwiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile" => "Name of the profile",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes casted. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes casted. One vote per line. Either 0, +1 or -1 followed by a username",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Displays a proposal acceptance widget" => "Displays a proposal acceptance widget",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Quote" => "Quote",
// "Quoted text" => "Quoted text",
// "Reply to" => "Reply to",
// "Name of the quoted person" => "Name of the quoted person",
// "wrote" => "wrote",
// "Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Quote text by surrounding the text with a box, like the [QUOTE] BBCode",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Includes random content from the dynamic content system" => "Includes random content from the dynamic content system",
// "Redirect" => "Redirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Redirects you to another wiki page" => "Redirects you to another wiki page",
// "Regular Expression" => "Regular Expression",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Page name containing the regular expression" => "Page name containing the regular expression",
// "Takes regex expressions and parses the content between the REGEX tags and replaces the text" => "Takes regex expressions and parses the content between the REGEX tags and replaces the text",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Remarks Box" => "Remarks Box",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Icon ID" => "Icon ID",
// "RSS Feed" => "RSS Feed",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Amount of results displayed" => "Amount of results displayed",
// "You need to specify a RSS Id" => "You need to specify a RSS Id",
// "RSS Id incorrect" => "RSS Id incorrect",
// "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage",
// "SourceForge" => "SourceForge",
// "aid?" => "aid?",
// "adit?" => "adit?",
// "groupid?" => "groupid?",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "sharethis" => "sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send services" => "Send services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "First post services shown" => "First post services shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Rotate image" => "Rotate image",
// "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Button text" => "Button text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header title" => "Header title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header background" => "Header background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header text color" => "Header text color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded elements" => "Embedded elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Sheet" => "Sheet",
// "Displays the content of a spreadsheet in the page" => "Displays the content of a spreadsheet in the page",
// "Internal ID of the TikiSheet" => "Internal ID of the TikiSheet",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Create new sheet" => "Create new sheet",
// "Show Pages" => "Show Pages",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "name|desc" => "name|desc",
// "Skype" => "Skype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Snarf" => "Snarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "PCRE compliant regular expression" => "PCRE compliant regular expression",
// "Regular Expression Part" => "Regular Expression Part",
// "ex: \$1" => "ex: \$1",
// "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace" => "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace",
// "This data is put in a CODE caption" => "This data is put in a CODE caption",
// "Missing url parameter for SNARF plugin" => "Missing url parameter for SNARF plugin",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "asc|desc|shuffle" => "asc|desc|shuffle",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute on the columns" => "Generate the width attribute on the columns",
// "Column Size" => "Column Size",
// "Editable" => "Editable",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom class" => "Custom class",
// "add a class to customize the design" => "add a class to customize the design",
// "SQL" => "SQL",
// "DNS Name" => "DNS Name",
// "ADODB DNS" => "ADODB DNS",
// "Subscript" => "Subscript",
// "Displays text in subscript" => "Displays text in subscript",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "Subscribe Group" => "Subscribe Group",
// "Group Name" => "Group Name",
// "As known in Tikiwiki" => "As known in Tikiwiki",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "Colon separated list of groups" => "Colon separated list of groups",
// "Superscript" => "Superscript",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "Displays text in superscript" => "Displays text in superscript",
// "Id" => "Id",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Displays a survey" => "Displays a survey",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Tag Name" => "Tag Name",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "Equivalent of the style attribute on the HTML tag" => "Equivalent of the style attribute on the HTML tag",
// "File ID from the file gallery" => "File ID from the file gallery",
// "Image ID from the image gallery" => "Image ID from the image gallery",
// "URL to the image" => "URL to the image",
// "Maximum Size" => "Maximum Size",
// "Maximum width or height for the image" => "Maximum width or height for the image",
// "Floating" => "Floating",
// "Link target of the image" => "Link target of the image",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "No image specified" => "No image specified",
// "Title Search" => "Title Search",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "hits|user" => "hits|user",
// "Exclude" => "Exclude",
// "Pipe separated list of page names to exclude from results" => "Pipe separated list of page names to exclude from results",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum amount of levels to display. On very large structures, this should be limited" => "Maximum amount of levels to display. On very large structures, this should be limited",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "asc|desc" => "asc|desc",
// "Show Description" => "Show Description",
// "0|1, show the page description instead of the page name" => "0|1, show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "0|1, display the section numbers or not" => "0|1, display the section numbers or not",
// "plain|fancy" => "plain|fancy",
// "Top Friends" => "Top Friends",
// "List top scoring users" => "List top scoring users",
// "Maximum result count" => "Maximum result count",
// "Translate a string using Tikiwiki translation table" => "Translate a string using Tikiwiki translation table",
// "string" => "string",
// "Translate a string" => "Translate a string",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button" => "Label on the submit button",
// "Show Title" => "Show Title",
// "Show Mandatory" => "Show Mandatory",
// "Embedded" => "Embedded",
// "Url used for the field links" => "Url used for the field links",
// "Values" => "Values",
// "Colon-separated list of values" => "Colon-separated list of values",
// "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or " => "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or ",
// "user|page" => "user|page",
// "itemId" => "itemId",
// "itemId if you want to edit an item" => "itemId if you want to edit an item",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Width of first column " => "Width of first column ",
// "Specify the width in pixels or percentage of the first column in the tracker form" => "Specify the width in pixels or percentage of the first column in the tracker form",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Following fields are incorrect" => "Following fields are incorrect",
// "Displays an input form for tracker submit" => "Displays an input form for tracker submit",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "Fields marked with a * are mandatory" => "Fields marked with a * are mandatory",
// "Filters" => "Filters",
// "Display List" => "Display List",
// "Line" => "Line",
// "Tracker Filter" => "Tracker Filter",
// "notice" => "notice",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Filters the items of a tracker, fields are indicated with numeric ids" => "Filters the items of a tracker, fields are indicated with numeric ids",
// "Tracker Item Field" => "Tracker Item Field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Item ID" => "Item ID",
// "Field ID" => "Field ID",
// "Colon separated list of field IDs" => "Colon separated list of field IDs",
// "Status" => "Status",
// "o|p|c|op|oc|pc|opc" => "o|p|c|op|oc|pc|opc",
// "Test" => "Test",
// "Value to compare against" => "Value to compare against",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)" => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)",
// "Tracker List" => "Tracker List",
// "Displays the output of a tracker content, fields are indicated with numeric ids" => "Displays the output of a tracker content, fields are indicated with numeric ids",
// "Notice" => "Notice",
// "Popup" => "Popup",
// "Colon-separated list of fields to display on click. Example: 6:7" => "Colon-separated list of fields to display on click. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Show Links" => "Show Links",
// "shownbitems" => "shownbitems",
// "Show Initials" => "Show Initials",
// "Show Status" => "Show Status",
// "Show Creation Date" => "Show Creation Date",
// "Show Last Modification" => "Show Last Modification",
// "Show Field Name" => "Show Field Name",
// "Status Filter" => "Status Filter",
// "Which item status to list. o = open, p = pending, c = closed" => "Which item status to list. o = open, p = pending, c = closed",
// "Sort Mode" => "Sort Mode",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Exact Value" => "Exact Value",
// "Checkbox" => "Checkbox",
// "goIfOne" => "goIfOne",
// "More" => "More",
// "More URL" => "More URL",
// "Select automatically the item of the current user or the page" => "Select automatically the item of the current user or the page",
// "View User" => "View User",
// "Item ID separated with " => "Item ID separated with ",
// "List of items Ids" => "List of items Ids",
// "link url" => "link url",
// "Left Deliminator" => "Left Deliminator",
// "Right Deliminator" => "Right Deliminator",
// "If y, value will be truncated" => "If y, value will be truncated",
// "Export Button" => "Export Button",
// "Compute" => "Compute",
// "Sum or average all the values of a field  and displays it at the bottom of the table" => "Sum or average all the values of a field  and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "incorrect filterfield" => "incorrect filterfield",
// "Error in tracker ID" => "Error in tracker ID",
// "Displays a button to link to a page with a tracker plugin with prefilled tracker fields" => "Displays a button to link to a page with a tracker plugin with prefilled tracker fields",
// "Tracker Prefill" => "Tracker Prefill",
// "Tracker page name" => "Tracker page name",
// "Button label" => "Button label",
// "Field 1" => "Field 1",
// "Value 1" => "Value 1",
// "Content of the field" => "Content of the field",
// "Field 2" => "Field 2",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Value 5" => "Value 5",
// "Tracker Stats" => "Tracker Stats",
// "Show Percentage" => "Show Percentage",
// "Show Bar" => "Show Bar",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Displays some stat of a tracker content, fields are indicated with numeric ids" => "Displays some stat of a tracker content, fields are indicated with numeric ids",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Start Date" => "Start Date",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "End Date" => "End Date",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "hour, day, week, month or year (default to hour)" => "hour, day, week, month or year (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "hour, day, week, month, year or empty (default to empty)" => "hour, day, week, month, year or empty (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link. (y|n)" => "Convert the group name to a link. (y|n)",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Translated" => "Translated",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "User Count" => "User Count",
// "Group name" => "Group name",
// "Displays a list of registered users" => "Displays a list of registered users",
// "Login Filter" => "Login Filter",
// "String to use between elements of the list" => "String to use between elements of the list",
// "Maximum" => "Maximum",
// "Result limit" => "Result limit",
// "Layout" => "Layout",
// "Split the text in parts visible only under some conditions" => "Split the text in parts visible only under some conditions",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. Note: Do not work when nav=>y" => "Display the current version name as the title. Note: Do not work when nav=>y",
// "Default" => "Default",
// "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'",
// "This is the default text" => "This is the default text",
// "(version 3)" => "(version 3)",
// "This is version 3 info" => "This is version 3 info",
// "(version 2)" => "(version 2)",
// "This is version 2 info" => "This is version 2 info",
// "(version 1)" => "(version 1)",
// "This is version 1 info" => "This is version 1 info",
// "Show Stats" => "Show Stats",
// "Show Stats After" => "Show Stats After",
// "Show Creator" => "Show Creator",
// "Wanted Pages" => "Wanted Pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "Split By" => "Split By",
// "Skip Extension" => "Skip Extension",
// "Collect" => "Collect",
// "Level" => "Level",
// "Lists ''wanted'' Wiki pages: " => "Lists ''wanted'' Wiki pages: ",
// "Page-Pattern" => "Page-Pattern",
// "^Parameters: key=>value,...\n" => "^Parameters: key=>value,...\n",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "(refer to PHP function fnmatch() for details)\n" => "(refer to PHP function fnmatch() for details)\n",
// "The character, by which ignored patterns are separated" => "The character, by which ignored patterns are separated",
// "possible values: characters\n" => "possible values: characters\n",
// "Whether to include external wikis in the list" => "Whether to include external wikis in the list",
// "possible values: " => "possible values: ",
// "Collect either originating or wanted pages in a cell and display them in the second column" => "Collect either originating or wanted pages in a cell and display them in the second column",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Lists ''wanted'' wiki pages" => "Lists ''wanted'' wiki pages",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "The character, by which ignored patterns are separated. possible values: characters" => "The character, by which ignored patterns are separated. possible values: characters",
// "Whether to include external wikis in the list. possible values" => "Whether to include external wikis in the list. possible values",
// "Collect either originating or wanted pages in a cell and display them in the second column. possible values" => "Collect either originating or wanted pages in a cell and display them in the second column. possible values",
// "Switch-on debug output with details about the items. possible values" => "Switch-on debug output with details about the items. possible values",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values",
// "non-valid custom regex" => "non-valid custom regex",
// "not in level" => "not in level",
// "End of debug output" => "End of debug output",
// "Wanted Page" => "Wanted Page",
// "Referenced By Page" => "Referenced By Page",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Youtube" => "Youtube",
// "Display youtube video in a wiki page" => "Display youtube video in a wiki page",
// "URL to the Youtube video" => "URL to the Youtube video",
// "quality" => "quality",
// "Missing parameter movie to the youtube plugin" => "Missing parameter movie to the youtube plugin",
// "rollback version " => "rollback version ",
// "Changed actual version to \$version" => "Changed actual version to \$version",
// "Top" => "Top",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Page locked" => "Page locked",
// "Page unlocked" => "Page unlocked",
// "list topics with links to the articles" => "list topics with links to the articles",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Please provide an Id" => "Please provide an Id",
// "no object here yet" => "no object here yet",
// "List by month" => "List by month",
// "Please wait.." => "Please wait..",
// "Since your last visit.." => "Since your last visit..",
// "updated tracker items" => "updated tracker items",
// "The task title must have at least 3 characters" => "The task title must have at least 3 characters",
// "Invalid server key" => "Invalid server key",
// "Cookie not found" => "Cookie not found",
// "Can view Tikiwiki tools calendar" => "Can view Tikiwiki tools calendar",
// "Can view categories" => "Can view categories",
// "Can view categorized items" => "Can view categorized items",
// "Can search on objects of this category" => "Can search on objects of this category",
// "Can suggest items" => "Can suggest items",
// "Administrator, can create channels remove channels etc" => "Administrator, can create channels remove channels etc",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submited articles automatically approved" => "Submited articles automatically approved",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Submited links are valid" => "Submited links are valid",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrator, can manage users groups and permissions, Hotwords and all the weblog features",
// "Can access site when closed" => "Can access site when closed",
// "Administrator, can admin banners" => "Administrator, can admin banners",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can clean cache" => "Can clean cache",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can remove association between two pages in a translation set" => "Can remove association between two pages in a translation set",
// "Can edit menu" => "Can edit menu",
// "Can edit menu option" => "Can edit menu option",
// "Can search" => "Can search",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view referer stats" => "Can view referer stats",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can list file galleries" => "Can list file galleries",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
// "Auto approve forum posts" => "Auto approve forum posts",
// "Can report msgs to moderator" => "Can report msgs to moderator",
// "Can admin freetags" => "Can admin freetags",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can tag objects" => "Can tag objects",
// "Can list image galleries" => "Can list image galleries",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can view poll results" => "Can view poll results",
// "Can view poll voters" => "Can view poll voters",
// "Can admin quicktags" => "Can admin quicktags",
// "Can view user quiz results" => "Can view user quiz results",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can list trackers" => "Can list trackers",
// "Can view trackers pending items" => "Can view trackers pending items",
// "Can export tracker items" => "Can export tracker items",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can admin workflow processes" => "Can admin workflow processes",
// "Can abort a process instance" => "Can abort a process instance",
// "Can declare an instance as exception" => "Can declare an instance as exception",
// "Can send instances after completion" => "Can send instances after completion",
// "Can execute workflow activities" => "Can execute workflow activities",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can admin comments" => "Can admin comments",
// "Can admin content templates" => "Can admin content templates",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can use group webmail" => "Can use group webmail",
// "Can administrate group webmail accounts" => "Can administrate group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can administrate personal webmail accounts" => "Can administrate personal webmail accounts",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin" => "Can execute unapproved plugin",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Trust all user inputs (no security checks)" => "Trust all user inputs (no security checks)",
// "View page backlinks" => "View page backlinks",
// "Can admin mail notifications" => "Can admin mail notifications",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "feature print indexed" => "feature print indexed",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature page title" => "feature page title",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wysiwyg toolbar" => "wysiwyg toolbar",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "feature blog comments" => "feature blog comments",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastmodif" => "fgal list lastmodif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "ProgressBarPlay" => "ProgressBarPlay",
// "ProgressBarLoad" => "ProgressBarLoad",
// "ProgressBarButton" => "ProgressBarButton",
// "ProgressBar" => "ProgressBar",
// "VolumeOn" => "VolumeOn",
// "VolumeOff" => "VolumeOff",
// "VolumeButton" => "VolumeButton",
// "Button" => "Button",
// "ButtonPressed" => "ButtonPressed",
// "ButtonOver" => "ButtonOver",
// "ButtonInfo" => "ButtonInfo",
// "ButtonInfoPressed" => "ButtonInfoPressed",
// "ButtonInfoOver" => "ButtonInfoOver",
// "ButtonInfoText" => "ButtonInfoText",
// "ID3" => "ID3",
// "PlayTime" => "PlayTime",
// "TotalTime" => "TotalTime",
// "PanelDisplay" => "PanelDisplay",
// "AlertMesg" => "AlertMesg",
// "PreloadDelay" => "PreloadDelay",
// "VideoHeight" => "VideoHeight",
// "VideoLength" => "VideoLength",
// "URLAppend" => "URLAppend",
// "LimitedMsg" => "LimitedMsg",
// "MaxPlay" => "MaxPlay",
// "MultimediaGalerie" => "MultimediaGalerie",
// "MultimediaDefaultLength" => "MultimediaDefaultLength",
// "MultimediaDefaultHeight" => "MultimediaDefaultHeight",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "cms spellcheck" => "cms spellcheck",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trk with mirror tables" => "trk with mirror tables",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "change password" => "change password",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki workflow" => "users prefs mytiki workflow",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "validateRegistration" => "validateRegistration",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature newsreader" => "feature newsreader",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "feature charts" => "feature charts",
// "rss forums" => "rss forums",
// "rss forum" => "rss forum",
// "rss directories" => "rss directories",
// "rss articles" => "rss articles",
// "rss blogs" => "rss blogs",
// "rss image galleries" => "rss image galleries",
// "rss file galleries" => "rss file galleries",
// "rss wiki" => "rss wiki",
// "rss image gallery" => "rss image gallery",
// "rss file gallery" => "rss file gallery",
// "rss blog" => "rss blog",
// "rss tracker" => "rss tracker",
// "rss trackers" => "rss trackers",
// "rss calendar" => "rss calendar",
// "rss mapfiles" => "rss mapfiles",
// "rss cache time" => "rss cache time",
// "max rss forums" => "max rss forums",
// "max rss forum" => "max rss forum",
// "max rss directories" => "max rss directories",
// "max rss articles" => "max rss articles",
// "max rss blogs" => "max rss blogs",
// "max rss image galleries" => "max rss image galleries",
// "max rss file galleries" => "max rss file galleries",
// "max rss wiki" => "max rss wiki",
// "max rss image gallery" => "max rss image gallery",
// "max rss file gallery" => "max rss file gallery",
// "max rss blog" => "max rss blog",
// "max rss mapfiles" => "max rss mapfiles",
// "max rss tracker" => "max rss tracker",
// "max rss trackers" => "max rss trackers",
// "max rss calendar" => "max rss calendar",
// "summary rss blogs" => "summary rss blogs",
// "rssfeed default version" => "rssfeed default version",
// "rssfeed language" => "rssfeed language",
// "rssfeed editor" => "rssfeed editor",
// "rssfeed webmaster" => "rssfeed webmaster",
// "rssfeed creator" => "rssfeed creator",
// "rssfeed css" => "rssfeed css",
// "rssfeed publisher" => "rssfeed publisher",
// "rssfeed img" => "rssfeed img",
// "rss basic auth" => "rss basic auth",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "rnd num reg" => "rnd num reg",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth create user tiki" => "auth create user tiki",
// "auth create user auth" => "auth create user auth",
// "auth skip admin" => "auth skip admin",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "https login" => "https login",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category reinforce" => "feature category reinforce",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "feature games" => "feature games",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "lang use db" => "lang use db",
// "language" => "language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature topbar version" => "feature topbar version",
// "feature topbar debug" => "feature topbar debug",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "site style" => "site style",
// "site style option" => "site style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature copyright" => "feature copyright",
// "feature multimedia" => "feature multimedia",
// "feature swfobj" => "feature swfobj",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "quicktags over textarea" => "quicktags over textarea",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "feature floating help" => "feature floating help",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty security" => "smarty security",
// "feature ajax" => "feature ajax",
// "feature ajax autosave" => "feature ajax autosave",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature drawings" => "feature drawings",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature workflow" => "feature workflow",
// "feature xmlrpc" => "feature xmlrpc",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "sender email" => "sender email",
// "feature site report email" => "feature site report email",
// "session db" => "session db",
// "session lifetime" => "session lifetime",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "system os" => "system os",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature blogposts pings" => "feature blogposts pings",
// "feature create webhelp" => "feature create webhelp",
// "feature forums search" => "feature forums search",
// "feature trackbackpings" => "feature trackbackpings",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "feature mootools" => "feature mootools",
// "javascript enabled" => "javascript enabled",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "feature template zoom" => "feature template zoom",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "use minified scripts" => "use minified scripts",
// "valid email regex" => "valid email regex",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery sheet" => "feature jquery sheet",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery cycle" => "feature jquery cycle",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature tikitests" => "feature tikitests",
// "feature magic" => "feature magic",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "transition style ver" => "transition style ver",
// "magic last load" => "magic last load",
// "feature groupalert" => "feature groupalert",
// "lib spellcheck" => "lib spellcheck",
// "wiki spellcheck" => "wiki spellcheck",
// "blog spellcheck" => "blog spellcheck",
// "allowMsgs" => "allowMsgs",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki workflow" => "mytiki workflow",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "Version" => "Version",
// "Group Monitor" => "Group Monitor",
// "Select Categories" => "Select Categories",
// "Select/deselect all categories" => "Select/deselect all categories",
// "top of page" => "top of page",
// "Reject" => "Reject",
// "Report this post" => "Report this post",
// "Comments Locked" => "Comments Locked",
// "Comments are locked" => "Comments are locked",
// "Quicktags" => "Quicktags",
// "Maximum size" => "Maximum size",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Your comment will have to be approved by the moderator before it is displayed" => "Your comment will have to be approved by the moderator before it is displayed",
// "Users with perms and not only the owner of the gallery can upload in it" => "Users with perms and not only the owner of the gallery can upload in it",
// "The files can be locked at download" => "The files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Perhaps you were looking for" => "Perhaps you were looking for",
// "There are no wiki pages similar to '{\$page}'" => "There are no wiki pages similar to '{\$page}'",
// "Archives" => "Archives",
// "Show an icon in a column" => "Show an icon in a column",
// "not in" => "not in",
// "Clear Filter" => "Clear Filter",
// "Folksonomy Tags" => "Folksonomy Tags",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together",
// "Tags" => "Tags",
// "Translate tags" => "Translate tags",
// "Images Galleries" => "Images Galleries",
// "You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page" => "You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page",
// "Loading" => "Loading",
// "\\074span class=\"shortcut\"\\076C\\074/span\\076lose" => "\\074span class=\"shortcut\"\\076C\\074/span\\076lose",
// "\\074span class=\"shortcut\"\\076N\\074/span\\076ext" => "\\074span class=\"shortcut\"\\076N\\074/span\\076ext",
// "\\074span class=\"shortcut\"\\076P\\074/span\\076revious" => "\\074span class=\"shortcut\"\\076P\\074/span\\076revious",
// "Hide Tree" => "Hide Tree",
// "Are you sure you want to delete the selected files" => "Are you sure you want to delete the selected files",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "New topic" => "New topic",
// "You sent a request with the subject" => "You sent a request with the subject",
// "Use the subject to indicate the operation to apply" => "Use the subject to indicate the operation to apply",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "New message arrived from %s" => "New message arrived from %s",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "User Tracker" => "User Tracker",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "You're invited to join my network of friends" => "You're invited to join my network of friends",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Look at this link" => "Look at this link",
// "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}",
// "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}" => "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "Tracker was modified at" => "Tracker was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user} at" => "{\$mail_title} by {\$mail_user} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "New blog post at %s" => "New blog post at %s",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "removed" => "removed",
// "Old" => "Old",
// "updated" => "updated",
// "Posted by" => "Posted by",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "You can view the updated map following this link" => "You can view the updated map following this link",
// "You can edit the map following this link" => "You can edit the map following this link",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "Structure modified" => "Structure modified",
// "File name" => "File name",
// "New attachment on %s, page" => "New attachment on %s, page",
// "The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "The old page content follows below" => "The old page content follows below",
// "Wiki page %s created by {\$mail_user}" => "Wiki page %s created by {\$mail_user}",
// "Wiki page %s deleted by {\$mail_user}" => "Wiki page %s deleted by {\$mail_user}",
// "Wiki page %s changed by {\$mail_user}" => "Wiki page %s changed by {\$mail_user}",
// "The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "Wiki page %s was commented on by" => "Wiki page %s was commented on by",
// "an anonymous user" => "an anonymous user",
// "Thank you for your registration. You may log in now" => "Thank you for your registration. You may log in now",
// "click on the map to zoom or pan, do not drag" => "click on the map to zoom or pan, do not drag",
// "Querying" => "Querying",
// "Zoom out" => "Zoom out",
// "Zoom in" => "Zoom in",
// "select zoom/pan/query and image size" => "select zoom/pan/query and image size",
// "View the Map Only" => "View the Map Only",
// "This layer has been set by the maps administrator to not be downloadable" => "This layer has been set by the maps administrator to not be downloadable",
// "from the mapfile" => "from the mapfile",
// "hits last 7 days" => "hits last 7 days",
// "c=compare" => "c=compare",
// "d=diff" => "d=diff",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "ERROR" => "ERROR",
// "Cc" => "Cc",
// "'name' parameter for tikimodule missed" => "'name' parameter for tikimodule missed",
// "opp side" => "opp side",
// "Unassign this module" => "Unassign this module",
// "Are you sure you want to unassign this module" => "Are you sure you want to unassign this module",
// "Toggle module contents" => "Toggle module contents",
// "Admin Drawings" => "Admin Drawings",
// "Content Templates" => "Content Templates",
// "External Wikis" => "External Wikis",
// "Tiki Cache/Sys Admin" => "Tiki Cache/Sys Admin",
// "Syntax Highlighting" => "Syntax Highlighting",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "More.." => "More..",
// "To configure your Tiki" => "To configure your Tiki",
// "Admin Home" => "Admin Home",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "as the Admin" => "as the Admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>" => "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>",
// "on blogpost" => "on blogpost",
// "Folksonomy" => "Folksonomy",
// "Tags This Page Has" => "Tags This Page Has",
// "Add tags" => "Add tags",
// "More Like This" => "More Like This",
// "Most popular tags" => "Most popular tags",
// "List everything tagged" => "List everything tagged",
// "My prefered tags" => "My prefered tags",
// "No avatar" => "No avatar",
// "You" => "You",
// "CapsLock is on" => "CapsLock is on",
// "What is OpenID" => "What is OpenID",
// "Your email could not be validated; make sure you email is correct and click register below" => "Your email could not be validated; make sure you email is correct and click register below",
// "A leading plus sign indicates that this word must be present in every object returned" => "A leading plus sign indicates that this word must be present in every object returned",
// "A leading minus sign indicates that this word must not be present in any row returned" => "A leading minus sign indicates that this word must not be present in any row returned",
// "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher" => "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher",
// "These two operators are used to change a word's contribution to the relevance value that is assigned to a row" => "These two operators are used to change a word's contribution to the relevance value that is assigned to a row",
// "Parentheses are used to group words into subexpressions" => "Parentheses are used to group words into subexpressions",
// "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator" => "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator",
// "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended" => "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended",
// "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed" => "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed",
// "Advanced search" => "Advanced search",
// "Advanced Search Help" => "Advanced Search Help",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "Page translation" => "Page translation",
// "There are no translations of this page" => "There are no translations of this page",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Better translations" => "Better translations",
// "update from it" => "update from it",
// "None match your" => "None match your",
// "Equivalent translations" => "Equivalent translations",
// "update it" => "update it",
// "The Next Event" => "The Next Event",
// "No Upcoming Events" => "No Upcoming Events",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "on host" => "on host",
// "on page" => "on page",
// "Videos on YouTube" => "Videos on YouTube",
// "More Videos" => "More Videos",
// "Changes that need to be reproduced are highlighted below" => "Changes that need to be reproduced are highlighted below",
// "Please make a selection of text in order to create a link" => "Please make a selection of text in order to create a link",
// "By" => "By",
// "Location : " => "Location : ",
// "Read more" => "Read more",
// "Do not group by item" => "Do not group by item",
// "Group by item" => "Group by item",
// "Tiki Action Calendar" => "Tiki Action Calendar",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Profiles" => "Profiles",
// "Customize look and feel of your Tiki" => "Customize look and feel of your Tiki",
// "Look &amp; Feel" => "Look &amp; Feel",
// "Editing and Plugins" => "Editing and Plugins",
// "Multimedia" => "Multimedia",
// "InterTiki" => "InterTiki",
// "Semantic wiki links" => "Semantic wiki links",
// "Semantic links" => "Semantic links",
// "Webservices" => "Webservices",
// "Sef URL" => "Sef URL",
// "Blogs Listing" => "Blogs Listing",
// "Create a blog" => "Create a blog",
// "Spell checking" => "Spell checking",
// "Requires a separate download" => "Requires a separate download",
// "Custom blog headings" => "Custom blog headings",
// "Blog-level" => "Blog-level",
// "Post-level" => "Post-level",
// "Default number per page" => "Default number per page",
// "Default ordering" => "Default ordering",
// "Blogs Listings" => "Blogs Listings",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "Title length" => "Title length",
// "To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or",
// "General settings" => "General settings",
// "Default calendars to display" => "Default calendars to display",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Create calendar" => "Create calendar",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "Manual selection of time/date" => "Manual selection of time/date",
// "JS calendar" => "JS calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current\n\tyear" => "Enter a year or use +/- N to specify a year relative to the current\n\tyear",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Group calendars" => "Group calendars",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Category path" => "Category path",
// "Exclude these categories" => "Exclude these categories",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Show category objects" => "Show category objects",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "PHPLayers is disabled" => "PHPLayers is disabled",
// "Enable now" => "Enable now",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "Permission to all (not just any) of an object's categories is required for access" => "Permission to all (not just any) of an object's categories is required for access",
// "Articles Listing" => "Articles Listing",
// "Title of articles home page" => "Title of articles home page",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "Default article image width" => "Default article image width",
// "Default article image height" => "Default article image height",
// "Batch upload (CSV file)" => "Batch upload (CSV file)",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "Publication date" => "Publication date",
// "Expiration date" => "Expiration date",
// "Users Listing" => "Users Listing",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Requires User Preferences feature" => "Requires User Preferences feature",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Real name" => "Real name",
// "Feature is disabled" => "Feature is disabled",
// "Default user preferences" => "Default user preferences",
// "Character set for mail" => "Character set for mail",
// "User messages" => "User messages",
// "Notify sender when reading mail" => "Notify sender when reading mail",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "Copyright allows to determine a copyright for all the objects of tikiwiki" => "Copyright allows to determine a copyright for all the objects of tikiwiki",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
// "Enable copyright management for" => "Enable copyright management for",
// "Feature" => "Feature",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Experimental" => "Experimental",
// "Programmer" => "Programmer",
// "Site Global Features" => "Site Global Features",
// "Additional Features" => "Additional Features",
// "Minichat" => "Minichat",
// "Comments Moderation" => "Comments Moderation",
// "Comments Locking" => "Comments Locking",
// "JsCalendar" => "JsCalendar",
// "Css Menus (suckerfish)" => "Css Menus (suckerfish)",
// "Shadowbox" => "Shadowbox",
// "Mootools or JQuery" => "Mootools or JQuery",
// "Mootools" => "Mootools",
// "Floating help aka the Big Blue Help Icon" => "Floating help aka the Big Blue Help Icon",
// "Seem ok" => "Seem ok",
// "Features that may change or might be re-worked in the future" => "Features that may change or might be re-worked in the future",
// "HTML Purifier" => "HTML Purifier",
// "JQuery: JavaScript UI effects" => "JQuery: JavaScript UI effects",
// "Need polish" => "Need polish",
// "Features that need admin help and user patience to work well" => "Features that need admin help and user patience to work well",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "SEFURL" => "SEFURL",
// "Ajax auto-save" => "Ajax auto-save",
// "Malfunctioning" => "Malfunctioning",
// "These features have critical faults - not recommended" => "These features have critical faults - not recommended",
// "Magic Admin Panel" => "Magic Admin Panel",
// "Neglected" => "Neglected",
// "Old features no longer maintained" => "Old features no longer maintained",
// "SWFObject" => "SWFObject",
// "SwfObject" => "SwfObject",
// "Used to embed Flash content in wiki pages, banners etc" => "Used to embed Flash content in wiki pages, banners etc",
// "Action Calendar" => "Action Calendar",
// "Group Watches" => "Group Watches",
// "Newsreader" => "Newsreader",
// "Group Alert" => "Group Alert",
// "Programmer Features" => "Programmer Features",
// "TikiTests" => "TikiTests",
// "requires PHP5 or more" => "requires PHP5 or more",
// "Use Minified Scripts" => "Use Minified Scripts",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "Gallery Listing" => "Gallery Listing",
// "Search Indexing" => "Search Indexing",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "The server must be able to read/write the directory" => "The server must be able to read/write the directory",
// "The directory can be outside the web space" => "The directory can be outside the web space",
// "Podcast directory" => "Podcast directory",
// "Required for podcasts" => "Required for podcasts",
// "Default Ordering" => "Default Ordering",
// "Score is disabled" => "Score is disabled",
// "Yes, even in the same gallery" => "Yes, even in the same gallery",
// "Only in different galleries" => "Only in different galleries",
// "Batch uploading" => "Batch uploading",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Upload Regex" => "Upload Regex",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "System Command" => "System Command",
// "Forums Listing" => "Forums Listing",
// "Create a forum" => "Create a forum",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Threads" => "Threads",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Default sort mode" => "Default sort mode",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Search is disabled" => "Search is disabled",
// "Use Tiki (database-independent) search" => "Use Tiki (database-independent) search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "Description length" => "Description length",
// "3D Tag Browser" => "3D Tag Browser",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all charactrs" => "Accept all charactrs",
// "Lowercase tags only" => "Lowercase tags only",
// "Multilingual freetags" => "Multilingual freetags",
// "Multiligual disabled" => "Multiligual disabled",
// "&quot;More Like This&quot; algorithm" => "&quot;More Like This&quot; algorithm",
// "basic" => "basic",
// "weighted" => "weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "Tag Management" => "Tag Management",
// "Cleanup unused tags" => "Cleanup unused tags",
// "Morcego 3D browser disabled" => "Morcego 3D browser disabled",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "Graph appearance" => "Graph appearance",
// "Node color" => "Node color",
// "Camera settinsg" => "Camera settinsg",
// "Physics engine" => "Physics engine",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Pixels Default" => "Pixels Default",
// "Default scale size" => "Default scale size",
// "Admin Password" => "Admin Password",
// "Release Check" => "Release Check",
// "Reset or upgrade your database" => "Reset or upgrade your database",
// "Check for updates automatically" => "Check for updates automatically",
// "TikiWiki will check for updates when you access the main Administration page" => "TikiWiki will check for updates when you access the main Administration page",
// "Check for updates now" => "Check for updates now",
// "Sender email" => "Sender email",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look &amp; Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look &amp; Feel</strong></a> section for additional site related customization preferences",
// "Use TikiWiki feature as homepage" => "Use TikiWiki feature as homepage",
// "Use different URL as home page" => "Use different URL as home page",
// "Miscellaneous" => "Miscellaneous",
// "Server OS" => "Server OS",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Default charset for sending mail" => "Default charset for sending mail",
// "Mail end of line" => "Mail end of line",
// "Logging and Reporting" => "Logging and Reporting",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Visible to Admin only" => "Visible to Admin only",
// "Include Smarty notices" => "Include Smarty notices",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Log SQL" => "Log SQL",
// "Log queries using more than" => "Log queries using more than",
// "This may impact performance" => "This may impact performance",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "Site Access" => "Site Access",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Host" => "Host",
// "Port" => "Port",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Send to URL" => "Send to URL",
// "Performance" => "Performance",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "GZip output" => "GZip output",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Session" => "Session",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Enabling this feature will immediately log you out when you save this preference" => "Enabling this feature will immediately log you out when you save this preference",
// "Session lifetime" => "Session lifetime",
// "The \"Contact Us\" feature is disabled" => "The \"Contact Us\" feature is disabled",
// "Allow anonymous visitors to use the \"Contact Us\"" => "Allow anonymous visitors to use the \"Contact Us\"",
// "The default help system may not be complete" => "The default help system may not be complete",
// "You can help with the TikiWiki documentation" => "You can help with the TikiWiki documentation",
// "Show user's real name instead of login (when possible)" => "Show user's real name instead of login (when possible)",
// "Highlight group" => "Highlight group",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Separators" => "Separators",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Sample" => "Sample",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at " => "You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at ",
// "whole earth" => "whole earth",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Default language" => "Default language",
// "Show pages in user's preferred language" => "Show pages in user's preferred language",
// "User preferences are disabled" => "User preferences are disabled",
// "Users can change site language" => "Users can change site language",
// "Restrict supported languages" => "Restrict supported languages",
// "Available languages" => "Available languages",
// "Use Ctrl+Click to select multiple languages" => "Use Ctrl+Click to select multiple languages",
// "Display available translations" => "Display available translations",
// "Changing page language will also change the site language" => "Changing page language will also change the site language",
// "Translation assistant" => "Translation assistant",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Quantify change size" => "Quantify change size",
// "Multilingual structures" => "Multilingual structures",
// "Structures are disabled" => "Structures are disabled",
// "Multilingual One Page feature" => "Multilingual One Page feature",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "Look and Feel" => "Look and Feel",
// "Text Area" => "Text Area",
// "Wysiwyg" => "Wysiwyg",
// "Semantic" => "Semantic",
// "Webservices management" => "Webservices management",
// "CAS" => "CAS",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Validate by email" => "Validate by email",
// "You need to set <a href=\"tiki-admin.php?page=general&amp;cookietab=2\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general&amp;cookietab=2\">Sender Email</a>",
// "Validate user's email server" => "Validate user's email server",
// "Require validation by Admin" => "Require validation by Admin",
// "Require passcode to register" => "Require passcode to register",
// "Passcode" => "Passcode",
// "Users must enter this code to register" => "Users must enter this code to register",
// "Use CAPTCHA to prevent automatic/robot registrations" => "Use CAPTCHA to prevent automatic/robot registrations",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Include &quot;Generate Password&quot; option on registration form" => "Include &quot;Generate Password&quot; option on registration form",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display" => "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Re-validate user by email after" => "Re-validate user by email after",
// "Use <strong>-1</strong> for never" => "Use <strong>-1</strong> for never",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "Create a new group for each user" => "Create a new group for each user",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Use HTTPS login" => "Use HTTPS login",
// "Cookie name" => "Cookie name",
// "Use email as username" => "Use email as username",
// "Minimum length" => "Minimum length",
// "Maximum length" => "Maximum length",
// "Force lowercase" => "Force lowercase",
// "Username pattern" => "Username pattern",
// "Store password as plain text" => "Store password as plain text",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords </em>are stored<em> as plain text, the password will be emailed to the user" => "If passwords </em>are stored<em> as plain text, the password will be emailed to the user",
// "If passwords </em>are not<em> plain text, reset instructions will be emailed to the user" => "If passwords </em>are not<em> plain text, reset instructions will be emailed to the user",
// "Encryption method" => "Encryption method",
// "Users can change their password" => "Users can change their password",
// "Require characters and numerals" => "Require characters and numerals",
// "Password expires after" => "Password expires after",
// "You must change the Authentication Method to PEAR::Auth for these changes to take effect" => "You must change the Authentication Method to PEAR::Auth for these changes to take effect",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Create user if not in Auth" => "Create user if not in Auth",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "Will override the Host and Port settings" => "Will override the Host and Port settings",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Base DN" => "Base DN",
// "LDAP User" => "LDAP User",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "LDAP Group" => "LDAP Group",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group OC" => "Group OC",
// "LDAP Member" => "LDAP Member",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "LDAP Admin" => "LDAP Admin",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Create with default group" => "Create with default group",
// "Default group" => "Default group",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "Hostname" => "Hostname",
// "You must enable PHP CAS first" => "You must enable PHP CAS first",
// "General Layout" => "General Layout",
// "UI Effects" => "UI Effects",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme options" => "Theme options",
// "Each group can have its theme" => "Each group can have its theme",
// "Use transition style sheet from version" => "Use transition style sheet from version",
// "View Templates" => "View Templates",
// "Shadow layer" => "Shadow layer",
// "Enable additional general layout layers for shadows, rounded corners or other decorative styling" => "Enable additional general layout layers for shadows, rounded corners or other decorative styling",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Activate will only show content for admin. Check Publish to use content for all users" => "Activate will only show content for admin. Check Publish to use content for all users",
// "Site Logo and Title" => "Site Logo and Title",
// "Site logo source (image path)" => "Site logo source (image path)",
// "Site logo background style" => "Site logo background style",
// "Site title" => "Site title",
// "Site subtitle" => "Site subtitle",
// "Site Search Bar" => "Site Search Bar",
// "Site Login Bar" => "Site Login Bar",
// "Top Bar" => "Top Bar",
// "Note: Needs feature PHPLayers on(default), or feature CSS Menu on  " => "Note: Needs feature PHPLayers on(default), or feature CSS Menu on  ",
// "Site Breadcrumbs" => "Site Breadcrumbs",
// "Prefix breadcrumbs with 'Location : '" => "Prefix breadcrumbs with 'Location : '",
// "Site Report Bar" => "Site Report Bar",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Left blank to use the default sender email" => "Left blank to use the default sender email",
// "Email this page" => "Email this page",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Power by" => "Power by",
// "Pagination links" => "Pagination links",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Use Icons" => "Use Icons",
// "JQuery plugins and add-ons" => "JQuery plugins and add-ons",
// "Requires jquery feature" => "Requires jquery feature",
// "JQuery Tooltips" => "JQuery Tooltips",
// "JQuery Tooltips: Customisable help tips" => "JQuery Tooltips: Customisable help tips",
// "JQuery Autocomplete" => "JQuery Autocomplete",
// "JQuery Superfish" => "JQuery Superfish",
// "JQuery Superfish (effects on CSS menus)" => "JQuery Superfish (effects on CSS menus)",
// "JQuery Reflection" => "JQuery Reflection",
// "JQuery Reflection (reflection effect on images)" => "JQuery Reflection (reflection effect on images)",
// "JQuery Cycle (slideshow)" => "JQuery Cycle (slideshow)",
// "For future use" => "For future use",
// "JQuery UI" => "JQuery UI",
// "JQuery UI: More JQuery functionality" => "JQuery UI: More JQuery functionality",
// "JQuery Sheet" => "JQuery Sheet",
// "JQuery Spreadsheet" => "JQuery Spreadsheet",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Standard UI effects" => "Standard UI effects",
// "Effect for modules etc" => "Effect for modules etc",
// "Main JQuery effect" => "Main JQuery effect",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect speed" => "Effect speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Effect direction" => "Effect direction",
// "Tab UI effects" => "Tab UI effects",
// "Effect for tabs" => "Effect for tabs",
// "JQuery effect for tabs" => "JQuery effect for tabs",
// "Effect speed for tabs" => "Effect speed for tabs",
// "Effect direction for tabs" => "Effect direction for tabs",
// "Other options" => "Other options",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "List of CSS selectors to be fixed, each selector separated by comma" => "List of CSS selectors to be fixed, each selector separated by comma",
// "List of HTMLDomElements to be fixed, each element separated by comma" => "List of HTMLDomElements to be fixed, each element separated by comma",
// "Context Menus (only in file galleries so far)" => "Context Menus (only in file galleries so far)",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Change Preferences" => "Change Preferences",
// "Meta tags" => "Meta tags",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Geo URL" => "Geo URL",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Show module controls" => "Show module controls",
// "Users can configure modules" => "Users can configure modules",
// "Users can shade modules" => "Users can shade modules",
// "Module decides" => "Module decides",
// "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item" => "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item",
// "ProgressBarPlay Color" => "ProgressBarPlay Color",
// "ProgressBarLoad Color" => "ProgressBarLoad Color",
// "ProgressBarButton Color" => "ProgressBarButton Color",
// "ProgressBar Color" => "ProgressBar Color",
// "Volume On Color" => "Volume On Color",
// "Volume Off Color" => "Volume Off Color",
// "Volume Button Color" => "Volume Button Color",
// "Button Color" => "Button Color",
// "Button Pressed Color" => "Button Pressed Color",
// "Button Over Color" => "Button Over Color",
// "Button Info Color" => "Button Info Color",
// "Button Info Pressed Color" => "Button Info Pressed Color",
// "Button Info Over Color" => "Button Info Over Color",
// "Button Info Text Color" => "Button Info Text Color",
// "Play Time Color" => "Play Time Color",
// "Total Time Color" => "Total Time Color",
// "Panel Display Color" => "Panel Display Color",
// "Alert Message Color" => "Alert Message Color",
// "Flash Length" => "Flash Length",
// "Flash Heigth" => "Flash Heigth",
// "Video Length" => "Video Length",
// "Preload Delay" => "Preload Delay",
// "URL Append" => "URL Append",
// "Message after limited time" => "Message after limited time",
// "ID of System File Galleries to upload multimedia files" => "ID of System File Galleries to upload multimedia files",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Categories disabled" => "Categories disabled",
// "Are you sure you want to install the profile" => "Are you sure you want to install the profile",
// "TikiWiki Profiles" => "TikiWiki Profiles",
// "Profile repository" => "Profile repository",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Profile" => "Profile",
// "Repository" => "Repository",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "More information" => "More information",
// "Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS Modules</strong> menu option, or" => "Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS Modules</strong> menu option, or",
// "Feed for articles" => "Feed for articles",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Feed for blogs" => "Feed for blogs",
// "Individual blogs" => "Individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Individual image galleries" => "Individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "Feed for wiki" => "Feed for wiki",
// "Individual forums" => "Individual forums",
// "Individual trackers items" => "Individual trackers items",
// "Calendar events" => "Calendar events",
// "Feed for directory" => "Feed for directory",
// "Map files" => "Map files",
// "Feed for maps" => "Feed for maps",
// "Defaults" => "Defaults",
// "Image Path" => "Image Path",
// "Caching time" => "Caching time",
// "Use <strong>0</strong> for no caching" => "Use <strong>0</strong> for no caching",
// "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public" => "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Search Results" => "Search Results",
// "Search type" => "Search type",
// "This search uses the MySQL Full-Text feature" => "This search uses the MySQL Full-Text feature",
// "Tiki search" => "Tiki search",
// "This database-independent search is always enabled" => "This database-independent search is always enabled",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "Refresh mode" => "Refresh mode",
// "Use <strong>0</strong> for no refresh" => "Use <strong>0</strong> for no refresh",
// "When the Database search is enabled, you must manually refresh the Tiki search indexes" => "When the Database search is enabled, you must manually refresh the Tiki search indexes",
// "Refresh all search index now" => "Refresh all search index now",
// "Refresh trackers search index now" => "Refresh trackers search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "Parse the results" => "Parse the results",
// "May impact performance" => "May impact performance",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Pertinence" => "Pertinence",
// "Last modified date" => "Last modified date",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "Self" => "Self",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "Plugins" => "Plugins",
// "Plugin Aliases" => "Plugin Aliases",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "External link icon" => "External link icon",
// "External links will be identified with" => "External links will be identified with",
// "Use File Galleries to store pictures " => "Use File Galleries to store pictures ",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "&lt;return&gt; for rows" => "&lt;return&gt; for rows",
// "Show quicktags above textareas" => "Show quicktags above textareas",
// "If disabled, quicktags will be shown to the left of textareas" => "If disabled, quicktags will be shown to the left of textareas",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Plugin disabled" => "Plugin disabled",
// "Default size" => "Default size",
// "Comments " => "Comments ",
// "Forum reply" => "Forum reply",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Edit plugin icons" => "Edit plugin icons",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "(experimental - not comprehensively tested and requires new JQuery feature)" => "(experimental - not comprehensively tested and requires new JQuery feature)",
// "Enable" => "Enable",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Validation" => "Validation",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely",
// "Tracker attachments" => "Tracker attachments",
// "Change" => "Change",
// "No records" => "No records",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Available" => "Available",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Page Listings" => "Page Listings",
// "If the page does not exist, it will be created" => "If the page does not exist, it will be created",
// "Wiki link format" => "Wiki link format",
// "Complete" => "Complete",
// "Latin" => "Latin",
// "Select the characters that can be used with Wiki link syntax: ((page name))" => "Select the characters that can be used with Wiki link syntax: ((page name))",
// "Page display" => "Page display",
// "Page ID" => "Page ID",
// "Page version" => "Page version",
// "Page name display stripper" => "Page name display stripper",
// "Enter a character to use as the delimiter when displaying page names. All characters after the delimiter will be stripped when displaying the page name.</em>" => "Enter a character to use as the delimiter when displaying page names. All characters after the delimiter will be stripped when displaying the page name.</em>",
// "Allow override per page" => "Allow override per page",
// "Display show/hide icon displayed before headings" => "Display show/hide icon displayed before headings",
// "Wiki action bar" => "Wiki action bar",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Page navigation bar location" => "Page navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line" => "Wiki top line",
// "Neither" => "Neither",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Wiki buttons" => "Wiki buttons",
// "Buttons: Edit, Source, Remove, .." => "Buttons: Edit, Source, Remove, ..",
// "Save draft" => "Save draft",
// "Requires AJAX" => "Requires AJAX",
// "experimental" => "experimental",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Allow minor edits" => "Allow minor edits",
// "Minor edits do not flag new content for translation and do not send watch notifications" => "Minor edits do not flag new content for translation and do not send watch notifications",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Regex search and replace" => "Regex search and replace",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "Display by default" => "Display by default",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
// "Remove a tag" => "Remove a tag",
// "WikiWords" => "WikiWords",
// "Maximum number of versions" => "Maximum number of versions",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Display IP address" => "Display IP address",
// "Default diff style" => "Default diff style",
// "HTML diff" => "HTML diff",
// "History includes only page data, description, and change comment" => "History includes only page data, description, and change comment",
// "Forums are disabled" => "Forums are disabled",
// "Forum for discussion" => "Forum for discussion",
// "Polls are disabled" => "Polls are disabled",
// "like pages" => "like pages",
// "Make structure from page" => "Make structure from page",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Create webhelp from structure" => "Create webhelp from structure",
// "Import pages" => "Import pages",
// "Slideshows" => "Slideshows",
// "User's page" => "User's page",
// "Users can lock pages" => "Users can lock pages",
// "When viewing a page, if it doesn't exist automatically redirect to a similarly  named page" => "When viewing a page, if it doesn't exist automatically redirect to a similarly  named page",
// "Wiki watch" => "Wiki watch",
// "Watch minor edits" => "Watch minor edits",
// "Use wiki page staging and approval" => "Use wiki page staging and approval",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Delete staging pages at approval" => "Delete staging pages at approval",
// "If not in the group, edit is always redirected to the staging page edit" => "If not in the group, edit is always redirected to the staging page edit",
// "Unique page name prefix to indicate staging copy" => "Unique page name prefix to indicate staging copy",
// "Hide page name prefix" => "Hide page name prefix",
// "Staging" => "Staging",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "Categorize approved pages with categories of staging copy on approval" => "Categorize approved pages with categories of staging copy on approval",
// "Freetags are disabled" => "Freetags are disabled",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Add new freetags of approved copy (into tags field) when editing staging pages" => "Add new freetags of approved copy (into tags field) when editing staging pages",
// "Orphan page" => "Orphan page",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Edit comments" => "Edit comments",
// "Edit Comments length" => "Edit Comments length",
// "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "Content is partially parsed" => "Content is partially parsed",
// "Toolbar skin" => "Toolbar skin",
// "Toolbar content" => "Toolbar content",
// "Database Version Problem" => "Database Version Problem",
// "A new version of Tikiwiki, <b>{\$tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>" => "A new version of Tikiwiki, <b>{\$tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>",
// "The following list of changes has been applied" => "The following list of changes has been applied",
// "disabled" => "disabled",
// "enabled" => "enabled",
// "information" => "information",
// "preference" => "preference",
// "preference name" => "preference name",
// "TikiCache/System" => "TikiCache/System",
// "Edit Languages" => "Edit Languages",
// "DSN" => "DSN",
// "Please select some actions to view" => "Please select some actions to view",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "mns" => "mns",
// "Volumn per category" => "Volumn per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volumn per the users'group and per contribution" => "Volumn per the users'group and per contribution",
// "Volumn per group and per contribution" => "Volumn per group and per contribution",
// "Volumn per user and per contribution" => "Volumn per user and per contribution",
// "Volumn per users'contribution and time" => "Volumn per users'contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "Configure" => "Configure",
// "Create Calendar" => "Create Calendar",
// "View Calendars" => "View Calendars",
// "Perso" => "Perso",
// "View Calendar" => "View Calendar",
// "Add Event" => "Add Event",
// "Create/Edit Calendars" => "Create/Edit Calendars",
// "Custom URL" => "Custom URL",
// "End of day" => "End of day",
// "Standard Colors" => "Standard Colors",
// "Green" => "Green",
// "Blue" => "Blue",
// "Purple" => "Purple",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Let me select my own colors" => "Let me select my own colors",
// "Ex" => "Ex",
// "Default event status" => "Default event status",
// "Show in calendar view" => "Show in calendar view",
// "Group of users alerted when calendar event is modified" => "Group of users alerted when calendar event is modified",
// "Delete events older than" => "Delete events older than",
// "Browse the category system" => "Browse the category system",
// "Current Category ID" => "Current Category ID",
// "Perms inherited from closest parent if possible or from global perms" => "Perms inherited from closest parent if possible or from global perms",
// "Use in" => "Use in",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Edit the contribution" => "Edit the contribution",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
// "To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link" => "To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Admin External Wikis" => "Admin External Wikis",
// "Enable Features" => "Enable Features",
// "View this forum" => "View this forum",
// "Import forums" => "Import forums",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
// "Set topics preferences" => "Set topics preferences",
// "Show topics preferences" => "Show topics preferences",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "Default style for threads" => "Default style for threads",
// "Duplicate Forum" => "Duplicate Forum",
// "List Forums" => "List Forums",
// ".." => "..",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "Human readable repository name" => "Human readable repository name",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "CSS file to load when browse this repository" => "CSS file to load when browse this repository",
// "Is repository visible to users" => "Is repository visible to users",
// "Can files from repository be cached" => "Can files from repository be cached",
// "Are files from repository can be cached" => "Are files from repository can be cached",
// "Clear all cached pages of this repository" => "Clear all cached pages of this repository",
// "Seconds count 'till cached page will be expired" => "Seconds count 'till cached page will be expired",
// "Human readable text description of repository" => "Human readable text description of repository",
// "view/hide copy rules dialog" => "view/hide copy rules dialog",
// "According this order rules will be applied ('0' or empty = auto)" => "According this order rules will be applied ('0' or empty = auto)",
// "Is this regular expression or simple search/replacer" => "Is this regular expression or simple search/replacer",
// "Is case sensitive (for simple replacer)" => "Is case sensitive (for simple replacer)",
// "Case sensitive" => "Case sensitive",
// "subset of chars: imsxeADSXUu, which is regex modifiers" => "subset of chars: imsxeADSXUu, which is regex modifiers",
// "Human readable text description of rule" => "Human readable text description of rule",
// "Check to enable this rule" => "Check to enable this rule",
// "Apply all rules or just this to generate preview" => "Apply all rules or just this to generate preview",
// "View source code after rules applied" => "View source code after rules applied",
// "Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
// "Case" => "Case",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "Position" => "Position",
// "wiki-get" => "wiki-get",
// "wiki-put" => "wiki-put",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Use Ctrl+Click to select multiple groups" => "Use Ctrl+Click to select multiple groups",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "sorted section level 0" => "sorted section level 0",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Export CSV data" => "Export CSV data",
// "Import CSV data" => "Import CSV data",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "For example, the default icon is: pics/icons/folder.png" => "For example, the default icon is: pics/icons/folder.png",
// "The name of the \"open folder\" icon is: pics/icons/ofolder.png" => "The name of the \"open folder\" icon is: pics/icons/ofolder.png",
// "Assign/Edit modules" => "Assign/Edit modules",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Use Wiki Structure" => "Use Wiki Structure",
// "Edit Newsletter" => "Edit Newsletter",
// "You can add several email addresses by separating them with commas" => "You can add several email addresses by separating them with commas",
// "Group subscription also subscribes included groups" => "Group subscription also subscribes included groups",
// "Don't send confirmation mail" => "Don't send confirmation mail",
// "The user email will be refreshed at each newsletter sending" => "The user email will be refreshed at each newsletter sending",
// "Batch e-mail subscribe" => "Batch e-mail subscribe",
// "txt file, one e-mail per line" => "txt file, one e-mail per line",
// "Export Subscriber Emails" => "Export Subscriber Emails",
// "Included group, group users and emails will be refreshed at each newsletter sending" => "Included group, group users and emails will be refreshed at each newsletter sending",
// "Add subscribers of another newsletter" => "Add subscribers of another newsletter",
// "Create Newsletter" => "Create Newsletter",
// "Allow customized text message to be sent with the html version" => "Allow customized text message to be sent with the html version",
// "Drafts" => "Drafts",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "Alert" => "Alert",
// "A user edits an article" => "A user edits an article",
// "A user deletes an article" => "A user deletes an article",
// "Preload Admin Account" => "Preload Admin Account",
// "User / Group" => "User / Group",
// "Multiple" => "Multiple",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Option" => "Option",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "Votes older than these days are no more considered" => "Votes older than these days are no more considered",
// "0 for no limit" => "0 for no limit",
// "Span" => "Span",
// "Use Ctrl+Click to select multiple pages" => "Use Ctrl+Click to select multiple pages",
// "Tips" => "Tips",
// "To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed" => "To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed",
// "Edit this RSS Module" => "Edit this RSS Module",
// "Create new RSS Module" => "Create new RSS Module",
// "RSS channels" => "RSS channels",
// "Show Date" => "Show Date",
// "View feed" => "View feed",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>",
// "TikiWiki settings" => "TikiWiki settings",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "sticky" => "sticky",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "Edit structure" => "Edit structure",
// "View structure" => "View structure",
// "PDF" => "PDF",
// "Create WebHelp" => "Create WebHelp",
// "View WebHelp" => "View WebHelp",
// "Xml Zip" => "Xml Zip",
// "Add a New Question" => "Add a New Question",
// "This survey stats" => "This survey stats",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
// "Wiki textarea" => "Wiki textarea",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "Min" => "Min",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)" => "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)",
// "Directory to exterminate" => "Directory to exterminate",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "All user prefs sessions" => "All user prefs sessions",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to {\$zipPath}" => "A zip has been written to {\$zipPath}",
// "Directory is not writeable" => "Directory is not writeable",
// "Inactive - Click to Activate" => "Inactive - Click to Activate",
// "New tracker field" => "New tracker field",
// "Select list items that will be displayed" => "Select list items that will be displayed",
// "Multilingual content" => "Multilingual content",
// "Field is public? (viewed in trackerlist plugin)" => "Field is public? (viewed in trackerlist plugin)",
// "Field is hidden" => "Field is hidden",
// "editable by admin only" => "editable by admin only",
// "visible by creator &amp; admin only" => "visible by creator &amp; admin only",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Description text is wiki-parsed" => "Description text is wiki-parsed",
// "Error message" => "Error message",
// "Export fieldId also" => "Export fieldId also",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Edit Tracker" => "Edit Tracker",
// "Create/Edit Tracker" => "Create/Edit Tracker",
// "Create a group for each item" => "Create a group for each item",
// "Use \"explicit\" names in the mirror table" => "Use \"explicit\" names in the mirror table",
// "tracker name must be unique, field names must be unique\nfor a tracker and they must be valid in SQL" => "tracker name must be unique, field names must be unique\nfor a tracker and they must be valid in SQL",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "Only one item per user or IP" => "Only one item per user or IP",
// "The tracker needs a user or IP field with the option 1" => "The tracker needs a user or IP field with the option 1",
// "Format if not the default short one" => "Format if not the default short one",
// "Show creation date when viewing tracker item" => "Show creation date when viewing tracker item",
// "Show lastModif date when viewing tracker item" => "Show lastModif date when viewing tracker item",
// "ItemId" => "ItemId",
// "and display last comment user/date" => "and display last comment user/date",
// "Items can be created only during a certain time" => "Items can be created only during a certain time",
// "Do not show empty fields in item view" => "Do not show empty fields in item view",
// "Show these fields (ID comma separated) in a popup on item link when listing tracker items" => "Show these fields (ID comma separated) in a popup on item link when listing tracker items",
// "Group of users alerted when tracker is modified" => "Group of users alerted when tracker is modified",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "Charset encoding" => "Charset encoding",
// "ISO-8859-1" => "ISO-8859-1",
// "Members" => "Members",
// "User Choice" => "User Choice",
// "Only directly included" => "Only directly included",
// "will have all the permissions of the included groups" => "will have all the permissions of the included groups",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Group Theme" => "Group Theme",
// "Use site default" => "Use site default",
// "choose a group tracker .." => "choose a group tracker ..",
// "choose a field .." => "choose a field ..",
// "choose a users tracker .." => "choose a users tracker ..",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
// "Group tracker item not found" => "Group tracker item not found",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Remove from Group" => "Remove from Group",
// "Add to group" => "Add to group",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login" => "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login",
// "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login" => "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login",
// "ago" => "ago",
// "Need to validate email" => "Need to validate email",
// "Assign to group" => "Assign to group",
// "Edit Included Group" => "Edit Included Group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Remove Users and their Userpages" => "Remove Users and their Userpages",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Template wiki page" => "Template wiki page",
// "Assign user to Groups" => "Assign user to Groups",
// "Use the email as username" => "Use the email as username",
// "Lowercase only" => "Lowercase only",
// "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tikiwiki is configured to delegate the password managment to LDAP through PEAR Auth" => "Tikiwiki is configured to delegate the password managment to LDAP through PEAR Auth",
// "Repeat Password" => "Repeat Password",
// "User must change password at first login" => "User must change password at first login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "Last Login" => "Last Login",
// "User tracker item : {\$usersitemid}" => "User tracker item : {\$usersitemid}",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "Loading.." => "Loading..",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Approve page changes in staging" => "Approve page changes in staging",
// "Page has been approved" => "Page has been approved",
// "New attachments" => "New attachments",
// "Old attachments" => "Old attachments",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "Show Help" => "Show Help",
// "Article type" => "Article type",
// "Show link to source after article body" => "Show link to source after article body",
// "Actions on this article type" => "Actions on this article type",
// "Level configuration" => "Level configuration",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Use Wysiwyg Editor" => "Use Wysiwyg Editor",
// "Use Normal Editor" => "Use Normal Editor",
// "Report to Webmaster" => "Report to Webmaster",
// "Powered by" => "Powered by",
// "The TikiWiki Community" => "The TikiWiki Community",
// "TikiWiki CMS/Groupware" => "TikiWiki CMS/Groupware",
// "database queries used in " => "database queries used in ",
// "Last update from SVN" => "Last update from SVN",
// "Admin the Category System" => "Admin the Category System",
// "Upper level" => "Upper level",
// "Browse related tags" => "Browse related tags",
// "Network of Tags related to" => "Network of Tags related to",
// "With all selected tags" => "With all selected tags",
// "With one selected tag" => "With one selected tag",
// "With last selected tag" => "With last selected tag",
// "More Popular Tags" => "More Popular Tags",
// "Alphabetically" => "Alphabetically",
// "By Size" => "By Size",
// "Cloud" => "Cloud",
// "\$feature_label" => "\$feature_label",
// "Stop Monitoring this Gallery" => "Stop Monitoring this Gallery",
// "Details" => "Details",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "Cyclic" => "Cyclic",
// "Click to zoom" => "Click to zoom",
// "Admin Calendar" => "Admin Calendar",
// "Export Calendars" => "Export Calendars",
// "Click to export calendars" => "Click to export calendars",
// "Click to select visible calendars" => "Click to select visible calendars",
// "Export calendars" => "Export calendars",
// "advanced parameters" => "advanced parameters",
// "Delete event" => "Delete event",
// "All-Day" => "All-Day",
// "Website" => "Website",
// "View this Week" => "View this Week",
// "View this Day" => "View this Day",
// "o" => "o",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "There's no such date as" => "There's no such date as",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Date and time of end" => "Date and time of end",
// "Events cannot end before they start" => "Events cannot end before they start",
// "Choose users to alert" => "Choose users to alert",
// "chair" => "chair",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "Avanced parameters for iCal export" => "Avanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Categories checking is not done in the database search" => "Categories checking is not done in the database search",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Change your password" => "Change your password",
// "Send another message" => "Send another message",
// "Publish this contact to groups" => "Publish this contact to groups",
// "<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "Edit a site" => "Edit a site",
// "Directory Categories" => "Directory Categories",
// "Use Ctrl+Click to select multiple directory categories" => "Use Ctrl+Click to select multiple directory categories",
// "Parent directory category" => "Parent directory category",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Directory Subcategories" => "Directory Subcategories",
// "cType" => "cType",
// "Admin related directory categories" => "Admin related directory categories",
// "Directory Category" => "Directory Category",
// "Use Ctrl+Click to select multiple categories" => "Use Ctrl+Click to select multiple categories",
// "Add a Directory Category" => "Add a Directory Category",
// "in current directory category" => "in current directory category",
// "Related directory categories" => "Related directory categories",
// "Total directory categories" => "Total directory categories",
// "One of the email addresses you typed is invalid" => "One of the email addresses you typed is invalid",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "-1 for unlimited" => "-1 for unlimited",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "Remove Zones (you lose entered info for the banner)" => "Remove Zones (you lose entered info for the banner)",
// "The file will be saved in" => "The file will be saved in",
// "For more information, please see <a href=\"{\$prefs.helpurl}Wiki+Page+Editor\" target=\"tikihelp\" class=\"tikihelp\" title=\"{tr}Wiki Page Editor" => "For more information, please see <a href=\"{\$prefs.helpurl}Wiki+Page+Editor\" target=\"tikihelp\" class=\"tikihelp\" title=\"{tr}Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "Wiki Syntax" => "Wiki Syntax",
// "The syntax system used for creating pages in TikiWiki" => "The syntax system used for creating pages in TikiWiki",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
// "2 dashes" => "2 dashes",
// "show/hide heading section. + (shown) or - (hidden) by default" => "show/hide heading section. + (shown) or - (hidden) by default",
// "Autonumbered Headings" => "Autonumbered Headings",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Horizontal rule" => "Horizontal rule",
// "Inserts an editable variable" => "Inserts an editable variable",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
// "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "to separate pages" => "to separate pages",
// "Prevents wiki parsing of the enclosed data" => "Prevents wiki parsing of the enclosed data",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt",
// "text, bold" => "text, bold",
// "text, italic" => "text, italic",
// "text, underline" => "text, underline",
// "horizontal rule" => "horizontal rule",
// "Add image from File Gallery" => "Add image from File Gallery",
// "quote" => "quote",
// "flash" => "flash",
// "{\$label}" => "{\$label}",
// "Add Image from File Gallery" => "Add Image from File Gallery",
// "Leave Fullscreen Edit" => "Leave Fullscreen Edit",
// "Fullscreen Edit" => "Fullscreen Edit",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Im-Export Languages" => "Im-Export Languages",
// "Toggle interactive translation off" => "Toggle interactive translation off",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "Quiz" => "Quiz",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
// "Edit quiz results" => "Edit quiz results",
// "and its subpages from the structure, now you have two options" => "and its subpages from the structure, now you have two options",
// "and its subpages from the structure" => "and its subpages from the structure",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "Submit Article" => "Submit Article",
// "Auto-Approve Article" => "Auto-Approve Article",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look &amp; Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look &amp; Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Admin notifications" => "Admin notifications",
// "View Article" => "View Article",
// "Unspecified" => "Unspecified",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "Select from available options.." => "Select from available options..",
// "No language is assigned to this page" => "No language is assigned to this page",
// "Please select a language before performing translation" => "Please select a language before performing translation",
// "Set Current Page's Language" => "Set Current Page's Language",
// "Your edit session will expire in" => "Your edit session will expire in",
// "Your edit session will expire in 1 minute. You must PREVIEW or SAVE your work now, to avoid losing your edits" => "Your edit session will expire in 1 minute. You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "Update '{\$page}'" => "Update '{\$page}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead" => "instead",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "Perhaps you are looking for" => "Perhaps you are looking for",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer",
// "Switch to WYSIWYG editor" => "Switch to WYSIWYG editor",
// "Switch to normal (wiki) editor" => "Switch to normal (wiki) editor",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "Disable" => "Disable",
// "AutoSave" => "AutoSave",
// "If you want the saved version instead of the autosaved one" => "If you want the saved version instead of the autosaved one",
// "Regex search " => "Regex search ",
// "Send urgent translation request" => "Send urgent translation request",
// "Edit Comment" => "Edit Comment",
// "Monitor this page" => "Monitor this page",
// "List Sheets" => "List Sheets",
// "Export to file" => "Export to file",
// "Format" => "Format",
// "Export Tracker Items" => "Export Tracker Items",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse as Wiki Text" => "Parse as Wiki Text",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "These fields" => "These fields",
// "Use Ctrl+Click to select multiple fields" => "Use Ctrl+Click to select multiple fields",
// "Dump All Tracker Items" => "Dump All Tracker Items",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
// "normal" => "normal",
// "Search by name" => "Search by name",
// "Search in content" => "Search in content",
// "Reported messages for forum" => "Reported messages for forum",
// "No records to display" => "No records to display",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Set language" => "Set language",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Pending requests" => "Pending requests",
// "Cancel friendship request" => "Cancel friendship request",
// "break friendship" => "break friendship",
// "To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tikiwiki.org\">Galaxia workflow engine</a>" => "To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tikiwiki.org\">Galaxia workflow engine</a>",
// "auto routed" => "auto routed",
// "Expiration Time" => "Expiration Time",
// "Auto routed" => "Auto routed",
// "Edit Tpl" => "Edit Tpl",
// "No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed" => "No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed",
// "New Minor" => "New Minor",
// "New Major" => "New Major",
// "Workitems" => "Workitems",
// "Not Interactive" => "Not Interactive",
// "Not Ended" => "Not Ended",
// "Get property" => "Get property",
// "Set property" => "Set property",
// "Set Next act" => "Set Next act",
// "Switch construct" => "Switch construct",
// "Enter the name of this instance" => "Enter the name of this instance",
// "The name is not valid. Please, enter the name again" => "The name is not valid. Please, enter the name again",
// "Not ended" => "Not ended",
// "Monitor workitems" => "Monitor workitems",
// "List of workitems" => "List of workitems",
// "exception instance" => "exception instance",
// "exceptions instance" => "exceptions instance",
// "Send Instance" => "Send Instance",
// "grab instance" => "grab instance",
// "Not defined" => "Not defined",
// "Browsing Workitem" => "Browsing Workitem",
// "Workitem information" => "Workitem information",
// "Global default" => "Global default",
// "Google Map Locator" => "Google Map Locator",
// "Save clicked point" => "Save clicked point",
// "Reset view to default" => "Reset view to default",
// "Save current view as default" => "Save current view as default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Select Graphic Type" => "Select Graphic Type",
// "Horizontal Scale" => "Horizontal Scale",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Modify String in Source Language" => "Modify String in Source Language",
// "Original String" => "Original String",
// "New String" => "New String",
// "Import pages from a Structured Text Dump" => "Import pages from a Structured Text Dump",
// "body" => "body",
// "XML Zip" => "XML Zip",
// "Welcome" => "Welcome",
// "Welcome to the Tiki installation and upgrade script" => "Welcome to the Tiki installation and upgrade script",
// "Use this script to install a new Tiki database or upgrade your existing database to release" => "Use this script to install a new Tiki database or upgrade your existing database to release",
// "For the latest information about this release, please read the" => "For the latest information about this release, please read the",
// "Release Notes" => "Release Notes",
// "For complete documentation, please visit" => "For complete documentation, please visit",
// "For more information about Tiki, please visit" => "For more information about Tiki, please visit",
// "Select your language" => "Select your language",
// "Read the License" => "Read the License",
// "Tiki is software distributed under the LGPL license" => "Tiki is software distributed under the LGPL license",
// " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>",
// "Review the System Requirements" => "Review the System Requirements",
// "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements",
// "This installer will perform some basic checks automatically" => "This installer will perform some basic checks automatically",
// "Memory" => "Memory",
// "Success" => "Success",
// "Tiki has not detected your PHP memory_limit" => "Tiki has not detected your PHP memory_limit",
// "This probably means you have no set limit (all is well)" => "This probably means you have no set limit (all is well)",
// "Tiki has detected your PHP memory limit at" => "Tiki has detected your PHP memory limit at",
// "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution",
// "Allocating too little memory will cause Tiki to display blank pages" => "Allocating too little memory will cause Tiki to display blank pages",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver",
// "Tiki has detected your PHP memory_limit at" => "Tiki has detected your PHP memory_limit at",
// "Mail" => "Mail",
// "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages",
// "To test your system configuration, Tiki will attempt to send a test message to you" => "To test your system configuration, Tiki will attempt to send a test message to you",
// "Test email" => "Test email",
// "Email address to send test to" => "Email address to send test to",
// "Copy test mail to " => "Copy test mail to ",
// "Send Test Message" => "Send Test Message",
// "Tiki was able to send a test message to" => "Tiki was able to send a test message to",
// "Tiki was not able to send a test message" => "Tiki was not able to send a test message",
// "Review your mail log for details" => "Review your mail log for details",
// "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)",
// "If your host requires SMTP authentication, additional configuration may be necessary" => "If your host requires SMTP authentication, additional configuration may be necessary",
// "Image Processing" => "Image Processing",
// "Tiki detected" => "Tiki detected",
// "Tiki was not able to detect the GD library" => "Tiki was not able to detect the GD library",
// "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support",
// "Set the Database Connection" => "Set the Database Connection",
// "Tiki requires an active database connection" => "Tiki requires an active database connection",
// "You must create the database and user <em>before</em> completing this page" => "You must create the database and user <em>before</em> completing this page",
// "This is normal for a new installation" => "This is normal for a new installation",
// "Tiki found an existing database connection in your local.php file" => "Tiki found an existing database connection in your local.php file",
// "Use Existing Connection" => "Use Existing Connection",
// "Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
// "Database information" => "Database information",
// "Enter your database connection information" => "Enter your database connection information",
// "Select the type of database to use with Tiki" => "Select the type of database to use with Tiki",
// "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension",
// "Host name" => "Host name",
// "Enter the host name or IP for your database" => "Enter the host name or IP for your database",
// "Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Use <strong>localhost</strong> if the database is running on the same machine as Tiki",
// "For SQLite, enter the path and filename to your database file" => "For SQLite, enter the path and filename to your database file",
// "Enter the name of the database that Tiki will use" => "Enter the name of the database that Tiki will use",
// "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names",
// "For Oracle" => "For Oracle",
// "Enter your TNS Name here and leave Host empty" => "Enter your TNS Name here and leave Host empty",
// "Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field" => "Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field",
// "Enter a database user with administrator permission for the Database" => "Enter a database user with administrator permission for the Database",
// "User name" => "User name",
// "Install &amp; Update Profile" => "Install &amp; Update Profile",
// "Install Profile" => "Install Profile",
// "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page" => "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page",
// "Select the installation (or upgrade) profile to use. This profile will populate (or upgrade) the database" => "Select the installation (or upgrade) profile to use. This profile will populate (or upgrade) the database",
// "Select the installation profile to use. This profile will populate the database" => "Select the installation profile to use. This profile will populate the database",
// "Profiles can be used to pre-configure your site with specific features and settings" => "Profiles can be used to pre-configure your site with specific features and settings",
// "Visit <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> for more information" => "Visit <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> for more information",
// "Reinstall the database" => "Reinstall the database",
// "This will destroy your current database" => "This will destroy your current database",
// "Create a new database (clean install) with profile" => "Create a new database (clean install) with profile",
// "Bare-bones default install" => "Bare-bones default install",
// "Personal Blog and Profile" => "Personal Blog and Profile",
// "Small Organization Web Presence" => "Small Organization Web Presence",
// "Company Intranet" => "Company Intranet",
// "Collaborative community" => "Collaborative community",
// "See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles" => "See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles",
// "The installer could not connect to the Profiles repository" => "The installer could not connect to the Profiles repository",
// "The default installation profile will be used" => "The default installation profile will be used",
// "Automatically upgrade your existing database to v" => "Automatically upgrade your existing database to v",
// "Please login with your admin password to continue" => "Please login with your admin password to continue",
// "Review the Upgrade" => "Review the Upgrade",
// "Review the Installation" => "Review the Installation",
// "Upgrade complete" => "Upgrade complete",
// "Installation complete" => "Installation complete",
// "Your database has been configured and Tiki is ready to run" => "Your database has been configured and Tiki is ready to run",
// "If this is your first install, your admin password is <strong>admin</strong>" => "If this is your first install, your admin password is <strong>admin</strong>",
// "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application",
// "Upgrade operations executed successfully" => "Upgrade operations executed successfully",
// "Installation operations executed successfully" => "Installation operations executed successfully",
// "SQL queries" => "SQL queries",
// "Database was left unchanged" => "Database was left unchanged",
// "Failed" => "Failed",
// "Operations failed" => "Operations failed",
// "Display details" => "Display details",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages",
// ".htaccess File" => ".htaccess File",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>",
// "Complete these fields to configure common, general settings for your site" => "Complete these fields to configure common, general settings for your site",
// "The information you enter here can be changed later" => "The information you enter here can be changed later",
// "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings",
// "This will appear in the browser title bar" => "This will appear in the browser title bar",
// "Email sent by your site will use this address" => "Email sent by your site will use this address",
// "Secure Login" => "Secure Login",
// "Administrator" => "Administrator",
// "Admin email" => "Admin email",
// "This is the email address for your administrator account" => "This is the email address for your administrator account",
// "Enter Your Tiki" => "Enter Your Tiki",
// "The installation is complete" => "The installation is complete",
// "Tiki is an opensource project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an opensource project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>",
// "Installation" => "Installation",
// "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
// "Enter Tiki and Lock Installer" => "Enter Tiki and Lock Installer",
// "Recommended" => "Recommended",
// "Enter Tiki Without Locking Installer" => "Enter Tiki Without Locking Installer",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "DB OK" => "DB OK",
// "No DB" => "No DB",
// "Adding a new host" => "Adding a new host",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "Are you upgrading an existing Tiki site" => "Are you upgrading an existing Tiki site",
// "Go directly to the <strong>Install/Upgrade</strong> step" => "Go directly to the <strong>Install/Upgrade</strong> step",
// "Install/Upgrade" => "Install/Upgrade",
// "Restart the installer" => "Restart the installer",
// "Database Connection" => "Database Connection",
// "Reset the Database Connection" => "Reset the Database Connection",
// "Configure the General Settings" => "Configure the General Settings",
// "Tiki Icon" => "Tiki Icon",
// "TikiWiki Project Web Site" => "TikiWiki Project Web Site",
// "Support Forums" => "Support Forums",
// "TikiWiki CMS/Groupware Project" => "TikiWiki CMS/Groupware Project",
// "Powered by TikiWiki" => "Powered by TikiWiki",
// "Interactive translator" => "Interactive translator",
// "has been updated" => "has been updated",
// "Close this window" => "Close this window",
// "Go Back" => "Go Back",
// "Clicking 'Close this window' will reload the main window from where it was opened" => "Clicking 'Close this window' will reload the main window from where it was opened",
// "Last 2 days" => "Last 2 days",
// "Last 3 days" => "Last 3 days",
// "Last 5 days" => "Last 5 days",
// "Last week" => "Last week",
// "Last 2 weeks" => "Last 2 weeks",
// "Last month" => "Last month",
// "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
// "Max Clicks" => "Max Clicks",
// "The cache is used by" => "The cache is used by",
// "Approval" => "Approval",
// "Rejected" => "Rejected",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
// "Current Value" => "Current Value",
// "SlideShow" => "SlideShow",
// "Keep gallery window open" => "Keep gallery window open",
// "optional" => "optional",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Flash binary (.swf or .dcr)" => "Flash binary (.swf or .dcr)",
// "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on" => "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on",
// "Page creator" => "Page creator",
// "Status of the page" => "Status of the page",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// "Page size" => "Page size",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "offline" => "offline",
// "Back to admin" => "Back to admin",
// "operator" => "operator",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Thank you" => "Thank you",
// "This is an experimental feature" => "This is an experimental feature",
// "Requires" => "Requires",
// "Not Enabled" => "Not Enabled",
// "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "all versions" => "all versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "Package Config" => "Package Config",
// "My Articles" => "My Articles",
// "User Articles" => "User Articles",
// "My User Items" => "My User Items",
// "User Items" => "User Items",
// "User forum topics" => "User forum topics",
// "Forum topics" => "Forum topics",
// "Date of post" => "Date of post",
// "User forum replies" => "User forum replies",
// "Forum replies" => "Forum replies",
// "To display the objects you participate" => "To display the objects you participate",
// "My Galleries" => "My Galleries",
// "My Tracker Items" => "My Tracker Items",
// "My Tasks" => "My Tasks",
// "Sent Edition" => "Sent Edition",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Add a news server" => "Add a news server",
// "Edit news server" => "Edit news server",
// "Wiki Create" => "Wiki Create",
// "Wiki Overwrite" => "Wiki Overwrite",
// "Object Watches" => "Object Watches",
// "Watching Groups" => "Watching Groups",
// "These permissions override any global permissions or category permissions affecting this object" => "These permissions override any global permissions or category permissions affecting this object",
// "To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>" => "To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>",
// "These permissions do not apply. Special permissions apply" => "These permissions do not apply. Special permissions apply",
// "and also to all pages of the sub-structure" => "and also to all pages of the sub-structure",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "View Details" => "View Details",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Any" => "Any",
// "Items found" => "Items found",
// "Sum" => "Sum",
// "Plugin Approval" => "Plugin Approval",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Plugin" => "Plugin",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "Permission denied. You do not have permission to read complete articles" => "Permission denied. You do not have permission to read complete articles",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "No pages" => "No pages",
// "Add Structure Pages" => "Add Structure Pages",
// "No pages selected" => "No pages selected",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions" => "randomly selected questions",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "&nbsp question(s)" => "&nbsp question(s)",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz" => "Allow students to store partial results and return to quiz",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
// "Grading method " => "Grading method ",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers " => "Show students the correct answers ",
// "Publish statistics " => "Publish statistics ",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
// "Prologue" => "Prologue",
// "Epilogue" => "Epilogue",
// "time taken" => "time taken",
// "Passed" => "Passed",
// "Rank" => "Rank",
// "Send a link" => "Send a link",
// "List all articles of this same topic" => "List all articles of this same topic",
// "Received Pages" => "Received Pages",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Received Structures" => "Received Structures",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "Use your email as login" => "Use your email as login",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Generate a\tpassword" => "Generate a\tpassword",
// "NOTE: Make sure to whitelist this domain to prevent registration emails being canned by your spam filter" => "NOTE: Make sure to whitelist this domain to prevent registration emails being canned by your spam filter",
// "Please register" => "Please register",
// "Enter your username or email" => "Enter your username or email",
// "Enter your email" => "Enter your email",
// "Request Password Reset" => "Request Password Reset",
// "Back to page" => "Back to page",
// "to version" => "to version",
// "\$name" => "\$name",
// "Faqs" => "Faqs",
// "Blogs Post" => "Blogs Post",
// "Date Search" => "Date Search",
// "All dates" => "All dates",
// "Calendar Items" => "Calendar Items",
// "Please Confirm" => "Please Confirm",
// "octets" => "octets",
// "Apply content template" => "Apply content template",
// "Data HTML" => "Data HTML",
// "Data Txt" => "Data Txt",
// "Attached Files" => "Attached Files",
// "To add a file, click here" => "To add a file, click here",
// "Save as Draft" => "Save as Draft",
// "Send a structure" => "Send a structure",
// "Ex: http://tikiwiki.org or localhost" => "Ex: http://tikiwiki.org or localhost",
// "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need",
// "Create a sheet" => "Create a sheet",
// "Edit this sheet" => "Edit this sheet",
// "Create New Sheet" => "Create New Sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
// "Create new Sheet" => "Create new Sheet",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Approve changes" => "Approve changes",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "page: %0/%1" => "page: %0/%1",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
// "redface" => "redface",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Params" => "Params",
// "Date of first pageview" => "Date of first pageview",
// "Days since first pageview" => "Days since first pageview",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "FAQ Stats" => "FAQ Stats",
// "Tiki Logs" => "Tiki Logs",
// "Thank you for your submission" => "Thank you for your submission",
// "Send a link to a friend" => "Send a link to a friend",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "Friend's email" => "Friend's email",
// "Separate multiple email addresses with a comma" => "Separate multiple email addresses with a comma",
// "Your email" => "Your email",
// "I found an interesting page that I thought you would like" => "I found an interesting page that I thought you would like",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Logout" => "Use Current Session/Logout",
// "Recorded Links" => "Recorded Links",
// "Request" => "Request",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "Additional Info" => "Additional Info",
// "You can link to the file from a Wiki page using" => "You can link to the file from a Wiki page using",
// "You can display an image in a Wiki page using" => "You can display an image in a Wiki page using",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "Unzip zip files" => "Unzip zip files",
// "Maximum amount of downloads" => "Maximum amount of downloads",
// "Add File" => "Add File",
// "Maximum file size is limited to" => "Maximum file size is limited to",
// "No gallery available" => "No gallery available",
// "You have to create a gallery first" => "You have to create a gallery first",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// "The column is disabled" => "The column is disabled",
// "a folder" => "a folder",
// "a URL" => "a URL",
// "(non public)" => "(non public)",
// "Homepage" => "Homepage",
// "System" => "System",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Toggle" => "Toggle",
// "Can you read more languages" => "Can you read more languages",
// "Select language.." => "Select language..",
// "Displays users' info tooltip on mouseover for every user who allows his information to be public" => "Displays users' info tooltip on mouseover for every user who allows his information to be public",
// "My user items" => "My user items",
// "Waiting for Me" => "Waiting for Me",
// "This message will be send to users if you are makeing changes of assigned tasks" => "This message will be send to users if you are makeing changes of assigned tasks",
// "You can only view this task" => "You can only view this task",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use \"watches\" to monitor wiki pages or other objects" => "Use \"watches\" to monitor wiki pages or other objects",
// "Watch new items by clicking the {icon _id=eye} button on specific pages" => "Watch new items by clicking the {icon _id=eye} button on specific pages",
// "Select event type" => "Select event type",
// "All watched events" => "All watched events",
// "A user edited an article" => "A user edited an article",
// "A user deleted an article" => "A user deleted an article",
// "A user created a wiki page in a language" => "A user created a wiki page in a language",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
// "No articles yet" => "No articles yet",
// "Add an article" => "Add an article",
// "Permanency" => "Permanency",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
// "Editing" => "Editing",
// "Post New" => "Post New",
// "Watch for replies" => "Watch for replies",
// "Send me an e-mail when someone replies to my topic" => "Send me an e-mail when someone replies to my topic",
// "Don't send me any e-mails" => "Don't send me any e-mails",
// "Editing posts" => "Editing posts",
// "Forum Lock" => "Forum Lock",
// "Unarchive" => "Unarchive",
// "posts in this forum" => "posts in this forum",
// "Filter Posts" => "Filter Posts",
// "Posts Filtering" => "Posts Filtering",
// "Last post date" => "Last post date",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
// "Posts with no replies" => "Posts with no replies",
// "Archived" => "Archived",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
// "Print this page only" => "Print this page only",
// "Print all pages" => "Print all pages",
// "Stop Monitor" => "Stop Monitor",
// "Tracker Items" => "Tracker Items",
// "Pending" => "Pending",
// "Special Operations" => "Special Operations",
// "There was an error connecting to your e-mail account" => "There was an error connecting to your e-mail account",
// "Add a new" => "Add a new",
// "Edit this" => "Edit this",
// " mail account" => " mail account",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "Click to activate" => "Click to activate",
// "This is the active account" => "This is the active account",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Clip" => "Clip",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Jump to Content" => "Jump to Content",
// "Latitude" => "Latitude",
// "Longitude" => "Longitude",
// "Remove Image" => "Remove Image",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator",
// "Number of voices" => "Number of voices",
// "Your vote" => "Your vote",
// "Click to vote for this value" => "Click to vote for this value",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "list" => "list",
// "Reinstall" => "Reinstall",
// "Undecided" => "Undecided",
// "Subscribe to a group" => "Subscribe to a group",
// "Toggle display" => "Toggle display",
// "Preview your changes" => "Preview your changes",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not send notifications and do not count it as new content to be translated" => "Save the page, but do not send notifications and do not count it as new content to be translated",
// "Save the page" => "Save the page",
// "Save the page as a draft" => "Save the page as a draft",
// "Save Draft" => "Save Draft",
// "Cancel the edit, you will lose your changes" => "Cancel the edit, you will lose your changes",
// "If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>" => "If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>",
// "Separate multiple usernames with a comma (&nbsp;,&nbsp;)" => "Separate multiple usernames with a comma (&nbsp;,&nbsp;)",
// "Permission denied you cannot view the Tiki calendar" => "Permission denied you cannot view the Tiki calendar",
// "%s set" => "%s set",
// "%s unset" => "%s unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Wiki Attachments" => "Wiki Attachments",
// "Freetags settings" => "Freetags settings",
// "Look & Feel" => "Look & Feel",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Help on \$admintitle Config" => "Help on \$admintitle Config",
// "Current version is up to date : <b>%s</b>" => "Current version is up to date : <b>%s</b>",
// "A new %s  major release branch is available" => "A new %s  major release branch is available",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Click here to delete the category" => "Click here to delete the category",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "Category can`t be parent of itself" => "Category can`t be parent of itself",
// "You have to provide a hotword and a URL" => "You have to provide a hotword and a URL",
// "moved %d images, %d errors occured" => "moved %d images, %d errors occured",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Test Image" => "Test Image",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "No valid gdaltindex executable" => "No valid gdaltindex executable",
// "If you use apache, you need a .htaccess file to have this feature working" => "If you use apache, you need a .htaccess file to have this feature working",
// "Requested action is not supported on repository" => "Requested action is not supported on repository",
// "Requested action in not supported on repository" => "Requested action in not supported on repository",
// "Frequency should be a positive integer" => "Frequency should be a positive integer",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Cannot create or update module: You need to specify a name to the module" => "Cannot create or update module: You need to specify a name to the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tikiwiki version: " => "This file is from another Tikiwiki version: ",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Remove group: " => "Remove group: ",
// "Remove permission: %s on %s" => "Remove permission: %s on %s",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "User login contains invalid characters" => "User login contains invalid characters",
// "Impossible to create new %s with %s %s" => "Impossible to create new %s with %s %s",
// "Deleted account %s" => "Deleted account %s",
// "%s <b>%s</b> assigned to %s <b>%s</b>" => "%s <b>%s</b> assigned to %s <b>%s</b>",
// "%s <b>%s</b> removed from %s <b>%s</b>" => "%s <b>%s</b> removed from %s <b>%s</b>",
// "group <b>%s</b> set as the default group of user <b>%s</b>" => "group <b>%s</b> set as the default group of user <b>%s</b>",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "Permission denied you cannot approve staging pages" => "Permission denied you cannot approve staging pages",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "You have to indicate a group" => "You have to indicate a group",
// "This group is invalid" => "This group is invalid",
// "Permission denied you cannot view backlinks for this page" => "Permission denied you cannot view backlinks for this page",
// "Image %s upload failed" => "Image %s upload failed",
// "Image %s uploaded successfully" => "Image %s uploaded successfully",
// "Image %s removed from Batch directory" => "Image %s removed from Batch directory",
// "Impossible to remove image %s from Batch directory" => "Impossible to remove image %s from Batch directory",
// "Permission denied you cannot use the batch directory loading" => "Permission denied you cannot use the batch directory loading",
// "Please contact the website administrator" => "Please contact the website administrator",
// "Upload was successful" => "Upload was successful",
// "Last modifications to the blog" => "Last modifications to the blog",
// "TOP" => "TOP",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache" => "You must clear your browser cache",
// "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>",
// "Permission denied you can not view this page" => "Permission denied you can not view this page",
// "Mo" => "Mo",
// "Tu" => "Tu",
// "We" => "We",
// "Th" => "Th",
// "Fr" => "Fr",
// "Sa" => "Sa",
// "Su" => "Su",
// "Permission denied; you cannot assign permissions for this category" => "Permission denied; you cannot assign permissions for this category",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Invalid old password or unknown user" => "Invalid old password or unknown user",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "ERROR: you must include a subject or a message at least" => "ERROR: you must include a subject or a message at least",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "No parent specified" => "No parent specified",
// "Last sites of directory \".\$rc[\"name\"].\" " => "Last sites of directory \".\$rc[\"name\"].\" ",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
// "You do not have permission to write the template" => "You do not have permission to write the template",
// "Translation in progress" => "Translation in progress",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "Page already exists. Go back and choose a different name" => "Page already exists. Go back and choose a different name",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "No questions group indicated" => "No questions group indicated",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "Not supported yet" => "Not supported yet",
// "Refused friendship request from %s" => "Refused friendship request from %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Broke friendship with %s" => "Broke friendship with %s",
// "I have broken our friendship" => "I have broken our friendship",
// "Friendship request sent to %s" => "Friendship request sent to %s",
// "You're already friend of %s" => "You're already friend of %s",
// "I have accepted your friendship request" => "I have accepted your friendship request",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "Invalid source path" => "Invalid source path",
// "A start activity requires a name for the instance" => "A start activity requires a name for the instance",
// "You couldn't abort a instance" => "You couldn't abort a instance",
// "You couldn't exception a instance" => "You couldn't exception a instance",
// "Permission denied you cannot make the map of this gallery" => "Permission denied you cannot make the map of this gallery",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
// "Last images uploaded to the image galleries" => "Last images uploaded to the image galleries",
// "Only the administrator can upload language files" => "Only the administrator can upload language files",
// "updated from structured text import" => "updated from structured text import",
// "created from structured text import" => "created from structured text import",
// "Operations executed successfully" => "Operations executed successfully",
// "Page saved (version %d)" => "Page saved (version %d)",
// "Error writing in the databse: \$query" => "Error writing in the databse: \$query",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Permission denied you can edit this file" => "Permission denied you can edit this file",
// "Cannot read the file" => "Cannot read the file",
// "The game file must have .swf or .dcr extension" => "The game file must have .swf or .dcr extension",
// "Please supply both files" => "Please supply both files",
// "Unable to contact remote server" => "Unable to contact remote server",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "Feature Ajax Disabled. Please ask your site administrator to enable" => "Feature Ajax Disabled. Please ask your site administrator to enable",
// "You must first setup MapServer" => "You must first setup MapServer",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named '.\$prefs['map_path'].' to hold your map files" => "Please create a directory named '.\$prefs['map_path'].' to hold your map files",
// "Maps feature is not correctly setup : Maps path is missing" => "Maps feature is not correctly setup : Maps path is missing",
// "map edit" => "map edit",
// "I do not know where is gdaltindex. Set correctly the Map feature" => "I do not know where is gdaltindex. Set correctly the Map feature",
// "No page provided" => "No page provided",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more" => "This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more",
// "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site" => "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site",
// "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody",
// "merged note" => "merged note",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "Permission denied you cannot assign permissions for this object" => "Permission denied you cannot assign permissions for this object",
// "Permission denied you cannot view the source of this page" => "Permission denied you cannot view the source of this page",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "You don't have permission to edit quizzes" => "You don't have permission to edit quizzes",
// "You must choose a group" => "You must choose a group",
// "Username must be at least" => "Username must be at least",
// "characters" => "characters",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "This is not a valid mail adress" => "This is not a valid mail adress",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "changed '%s' from '%s' to '%s'" => "changed '%s' from '%s' to '%s'",
// "Post recommendation at" => "Post recommendation at",
// "invalid email" => "invalid email",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Permission denied you cannot remove this sheet" => "Permission denied you cannot remove this sheet",
// "Clean the sql logs" => "Clean the sql logs",
// "Report to the webmaster" => "Report to the webmaster",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Password has been changed" => "Password has been changed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "Rights by creator" => "Rights by creator",
// "END" => "END",
// "Percentage" => "Percentage",
// "Sorry this task does not exist or you have no rights to view this task" => "Sorry this task does not exist or you have no rights to view this task",
// "Task entries" => "Task entries",
// "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks" => "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks",
// "You've to start your work at least on" => "You've to start your work at least on",
// "You've to finish your work on" => "You've to finish your work on",
// "Please read the task and work on it" => "Please read the task and work on it",
// "Sorry, there was an error while trying to write data into the database" => "Sorry, there was an error while trying to write data into the database",
// "A new page is created in a language" => "A new page is created in a language",
// "Language watch" => "Language watch",
// "Permission denied: you cannot view this blog post while it is marked private" => "Permission denied: you cannot view this blog post while it is marked private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "Incorrect thread" => "Incorrect thread",
// "That tracker don't use extras" => "That tracker don't use extras",
// " The connection failed, so check the server names" => " The connection failed, so check the server names",
// "The connection was OK" => "The connection was OK",
// " But the login failed, so check the Username and Password" => " But the login failed, so check the Username and Password",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Andorra" => "Andorra",
"Angola" => "Angola",
"Antigua" => "Antigua",
"Aruba" => "Aruba",
"Australia" => "Australia",
"Bahamas" => "Bahamas",
"Bahrain" => "Bahrain",
"Bangladesh" => "Bangladesh",
"Barbados" => "Barbados",
"Benin" => "Benin",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Botswana" => "Botswana",
"Brunei" => "Brunei",
"Burundi" => "Burundi",
"Chile" => "Chile",
"China" => "China",
"Colombia" => "Colombia",
"Cyprus" => "Cyprus",
"Ecuador" => "Ecuador",
"Egypt" => "Egypt",
"Estonia" => "Estonia",
"Finland" => "Finland",
"France" => "France",
"Georgia" => "Georgia",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Greece" => "Greece",
"Grenada" => "Grenada",
"Guadeloupe" => "Guadeloupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernsey",
"Guinea" => "Guinea",
"Guyana" => "Guyana",
"Haiti" => "Haiti",
"Honduras" => "Honduras",
"India" => "India",
"Iran" => "Iran",
"Israel" => "Israel",
"Italy" => "Italy",
"Japan" => "Japan",
"Jordan" => "Jordan",
"Kazakstan" => "Kazakstan",
"Kenya" => "Kenya",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Laos" => "Laos",
"Latvia" => "Latvia",
"Luxemburg" => "Luxemburg",
"Macao" => "Macao",
"Malawi" => "Malawi",
"Malaysia" => "Malaysia",
"Mali" => "Mali",
"Malta" => "Malta",
"Martinique" => "Martinique",
"Mauritius" => "Mauritius",
"Mexico" => "Mexico",
"Monaco" => "Monaco",
"Morocco" => "Morocco",
"Mozambique" => "Mozambique",
"Namibia" => "Namibia",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
"Nicaragua" => "Nicaragua",
"Niger" => "Niger",
"Nigeria" => "Nigeria",
"Niue" => "Niue",
"Pakistan" => "Pakistan",
"Panama" => "Panama",
"Paraguay" => "Paraguay",
"Peru" => "Peru",
"Poland" => "Poland",
"Portugal" => "Portugal",
"Quatar" => "Quatar",
"Romania" => "Romania",
"Samoa" => "Samoa",
"Senegal" => "Senegal",
"Singapore" => "Singapore",
"Somalia" => "Somalia",
"Sudan" => "Sudan",
"Surinam" => "Surinam",
"Swaziland" => "Swaziland",
"Sweden" => "Sweden",
"Taiwan" => "Taiwan",
"Thailand" => "Thailand",
"Timor-Leste" => "Timor-Leste",
"Togo" => "Togo",
"Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Turkmenistan" => "Turkmenistan",
"Tuvalu" => "Tuvalu",
"Uganda" => "Uganda",
"Ukraine" => "Ukraine",
"Uruguay" => "Uruguay",
"Vanuatu" => "Vanuatu",
"Venezuela" => "Venezuela",
"Wales" => "Wales",
"Arabic" => "Arabic",
"Simplified Chinese" => "Simplified Chinese",
"English British" => "English British",
"Hebrew" => "Hebrew",
"Korean" => "Korean",
"Pijin Solomon" => "Pijin Solomon",
"Serbian Latin" => "Serbian Latin",
"Tuvaluan" => "Tuvaluan",
"Traditional Chinese" => "Traditional Chinese",
"latin" => "latin",
"CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
"in" => "in",
"Wiki" => "Wiki",
"Blogs" => "Blogs",
"FAQs" => "FAQs",
"Link" => "Link",
"Forums last posts" => "Forums last posts",
"Downloads" => "Downloads",
"Tracker" => "Tracker",
"Date Selector" => "Date Selector",
"Text cut here" => "Text cut here",
"km" => "km",
"max" => "max",
"Google Maps" => "Google Maps",
"(AT)" => "(AT)",
"(DOT)" => "(DOT)",
"linktext" => "linktext",
"Cookie" => "Cookie",
"Copyright" => "Copyright",
"Start" => "Start",
"Information" => "Information",
"Pop-up" => "Pop-up",
"Sheet Heading" => "Sheet Heading",
"TikiSheet" => "TikiSheet",
"Edit Sheet" => "Edit Sheet",
"row1col1" => "row1col1",
"row1col2" => "row1col2",
"row2col1" => "row2col1",
"row2col2" => "row2col2",
"Tag" => "Tag",
"Displays text between an html tag" => "Displays text between an html tag",
"Original" => "Original",
"Search the titles of all pages in this wiki" => "Search the titles of all pages in this wiki",
"Custom-Level-Regex" => "Custom-Level-Regex",
"__key__ | __default__ | __comments__\n" => "__key__ | __default__ | __comments__\n",
", " => ", ",
"dash-WikiWord" => "dash-WikiWord",
"WikiWord" => "WikiWord",
"Threaded" => "Threaded",
"Reply to the selected post" => "Reply to the selected post",
"Smileys" => "Smileys",
"Reply to parent post" => "Reply to parent post",
"Copyrights" => "Copyrights",
"Syntax" => "Syntax",
"RSS Wiki" => "RSS Wiki",
"RSS Blogs" => "RSS Blogs",
"RSS Articles" => "RSS Articles",
"RSS File Galleries" => "RSS File Galleries",
"RSS Forums" => "RSS Forums",
"RSS Directories" => "RSS Directories",
"RSS Calendars" => "RSS Calendars",
"New article submitted at %s" => "New article submitted at %s",
"Pan" => "Pan",
"Layer" => "Layer",
"Diff" => "Diff",
"OK" => "OK",
"CC" => "CC",
"BCC" => "BCC",
"No messages to download" => "No messages to download",
"1" => "1",
"2" => "2",
"3" => "3",
"4" => "4",
"5" => "5",
"\$tpl_module_title" => "\$tpl_module_title",
"Cache" => "Cache",
"Links" => "Links",
"Hotwords" => "Hotwords",
"Chat" => "Chat",
"Cookies" => "Cookies",
"Mail-in" => "Mail-in",
"\$module_title" => "\$module_title",
"April" => "April",
"August" => "August",
"September" => "September",
"November" => "November",
"\$modcattitle" => "\$modcattitle",
"\$type" => "\$type",
"Last Modified Comments" => "Last Modified Comments",
"Login through CAS" => "Login through CAS",
"Standard" => "Standard",
"local account" => "local account",
"Tiki Logo" => "Tiki Logo",
"RSS Feeds" => "RSS Feeds",
"Wiki RSS" => "Wiki RSS",
"Blogs RSS" => "Blogs RSS",
"Theme" => "Theme",
"Top `\$module_rows` Forum Posters" => "Top `\$module_rows` Forum Posters",
"Top Forum Posters" => "Top Forum Posters",
"Top `\$module_rows` Objects" => "Top `\$module_rows` Objects",
"Top Objects" => "Top Objects",
"Upcoming `\$module_rows` events" => "Upcoming `\$module_rows` events",
"[-]" => "[-]",
"Permalink" => "Permalink",
"Trackback pings" => "Trackback pings",
"URI" => "URI",
"Tip" => "Tip",
"i18n" => "i18n",
"RSS" => "RSS",
"Freetags" => "Freetags",
"Webmail" => "Webmail",
"Intertiki" => "Intertiki",
"Featured Help" => "Featured Help",
"PHPLayers" => "PHPLayers",
"Ajax" => "Ajax",
"Spreadsheet" => "Spreadsheet",
"Tiki Sheet" => "Tiki Sheet",
"Integrator" => "Integrator",
"MIME Type" => "MIME Type",
"Moved" => "Moved",
"Unix" => "Unix",
"Windows" => "Windows",
"(standard)" => "(standard)",
"Google Map setup" => "Google Map setup",
"Google Map Key" => "Google Map Key",
"Default x for map center" => "Default x for map center",
"Default y from map center" => "Default y from map center",
"Default zoom level" => "Default zoom level",
"Intertiki exchange feature" => "Intertiki exchange feature",
"Import user preferences" => "Import user preferences",
"Import user groups" => "Import user groups",
"InterTiki Server" => "InterTiki Server",
"IP" => "IP",
"PEAR::Auth" => "PEAR::Auth",
"PAM" => "PAM",
"LDAP" => "LDAP",
"Version 1.0" => "Version 1.0",
"Version 2.0" => "Version 2.0",
"Template Viewing" => "Template Viewing",
"Users can Flip Columns" => "Users can Flip Columns",
"Vertical" => "Vertical",
"Horizontal" => "Horizontal",
"image/png" => "image/png",
"image/bmp" => "image/bmp",
"image/x-icon" => "image/x-icon",
"Map Zone" => "Map Zone",
"Robots" => "Robots",
"Editor" => "Editor",
"Webmaster" => "Webmaster",
"Sandbox" => "Sandbox",
"SysLogs" => "SysLogs",
"Mods" => "Mods",
"Prio" => "Prio",
"h" => "h",
"tiki admin external wikis template" => "tiki admin external wikis template",
"Online" => "Online",
"Source repository" => "Source repository",
"Regex" => "Regex",
"Configure/Options" => "Configure/Options",
"article-put" => "article-put",
"wiki-append" => "wiki-append",
"Import/Export" => "Import/Export",
"UTF-8" => "UTF-8",
"Group Information Tracker" => "Group Information Tracker",
"No backlinks to this page" => "No backlinks to this page",
"Sheets" => "Sheets",
"+" => "+",
"Nickname" => "Nickname",
"You can browse the generated WebHelp here" => "You can browse the generated WebHelp here",
"single quotes" => "single quotes",
"col" => "col",
"Line break" => "Line break",
"(very useful especially in tables)" => "(very useful especially in tables)",
"New wms Metadata" => "New wms Metadata",
"New Class" => "New Class",
"New Projection" => "New Projection",
"New Query" => "New Query",
"New Scalebar" => "New Scalebar",
"New Layer" => "New Layer",
"New Label" => "New Label",
"New Reference" => "New Reference",
"New Legend" => "New Legend",
"New Web" => "New Web",
"New Outputformat" => "New Outputformat",
"New Mapfile" => "New Mapfile",
"Immediate feedback" => "Immediate feedback",
"Show correct answers" => "Show correct answers",
"Shuffle questions" => "Shuffle questions",
"Shuffle answers" => "Shuffle answers",
"Passing Percentage" => "Passing Percentage",
"%" => "%",
"Import questions from text" => "Import questions from text",
"<b>*</b>=optional" => "<b>*</b>=optional",
"detach" => "detach",
"Graph" => "Graph",
"neutral" => "neutral",
"join" => "join",
"standalone" => "standalone",
"Int" => "Int",
"Routing" => "Routing",
"#" => "#",
"route" => "route",
"Origin" => "Origin",
"Process Graph" => "Process Graph",
"Galaxia Admin Graph" => "Galaxia Admin Graph",
"Galaxia Admin Graph tpl" => "Galaxia Admin Graph tpl",
"Process Graph for" => "Process Graph for",
"Send all to" => "Send all to",
"Executed" => "Executed",
"erase" => "erase",
"Galaxia Admin Processes" => "Galaxia Admin Processes",
"Galaxia Admin Processes tpl" => "Galaxia Admin Processes tpl",
"Operation" => "Operation",
"If:SetNextact" => "If:SetNextact",
"Galaxia Monitor Activities" => "Galaxia Monitor Activities",
"Galaxia Monitor Activities tpl" => "Galaxia Monitor Activities tpl",
"Galaxia Monitor Instances" => "Galaxia Monitor Instances",
"Galaxia Monitor Instances tpl" => "Galaxia Monitor Instances tpl",
"Galaxia Monitor Processes" => "Galaxia Monitor Processes",
"Galaxia Monitor Processes tpl" => "Galaxia Monitor Processes tpl",
"Instance Id" => "Instance Id",
"Instance Name" => "Instance Name",
"Instance Status" => "Instance Status",
"Elapsed time" => "Elapsed time",
"Galaxia User Activities" => "Galaxia User Activities",
"Galaxia User Activities tpl" => "Galaxia User Activities tpl",
"Galaxia User Instances" => "Galaxia User Instances",
"Galaxia User Instances tpl" => "Galaxia User Instances tpl",
"Inst Status" => "Inst Status",
"Galaxia User Processes" => "Galaxia User Processes",
"Galaxia User Processes tpl" => "Galaxia User Processes tpl",
"Bounding box" => "Bounding box",
"Pie Chart" => "Pie Chart",
"Multiline" => "Multiline",
"Multibar" => "Multibar",
"Bar Stack" => "Bar Stack",
"Portrait" => "Portrait",
"Independant Scale" => "Independant Scale",
"Vertical Scale" => "Vertical Scale",
"Series" => "Series",
"Wiki plug-in" => "Wiki plug-in",
"Import From File" => "Import From File",
"Grab Wiki Tables" => "Grab Wiki Tables",
"Name of the dump file (it has to be in dump/)" => "Name of the dump file (it has to be in dump/)",
"Upgrade" => "Upgrade",
"MultiTiki" => "MultiTiki",
"v" => "v",
"/" => "/",
"Requested" => "Requested",
"msgs" => "msgs",
"Mail-in feature" => "Mail-in feature",
"Display only this type" => "Display only this type",
"Unpublish" => "Unpublish",
"Republish" => "Republish",
"configure newsreader server tpl" => "configure newsreader server tpl",
"Read the news" => "Read the news",
"(current)" => "(current)",
"Edit quiz" => "Edit quiz",
"General Options" => "General Options",
"Test-time Options" => "Test-time Options",
"P/F" => "P/F",
"tikiwiki.org" => "tikiwiki.org",
"Replicate" => "Replicate",
"Slave" => "Slave",
"Master" => "Master",
"Operations" => "Operations",
"Operations Log" => "Operations Log",
"Class Name" => "Class Name",
"cool" => "cool",
"mr green" => "mr green",
"razz" => "razz",
"rolleyes" => "rolleyes",
"twisted" => "twisted",
"Image ID thumb" => "Image ID thumb",
"Toggle options" => "Toggle options",
"info/vote" => "info/vote",
"Impossible to change %s from %s to %s" => "Impossible to change %s from %s to %s",
"%H:%M %Z" => "%H:%M %Z",
"Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
"Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
"tiki-mobile.php" => "tiki-mobile.php",
"Permission denied you cannot rename this page" => "Permission denied you cannot rename this page",
"Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Error Message: \$errmsg",
"No trackerId specified" => "No trackerId specified",
// ###
// ### end of possibly untranslated words
// ###

"This feature is disabled" => "Diese Funktion ist deaktiviert",
"Permission denied you cannot view pages" => "Zugriff verweigert. Sie k&ouml;nnen keine Seiten ansehen",
"Re:" => "Aw:",
"This script cannot be called directly" => "Dieses Script kann nicht direkt aufgerufen werden",
"The copyright management feature is not enabled." => "Das Copyright Management ist nicht aktiviert.",
"Copyright management" => "Copyright Management",
"No page indicated" => "Keine Seite angegeben",
"You must supply all the information, including title and year." => "Sie m&uuml;ssen alle Daten angeben, inkl. Titel und Jahr.",
"You do not have permission to use this feature" => "Sie haben keine Berechtigung, diese Funktion zu nutzen",
"This feature is for admins only" => "Zugriff nur f&uuml;r Admin m&ouml;glich",
"Type" => "Typ",
"Description" => "Beschreibung",
"Size" => "Gr&ouml;&szlig;e",
"Created" => "Erstellt",
"Uploaded" => "Hochgeladen",
"Last Modified" => "Zuletzt modifiziert",
"Creator" => "Ersteller",
"Author" => "Autor",
"Last editor" => "letzter Schreiber",
"Comment" => "Kommentar",
"Files" => "Dateien",
"Hits" => "Zugriffe",
"Locked by" => "Gesperrt von",
"Path" => "Pfad",
"Albania" => "Albanien",
"Algeria" => "Algerien",
"Argentina" => "Argentinien",
"Armenia" => "Armenien",
"Austria" => "&Ouml;sterreich",
"Azerbaijan" => "Aserbaidschan",
"Belarus" => "Wei&szlig;russland",
"Belgium" => "Belgien",
"Bolivia" => "Bolivien",
"Brazil" => "Brasilien",
"Bulgaria" => "Bulgarisch",
"Cambodia" => "Kambodscha",
"Cameroon" => "Kamerun",
"Canada" => "Kanada",
"Chad" => "&Auml;nderung",
"Croatia" => "Kroatien",
"Cuba" => "Kuba",
"Denmark" => "D&auml;nemark",
"Dominica" => "Dominikanisch",
"Ethiopia" => "&Auml;thiopien",
"Europe" => "Europa",
"Fiji" => "Fidschiinseln",
"Germany" => "Deutschland",
"Greenland" => "Gr&ouml;nland",
"Hungary" => "Ungarn",
"Iceland" => "Island",
"Indonesia" => "Indonesien",
"Iraq" => "Irak",
"Ireland" => "Irland",
"Jamaica" => "Jamaika",
"Kyrgyzstan" => "Kirgisistan",
"Lebanon" => "links",
"Liechtenstein" => "Lichtenstein",
"Lithuania" => "Litauen",
"Macedonia" => "Mazedonien",
"Madagascar" => "Madagaskar",
"Mauritania" => "Mauretanien",
"Netherlands" => "Niederlande",
"None" => "Keine",
"Norway" => "Norwegen",
"Other" => "Sonstige",
"Reunion" => "Wiedervereinigung",
"Russia" => "Russland",
"Rwanda" => "Ruanda",
"Serbia" => "Serbien",
"Seychelles" => "Seychellen",
"Slovakia" => "Slowakei",
"Slovenia" => "Slowenien",
"Spain" => "Spanien",
"Switzerland" => "Schweiz",
"Tanzania" => "Tansania",
"Tunisia" => "Tunesien",
"Turkey" => "T&uuml;rkei",
"Uzbekistan" => "Usbekistan",
"Vatican" => "Vatikan",
"World" => "Welt",
"Yemen" => "Jemen",
"Yugoslavia" => "Jugoslawien",
"Zambia" => "Sambia",
"Zimbabwe" => "Simbabwe",
"Catalan" => "Katalanisch",
"Chinese" => "Chinesisch",
"Czech" => "Tschechisch",
"Danish" => "D&auml;nisch",
"German" => "Deutsch",
"English" => "Englisch",
"Spanish" => "Spanisch",
"Greek" => "Griechisch",
"Finnish" => "Finnisch",
"Fijian" => "Fidschianisch",
"French" => "Franz&ouml;sisch",
"Croatian" => "Kroatisch",
"Italian" => "Italienisch",
"Japanese" => "Japanisch",
"Hungarian" => "Ungarisch",
"Dutch" => "Holl&auml;dnisch",
"Norwegian" => "Norwegisch",
"Polish" => "Polnisch",
"Português" => "portugiesisch",
"Russian" => "Russisch",
"Slovak" => "Slowakisch",
"Serbian" => "Serbisch",
"Swedish" => "Schwedisch",
"Ukrainian" => "Ukrainisch",
"Fatal error: cannot execute automatic activity \$activityId" => "Fataler Fehler: Kann automatische Aktivit&auml; \$activityId nicht ausf&uuml;hren",
"Fatal error: setting next activity to an unexisting activity" => "Fataler Fehler: Folgeaktivit&auml;t wurde auf einen ung&uuml;ltigen Eintrag gesetzt",
"Fatal error: trying to send an instance to an activity but no transition found" => "Fataler Fehler: Versuch, eine Instanz an eine Aktivit&auml;t zu schicken, jedoch ist kein &Uuml;bergang definiert",
"Process does not have a start activity" => "Prozess besitzt keine Start-Aktivit&auml;t",
"Process does not have exactly one end activity" => "Prozess besitzt nicht genau eine End-Aktivit&auml;t",
"End activity is not reachable from start activity" => "End-Aktivit&auml; von der Start-Aktivit&auml;t aus nicht erreichbar",
"Activity" => "Aktivit&auml;t",
"is interactive but has no role assigned" => "ist interaktiv, besitzt aber keine zugeordnete Rolle",
"is standalone but has transitions" => "ist standalone, besitzt aber &Uuml;berg&auml;nge",
"Role" => "Rolle",
"Process %d has been activated" => "Prozess %d wurde aktiviert",
"Process %d has been deactivated" => "Prozess %d wurde deaktiviert",
"Process %s %s imported" => "Prozess %s %s importiert",
"Process %s removed" => "Prozess %s entfernt",
"Process %s has been updated" => "Prozess %s wurde aktualisiert",
"Process %s has been created" => "Prozess %s wurde erstellt",
"points" => "Punkte",
"on left side" => "auf linker Seite",
"on center" => "in der Mitte",
"on right side" => "auf rechter Seite",
"Disabled" => "deaktiviert",
"Plain text" => "Klartext",
"Link to user information" => "Link auf Benutzer-Informationen",
"User avatar" => "Benutzer Avatar",
"Creation date (desc)" => "Erstellungsdatum (abst.)",
"Last modification date (desc)" => "Datum letzte &Auml;nderung (abst.)",
"Blog title (asc)" => "Blog-Titel (aufst.)",
"Number of posts (desc)" => "Anzahl Posts (abst.)",
"Visits (desc)" => "Besuchszahlen (abst.)",
"Activity (desc)" => "Aktivit&auml;t (abst.)",
"Top bar" => "Oberer Balken",
"Bottom bar" => "Unterer Balken",
"no cache" => "kein Cache",
"minute" => "Minute",
"minutes" => "Minuten",
"hour" => "Stunde",
"hours" => "Stunden",
"as Creator &amp; Last Editor" => "als Ersteller &amp; letzter Bearbeiter",
"Business style" => "gesch&auml;ftlich",
"Collaborative style" => "kollaborativ",
"Page last modified on" => "Seite zuletzt ge&auml;ndert am",
"no (disabled)" => "keine (deaktiviert)",
"|| for rows" => "|| f&uuml;r Spalten",
"<return> for rows" => "\\n f&uuml;r Spalten",
"Only with last version" => "nur mit letzter Version",
"Any 2 versions" => "zwei beliebige Versionen",
"complete" => "vollst&auml;ndig",
"english" => "englisch",
"Day" => "Tag",
"Week" => "Woche",
"Month" => "Monat",
"Quarter" => "Vierteljahr",
"Semester" => "Halbjahr",
"Year" => "Jahr",
"Saturday" => "Samstag",
"Sunday" => "Sonntag",
"Monday" => "Montag",
"No error reporting" => "Keine Fehlerausgabe",
"Report all PHP errors" => "Alle PHP Fehler ausgeben",
"Report all errors except notices" => "Alle Fehler au&szlig;er Hinweisen ausgeben",
"Creation Date (desc)" => "Erstellungsdatum (abst.)",
"Topics (desc)" => "Themen (abst.)",
"Threads (desc)" => "Threads (abst.)",
"Last post (desc)" => "Neueste Eintr&auml;ge (abst.)",
"Name (desc)" => "Name (abst.)",
"Name (asc)" => "Name (aufst.)",
"Score ascending" => "Punkte aufsteigend",
"Score descending" => "Punkte absteigend",
"Name ascending" => "Name aufsteigend",
"Name descending" => "Name absteigend",
"Login ascending" => "Anmeldung aufsteigend",
"Login descending" => "Anmeldung absteigend",
"replace current window" => "Fenster ersetzen",
"new window" => "neues Fenster",
"inline frame" => "Frame innerhalb der Seite",
"Each day" => "t&auml;glich",
"Each week" => "w&ouml;chentlich",
"Each month" => "monatlich",
"5 minutes" => "5 Minuten",
"15 minutes" => "15 Minuten",
"30 minutes" => "30 Minuten",
"1 day" => "1 Tag",
"1 week" => "1 Woche",
"1 month" => "1 Monat",
"Allow secure (https) login" => "Erlaube sicheren Login (https)",
"Encourage secure (https) login" => "Schlage sicheren Login (https) vor",
"Consider we are always in HTTPS, but do not check" => "Gehe von HTTPS aus, aber pr&uuml;fe nicht nach",
"Require secure (https) login" => "Sicherer Login (https) notwendig",
"tikihash (old)" => "tikihash (alt)",
"Just Tiki" => "Nur &uuml;ber Tiki",
"Web Server" => "Webserver",
"Tiki and PEAR::Auth" => "Tiki und PEAR::Auth",
"Tiki and PAM" => "Tiki und PAM",
"choose a group ..." => "Gruppe ausw&auml;hlen ...",
"Registered" => "Registriert",
"Anonymous" => "Unbekannt",
"LastModif" => "&Auml;nderung",
"Use database to store files" => "Datenbank zum Speichern von Dateien benutzen",
"Use a directory to store files" => "Ein Verzeichnis zur Dateiablage benutzen",
"%s enabled" => "%s aktiviert",
"%s disabled" => "%s deaktiviert",
"Permission denied" => "Zugriff verweigert",
"Template %s not registered" => "Vorlage %s nicht registriert",
"The file is not a CSV file or has not a correct syntax" => "Diese Datei ist keine CSV Datei oder hat nicht die erforderliche Syntax",
"locked" => "gesperrt",
"locked by" => "gesperrt von",
"continued" => "weiter",
"New Image Uploaded by" => "Neue Bilder hochgeladen von",
"New Subscriptions" => "Neue Abonnenten",
"New Item in Tracker" => "Neuer Eintrag im Tracker",
"tracker" => "Tracker",
"by" => "von",
"Image Gallery" => "Bildergalerie",
"Articles" => "Artikel",
"Forums" => "Foren",
"Directory" => "Linkverzeichnis",
"File Gallery" => "Dateiarchiv",
"Quizzes" => "Quiz",
"Trackers" => "Tracker",
"Survey" => "Umfrage",
"Charts" => "Hitlisten",
"article" => "Artikel",
"blog" => "Blog",
"directory" => "Linkverzeichnis",
"faq" => "FAQ",
"file gallery" => "Dateiarchiv",
"forum" => "Forum",
"image gallery" => "Bildergalerie",
"newsletter" => "Newsletter",
"poll" => "Abstimmung",
"quiz" => "Quiz",
"wiki page" => "Wiki-Seite",
"image" => "Bild",
"calendar" => "Kalender",
"Invalid filename (using filters for filenames)" => "Ung&uuml;ltiger Dateiname (verwende Filter)",
"Cannot upload this file maximum upload size exceeded" => "Datei &uuml;berschreitet maximale Gr&ouml;&szlig; f&uuml;r das Hochladen",
"Wrong password. Cannot post comment" => "Falsches Passwort. Kommentar kann nicht gespeichert werden",
"A contribution is mandatory" => "Die Art der Beteiligung mu&szlig; angegeben werden",
"You have to enter a title and text" => "Sie m&uuml;ssen Titel und Text eingeben",
"text" => "Text",
"Line:" => "Zeile:",
"Lines:" => "Zeilen:",
"Tiki Link - Insert internal link" => "Tiki-Link - internen Wikilink einf&uuml;gen",
"Find" => "Suchen",
"find" => "Suchen",
"prev" => "vorh.",
"Page" => "Seite",
"next" => "n&auml;chstes",
"Page name" => "Seitenname",
"Wiki Home" => "Wiki-Home",
"Home" => "Startseite",
"previous page" => "vorherige Seite",
"next page" => "n&auml;chste Seite",
"posted on" => "aufgegeben am",
"Continue" => "Weiter",
"By:" => "Von:",
"Read" => "Lesen",
"List articles" => "Artikel auflisten",
"Last post" => "Neuester Eintrag",
"Invalid imagename (using filters for filenames)" => "Ung&uuml;ltiger Dateiname (using filters for filenames)",
"Errors detected" => "Fehler entdeckt",
"Upload was not successful" => "Hochladen war nicht erfolgreich",
"No image yet, sorry." => "Leider noch keine Bilder vorhanden.",
"Contributions" => "Beitr&auml;ge",
"unknown" => "unbekannt",
"NONE" => "KEINES",
"%s impossible to remove" => "%s kann nicht gel&ouml;scht werden",
"section edit" => "Bereich bearbeiten",
"Wiki top pages" => "Wiki-Top-Seiten",
"Most relevant pages" => "Relevanteste Seiten",
"Relevance" => "Relevanz",
"Wiki last pages" => "Neueste Wiki-Seiten",
"Modified" => "Ge&auml;ndert",
"Forums last topics" => "Neueste Forenthemen",
"Topic date" => "Themendatum",
"Forums most read topics" => "Foren mit den meistgelesenen Themen",
"Reads" => "Zugriffe",
"Forums best topics" => "Foren mit den beliebtesten Themen",
"Score" => "Punkte",
"Forums most visited forums" => "Meistbesuchte Foren",
"Visits" => "Besuche",
"Forums with most posts" => "Foren mit den meisten Beitr&auml;gen",
"Posts" => "Eintr&auml;ge",
"Wiki top galleries" => "Wiki Top Galerien",
"Wiki top file galleries" => "Wiki Top Dateiarchive",
"Wiki top images" => "Wiki Top Bilder",
"Wiki top files" => "Wiki Top Dateien",
"Wiki last images" => "Wiki neueste Bilder",
"Upload date" => "Hochlade-Datum",
"Wiki last files" => "Wiki neueste Dateien",
"Wiki top articles" => "Meistgelesene Artikel",
"Most visited blogs" => "Meistbesuchte Blogs",
"Most active blogs" => "Aktivste Blogs",
"Blogs last posts" => "Neueste Blog-Eintr&auml;ge",
"Post date" => "Eintragsdatum",
"Wiki top authors" => "Wiki Top Autoren",
"Pages" => "Seiten",
"Top article authors" => "Top Artikel-Autoren",
"User already exists" => "Benutzer existiert bereits",
"Wrong registration code" => "Falscher Registrierungscode",
"Invalid username" => "Benutzername ung&uuml;ltig",
"Username is too long" => "Benutzername zu lang",
"Username cannot contain whitespace" => "Benutzername darf keine Leerzeichen enthalten",
"Wrong passcode you need to know the passcode to register in this site" => "Falscher Passcode. Sie m&uuml;ssen Ihren Passcode kennen, um sich an dieser Site zu registrieren",
"Invalid email address. You must enter a valid email address" => "eMail-Adresse ung&uuml;ltig. Eine g&uuml;ltige Adresse ist zwingend",
"The registration mail can't be sent. Contact the administrator" => "Die Registrierungs-Mail konnte nicht gesendet werden. Benachrichtigen Sie bitte den Administrator.",
"Login" => "Anmeldung",
"See other user's profile" => "Profil eines anderen Benutzers ansehen",
"Have your profile seen" => "Benutzer sieht sich Ihr Profil an",
"Make friends" => "Freundschaft schlie&szlig;en",
"Receive message" => "Nachricht empfangen",
"Send message" => "Nachricht schicken",
"Read an article" => "Artikel lesen",
"Publish an article" => "Artikel ver&ouml;ffentlichen",
"Have your article read" => "Benutzer liest Ihren Artikel",
"Create new file gallery" => "Neues Dateiarchiv anlegen",
"Upload new file to gallery" => "Datei in Archiv hochladen",
"Download other user's file" => "Datei eines anderen Benutzers herunterladen",
"Have your file downloaded" => "Benutzer l&auml;d eine Ihrer Dateien herunter",
"Create a new image gallery" => "Neue Bildgalerie anlegen",
"Upload new image to gallery" => "Bild in Galerie hochladen",
"See other user's gallery" => "Galerie eines anderen Benutzers anschauen",
"See other user's image" => "Bild eines anderen Benutzers betrachten",
"Have your gallery seen by other user" => "Benutzer betrachtet Ihre Galerie",
"Have your image seen" => "Benutzer betrachtet eines Ihrer Bilder",
"Create new blog" => "Neuen Blog erstellen",
"Post in a blog" => "Eintrag in Blog vornehmen",
"Read other user's blog" => "Blog eines anderen Benutzers lesen",
"Have your blog read" => "Benutzer liest Ihren Blog",
"Create a new wiki page" => "Neue Wiki-Seite erstellen",
"Edit an existing page" => "Vorhandene Wiki-Seite bearbeiten",
"Attach file" => "Datei anh&auml;ngen",
"Unknown" => "Unbekannt",
"Trackeritem" => "Tracker-Eintrag",
"Image" => "Bild",
"Article" => "Artikel",
"Directory category" => "Verzeichniskategorie",
"Gallery" => "Galerie",
"Blog post" => "Blog-Eintrag",
"Tracker item" => "Tracker-Eintrag",
"Simple" => "Anf&auml;nger",
"Advanced" => "Fortgeschritten",
"Prev" => "Vorher.",
"Next" => "N&auml;chst.",
"Admin Feature" => "Einstellungen",
"Hide" => "Verbergen",
"help" => "Hilfe",
"All" => "Alle",
"The text is" => "Der Text lautet",
"character(s) too long - please edit it." => "Zeichen zu lang. Bitte anpassen.",
"Select All" => "Alle ausw&auml;hlen",
"days" => "Tage",
"day" => "Tag",
"mins" => "Min.",
"min" => "Min.",
"secs" => "Sek.",
"done" => "fertig",
"Task" => "Aufgabe",
"from" => "von",
"for" => "f&uuml;r",
"Priority" => "Priorit&auml;t",
"Start date:" => "Anfangsdatum",
"End date:" => "Enddatum",
"User information - Click for more info" => "Benutzer Information - Klick f&uuml;r weitere Details",
"Friend" => "Freund",
"Last seen on" => "Zuletzt online am",
"(idle for %s seconds)" => "(unt&auml;tig f&uuml;r %s Sekunden)",
"More info about \$other_user" => "Mehr Info &uuml;ber \$other_user",
"(idle for \$idletime seconds)" => "(nicht am Rechner seit \$idletime Sekunden)",
"Yes" => "Ja",
"No" => "Nein",
"pvs" => "Besuche",
"Use this tree to copy the structure" => "Diesen Baum benutzen zum Erstellen der Struktur",
"created from structure" => "aus Struktur erstellt",
"Table of contents" => "Inhaltsverzeichnis",
"unknown error" => "Unbekannter Fehler",
"You are not logged in" => "Sie sind nicht angemeldet",
"Page cannot be found" => "Seite nicht gefunden",
"Permission denied you cannot view this section" => "Zugriff verweigert. Sie k&ouml;nnen diesen Bereich nicht betrachten",
"Help" => "Hilfe",
"You are banned from" => "Sie wurden verbannt von",
"wiki" => "Wiki",
"img-g" => "Bildergalerien",
"file-g" => "Dateiarchive",
"faqs" => "FAQs",
"quizzes" => "Quiz",
"arts" => "Artikel",
"blogs" => "Blogs",
"forums" => "Foren",
"games" => "Spiele",
"Click to edit dynamic variable" => "Klicken zum Bearbeiten der dynamischen Variable",
"Update variables" => "Variablen aktualisieren",
"Edit Section" => "Bereich bearbeiten",
"index" => "Inhaltsverzeichnis",
"Show" => "Zeigen",
"%d points" => "%d Punkte",
"Removed" => "Gel&ouml;scht",
"at" => "um",
"new" => "neu",
"Create page:" => "Seite erstellen:",
"Unknown language" => "unbekannte Sprache",
"Click here to confirm your action" => "Zur Best&auml;tigung hier klicken",
"Rating" => "Wertung",
"Item" => "Eintrag",
"Item creation" => "Eintrag erstellen",
"Subject" => "Betreff",
"Tracker was modified at " => "Tracker wurde ver&auml;ndert auf ",
"Field is not numeric" => "Feld ist nicht numerisch",
"text field" => "Eingabefeld",
"half column" => "halbe Spalte",
"size" => "Gr&ouml;&szlig;e",
"prepend" => "voranstellen",
"append" => "anh&auml;ngen",
"textarea" => "Textbereich",
"checkbox" => "Schalter",
"numeric field" => "Zahl",
"drop down" => "Auswahlliste",
"user selector" => "Nutzerauswahl",
"group selector" => "Gruppenauswahl",
"country selector" => "L&auml;nderauswahl",
"date and time" => "Datum und Zeit",
"jscalendar" => "JSKalender",
"action" => "Aktion",
"header" => "&Uuml;berschrift einf&uuml;gen",
"category" => "Kategorie",
"item link" => "Link auf Objekt",
"items list" => "Eintr&auml;ge auflisten",
"email" => "eMail",
"system" => "System",
"attachment" => "Anhang",
"open" => "offen",
"pending" => "anstehend",
"closed" => "geschlossen",
"Message" => "Nachricht",
"child categories" => "Unterkategorien",
"objects in category" => "Objekte in Kategorie",
"Password should be at least" => "Pa&szlig;wort sollte mindestens",
"characters long" => "Zeichen lang sein",
"Password must contain both letters and numbers" => "Pa&szlig;wort muss sowohl Buchstaben als auch Zahlen enthalten",
"Personal Phone" => "privates Telefon",
"Personal Mobile" => "privates Mobiltelefon",
"Personal Fax" => "privates Fax",
"Work Phone" => "Telefon Arbeit",
"Work Mobile" => "Mobieltelefon Arbeit",
"Work Fax" => "Fax Arbeit",
"Company" => "Firma",
"Organization" => "Organisation",
"Street Address" => "Stra&szlig;e",
"City" => "Stadt",
"State" => "Status",
"Zip Code" => "PLZ",
"Country" => "Land",
"Info" => "Information",
"Displays browser client info" => "Zeigt Browserinformationen",
"Location" => "Ort",
"Field" => "Feld",
"Language" => "Sprache",
"Attachment" => "Anhang",
"File" => "Datei",
"Show description" => "Beschreibung zeigen",
"Displays the user Avatar" => "Zeigt den Benutzer-Avatar an.",
"username" => "Benutzername",
"Back" => "Zur&uuml;ck",
"No pages links to" => "Keine Seitenverweise auf",
"One page links to" => "Ein Seitenverweis auf",
"pages link to" => "Seitenverweise auf",
"Zone" => "Bereich",
"Items" => "Eintr&auml;ge",
"Insert theme styled box on wiki page" => "Box im Theme-Layout in Wiki-Seite einf&uuml;gen",
"Category" => "Kategorie",
"Insert list of items for the current/given category into wiki page" => "Alle Eintr&auml;ge der aktuellen/angegebenen Kategorie in die Wiki-Seite einf&uuml;gen",
"Categories are disabled" => "Kategorien sind nicht aktiviert",
"Display Tiki objects that have not been categorized" => "Noch nicht kategorisierte Tiki-Objekte anzeigen",
"Objects" => "Objekte",
"Insert the full category path for each category that this wiki page belongs to" => "F&uuml;gt den Kategorienbaum f&uuml;r jede Kategorie an, zu der diese Seite geh&ouml;rt",
"Centers the plugin content in the wiki page" => "Zentriert den PlugIn-Inhalt innerhalb der Wiki-Seite.",
"Chart" => "Hitliste",
"title" => "Titel",
"Chart as PDF" => "Hitliste als PDF",
"Chart as PostScript" => "Hitliste als PostScript",
"Code" => "Quellcode",
"Displays a snippet of code" => "Zeigt einen Quellcode-Ausschnitt an",
"code" => "Quellcode",
"Dynamic Content" => "Dynamischer Inhalt",
"Insert copyright notices" => "F&uuml;gt Copyright-Notizen ein.",
"Example" => "Beispiel",
"and" => "und",
"seconds" => "Sekunden",
"Creates a definition list" => "Legt eine Definitionsliste an",
"term" => "Term",
"definition" => "Definition",
"one definition per line" => "eine Definition pro Zeile",
"drawing not found" => "Zeichnung nicht gefunden",
"Events" => "Ereignisse",
"Desc" => "Beschreibung",
"Upcoming events" => "n&auml;chste Termine",
"Label" => "Beschriftung",
"Displays the data using the Tikiwiki odd/even table style" => "Daten im Tiki gerade/ungerade Stil anzeigen",
"cells" => "Zellen",
"heads and cells separated by ~|~" => "Kopfzellen und sonstige Felder werden getrennt durch ~|~",
"Title" => "Titel",
"sort" => "sortieren",
"missing parameters" => "fehlende Parameter",
"failed" => "fehlgeschlagen",
"description" => "Beschreibung",
"Value" => "Wert",
"type" => "Typ",
"Group" => "Gruppe",
"HTML code" => "HTML-Code",
"name" => "Name",
"Image ID" => "Bild-ID",
"Image size" => "Bildgr&ouml;sse",
"Img" => "Bild",
"Include" => "Aufnehmen",
"Stop" => "Anhalten",
"Include a page" => "Eine Seite einbinden",
"Last Modification" => "Letzte &Auml;nderung",
"List Pages" => "Seiten auflisten",
"Sort" => "Sortieren",
"or" => "oder",
"Lists files in a directory" => "Dateien im Verzeichnis auflisten",
"Map" => "Karte",
"Feature disabled" => "Funktion deaktiviert",
"Style" => "Stil",
"Module Name" => "Modulname",
"Please choose a module" => "Bitte ein Modul w&auml;hlen",
"to be used as argument" => "als Argument zu verwenden",
"Displays a module inlined in page" => "Zeigt ein Modul innerhalb einer Wiki-Seite an.",
"Sorry no such module" => "Kein solches Modul vorhanden",
"Displays the data using a monospace font" => "Zeigt den PlugIn-Inhalt in einer MonoSpace-Schrift an",
"data" => "Daten",
"Object" => "Objekt",
"Days" => "Tage",
"Picture" => "Bild",
"picture not found" => "Bild nicht gefunden",
"No version indicated" => "Keine Version angegeben",
"No arguments indicated" => "Es wurden keine Argumente angegeben",
"Poll" => "Abstimmung",
"one data per line" => "ein Eintrag pro Zeile",
"Search" => "Suche",
"Icon" => "Symbol",
"Date" => "Datum",
"Automatically creates a link to the appropriate SourceForge object" => "Erstellt automatisch einen Link zum passenden SourceForge Objekt",
"List wiki pages" => "Wiki-Seiten auflisten",
"Display" => "Anzeigen",
"Last modified by" => "Zuletzt bearbeitet von",
"Action" => "Aktion",
"Sorts the plugin content in the wiki page" => "Sortiert den PlugIn-Inhalt innerhalb einer Wiki-Seite",
"Order" => "Reihenfolge",
"Split a page into rows and columns" => "Seite in Spalten und Zeilen aufteilen",
"First" => "Erste",
"Edit" => "Bearbeiten",
"Run a sql query" => "SQL-Abfrage ausf&uuml;hren",
"sql query" => "SQL-Abfrage",
"Missing db param" => "Datenbank-Parameter fehlt",
"Subscribe" => "Abonnieren",
"Groups" => "Gruppen",
"Thumbnail" => "Vorschau",
"Displays the thumbnail for an image" => "Zeigt ein Vorschaubild des Bildes",
"No pages found for title search" => "Titelsuche hat keine Seiten gefunden",
"One page found for title search" => "Titelsuche hat eine Seite gefunden",
"pages found for title search" => "Seiten bei Titelsuche gefunden",
"Structure ID" => "Struktur-ID",
"Public" => "&Ouml;ffentlich",
"Translate" => "&uuml;bersetzen",
"Fields" => "Felder",
"Preview" => "Vorschau",
"preview" => "Vorschau",
"View" => "Betrachten",
"Error" => "Fehler",
"Following mandatory fields are missing" => "Erforderliche Felder fehlen",
"Wiki text" => "Wikitext",
"Template" => "Vorlage",
"Mode" => "Modus",
"No field indicated" => "Kein Feld angegeben",
"Links to a translated content" => "Verweist auf einen &uuml;bersetzten Inhalt",
"Flag" => "Kennzeichen",
"Displays the number of registered users" => "Zeigt die Anzahl der registrierten Benutzer",
"User List" => "Benutzerliste",
"users" => "Benutzer",
"Preferences" => "Einstellungen",
"User Information" => "Benutzer-Information",
"Versions" => "Versionen",
"Vote" => "Stimme",
"Table" => "Tabelle",
"empty string" => "leere Zeichenfolge",
"ignored" => "ignorierten",
"External Wiki" => "Externes Wiki",
"valid" => "g&uuml;ltig",
"width" => "Breite",
"height" => "H&ouml;he",
"Removed version \$version" => "gel&ouml;schte Version  \$version",
"Plugin " => "PlugIn ",
"Removed last version" => "L&ouml;schte letzte Version",
"ERROR: Either the subject or body must be non-empty" => "FEHLER: Text und Betreff d&uuml;rfen nicht leer sein.",
"ERROR: No valid users to send the message" => "FEHLER: Keine g&uuml;ltigen Benutzer zum Verschicken der Nachricht.",
"Invalid user" => "Ungueltiger Benutzer",
"Message sent to" => "Nachricht gesandt an",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "Ausgangsordner ist voll. Bitte ein paar verschickte Nachrichten archivieren oder l&ouml;schen, damit weitere verschickt werden k&ouml;nnen.",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Zum Versenden von Nachrichten m&uuml;ssen Sie auch Antwort empfangen k&ouml;nnen. Bitte aktivieren Sie 'Nachrichten von anderen Anwendern erlauben' in den Benutzereinstellungen.",
"User %s can not receive messages, mailbox is full" => "Benutzer %s kann keine Nachrichten empfangen, Briefkasten ist voll.",
"User %s can not receive messages" => "Benutzer %s kann keine Nachrichten empfangen.",
"Invalid user: %s" => "Ung&uuml;ltiger Benutzer: %s.",
"Message will be sent to: " => "Die Nachricht wird versandt an: ",
"Archive is full. Delete some messages from archive first." => "Archiv ist voll! Bitte erst ein paar Nachrichten aus dem Archiv l&ouml;schen.",
"No more messages" => "Keine weiteren Nachrichten",
"Tiki Calendar" => "Tiki Kalender",
"Article Topics" => "Artikel-Themen",
"Calendar" => "Kalender",
"Create/Edit" => "Hinzuf&uuml;gen/bearbeiten",
"Quick Edit a Wiki Page" => "Schnellbearbeitung einer Wiki-Seite",
"Post" => "Eintrag",
"Changes since" => "&Auml;nderungen seit",
"new comments" => "Neue Kommentare",
"new posts" => "neue Posts",
"wiki pages changed" => "Wiki-Seiten ge&auml;ndert",
"new articles" => "neue Artikel",
"new FAQs" => "neue FAQs",
"new blogs" => "neue Blogs",
"new blog posts" => "neue Blog Posts",
"new image galleries" => "neue Bildergallerie",
"new images" => "Neue Bilder",
"new file galleries" => "neues Dateiarchiv ",
"new files" => "Neue Dateien",
"new polls" => "neue Polls",
"new users" => "Neue Benutzer",
"new tracker items" => "neue Tracker-Eintr&auml;ge",
"Invalid username or password" => "Ung&uuml;ltiger Benutzername oder Pa&szlig;wort",
"Can create/admin calendars" => "darf Kalender erstellen/verwalten",
"Can add events in the calendar" => "darf Ereignisse in Kalender eintragen",
"Can change events in the calendar" => "darf Ereignisse im Kalender &auml;ndern",
"Can browse the calendar" => "darf Kalender durchsuchen",
"Can view events details" => "darf Ereignis-Details ansehen",
"Can admin categories" => "darf Kategorien verwalten",
"Can edit items in categories" => "darf Kategorie-Eintr&auml;ge bearbeiten",
"Can admin charts" => "darf Hitlisten verwalten",
"Autovalidate suggestions" => "automatisch Vorschl&auml;ge als g&uuml;ltig markieren",
"Can view charts" => "darf Hitlisten anschauen",
"Can vote" => "darf abstimmen",
"Can use the chat system" => "darf Chat-System verwenden",
"Can admin the cms" => "darf Artikel verwalten",
"Can approve submissions" => "darf Einreichungen genehmigen",
"Can edit articles" => "darf Artikel bearbeiten",
"Can edit submissions" => "darf Einreichungen bearbeiten",
"Can read articles" => "darf Artikel lesen",
"Can remove articles" => "darf Artikel l&ouml;schen",
"Can remove submissions" => "darf Einreichungen l&ouml;schen",
"Can submit articles" => "darf Artikel schreiben",
"Can admin contributions" => "darf Beitr&auml;ge verwalten",
"Can admin the directory" => "darf Linkverzeichnis verwalten",
"Can admin directory categories" => "darf Linkverzeichnis-Kategorien verwalten",
"Can admin directory sites" => "darf Links im Linkverzeichnis verwalten",
"Can submit sites to the directory" => "darf Links ins Linkverzeichnis eintragen",
"Can validate submited links" => "darf eingestellte Links &uuml;berpr&uuml;fen",
"Can use the directory" => "darf Linkverzeichnis benutzen",
"Can admin drawings" => "darf Zeichnungen verwalten",
"Can edit drawings" => "darf Zeichnungen bearbeiten",
"Can admin faqs" => "darf FAQs verwalten",
"Can view faqs" => "darf FAQs anschauen",
"Can admin users" => "darf Benutzer verwalten",
"Can ban users or ips" => "darf Benutzer oder IP sperren",
"Can admin the dynamic content system" => "darf Dynamisches Inhaltssystem verwalten",
"Can admin mail-in accounts" => "darf Mail-Konten verwalten",
"Can edit object permissions" => "darf Objekt-Berechtigungen bearbeiten",
"Can admin rss modules" => "darf RSS-Module verwalten",
"Can admin cookies" => "darf Cookies verwalten",
"Can edit translations and create new languages" => "darf &Uuml;bersetzung bearbeiten und neue Sprache erstellen",
"Can edit site templates" => "darf Seiten-Vorlagen bearbeiten",
"Can send a link to a friend" => "darf Links an Freunde senden",
"Can use HTML in pages" => "darf HTML in Seiten verwenden",
"Can view site stats" => "darf Statistik anschauen",
"Can view site templates" => "darf Seitenvorlagen anschauen",
"Can admin blogs" => "darf Blogs verwalten",
"Can assign perms to blog" => "darf Blogs Berechtigungen zuweisen",
"Can post to a blog" => "darf in Blogs schreiben",
"Can create a blog" => "darf Blog erstellen",
"Can read blogs" => "darf Blogs lesen",
"Can admin file galleries" => "darf Dateiarchive verwalten",
"Can assign perms to file gallery" => "darf Dateiarchiven Berechtigungen zuweisen",
"Can upload zip files with files" => "darf zip-Dateien in Dateiverzeichnisse hochladen",
"Can create file galleries" => "darf Dateiverzeichnis erstellen",
"Can download files" => "darf Dateien runterladen",
"Can edit a gallery file" => "darf Dateiarchiv bearbeiten",
"Can upload files" => "darf Dateien hochladen",
"Can view file galleries" => "darf Dateiarchive anschauen",
"Can admin forums" => "darf Foren verwalten",
"Can attach to forum posts" => "darf Dateien in Foren anh&auml;ngen",
"Can edit own forum posts" => "darf eigene Foren-Eintr&auml;ge editieren",
"Can post in forums" => "darf im Foren schreiben",
"Can start threads in forums" => "darf Themen im Forum starten",
"Can read forums" => "darf Foren lesen",
"Can vote comments in forums" => "darf Kommentare in Foren bewerten",
"Can admin Image Galleries" => "darf Bildergalerien verwalten",
"Can upload zip files with images" => "darf zip-Dateien in Bildergalerien hochladen",
"Can create image galleries" => "darf Bildergalerie erstellen",
"Can upload images" => "darf Bilder hochladen",
"Can browse freetags" => "darf Freetags durchsuchen",
"Can view image galleries" => "darf Bildergalerien anschauen",
"Can admin games" => "darf Spiele verwalten",
"Can play games" => "darf Spiele spielen",
"Can admin newsletters" => "darf Rundschreiben verwalten",
"Can send newsletters" => "darf Rundschreiben verschicken",
"Can admin polls" => "darf Umfragen verwalten",
"Can vote polls" => "darf in Umfragen abstimmen",
"Can admin quizzes" => "darf Quizze verwalten",
"Can take quizzes" => "darf an Quizen teilnemen",
"Can view quiz stats" => "darf Quiz-Statistiken ansehen",
"Can admin sheet" => "darf Datenbl&auml;tter verwalten",
"Can create and edit sheets" => "darf Sheets erstellen und bearbeiten",
"Can view sheet" => "darf Datenbl&auml;tter anschauen",
"Can view sheet history" => "darf Datenblatt-Verlauf anschauen",
"Can admin shoutbox (Edit/remove msgs)" => "darf Tiki-Nachrichtenbox verwalten (bearbeiten/l&ouml;schen von Nachrichten)",
"Can post messages in shoutbox" => "darf Nachrichten in Tiki-Nachrichtenbox schreiben",
"Can view shoutbox" => "darf Tiki-Nachrichtenbox anschauen",
"Can admin surveys" => "darf Umfragen verwalten",
"Can take surveys" => "darf an Umfragen teilnemen",
"Can view survey stats" => "darf Umfragen-Statistik anschauen",
"Can admin trackers" => "darf Tracker verwalten",
"Can attach files to tracker items" => "darf Dateien an Tracker-Eintr&auml;ge anh&auml;ngen",
"Can insert comments for tracker items" => "darf Tracker-Eintr&auml;ge kommentieren",
"Can create new items for trackers" => "darf neuen Tracker-Eintrag erstellen",
"Can change tracker items" => "darf Tracker-Eintr&auml;ge &auml;ndern",
"Can view rating result for tracker items" => "darf Bewertungen f&uuml;r Tracker-Eintr&auml;ge anschauen",
"Can vote a rating for tracker items" => "darf Tracker-Eintr&auml;ge bewerten",
"Can view trackers" => "darf Tracker anschauen",
"Can view trackers closed items" => "darf geschlossene Tracker-Eintr&auml;ge anschauen",
"Can watch tracker" => "darf Tracker beobachten",
"Can admin the wiki" => "darf Wiki verwalten",
"Can assign perms to wiki pages" => "darf Wiki-Seiten Berechtigungen zuweisen",
"Can edit pages" => "darf Seiten bearbeiten",
"Can edit copyright notices" => "darf Copyright-Informationen bearbeiten",
"Can edit dynamic variables" => "darf dynamische Variablen bearbeiten",
"Can create and edit structures" => "darf Struktur erstellen und bearbeiten",
"Can lock pages" => "darf Seiten sperren",
"Can save as minor edit" => "darf als geringf&uuml;gig speichern",
"Can remove" => "darf l&ouml;schen",
"Can rename pages" => "darf Seiten umbenennen",
"Can rollback pages" => "darf Seiten zur&uuml;cksetzen",
"Can upload pictures to wiki pages" => "darf Bilder in Wiki-Seiten hochladen",
"Can view page/pages" => "darf Seiten anschauen",
"Can watch structure" => "darf Strukturen beobachten",
"Can admin attachments to wiki pages" => "darf Anh&auml;nge von Wiki-Seiten verwalten",
"Can add and change ratings on wiki pages" => "darf Bewertungen von Wiki-Seiten erstellen und bearbeiten",
"Can attach files to wiki pages" => "darf Dateien an Wiki-Seiten anh&auml;ngen",
"Can view wiki attachments and download" => "darf Wiki-Anh&auml;nge anschauen und runterladen",
"Can view wiki comments" => "darf Wiki-Kommentare anschauen",
"Can view wiki history" => "darf Wiki-Verlauf anschauen",
"Can view rating of wiki pages" => "darf Bewertung von Wiki-Seiten anschauen",
"Can view source of wiki pages" => "darf Quelltext von Wiki-Seiten anschauen",
"Can participate to rating of wiki pages" => "darf Wiki-Seiten bewerten",
"Can admin received articles" => "darf erhaltene Artikel verwalten",
"Can admin received pages" => "darf erhaltene Seiten verwalten",
"Can send articles to other sites" => "darf Artikel an andere Seiten senden",
"Can send articles to this site" => "darf Artikel an diese Seite senden",
"Can send pages to this site" => "darf Seiten an diese Seite senden",
"Can send pages to other sites" => "darf Seiten an andere Seiten senden",
"Can cache user bookmarks" => "darf Benutzer-Lesezeichen cachen",
"Can configure modules" => "darf Module konfigurieren",
"Can create user bookmarks" => "darf Benutzer-Lesezeichen erstellen",
"Can use the mini event calendar" => "darf den Mini-Kalender verwenden",
"Can use the newsreader" => "darf Newsreader verwenden",
"Can use the notepad" => "darf Notepad verwenden",
"Can admin public tasks" => "darf &ouml;ffentliche Aufgaben verwalten",
"Can use tasks" => "darf Aufgaben verwenden",
"Can upload personal files" => "darf pers&ouml;nliche Dateien hochladen",
"Can create items in personal menu" => "darf Eintr&auml;ge im pers&ouml;nlichen Men&uuml; erstellen",
"Can broadcast messages to all user" => "darf Nachrichten an alle Benutzer senden",
"Can broadcast messages to groups" => "darf Nachrichten an Gruppen senden",
"Can use the messaging system" => "darf Nachrichten-System verwenden",
"Can edit all comments" => "darf alle Kommentare bearbeiten",
"Can post new comments" => "darf neue Kommentare schreiben",
"Can read comments" => "darf Kommentare lesen",
"Can delete comments" => "darf Kommentare l&ouml;schen",
"Can vote comments" => "darf Kommentare bewerten",
"Can edit content templates" => "darf Inhalts-Vorlagen bearbeiten",
"Can use content templates" => "darf Inhalts-Vorlagen verwenden",
"Can edit HTML pages" => "darf HTML-Seiten bearbeiten",
"Can view HTML pages" => "darf HTML-Seiten anschauen",
"Can list registered users" => "darf registirerte Benutzer auflisten",
"Admin live support system" => "darf Live-Support-System verwalten",
"Can use live support system" => "darf Live-Support-System verwenden",
"Can create new mapfile" => "darf neue Karte erstellen",
"Can delete mapfiles" => "darf Karten l&ouml;schen",
"Can edit mapfiles" => "darf Karten bearbeiten",
"Can view mapfiles" => "darf Karten anschauen",
"Can use webmail" => "darf Web-Mail verwenden",
"smarty notice reporting" => "Smarty 'notice' Berichterstattung",
"country" => "Land",
"Anti-Bot verification code" => "Anti-Bot Best&auml;tigungscode",
"Random Image" => "Zuf&auml;lliges Bild",
"Enter the code you see above" => "Geben Sie den Anti-Bot Best&auml;tigungscode hier ein",
"List of attached files" => "Liste aller angeh&auml;ngten Dateien",
"id" => "ID",
"desc" => "Beschreibung",
"uploaded" => "hochgeladen",
"Download" => "Herunterladen",
"Delete" => "L&ouml;schen",
"Remove" => "Entfernen",
"Upload file" => "Datei hochladen",
"Attach" => "Anh&auml;ngen",
"Attach a file to this item" => "Datei an diesen Eintrag anh&auml;ngen",
"Attachments" => "Anh&auml;nge",
"more info" => "weitere Infos",
"No attachments for this item" => "Keine Anh&auml;nge f&uuml;r diesen Eintrag",
"debug" => "Debug",
"Fatal error" => "Fataler Fehler",
"Created by" => "Erstellt von",
"on" => "am",
"RSS feed" => "RSS Feed",
"Edit blog" => "Blog bearbeiten",
"Monitor this Blog" => "Diesen Blog beobachten",
"Stop Monitoring this Blog" => "Diesen Blog nicht mehr beobachten",
"Activity=" => "Aktivit&auml;t=",
"Watched by categories" => "Beobachtet durch die Kategorien",
"Actions" => "Aktionen",
"Properties" => "Eigenschaften",
"No records found" => "Keine Datens&auml;tze gefunden",
"Categorize" => "Kategorisieren",
"Admin Categories" => "Kategorien verwalten",
"No categories defined" => "Keine Kategorien definiert",
"Browse Category" => "Kategorien durchst&ouml;bern",
"stars" => "Sterne",
"User Level" => "Benutzerlevel",
"private message" => "private Nachricht",
"Send eMail to User" => "EMail an Benutzer schicken",
"user online" => "Benutzer online",
"user offline" => "Benutzer offline",
"Reply" => "Antwort",
"Approve" => "Freigeben",
"Save to notepad" => "Im Notizblock speichern",
"Monitor this Topic" => "Thema beobachten",
"Stop Monitoring this Topic" => "Beobachtung dieses Themas beenden",
"Errors" => "Fehler",
"Moderator actions" => "Moderator-Aktionen",
"reported:" => "gemeldet:",
"queued:" => "aufgelaufen:",
"Move to topic:" => "Verschiebe zu Thema:",
"Move" => "Verschieben",
"Delete Selected" => "Markierte l&ouml;schen",
"Unlock" => "Entsperren",
"Lock" => "Sperren",
"Messages" => "Nachrichten",
"Plain" => "flach",
"Headers Only" => "nur K&ouml;pfe",
"Newest first" => "Neueste zuerst",
"Oldest first" => "&Auml;lteste zuerst",
"Title (desc)" => "Titel (abst.)",
"Title (asc)" => "Titel (aufst.)",
"Threshold" => "Schwellenwert",
"Set" => "Ok",
"Replies" => "Antworten",
"below your current threshold" => "unterhalb Ihres aktuellen Schwellenwerts",
"Note" => "Notiz",
"New Reply" => "Neue Antwort",
"Editing reply" => "Antwort bearbeiten",
"Post new message" => "Neuen Beitrag erstellen",
"Editing comment" => "Bearbeitungskommentar",
"Comment on the selected post" => "Diesen Beitrag kommentieren",
"Post new comment" => "Neuen Kommentar posten",
"required" => "erforderlich",
"Enter your name" => "Geben Sie Ihren Namen ein",
"Post new reply" => "Neue Anwort schreiben",
"Post as Anonymous" => "als anonym posten",
"Cancel" => "Abbrechen",
"Posting replies" => "Post-Antworten",
"Posting comments" => "Posting-Kommentare",
"Use" => "Benutze",
"for links" => "f&uuml;r Links",
"HTML tags are not allowed inside posts" => "HTML-Tags sind in Posts nicht erlaubt",
"Add Comment" => "Kommentieren",
"1 comment" => "1 Kommentar",
"Comments" => "Kommentare",
"Go back" => "zur&uuml;ck",
"Return to home page" => "Zur Home-Seite zur&uuml;ckkehren",
"Type of contribution:" => "Art der Beteiligung:",
"Contributors" => "Mitwirkende",
"Authors" => "Autoren",
"Add" => "Hinzuf&uuml;gen",
"Page generation debugging log" => "Debug-Log der Seitengenerierung",
"Features state" => "Status der Funktion",
"Total" => "Gesamt",
"features matched" => "Features gefunden",
"Watchlist" => "Beobachtungsliste",
"Duplicate File Gallery" => "Dateiarchiv duplizieren",
"Duplicate categories" => "Kategorien kopieren",
"Duplicate perms" => "Berechtigungen kopieren",
"duplicate" => "Kopie",
"There are individual permissions set for this file gallery" => "F&uuml;r dieses Dateiarchiv sind individuelle Berechtigungen gesetzt",
"Save" => "Speichern",
"View inserted gallery" => "Unterverzeichnisse anzeigen",
"Display Properties" => "Anzeige Einstellungen",
"required field for podcasts" => "bei PodCasts erforderlich",
"any file" => "beliebige Dateien",
"podcast (audio)" => "PodCast (Audio)",
"podcast (video)" => "PodCast (Video)",
"Gallery is visible to non-admin users?" => "Galerie sichtbar f&uuml;r Nicht-Admins?",
"This Gallery is Public" => "Diese Galerie ist &ouml;ffentlich",
"unlimited" => "unbegrenzt",
"none" => "nichts",
"Parent gallery" => "Mutter-Galerie",
"Owner of the gallery" => "Besitzer der Gallerie",
"Default sort order" => "Standard-Sortierreihenfolge",
"descending" => "absteigend",
"ascending" => "aufsteigend",
"Max description display size" => "Maximale Anzeigebreite der Beschreibung",
"Max Rows per page" => "Max. Zeilen pro Seite",
"Listing configuration" => "Listen-Konfiguration",
"Please login" => "Bitte anmelden",
"Go to Login Page" => "zur Anmeldeseite wechseln",
"Create this page" => "Diese Seite anlegen",
"(page will be orphaned)" => "(Seite wird verwaist sein)",
"Close Window" => "Fenster schlie&szlig;en",
"Go to" => "gehe zu",
"Private Gallery" => "Privates Verzeichnis",
"Active Perms" => "Active Rechte",
"Perms" => "Berecht.",
"Upload New Version" => "neue Version hochladen",
"Replace" => "Ersetzen",
"Download and lock" => "Herunterladen und sperren",
"List" => "Liste",
"Browse" => "Ansehen",
"Name-filename" => "Name-Dateiname",
"Filename only" => "nur Dateiname",
"Show as a column" => "zeigen als eine Spalte",
"Show in popup box" => "in Popup-Fenster anzeigen",
"Both" => "beides",
"Close" => "Schlie&szlig;en",
"Exact&nbsp;match" => "genau&nbsp;so",
"any type" => "alle Typen",
"all topic" => "alle Themen",
"any language" => "alle Sprachen",
"any category" => "alle Kategorien",
"Number of displayed rows" => "Angezeigte Spaltenanzahl",
"Go" => "Start",
"Show php error messages" => "php-Fehlermeldungen anzeigen",
"RSS Image Galleries" => "RSS Bildergalerien",
"RSS Maps" => "RSS Karten",
"Show Tree" => "zeige Verzeichnisbaum",
"Perform action with checked:" => "Aktion auf alle markierten ausf&uuml;hren",
"Move Selected Files" => "Markierte Dateien verschieben",
"Download the zip" => "zip-komprimiert herunterladen",
"Assign Permissions" => "Berechtigungen vergeben",
"Move to" => "Verschieben nach",
"Assign" => "Zuweisen",
"Filename" => "Dateiname",
"Other Sorts" => "Andere Sortierungen",
"No Additionnal Sort" => "Keine weitere Sortierung",
"No information" => "Keine Information",
"Hi {\$mail_user} has sent you this link:" => "Hallo, {\$mail_user} hat Ihnen diesen Link zugesandt:",
"Blog post:" => "Blog-Eintrag:",
"at:" => "auf:",
"Somebody or you tried to subscribe this email address at our site:" => "Sie oder jemand anders hat versucht, diese eMail-Adresse einzutragen bei:",
"To the newsletter:" => "Zum Newsletter:",
"Description:" => "Beschreibung:",
"In order to confirm your subscription you must access the following URL:" => "Zur Best&auml;tigung der Newsletter-Registrierung m&uuml;ssen Sie diesem Link folgen:",
"A new message was posted to forum" => "Ein neuer Beitrag wurde gepostet ins Forum",
"Contribution" => "Beitrag",
"Tiki mail-in instructions" => "Tiki Mail-in Anweisungen",
"Page not found:" => "Seite nicht gefunden:",
"Hi," => "Hallo,",
"A new message was posted to you at {\$mail_machine}" => "Eine neue Nachricht f&uuml;r Sie auf {\$mail_machine}",
"From" => "Von",
"Hi" => "Hallo",
"Enjoy the site!" => "Viel Spass auf der Site!",
"has requested an account on" => "hat einen Zugang beantragt f&uuml;r",
"Group:" => "Gruppe",
"To validate that account, please follow the link:" => "Zum Best&auml;tigen des Account-Antrags den folgenden Link klicken:",
"best regards" => "Gruss",
"your Tikiwiki" => "Ihr Tiki",
"User Registration Request" => "Anfrage Tiki Benutzerregistrierung",
"The user" => "Der Benutzer",
"registered at your site" => "hat sich auf Ihrer Tiki-Site registriert",
"New user registration" => "Neue User-Anmeldung",
"Bye bye!" => "Auf Wiedersehen!",
"This email address has been removed to the list of subscriptors of:" => "Diese eMail-Adresse wurde aus die Liste der Adressaten gel&ouml;scht von:",
"Bye bye from %s at %s" => "Auf Wiedersehen von %s an %s",
"You can unsubscribe from this newsletter following this link" => "Abbestellen dieses Newsletters durch Klick auf den Link m&ouml;glich",
"Welcome to our newsletter!" => "Willkommen bei diesem Newsletter!",
"This email address has been added to the list of subscriptors of:" => "Diese eMail-Adresse wurde in die Liste der Adressaten aufgenommen von:",
"You can always cancel your subscription using:" => "Sie k&ouml;nnen die Newsletter-Registrierung jederzeit r&uuml;ckg&auml;ngig machen &uuml;ber:",
"Email notification" => "Tiki eMail-Benachrichtigung",
"Someone coming from IP Address" => "jemand mit der IP Adresse",
"Since this is your registered email address we inform that the password for this account is" => "Da dies Ihre registrierte eMail-Adresse ist, informieren wir Sie dar&uuml;ber, dass das Passwort f&uuml;r diesen Account wie folgt lautet:",
"Important: Username & password are CaSe SenSitiVe" => "Wichtig: Benutzername & Kennwort sind vertraulich",
"Your account information for %s" => "Ihre Tiki-Accountinformationen f&uuml;r %s",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "Es wurde ein neuer Artikel von {\$mail_user} auf {\$mail_site} um {\$mail_date|tiki_short_datetime} erstellt",
"You can edit the submission following this link:" => "Sie k&ouml;nnen diesen Beitrag bearbeiten, wenn Sie hier klicken:",
"Title:" => "Titel:",
"Heading:" => "Kopfbereich:",
"Body:" => "Hauptteil:",
"A friend sends you a link from: " => "Ein Freund sendet Dir diesen Link:",
"User:" => "Benutzer:",
"You or someone registered this email address at" => "Sie oder jemand anderes hat Ihre eMail-Adresse bei",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Falls Sie sich f&uuml;r diese Site registrieren m&ouml;chten, m&uuml;ssen Sie sich f&uuml;r das erste Login &uuml;ber diesen Link anmelden:",
"Your registration confirmation" => "Ihre Tiki Registrierungsinformationen",
"You will receive an email with information to login for the first time into this site" => "Sie erhalten in K&uuml;rze eine Mail, die Informationen enthalten, wie Sie sich zum ersten mal anmelden.",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Die Anfrage wurde gespeichert und wird vom Administrator schnellst m&ouml;glich bearbeitet.",
"View the article at:" => "Klicken Sie hier um zu dem Artikel zu gelangen:",
"If you don't want to receive these notifications follow this link:" => "Falls Sie diese Benachrichtigungen nicht mehr bekommen m�chten, klicken sie hier:",
"View the blog at:" => "Zeige den Blog auf:",
"changed" => "ge&auml;ndert",
"A new category was created in" => "Eine neue Kategorie wurde erstellt in",
"created" => "erstellt",
"A category was removed in" => "Eine Kategorie wurde gel&ouml;scht in",
"Removed by" => "Gel&ouml;scht von",
"A category was updated" => "Eine Kategorie wurde aktualisiert",
"Updated by" => "Aktualisiert von",
"New" => "Neu",
"File Gallery %s changed" => "Dateiverzeichnis %s ge&auml;ndert",
"A file was removed from the file gallery" => "Eine Datei wurde aus dem Dateiverzeichnis gel&ouml;scht",
"File Name" => "Dateiname",
"A new file was posted to file gallery" => "Eine neue Datei wurde hochgeladen in Dateiverzeichnis",
"File Description" => "Dateibeschreibung",
"A new file was posted to image gallery" => "Ein neues Bild wurde hochgeladen in Bildergalerie",
"An object was added to category" => "Ein Objekt wurde hinzugef&uuml;gt zur Kategorie",
"Added by" => "Hinzugef&uuml;gt durch",
"Object type" => "Objekttyp",
"An object was removed from category" => "Ein Objekt wurde entfernt aus der Kategorie",
"A new file have been attached to page" => "Eine neue Datei wurde angeh&auml;ngt an Seite",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Die Seite {\$mail_page} wurde von {\$mail_user} um {\$mail_date|tiki_short_datetime} ge&auml;ndert",
"Comment:" => "Kommentar:",
"You can view the page by following this link:" => "Sie k&ouml;nnen die Seite betrachten in dem Sie diesem Link folgen:",
"You can view a diff back to the previous version by following this link:" => "Sie k&ouml;nnen einen Blick auf die vorherige Version werfen, indem Sie diesem Link folgen:",
"The changes in this version follow below, followed after by the current full page text." => "Die &Auml;nderungen dieser Version folgen unten, gefolgt von dem aktuellen komplette Seiteninhalt.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Zeilen: {\$oldd} ge&auml;ndert zu +Zeilen: {\$newd}",
"The new page content follows below." => "Der neue Seiteninhalt folgt unten.",
"Wiki page renamed" => "Wiki Seite wurde umbenannt",
"Old name" => "Alter Name",
"New name" => "Neuer Name",
"Query Results" => "Abfrage-Ergebnis",
"Scroll Up" => "hoch scrollen",
"Scroll Down" => "runter scrollen",
"Scale" => "Skalieren",
"Query" => "Abfrage",
"Redraw" => "Neu zeichnen",
"Reset Map" => "Karte zur&uuml;cksetzen",
"Click on the map or click redraw" => "Karte oder 'Neu zeichnen' anklicken",
"Last modification date" => "Datum der letzten Modifikation",
"Overview" => "&Uuml;bersicht",
"Legend" => "Legende",
"Layer Manager" => "Layer-Manager",
"On" => "Am",
"Download Layer" => "Layer herunterladen",
"you have requested to download the layer:" => "Sie haben das Herunterladen des Layers angefordert:",
"Here are the files to download, do not forget to rename them:" => "Heie sind die herunterladbaren Dateien, bitte nicht vergessen, sie umzubenennen:",
"Mapfiles" => "Kartendateien",
"Mapfile" => "Kartendatei",
"Available mapfiles" => "Verf&uuml;gbare Kartendateien",
"monitor this map" => "diese Karte beobachten",
"Stop Monitoring this Map" => "Diese Karte nicht mehr beobachten",
"Create a new mapfile" => "Neue Kartendatei anlegen",
"Create" => "Erstellen",
"Mapfile listing" => "Liste Kartendateien",
"Reload" => "Aktualisieren",
"History" => "Historie",
"You can view this map in your browser using" => "Sie k&ouml;nnen diese Karte in Ihrem Browser betrachten",
"Zoom out x2" => "Zoom heraus x2",
"Zoom in x2" => "Zoom hinein x2",
"Mapfile History" => "Kartenverlauf",
"of" => "von",
"Compare" => "Vergleichen",
"Comparing version {\$old.version} with version {\$new.version}" => "Vergleiche Version {\$old.version} mit Version {\$new.version}",
"Current" => "Aktuell",
"Versions are identical" => "Versionen sind identisch",
"Legend:" => "Legende:",
"v=view" => "v=betrachten",
"Full side-by-side diff" => "Kompletter Side-By-Side Vergleich",
"Unified diff" => "Einheitlicher Vergleich",
"Side-by-side view" => "Side-By-Side Ansicht",
"User" => "Benutzer",
"Ip" => "IP",
"Older Version" => "&auml;ltere Version",
"Directories" => "Links",
"back to" => "zur&uuml;ck zu",
"Upload From Disk:" => "Von Platte hochladen:",
"Upload Files" => "Dateien hochladen",
"Bytes maximum" => "Bytes maximal",
"Create Directory:" => "Verzeichnis anlegen:",
"index file (.shp):" => "Index-Datei (.shp):",
"files to index (regexp):" => "zu indizierende Dateien (regexp):",
"Message Archive" => "Nachrichten-Archiv",
"messages" => "Nachrichten",
"Archive is full!" => "Archiv ist voll!",
"Unread" => "Ungelesen",
"Flagged" => "Gekennzeichnet",
"Unflagged" => "Nicht gekennzeichnet",
"Containing" => "die enthalten",
"Sender" => "Absender",
"No messages to display" => "Keine Nachrichten anzuzeigen",
"Broadcast message" => "Nachricht an Verteiler",
"All users" => "Alle Benutzer",
"Lowest" => "sehr niedrig",
"Low" => "niedrig",
"Normal" => "normal",
"High" => "hoch",
"Very High" => "sehr hoch",
"Send" => "Verschicken",
"Compose message" => "Nachricht erstellen",
"Invalid" => "Ung&uuml;ltig",
"To" => "An",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "Mailbox ist voll! Bitte ein paar Nachrichten archivieren oder l&ouml;schen, damit weitere empfangen werden k&ouml;nnen.",
"is reply to" => "ist Antwort auf",
"Find replied message" => "suche beantwortete Nachricht",
"Archive" => "Archiv",
"Mark as read" => "auf gelesen ...",
"Mark as unread" => "auf ungelesen ...",
"Mark as flagged" => "Kennzeichnung nicht ...",
"Mark as unflagged" => "Kennzeichnung ...",
"Mark" => "setzen",
"Mailbox" => "Briefkasten",
"Compose" => "Erstellen",
"Broadcast" => "Verteiler",
"Sent" => "Ausgang",
"Auto-archive age for read messages:" => "Mindestalter gelesener Nachrichten f&uuml;r Auto-Archivierung:",
"Read message" => "Nachricht lesen",
"Return to mailbox" => "zur&uuml;ck zum Briefkasten",
"replyall" => "allen antworten",
"Unflag" => "Kennzeichnung aufheben",
"Flag this message" => "Nachricht kennzeichnen",
"Return to archive" => "Zur&uuml;ck zum Archiv",
"Return to outbox" => "Zur&uuml;ck zum Ausgang",
"Sent Messages" => "Ausgegangene Nachrichten",
"Replied" => "Beantwortet",
"Not replied" => "Nicht beantwortet",
"move to archive" => "archivieren",
"receiver" => "Empf&auml;nger",
"Move module up" => "Modul nach oben verschieben",
"Up" => "Rauf",
"Move module down" => "Modul nach unten verschieben",
"Down" => "Runter",
"Move module to opposite side" => "Modul zur anderen Seite verschieben",
"toggle" => "Toggle",
"Admin Menu" => "Men&uuml; verwalten",
"Live Support" => "Onlinesupport",
"Banning" => "Benutzer aussperren",
"Users" => "Benutzer",
"Modules" => "Module",
"RSS Modules" => "RSS-Module",
"Menus" => "Men&uuml;s",
"Polls" => "Abstimmungen",
"Mail Notifications" => "eMail-Benachrichtigungen",
"Search Stats" => "Suchstatistik",
"QuickTags" => "Quicktags",
"Categories" => "Kategorien",
"Banners" => "Banner",
"Edit Templates" => "Vorlagen bearbeiten",
"HTML Pages" => "HTML-Seiten",
"Shoutbox" => "Nachrichtenbox",
"Shoutbox Words" => "Nachrichtenbox-W&ouml;rter",
"Referer Stats" => "Referer-Statistik",
"Import PHPWiki Dump" => "PHPWiki Dump importieren",
"phpinfo" => "PHPInfo",
"Admin dsn" => "DSN verwalten",
"Security Admin" => "Sicherheit",
"You forgot your Google ad_client number !" => "Es wurde keine Google ad_client Nummer angegeben!",
"Tikiwiki Assistant" => "Tiki Assistent",
"Thank you for installing Tikiwiki" => "Vielen Dank f&uuml;r die Nutzung von Tiki",
"Select" => "Ausw&auml;hlen",
"Admin" => "Einstellungen",
"Admin Modules" => "Module verwalten",
"Admin Menus" => "Men&uuml;s verwalten",
"login" => "Anmeldung",
"Last `\$module_rows` blog comments" => "Die letzten `\$module_rows` Blog-Kommentare",
"Last blog comments" => "letzten Blog-Kommentare",
"Recently visited pages" => "Zuletzt besuchte Seiten",
"January" => "Januar",
"February" => "Februar",
"March" => "M&auml;rz",
"May" => "Mai",
"June" => "Juni",
"July" => "Juli",
"October" => "Oktober",
"December" => "Dezember",
"Tuesday" => "Dienstag",
"Wednesday" => "Mittwoch",
"Thursday" => "Donnerstag",
"Friday" => "Freitag",
"Today" => "Heute",
"Add event" => "Ereignis hinzuf&uuml;gen",
"Received objects" => "Empfangene Objekte",
"Pages:" => "Seiten:",
"Last `\$module_rows` Sites" => "Die letzten `\$module_rows` Links",
"Last Sites" => "Neueste Links",
"Directory Stats" => "Verzeichnis-Statistik",
"Sites" => "Links",
"Sites to validate" => "Zu &uuml;berpr&uuml;fende Links",
"Searches" => "Suchanfragen",
"Visited links" => "Besuchte Links",
"Top \$module_rows Sites" => "Die \$module_rows Top-Links",
"Top Sites" => "Beliebteste Links",
"Current events" => "Aktuelle Termine",
"Featured links" => "Linktips",
"Top `\$module_rows` topics" => "besten 10",
"Top topics" => "Top Themen",
"Last `\$module_rows` forum posts" => "`\$module_rows` neueste Forenbeitr&auml;ge",
"Last forum posts" => "Neueste Forenbeitr&auml;ge",
"Last `\$module_rows` forum topics" => "Die letzten `\$module_rows` Forenthemen",
"Last forum topics" => "Neueste Forenthemen",
"Most commented forums" => "Meistkommentierte Foren",
"Most read topics" => "Meistgelesene Themen",
"Most visited forums" => "Meistbesuchte Foren",
"Google Search" => "Google-Suche",
"Last `\$module_rows` actions" => "Letzte `\$module_rows` Aktionen",
"Last actions" => "Letzte Aktionen",
"Last `\$module_rows` articles" => "Die letzten `\$module_rows` Artikel",
"Last articles" => "Neueste Beitr&auml;ge",
"Last `\$module_rows` blog posts" => "Die letzten `\$module_rows` Blog-Eintr&auml;ge",
"Last blog posts" => "Neueste Blog-Eintr&auml;ge",
"Last" => "letzte",
"Last `\$module_rows` Created blogs" => "Die letzten `\$module_rows` angelegten Blogs",
"Last Created blogs" => "Neueste Blogs",
"Last `\$module_rows` Created FAQs" => "Die letzten `\$module_rows` angelegten FAQs",
"Last Created FAQs" => "Neueste FAQs",
"Last `\$module_rows` Created Quizzes" => "Die letzten `\$module_rows` angelegte Quiz",
"Last Created Quizzes" => "Neueste Quiz",
"Last `\$module_rows` modified file galleries" => "Die letzten `\$module_rows` ge&auml;nderten Dateiarchive",
"Last modified file galleries" => "Zuletzt modifizierte Dateiarchive",
"Last `\$module_rows` Files" => "Die letzten `\$module_rows` Dateien",
"Last Files" => "Neueste Dateien",
"Last `\$module_rows` galleries" => "Die letzten `\$module_rows` Galerien",
"Last galleries" => "Neueste Galerien",
"Last `\$module_rows` Images" => "Die letzten `\$module_rows` Bilder",
"Last Images" => "Neueste Bilder",
"insert original" => "Original einf&uuml;gen",
"insert thumbnail" => "Vorschaubild einf&uuml;gen",
"Last `\$module_rows` modified events" => "Die letzten `\$module_rows` ge&auml;nderten Ereignisse",
"Last modifed events" => "Neueste Termine",
"Last `\$module_rows` changes" => "Die letzten `\$module_rows` &Auml;nderungen",
"Last changes" => "Neueste &Auml;nderungen",
"more" => "weiter",
"Last `\$module_rows` Modified Items" => "Die letzten `\$module_rows` ge&auml;nderten Eintr&auml;ge",
"Last Modified Items" => "Zuletzt ge&auml;nderte Eintr&auml;ge",
"Last `\$module_rows` Modified blogs" => "Die letzten `\$module_rows` ge&auml;nderten Blogs",
"Last Modified blogs" => "Zuletzt ge&auml;nderte Blogs",
"Last `\$module_rows` submissions" => "Die letzten `\$module_rows` Einreichungen",
"Last submissions" => "Neueste Einreichungen",
"Last `\$module_rows` Modified Comments" => "Die letzten `\$module_rows` ge&auml;nderten Kommentare",
"Last `\$module_rows` Items" => "Die letzten `\$module_rows` Eintr&auml;ge",
"Last Items" => "Neueste Eintr&auml;ge",
"Last `\$module_rows` visitors" => "Die letzten `\$module_rows` Besucher",
"Last Visitors" => "Letzte Besucher",
"Register" => "Registrieren",
"Live support" => "Onlinesupport",
"Open operator console" => "Operatorkonsole &ouml;ffnen",
"Online users" => "Benutzer online",
"We have" => "Wir haben",
"online users" => "Benutzer online",
"Logged in as" => "Angemeldet als",
"Logout" => "Abmelden",
"Switch User" => "Benutzer wechseln",
"Switch" => "Wechseln",
"Switch user" => "Benutzer wechseln",
"Login as admin" => "Als Admin anmelden",
"Login through Shibboleth" => "Anmeldung durch das Erkennungszeichen",
"Login as" => "Anmelden als",
"Email" => "eMail",
"eMail" => "EMail",
"Password" => "Pa&szlig;wort",
"Remember me" => "Merken",
"week" => "Woche",
"month" => "Monat",
"year" => "Jahr",
"Click here to register" => "hier klicken f&uuml;r die Registrierung",
"Click here if you've forgotten your password" => "hier klicken, wenn das Kennwort vergessen wurde",
"I forgot my password" => "Ich habe mein Pa&szlig;wort vergessen",
"Click here to login using the default security protocol" => "Klicke hier um Dich &uuml;ber die Voreingestellte Verbindung anzumelden",
"Click here to login using a secure protocol" => "Klicke hier um Dich &uuml;ber eine gesicherte Verbindung anzumelden",
"Secure" => "Sicher",
"Stay in ssl Mode" => "In SSL-Modus bleiben",
"OpenID Login" => "OpenID Anmeldung",
"Menu" => "Men&uuml;",
"You have" => "Du hast",
"New Messages" => "Neue Nachrichten",
"New Message" => "Neue Nachricht",
"You have 0 new messages" => "Sie haben keine neuen Nachrichten",
"Waiting Submissions" => "Wartende Einreichungen",
"submissions waiting to be examined" => "Einreichungen, die auf Sichtung warten",
"Old articles" => "Alte Artikel",
"Send a message to" => "Schicke eine Nachricht an",
"Send a message" => "Mitteilung senden",
"Random Images" => "zuf&auml;lliges Bild",
"Random Pages" => "Zuf&auml;llige Seiten",
"Register as a new user" => "Als neuer Benutzer registrieren",
"Your registration code:" => "Ihr Registrierungscode:",
"Username" => "Benutzername",
"Passcode to register (not your user password)" => "Passcode zum Registrieren (nicht Ihr Benutzerpa&szlig;wort)",
"Registration code" => "Registrierungscode",
"Repeat password" => "Pa&szlig;wort wiederholen",
"Generate a password" => "Pa&szlig;wort vorschlagen",
"Articles RSS" => "Artikel RSS",
"Image Galleries RSS" => "Bilder-Galerien RSS",
"Image Galleries" => "Bildergalerien",
"File Galleries RSS" => "Datei-Archive RSS",
"File Galleries" => "Dateiarchive",
"Forums RSS" => "Foren RSS",
"Maps RSS" => "Karten RSS",
"Maps" => "Karten",
"Calendars" => "Kalender",
"Entire Site" => "Ganze Site",
"Wiki Pages" => "Wiki-Seiten",
"Image Gals" => "Bildergalerien",
"Images" => "Bilder",
"Blog Posts" => "Blog-Eintr&auml;ge",
"Search Wiki PageName" => "Suche Wiki-Seitennamen",
"Read More" => "Weiterlesen",
"Since your last visit" => "Was ist neu?",
"Since your last visit on" => "Letzter Besuch",
"New Images" => "Neue Bilder",
"Wiki Pages Changed" => "Wiki-Seiten ge&auml;ndert",
"New Files" => "Neue Dateien",
"New Comments" => "Neue Kommentare",
"New Tracker Items" => "neue Tracker-Eintr&auml;ge",
"New Calendar Events" => "Neue Kalender-Ereignisse",
"New Users" => "Neue Benutzer",
"click to edit" => "Bearbeiten mit Klick",
"Nothing has changed" => "Keine &Auml;nderungen",
"Site Language:" => "Site-Sprache:",
"Site default" => "Site-Default",
"TikiTests Menu" => "TikiTests Men&uuml;",
"List Tests" => "Tests auflisten",
"Create Test" => "Test erstellen",
"Most Active blogs" => "Aktivste Blogs",
"Top `\$module_rows` articles" => "Die `\$module_rows` Top-Artikel",
"Top articles" => "Top Artikel",
"Top `\$module_rows` File Galleries" => "Die `\$module_rows` Top-Dateiarchive",
"Top File Galleries" => "Top-Dateiarchive",
"Top `\$module_rows` files" => "Die `\$module_rows` Top-Dateien",
"Top files" => "Top-Dateien",
"Top `\$module_rows` games" => "Die `\$module_rows` Top-Spiele",
"Top games" => "Top-Spiele",
"Top `\$module_rows` galleries" => "Die `\$module_rows` Top-Galerien",
"Top galleries" => "Top Galerien",
"Top `\$module_rows` Images" => "Die `\$module_rows` Top-Bilder",
"Top Images" => "Top-Bilder",
"Top `\$module_rows` Pages" => "Die `\$module_rows` Top-Seiten",
"Top Pages" => "Top-Seiten",
"Top `\$module_rows` Quizzes" => "Die `\$module_rows` Top-Quiz",
"Top Quizzes" => "Top-Quiz",
"Most `\$module_rows` visited blogs" => "Die `\$module_rows` meistbesuchten Blogs",
"Top `\$module_rows` Visited FAQs" => "Die `\$module_rows` meistbesuchten FAQs",
"Top Visited FAQs" => "Meistbesuchte FAQs",
"view" => "betrachten",
"Set your preferred languages." => "Bevorzuge Sprachen einstellen.",
"preferred languages" => "Bevorzugte Sprachen",
"Translations that need improvement" => "Verbesserungsw&uuml;rdige &Uuml;bersetzungen",
"click to view" => "f&uuml;r Ansicht klicken",
"My blogs" => "Meine Blogs",
"Bookmarks" => "Lesezeichen",
"My galleries" => "Meine Galerien",
"My Pages" => "Meine Seiten",
"User tasks" => "Benutzer-Aufgaben",
"Done" => "fertig",
"Del" => "L&ouml;schen",
"Public tasks" => "&ouml;ffentliche Aufgaben",
"select" => "ausw&auml;hlen",
"User informations" => "Benutzer-Infos",
"Group informations" => "Gruppen-Infos",
"Top users" => "beste Benutzer",
"Whats related" => "Verwandte Objekte",
"online user" => "Benutzer online",
"Last `\$module_rows` wiki comments" => "Die letzten `\$module_rows` Wiki-Kommentare",
"Last wiki comments" => "Die letzten Wiki-Kommentare",
"Real Name" => "Tats&auml;chlicher Name",
"vote" => "Abstimmen",
"Send Newsletter" => "Newsletter versenden",
"Insert/Edit an internal wiki link" => "internen Wiki-Link Einf&uuml;gen/Bearbeiten",
"Wiki Link insert" => "Wiki-Link einf&uuml;gen",
"Insert an image" => "Bild einf&uuml;gen",
"Tiki Image - Insert an image" => "Tiki-Bild - Bild einf&uuml;gen",
"Structures:" => "Strukturen:",
"show structures" => "Strukturen anzeigen",
"hide structures" => "Strukturen ausblenden",
"Manage structures" => "Strukturen verwalten",
"Find:" => "Suche:",
"pages" => "Seiten",
"To edit the copyright notices" => "Zum Editieren der Copyright-Hinweise",
"Click Here" => "Hier klicken",
"The content on this page is licensed under the terms of the" => "Der Inhalt dieser Seite unterliegt folgenden Lizenzbestimmungen:",
"Print" => "Drucken",
"Email This Post" => "Diesen Beitrag verschicken",
"comment" => "Kommentar",
"comments" => "Kommentare",
"First page" => "Erste Seite",
"Previous page" => "Vorherige Seite",
"page" => "Seite",
"Next page" => "N&auml;chste Seite",
"Last page" => "Letzte Seite",
"referenced by" => "Referenzen",
"references" => "Verweise",
"View Comments" => "Kommentare ansehen",
"Blog name" => "Blog Name",
"Enlarge area height" => "H&ouml;he vergr&ouml;&szlig;ern",
"Reduce area height" => "H&ouml;he verringern",
"Calendar View" => "Kalenderansicht",
"List View" => "Listenansicht",
"Tools Calendars" => "Kalendereintr&auml;ge",
"Check / Uncheck All" => "Alle (ent)markieren",
"Refresh" => "Aktualisieren",
"Cancel Edit" => "Bearbeitung verwerfen",
"Change preferences" => "Einstellungen &uuml;bernehmen",
"Site Ads and Banners" => "Site Werbung und Banner",
"Content" => "Inhalt",
"Activate" => "Aktivieren",
"Publish" => "Ver&ouml;ffentlichen",
"General" => "Allgemein",
"Features" => "Funktionen",
"Text area" => "Textbereich",
"Module" => "Modul",
"Meta Tags" => "Meta-Tags",
"Community" => "Gemeinschaft",
"User files" => "Benutzer-Dateien",
"Wysiwyg editor" => "WYSIWYG Editor",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Blogs hinzuf&uuml;gen/l&ouml;schen &uuml;ber Men&uuml;punkt 'Blogs' im Men&uuml; im Seitenbalken oder",
"General Settings" => "Verschiedene Einstellungen II",
"Home Blog (main blog)" => "Home-Blog (Haupt-Blog)",
"Rankings" => "Bewertungen",
"Not Installed" => "nicht Installiert",
"Points" => "Punkte",
"Creation date" => "Erstelldatum",
"Last modified" => "Zuletzt modifiziert",
"Change settings" => "Einstellungen &uuml;bernehmen",
"Default view mode" => "Standardansicht",
"First day of the week" => "erster Tag der Woche",
"Split hours in periods of" => "Teile Stunden in Perioden von",
"1 minute" => "1 Minute",
"10 minutes" => "10 Minuten",
"Browse categories" => "Kategorien durchst&ouml;bern",
"Administer categories" => "Verwalten Sie Kategorien",
"Permissions" => "Berechtigungen",
"Ignore category viewing restrictions" => "Kategorie-Sichteinschr&auml;ngkungen ignorieren",
"Look under \"Articles\" on the application menu for links to" => "Unter Men&uuml;punkt 'Artikel' im Seitenbalken kann man",
"Admin topics" => "Themen verwalten",
"Admin types" => "Typen verwalten",
"Topic" => "Thema",
"Submissions" => "Einreichungen",
"Import CSV file" => "CSV-Datei importieren",
"Import" => "Importieren",
"Visible" => "Sichtbar",
"Gender" => "Geschlecht",
"avatar" => "Avatar",
"Number of friends" => "Anzahl der Freunde",
"E-mail" => "eMail",
"Last login" => "Letzte Anmeldung",
"Distance" => "Distanz",
"Users Default Preferences" => "Benutzer-Standardeinstellungen",
"default" => "standard",
"Number of visited pages to remember" => "Anzahl besuchter Seiten zum Vorhalten",
"Displayed time zone" => "Angezeigte Zeitzone",
"Detect user timezone if browser allows, otherwise site default" => "Versuche Zeitzone zu erkennen, ansonsten Site-Default benutzen",
"User information" => "Benutzerangaben",
"Private" => "Privat",
"public" => "&ouml;ffentlich",
"Use double-click to edit pages" => "Doppelklick zum &Auml;ndern von Seiten benutzen",
"Show user's info on mouseover" => "Benutzer-Info bei Mouseover anzeigen",
"Tasks per page" => "Aufgaben pro Seite",
"Messages per page" => "Nachrichten pro Seite",
"Allow messages from other users" => "Nachrichten von anderen Anwendern erlauben",
"Send me an email for messages with priority equal or greater than" => "Schicke mir eine eMail beim Eintreffen von Nachrichten mit Priorit&auml;t gr&ouml;&szlig;er gleich",
"Auto-archive read messages after x days" => "Gelesene Nachrichten nach x Tagen automatisch archivieren",
"never" => "niemals",
"My Tiki" => "Mein Tiki",
"My pages" => "Meine Seiten",
"My messages" => "Meine Nachrichten",
"My tasks" => "Meine Aufgaben",
"My forum topics" => "Meine Foren-Themen",
"My forum replies" => "Meine Foren-Antworten",
"My items" => "Meine Eintr&auml;ge",
"My workflow" => "Mein Workflow",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Verzeichnisse konfigurieren &uuml;ber Men&uuml; 'Verzeichnisse verwalten' unter 'Linkverzeichnis' im Seitenbalken oder",
"Number of columns per page when listing categories" => "Spalten pro Seite in Kategorienliste",
"Links per page" => "Links pro Seite",
"Validate URLs" => "URLs &uuml;berpr&uuml;fen",
"enable cool sites" => "'Coole Links' aktivieren",
"Show Country Flag" => "L&auml;nderfahnen anzeigen",
"Method to open directory links" => "Art und Weise Links zu &ouml;ffnen",
"New Window" => "Neues Fenster",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "FAQs hinzuf&uuml;gen/l&ouml;schen &uuml;ber Men&uuml;punkt 'FAQs auflisten' unter 'FAQs' im Men&uuml; im Seitenbalken oder",
"Default number of comments per page" => "Standardanzahl von Kommentaren pro Seite",
"Comments default ordering" => "Standardsortierung f&uuml;r Kommentare",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Bitte die <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>Bewertung der Funktionen</a> auf der Tiki Dokumentationsseite beachten.",
"No tabs" => "Tabs abschalten",
"Apply" => "&Uuml;bernehmen",
"Reset" => "Zur&uuml;cksetzen",
"Main" => "Aktivierung der Hauptkomponenten",
"Global Features" => "&Uuml;bergreifende Einstellungen",
"More Functionality" => "Aktivierung weiterer Komponenten",
"UI Enhancements" => "Darstellungsoptimierungen",
"Main Features" => "Hauptkomponenten",
"Newsletters" => "Newsletter",
"Action Log" => "Aktionslog",
"Action log setting" => "Action Log Einstellungen",
"Internationalization" => "Internationalisierung",
"Multilingual" => "Mehrsprachig",
"Surveys" => "Umfragen",
"Copyright System" => "Copyrightsystem",
"Copyright system" => "Copyrightsystem",
"Live support system" => "Onlinesupport-System",
"Tell a Friend" => "Erz&auml;hle dies weiter",
"HTML pages" => "HTML Seiten",
"Contact Us" => "Kontaktiere uns",
"User interface enhancement features" => "Darstellungsoptimierungen",
"JavaScript popup date selector" => "JavaScript-Aufwahlbox f&uuml;r Datum",
"PhpLayers Dynamic menus" => "Dynamische PHPLayer Men&uuml;s",
"Fullscreen" => "Vollbild",
"Allow users to activate fullscreen mode" => "Benutzer darf Fullscreen-Anzeige aktivieren",
"Experimental Features" => "Experimentelles",
"HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "HTML Purifier (Inhalte werden beim Speichern auf XHTML 1.1 ges&auml;ubert)",
"Mobile" => "Tiki Mobil",
"Morcego 3D browser" => "Morcego-3D-Browser",
"Search engine friendly url" => "Suchmaschinen-freundliche URLs",
"Drawings" => "Zeichnungen",
"Friendship" => "Freundschaft",
"Friendship Network" => "Freundschafts-Netzwerk",
"Games" => "Spiele",
"Administration Features" => "Administrative Einstellungen",
"Banning System" => "Benutzer-Sperrsystem",
"Banning system" => "Benutzer-Sperrsystem",
"Stats" => "Statistiken",
"Tiki action calendar" => "Tiki-Aktionskalender",
"Redirect On Error" => "Bei Fehler wiederverbinden",
"Communications (send/receive objects)" => "Kommunikation (Objekte senden/empfangen)",
"Custom Home" => "Angepasstes Home",
"User Features" => "Benutzer-Einstellungen",
"Display 'MyTiki' in the application menu" => "'MeinTiki' im Anwendungsmen&uuml; anzeigen",
"Mini Calendar" => "Mini-Kalender",
"User Preferences Screen" => "Benutzer-Einstellungsseite",
"User Notepad" => "Benutzer-Notizblock",
"User Bookmarks" => "Benutzer-Lesezeichen",
"User Contacts" => "Benutzerkontakte",
"User Watches" => "Benutzer Beobachtungspunkte",
"User Watches Translations" => "Beobachtungspunkte beobachten auch &Uuml;bersetzungen",
"User Menu" => "Benutzer-Men&uuml;",
"User Tasks" => "Benutzer-Aufgaben",
"User Messages" => "Benutzer-Nachrichten",
"User Files" => "Benutzer-Dateien",
"User Levels" => "Benutzerlevel",
"XMLRPC API" => "XMLRPC-API",
"Debugger Console" => "Debug-Konsole",
"Workflow" => "Aktivit&auml;ten",
"Workflow engine" => "Workflow Engine",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Wenn Dateien in einem Verzeichnis (statt in der Datenbank) gespeichert werden sollen, sollte das Verzeichnis nicht direkt zugreifbar sein.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Daf&uuml;r gibt es zwei M&ouml;glichkeiten:<br /><ul><li>Das Verzeichnis liegt au&szlig;erhalb des Document-Roots. Achtung: evtl. mu&szlig; es dann noch f&uuml;r PHP lesbar gemacht werden.</li><li>Das Verzeichnis liegt im Document-Root. Achtung: es sollte dann &uuml;ber eine .htaccess Datei gesch&uuml;tzt werden.</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Das Verzeichnis sollte in Unix-Notation angegeben werden, z.B. files/ oder c:/foo/files oder /www/files/",
"Home Gallery (main gallery)" => "Home-Galerie (Hauptgalerie)",
"Create a Gallery" => "Neue Galerie anlegen",
"Allow download limit per file" => "Dateiweise Download-Begrenzung erlauben",
"Prevent download if score becomes negative" => "Downloads bei negativem Score verbieten",
"Allow same file to be uploaded more than once" => "Selbe Datei darf mehrfach hochgeladen werden",
"Never" => "Nie",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "Wenn 'Batch-Upload aus Verzeichnis' aktiviert wird mu&szlig; ein vom Webserver lesbares Verzeichnis benutzt werden (am besten au&szlig;erhalb des Webspace). Dorthin m&uuml;ssen die Dateien dann mit scp, ftp o.&auml;. &uuml;bertragen werden.",
"Reindex all files for search" => "Dateien f&uuml;r Suche neu indizieren",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Foren hinzuf&uuml;gen/l&ouml;schen &uuml;ber Men&uuml;punkt 'Foren verwalten' im Men&uuml; im Seitenbalken oder",
"Home Forum (main forum)" => "Home-Forum (Hauptforum)",
"Accept wiki syntax" => "Wiki-Syntax erlauben",
"Topics" => "Themen",
"Posts per day" => "Eintr&auml;ge pro Tag",
"Browser width" => "Browser-H&ouml;he",
"Browser height" => "Browser-Breite",
"Navigation depth" => "Navigationstiefe",
"Node size" => "Knotengr&ouml;sse",
"Text size" => "Textgr&ouml;sse",
"Spring (connection) size" => "Quellengr&ouml;sse (Verbindung)",
"Camera distance adjusted relative to nearest node" => "Kamera Entfernung einstellen, relativ zum nahsten Knoten",
"Camera distance" => "Kamera Entfernung",
"Field of view" => "Sichtbares Feld",
"Feed animation interval (milisecs)" => "Feed Animationsintervall (Millisek.)",
"Friction constant" => "Reibungskostante",
"Elastic constant" => "Elastizit&auml;tskonstante",
"Eletrostatic constant" => "Elektrostatischekonstante",
"Node mass" => "Knotengewicht",
"Node charge" => "Knotenladung",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Bildgalerien hinzuf&uuml;gen/l&ouml;schen &uuml;ber Men&uuml;punkt 'Bildgalerien' im Men&uuml; im Seitenbalken oder",
"You can upload images of a size of " => "Maximale Gr&ouml;sse zum uploaden von Bildern: ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "&Auml;ndern Sie in der php.ini die Parameter file_uploads, upload_max_filesize, post_max_size und die Datenbankparameter (max_allowed_packet f&uuml;r MySQL) um diesen Gr&ouml;sse zu &auml;ndern",
"Home Gallery" => "Hauptarchiv",
"Galleries features" => "Galerieeigenschaften",
"Uses Slideshow" => "Diaschau verwenden",
"Use database to store images" => "Datanbank zum Speichern von Bildern benutzen",
"Use a directory to store images" => "Ein Verzeichnis zum Speichern von Bildern benutzen",
"Directory path" => "Verzeichnis",
"Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below." => "Hinweis: wenn das Verzeichnis ge&auml;ndert wird, mu&szlig; auch der Inhalt im Filesystem entsprechend manuell verschoben werden. Oder Sie k&ouml;nnen die Dateien in die Datenbank verlagern (s.u.)",
"Library to use for processing images" => "Bibliothek zur Bildbearbeitung",
"Uploaded image names must match regex" => "Hochgeladene Bildnamen m&uuml;ssen diese RegEx erf&uuml;llen",
"Uploaded image names cannot match regex" => "Hochgeladene Bildnamen d&uuml;rfen dieser RegEx nicht entsprechen",
"Directory Batch Loading" => "Aus Verzeichnis einlesen",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Wenn 'Batch-Upload aus Verzeichnis' aktiviert wird mu&szlig; ein vom Webserver lesbares Verzeichnis benutzt werden (am besten au&szlig;erhalb des Webspace). Dorthin m&uuml;ssen die Bilder dann mit scp, ftp o.&auml;. &uuml;bertragen werden.",
"Enable directory batch loading" => "Batch-Upload aus Verzeichnis erlauben",
"Batch loading directory" => "Batch-Upload Verzeichnis",
"Display image informations in a mouseover box" => "Anzeige der Bildinformationen in einer Mauszeiger-Box",
"yes, and don't display those informations under the image" => "ja, keine Anzeige der Informationen unter dem Bild",
"Images per row" => "Bilder pro Zeile",
"Thumbnails size X" => "Thumbnails Breite",
"Thumbnails size Y" => "Thumbnails H&ouml;he",
"pixels" => "Pixel",
"Set features" => "Einstellungen &uuml;bernehmen",
"Exterminator" => "unbenutzte Bilder l&ouml;schen",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Bilder aus der Systemgalerie entfernen, die nicht auf Wiki-Seiten, in Artikeln oder Blog-Eintr&auml;gen genutzt werden",
"Mover" => "Dateien verlagern",
"Move images from database storage to filesystem storage" => "Verschieben alle  Bildern aus der Datenbank ins Dateisystem",
"Move images from filesystem storage to database storage" => "Verschiebe alle Bilder aus dem Dateisystem in die Datenbank",
"All galleries" => "Alle Galerien",
"System Gallery" => "Systemgalerie",
"Move images from old filesystem store to new directory" => "Verschiebe Bilder aus Dateisystem in neuen Ordner im Dateisystem",
"Gallery listing configuration" => "Einstellungen Galerie-Liste",
"Parent" => "Oberkategorie",
"Change configuration" => "Einstellungen &uuml;bernehmen",
"Image galleries comments settings" => "Bildergalerie-Kommentareinstellungen",
"General Preferences" => "Verschiedene Einstellungen I",
"Date and Time Formats" => "Datums- und Zeitformate",
"Check frequency" => "Pr&uuml;fh&auml;ufigkeit",
"Site Identity" => "Site Identit&auml;t",
"Browser title" => "Browsertitel",
"Home Page" => "Startseite",
"Use group homepages" => "Gruppen-Homepages benutzen",
"Go to group homepage only if login from default homepage" => "Sprung zur Gruppen-Homepage nur bei Login &uuml;ber die Default-Homepage",
"Custom home" => "Angepasstes Home",
"Unknown/Other" => "unbekannt/anderes",
"(some Unix MTA)" => "(Unix)",
"PHP error reporting level:" => "PHP Fehler Ausgabelevel:",
"Protect against CSRF with a ticket" => "Durch Ticket gegen CSRF sch&uuml;tzen",
"Use proxy" => "Proxy benutzen",
"Tikiwiki.org help" => "Tikiwiki.org Hilfe",
"Store session data in database" => "Session-Daten in Datenbank speichern",
"Contact" => "Kontakt",
"Contact user" => "Kontaktperson",
"Count admin pageviews" => "Seitenaufrufe durch Admin mitz&auml;hlen",
"Temporary directory" => "Tempor&auml;rverzeichnis",
"Help System" => "Hilfe-System",
"Help URL" => "Hilfe URL",
"Examples" => "Beispiele",
"Default timezone" => "Standard Zeitzone",
"Long date format" => "Langes Datumsformat",
"Short date format" => "Kurzes Datumsformat",
"Long time format" => "Langes Zeitformat",
"Short time format" => "Kurzes Zeitformat",
"Fields display order" => "Darstellungsreihenfolge der Felder",
"Date and Time Format Help" => "Hilfe zum Datums- und Zeitformat",
"Change admin password" => "Admin-Pa&szlig;wort &auml;ndern",
"New password" => "Neues Pa&szlig;wort",
"Change password" => "Pa&szlig;wort &auml;ndern",
"country size" => "Landgr&ouml;&szlig;e",
"city size" => "Stadtgr&ouml;&szlig;e",
"max zoom" => "max Zoom",
"Detect browser language" => "Sprache des Clients abfragen",
"Use database for translation" => "f&uuml;r &Uuml;bersetzung Datenbank benutzen",
"Edit or ex/import Languages" => "Sprachen erstellen oder im/exportieren",
"Record untranslated" => "Eintrag nicht &uuml;bersetzt",
"Syntax error" => "Syntax Fehler",
"Intertiki client" => "Intertiki Client",
"Tiki Unique key" => "Eindeutiger Tiki Schl&uuml;ssel",
"InterTiki Slave mode" => "InterTiki Slave Modus",
"Warning: overrides manually registered local users" => "Warnung: &Uuml;berschreibt Nutzer die sich manuell registriert haben",
"as master" => "als Master",
"host" => "Server",
"port" => "Port",
"Add new server" => "Neuen Server hinzuf&uuml;gen",
"Intertiki server" => "Intertiki Server",
"Intertiki Server enabled" => "Intertiki Server aktiviert",
"Access Log file" => "Verbindungs-Log-Datei",
"Errors Log file" => "Fehler Log-Datei",
"Known hosts" => "Bekannte Hosts",
"Key" => "Schl&uuml;ssel",
"Enable/disable Tiki features in " => "Tiki-Features ein/ausschalten in ",
", but configure them elsewhere" => ", konfiguriert werden sie dann an anderen Stellen.",
"Admin Groups" => "Gruppen verwalten",
"Admin Users" => "Benutzer verwalten",
"Authentication method" => "Authentifizierungsmethode",
"Tiki and HTTP Auth" => "Tiki und HTTP Auth",
"Registration" => "Registrierung",
"Users can register" => "Benutzer k&ouml;nnen sich registrieren",
"Use challenge/response authentication" => "Benutze Challenge-/Response-Authentifizierung",
"Users can choose to stay in SSL mode after an HTTPS login" => "Benutzer darf nach HTTPS Login wahlweise mit SSL fortfahren",
"Users can switch between secured or standard mode at login" => "Benutzer darf zwischen HTTPS und normalem Login w&auml;hlen",
"HTTP port" => "HTTP-Port",
"HTTPS port" => "HTTPS-Port",
"User's choice" => "Benutzer-Wahl",
"Always" => "Immer",
"Duration" => "Dauer",
"PAM service" => "PAM Dienst",
"Currently unused" => "momentan unbenutzt",
"You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/." => "<a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> mu&szlig; zuvor nach lib/phpcas/ installiert werden.",
"CAS server version" => "CAS Serverversion",
"Users can change theme" => "Reg. Benutzer k&ouml;nnen Theme &auml;ndern",
"Restrict available themes" => "Verf&uuml;gbare Themes einschr&auml;nken",
"Available styles:" => "Verf&uuml;gbare Styles:",
"Slideshows theme" => "Diaschau-Theme",
"Edit CSS" => "CSS bearbeiten",
"Theme Control" => "Theme-Konfiguration",
"Tiki Template Viewing" => "Tiki Templates betrachten",
"General Layout options" => "Allgemeine Layout-Einstellungen",
"Custom Site Header" => "Seitenkopf anpassen",
"logged as" => "angemeldet",
"Site logo background color" => "Logo-Hintergrundfarbe",
"Site logo alignment" => "Seiten-Logo Ausrichtung",
"Site logo title (on mouse over)" => "Mouseover-Titel des Logos",
"Alt. description (e.g. for text browsers)" => "Logo ALT-Text",
"Site menu bar" => "Balken f&uuml;r Site Men&uuml;",
"Menu ID" => "Men&uuml;-ID",
"Current Version" => "Aktuelle Version",
"Custom code" => "Angepasster Code",
"Left column" => "Linke Spalte",
"always" => "immer",
"user decides" => "Benutzer entscheidet",
"Site location bar" => "Position des Breadcrumb Balkens",
"at top of page" => "am Seitenanfang",
"at top of center column" => "am Anfang der Mittelspalte",
"Larger font for" => "Gr&ouml;&szlig;ere Schrift f&uuml;r",
"entire location" => "komplette Position",
"page name" => "Seitenname",
"Use page description:" => "Seitenbeschreibung benutzen:",
"Right column" => "Rechte Spalte",
"Custom Site Footer" => "Seitenfu&szlig; anpassen",
"Bottom bar icons" => "Icons im unteren Balken anzeigen",
"Bottom bar debug" => "Server-Info im unteren Balken anzeigen",
"Maximum number of records in listings" => "Maximale Anzahl der Datens&auml;tze in Listen",
"Use direct pagination links" => "Seitennavigation &uuml;ber Seitenzahlen",
"Warning" => "Warnung",
"Left" => "links",
"Right" => "rechts",
"Use Tabs" => "Tabs benutzen",
"Display menus as folders" => "Men&uuml;s als Ordner darstellen",
"Layout per section" => "Layout pro Bereich",
"Admin layout per section" => "Layout pro Bereich verwalten",
"Favicon icon file name:" => "Favicon Dateiname:",
"Favicon icon MIME type:" => "Favicon MIME-Type:",
"full path to mapfiles" => "Kompletter Pfad zu Kartendateien",
"default mapfile" => "Standard-Kartendatei",
"Wiki Page for Help" => "Wikiseite f&uuml;r Hilfe",
"Wiki Page for Comments" => "Wikiseite f&uuml;r Kommentare",
"Full path to gdaltindex" => "Kompletter Pfad zu gdaltindex",
"Full path to ogr2ogr" => "Kompletter Pfad zu ogr2ogr",
"Generate User Map" => "Benutzerkarte erstellen",
"Users can opt-out internal messages" => "Benutzer k&ouml;nnen Empfang interne Nachrichten deaktivieren",
"Users accept internal messages by default" => "Standardm&auml;ssig interne Nachrichten empfangen",
"Maximum mailbox size (messages, 0=unlimited)" => "Mailbox-Gr&ouml;&szlig;e (in Nachrichten, 0=unbegrenzt)",
"Maximum mail archive size (messages, 0=unlimited)" => "Mailboxarchiv-Gr&ouml;&szlig;e (in Nachrichten, 0=unbegrenzt)",
"Maximum sent box size (messages, 0=unlimited)" => "Ausgangsordner-Gr&ouml;&szlig;e (in Nachrichten, 0=unbegrenzt)",
"geo.position" => "Geo Position",
"geo.region" => "Geo Region",
"geo.placename" => "Geo Ort",
"Display modules to all groups always" => "Module immer in allen Gruppen anzeigen",
"Hide anonymous-only modules from registered users" => "Module f&uuml;r Anonym bei registrierten Benutzern verstecken",
"ID3 Tag Color" => "ID3 Tag Farbe",
"Video Heigth" => "Videoh&ouml;he",
"Max Play time" => "maximale Spielzeit",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Umfragen hinzuf&uuml;gen/l&ouml;schen &uuml;ber Men&uuml;punkt 'Abstimmungen' unter 'Admin' im Men&uuml; im Seitenbalken oder",
"Show categories" => "Kategorien anzeigen",
"Show objects" => "Objekte anzeigen",
"Last update" => "Letzte Aktualisierung",
"installed" => "installiert",
"Image galleries" => "Bildergalerien",
"Feed for forums" => "Feed f&uuml;r Foren",
"Default RDF version" => "Welchs Protokoll benutzen",
"Specification" => "Spezifikation",
"Documentation" => "Dokumentation",
"You can see users rank by score in the module users_rank, for that go to" => "Den Benutzerrang nach Punkten kann man dem Modul user_rank entnehmen, einschaltbar unter",
"Admin modules" => "Module",
"Expiration" => "Verfallszeit",
"Search stats" => "Such-Statistik",
"Database search" => "Datenbanksuche",
"random" => "zuf&auml;llig",
"Refresh rate" => "Refresh-Rate",
"Minimum length of search word" => "Mindestl&auml;nge des Suchwortes",
"Max. number of words containing a syllable" => "Maximalzahl einsilbiger W&ouml;rter",
"Max. age in hours of syllable search cache" => "Maximales Alter in Stunden im Cache f&uuml;r Silbensuche",
"LRU list purging rate" => "L&ouml;schrate der LRU Liste",
"LRU list length" => "L&auml;nge der LRU Liste",
"Refresh wiki search index now" => "Wiki Suchindex jetzt aktualisieren",
"Refresh tracker search index now" => "Tracker Suchindex jetzt aktualisieren",
"Referer Search Highlighting" => "Hervorhebung der Suchbegriffe auf den gefundenen Seiten",
"Ignore individual object permissions" => "Individuelle Objekt-Berechtigungen ignorieren",
"hits" => "Zugriffe",
"Protect email against spam" => "eMail-Adressen vor Spam sch&uuml;tzen",
"Open external links in new window" => "Externe Links in neuem Fenster &ouml;ffnen",
"Dynamic Content System" => "Dynamischer Inhalt",
"Allow to post comments as Anonymous" => "Unbekannte Benutzer d&uuml;rfen kommentieren",
"Automonospaced text" => "Blockschrift durch Einr&uuml;cken",
"Tables syntax" => "Tabellensyntax",
"AutoLinks" => "URLs in Links verwandeln",
"Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Quote-PlugIn statt &ldquo;&gt;&rdquo; Zitierung verwenden",
"rows" => "Zeilen",
"Required" => "Erforderlich",
"Parameters" => "Parameter",
"Encoding" => "Formatierung",
"To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "Tracker konfigurieren &uuml;ber Men&uuml;punkt 'Tracker verwalten' unter 'Tracker' im Seitenbalken oder",
"Trackers with mirror tables" => "Tracker mit Mirror Tabellen",
"Use trackers with mirror tables" => "Tracker mit Mirror Tabellen benutzen",
"Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Die Werte f&uuml;r jeden Tracker werden in der separaten Tabelle gespeichert, diese k&ouml;nnen ausserhalb von Tiki angepasst werden.",
"Validate choice" => "Auswahl &uuml;berpr&uuml;fen",
"dls" => "DLs",
"Storage" => "Speicher",
"Change all to db" => "Alle auf Datenbank umstellen",
"Change all to file" => "Alle auf Datei umstellen",
"Quota (Mb)" => "Quota (MB)",
"Use database to store userfiles" => "Benutzer-Dateien in Datenbank speichern",
"Use a directory to store userfiles" => "Benutzer-Daten in Verzeichnis ablegen",
"Allow viewing HTML mails?" => "Anzeigen von HTML Mails erlauben?",
"Maximum size for each attachment" => "Maximale Gr&ouml;&szlig;e pro Anlage",
"Unlimited" => "unbegrenzt",
"Create New" => "Erstelle neu",
"Output" => "Ausgabe",
"Home page" => "Startseite",
"Individual cache" => "Individuelle Cache",
"Content templates" => "Inhaltsvorlagen",
"Warn on edit conflict" => "Bei Bearbeiten-Konflikt warnen",
"Undo" => "R&uuml;ckg&auml;ngig",
"Footnotes" => "Fu&szlig;noten",
"Permission" => "Berechtigung",
"Allow HTML" => "HTML erlauben",
"Manage attachments" => "Anh&auml;nge verwalten",
"Dumps" => "Datenbankabz&uuml;ge",
"Generate dump" => "Datenbankabzug erzeugen",
"Download last dump" => "Letzten Datenbankabzug downloaden",
"Pictures" => "Bilder",
"Remove unused pictures" => "Entferne unbenutzte Bilder",
"Export" => "Exportieren",
"Export Wiki Pages" => "Exportiere Wiki-Seiten",
"Accept dashes and underscores in WikiWords" => "Binde- und Unterstriche in WikiWords erlauben",
"Link plural WikiWords to their singular forms" => "Mehrzahl-WikiWords auf ihre Einzahl-Variante verlinken",
"Side-by-side diff" => "Side-By-Side Vergleich",
"Side-by-side diff by characters" => "Side-By-Side Vergleich nach Zeichen",
"Inline diff" => "Zeilenvergleich",
"Inline diff by characters" => "Zeilenvergleich nach Zeichen",
"Full side-by-side diff by characters" => "Kompletter Side-By-Side Vergleich nach Zeichen",
"Full inline diff" => "Kompletter Zeilenvergleich",
"Full inline diff by characters" => "Kompletter Zeilenvergleich nach Zeichen",
"Discuss pages on forums" => "Seiten im Forum diskutieren",
"View source" => "Quelltext ansehen",
"Similar" => "&auml;hnlich",
"Structures" => "Strukturen",
"Open page as structure" => "Seite als Struktur &ouml;ffnen",
"Import HTML" => "HTML importieren",
"Page creators are admin of their pages" => "Ersteller sind auch Verwalter ihrer Seiten",
"MultiPrint" => "Mehrfachdruck",
"Create watch for author on page creation" => "Beobachtungspunkt f&uuml;r Seite beim Erstellen setzen",
"Enable watch events when I am the editor" => "Beobachtungspunkt f&uuml;r Seite beim &Auml;ndern setzen",
"Enable watches on comments" => "Beobachtungspunkte auf Kommentare aktivieren",
"List pages" => "Seiten auflisten",
"Categories path" => "Kategorie-Pfad",
"Wiki attachments" => "Wiki-Anh&auml;nge",
"... and is displayed by default" => "... und wird standardm&auml;&szlig;ig angezeigt",
"Restore defaults" => "Standardeinstellungen wiederherstellen",
"Crosslinks to other features and settings" => "Querverweise zu anderen Einstellungen",
"Other sections" => "Andere Bereiche",
"Contact us" => "Kontaktiere uns",
"Administration features" => "Grundlegende Konfiguration",
"Security" => "Sicherheit",
"Transversal features" => "&Uuml;bergeordnete Einstellungen",
"which apply to more than one section" => "die sich auf mehr als einen Bereich auswirken",
"Navigation features" => "Navigation",
"Look &amp; feel" => "Look &amp; Feel",
"themes" => "Themes",
"Text area features" => "Einstellungen f&uuml;r Inhalte",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "Einstellungen, die f&uuml;r Wikiseiten, Blogs, Artikeln, Foren etc. gelten",
"Stats &amp; banners" => "Statistiken &amp; Banner",
"Report" => "Protokoll",
"Setting" => "Einstellung",
"Category:" => "Kategorie",
"bytes" => "Bytes",
"kb" => "KB",
"contribution" => "Mitwirkung",
"contributor" => "Mitwirkender",
"Statistics" => "Statistiken",
"connection time" => "Verbindungszeit",
"connection seconds" => "Verbindungssekunden",
"Weeks" => "Wochen",
"recorded" => "gespeichert",
"viewed" => "angesehen",
"Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki Seiten &Auml;nderungen werden bis auf 'betrachtet' gespeichert, k&ouml;nnen aber nicht protokolliert werden.",
"Add or edit a rule" => "Regel hinzuf&uuml;gen/bearbeiten",
"Rule title" => "Regelbezeichnung",
"Username regex matching" => "Benutzername-basiert (regex)",
"IP regex matching" => "IP-basiert (regex)",
"Banned from sections" => "Aus diesen Bereichen bannen",
"Rule activated by dates" => "Sperrung &uuml;ber Zeitraum",
"Rule active from" => "Regel g&uuml;ltig von",
"Rule active until" => "Regel g&uuml;ltig bis",
"Custom message to the user" => "Spezielle Nachricht f&uuml;r den Benutzer",
"Rules" => "Regeln",
"x" => "X",
"User/IP" => "Benutzername/IP",
"Sections" => "Bereiche",
"Admin Calendars" => "Kalender verwalten",
"List of Calendars" => "Liste der Kalender",
"Edit Calendar" => "Kalender bearbeiten",
"Loc" => "Ort",
"Participants" => "Teilnehmer",
"Cat" => "Kateg.",
"Lang" => "Sprache",
"Url" => "URL",
"Subscription" => "Abonnement",
"Custom Locations" => "Pers&ouml;nliche &Ouml;rtlichkeiten",
"Custom Participants" => "Pers&ouml;nliche Teinehmer",
"Custom Categories" => "Pers&ouml;nliche Kategorien",
"Custom Languages" => "Pers&ouml;nliche Sprache",
"Custom Subscription List" => "Pers&ouml;nliche Abo-Liste",
"Custom Priorities" => "Pers&ouml;nliche Priorit&auml;ten",
"Personal Calendar" => "Pers&ouml;nlicher Kalender",
"Start of day" => "Starttag",
"Red" => "Rot",
"Custom foreground color" => "Benutzerdefinierte Vordergrundfarbe",
"Custom background color" => "Benutzerdefinierte Hintergrundfarbe",
"Current category" => "Aktuelle Kategorie",
"Child categories" => "Unterkategorien",
"Edit permissions for this category" => "Berechtigungen dieser Kategorie &auml;ndern",
"Edit this category:" => "Diese Kategorie bearbeiten:",
"Add new category" => "Neue Kategorie hinzuf&uuml;gen",
"Assign permissions automatically" => "Berechtigungen automatisch vergeben",
"recommended for best performance" => "empfohlen f&uuml;r beste Performance",
"Objects in category" => "Objekte in Kategorie",
"Remove from this Category" => "aus dieser Kategorie entfernen",
"No records found." => "Keine Eintr&auml;ge gefunden.",
"Add objects to category" => "Objekte zu Kategorie hinzuf&uuml;gen",
"image gal" => "Bildergalerie",
"file gal" => "Dateiarchiv",
"Admin chart items" => "Eintr&auml;ge in Hitlisten verwalten",
"Edit Chart" => "Hitliste bearbeiten",
"Add or edit an item" => "Eintrag hinzuf&uuml;gen/bearbeiten",
"Update" => "Aktualisieren",
"Chart items" => "Eintr&auml;ge in Hitlisten",
"No items defined yet" => "Noch keine Eintr&auml;ge vorhanden",
"Admin charts" => "Hitlisten verwalten",
"Add or edit a chart" => "Hitliste hinzuf&uuml;gen/bearbeiten",
"Active" => "aktiv",
"Users can vote for only one item from this chart per period" => "Benutzer k&ouml;nnen nur f&uuml;r einen Eintrag pro Abstimmungszeitraum stimmen",
"Prevent users from voting for the same item more than once" => "Benutzer k&ouml;nnen nur einmal &uuml;berhaupt pro Hitliste abstimmen",
"Users can suggest new items" => "Benutzer k&ouml;nnen neue Eintr&auml;ge vorschlagen",
"Auto validate user suggestions" => "Vorschl&auml;ge der Benutzer automatisch validieren",
"Ranking shows" => "Rangliste zeigt",
"All items" => "Alle Eintr&auml;ge",
"Top 10 items" => "Top 10 Eintr&auml;ge",
"Top 20 items" => "Top 20 Eintr&auml;ge",
"Top 40 items" => "Top 40 Eintr&auml;ge",
"Top 50 items" => "Top 50 Eintr&auml;ge",
"Top 100 items" => "Top 100 Eintr&auml;ge",
"Top 250 items" => "Top 250 Eintr&auml;ge",
"Voting system" => "Wahlsystem",
"Vote items" => "Eintr&auml;ge w&auml;hlen",
"Rank 1..5" => "Rang 1..5 vergeben",
"Rank 1..10" => "Rang 1..10 vergeben",
"Ranking frequency" => "Wahlh&auml;ufigkeit",
"Realtime" => "Echtzeit",
"Each 5 minutes" => "alle 5 Minuten",
"Daily" => "t&auml;glich",
"Weekly" => "w&ouml;chentlich",
"Monthly" => "monatlich",
"Show Average" => "Zeige Durchschnitt",
"Show Votes" => "Zeige Stimmen",
"Use Cookies for unregistered users" => "Bei nicht angemeldeten Benutzern Cookies verwenden",
"Users can vote again after" => "Benutzer k&ouml;nnen erneut abstimmen nach",
"Anytime" => "jederzeit",
"Ranks" => "R&auml;nge",
"No charts defined yet" => "Noch keine Hitlisten definiert",
"Admin templates" => "Vorlagen verwalten",
"Edit this template:" => "Dieses Template bearbeiten:",
"Create new template" => "Neue Vorlage erstellen",
"Use wysiwyg editor" => "WYSIWYG Editor benutzen",
"Use normal editor" => "Standardeditor benutzen",
"CMS" => "Artikel",
"Templates" => "Vorlagen",
"Admin Contributions" => "Beteiligungslisten verwalten",
"Settings" => "Einstellungen",
"Contributions are mandatory in wiki pages" => "Auswahl bei Wikiseiten verbindlich",
"Contributions are mandatory in forums" => "Auswahl bei Foreneintr&auml;gen verbindlich",
"Contributions are mandatory in comments" => "Auswahl bei Kommentaren verbindlich",
"Contributions are mandatory in blogs" => "Auswahl bei Blogeintr&auml;gen verbindlich",
"Contributions are displayed in the comment/post" => "Beteiligung wird in Kommentar/Beitrag angezeigt",
"Create a new contribution" => "Neue Beteiligungsliste erstellen",
"List of contributions" => "&Uuml;bersicht der Beteiligungslisten",
"Admin cookies" => "Cookies verwalten",
"Create/edit cookies" => "Cookies hinzuf&uuml;gen/bearbeiten",
"Upload Cookies from textfile" => "Cookies aus Textdatei hochladen",
"Upload from disk:" => "Hochladen von Disk:",
"Upload" => "Hochladen",
"Remove all cookies" => "Alle Cookies l&ouml;schen",
"cookie" => "Cookie",
"Admin drawings" => "Zeichnungen verwalten",
"Available drawings" => "Verf&uuml;gbare Zeichnungen",
"Ver" => "Version",
"Create/edit dsn" => "DSN hinzuf&uuml;gen/bearbeiten",
"Admin external wikis" => "Externe Wikis verwalten",
"View template" => "Vorlage betrachten",
"Edit template" => "Vorlage bearbeiten",
"Create/Edit External Wiki" => "Externes Wiki erstellen/bearbeiten",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (\$page benutzen und mit dem Wiki Seitennamen ersetzen, z.B.: http://qum74.mms-dresden.telekom.de/tiki/tiki-index.php?page=\$page)",
"ExtWiki" => "externes Wiki",
"Admin Forums" => "Foren verwalten",
"Create new forum" => "Neues Forum anlegen",
"Duplicate forum" => "Forum kopieren",
"List forums" => "Foren auflisten",
"Edit this Forum:" => "Dieses Forum bearbeiten:",
"Create New Forum" => "Neues Forum erstellen",
"There are individual permissions set for this forum" => "F&uuml;r dieses Forum sind individuelle Rechte gesetzt",
"Prevent flooding" => "Flooding verhindern",
"Minimum time between posts" => "Minimale Zeit zwischen Posts",
"Section" => "Bereich",
"Create new" => "Erstelle neu",
"Moderator user" => "Moderator",
"Moderator group" => "Moderator-Gruppe",
"Password protected" => "mit Passwort gesichert",
"Topics only" => "nur Themen",
"All posts" => "Alle Postings",
"Forum password" => "Foren-Passwort",
"Send this forums posts to this email" => "Postings in dieses Forum an eMail-Adresse weiterleiten",
"Prune unreplied messages after" => "Nicht beantwortete Nachrichten l&ouml;schen nach",
"Prune old messages after" => "Alte Nachrichten l&ouml;schen nach",
"Topic list configuration" => "Einstellungen Themenliste",
"Posts can be rated" => "Eintr&auml;ge d&uuml;rfen bewertet werden",
"Display last post titles" => "Neueste Beitragstitel anzeigen",
"no display" => "keine Anzeige",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Nachrichten in dieses Forum an die angegebene eMail-Adresse weiterleiten in einem Format, das R&uuml;ckantworten ins Forum erlaubt",
"Send mails even when the post is generated by inbound mail" => "Nachrichten auch schicken, wenn das Posting per eMail get&auml;tigt wurde",
"Append a reply link to outbound mails" => "Antwort-Link an ausgehende Nachrichten anh&auml;ngen",
"Originating e-mail address for mails from this forum" => "Absenderadresse f&uuml;r Nachrichten aus diesem Forum",
"Add messages from this email to the forum" => "Nachrichten von dieser eMail-Adresse in das Forum weiterleiten",
"POP3 server" => "POP3 Server",
"Use topic smileys" => "Smilies f&uuml;r Themen benutzen",
"Show topic summary" => "Themenzusammenfassung anzeigen",
"User information display" => "Benutzer-Informationen anzeigen",
"Approval type" => "Best&auml;tigung n&ouml;tig f&uuml;r",
"All posted" => "keine Nachricht",
"Queue anonymous posts" => "anonyme Nachrichten",
"Queue all posts" => "alle Nachrichten",
"No attachments" => "keine Anh&auml;nge",
"Everybody can attach" => "jeder darf Dateien anh&auml;ngen",
"Only users with attach permission" => "nur Benutzer mit Anhangserlaubnis",
"Moderators and admin can attach" => "nur Moderatoren und Admins",
"Store attachments in:" => "Anh&auml;nge speichern in:",
"Database" => "Datenbank",
"Max attachment size (bytes)" => "Maximale Gr&ouml;&szlig;e (Bytes)",
"hide topics preferences" => "Themeneinstellungen verstecken",
"Default ordering for topics" => "Standardsortierung f&uuml;r Themen",
"Date (desc)" => "Datum (abst.)",
"Date (asc)" => "Datum (aufst.)",
"Score (desc)" => "Score (abst.)",
"Replies (desc)" => "Antworten (abst.)",
"Reads (desc)" => "Zugriffe (abst.)",
"Topics per page" => "Themen pro Seite",
"hide threads preferences" => "Thread-Einstellungen verstecken",
"Default ordering for threads" => "Standardsortierung f&uuml;r Threads",
"Duplicate" => "Dopplung",
"Coms" => "Kommentare",
"Age" => "Alter",
"PPD" => "PPT",
"Admin Hotwords" => "Hotwords verwalten",
"Add Hotword" => "Hotword hinzuf&uuml;gen",
"Word" => "Wort",
"Admin HTML pages" => "HTML-Seiten verwalten",
"Edit this page" => "&Auml;ndere diese Seite",
"View page" => "Seite anzeigen",
"Edit zone" => "Bereiche bearbeiten",
"Dynamic zones" => "Dynamische Bereiche",
"zone" => "Bereich",
"content" => "Inhalt",
"Mass update" => "Massenaktualisierung",
"Create new HTML page" => "Neue HTML-Seite erstellen",
"Edit this HTML page:" => "Diese HTML-Seite bearbeiten:",
"Apply template" => "Vorlage anwenden",
"Dynamic" => "Dynamisch",
"Static" => "Statisch",
"Last Modif" => "Letzte &Auml;nderung",
"Edit Repository:" => "Repository bearbeiten:",
"Create New Repository" => "Neues Repository erstellen",
"List Repositories" => "Repositories auflisten",
"New Repository" => "Neues Repository",
"View Repository" => "Repository anschauen",
"File name of start page" => "Dateiname der Startseite",
"Start page" => "Startseite",
"CSS file" => "CSS-Datei",
"Cacheable" => "cachebar",
"Clear cache" => "Cache leeren",
"Cache expiration" => "Cache Verfallszeit",
"Available Repositories" => "Vorhandene Repositories",
"CSS File" => "CSS-Datei",
"Edit rules" => "Regeln bearbeiten",
"Edit Rules for Repository:" => "Regeln &auml;ndern f&uuml;r Repository:",
"Configure Repositories" => "Repositories konfigurieren",
"Configure this Repository" => "Dieses Repository konfigurieren",
"View this Repository" => "Repository ansehen",
"New Rule" => "Neue Regeln",
"Copy Rules" => "Regeln kopieren",
"Copy" => "Kopieren",
"Rule order" => "Reihenfolge der Regeln",
"Text to search for" => "Zu suchender Text",
"Text to replace" => "Zu ersetzender Text",
"Regex modifiers" => "Regex bearbeiten",
"Enabled" => "Aktiviert",
"Preview options" => "Vorschau-Einstellungen",
"Apply all rules" => "Alle Regeln anwenden",
"Code preview" => "Code-Vorschau",
"Generate HTML preview" => "HTML-Vorschau erstellen",
"HTML preview" => "HTML-Vorschau",
"Preview Results" => "Vorschau der Ergebnisse",
"Rules List" => "Regelliste",
"Admin layout" => "Layout verwalten",
"Theme control" => "Theme-Konfiguration",
"layout options" => "Layout Optionen",
"Generate positions by hits" => "Positionen nach Zugriffen vergeben",
"List of featured links" => "Liste vorhandener Linktips",
"Add Featured Link" => "Linktip hinzuf&uuml;gen",
"Edit this Featured Link:" => "Diesen Linktip bearbeiten:",
"Create new Featured Link" => "Neuen Linktip anlegen",
"disables the link" => "deaktiviert den Link",
"Link type" => "Linktyp",
"replace current page" => "Aktuelle Seite ersetzen",
"framed" => "umrahmt",
"open new window" => "Neues Fenster &ouml;ffnen",
"Mail-in accounts" => "Mail-in Accounts",
"Account" => "Konto",
"Add new Mail-in account" => "Mail-in Account erstellen",
"Edit Mail-in account" => "Mail-in Account bearbeiten",
"Account name" => "Account-Name",
"POP server" => "POP-Server",
"SMTP server" => "SMTP-Server",
"SMTP requires authentication" => "SMTP ben&ouml;tigt Authentifizierung",
"Article Topic" => "Artikel-Thema",
"Admin Topics" => "Themen verwalten",
"Article Type" => "Artikel-Typ",
"Admin Types" => "Typen verwalten",
"Allow anonymous acces" => "Anonymen Zugriff erlauben",
"Allow attachments" => "Anh&auml;nge erlauben",
"Discard to the end from" => "Verwerfen bis zum",
"Check Mail-in accounts" => "Mail-in Accounts &uuml;berpr&uuml;fen",
"Check automatically" => "Automatisch &uuml;berpr&uuml;fen",
"Frequency" => "Frequenz",
"mn" => "min",
"List menus" => "Men&uuml;s auflisten",
"Edit this menu" => "Dieses Men&uuml; bearbeiten",
"Edit menu options" => "Men&uuml;optionen bearbeiten",
"Show Quick Urls" => "Quick URLs anzeigen",
"Some useful URLs" => "Einige n&uuml;tzliche URLs",
"Hide Quick Urls" => "Quick URLs verstecken",
"option" => "Option",
"section level 0" => "Bereich Ebene 0",
"section level 1" => "Bereich Ebene 1",
"section level 2" => "Bereich Ebene 2",
"section level 3" => "Bereich Ebene 3",
"separator" => "Trennlinie",
"Choose" => "Ausw&auml;hlen",
"Home Blog" => "Home-Blog",
"Home Image Gal" => "Home-BilderGal",
"Home Image Gallery" => "Home-Bildergalerie",
"Home File Gal" => "Home-Dateiarchiv",
"Home File Gallery" => "Home-Dateiarchiv",
"User preferences" => "Benutzereinstellungen",
"User prefs" => "Benutzereinstellungen",
"List galleries" => "Galerien auflisten",
"List image galleries" => "Bildergalerien auflisten",
"Upload image" => "Bild hochladen",
"Gallery Rankings" => "Galerie-Bewertungen",
"Browse a gallery" => "Galerie ansehen",
"Articles home" => "Artikel-Home",
"All articles" => "Alle Artikel",
"Submit" => "Abschicken",
"List Blogs" => "Blogs auflisten",
"Create blog" => "Blog erstellen",
"File galleries" => "Dateiarchive",
"View a forum" => "Forum ansehen",
"View a thread" => "Thread ansehen",
"View a FAQ" => "Eine FAQ ansehen",
"Take a quiz" => "Ein Quiz durchf&uuml;hren",
"Quiz stats" => "Quiz-Statistik",
"Stats for a Quiz" => "Statistik f&uuml;r ein Quiz",
"Preview menu" => "Vorschau des Men&uuml;s",
"Menu options" => "Men&uuml;optionen",
"Edit this Menu:" => "Dieses Men&uuml; bearbeiten:",
"Create new Menu" => "Neues Men&uuml; erstellen",
"dynamic collapsed" => "Dynamisch eingeklappt",
"dynamic extended" => "Dynamisch ausgeklappt",
"fixed" => "fest",
"Options" => "Optionen",
"Active Permissions" => "aktive Berechtigungen",
"Clear Cache" => "Cache leeren",
"User Modules" => "Benutzer-Module",
"Assigned Modules" => "Zugewiesene Module",
"Left Modules" => "Module links",
"Rows" => "Zeilen",
"Move to Right Column" => "In die rechte Spalte verschieben",
"Unassign" => "Zuordnung aufheben",
"Right Modules" => "Module rechts",
"Move to Left Column" => "In die linke Spalte verschieben",
"Assign new module" => "Neues Modul hinzuf&uuml;gen",
"Edit this assigned module:" => "Dieses zugewiesene Modul bearbeiten:",
"Cache Time" => "Cache-Zeit",
"Visibility" => "Sichtbarkeit",
"Displayed now for all eligible users even with personal assigned modules" => "Sichtbar f&uuml;r alle Benutzer, auch die mit pers&ouml;nlicher Modul-Konfiguration",
"Displayed for the eligible users with no personal assigned modules" => "Sichtbar f&uuml;r Benutzer ohne pers&ouml;nliche Modul-Konfiguration",
"Displayed now, can't be unassigned" => "Immer anzeigen, kann nicht wegkonfiguriert werden",
"Not displayed until a user chooses it" => "Nicht anzeigen bis der Benutzer es hinzukonfiguriert",
"Create new user module" => "Neues Benutzer-Modul erstellen",
"Edit this user module:" => "Dieses Benutzer-Modul bearbeiten:",
"Must be wiki parsed" => "Wiki Parser anwenden",
"Objects that can be included" => "Objekte, die eingebunden werden k&ouml;nnen",
"Available polls" => "Verf&uuml;gbare Abstimmungen",
"Random active poll" => "Zuf&auml;llige aktive Umfrage",
"Random current poll" => "Zuf&auml;llige aktuelle Umfrage",
"Use Poll" => "Abstimmung benutzen",
"Random image from" => "Zuf&auml;lliges Bild aus",
"Use Gallery" => "Galerie benutzen",
"Dynamic content blocks" => "Dynamische Inhaltsbl&ouml;cke",
"Use Dynamic Content" => "Dynamischen Inhaltsblock benutzen",
"Use RSS Module" => "RSS-Modul benutzen",
"Use Menu" => "Men&uuml; benutzen",
"phpLayersMenus" => "phpLayerMen&uuml;s",
"Use phplayermenu" => "PHPLayerMen&uuml; benutzen",
"Banner zones" => "Bannerzonen",
"Use Banner Zone" => "Bannerzone benutzen",
"Data" => "Daten",
"Admin newsletter subscriptions" => "Newsletter-Abonnenten verwalten",
"List Newsletters" => "Newsletter auflisten",
"Admin Newsletters" => "Newsletter verwalten",
"Send Newsletters" => "Newsletter versenden",
"Add a subscription newsletters" => "Abo f&uuml;r Newsletter hinzuf&uuml;gen",
"Add email:" => "eMail hinzuf&uuml;gen:",
"Add user:" => "Benutzer hinzuf&uuml;gen:",
"Group users" => "Benutzergruppen",
"Subscribe group" => "Registrierungsgruppen",
"Subscriptions" => "Registrierungen",
"Valid" => "G&uuml;ltig",
"Subscribed" => "abonniert",
"Admin newsletters" => "Newsletter verwalten",
"There are individual permissions set for this newsletter" => "Es existieren individuelle Berechtigungen f&uuml;r diesen Newsletter",
"Users can subscribe/unsubscribe to this list" => "Benutzer k&ouml;nnen sich f&uuml;r diese Liste an/abmelden",
"Users can subscribe any email address" => "Benutzer k&ouml;nnen beliebige eMail-Adressen eintragen",
"Add unsubscribe instructions to each newsletter" => "Hinweise zur Abmeldung von der Liste an jeden Newsletter anh&auml;ngen",
"Validate email addresses" => "eMail-Adressen &uuml;berpr&uuml;fen",
"Editions" => "Ausgaben",
"Last Sent" => "Zuletzt gesendet",
"Mail notifications" => "eMail-Benachrichtigungen",
"Add notification" => "Benachrichtigung hinzuf&uuml;gen",
"Event" => "Ereignis",
"A user registers" => "Ein Benutzer registriert sich",
"A user submits an article" => "Ein Benutzer reicht einen Artikel ein",
"Any wiki page is changed" => "Eine Wiki-Seite hat sich ge&auml;ndert",
"Any wiki page is changed, even minor changes" => "Eine Wiki-Seite hat sich ge&auml;ndert, auch kleine &Auml;nderungen",
"A comment in a wiki page is posted or edited" => "Kommentar zu einer Wikiseite wird erstellt oder ge&auml;ndert",
"PHP error" => "PHP Fehler",
"Email:" => "eMail:",
"List polls" => "Abstimmungen auflisten",
"Edit this poll" => "Diese Abstimmung bearbeiten",
"Preview poll" => "Vorschau der Abstimmung",
"Poll options" => "Abstimmungs-Optionen",
"Votes" => "Stimmen",
"Admin Polls" => "Abstimmungen verwalten",
"Set last poll as current" => "Letzte Abstimmung als aktuelle Abstimmung setzen",
"Close all polls but last" => "Alle bis auf die letzte Abstimmung schlie&szlig;en",
"Activate all polls" => "Alle Abstimmungen aktivieren",
"active" => "aktiv",
"current" => "aktuell",
"template" => "Vorlage",
"object" => "Objekt",
"PublishDate" => "DatumVer&ouml;ff.",
"Results" => "Ergebnisse",
"Add poll to pages" => "Abstimmung zur Seite hinzuf&uuml;gen",
"Wiki pages" => "Wiki-Seiten",
"Lock the pages" => "Seiten sperren",
"Admin Quicktags" => "Quicktags verwalten",
"Create/Edit QuickTags" => "QuickTags hinzuf&uuml;gen/bearbeiten",
"Quicktags category filter" => "Quicktags Kategorien filtern",
"Insert (use 'text' for figuring the selection)" => "Einf&uuml;gen ('text' um die Auswahl zu markieren)",
"Path to the tag icon" => "Icon-Pfad",
"Admin RSS Modules" => "RSS-Module verwalten",
"This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "Auf dieser Seite werden die RSS Feeds konfiguriert, die von Tiki gelesen und importiert werden. Zum generieren/exportieren von RSS Feeds \"RSS Feeds\" im Men&uuml; w&auml;hlen oder",
"Content for the feed" => "Inhalt f&uuml;r den Feed",
"show feed title" => "Feed-Titel anzeigen",
"show publish date" => "Ver&ouml;ffentlichungsdatum anzeigen",
"PHP settings" => "PHP Einstellungen",
"PHP variable" => "PHP Variable",
"Risk Factor" => "Risikofaktor",
"Explanation" => "Erkl&auml;rung",
"Tiki variable" => "Tiki Variable",
"Check all tiki files" => "Alle Tiki-Dateien &uuml;berpr&uuml;fen",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Achtung, dies kann viel Zeit in Anspruch nehmen. Der Parameter max_execution_time setting in der php.ini sollte entsprechend hoch sein, damit das Script nicht abbricht.",
"Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Bemerkung: Sicherheitsdaten werden nur &uuml;ber den Installationsvorgang importiert (<a href=\"tiki-install.php\">tiki-install.php</a>). Importieren Sie die *secdb* Update Dateien in Ihre Datenbank.",
"File checks" => "Datei-Checks",
"user" => "Benutzer",
"group" => "Gruppe",
"Admin Shoutbox Words" => "Shoutbox Words Verwaltung",
"Add Banned Word" => "Nicht erlaubtes Wort eintragen",
"Are you sure you want to delete this word?" => "Soll das Wort wirklich gel&ouml;scht werden?",
"You will remove structure" => "Sie wollen die Struktur entfernen",
"Destroy the structure leaving the wiki pages" => "Nur Struktur entfernen",
"Destroy the structure and remove the pages" => "Struktur und Seiten entfernen",
"Export Pages" => "Seiten exportieren",
"Dump Tree" => "Baum ausgeben",
"Create new structure" => "Neue Struktur anlegen",
"Alias" => "alternativer Name",
"Tree" => "Baum",
"Use single spaces to indent structure levels" => "Strukturelevel durch Einr&uuml;cken (einzelne Leerzeichen) definieren",
"Create New Structure" => "Neue Struktur anlegen",
"List surveys" => "Umfragen auflisten",
"Survey Stats" => "Umfragen-Statistik",
"Edit this Survey" => "Diese Umfrage bearbeiten",
"Admin Surveys" => "Umfragen verwalten",
"Question" => "Frage",
"One choice" => "Eine Auswahl",
"Multiple choices" => "Multiple Auswahlen",
"Short text" => "Kurzbeschreibung",
"Rate (1..5)" => "Bewerte (1..5)",
"Rate (1..10)" => "Bewerte (1..10)",
"Rate" => "Bewerten",
"For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "Bei Fragen mit mehreren m&ouml;glichen Antworten diese im folgenden Feld kommagetrennt eingeben",
"Options (if apply)" => "Optionen (falls n&ouml;tig)",
"Questions" => "Fragen",
"Admin surveys" => "Umfragen verwalten",
"List Surveys" => "Umfragen auflisten",
"Edit this Survey:" => "Diese Umfrage bearbeiten:",
"Create New Survey" => "Neue Unfrage erstellen",
"There are individual permissions set for this survey" => "F&uuml;r diese Umfrage sind individuelle Berechtigungen gesetzt",
"Open" => "Offen",
"Exterminator of cached content" => "l&ouml;schen der zwischengespeicherten Inhalte",
"Empty" => "Leeren",
"Directories to save" => "Verzeichnisse zum Speichern",
"Templates compiler" => "Template Compiler",
"Compile" => "Kompilieren",
"Advanced feature" => "Funktion f&uuml;r Fortgeschrittene",
"Fix UTF-8 Errors in Tables" => "UTF-8 Fehler in Tabellen korrigieren",
"Warning: Make a backup of your Database before using this function!" => "Warnung: Erstellen Sie ein Datenbank Backup bevor Sie diese Funktion benutzen!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Warnung: Wenn Sie grosse Tabellen konvertieren wollen, erh&ouml;hen Sie die maximum execution time in Ihrer php.ini!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Diese Funktion konvertiert ISO-8859-1 codierte Strings in UTF-8",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Notwendig, wenn Sie mit Tiki &lt; v1.8.4 und ISO-8859-1 Codierung gearbeitet haben.",
"UTF-8 Errors fixed" => "UTF-8 Fehler korrigieren",
"Investigate" => "Untersuchen",
"Fix it" => "Korrigieren",
"Create a new topic" => "Neues Thema erstellen",
"Topic Name" => "Themenname",
"Upload Image" => "Bild hochladen",
"List of topics" => "Themenliste",
"Articles (subs)" => "Artikel (eingereicht)",
"topic image" => "Themenlogo",
"Deactivate" => "Deaktivieren",
"Active - Click to Deactivate" => "Aktiviert - klicken zum deaktivieren",
"Remove with articles" => "Typ und zugeh&ouml;rige Artikel l&ouml;schen",
"List Trackers" => "Tracker auflisten",
"Admin Trackers" => "Tracker verwalten",
"Edit This Tracker" => "Diesen Tracker bearbeiten",
"View This Tracker's Items" => "Eintr&auml;ge dieses Trackers ansehen",
"Edit tracker field" => "Tracker-Felder bearbeiten",
"Is column visible when listing tracker items?" => "Ist Spalte beim Auflisten von Tracker-Eintr&auml;gen sichtbar?",
"Column links to edit/view item?" => "Links in Spalten zum Editiere/Betrachten von Eintr&auml;gen?",
"Column is searchable?" => "Spalte durchsuchbar?",
"not hidden" => "nicht verstecken",
"visible to admin only" => "nur f&uuml;r Admin sichtbar",
"Field is mandatory?" => "Pflichtfeld?",
"Tracker fields" => "Tracker-Felder",
"isMain" => "Hauptfeld",
"Tbl vis" => "in Liste",
"Searchable" => "Durchsuchbar",
"Hidden" => "Versteckt",
"Mandatory" => "Pflicht",
"Import/Export Trackers Fields" => "Tracker-Felder importieren/exportieren",
"Edit This Tracker's Fields" => "Felder des Trackers bearbeiten",
"Create Tracker" => "Tracker anlegen",
"Duplicate Tracker" => "Tracker kopieren",
"Found" => "Fand",
"trackers" => "Tracker",
"with" => "weite",
"There are individual permissions set for this tracker" => "F&uuml;r diesen Tracker sind individuelle Berechtigungen gesetzt",
"No individual permissions. Global permissions apply." => "Keine individuellen Berechtigungen, globale Berechtigungen gelten",
"Auto create corresponding categories" => "automatisch zugeh&ouml;rige Kategorie erstellen",
"Show status" => "Zeige Status",
"Default status displayed in list mode" => "Stati, die in der Listenanzeige ausgegeben werden sollen",
"Show status to tracker admin only" => "Status nur dem Tracker-Admin zeigen",
"Send copies of all activity in this tracker to this e-mail address" => "Kopien aller Aktivit&auml;ten dieses Trackers an diese eMail-Adresse schicken",
"Use simplified e-mail format" => "Vereinfachtes eMail-Format benutzen",
"New items are created with status" => "Status neuer Eintr&auml;ge",
"Authoritative status for modified items" => "Authoritiver Status des Trackers wird beim &Auml;ndern des Trackers gesetzt auf",
"No change" => "keine &Auml;nderung",
"Item creator can modify his items?" => "Ersteller kann Eintr&auml;ge &auml;ndern?",
"The tracker needs a user field with the option 1" => "Der Tracker mu&szlig; ein Benutzerfeld mit der Option 1 besitzen",
"Member of the default group of creator can modify items?" => "Mitglieder aus der Standardgruppe des Erstellers d&uuml;rfen Eintr&auml;ge &auml;ndern?",
"The tracker needs a group field with the option 1" => "Der Tracker mu&szlig; ein Gruppenfeld mit der Option 1 besitzen",
"Show creation date when listing tracker items?" => "Erstellungsdatum beim Auflisten von Tracker-Eintr&auml;gen anzeigen?",
"Show lastModif date when listing tracker items?" => "&Auml;nderungsdatum beim Auflisten von Tracker-Eintr&auml;gen anzeigen?",
"What field is used for default sort?" => "Standardfeld f&uuml;r Sortierung",
"What is default sort order in list?" => "Standardsortierung",
"Tracker items allow ratings?" => "Bewertung von Tracker-Eintr&auml;gen erlauben?",
"with values" => "mit den Werten",
"and display rating results in listing?" => "und Bewertungsergebnisse in Liste anzeigen?",
"Tracker items allow comments?" => "Kommentare zu Tracker-Eintr&auml;gen zulassen?",
"and display comments in listing?" => "und Kommentare in Liste anzeigen?",
"Tracker items allow attachments?" => "Anlagen zu Tracker-Eintr&auml;gen zulassen?",
"and display attachments in listing?" => "und Anh&auml;nge in Liste anzeigen?",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Darstellungsoptionen f&uuml;r Anh&auml;nge (Nummern zur Sortierung eintragen, 0 versteckt Felder, bei negativen Eintr&auml;gen erscheinen Popups)",
"Filesize" => "Dateigr&ouml;&szlig;e",
"Filetype" => "Dateityp",
"LongDesc" => "Beschreibung",
"Import/export trackers" => "Tracker im-/exportieren",
"Admin groups" => "Gruppen verwalten",
"Admin users" => "Benutzer verwalten",
"Add new group" => "Neue Gruppe hinzuf&uuml;gen",
"Edit group" => "Bearbeite Gruppe",
"Add a New Group" => "Eine neue Gruppe hinzuf&uuml;gen",
"List of existing groups" => "Liste vorhandener Gruppen",
"Includes" => "Beinhaltet",
"Group Homepage" => "Gruppen-Homepage",
"Use wiki page name or full URL" => "Wiki-Seitennamen oder volle URL benutzen",
"Users Information Tracker" => "Tracker Benutzer-Information",
"Edit Item" => "Punkt bearbeiten",
"Members List" => "Mitgliederliste",
"users in group" => "Benutzer und Gruppen",
"Download CSV export" => "CSV-Datei herunterladen",
"CSV File" => "CSV Datei",
"Add a New User" => "Neuen Benutzer hinzuf&uuml;gen",
"Updated users" => "Aktualisierte Benutzer",
"Rejected users" => "Abgelehnte Benutzer",
"Reason" => "Grund",
"Edit user" => "Benutzerdaten bearbeiten",
"More Criteria" => "Erweiterte Suchoptionen",
"Group (direct)" => "Gruppe (direkt)",
"Edit Account Settings" => "Kontoeinstellungen bearbeiten",
"to groups" => "zu Gruppen",
"Change user preferences" => "Benutzereinstellungen &auml;ndern",
"Manage Group Assignments" => "Gruppenzuordnungen bearbeiten",
"Set Default Groups" => "Standardgruppen setzen",
"Assign selected to" => "Markierte hinzuf&uuml;gen zu",
"Remove selected from" => "Markierte l&ouml;schen aus",
"the following groups:" => "den folgenden Gruppen:",
"Tip: Hold down CTRL to select multiple" => "Tip: STRG gedr&uuml;ckt halten f&uuml;r Mehrfachauswahl",
"Set the default group of the selected users to" => "Setzt die Standardgruppe der markierten Benutzer auf",
"bcc" => "BCC",
"Overwrite" => "&Uuml;berschreiben",
"Overwrite but keep the previous login if the login exists in another case" => "&Uuml;berschreibe, aber behalte den vorhergehenden Login wenn der Login in anderer Schreibweise bereits existiert",
"Don't overwrite" => "Nicht &uuml;berschreiben",
"Overwrite groups:" => "Gruppen &uuml;berschreiben:",
"Source" => "Quelle",
"Admin Article Types" => "Artikeltypen verwalten",
"List of types" => "Liste vorhandener Typen",
"Shows up in the drop down list of article types" => "In der Auswahlliste der Typen anzeigen",
"Allow ratings by the author" => "Bewertungen des Autors erlauben",
"Show before publish date" => "Vor dem Ver&ouml;ffentlichungsdatum anzeigen",
"non-admins can view before the publish date" => "Nicht-Admins sehen den Artikel vor dem Ver&ouml;ffentlichungsdatum",
"Show after expire date" => "Nach dem Auslaufdatum anzeigen",
"non-admins can view after the expire date" => "Nicht-Admins sehen den Artikel nach dem Ablaufdatum",
"Heading only" => "nur Kopfteil",
"No article body, heading only" => "Nur den Header ohne den Artikelbody anzeigen",
"Allow comments for this type" => "Kommentare f&uuml;r diesen Typ erlauben",
"Comment Can Rate Article" => "Kommentar darf Artikel bewerten",
"Allow comments to include a rating value" => "Kommentare inklusive Bewertung erlauben",
"Show image" => "Zeige Bild",
"Show topic or own image" => "Thema oder eigenes Bild anzeigen",
"Show avatar" => "Zeige Avatar",
"Show author's avatar" => "Avatar des Autors anzeigen",
"Show author" => "Zeige Autor",
"Show author name" => "Namen des Autors anzeigen",
"Show publish date" => "Zeige Ver&ouml;ffentlichungsdatum",
"Show expire date" => "Zeige Ablaufdatum",
"Show reads" => "Zeige Zugriffe",
"Show the number of times the article was read" => "Anzeigen wie oft der Artikel gelesen wurde",
"Show size" => "Zeige Gr&ouml;&szlig;e",
"Show the size of the article" => "Gr&ouml;&szlig;e des Artikels anzeigen",
"Show topline" => "Introzeile anzeigen",
"Show a small title over the title" => "Kleine Introzeile &uuml;ber der &Uuml;berschrift anzeigen",
"Show subtitle" => "Untertitel anzeigen",
"Show the subtitle" => "Untertitel anzeigen",
"Show source" => "Zeige Quelle",
"Show Image Caption" => "Bildbeschreibung anzeigen",
"Show a legend under the image" => "Legende unter dem Bild anzeigen",
"Show Language" => "Sprache anzeigen",
"Show the language" => "Sprache anzeigen",
"Creator can edit" => "Ersteller kann bearbeiten",
"The person who submits an article of this type can edit it" => "Einreicher dieses Artikeltyps d&uuml;rfen diese Artikel &auml;ndern",
"Show lang" => "Sprache anzeigen",
"Review" => "Rezension",
"Classified" => "Vertraulich",
"Create a new type" => "Neuen Typ anlegen",
"Group Information" => "Gruppeninformationen",
"level" => "Stufe",
"inherited from" => "geeerbt von",
"inherited" => "geerbt",
"Create level" => "Neue Berechtigungsstufe",
"all permissions in level" => "alle Rechte auf Stufe",
"Assign User {\$assign_user} to Groups" => "Benutzer {\$assign_user} zuordnen zu Gruppen",
"Default Group" => "Standardgruppe",
"Assign Perms to this Group" => "Dieser Gruppe Rechte zuweisen",
"Assign User to Group" => "Benutzer der Gruppen zuordnen",
"backlinks to" => "besuchte Links zu",
"Directory batch upload" => "Aus Verzeichnis einlesen",
"Browse Gallery" => "Galerie anzeigen",
"Upload From Disk" => "Hochladen von Disk",
"available images" => "Bilder vorhanden",
"Remove File Extension from Image Name" => "Dateiendung im Namensfeld entfernen",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "z.B. wird von \"digicam0001.jpg\" der Name digicam0001 im Namensfeld benutzt",
"Select a Gallery" => "Ziel-Galerie ausw&auml;hlen",
"Process" => "Prozess",
"Browse File Gallery" => "Dateiarchiv durchsehen",
"Please do not use this feature to upload data into the database." => "Mit dieser Funktion bitte keine Daten in die Datenbank laden.",
"available files" => "verf&uuml;gbare Dateien",
"Select a File Gallery" => "Dateiarchiv ausw&auml;hlen",
"Process files" => "Dateien verarbeiten",
"Edit Post" => "Eintrag bearbeiten",
"View Blog" => "Blog betrachten",
"If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "Falls Sie Bilder benutzen m&ouml;chten speichern Sie bitte den Beitrag und h&auml;ngen Sie dann erst Bilder an. Benutzen Sie das &lt;img&gt; Schnipsel um hochgeladene Bilder einzubinden oder benutzen Sie die Bilder-URL im WYSIWYG-Editor. ",
"Use ...page... to separate pages in a multi-page post" => "Benutze ...page... um den Eintrag in mehrere Seiten zu untergliedern",
"Upload image for this post" => "Bild f&uuml;r diesen Beitrag hochladen",
"Trash" => "M&uuml;ll",
"Mark entry as private:" => "Eintrag als privat kennzeichnen:",
"Spellcheck" => "Rechtschreibpr&uuml;fung",
"Save and Exit" => "Speichern und verlassen",
"Made with" => "Erstellt mit",
"powered by" => "Powered by",
"Execution time" => "Ausf&uuml;hrungszeit",
"Memory usage" => "Speicherverbrauch",
"Server load" => "Serverlast",
"Watch Only This Category" => "Nur diese Kategorie beobachten",
"Watch This Category and Their Descendants" => "Diese Kategorien und deren Nachfolger beobachten",
"Stop Watching Only This Category" => "Nur diese Kategorie nicht mehr beobachten",
"Stop Watching This Category and Their Descendants" => "Diese Kategorie und deren Nachfolger nicht mehr beobachten",
"Admin Category" => "Kategorien verwalten",
"Browse in" => "St&ouml;bern in",
"Trackers Items" => "Tracker Eintr&auml;ge",
"in the current category - and its subcategories: " => "in der aktuellen Kategorie - und in allen Unterkategorien: ",
"Hide subcategories objects" => "Eintr&auml;ge von Unterkategorien verstecken",
"Show subcategories objects" => "Eintr&auml;ge von Unterkategorien anzeigen",
"Clear" => "Zur&uuml;cksetzen",
"results found" => "gefundene Ergebnisse",
"List Galleries" => "Galerien auflisten",
"Edit Gallery" => "Galerie bearbeiten",
"Rebuild Thumbnails" => "Thumbnails neu erzeugen",
"Directory Batch" => "Aus Verzeichnis einlesen",
"List Gallery" => "Galerie als Liste zeigen",
"All Images" => "alle Bilder",
"Monitor this Gallery" => "Galerie beobachten",
"Sort Images by" => "Bilder sortieren nach",
"subgallery" => "Unter-Galerie",
"Subgallery" => "Unter-Galerie",
"Hit" => "Treffer",
"Original Size" => "Originalgr&ouml;&szlig;e",
"rotate right" => "rechts drehen",
"rotate" => "drehen",
"popup" => "Popup",
"You can include the gallery's image in an HTML page using one of these lines" => "Die Bildergalerie kann wie folgt in eine HTML-Seite eingebunden werden",
"You can include the image in a tiki page using one of these lines" => "Das Bild kann mit den folgenden Zeilen in eine Wikiseite eingebunden werden",
"Return to Gallery" => "Zur&uuml;ck zur Galerie",
"Edit Image" => "Bild bearbeiten",
"First Image" => "Erstes Bild",
"Prev Image" => "Vorh. Bild",
"Smaller" => "Kleiner",
"Bigger" => "Gr&ouml;&szlig;er",
"Popup window" => "Popup-Fenser",
"Next Image" => "N&auml;ch. Bild",
"Slideshow Forward" => "Diaschau vorw&auml;rts",
"Last Image" => "Neuestes Bild",
"Direction" => "Schreibrichtung",
"Image Name" => "Bildname",
"Image Scale" => "Bildskalierung",
"Latitude (WGS84/decimal degrees)" => "Breitengrad (WGS84/Grad)",
"Longitude (WGS84/decimal degrees)" => "L&auml;ngengrad (WGS84/Grad)",
"Move image" => "Bild verschieben",
"You can view this image in your browser using" => "Sie k&ouml;nnen dieses Bild in Ihrem Browser betrachten",
"You can include the image in an HTML page using one of these lines" => "Das Bild kann wie folgt in eine HTML-Seite eingebunden werden",
"Stop Monitoring this Page" => "Diese Seite nicht mehr beobachten",
"Monitor this Page" => "Diese Seite beobachten",
"Visible Calendars" => "Kalender anzeigen",
"Group Calendars" => "Gruppenkalender",
"Edit event" => "Ereignis bearbeiten",
"View event" => "Ereignis anzeigen",
"Organized by" => "Organisiert von",
"Tentative" => "Unter Vorbehalt",
"Confirmed" => "Zugesagt",
"Cancelled" => "Abgelehnt",
"Change Focus" => "Hierher wechseln",
"Calendar Item" => "Kalender-Eintrag",
"New event" => "neues Ereignis",
"Edit Calendar Item" => "Kalendereintrag bearbeiten",
"New Calendar Item" => "Neuer Kalender-Eintrag",
"times" => "mal",
"End" => "Ende",
"or new" => "oder neu",
"Roles" => "Rollen",
"default role" => "Standard-Rolle",
"Calendar import" => "Kalender importieren",
"Calendar has been updated" => "Kalender wurde aktualisiert",
"import" => "Import",
"Previous" => "Vorherige",
"%m/%d" => "%d.%m.",
"Assign permissions to category" => "Berechtigungen zuweisen f&uuml;r Kategorie",
"Current permissions for this category" => "Aktuelle Berechtigungen f&uuml;r diese Kategorie",
"Remove from this Category Only" => "Nur von dieser Kategorie entfernen",
"Remove from this Category &amp; all its Children" => "Von dieser und allen Unterkategorien entfernen",
"Perform action with checked" => "Aktion auf alle markierten ausf&uuml;hren",
"Assign permissions" => "Berechtigungen vergeben",
"to group" => "zu Gruppe",
"this category &amp; all its children" => "diese und alle Unterkategorien",
"this category only" => "nur f&uuml;r diese Kategorie",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "f&uuml;r beste Performance werden Berechtigungen f&uuml;r <b>diese und alle Unterkategorien</b> empfohlen",
"Change password enforced" => "Pa&szlig;wortwechsel erzwungen",
"Old password" => "Altes Pa&szlig;wort",
"Send a message to us" => "Schick uns eine Nachricht",
"Contact us by email" => "Kontaktiere uns per eMail",
"Click here to send us an email" => "Hier klicken um uns eine eMail zu schicken",
"Contacts" => "Kontakte",
"Group View" => "Gruppeansicht",
"Create/edit contacts" => "Kontakte hinzuf&uuml;gen/bearbeiten",
"First Name" => "Vorname",
"Last Name" => "Nachname",
"Structure" => "Struktur",
"Top page" => "Top-Seite",
"Tiki Debugger Console" => "Tiki Debug-Konsole",
"Current URL" => "Aktuelle URL",
"Command" => "Befehle",
"exec" => "Ausf&uuml;hren",
"Type <code>help</code> to get list of available commands" => "<code>help</code> f&uuml;r eine Befehls&uuml;bersicht eingeben",
"Add a new site" => "F&uuml;ge neuen Link hinzu",
"You cannot add sites until Directory Categories are setup." => "Links k&ouml;nnen erst hinzugef&uuml;gt werden, wenn Kategorien daf&uuml;r eingerichtet wurden.",
"Please contact the Site Administrator" => "Bitte kontaktieren sie den Administrator der Site.",
"Site added" => "Link hinzugef&uuml;gt",
"Add a site" => "Link hinzuf&uuml;gen",
"Directory Administration" => "Linkverzeichnis verwalten",
"There are" => "Es gibt",
"invalid sites" => "ung&uuml;ltige Links",
"valid sites" => "g&uuml;ltige Links",
"Users have visited" => "Benutzer besuchten",
"sites from the directory" => "Links aus dem Verzeichnis",
"Users have searched" => "Benutzer suchten",
"times from the directory" => "mal im Linkverzeichnis",
"Related" => "Verwandt",
"Validate" => "&uuml;berpr&uuml;fen",
"Admin directory categories" => "Verzeichniskategorien verwalten",
"Add a directory category" => "Verzeichniskategorie hinzuf&uuml;gen",
"Edit this directory category" => "Diese Verzeichniskategorie bearbeiten",
"Children type" => "Kind-Typ",
"Most visited sub-categories" => "Meistbesuchte Unterkategorien",
"Category description" => "Kategorie-Beschreibung",
"Random sub-categories" => "Zuf&auml;llige Unterkategorien",
"Maximum number of children to show" => "Maximalzahl der angezeigten Kinder",
"Editor group" => "Editor-Gruppe",
"allow" => "Erlauben",
"count" => "z&auml;hlen",
"editor" => "Bearbeiter",
"relate" => "verwandt",
"Parent category" => "&Uuml;bergeordnete Kategorie",
"Add a related category" => "Verwandte Kategorie hinzuf&uuml;gen",
"Mutual" => "Gegenseitig",
"Related categories" => "Verwandte Kategorien",
"Admin sites" => "Links verwalten",
"Is valid" => "Ist g&uuml;ltig",
"New Sites" => "Neue Links",
"Cool Sites" => "Coole Links",
"Add a Site" => "Link hinzuf&uuml;gen",
"any" => "irgendeines",
"in entire directory" => "im gesamten Linkverzeichnis",
"Sort by" => "Sortiere nach",
"name (desc)" => "Name (abst.)",
"name (asc)" => "Name (aufst.)",
"hits (desc)" => "Zugriffen (abst.)",
"hits (asc)" => "Zugriffen (aufst.)",
"creation date (desc)" => "Erstelldatum (abst.)",
"creation date (asc)" => "Erstelldatum (aufst.)",
"last updated (desc)" => "letzte &Auml;nderung (abst.)",
"last updated (asc)" => "letzte &Auml;nderung (aufst.)",
"Added" => "Hinzugef&uuml;gt",
"Last updated" => "Zuletzt aktualisiert",
"Total links" => "Links gesamt",
"Links to validate" => "Zu &uuml;berpr&uuml;fende Links",
"Searches performed" => "Durchgef&uuml;hrte Suchauftr&auml;ge",
"Total links visited" => "Besuchte Links gesamt",
"Directory ranking" => "Rang im Verzeichnis",
"Search results" => "Suchergebnisse",
"Validate sites" => "Links &uuml;berpr&uuml;fen",
"Edit article" => "Artikel erstellen/bearbeiten",
"List Articles" => "Artikel auflisten",
"View Articles" => "Beitr&auml;ge ansehen",
"Topline" => "Introzeile",
"Subtitle" => "Untertitel",
"Author Name" => "Autor",
"Own Image" => "Eigenes Bild",
"Article image" => "Artikellogo",
"Use own image" => "Eigenes Bild benutzen",
"Float text around image" => "Text flie&szlig;t um Bilder herum",
"Own image size x" => "Eigene Bildbreite",
"Own image size y" => "Eigene Bildh&ouml;he",
"Image caption" => "Bildbeschreibung",
"Heading" => "Aufmacher",
"Body" => "Text",
"Publish Date" => "Ver&ouml;ffentlichungsdatum",
"Expiration Date" => "Ablaufdatum",
"From:" => "Von:",
"Edit or create banners" => "Banner hinzuf&uuml;gen/bearbeiten",
"List banners" => "Banner anzeigen",
"URL to link the banner" => "URL, die mit dem Banner verkn&uuml;pft wird",
"Client" => "Agent",
"Max impressions" => "Max. Aufrufe",
"Show the banner only between these dates" => "Banner nur w&auml;hrend dieser Tage zeigen",
"From date" => "Von Datum",
"To date" => "Bis Datum",
"Use dates" => "Datum benutzen",
"Show the banner only in this hours" => "Banner nur w&auml;hrend dieser Stunden zeigen",
"to" => "bis",
"Show the banner only on" => "Zeige das Banner nur auf",
"Mon" => "Mo",
"Tue" => "Di",
"Wed" => "Mi",
"Thu" => "Do",
"Fri" => "Fr",
"Sat" => "Sa",
"Sun" => "So",
"Select ONE method for the banner" => "EINE Methode f&uuml;r das Banner ausw&auml;hlen",
"Use HTML" => "HTML benutzen",
"Use image" => "Bild benutzen",
"Image:" => "Bild:",
"Current Image" => "Aktuelles Bild",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Bild benutzen, das durch die URL erzeugt wird (das Bild wird bei jedem Aufruf der URL angefordert)",
"Use text" => "Text benutzen",
"Save the Banner" => "Das Banner speichern",
"Create Blog" => "Blog erstellen",
"A category is mandatory" => "Eine Kategorie ist obligatorisch",
"Current heading" => "Aktueller Kopfbereich",
"There are individual permissions set for this blog" => "Es gibt individuelle Berechtigungen f&uuml;r dieses Blog",
"Number of posts to show" => "Anzahl der anzuzeigenden Eintr&auml;ge",
"Allow other user to post in this blog" => "Anderer Benutzer darf in dieses Blog eintragen",
"Use titles in blog posts" => "&Uuml;berschriften in Blog-Eintr&auml;gen verwenden",
"Allow search" => "Suchen erlauben",
"Allow comments" => "Kommentare erlauben",
"Show user avatar" => "Zeige Benutzer-Avatar",
"Blog heading" => "Blog Kopfbereich",
"Edit Style Sheet" => "Stylesheet bearbeiten",
"Style Sheet" => "Stylesheet",
"choose a stylesheet" => "Stylesheet ausw&auml;hlen",
"Try" => "Ausprobieren",
"Wiki Help" => "Wiki Hilfe",
"Bold text" => "fetter Text",
"Italic text" => "kursiver Text",
"Underlined text" => "unterstrichener Text",
"Colored text" => "Farbiger Text",
"Headings" => "&Uuml;berschriften",
"Show/Hide" => "Ein-/Ausblenden",
"Text box" => "Textkasten",
"Box content" => "Box-Inhalt",
"Centered text" => "zentrierter Text",
"Dynamic variables" => "Dynamische Variablen",
"External links" => "Externe Links",
"Square Brackets" => "Eckige Klammern",
"Use [[foo] to show [foo]." => "[[foo] benutzen, damit [foo] ausgegeben wird.",
"Wiki References" => "Wiki-Referenzen",
"JoinCapitalizedWords or use" => "ZusammenGrossKleinSchreibung oder benutzen Sie",
"page|description" => "Seite|Beschr.",
"for wiki references" => "f&uuml;r Wiki-Referenzen",
"SomeName" => "EinName",
"prevents referencing" => "verhindert Referenzierung",
"Lists" => "Listen",
"for bullet lists" => "f&uuml;r einfache Listen",
"for numbered lists" => "f&uuml;r numerierte Listen",
"for definiton lists" => "f&uuml;r Definitionslisten",
"Tables" => "Tabellen",
"row" => "Zeile",
"Title bar" => "Titelbalken",
"creates the editable drawing foo" => "erzeugt die bearbeitbare Zeichnung foo",
"Multi-page pages" => "Mehrseitige Seiten",
"Non parsed sections" => "Nicht geparste Bereiche",
"Preformated sections" => "Vorformatierte Bereiche",
"Block Preformatting" => "Block Vorformatierung",
"No description available" => "Keine Beschreibung vorhanden.",
"table" => "Tabelle",
"table new" => "neue Tabelle",
"external link" => "externen Verweis",
"wiki link'" => "Wiki-Link'",
"heading1" => "&Uuml;berschrift1",
"title bar" => "Titelbalken",
"box" => "Box",
"rss feed" => "RSS-Feed",
"dynamic content" => "Dynamischer Inhalt",
"tagline" => "Tagline",
"center text" => "Text zentrieren",
"colored text" => "Farbiger Text",
"dynamic variable" => "dynamische Variable",
"special chars" => "Sonderzeichen",
"special characters" => "Sonderzeichen",
"Browse Images" => "Bild betrachten",
"Edit successful!" => "Bearbeitung erfolgreich!",
"The following image was successfully edited" => "Das folgende Bild wurde erfolgreich bearbeitet",
"Image Description" => "Bildbeschreibung",
"Save and Go Next" => "Speichern und zum N&auml;chsten",
"Edit and create Languages" => "Sprachen erstellen/bearbeiten",
"Edit and create languages" => "Sprachen erstellen/bearbeiten",
"Create Language" => "Sprache erstellen",
"Shortname" => "Kurzname",
"like" => "wie",
"Longname" => "Voller Name",
"Select the language to edit" => "Zu bearbeitende Sprache ausw&auml;hlen",
"Add a translation" => "&Uuml;bersetzung hinzuf&uuml;gen",
"Edit translations" => "&Uuml;bersetzungen bearbeiten",
"Translate recorded" => "Aufgezeichnetes &uuml;bersetzen",
"Translation" => "&Uuml;bersetzung",
"reset table" => "Tabelle zur&uuml;cksetzen",
"Create New Block" => "Neuen Block erzeugen",
"Return to block listing" => "Zur&uuml;ck zur Block-Auflistung",
"Block description: " => "Blockbeschreibung: ",
"You are editing block:" => "Sie bearbeiten Block:",
"Publishing date" => "Ver&ouml;ffentlichungsdatum",
"Publishing Date" => "Ver&ouml;ffentlichungsdatum",
"Edit question options" => "Optionen bearbeiten",
"List Quizzes" => "Quiz auflisten",
"Quiz Stats" => "Quiz-Statistik",
"This Quiz Stats" => "Statistik f&uuml;r dieses Quiz",
"Edit this Quiz" => "Dieses Quiz bearbeiten",
"Admin Quizzes" => "Quiz verwalten",
"Create/edit options for question" => "Optionen f&uuml;r Frage erstellen/bearbeiten",
"Create/edit quizzes" => "Quiz hinzuf&uuml;gen/bearbeiten",
"There are individual permissions set for this quiz" => "F&uuml;r dieses Quiz gibt es individuelle Berechtigungen",
"Quiz can be repeated" => "Quiz kann wiederholt werden",
"Store quiz results" => "Quiz-Ergebnisse abspeichern",
"Questions per page" => "Fragen pro Seite",
"Quiz is time limited" => "Ratezeit ist limitiert",
"Maximum time" => "Maximale Zeit",
"canRepeat" => "wiederholbar",
"timeLimit" => "ZeitLimit",
"Edit quiz questions" => "Quiz-Fragen bearbeiten",
"Create/edit questions for quiz" => "Fragen f&uuml;r Quiz erstellen/bearbeiten",
"Question Type" => "Fragentyp",
"Input" => "Eingabe",
"maxScore" => "maxPunktzahl",
"From Points" => "von Punkten",
"To Points" => "zu Punkten",
"Answer" => "Antwort",
"Modify Structure" => "Struktur ver&auml;ndern",
"You will remove" => "Sie wollen entfernen",
"Remove only from structure" => "Nur aus Struktur entfernen",
"Remove from structure and remove page too" => "Aus Struktur und von Seite entfernen",
"Structure Layout" => "Struktur Layout",
"Promote" => "Aufwerten",
"Demote" => "Abwerten",
"Current Node" => "Aktueller Knoten",
"Page alias" => "Seitenalias",
"Move in this structure" => "verschieben in dieser Struktur",
"Move to another structure" => "verschieben in andere Struktur",
"at the beginning" => "an den Anfang",
"at the end" => "an das Ende",
"Add pages to current node" => "Seiten zu aktuellem Knoten hinzuf&uuml;gen",
"After page" => "Nach Seite",
"Create Page" => "Seite erstellen",
"Use pre-existing page" => "Vorhandene Seite verwenden",
"Submit article" => "Artikel einreichen",
"List Submissions" => "Einreichungen auflisten",
"<b>Topline</b>=small line above Title" => "<b>Kopfzeile</>=schmale Zeile &uuml;ber Titel",
"<b>Subtitle</b>=small line below Title" => "<b>Untertitel</b>=schmale Zeile unter Titel",
"<b>Source</b>=URL to article source" => "<b>Quelltext</b>=URL zum Artikel-Quelltext",
"Edit templates" => "Vorlagen bearbeiten",
"Template listing" => "Vorlagenliste",
"Available templates" => "Verf&uuml;gbare Templates",
"Save Only in the Theme:" => "Nur f&uuml;r diesen Style speichern:",
"Edit a topic" => "Thema bearbeiten",
"Add Notification Email" => "Benachrichtigungs-Email hinzuf&uuml;gen",
"View Page" => "Seite anzeigen",
"You must specify the object language" => "Sie m&uuml;ssen die Sprache des Objekts angeben",
"The object doesn't exist" => "Das Objekt ist nicht vorhanden",
"The object doesn't have a language" => "Das Objekt hat nicht die angegebene Sprache",
"The object has already a translation for this language" => "Das Objekt hat bereits eine &Uuml;bersetzung f&uuml;r diese Sprache",
"The object is already in the set of translations" => "Das Objekt ist bereits als &Uuml;bersetzung gespeichert",
"Language of newly translated page" => "Sprache f&uuml;r neue &Uuml;bersetzungsseite",
"Name of newly translated page" => "Name f&uuml;r neue &Uuml;bersetzungsseite",
"Create translation" => "&Uuml;bersetzung erstellen",
"Or" => "oder",
"Add existing page as a translation of this page" => "Eine vorhandene Seite zu den &Uuml;bersetzungen hinzuf&uuml;gen.",
"Manage existing translations of this page" => "&Uuml;bersetzungen der Seite verwalten",
"Change language for this page" => "Sprache f&uuml;r diese Seite &auml;ndern",
"Change Language" => "Sprache &auml;ndern",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "Die SandBox ist eine Seite, an der Sie Ihre Editierf&auml;higkeiten &uuml;ben k&ouml;nnen. Benutzen Sie die Vorschau-Funktion, um sich das Resultat Ihrer Seite anzusehen. Keine Version dieser Seite wird gespeichert.",
"This edit session will expire in {\$edittimeout} minutes" => "Die Bearbeitungszeit endet in {\$edittimeout} Minuten",
"Admin Content Templates" => "Inhaltsvorlagen verwalten",
"Use rating" => "Bewertung erlauben",
"There is no available poll template." => "Kein Bewertungstemplate vorhanden.",
"You should ask an admin to create them." => "Du solltest den Admin bitten, eines anzulegen",
"or use" => "oder",
"an existing poll" => "vorhandene Abstimmung verwenden",
"votes" => "Stimmen",
"Replace to" => "Ersetzen mit",
"Case Insensitivity" => "Gro&szlig;- und Kleinschreibung nicht beachten",
"My Footnotes" => "Fu&szlig;noten",
"Translation request" => "Anfrage &Uuml;bersetzung",
"Year:" => "Jahr:",
"Authors:" => "Autoren:",
"Try to convert HTML to wiki" => "Versuche HTML in Wiki zu konvertieren",
"Import page" => "Seite importieren",
"export all versions" => "alle Versionen exportieren",
"Upload picture" => "Bild hochladen",
"Add another image" => "weiteres Bild hinzuf&uuml;gen",
"License" => "Lizenz",
"Important" => "Wichtig",
"Lock this page" => "Diese Seite sperren:",
"Autodetect" => "Automatische Erkennung",
"status" => "Status",
"lastModif" => "&Auml;nderung",
"All fields" => "alle Felder",
"Dump" => "Datenbankabzug",
"Admin FAQ" => "FAQ verwalten",
"List FAQs" => "FAQs auflisten",
"View FAQ" => "FAQ anzeigen",
"Edit this FAQ" => "Diese FAQ bearbeiten",
"New Question" => "Neue Frage",
"Use a question from another FAQ" => "Eine Frage aus einer anderen FAQ benutzen",
"FAQ questions" => "FAQ-Fragen",
"Suggested questions" => "Vorgeschlagene Fragen",
"No suggested questions" => "Keine vorgeschlagenen Fragen",
"File Archive" => "Dateiarchive",
"Upload File" => "Datei hochladen",
"View tpl" => "tpl anzeigen",
"File Galleries tpl" => "tpl - Dateiverzeichnis",
"Create New File Gallery" => "Neues Dateiarchiv anlegen",
"You can access the file gallery using the following URL" => "Sie k&ouml;nnen das Dateiarchiv unter der folgenden URL erreichen",
"Size (width x height)" => "Gr&ouml;&szlig;e (Breite x H&ouml;he)",
"Admin forums" => "Foren verwalten",
"Edit queued message" => "Nachrichten-Liste bearbeiten",
"make this a thread of" => "Hieraus einen Thread machen von",
"None, this is a thread message" => "nichts, dies ist eine Thread-Nachricht",
"summary" => "Zusammenfassung",
"announce" => "Annoncieren",
"hot" => "hei&szlig;",
"no feeling" => "gleichg&uuml;ltig",
"frown" => "verdutzt",
"exclaim" => "ausrufend",
"idea" => "Idee",
"mad" => "sauer",
"question" => "Frage",
"sad" => "traurig",
"happy" => "fr&ouml;hlich",
"wink" => "winkend",
"Save and Approve" => "Speichern und freigeben",
"convert to topic" => "in Thema konvertieren",
"List of messages" => "Nachrichtenliste",
"New Topic" => "Neues Thema",
"no summary" => "keine Zusammenfassung",
"No messages queued yet" => "Es stehen keine Nachrichten an",
"Last Post" => "Neuester Eintrag",
"Configure Forum" => "Forum einrichten",
"Reported by" => "Gemeldet von",
"Request Time" => "Anfrage vom",
"Accept" => "Annehmen",
"Refuse" => "Ablehnen",
"Waiting requests" => "Laufende Anfragen",
"Your friends" => "Ihre Freunde",
"Activity completed" => "Aktivit&auml;t erfolgreich beendet",
"Admin process activities" => "Prozessaktivit&auml;ten verwalten",
"Add or edit an activity" => "Aktivit&auml;t hinzuf&uuml;gen/bearbeiten",
"activity" => "Aktivit&auml;t",
"split" => "teilen",
"interactive" => "interaktiv",
"Years" => "Jahre",
"Months" => "Monate",
"Hours" => "Stunden",
"Minutes" => "Minuten",
"Add transitions" => "&Uuml;berg&auml;nge hinzuf&uuml;gen",
"Add transition from:" => "&Uuml;bergang hinzuf&uuml;gen von:",
"Add transition to:" => "&Uuml;bergang hinzuf&uuml;gen nach:",
"No roles associated to this activity" => "Keine Rollen mit dieser Aktivit&auml;t verbunden",
"Add Role" => "Rolle hinzuf&uuml;gen",
"Add New" => "Neu hinzuf&uuml;gen",
"Process activities" => "Prozessaktivit&auml;ten",
"Interactive" => "Interaktiv",
"Automatic" => "Automatisch",
"Manual" => "Manuell",
"inter" => "Interaktiv",
"(no roles)" => "(keine Rollen)",
"No activities defined yet" => "Noch keine Aktivit&auml;ten definiert",
"Process Transitions" => "Prozess&uuml;berg&auml;nge",
"List of transitions" => "&Uuml;bergangsliste",
"No transitions defined yet" => "Keine &Uuml;berg&auml;nge definiert",
"Add a transition" => "&Uuml;bergang hinzuf&uuml;gen",
"This process is invalid" => "Dieser Prozess ist ung&uuml;ltig",
"List of processes" => "Prozessliste",
"Inactive" => "inaktiv",
"act" => "Aktion",
"val" => "aktiv",
"Active Process" => "Aktiver Prozess",
"Invalid Process" => "Ung&uuml;ltiger Prozess",
"Valid Process" => "G&uuml;ltiger Prozess",
"Activities" => "Aktivit&auml;ten",
"No processes defined yet" => "Noch keine Prozesse definiert.",
"Admin instance" => "Instanzen verwalten",
"Process:" => "Prozess:",
"Instance" => "Instanz",
"exception" => "Fehler",
"completed" => "erledigt",
"Aborted" => "Abgebrochen",
"Owner" => "Besitzer",
"Don't move" => "Nicht verschieben",
"Started" => "Gestartet",
"Act status" => "Act Status",
"Ended" => "Beendet",
"Not Defined" => "nicht definiert",
"Property" => "Eigenschaft",
"Add property" => "Eigentum hinzuf&uuml;gen",
"run instance" => "Instanz starten",
"Admin processes" => "Prozesse verwalten",
"Add or edit a process" => "Prozess hinzuf&uuml;gen/bearbeiten",
"Process Name" => "Prozessname",
"ver:" => "Version:",
"is active?" => "ist aktiv?",
"Or upload a process using this form" => "Oder Prozess &uuml;ber dieses Formular hochladen",
"Admin process roles" => "Prozess-Rollen verwalten",
"Add or edit a role" => "Rolle hinzuf&uuml;gen/bearbeiten",
"Process roles" => "Prozess-Rollen",
"No roles defined yet" => "Keine Rollen definiert",
"Map users to roles" => "User zu Rollen zuordnen",
"map" => "zuordnen",
"Map groups to roles" => "Gruppen zu Rollen zuordnen",
"No roles are defined yet so no roles can be mapped" => "Keine Rollen definiert, daher keine Zuordnungen m&ouml;glich",
"List of mappings" => "Zuordnungen",
"No mappings defined yet" => "Keine Zuordnungen definiert",
"Admin process sources" => "Prozess-Quellcode verwalten",
"select source" => "Quellcode ausw&auml;hlen",
"Shared code" => "geteilter Code",
"Set next user" => "Setze n&auml;chsten Benutzer",
"Process form" => "Prozess von",
"Map process roles" => "Prozess-Rollen zuordnen",
"Admin Processes" => "Prozesse verwalten",
"Admin Activities" => "Aktivit&auml;ten verwalten",
"Admin Roles" => "Rollen verwalten",
"Edit this Process" => "Prozess bearbeiten",
"Monitor Activities" => "Aktivit&auml;ten &uuml;berwachen",
"List of activities" => "Aktivit&auml;tsliste",
"Proc" => "Prozesse",
"auto" => "Automatisch",
"int" => "Interaktiv",
"routing" => "Routing",
"Instances" => "Instanzen",
"run" => "starten",
"run activity" => "Aktivit&auml;t starten",
"Monitor" => "&Uuml;berwachen",
"monitor processes" => "Prozesse &uuml;berwachen",
"monitor activities" => "Aktivit&auml;ten &uuml;berwachen",
"monitor instances" => "Instanzen &uuml;berwachen",
"monitor workitems" => "Workitems &uuml;berwachen",
"Monitor Instances" => "Instanzen &uuml;berwachen",
"List of instances" => "Instanzliste",
"No instances created yet" => "noch keine Instanzen erstellt",
"Monitor Processes" => "Prozesse &uuml;berwachen",
"processes" => "Prozesse",
"being run" => "ausgef&uuml;hrt",
"Completed" => "Erledigt",
"Exceptions" => "Fehler",
"instance" => "Instanz",
"My activities" => "Meine Aktivit&auml;ten",
"Current Activity" => "Aktuelle Aktivit&auml;t",
"Assigned To" => "Zugewiesen zu Benutzer",
"abort instance" => "Instanz abbrechen",
"release instance" => "Instanz freigeben",
"No activities found" => "Keine Aktivit&auml;ten gefunden",
"My instances" => "Meine Instanzen",
"No instances found" => "Keine Instanzen gefunden",
"User Activities" => "Benutzeraktivit&auml;ten",
"process" => "Prozess",
"No processes defined or activated yet" => "Noch kein Prozess definiert oder aktiv.",
"user processes" => "Benutzer-Prozesse",
"user activities" => "Benutzer-Aktivit&auml;ten",
"user instances" => "Benutzer-Instanzen",
"User Instances" => "Benutzer-Instanzen",
"No instances defined yet" => "Noch keine Instanzen definiert.",
"User Processes" => "Benutzer-Prozesse",
"Galleries" => "Galerien",
"Create New Gallery" => "Neue Galerie anlegen",
"Create a gallery" => "Neue Galerie anlegen",
"Edit this gallery:" => "Diese Galerie bearbeiten:",
"There are individual permissions set for this gallery" => "F&uuml;r diese Galerie gibt es individuelle Berechtigungen",
"Geographic" => "Geographisch",
"Fields to show during browsing the gallery" => "Angezeigte Felder beim Durchst&ouml;bern der Galerie",
"Creation Date" => "Erstelldatum",
"XY-Size" => "XY-Gr&ouml;&szlig;e",
"Gallery Image" => "Galerie Logo",
"Available scales" => "Verf&uuml;gbare Skalierungen",
"default scale" => "Standard-Skalierung",
"No scales available" => "Keine Skalierungen verf&uuml;gbar",
"Original image is default scale" => "Originalbild ist die Standard-Skalierung",
"Add scaled images with bounding box of square size" => "Skalierte Bilder in Box anzeigen, Kantenl&auml;nge",
"Other users can upload images to this gallery" => "Andere Benutzer k&ouml;nnen Bilder in diese Galerie hochladen",
"You can access the gallery using the following URL" => "Sie k&ouml;nnen die Galerie &uuml;ber folgende URL erreichen",
"Available Galleries" => "Verf&uuml;gbare Galerien",
"Choose a filter" => "Filter w&auml;hlen",
"Imgs" => "Bilder",
"Make Map" => "Karte erstellen",
"Users Map" => "Benutzerkarten",
"Landscape" => "Gestalten",
"Bottom" => "Unten",
"Im- Export languages" => "Sprachen im/exportieren",
"Select the language to Import" => "Sprache f&uuml;r Import w&auml;hlen",
"Select the language to Export" => "Sprache f&uuml;r Export w&auml;hlen",
"Overwrite existing pages if the name is the same" => "&Uuml;berschreibe vorhandene Seiten, falls der Name gleich ist",
"Previously remove existing page versions" => "Zuvor vorhandene Seitenversionen entfernen",
"excerpt" => "Auszug",
"Result" => "Ergebnis",
"Locked" => "Gesperrt",
"Tiki installer" => "Tiki Installer",
"Database user" => "Datenbank Benutzer",
"Install" => "Installieren",
"Configure General Settings" => "Verschiedene Einstellungen II",
"Clear cached version and refresh cache" => "Cache aktualisieren",
"configure rules" => "Regeln konfigurieren",
"Edit Repository" => "Repository bearbeiten",
"Last Changes" => "Neueste &Auml;nderungen",
"Search by Date" => "Suche nach Datum",
"LastChanges" => "Letzte&Auml;nderungen",
"Rollback" => "Zur&uuml;ckgerollt",
"Pages like" => "&Auml;hnliche Seiten",
"No pages found" => "Keine Seiten gefunden",
"Edit New Article" => "Neuen Artikel erstellen",
"View Submissions" => "Einreichungen ansehen",
"ExpireDate" => "Ablaufdatum",
"AuthorName" => "Autor",
"Create banner" => "Banner erstellen",
"Method" => "Methode",
"Use Dates?" => "Datum benutzen?",
"Max Impressions" => "Max Aufrufe",
"Impressions" => "Aufrufe",
"Clicks" => "Klicks",
"Create New Blog" => "Neuen Blog anlegen",
"Use cache for external pages" => "Cache f&uuml;r externe Seiten benutzen",
"Dynamic content system" => "Dynamischer Inhalt",
"Available content blocks" => "Verf&uuml;gbare Inhaltsbl&ouml;cke",
"Current ver" => "Aktuelle Ver.",
"Next ver" => "N&auml;chste Ver.",
"Future vers" => "Zuk&uuml;nft. Ver.",
"Program" => "Programm",
"Edit this FAQ:" => "Diese FAQ bearbeiten:",
"Create new FAQ" => "Neue FAQ erstellen",
"Create New FAQ:" => "Neue FAQ erstellen:",
"Users can suggest questions" => "Benutzer k&ouml;nnen Fragen vorschlagen",
"Available FAQs" => "Verf&uuml;gbare FAQs",
"Create a File Gallery" => "Dateiarchiv anlegen",
"Your comment" => "Ihr Kommentar",
"Gallery Images" => "Galerie-Bilder",
"All games are from" => "Alle Spiele von",
"visit the site for more games and fun" => "Besuchen Sie die Site f&uuml;r weitere Spiele und Unterhaltung.",
"Upload a game" => "Ein Spiel hochladen",
"Upload a new game" => "Ein neues Spiel hochladen",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Thumbnail (Wenn das Spiel foo.swf hei&szlig;t, muss der Thumbnail foo.swf.gif, foo.swf.png oder foo.swf.jpg hei&szlig;en)",
"Edit game" => "Spiel bearbeiten",
"Played" => "Gespielt",
"If you can't see the game then you need a flash plugin for your browser" => "Wenn Sie das Spiel nicht sehen k&ouml;nnen, ben&ouml;tigen Sie ein Flash-Plugin f&uuml;r Ihren Browser.",
"Edit Blog" => "Blog bearbeiten",
"Blog Title" => "Blog-Titel",
"Edit New Submission" => "Neue Einreichung bearbeiten",
"Survey stats" => "Umfragen-Statistik",
"Take Survey" => "Fragen anzeigen",
"users registered" => "registrierte Benutzer",
"Distance (km)" => "Entfernung (km)",
"List Movies" => "Filme auflisten",
"Choose a movie" => "Film ausw&auml;hlen",
"Last mod" => "letzte Mod.",
"Last modification" => "Letzte &Auml;nderung",
"Last author" => "Letzter Autor",
"Last version" => "Neueste Version",
"unlocked" => "entsperrt",
"Open client window" => "Clientfenster &ouml;ffnen",
"Generate HTML" => "",
"Transcripts" => "Logb&uuml;cher",
"Online operators" => "Operatoren online",
"Operator" => "operator",
"Accepted requests" => "Bearbeitete Anfragen",
"since" => "seit",
"transcripts" => "Logs",
"Offline operators" => "Abwesende Operatoren",
"Add an operator to the system" => "Neuen Operator hinzuf&uuml;gen",
"Operators must be tiki users" => "Operatoren m&uuml;ssen Tiki Benutzer sein",
"Set as Operator" => "Als Operator hinzuf&uuml;gen",
"Chat started" => "Chat begonnen",
"Live support:User window" => "Online-Support: Benutzerfenster",
"Request live support" => "Live Support-Anfrage stellen",
"Request support" => "Supportanfrage stellen",
"Open a support ticket instead" => "Stattdessen ein Support-Ticket erstellen",
"Your request is being processed" => "Ihre Anfrage wird bearbeitet",
"cancel request and exit" => "Anfrage abbrechen und verlassen",
"cancel request and leave a message" => "Anfrage abbrechen und Nachricht hinterlassen",
"Live support:Console" => "Live Support: Konsole",
"be online" => "online gehen",
"be offline" => "offline gehen",
"Support requests" => "Support-Anfragen",
"Join" => "Beitreten",
"Support chat transcripts" => "Support Chat-Logb&uuml;cher",
"started" => "gestartet",
"reason" => "Grund",
"Transcript" => "Logbuch",
"Prefs" => "Konfig.",
"Remove old events" => "Alte Termine l&ouml;schen",
"duration" => "Dauer",
"Mini Calendar: Preferences" => "Mini-Kalender: Einstellungen",
"Calendar Interval in daily view" => "Kalender Intervall in Tagesansicht",
"Start hour for days" => "Tag beginnt um",
"End hour for days" => "Tag endet um",
"Reminders" => "Erinnerungen",
"no reminders" => "keine Erinnerungen",
"Or enter path or URL" => "Oder Pfad oder URL eingeben",
"Add Topic" => "Thema hinzuf&uuml;gen",
"Tikiwiki Mods" => "Tiki Mods",
"Mods Configuration" => "Mod Konfiguration",
"Update remote index" => "Remote Index aktualisieren",
"Rebuild local list" => "Lokale Liste aktualisieren",
"Republish all" => "alle wiederver&ouml;ffentlichen",
"Publish all" => "alle ver&ouml;ffentlichen",
"Unpublish all" => "alle nicht ver&ouml;ffentlichen",
"Attention" => "Achtung",
"all types" => "alle Typen",
"licence" => "Lizenz",
"Tikiwiki Mods Configuration" => "Tiki Mod Konfiguration",
"Mods Install/uninstall" => "Mod Installation/Deinstallation",
"Enable Mods providing" => "Mod Verteilung aktivieren",
"Mods local directory" => "Lokales Mod Verzeichnis",
"Mods remote server" => "Mod Remote Server",
"User Pages" => "Benutzer-Seiten",
"y" => "j",
"User Galleries" => "Benutzer-Galerien",
"Unread Messages" => "Ungelesene Nachrichten",
"Tasks" => "Aufgaben",
"User Blogs" => "Benutzer-Blogs",
"MyTiki" => "Mein Tiki",
"My Infos" => "Meine Informationen",
"Contacts Preferences" => "Kontakte Einstellungen",
"Notepad" => "Notizblock",
"MyFiles" => "MeineDateien",
"My Watches" => "Meine Beobachtungspunkte",
"My Contacts" => "Meine Kontakte",
"My Wiki Pages" => "Meine Wiki-Seiten",
"Assigned items" => "Zugewiesene Eintr&auml;ge",
"My Messages" => "Meine Nachrichten",
"Sent editions" => "Gesendete Ausgaben",
"HTML version" => "HTML-Version",
"Text version" => "Textversion",
"The newsletter was sent to {\$sent} email addresses" => "Der Newsletter wurde an {\$sent} eMail-Adressen verschickt",
"Delete errors" => "Fehler l&ouml;schen",
"Not sent" => "nicht senden",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Vielen Dank f&uuml;r Ihr Abonnenment. Sie werden in K&uuml;rze eine eMail zur Best&auml;tigung Ihres Abonnements erhalten. Vor einer Best&auml;tigung Ihres Abonnements wird Ihnen kein Newsletter zugesandt.",
"Your email address was removed from the list of subscriptors." => "Ihre Mail-Adresse wurde von der Liste der Abonnementen entfernt.",
"Subscription confirmed!" => "Abonnement best&auml;tigt!",
"Subscribe to Newsletter" => "Newsletter abonnieren",
"Subscribe to this Newsletter" => "Abonnieren",
"Available Newsletters" => "Verf&uuml;gbare Newsletter",
"Select news group" => "Newsgroup ausw&auml;hlen",
"Back to servers" => "Zur&uuml;ck zur Server&uuml;bersicht",
"Msgs" => "Nachrichten",
"News from" => "Nachricht von",
"Back to groups" => "Zur&uuml;ck zu Gruppen",
"Save position" => "Position speichern",
"Reading article from" => "Artikel lesen aus",
"Back to list of articles" => "Zur&uuml;ck zur Artikel&uuml;bersicht",
"Newsgroup" => "Nachrichten-Gruppe",
"Configure news servers" => "Newsserver-Konfiguration",
"Configure Newsreader" => "Newsreader konfigurieren",
"Select a news server to browse" => "Auswahl des Newsservers",
"server" => "Server",
"News server" => "Newsserver",
"Notes" => "Notizen",
"Write a note" => "Notiz schreiben",
"quota" => "Quota",
"No notes yet" => "Noch keine Notizen vorhanden.",
"Merge selected notes into" => "Notizen verschmelzen mit",
"Reading note:" => "Lese Notiz:",
"List notes" => "Notizen auflisten",
"Write note" => "Notiz schreiben",
"Assign permissions to " => "Berechtigungen vergeben f&uuml;r ",
"View Permissions" => "Berechtigungen Ansicht",
"Edit Permissions" => "Berechtigungen Bearbeiten",
"Current permissions for this object" => "Aktuelle Berechtigungen f&uuml;r dieses Objekt",
"No individual permissions, category permissions apply" => "Keine individuelle Berechtigungen, Kategorie-Berechtigung gilt",
"Current permissions for categories that this object belongs to" => "Aktuelle Berechtigungen f&uuml;r die Kategorien, zu denen dieses Objekt geh&ouml;rt",
"No category permissions; global permissions apply" => "Keine Kategorieberechtigungen vergeben; Globale Berechtigungen greifen",
"No category permissions; special permissions apply" => "Keine Kategorieberechtigungen vergeben; spezielle Berechtigungen greifen",
"Assign permissions to this object" => "Diesem Objekt Berechtigungen zuweisen",
"Perms Help" => "Berechtigungen Hilfe",
"Published" => "Ver&ouml;ffentlicht",
"Create a new Tikiwiki account from OpenID" => "neues Tikiwiki-Konto erstellen mit OpenID",
"Associate OpenID with an existing Tikiwiki account" => "OpenID mit Tikiwiki-Konto verkn&uuml;pfen",
"Orphan Pages" => "Verwaiste Seiten",
"Browser not supported" => "Browser wird nicht unterst&uuml;tzt",
"Rename" => "Umbenennen",
"Make Structure" => "Struktur erstellen",
"Slides" => "Dias",
"Discuss" => "Diskutieren",
"Attach File" => "Datei anh&auml;ngen",
"1 File Attached" => "1 angeh&auml;ngte Datei",
"{\$atts|@count} files attached" => "{\$atts|@count} angeh&auml;ngte Dateien",
"Preview of version" => "Vorschau der Version",
"Rollback to this version" => "diese Version wiederherstellen",
"Source of version" => "Quelltext der Version",
"s=source" => "s=Quellcode",
"b=rollback" => "b=Rollback",
"Update Translation" => "&Uuml;bersetzung aktualisieren",
"Pick your avatar" => "W&auml;hlen Sie Ihren Avatar",
"User Preferences" => "Benutzer-Einstellungen",
"Your current avatar" => "Ihr momentaner Avatar",
"no avatar" => "keinen Avatar benutzen",
"reset" => "zur&uuml;cksetzen",
"Pick avatar from the library" => "W&auml;hle Avatar aus der Bibliothek",
"Pick user Avatar" => "Nutzer-Avatar ausw&auml;hlen",
"Hide all" => "Alles verbergen",
"icons" => "Icons",
"Show all" => "Zeige alles",
"Avatar Image" => "Avatar Bild",
"Upload your own avatar" => "Eigenen Avatar hochladen",
"Insert" => "Einf&uuml;gen",
"atts" => "Anh&auml;nge",
"List Attachments" => "Anh&auml;nge auflisten",
"Average" => "Durchschnitt",
"View Results" => "Ergebnisse anschauen",
"Vote poll" => "Umfrage w&auml;hlen",
"Other Polls" => "Andere Abstimmungen",
"Poll Results" => "Ergebnis der Abstimmung",
"List Votes" => "Stimmen auflisten",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Hinweis: Dies ist nur eine Vorschau und wurde noch nicht gespeichert!",
"on:" => "Am:",
"Topic image" => "Themenlogo",
"Viewing blog post" => "Betrachte Blog-Eintrag",
"Return to blog" => "Zur&uuml;ck zum Blog",
"The original document is available at" => "Das Originaldokument ist zu finden unter",
"Print multiple pages" => "Mehrere Seiten drucken",
"Add Pages" => "Seite hinzuf&uuml;gen",
"Add Page" => "Seite hinzuf&uuml;gen",
"Add Pages from Structures" => "alle Seiten von Struktur hinzuf&uuml;gen",
"Selected Pages" => "ausgew&auml;hlte Seite",
"Publication Date" => "Datum der Ver&ouml;ffentlichung",
"Extra Options" => "Zus&auml;tzliche Optionen",
"Quiz result stats" => "Quiz-Ergebnis-Statistik",
"Time" => "Zeit",
"User answers" => "Benutzerantworten",
"Stats for quizzes" => "Statistik f&uuml;r die Quiz",
"taken" => "teilgenommen",
"Av score" => "durchschn. Punktzahl",
"Av time" => "durchschn. Zeit",
"Clear Stats" => "Statistiken zur&uuml;cksetzen",
"Stats for this quiz Questions " => "Statistik f&uuml;r die Fragen in diesem Quiz ",
"Top 10" => "besten 10",
"Top 20" => "besten 20",
"Top 50" => "besten 50",
"Top 100" => "besten 100",
"star" => "Stern",
"half star" => "halber Stern",
"Received articles" => "Empfangene Artikel",
"Edit received article" => "Empfangenen Artikel bearbeiten",
"Use Image" => "Bild benutzen",
"Image x size" => "Bildbreite",
"Image y size" => "Bildh&ouml;he",
"Image name" => "Bildname",
"Accept Article" => "Artikel annehmen",
"Site" => "Link",
"Referer stats" => "Referer-Statistik",
"A valid email is mandatory to register" => "Zum Registrieren ist eine g&uuml;ltige eMail-Adresse n&ouml;tig.",
"Select your group" => "Bitte Gruppe ausw&auml;hlen",
"Tiki site registered" => "Tiki Site registriert",
"The following site was added and validation by admin may be needed before appearing on the lists" => "Folgende Site wurde hinzugef&uuml;gt. Der Link erscheint erst nach &Uuml;berpr&uuml;fung des Administrators in der Liste",
"You don't have permission to use this feature." => "Keine Berechtigung zur Nutzung dieser Funktion vorhanden.",
"Register this site at tikiwiki.org" => "Diese Site auf tikiwiki.org registrieren",
"Read this first!" => "Bitte lesen!",
"On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites." => "Hier k&ouml;nnen Sie Ihre Site bei tikiwiki.org bekanntmachen. Dort wird sie in die Liste der bekannten Tiki-Sites eingetragen.",
"Registering is voluntary." => "Die Registrierung ist freiwillig.",
"Registering does not give you any benefits except one more link to your site." => "Eine Registrierung bringt keine Vorteile au&szlig;er einen zus&auml;tzlichen Link auf die Site.",
"You don't get any emails, we don't sell the data about your site." => "Sie bekommen keine eMails und wir verkaufen auch keine Daten. :)",
"Registering is just for us to get an overview of Tiki's usage." => "Die Registrierung hilft uns einen kleinen &Uuml;berblick &uuml;ber die Nutzung von Tiki zu gewinnen.",
"If your site is private or inside your intranet, you should not register!" => "Wenn ihre Tiki Site rein privat oder nur in ihrem Intranet zu erreichen ist, tragen sie ihre Site bitte nicht ein!",
"Information about your site" => "Informationen zu Ihrer Site",
"Send me my Password" => "Mein Pa&szlig;wort senden",
"Remove page" => "Seite entfernen",
"Last Version" => "Neueste Version",
"You are about to remove the page" => "Sie dabei, die Seite zu entfernen",
"permanently" => "permanent",
"Remove all versions of this page" => "Alle Versionen dieser Seite entfernen",
"Rollback page" => "Rollback-Seite",
"Searched" => "Gesucht",
"Search in" => "Suche in",
"Simple search" => "Einfache Suche",
"No pages matched the search criteria" => "Keine passenden Seiten zum Suchkriterium",
"Send blog post" => "Sende Blog-Eintrag",
"A link to this post was sent to the following addresses:" => "Ein Link auf diesen Eintrag wurde an folgende Adressen verschickt:",
"Send post to this addresses" => "Eintrag an diese Adressen verschicken",
"List of email addresses separated by commas" => "Liste der eMail-Adressen (kommagetrennt)",
"This newsletter will be sent to {\$subscribers} email addresses." => "Der Newsletter wird an {\$subscribers} eMail-Adressen verschickt.",
"Prepare a newsletter to be sent" => "Newsletter auf Versand vorbereiten",
"remove" => "entfernen",
"Send objects" => "Objekte senden",
"Transmission results" => "&Uuml;bertragungsergebnisse",
"Send Wiki Pages" => "Wiki-Seiten senden",
"Send Articles" => "Artikel senden",
"Add Article" => "Artikel hinzuf&uuml;gen",
"Send objects to this site" => "Objekte an diese Site senden",
"Header Rows" => "Kopfzeilen",
"Footer Rows" => "Fu&szlig;zeilen",
"Available Sheets" => "Verf&uuml;gbare Sheets",
"Change shoutbox general settings" => "Shoutbox-Einstellungen &auml;ndern",
"auto-link urls" => "autom. URLs in Links wandeln",
"Post or edit a message" => "Eine Nachricht posten oder bearbeiten",
"Parent page" => "&uuml;bergeordnete Seite",
"TOC" => "Inhaltzverzeichnis",
"Child" => "neue Sub-Seite",
"Last edited by" => "Zuletzt bearbeitet von",
"based on work by" => "beigetragen haben weiterhin",
"Contributors to this page" => "Zu dieser Seite haben beigesteuert",
"big grin" => "grinsend",
"confused" => "verwirrt",
"cry" => "weinend",
"eek" => "erschrocken",
"evil" => "b&ouml;se",
"lol" => "lachend",
"smile" => "l&auml;chelnd",
"surprised" => "&uuml;berrascht",
"arrow" => "Pfeil",
"santa" => "Santa",
"Clean" => "L&ouml;schen",
"Most viewed objects" => "Meist besuchte Objekte (gesamt)",
"Most viewed objects in the last 7 days" => "Meist besuchte Objekte der letzten 7 Tage",
"Site Stats" => "Site-Statistik",
"Total pageviews" => "Besuche gesamt",
"Average pageviews per day" => "Durchschn. Besuche pro Tag",
"Best day" => "Bester Tag",
"Worst day" => "Schlechtester Tag",
"Wiki Stats" => "Wiki-Statistik",
"Size of Wiki Pages" => "Gr&ouml;sse der Wiki-Seiten",
"Mb" => "MB",
"Average page length" => "Durchschn. Seitenl&auml;nge",
"Average versions per page" => "Durchschn. Versionen pro Seite",
"Visits to wiki pages" => "Besuche auf Wiki-Seiten",
"Orphan pages" => "Verwaiste Seiten",
"Average links per page" => "Durchschn. Links pro Seite",
"Image galleries Stats" => "Bildergalerie-Statistik",
"Average images per gallery" => "Durchschn. Bilder pro Galerie",
"Total size of images" => "Gr&ouml;&szlig;e der Bilder gesamt",
"Average image size" => "Durchschn. Bildgr&ouml;&szlig;e",
"Visits to image galleries" => "Besuche in Bildergalerien",
"File galleries Stats" => "Dateiarchiv-Statistik",
"Average files per gallery" => "Durchschn. Dateien pro Archiv",
"Total size of files" => "Gr&ouml;&szlig;e der Dateien gesamt",
"Average file size" => "Durchschn. Dategr&ouml;&szlig;e",
"Visits to file galleries" => "Besuche in Dateiarchiven",
"CMS Stats" => "CMS-Statistik",
"Total reads" => "Zugriffe insgesamt",
"Average reads per article" => "Durchschn. Zugriffe pro Artikel",
"Total articles size" => "Artikel Gr&ouml;&szlig;e gesamt",
"Average article size" => "Durchschn. Artikelgr&ouml;&szlig;e",
"Forum Stats" => "Foren-Statistik",
"Total topics" => "Themen gesamt",
"Average topics per forums" => "Durchschn. Themen pro Forum",
"Visits to forums" => "Besuche in Foren",
"Blog Stats" => "Blog-Statistik",
"Weblogs" => "Blogs",
"Total posts" => "Posts gesamt",
"Average posts per weblog" => "Durchschn. Eintr&auml;ge pro Blog",
"Total size of blog posts" => "Gesamtgr&ouml;&szlig;e der Blog-Posts",
"Average posts size" => "Durchschn. Post Gr&ouml;&szlig;e",
"Visits to weblogs" => "Besuche auf Blogs",
"Poll Stats" => "Abstimmungs-Statistik",
"Total votes" => "Stimmen gesamt",
"Average votes per poll" => "Durchschn. Stimmen pro Abstimmung",
"Total questions" => "Fragen gesamt",
"Average questions per FAQ" => "Durchschn. Fragen pro FAQ",
"User Stats" => "Benutzer-Statistik",
"User bookmarks" => "Benutzer-Lesezeichen",
"Average bookmarks per user" => "Durchschn. Lesezeichen pro Benutzer",
"Average questions per quiz" => "Durchschn. Fragen pro Quiz",
"Quizzes taken" => "Quiz durchgef&uuml;hrt",
"Average quiz score" => "Durchschn. Quiz-Punktzahl",
"Average time per quiz" => "Durchschn. Zeit pro Quiz",
"Usage chart" => "Benutzungsdiagramm",
"Usage chart image" => "Grafik der Nutzungsstatistik",
"Daily Usage" => "Zugriffe / Tag",
"Stats for surveys" => "Statistik f&uuml;r Umfrage",
"Last taken" => "Zuletzt teilgenommen",
"Clean logs older than" => "L&ouml;sche Logs die &auml;lter sind als",
"months" => "Monate",
"Time Left" => "Zeit &uuml;brig",
"Send Answers" => "Antworten senden",
"Your email was sent" => "Ihre Mail wurde verschickt",
"Your name" => "Ihr Name",
"Theme is selected as follows" => "Die Theme wird folgenderma&szlig;en gew&auml;hlt",
"If a theme is assigned to the individual object that theme is used." => "Wenn eine Theme einem individuellem Objekt zugewiesen ist, wird diese verwendet",
"If not then if a theme is assigned to the object's category that theme is used" => "Wenn nicht, dann wird die Theme, die der Kategorie des Objekts zugewiesen ist gew&auml;hlt",
"If not then a theme for the section is used" => "Wenn nicht, dann wird die Theme des Bereichs gew&auml;hlt",
"If none of the above was selected the user theme is used" => "Wenn nicht, dann wird die Theme des Benutzers gew&auml;hlt",
"Finally if the user didn't select a theme the default theme is used" => "Trifft keiner der obenstehenden Punkte zu, dann wird die Default-Theme benutzt",
"Control by Objects" => "Kontrolle anhand der Objekte",
"Control by Sections" => "Theme Bereiche",
"Assign themes to categories" => "Kategorien Themes zuweisen",
"Assigned categories" => "Zugeordnete Kategorien",
"Theme Control Center: Objects" => "Theme Kontrollcenter: Objekte",
"Control by Categories" => "Theme Kategorien",
"Assign themes to objects" => "Objekten Themen zuordnen",
"Assigned objects" => "Zugeordnete Objekte",
"Assign themes to sections" => "Bereichen Themen zuweisen",
"Assigned sections" => "Zugeordnete Bereiche",
"Edit File:" => "Datei bearbeiten:",
"The following file was successfully uploaded" => "Folgende Datei erfolgreich hochgeladen",
"You can download this file using" => "Sie k&ouml;nnen diese Datei herunterladen mit",
"Batch Upload Results" => "Ergebnis Batchupload",
"Upload successful!" => "Upload erfolgreich!",
"The following image was successfully uploaded" => "Das folgende Bild wurde erfolgreich hochgeladen",
"You can include the image in an Wiki page using" => "Sie k&ouml;nnen das Bild in ein Wikiseite einbinden mittels",
"or use filename" => "oder Dateinamen verwenden",
"Now enter the image URL" => "Nun Bild-URL eingeben",
"or upload a local image from your disk" => "oder lokales Bild von Ihrer Disk hochladen",
"Batch Upload" => "Batch hochladen",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Thumbnail (optional, &uuml;berschreibt automatische Thumbnail-Erzeugung)",
"Note: Maximum image size is limited to" => "Hinweis: Die Uploadgr&ouml;sse ist beschr&auml;nkt auf",
"User assigned modules" => "Vom Benutzer zugewiesene Module",
"Assign module" => "Modul zuweisen",
"Column" => "Spalte",
"top" => "Top",
"Current folder" => "Aktueller Ordner",
"Folders" => "Ordner",
"Folder in" => "Ordner in",
"Remove Folder" => "Ordner l&ouml;schen",
"Refresh Cache" => "Cache aktualisieren",
"Admin folders and bookmarks" => "Ordner und Lesezeichen verwalten",
"User Contacts Preferences" => "Benutzer-Kontakte verwalten",
"Manage Fields" => "Felder verwalten",
"Default view" => "Standard-Ansicht",
"Send me a message" => "Schick mir eine Nachricht",
"Assign Group" => "Gruppe zuweisen",
"Users HomePage" => "Benutzer Homepage",
"Personal Wiki Page" => "Private Wiki-Seite",
"Create page" => "Seite erstellen",
"This user is your friend" => "Dieser Benutzer ist Ihr Freund",
"Request friendship from this user" => "Diesen Benutzer um Freundschaft bitten",
"Forum comments" => "Forum-Kommentar",
"Personal Information" => "Pers&ouml;nliche Informationen",
"Male" => "m&auml;nnlich",
"Female" => "weiblich",
"Use Google Map locator" => "Google Map Locator benutzen",
"Your personal Wiki Page" => "Ihre pers&ouml;nliche Wiki-Seite",
"Your personal tracker information" => "Ihre pers&ouml;nlichen Tracker-Information",
"View extra information" => "weitere Informationen anzeigen",
"Is email public? (uses scrambling to prevent spam)" => "eMail-Adresse &ouml;ffentlich? (es wird Verschl&uuml;sselung gegen Spam benutzt)",
"Unavailable - please set your e-mail below" => "Nicht verf&uuml;gbar - bitte zuerst eMail-Adresse eingeben",
"Does your mail reader need a special charset" => "Ben&ouml;tigt der Mailreader einen speziellen Zeichensatz?",
"Your preferred language" => "Ihre bevorzugte Sprache",
"Other languages you can read (select on the left to add to the list on the right)" => "Wenn Sie weitere Sprachen k&ouml;nnen (w&auml;hlen Sie die Sprache im Auswahlfeld, um die Sprache der Liste hinzuzuf&uuml;gen)",
"Note author when reading his mail" => "Lesebest&auml;tigung an den Autor einer Nachricht &uuml;bermitteln",
"My level" => "Mein Benutzer-Level",
"Account Information" => "Kontoinformationen",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Felder \"Neues Pa&szlig;wort\" und \"Pa&szlig;wort best&auml;tigen\" frei lassen um das alte Pa&szlig;wort zu behalten",
"Email address" => "eMail-Adresse",
"Confirm new password" => "Pa&szlig;wort best&auml;tigen",
"Current password (required)" => "aktuelles Pa&szlig;wort (erforderlich)",
"Change administrative info" => "Einstellungen &uuml;bernehmen",
"New task" => "Neue Aufgabe",
"Task list" => "Aufgaben-&Uuml;bersicht",
"Admin mode off" => "Verwaltungsmodus aus",
"Admin mode on" => "Verwaltungsmodus an",
"Task help" => "Hilfe",
"Empty Trash" => "Papierkorb l&ouml;schen",
"Received task" => "Erhaltene Aufgabe",
"You received this task, please read and execute it" => "Sie erhielten diese Aufgabe, bitte lesen und ausf&uuml;hren",
"Send task" => "Aufgabe senden",
"You send this task to a other user" => "Senden Sie diese Aufgabe einem anderen Benutzer",
"Shared task" => "geteilte Aufgabe",
"This task is public to a special group" => "Diese Aufgabe wird &ouml;ffentlich bei einer speziellen Gruppe angezeigt.",
"Accepted by Task User and Creator" => "akzeptiert von Aufgaben-Benutzer und Ersteller",
"Accepted User and Creator" => "akzeptiert von Benutzer und Ersteller",
"Task is accepted by user and creator" => "Aufgabe ist akzeptiert von Benutzer und Ersteller",
"Not Accepted by One User" => "nicht aktzeptiert von einem Benutzer",
"Not Accepted User" => "nicht akzeptiert von Benutzer",
"Task is rejected by one user" => "Aufgabe wurde von einem Benutzer zur&uuml;ckgewiesen",
"Task is not accepted by you, read the task and accept or reject it" => "Aufgabe ist nicht akzeptiert. Bitte lesen und akzeptieren oder zur&uuml;ckweisen",
"Waiting for Other User" => "warten auf andere Benutzer",
"Task is not accepted/rejected by other user" => "Aufgabe ist nicht akzeptiert/gesendet an anderen Benutzer",
"Admin Mode" => "Verwaltungsmodus",
"Edit task" => "Aufgabe bearbeiten",
"NOT accept" => "nicht akzeptieren",
"Remove from Trash" => "Aus dem Papierkorb",
"Move into Trash" => "In den Papierkorb",
"Task saved" => "Aufgabe gespeichert",
"Edit Task" => "Aufgabe bearbeiten",
"View Task" => "Aufgabe ansehen",
"Open a new task" => "Neue Aufgabe hinzuf&uuml;gen",
"taskId" => "Aufgaben-Nummer",
"Task user" => "ist zu bearbeiten von",
"Only the creator can delete this task" => "Nur Ersteller kann die Aufgabe l&ouml;schen",
"Use start date and time" => "Startdatum/-zeit benutzen",
"Use end date and time" => "Endedatum/-zeit benutzen",
"Open / In Process" => "Offen / in Bearbeitung",
"Waiting / Not Started" => "Wartend / noch nicht begonnen",
"Percentage completed" => "Prozent erledigt",
"Waiting" => "Wartend",
"Shared for Group" => "Wird geteilt von Gruppe",
"Accepted by User" => "Akzeptiert von Benutzer",
"No / Rejected" => "Nein / zur&uuml;ckgewiesen",
"Accepted by Creator" => "Vom Ersteller akzeptiert",
"Send message with changes" => "Nachricht mit &Auml;nderungen verschicken",
"Modified by" => "Ge&auml;ndert von",
"Marked as deleted" => "als gel&ouml;scht markieren",
"Inform task user by email" => "Bearbeiter per eMail informieren",
"%m/%d/%Y [%H:%M]" => "%d.%m.%Y [%H:%M]",
"No tasks entered" => "Keine Aufgaben vorhanden",
"Select One" => "Status",
"Undo Trash" => "Aus Papierkorb",
"Show:" => "Anzeigen:",
"Received" => "Erhalten",
"Submitted" => "Zugewiesen",
"Shared" => "Geteilt",
"All Shared Tasks" => "Alle geteilten Aufgaben",
"completed (100%)" => "erledigt (100%)",
"Public for group" => "&ouml;ffentlich f&uuml;r Gruppen",
"Add Watch" => "Beobachtungspunkt hinzuf&uuml;gen",
"Watches" => "Beobachtungspunkte",
"A user submits a blog post" => "Ein Benutzer erstellte einen Blog-Eintrag",
"A user posts a forum thread" => "Ein Benutzer erstellte einen Forum-Thread",
"A user posts a forum topic" => "Ein Benutzer erstellte ein Forum-Thema",
"A user edited a wiki page" => "Jemand hat eine Wikiseite bearbeitet",
"May need to refresh twice to see changes" => "Evtl. zweimal Refresh n&ouml;tig, damit die &Auml;nderungen sichtbar werden",
"Add top level bookmarks to menu" => "Lesezeichen der obersten Ebene ins Men&uuml; &uuml;bernehmen",
"replace window" => "Fenster ersetzen",
"Pos" => "Position",
"User_versions_for" => "Benutzer_Versionen_f&uuml;r",
"This page is being edited by" => "Diese Seite wird gerade bearbeitet von",
"Proceed at your own peril" => "Weiter auf eigene Gefahr",
"Insert Row" => "Zeile einf&uuml;gen",
"Insert Column" => "Spalte einf&uuml;gen",
"Remove Row" => "Zeile l&ouml;schen",
"Remove Column" => "Spalte l&ouml;schen",
"Merge Cells" => "Zellen zusammenf&uuml;gen",
"Restore Cells" => "Zellen wiederherstellen",
"Copy Calculation" => "Rechnung kopieren",
"Format Cell" => "Zellenformat",
"Before" => "Vorher",
"After" => "Nach",
"expires:" => "l&auml;uft aus:",
"Banner stats" => "Banner-Statistik",
"Create new banner" => "Neues Banner erzeugen",
"Banner Information" => "Banner-Information",
"Click ratio" => "Click-Ratio",
"Weekdays" => "Wochentage",
"mon" => "Mo",
"tue" => "Di",
"wed" => "Mi",
"thu" => "Do",
"fri" => "Fr",
"sat" => "Sa",
"sun" => "So",
"Banner raw data" => "Banner Rohdaten",
"Cached" => "gecached",
"This is a cached version of the page." => "Dies ist eine gecachte Version der Seite.",
"Click here to view the Google cache of the page instead." => "Zum Betrachten der Seite im Google-Cache hier klicken.",
"Edit Items" => "Eintr&auml;ge bearbeiten",
"List Charts" => "Hitlisten anzeigen",
"Last Chart" => "Neueste Hitliste",
"Previous Chart" => "Vorherige Hitliste",
"Chart created" => "Hitliste erstellt",
"Next Chart" => "N&auml;chste Hitliste",
"Pre" => "Letzte",
"chg" => "&Auml;nderung",
"Avg" => "Durchschnitt",
"Next chart will be generated on" => "N&auml;chste Hitliste wird erstellt am",
"View or vote items not listed in the chart" => "Eintr&auml;ge anzeigen oder f&uuml;r welche stimmen, die nicht in dieser Hitliste vorhanden sind",
"Select something to vote on" => "Etwas ausw&auml;hlen, f&uuml;r das Sie stimmen wollen",
"Item information" => "Info &uuml;ber Eintrag",
"Dif" => "Diff",
"Best Position" => "Beste Position",
"Vote this item" => "F&uuml;r diesen Eintrag stimmen",
"Highest" => "H&ouml;chste",
"Answers" => "Antworten",
"Q" => "Frage",
"A" => "Antwort",
"Add Suggestion" => "Vorschlag hinzuf&uuml;gen",
"Forum List" => "Forenliste",
"Edit Forum" => "Forum Bearbeiten",
"Summary" => "Zusammenfassung",
"Moderator Actions" => "Moderator-Aktionen",
"Move Selected Topics" => "Ausgew&auml;hlte Themen verschieben",
"Unlock Selected Topics" => "Ausgew&auml;hlte Themen entsperren",
"Lock Selected Topics" => "Ausgew&auml;hlte Themen sperren",
"Delete Selected Topics" => "Ausgew&auml;hlte Themen l&ouml;schen",
"Merge" => "Zusammenf&uuml;hren",
"Merge Selected Topics" => "Ausgew&auml;hlte Themen zusammenf&uuml;hren",
"Reported Messages:" => "Gemeldete Nachrichten:",
"Queued Messages:" => "Aufgelaufene Nachrichten:",
"Merge into topic" => "Zusammenf&uuml;hren mit Thema",
"Emot" => "Stimmung",
"pts" => "Punkte",
"Announce" => "Annoncieren",
"Hot" => "Hei&szlig;",
"No topics yet" => "Noch keine Themen",
"Jump to forum" => "Sprung in Forum",
"Last hour" => "Letzte Stunde",
"Last 24 hours" => "Letzte 24 Stunden",
"Last 48 hours" => "Letzte 48 Stunden",
"Topic List" => "Themenliste",
"prev topic" => "vorheriges Thema",
"next topic" => "n&auml;chstes Thema",
"Show posts" => "Zeige Postings",
"Insert New Item" => "Neuen Eintrag hinzuf&uuml;gen",
"Edit Fields" => "Felder bearbeiten",
"View inserted item" => "eingef&uuml;gten Eintrag anschauen",
"Insert new item" => "Neuen Eintrag hinzuf&uuml;gen",
"Edit/Delete" => "bearbeiten/l&ouml;schen",
"View Item" => "Eintrag ansehen",
"Filter Tracker Items" => "Tracker-Eintr&auml;ge filtern",
"Add a Comment" => "Kommentar hinzuf&uuml;gen",
"Items list" => "Eintr&auml;ge auflisten",
"close" => "schlie&szlig;",
"Show All" => "Zeige alle",
"Back To Mailbox" => "Zur&uuml;ck zum Briefkasten",
"Full Headers" => "Alle Header",
"Normal Headers" => "Normale Header",
"Reply To All" => "allen antworten",
"Forward" => "weiterleiten",
"Select from address book" => "Aus Adressbuch ausw&auml;hlen",
"Use HTML mail" => "HTML-Mail verwenden",
"The following addresses are not in your address book" => "Die folgenden Adressen sind nicht in Ihrem Adressbuch",
"Add Contacts" => "Kontakte hinzuf&uuml;gen",
"Attachment 1" => "Anlage 1",
"Attachment 2" => "Anlage 2",
"Attachment 3" => "Anlage 3",
"Address book" => "Adressbuch",
"page id" => "Seiten-ID",
"3d browser" => "3D-Browser",
"Cancel Fullscreen" => "Vollbild beenden",
"Show/Hide Left Menus" => "Linke Men&uuml;s an/aus",
"Show/Hide Right Menus" => "Rechte Men&uuml;s an/aus",
"Unsubscribe" => "Datei entpacken",
"Categories:" => "Kategorien:",
"Save Minor Edit" => "geringf&uuml;gig",
"Compose Message" => "Nachricht erstellen",
"Enable/disable Tiki features here, but configure them elsewhere" => "Tiki-Features hier ein/ausschalten, konfiguriert werden sie dann an anderen Stellen.",
"General preferences and settings" => "Allgemeine Einstellungen",
"User registration, login and authentication" => "Benutzer-Registrierung, Login und Authentifizierung",
"Wiki settings" => "Wiki-Einstellungen",
"Article/CMS settings" => "Artikel Konfiguration",
"Poll comments settings" => "Einstellungen Abstimmungskommentare",
"Configuration options for all blogs on your site" => "Globale Blog-Einstellungen",
"Forums settings" => "Foreneinstellungen",
"FAQ comments settings" => "FAQ Kommentar-Einstellungen",
"Trackers settings" => "Tracker Konfiguration",
"RSS feeds" => "RSS-Feeds",
"RSS settings" => "RSS-Feed Einstellungen",
"Directory settings" => "Linkverzeichnis Konfiguration",
"Maps configuration" => "Karten Konfiguration",
"Meta Tags settings" => "Meta-Tag Konfiguration",
"Search settings" => "Suche-Einstellungen",
"Score settings" => "Punkte Konfiguration",
"Community settings" => "Community Einstellungen",
"Calendar settings" => "Kalender Einstellungen",
"Intertiki settings" => "Intertiki Einstellungen",
"No chart indicated" => "Keine Hitliste angegeben",
"Upload failed" => "Hochladen fehlgeschlagen",
"Detected, Version:" => "Gefunden, Version:",
"Not detected." => "Nicht gefunden.",
"Your admin password has been changed" => "Das Administrator-Pa&szlig;wort wurde ge&auml;ndert",
"You cannot have a blank password" => "Sie k&ouml;nnen kein leeres Kennwort haben",
"All Fields except gdaltindex must be filled" => "Alle Felder au&szlig;er gdaltindex m&uuml;ssen ausgef&uuml;llt werden",
"You cannot mix old and new trackers" => "Sie k&ouml;nnen nicht alte und neue Tracker mischen",
"Tag already exists" => "Marke existiert bereits",
"Tag not found" => "Marke nicht gefunden",
"Repository name can't be an empty" => "Repository-Name mu&szlig; angegeben werden",
"No repository" => "Kein Repository",
"Search is mandatory field" => "Suche ist ein erforderliches Feld",
"File not found " => "Datei nicht gefunden ",
"Non-existent link" => "Nicht existierender Link",
"Mail-in account %s incorrect" => "Mail-in Konto %s fehlerhaft",
"Mail-in account %s saved" => "Mail-in Konto %s gespeichert",
"Automatic Mail-in accounts checking disabled" => "automatisches Pr&uuml;fen des Mail-Kontos deaktivieren",
"No menu indicated" => "Kein Men&uuml; angegeben",
"No newsletter indicated" => "Kein Newsletter angegeben",
"Error opening uploaded file" => "Fehler beim &ouml;ffnen der hochgeladenen Datei",
"Invalid email" => "ung&uuml;ltige Email",
"No poll indicated" => "Keine Abstimmung angegeben",
"unsafe" => "unsicher",
"register_globals should be off by default. See the php manual for details." => "register_globals sollte ausgeschaltet sein. Details bitte der PHP Anleitung entnehmen.",
"safe" => "sicher",
"session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid sollte ausgeschaltet sein. Details bitte der PHP Anleitung entnehmen.",
"upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir liegt vermutlich innerhalb des Tiki Verzeichnisses. Es besteht das Risiko, da&szlig; jemand dorthin Dateien l&auml;d und versucht, sie dort auszuf&uuml;hren.",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "Kann nicht &uuml;berpr&uuml;fen, ob upload_tmp_dir per Browser lesbar ist. Bitte die Webservereinstellungen &uuml;berpr&uuml;fen.",
"setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "Setzen der xbithack Option ist unsicher. Abh&auml;ngig vom Dateihandling des Webservers und der Tiki-Einstellungen ist es unter Umst&auml;nden m&ouml;glich, da&szlig; jemand Scripte ins Dateiarchiv hochl&auml;d und dort ausf&uuml;hrt.",
"risky" => "gef&auml;hrlich",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "allow_url_fopen kann benutzt werden um schadhafte Skripts zu uploaden. Wenn Sie die Blog Funktion nicht benutzen, kann es deaktiviert werden.",
"The Path to store files in the filegallery should be outside the tiki root directory" => "Der Pfad des Dateiarchivs sollte au&szlig;erhalb des Tiki-Verzeichnisses liegen.",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "Der Pfad der Bildergalerien sollte au&szlig;erhalb des Tiki-Verzeichnisses liegen.",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "Die Funktion \"Vorlagen bearbeiten\" ist aktiviert. Diese Funktion sollte von keinem nicht-Administrator benutzt werden. Sie kann verwendet werden um schadhaften Code einzuschleusen.",
"File upload" => "Datei hochladen",
"File is not readable. Unable to check." => "Diese Datei ist lesegesch&uuml;tzt und konnte nicht &uuml;berpr&uuml;ft werden.",
"You have to provide a word" => "Es mu&szlig; ein Wort angegeben werden",
"Permission denied you cannot view this page" => "Zugriff verweigert. Sie k&ouml;nnen diese Seite nicht betrachten.",
"Permission denied you cannot edit this page" => "Zugriff verweigert. Sie k&ouml;nnen diese Seite nicht bearbeiten",
"You must specify a page name, it will be created if it doesn't exist." => "Ein Seitenname mu&szlig; angegeben werden. Die Seite wird neu angelegt, wenn sie noch nicht vorhanden ist",
"page not added (Exists)" => "Seite nicht hinzugef&uuml;gt (existiert schon)",
"No survey indicated" => "Keine Umfrage angegeben",
"You don't have permission to use this feature" => "Keine Berechtigung zur Nutzung dieses Features",
"No Errors detected" => "Keine Fehler gefunden",
"No tracker indicated" => "Kein Tracker angegeben",
"Group already exists" => "Gruppe existiert bereits",
"User doesn't exist" => "Benutzer existiert nicht",
"Invalid or unknown email" => "ung&uuml;ltige oder unbekannte Email",
"No records were found. Check the file please!" => "Keine Eintr&auml;ge gefunden. Bitte die Datei &uuml;berpr&uuml;fen!",
"User login is required" => "Benutzerlogin ist erforderlich",
"Password is required" => "Passwort ist erforderlich",
"Email is required" => "eMail ist erforderlich",
"User is duplicated" => "Benutzer ist erforderlich",
"Created account %s <%s>" => "Account %s <%s> angelegt",
"Assigned %s in group %s" => "%s zu Gruppe %s hinzugef&uuml;gt",
"User %s already exists" => "Benutzer %s schon vorhanden",
"New %s created with %s %s." => "%s neu erstellt mit %s %s.",
"%s %s successfully deleted." => "%s %s erfolgreich gel&ouml;scht.",
"%s %s removed from %s %s." => "%s %s wurde aus %s %s entfernt.",
"%s <b>%s</b> successfully deleted." => "%s <b>%s</b> erfolgreich gel&ouml;scht.",
"Login contains invalid characters" => "Anmeldung enth&auml;lt ung&uuml;ltige Zeichen",
"%s changed from %s to %s" => "%s ge&auml;ndert von %s auf %s",
"%s modified successfully." => "%s erfolgreich ge&auml;ndert.",
"password" => "Pa&szlig;wort",
"%s modification failed." => "%s &Auml;nderung fehlgeschlagen.",
"rss feed disabled" => "RSS Feed nicht aktiv",
"Tiki RSS feed for articles" => "Tiki RSS Artikel Feed",
"Last articles." => "Neueste Artikel.",
"Unknown group" => "Unbekannte Gruppe",
"Group doesn't exist" => "Gruppe existiert nicht",
"The page cannot be found" => "Die Seite kann nicht gefunden werden",
"Image Galleries Admin Panel" => "Bildergalerien-Adminseite",
"Could not read image %s." => "Konnte Bilddatei %s nicht lesen.",
"Incorrect directory chosen for batch upload of images." => "Kein g&uuml;ltiges Bilder-Uploadverzeichnis ausgew&auml;hlt.",
"Please setup that dir on " => "Bitte dieses Verzeichnis einstellen auf der ",
"Invalid directory name" => "Ung&uuml;ltiger Verzeichnisname",
"File Galleries Admin Panel" => "Dateiarchiv-Adminseite",
"Could not read file %s." => "Konnte Datei %s nicht lesen.",
"Could not write to file %s." => "Konnte die Datei %s nicht schreiben.",
"File %s upload failed." => "Hochladen der Datei %s fehlgeschalgen.",
"File %s removed from Batch directory." => "Datei %s wurde aus dem Batchupload-Verzeichnis gel&ouml;scht.",
"Impossible to remove file %s from Batch directory." => "Konnt Datei %s nicht aus dem Batchupload-Verzeichnis l&ouml;schen.",
"Incorrect directory chosen for batch upload of files." => "Kein g&uuml;ltiges Datei-Uploadverzeichnis ausgew&auml;hlt.",
"You can't post in any blog maybe you have to create a blog first" => "Sie k&ouml;nnen in keinen Blog eintragen. M&ouml;glicherweise m&uuml;ssen Sie zuerst ein Blog anlegen.",
"Permission denied you cannot post" => "Zugriff verweigert. Sie k&ouml;nnen nicht posten",
"Permission denied you cannot edit this post" => "Zugriff verweigert. Sie k&ouml;nnen diesen Eintrag nicht bearbeiten",
"Top visited blogs" => "Meistbesuchte Blogs",
"Last posts" => "neueste Beitr&auml;ge",
"Top active blogs" => "aktivste Blogs",
"Tiki RSS feed for blog: " => "Tiki RSS Feed von Weblog: ",
"No blogId specified" => "Keine blogId angegeben",
"Tiki RSS feed for weblogs" => "Tiki RSS Weblog Feed",
"Last posts to weblogs." => "Neueste Weblog-Eintr&auml;ge.",
"Permission denied you cannot access this gallery" => "Zugriff verweigert. Sie k&ouml;nnen auf diese Galerie nicht zugreifen.",
"No gallery indicated" => "Keine Galerie angegeben",
"Permission denied you can not view this section" => "Zugriff verweigert. Sie k&ouml;nnen diesen Bereich nicht betrachten",
"Permission denied you cannot remove images from this gallery" => "Zugriff verweigert. Sie k&ouml;nnen keine Bilder aus dieser Galerie entfernen",
"Permission denied you cannot rebuild thumbnails in this gallery" => "Neuerstellung der Thumbnails in dieser Galerie nicht gestattet",
"Permission denied you cannot rotate images in this gallery" => "Rotation der Bilder in dieser Galerie nicht gestattet",
"No image indicated" => "Kein Bild angegeben",
"Permission denied you cannot move images from this gallery" => "Zugriff verweigert. Sie k&ouml;nnen keine Bilder dieser Galerie verschieben",
"Permission denied you cannot view the calendar" => "Berechtigung f&uuml;r den Zugriff auf den Kalender nicht vorhanden",
"event without name" => "Ereignis ohne Name",
"Access Denied" => "Zugriff verweigert",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "1",
"No category indicated" => "Keine Kategorie angegeben",
"You can not use the same password again" => "Dasselbe Pa&szlig;wort noch einmal ist nicht erlaubt",
"Top authors" => "Top Autoren",
"Account validated successfully." => "Account erfolgreich best&auml;tigt.",
"This feature has been disabled" => "Diese Funktion wurde deaktiviert",
"Tiki RSS feed for directory sites" => "Tiki RSS Feed von Linkverzeichnis",
"Last sites." => "Neueste Sites.",
"Must enter a name to add a site. " => "Ein Seitenname mu&szlig; angegeben werden. ",
"Must enter a url to add a site. " => "Eine URL mu&szlig; angegeben werden. ",
"URL already added to the directory. Duplicate site? " => "URL schon im Verzeichnis vorhanden. Doppelter Eintrag? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "Auf die URL kann nicht zugegriffen werden: fehlerhafte URL oder die Site ist nicht verf&uuml;gbar und kann daher nicht zum Linkverzeichnis hinzugef&uuml;gt werden. ",
"Must select a category. " => "Eine Kategorie mu&szlig; ausgew&auml;hlt werden. ",
"Must enter a name to add a site" => "Zum Hinzuf&uuml;gen mu&szlig der Name der Site angegeben werden",
"Must enter a url to add a site" => "Die URL der Site mu&szlig; angegeben werden",
"URL already added to the directory. Duplicate site?" => "URL im Verzeichnis schon vorhanden. Doppelter Eintrag?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "Auf die URL kann nicht zugegriffen werden: fehlerhafte URL oder die Site ist nicht verf&uuml;gbar und kann daher nicht zum Linkverzeichnis hinzugef&uuml;gt werden",
"Must select a category" => "Eine Kategorie mu&szlig; ausgew&auml;hlt werden",
"No site indicated" => "Kein Site angegeben",
"Article not found" => "Artikel nicht gefunden",
"Permission denied you cannot edit this article" => "Zugriff verweigert. Sie k&ouml;nnen diesen Artikel nicht bearbeiten",
"You do not have permissions to edit banners" => "Sie haben keine Berechtigung, Banner zu bearbeiten",
"Banner not found" => "Banner nicht gefunden",
"You do not have permission to edit this banner" => "Sie haben keine Berechtigung dieses Banner zu bearbeiten",
"Permission denied you cannot create or edit blogs" => "Zugriff verweigert. Sie k&ouml;nnen Blogs nicht erstellen oder bearbeiten",
"Permission denied you cannot edit this blog" => "Zugriff verweigert. Sie k&ouml;nnen dieses Blog nicht bearbeiten",
"You do not have permission to write the style sheet" => "Berechtigung zum Ver&auml;ndern des Stylesheets nicht vorhanden",
"Invalid request to edit an image" => "Ung&uuml;ltige Anforderung zur Bearbeitung eines Bildes",
"Permission denied you cannot edit images" => "Zugriff verweigert. Sie k&ouml;nnen keine Bilder bearbeiten",
"Permission denied you can edit images but not in this gallery" => "Zugriff verweigert. Sie k&ouml;nnen Bilder bearbeiten, jedoch nicht in dieser Galerie",
"Failed to edit the image" => "Bearbeitung des Bildes fehlgeschlagen",
"Permission denied to use this feature" => "Keine Berechtigung zur Nutzung dieser Funktion",
"Shortname must be 2 Characters" => "Kurzname mu&szlig; zwei Zeichen lang sein",
"You must provide a longname" => "Langer Name mu&szlig; angegeben werden",
"Language created" => "Sprache erstellt",
"No content id indicated" => "Keine Inhalts-ID angegeben",
"No question indicated" => "Keine Frage angegeben",
"No quiz indicated" => "Kein Quiz angegeben",
"No structure indicated" => "Keine Struktur angegeben",
"Invalid structure_id or page_ref_id" => "ung&uuml;ltige structure_id oder page_ref_id",
"Permission denied you cannot send submissions" => "Zugriff verweigert. Sie k&ouml;nnen Einreichungen nicht senden",
"Permission denied you cannot edit submissions" => "Zugriff verweigert. Sie k&ouml;nnen Einreichungen nicht bearbeiten",
"You have to create a topic first" => "Sie m&uuml;ssen zuerst ein Thema erstellen",
"You do not have permission to do that" => "Sie haben nicht die Berechtigung, das zu tun",
"You do not have permission to read the template" => "Sie haben keine Berechtigung, die Vorlage zu lesen",
"No topic id specified" => "Keine Themen-ID angegeben",
"Invalid topic id specified" => "Ung&uuml;ltige Themen-ID angegeben",
"No object indicated" => "Kein Objekt angegeben",
"No type indicated" => "Kein Typ angegeben",
"page imported" => "Seite importiert",
"created from import" => "aus Import erstellt",
"Can't import remote HTML page" => "Kann externe HTML-Seite nicht importieren",
"The SandBox is disabled" => "Die SandBox ist deaktiviert",
"Cannot edit page because it is locked" => "Seite kann wegen Sperrung nicht bearbeitet werden",
"Remove archive: " => "Archiv l&ouml;schen:",
"Remove file gallery: " => "Dateiverzeichnis l&ouml;schen:",
"Permission denied you cannot edit this file" => "Berechtigung zum Bearbeiten dieser Datei nicht vorhanden",
"Permission denied you cannot remove files from this gallery" => "Zugriff Verweigert. Sie k&ouml;nnen keine Dateien aus dieser Galerie entfernen",
"Top visited file galleries" => "Meistbesuchte Dateiarchive",
"Most downloaded files" => "H&auml;ufigste Downloads",
"Last files" => "Neueste Dateien",
"Tiki RSS feed for file galleries" => "Tiki RSS Dateiarchiv Feed",
"Last files uploaded to the file galleries." => "Neueste Dateien in den Dateiarchiven.",
"No galleryId specified" => "Keine galleryId angegeben.",
"Tiki RSS feed for the file gallery: " => "Tiki RSS Feed von Dateiarchiv: ",
"No forum indicated" => "Kein Forum angegeben",
"Forum posts" => "Zahl der Eintr&auml;ge",
"No forumId specified" => "Keine forumId angegeben",
"Tiki RSS feed for forum: " => "Tiki RSS Feed von Forum: ",
"Tiki RSS feed for forums" => "Tiki RSS Foren Feed",
"Last topics in forums." => "Neueste Forenthemen.",
"Accepted friendship request from %s" => "akzeptiert Freunschafts-Bitte von",
"You must be logged in to use this feature" => "Sie m&uuml;ssen angemeldet sein, um diese Funktion nutzen zu k&ouml;nnen.",
"No process indicated" => "Kein Prozess angegeben",
"Role name cannot be empty" => "Pollenname darf nicht leer sein",
"Activity name cannot be empty" => "Aktivit&auml;tsname darf nicht leer sein",
"Activity name already exists" => "Aktivit&auml;t mit diesem Namen existiert bereits",
"indicates if the process is active. Invalid processes cant be active" => "zeigt an ob der Prozess aktiv ist. Ung&uuml;ltige Prozesse k&ouml;nnen nicht aktiviert werden",
"No instance indicated" => "Keine Instanz angegeben",
"No activity indicated" => "Keine Aktivit&auml;t angegeben",
"The process name already exists" => "Dieser Prozessname ist bereits vergeben",
"Process already exists" => "Dieser Prozess existiert schon",
"You cant execute this activity" => "Sie k&ouml;nnen diese Aktivit&auml;t nicht ausf&uuml;hren",
"No user indicated" => "Kein Benutzer angegeben",
"No title indicated" => "Kein Titel angegeben",
"No comment indicated" => "Kein Kommentar angegeben",
"No date indicated" => "Kein Datum angegeben",
"No item indicated" => "Kein Objekt angegeben",
"first uploaded image" => "erstes hochgeladenes Bild",
"last uploaded image" => "neustes Bild",
"first image" => "erstes Bild",
"last image" => "neuestes Bild",
"random image" => "zuf&auml;lliges Bild",
"Permission denied you cannot create galleries and so you cant edit them" => "Zugriff verweigert. Sie k&ouml;nnen Galerien nicht erzeugen, also auch nicht bearbeiten",
"Permission denied you cannot edit this gallery" => "Zugriff verweigert. Sie k&ouml;nnen diese Galerie nicht bearbeiten",
"Permission denied you cannot remove this gallery" => "Zugriff verweigert. Sie k&ouml;nnen diese Galerie nicht l&ouml;schen",
"Top images" => "Top Bilder",
"Last images" => "Neueste Bilder",
"Back to preferences" => "zur&uuml;ck zu Einstellungen",
"Back to item" => "zur&uuml;ck zum Eintrag",
"Tiki RSS feed for image galleries" => "Tiki RSS Feed von Bildergalerien",
"Tiki RSS feed for the image gallery: " => "Tiki RSS Feed von Bildergalerie: ",
"overwriting old page" => "&uuml;berschreibe alte Seite",
"page created" => "Seite erstellt",
"No name indicated for wiki page" => "Kein Name f&uuml;r die Wiki-Seite angegeben",
"No repository given" => "Kein Repository angegeben",
"Permission denied you cannot view pages like this page" => "Zugriff verweigert. Sie k&ouml;nnen Seiten wie diese nicht ansehen",
"Permission denied you cannot remove articles" => "Zugriff verweigert. Sie k&ouml;nnen Artikel nicht entfernen",
"Permission denied you cannot remove banners" => "Zugriff verweigert. Sie k&ouml;nnen keine Banner entfernen",
"Permission denied you cannot remove this blog" => "Zugriff verweigert. Sie k&ouml;nnen dieses Blog nicht entfernen",
"Non-existent gallery" => "Nicht existierende Galerie",
"Remove file: " => "Datei l&ouml;schen:",
"Permission denied you can upload files but not to this file gallery" => "Zugriff verweigert. Sie k&ouml;nnen Dateien hochladen, jedoch nicht in dieses Archiv",
"Could not upload the file" => "Konntr Datei nicht hochladen",
"Could not find the file requested" => "Konnte die angegebene Datei nicht finden",
"Upload was not successful. Duplicate file content" => "Hochladen war nicht erfolgreich. Doppelter Dateiinhalt",
"File update was successful" => "Datei erfolgreich aktualisiert",
"Permission denied you can't upload files so you can't edit them" => "Berechtigung zum Hochladen und damit auch zum &Auml;ndern nicht vorhanden",
"This gallery does not exist" => "Diese Galerie ist nicht vorhanden",
"The thumbnail name must be" => "Der Thumbnail-Name muss sein",
"You cannot admin blogs" => "Sie k&ouml;nnen Blogs nicht administrieren",
"Permission denied you cannot remove submissions" => "Zugriff verweigert. Sie k&ouml;nnen Einreichungen nicht entfernen",
"Permission denied you cannot approve submissions" => "Zugriff verweigert. Sie k&ouml;nnen Einreichungen nicht freigeben",
"You have to enable cookies to be able to login to this site" => "Aktivieren Sie 'Cookies akzeptieren' um sich einloggen zu k&ouml;nnen",
"XMLRPC Error: " => "XMLRPC Fehler:",
"Invalid password" => "ung&uuml;ltiges Kennwort",
"Account disabled" => "Konto deaktiviert",
"Sorry, you can't use this feature." => "Keine Berechtigung zur Nutzung dieser Funktion",
"invalid mapfile name" => "ung&uuml;ltiger Kartenname",
"edit" => "bearbeiten",
"You do not have permissions to view the maps" => "Keine Berechtigung zum Betrachten von Karten",
"mapfile name incorrect" => "Name der Kartendatei nicht korrekt",
"This mapfile already exists" => "Diese Kartendatei existiert schon",
"You do not have permission to write to the mapfile" => "Keine Berechtigung zum Schreiben von Kartendateien",
"You do not have permission to delete the mapfile" => "Keine Berechtigung zum L&ouml;schen der Kartendatei",
"I could not make a copy" => "Es konnte keine Kopie erstellt werden",
"You do not have permission to read the mapfile" => "Keine Berechtigung zum Lesen der Kartendatei",
"You dont have permission to do that" => "Keine Berechtigung vorhanden",
"Tiki RSS feed for maps" => "Tiki RSS Karten Feed",
"List of maps available." => "Neueste Karten.",
"You do not have permissions to view the layers" => "Keine Berechtigung zum Betrachten der Layer",
"You do not have permissions to delete a file" => "Keine Berechtigung zum L&ouml;schen einer Datei",
"File not found" => "Datei nicht gefunden",
"You do not have permissions to create a directory" => "Keine Berechtigung zum Erstellen eines Verzeichnisses",
"The Directory is not empty" => "Das Verzeichnis ist nicht leer",
"You do not have permissions to delete a directory" => "Keine Berechtigung zum L&ouml;schen eines Verzeichnisses",
"You do not have permissions to create an index file" => "Keine Berechtigung zum Anlegen einer Indexdatei",
"Invalid file name" => "Ung&uuml;ltiger Dateiname",
"Invalid files to index" => "&Uuml;ng&uuml;ltige Seiten, die indiziert werden sollen",
"I could not create the index file" => "Indexdatei konnte nicht angelegt werden",
"Must be logged to use this feature" => "F&uuml;r diese Funktion m&uuml;ssen Sie angemeldet sein",
"Welcome at Hawiki" => "Willkommen bei Hawiki",
"About" => "&Uuml;ber",
"Your PHP installation does not have zlib enabled." => "Die PHP Installation enth&auml;lt keine zlib Bibliothek.",
"You must log in to use this feature" => "Sie m&uuml;ssen sich anmelden, um diese Funktion zu nutzen",
"You do not have permission to view other users data" => "Sie haben keine Berechtigung, die Daten anderer Benutzer einzusehen",
"You must be logged in to subscribe to newsletters" => "Sie m&uuml;ssen eingeloggt sein, um Newsletter abonnieren zu k&ouml;nnen",
"No server indicated" => "Kein Server angegeben",
"Cannot connect to" => "Konnte Verbindung nicht herstellen zu",
"Missing information to read news (server,port,username,password,group) required" => "Zum Lesen von News fehlen Daten (Server,Port,Username,Pa&szlig;wort,Gruppe)",
"Cannot get messages" => "Kann keine Nachrichten abholen",
"No note indicated" => "Keine Notiz angegeben",
"File is too big" => "Datei ist zu gro&szlig;",
"created from notepad" => "Aus dem Notitzblock erstellt",
"Page already exists" => "Seite existiert schon",
"Not enough information to display this page" => "Nicht genug Informationen, um diese Seite anzuzeigen",
"Permission denied you cannot browse this page history" => "Zugriff verweigert. Sie k&ouml;nnen diese Seitenhistorie nicht ansehen",
"No article indicated" => "Kein Artikel angegeben",
"Article is not published yet" => "Artikel ist noch nicht ver&ouml;ffentlicht",
"No post indicated" => "Kein Posting angegeben",
"Blog not found" => "Blog nicht gefunden",
"No pages indicated" => "Keine Seiten angegeben",
"Pageviews" => "Seitenaufrufe",
"No result indicated" => "Kein Ergebnis angegeben",
"The passwords don't match" => "Die Passw&ouml;rter stimmen nicht &uuml;berein",
"Username cannot contain uppercase letters" => "Benutzername darf keine Gro&szlig;buchstaben enthalten",
"Username cannot contain more than" => "Benutzername darf nicht mehr enthalten als",
"mail adress" => "EMail-Adresse",
"empty" => "leer",
"Invalid or unknown username" => "Ung&uuml;ltiger oder unbekannter Benutzername",
"A password and your IP address reminder email has been sent " => "Eine Erinnerungsnachricht mit dem Passwort (und Ihrer IP Adresse) wurde verschickt ",
"to the registered email address for" => "an die registrierte eMail-Adresse f&uuml;r",
"last version" => "neueste Version",
"Permission denied you cannot remove versions from this page" => "Zugriff verweigert. Sie k&ouml;nnen Versionen dieser Seite nicht entfernen",
"Cannot rename page maybe new page already exists" => "Kann die Seite nicht umbenennen, evtl. existiert der Name schon",
"Non-existent version" => "Nicht existierende Version",
"Permission denied you cannot rollback this page" => "Zugriff verweigert. Rollback f&uuml;r diese Seite nicht erlaubt.",
"Error Message" => "Fehlermeldung",
"No newsletters available." => "Keine Newsletter vorhanden.",
"successfully sent" => "erfolgreich verschickt",
"not sent" => "nicht verschickt",
"Error: " => "Fehler: ",
"You do not have permission to edit messages \$owner" => "Sie haben keine Berechtigung, diese Nachrichten zu bearbeiten \$owner",
"Page must be defined inside a structure to use this feature" => "F&uuml;r diese Funktion mu&szlig; die Seite innerhalb einer Struktur angelegt werden",
"You cannot take this quiz twice" => "Sie k&ouml;nnen dieses Quiz nicht zweimal durchf&uuml;hren",
"Quiz time limit exceeded quiz cannot be computed" => "Quizzeit &uuml;berschritten. Quiz kann nicht gewertet werden",
"You cannot take this survey twice" => "Sie k&ouml;nnen nicht zweimal an dieser Umfrage teilnehmen",
"Please create a category first" => "Bitte erst eine Kategorie anlegen",
"Tiki RSS feed for individual trackers: " => "Tiki RSS Feed von Tracker: ",
"No permission to upload zipped file packages" => "Berechtigung zum Hochladen gepackter Dateien nicht vorhanden",
"Error processing zipped image package" => "Fehler beim Verarbeiten der gepackten Bilddateien",
"No permission to upload zipped image packages" => "Berechtigung zum Hochladen gepackter Bildarchive nicht vorhanden",
"The uploaded file ist not recognized as a image" => "Die hochgeladene Datei konnte nicht als Bild identifiziert werden",
"Permission denied you cannot upload images" => "Zugriff verweigert. Sie k&ouml;nnen keine Bilder hochladen",
"Permission denied you can upload images but not to this gallery" => "Zugriff verweigert. Sie k&ouml;nnen Bilder hochladen, aber nicht in diese Galerie",
"Cannot get image from URL" => "Kann Bild nicht von URL beziehen",
"That is not an image (or you have php < 4.0.5)" => "Dies ist kein Bild (Oder die PHP Version ist kleiner als 4.0.5)",
"Usage" => "Zugriffe",
"No url indicated" => "Keine URL angegeben",
"Unknown user" => "Unbekannter Benutzer",
"You are not logged in and no user indicated" => "Du bist nicht eingeloggt und es wurde auch kein Benutzer angegeben",
"The user has chosen to make his information private" => "Der Benutzer hat diese Information als privat deklariert",
"Email is set to %s" => "eMail-Adresse ist jetzt %s",
"The passwords did not match" => "Die Pa&szlig;w&ouml;rter stimmen nicht &uuml;berein",
"no" => "nein",
"unicode" => "Unicode",
"was moved into trash" => "wurde in den Papierkorb verschoben",
"trashed by" => "verschoben von",
"open / in process" => "offen / in Bearbeitung",
"Task accepted by creator" => "Aufgabe vom Ersteller akzeptiert",
"Task accepted by task user" => "Aufgabe vom Aufgaben-Benutzer akzeptiert",
"Task NOT accepted by creator" => "Aufgabe NICHT akzeptiert vom Ersteller",
"Task NOT accepted by task user" => "Aufgabe NICHT akzeptiert von Aufgaben-Benutzer",
"Changes:" => "&Auml;nderungen:",
"Info message" => "Benachrichtigung",
"NEW Task" => "Neue Aufgabe",
"Changes on Task" => "&Auml;nderungen an Aufgabe",
"You received a new task" => "Neue Aufgabe erhalten",
"The priority is" => "Die Priorit&auml;t ist",
"very low" => "sehr niedrig",
"low" => "niedrig",
"high" => "hoch",
"very high" => "sehr hoch",
"Login and click the link below" => "Anmelden und Link unten anklicken",
"Cannot upload this file not enough quota" => "Hochladen w&uuml;rde Quota &uuml;berschreiten",
"Non-existent user" => "Nicht existierender Benutzer",
"No banner indicated" => "Kein Banner angegeben",
"No blog indicated" => "Kein Blog angegeben",
"Permission denied you cannot remove the post" => "Zugriff verweigert. Sie k&ouml;nnen den Eintrag nicht entfernen",
"No cache information available" => "Keine Cache-Informationen verf&uuml;gbar",
"No faq indicated" => "Keine FAQ angegeben",
"You are not permitted to remove someone else\\'s post!" => "Keine Erlaubnis zum L&ouml;schen von Postings anderer Benutzer!",
"No thread indicated" => "Kein Thread angegeben",
"A SheetId is required." => "Eine SheetId mu&szlig; angegeben werden.",
"No subject" => "Kein Betreff vorhanden",
"Top pages" => "Top-Seiten",
"Last pages" => "Letzte Seiten",
"Tiki RSS feed for the wiki pages" => "Tiki RSS Wiki Feed",
"Last modifications to the Wiki." => "Zuletzt ge&auml;nderte Wikiseiten.",
"###end###"=>"###end###");
?>
